/*____________________________________________________________________________
	Copyright (C) 2002 PGP Corporation
	All rights reserved.

	$Id: PGPadminXCtl.h,v 1.6 2002/08/06 20:09:15 dallen Exp $
____________________________________________________________________________*/
#if !defined(AFX_PGPADMINXCTL_H__6917C203_755A_11D5_AE28_00010234518F__INCLUDED_)
#define AFX_PGPADMINXCTL_H__6917C203_755A_11D5_AE28_00010234518F__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "pflPrefs.h"
#include "pgpUtilities.h"

typedef struct _TabPageProps
{
	UINT nID;
	DLGPROC dlgProc;
}
TabPageProps;


// PGPadminXCtl.h : Declaration of the CPGPadminXCtrl ActiveX Control class.

/////////////////////////////////////////////////////////////////////////////
// CPGPadminXCtrl : See PGPadminXCtl.cpp for implementation.

class CPGPadminXCtrl : public COleControl
{
	DECLARE_DYNCREATE(CPGPadminXCtrl)

// Constructor
public:
	CPGPadminXCtrl();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CPGPadminXCtrl)
	public:
	virtual void OnDraw(CDC* pdc, const CRect& rcBounds, const CRect& rcInvalid);
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual void DoPropExchange(CPropExchange* pPX);
	virtual void OnResetState();
	//}}AFX_VIRTUAL

// Implementation
protected:
	~CPGPadminXCtrl();

	DECLARE_OLECREATE_EX(CPGPadminXCtrl)    // Class factory and guid
	DECLARE_OLETYPELIB(CPGPadminXCtrl)      // GetTypeInfo
	DECLARE_PROPPAGEIDS(CPGPadminXCtrl)     // Property page IDs
	DECLARE_OLECTLTYPE(CPGPadminXCtrl)		// Type name and misc status

	// Subclassed control support
	BOOL IsSubclassedControl();
	LRESULT OnOcmCommand(WPARAM wParam, LPARAM lParam);
	LRESULT OnOcmNotify(WPARAM wParam, LPARAM lParam);

// Message maps
	//{{AFX_MSG(CPGPadminXCtrl)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnDestroy();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

// Dispatch maps
	//{{AFX_DISPATCH(CPGPadminXCtrl)
	afx_msg BSTR GetSzPrefs();
	afx_msg void SetSzPrefs(LPCTSTR lpszNewValue);
	afx_msg BSTR GetSzNetPrefs();
	afx_msg void SetSzNetPrefs(LPCTSTR lpszNewValue);
	afx_msg BOOL GetDisabled();
	afx_msg void SetDisabled(BOOL bNewValue);
	afx_msg long GetNPrefBlocks();
	afx_msg void SetNPrefBlocks(long nNewValue);
	afx_msg long GetNNetPrefBlocks();
	afx_msg void SetNNetPrefBlocks(long nNewValue);
	afx_msg BSTR GetSzDefaultKeys();
	afx_msg void SetSzDefaultKeys(LPCTSTR lpszNewValue);
	afx_msg long GetNDefaultKeyBlocks();
	afx_msg void SetNDefaultKeyBlocks(long nNewValue);
	afx_msg BSTR GetSzProductKey();
	afx_msg void SetSzProductKey(LPCTSTR lpszNewValue);
	//}}AFX_DISPATCH
	DECLARE_DISPATCH_MAP()

// Event maps
	//{{AFX_EVENT(CPGPadminXCtrl)
	//}}AFX_EVENT
	DECLARE_EVENT_MAP()

// Dispatch and event IDs
public:
	enum {
	//{{AFX_DISP_ID(CPGPadminXCtrl)
	dispidSzPrefs = 1L,
	dispidSzNetPrefs = 2L,
	dispidDisabled = 3L,
	dispidNPrefBlocks = 4L,
	dispidNNetPrefBlocks = 5L,
	dispidSzDefaultKeys = 6L,
	dispidNDefaultKeyBlocks = 7L,
	dispidSzProductKey = 8L,
	//}}AFX_DISP_ID
	};

private:
	PGPContextRef m_pgpContext;
	PGPMemoryMgrRef m_pgpMemMgr;
	TabPageProps *m_pPage;
	char m_szPrefFile[_MAX_PATH];
	char m_szNetPrefFile[_MAX_PATH];
	PGPPrefRef m_prefRef;
	PGPPrefRef m_prefRefNet;
	BOOL m_bDisabled;
	long m_nPrefBlocks;
	long m_nCurPrefBlock;
	PGPSize m_nPrefIndex;
	char *m_szPrefBuffer;
	long m_nNetPrefBlocks;
	long m_nCurNetPrefBlock;
	PGPSize m_nNetPrefIndex;
	char *m_szNetPrefBuffer;
	long m_nKeyBlocks;
	long m_nCurKeyBlock;
	PGPSize m_nKeyIndex;
	char *m_szKeyBuffer;
	char *m_szProductKey;
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_PGPADMINXCTL_H__6917C203_755A_11D5_AE28_00010234518F__INCLUDED)
