/*____________________________________________________________________________
	Copyright (C) 2002 PGP Corporation
	All rights reserved.

	$Id: main.c,v 1.16 2002/11/20 16:48:03 pbj Exp $
____________________________________________________________________________*/

#include <windows.h>
#include "PGPadmin.h"
#include <htmlhelp.h>
#include "PGPadminRes.h"

#include "pgpUtilities.h"
#include "pgpClientPrefs.h"
#include "pgpNetPrefs.h"
#include "pgpClientLib.h"
#include "pgpLnLib.h"
#include "pgpFileSpec.h"
#include "pgpHashPrefs.h"

HINSTANCE g_hInstance = NULL;
HWND g_hCurrentDlgWnd = NULL;

static PGPContextRef g_pgpContext = NULL;
static HBITMAP g_hBitmap = NULL;
static HPALETTE g_hPalette = NULL;
static pgpConfigInfo Config;

LRESULT CALLBACK MainDlgProc(HWND hwnd, 
							 UINT uMsg, 
							 WPARAM wParam, 
							 LPARAM lParam);

static HPALETTE 
CreateDIBPalette (LPBITMAPINFO lpbmi, 
				  LPINT lpiNumColors);

static HBITMAP 
LoadResourceBitmap (HINSTANCE hInstance, 
					LPSTR lpString,
					HPALETTE FAR* lphPalette);

static void sNewPrefs(void);
static void sSavePrefs(HWND hwndMain);
static void sFreeData(void);

int WINAPI WinMain(
    HINSTANCE hInstance,	// handle to current instance
    HINSTANCE hPrevInstance,	// handle to previous instance
    LPSTR lpCmdLine,	// pointer to command line
    int nCmdShow 	// show state of window
   )
{
	int nResult;
	PGPError err;
	char szTitle[255];
	char szMsg[255];
    
	UNREFERENCED_PARAMETER(lpCmdLine); 
 
    g_hInstance = hInstance;  /* save instance handle */ 

#if PGP_DEBUG
	if (kPGPPrefBoolLast != 51)
	{
		wsprintf(szMsg, "Client boolean prefs have changed!\r\nNew value is %d", 
			kPGPPrefBoolLast);
		MessageBox(NULL, szMsg, "DEBUG", MB_OK);
	}
	if (kPGPPrefNumberLast != 225)
	{
		wsprintf(szMsg, "Client number prefs have changed!\r\nNew value is %d", 
			kPGPPrefNumberLast);
		MessageBox(NULL, szMsg, "DEBUG", MB_OK);
	}
	if (kPGPPrefStringLast != 413)
	{
		wsprintf(szMsg, "Client string prefs have changed!\r\nNew value is %d", 
			kPGPPrefStringLast);
		MessageBox(NULL, szMsg, "DEBUG", MB_OK);
	}
	if (kPGPPrefByteLast != 621)
	{
		wsprintf(szMsg, "Client byte prefs have changed!\r\nNew value is %d", 
			kPGPPrefByteLast);
		MessageBox(NULL, szMsg, "DEBUG", MB_OK);
	}
	if (kPGPPrefStructLast != 801)
	{
		wsprintf(szMsg, "Client struct prefs have changed!\r\nNew value is %d", 
			kPGPPrefStructLast);
		MessageBox(NULL, szMsg, "DEBUG", MB_OK);
	}
	if (kPGPPrefArrayLast != 1002)
	{
		wsprintf(szMsg, "Client array prefs have changed!\r\nNew value is %d", 
			kPGPPrefArrayLast);
		MessageBox(NULL, szMsg, "DEBUG", MB_OK);
	}
	if (kPGPAdminPrefBoolLast != 3049)
	{
		wsprintf(szMsg, "Admin boolean prefs have changed!\r\nNew value is %d", 
			kPGPAdminPrefBoolLast);
		MessageBox(NULL, szMsg, "DEBUG", MB_OK);
	}
	if (kPGPAdminPrefNumberLast != 3212)
	{
		wsprintf(szMsg, "Admin number prefs have changed!\r\nNew value is %d", 
			kPGPAdminPrefNumberLast);
		MessageBox(NULL, szMsg, "DEBUG", MB_OK);
	}
	if (kPGPAdminPrefStringLast != 3404)
	{
		wsprintf(szMsg, "Admin string prefs have changed!\r\nNew value is %d", 
			kPGPAdminPrefStringLast);
		MessageBox(NULL, szMsg, "DEBUG", MB_OK);
	}
	if (kPGPAdminPrefByteLast != 3606)
	{
		wsprintf(szMsg, "Admin byte prefs have changed!\r\nNew value is %d", 
			kPGPAdminPrefByteLast);
		MessageBox(NULL, szMsg, "DEBUG", MB_OK);
	}
	if (kPGPAdminPrefStructLast != 3801)
	{
		wsprintf(szMsg, "Admin struct prefs have changed!\r\nNew value is %d", 
			kPGPAdminPrefStructLast);
		MessageBox(NULL, szMsg, "DEBUG", MB_OK);
	}
	if (kPGPAdminPrefArrayLast != 4001)
	{
		wsprintf(szMsg, "Admin array prefs have changed!\r\nNew value is %d", 
			kPGPAdminPrefArrayLast);
		MessageBox(NULL, szMsg, "DEBUG", MB_OK);
	}
	if (kPGPNetPrefBoolLast != 11035)
	{
		wsprintf(szMsg, "Net boolean prefs have changed!\r\nNew value is %d", 
			kPGPNetPrefBoolLast);
		MessageBox(NULL, szMsg, "DEBUG", MB_OK);
	}
	if (kPGPNetPrefNumberLast != 11210)
	{
		wsprintf(szMsg, "Net number prefs have changed!\r\nNew value is %d", 
			kPGPNetPrefNumberLast);
		MessageBox(NULL, szMsg, "DEBUG", MB_OK);
	}
	if (kPGPNetPrefStringLast != 11406)
	{
		wsprintf(szMsg, "Net string prefs have changed!\r\nNew value is %d", 
			kPGPNetPrefStringLast);
		MessageBox(NULL, szMsg, "DEBUG", MB_OK);
	}
	if (kPGPNetPrefByteLast != 11605)
	{
		wsprintf(szMsg, "Net byte prefs have changed!\r\nNew value is %d", 
			kPGPNetPrefByteLast);
		MessageBox(NULL, szMsg, "DEBUG", MB_OK);
	}
	if (kPGPNetPrefStructLast != 12001)
	{
		wsprintf(szMsg, "Net struct prefs have changed!\r\nNew value is %d", 
			kPGPNetPrefStructLast);
		MessageBox(NULL, szMsg, "DEBUG", MB_OK);
	}
	if (kPGPNetPrefArrayLast != 11805)
	{
		wsprintf(szMsg, "Net array prefs have changed!\r\nNew value is %d", 
			kPGPNetPrefArrayLast);
		MessageBox(NULL, szMsg, "DEBUG", MB_OK);
	}
#endif /* PGP_DEBUG */

	// Make sure SDK isn't expired 

	err = PGPclInitLibrary(&g_pgpContext, 
			kPGPclEnableNewUserWizard | kPGPclForceNewUserWizard);
	if (IsPGPError(err))
	{
		if (err == kPGPError_FeatureNotAvailable)
		{
			LoadString(g_hInstance, IDS_E_EXPIRED, szMsg, 254);
			LoadString(g_hInstance, IDS_TITLE, szTitle, 254);
			MessageBox(NULL, szMsg, szTitle, MB_ICONWARNING);
		}
		else
			PGPclErrorBox(NULL, err);

		PGPclCloseLibrary();
		return 0;
	}

	// Check for beta/demo expiration
	PGPlnLicenseCheck (g_pgpContext);
	if (!PGPlnEnterprise())
	{
		PGPclNoLicense(NULL, kPGPclPGPadmin);
		PGPclCloseLibrary();
		return 0;
	}

	if (PGPlnIsExpired(NULL, kPGPlnModuleGraceExpiration) != kPGPError_NoErr)
	{
		PGPclCloseLibrary();
		return 0;
	}

	if(!PGPclIsAdminInstall())
	{
		LoadString(g_hInstance, IDS_NOTADMIN, szMsg, 254);
		LoadString(g_hInstance, IDS_TITLE, szTitle, 254);
		MessageBox(NULL, szMsg, szTitle, MB_ICONWARNING);
		PGPclCloseLibrary();
		return 0;
	}

	/* Show the main dialog */

	nResult = DialogBox(hInstance, MAKEINTRESOURCE(IDD_MAIN), NULL,
				MainDlgProc);
	
	if (g_hBitmap != NULL)
		DeleteObject(g_hBitmap);

	sFreeData();
	PGPclCloseLibrary();
	return nResult;
}


LRESULT CALLBACK MainDlgProc(HWND hwndDlg, 
							 UINT uMsg, 
							 WPARAM wParam, 
							 LPARAM lParam)
{
	HICON hPGPOptions;
	HICON hAdminOptions;
	int iNumBits;
	int iBitmap;
	HDC	hDC;
	BOOL bReturn = FALSE;
	PGPUInt32 panelFlags;
	PGPError err;

	switch (uMsg)
	{
	case WM_INITDIALOG:
		hPGPOptions = LoadImage(g_hInstance, MAKEINTRESOURCE(IDI_PGPKEYS),
							IMAGE_ICON, 0, 0, LR_DEFAULTCOLOR);
		hAdminOptions = LoadImage(g_hInstance, MAKEINTRESOURCE(IDI_ADMIN),
							IMAGE_ICON, 0, 0, LR_DEFAULTCOLOR);

		SendMessage(GetDlgItem(hwndDlg, IDC_PGPOPTIONS), BM_SETIMAGE,
			IMAGE_ICON, (LPARAM) hPGPOptions);
		SendMessage(GetDlgItem(hwndDlg, IDC_ADMINOPTIONS), BM_SETIMAGE,
			IMAGE_ICON, (LPARAM) hAdminOptions);
		
		PostMessage(hwndDlg, WM_SETICON, ICON_BIG, (LPARAM) hAdminOptions);
		PostMessage(hwndDlg, WM_SETICON, ICON_SMALL, (LPARAM) hAdminOptions);
		
		/* Determine which bitmap will be displayed */
		
		hDC = GetDC (NULL);		// DC for desktop
		iNumBits = GetDeviceCaps (hDC, BITSPIXEL) * 
					GetDeviceCaps (hDC, PLANES);
		ReleaseDC (NULL, hDC);
		
		if (iNumBits <= 1)
			iBitmap = IDB_ADMINWIZ1;
		else if (iNumBits <= 4) 
			iBitmap = IDB_ADMINWIZ4;
		else 
			iBitmap = IDB_ADMINWIZ8;
		
		g_hBitmap = LoadResourceBitmap(g_hInstance, MAKEINTRESOURCE(iBitmap), 
					&g_hPalette);
		
		SendDlgItemMessage(hwndDlg, IDC_MAINPIC, STM_SETIMAGE, 
			IMAGE_BITMAP, (LPARAM) g_hBitmap);

		PGPclCenterWindowOnMonitor(hwndDlg, kPGPclPrimaryMonitor);

		if (1)
		{
			PGPPrefRef prefRef = NULL;
			PGPPrefRef prefRefNet = NULL;

			sNewPrefs();
			PGPclPeekClientLibPrefRefs(&prefRef, &prefRefNet);
			PGPAddPrefs(prefRef, Config.prefRef);
			if (prefRefNet != NULL)
				PGPAddPrefs(prefRefNet, Config.prefRefNet);
			LoadAdminOptions(&Config);
		}

		EnableWindow(GetDlgItem(hwndDlg, IDC_UPDATESERVER), FALSE);
		EnableWindow(GetDlgItem(hwndDlg, IDC_CREATEINSTALL), FALSE);
		bReturn = TRUE;
		break;

	case WM_PAINT:
		if (g_hPalette)
		{
			PAINTSTRUCT ps;
			HDC	hDC = BeginPaint (hwndDlg, &ps);
			SelectPalette (hDC, g_hPalette, FALSE);
			RealizePalette (hDC);
			EndPaint (hwndDlg, &ps);
			bReturn = TRUE;
		}
		break;
		
	case WM_COMMAND:
		switch (LOWORD(wParam))
		{
		case IDC_PGPOPTIONS:
			panelFlags = 0;
			if (PGPclIsComponentInstalled (kPGPclPGPkeys))
				panelFlags |= ADMINKEYSPREFSPAGES;
			if (PGPclIsComponentInstalled (kPGPclPGPtools))
				panelFlags |= ADMINMAILPREFSPAGES;
			if (PGPclIsComponentInstalled(kPGPclPGPdisk))
				panelFlags |= ADMINDISKPREFSPAGES;
			if (PGPclIsComponentInstalled (kPGPclPFIDS))
				panelFlags |= ADMINFIREPREFSPAGES;
			if (PGPclIsComponentInstalled(kPGPclVPN))
				panelFlags |= ADMINVPNPREFSPAGES;

			err = PGPclAdminPreferences(g_pgpContext, hwndDlg, Config.prefRef,
					Config.prefRefNet, kPGPclRespectDisableFlags, 
					panelFlags, 0, Config.keyDB);

			if (IsntPGPError(err))
				Config.bCopyClientPrefs = TRUE;
			else if (err != kPGPError_UserAbort)
				PGPclErrorBox(hwndDlg, err);

			bReturn = TRUE;
			break;

		case IDC_ADMINOPTIONS:
			{
				void *pCurrentPrefs;
				void *pCurrentNetPrefs;
				PGPSize currentSize;
				PGPSize currentNetSize;

				PGPExportPrefsToBuffer(Config.prefRef, &currentSize, 
					&pCurrentPrefs);
				PGPExportPrefsToBuffer(Config.prefRefNet, &currentNetSize, 
					&pCurrentNetPrefs);

				AdminOptions(hwndDlg, &Config);
				if (Config.bCancel)
				{
					PGPPrefRef prefRef;
					PGPPrefRef prefRefNet;

					sFreeData();
					sNewPrefs();
					
					PGPImportBufferToMemoryPrefs(Config.memoryMgr,
						pCurrentPrefs, currentSize, clientDefaults,
						clientDefaultsSize, &prefRef);

					PGPImportBufferToMemoryPrefs(Config.memoryMgr,
						pCurrentNetPrefs, currentNetSize, netDefaults,
						netDefaultsSize, &prefRefNet);

					PGPAddPrefs(prefRef, Config.prefRef);
					PGPAddPrefs(prefRefNet, Config.prefRefNet);
					PGPFreePrefs(prefRef);
					PGPFreePrefs(prefRefNet);
					LoadAdminOptions(&Config);
				}
				else
				{
					EnableWindow(GetDlgItem(hwndDlg, IDC_UPDATESERVER), TRUE);
					EnableWindow(GetDlgItem(hwndDlg, IDC_CREATEINSTALL), TRUE);
				}

				PGPFreeData(pCurrentPrefs);
				PGPFreeData(pCurrentNetPrefs);
				bReturn = TRUE;
				break;
			}

		case IDC_RETRIEVESERVER:
			{
				char szTitle[255];
				char szMsg[255];

				LoadString(g_hInstance, IDS_TITLE, szTitle, sizeof(szTitle));
				LoadString(g_hInstance, IDS_E_NOLDAP, szMsg, sizeof(szMsg));
			
				if (!Config.szLDAPServer) // !Config.bUpdateAdminPrefs ||
				{
					MessageBox(hwndDlg, szMsg, szTitle, MB_ICONEXCLAMATION);
					break;
				}

				err = PGPclGetPrefsFromServer(Config.pgpContext, 
						Config.tlsContext, hwndDlg, Config.prefRef,
						Config.prefRefNet);
				
				if (IsPGPError(err) && (err != kPGPError_UserAbort))
					PGPclErrorBox(hwndDlg, err);
				else
				{
					FreeAdminOptions(&Config);
					InitAdminOptions(g_pgpContext, &Config, FALSE);
					LoadAdminOptions(&Config);
					EnableWindow(GetDlgItem(hwndDlg, IDC_UPDATESERVER), TRUE);
					EnableWindow(GetDlgItem(hwndDlg, IDC_CREATEINSTALL), TRUE);
				}

				bReturn = TRUE;
			}
			break;

		case IDC_UPDATESERVER:
			{
				char szTitle[255];
				char szMsg[255];
				PGPPrefArray *pArray;
				char szRNG[_MAX_PATH];

				LoadString(g_hInstance, IDS_TITLE, szTitle, sizeof(szTitle));
				LoadString(g_hInstance, IDS_E_NOLDAP, szMsg, sizeof(szMsg));
			
				if (!Config.szLDAPServer) // !Config.bUpdateAdminPrefs || 
				{
					MessageBox(hwndDlg, szMsg, szTitle, MB_ICONEXCLAMATION);
					break;
				}

				if (!Config.bCopyNetHosts)
				{
					PGPGetPrefArray(Config.prefRefNet, kPGPNetPrefHostArray, 
						&pArray);
					PGPClearPrefData(Config.prefRefNet, kPGPNetPrefHostArray);
					PGPSavePrefFile(Config.prefRefNet);
					PGPWritePrefsHash(Config.pgpContext, Config.prefRefNet);
				}

				PGPGetPrefStringBuffer(Config.prefRef, kPGPPrefRNGSeedFile,
					_MAX_PATH, szRNG);
				PGPSetPrefString(Config.prefRef, kPGPPrefRNGSeedFile, "");
				PGPSavePrefFile(Config.prefRef);

				err = PGPclSendPrefsToServer(Config.pgpContext, 
						Config.tlsContext, hwndDlg, Config.prefRef, 
						Config.prefRefNet, Config.keyDB);

				PGPSetPrefString(Config.prefRef, kPGPPrefRNGSeedFile, szRNG);
				PGPSavePrefFile(Config.prefRef);

				if (!Config.bCopyNetHosts)
				{
					PGPSetPrefArray(Config.prefRefNet, kPGPNetPrefHostArray,
						pArray);
					PGPFreePrefArray(pArray);
					PGPSavePrefFile(Config.prefRefNet);
					PGPWritePrefsHash(Config.pgpContext, Config.prefRefNet);
				}
				
				if (IsPGPError(err) && (err != kPGPError_UserAbort))
					PGPclErrorBox(hwndDlg, err);
				else
					Config.bSave = FALSE;

				bReturn = TRUE;
			}
			break;

		case IDC_CREATEINSTALL:
			{
				PGPUInt32 nUserAccountStatus;
				PGPBoolean bFirstKeyGenerated;
				PGPPrefArray *pArray;
				char szRNG[_MAX_PATH];

				PGPGetPrefNumber(Config.prefRef, kPGPPrefUserAccountStatus,
					&nUserAccountStatus);
				PGPGetPrefBoolean(Config.prefRef, kPGPPrefFirstKeyGenerated,
					&bFirstKeyGenerated);

				if (Config.bPreselectInstall && 
					Config.bRemainSilentAfterInstall)
				{
					PGPSetPrefNumber(Config.prefRef, kPGPPrefUserAccountStatus,
						kPGPPrefPGPDisabled);
				}
				else
				{
					PGPSetPrefNumber(Config.prefRef, kPGPPrefUserAccountStatus,
						kPGPPrefPGPNotInitialized);
				}

				PGPSetPrefBoolean(Config.prefRef, kPGPPrefFirstKeyGenerated,
					FALSE);
				PGPGetPrefStringBuffer(Config.prefRef, kPGPPrefRNGSeedFile,
					_MAX_PATH, szRNG);
				PGPSetPrefString(Config.prefRef, kPGPPrefRNGSeedFile, "");
				PGPSavePrefFile(Config.prefRef);

				if (!Config.bCopyNetHosts)
				{
					PGPGetPrefArray(Config.prefRefNet, kPGPNetPrefHostArray, 
						&pArray);
					PGPClearPrefData(Config.prefRefNet, kPGPNetPrefHostArray);
					PGPSavePrefFile(Config.prefRefNet);
					PGPWritePrefsHash(Config.pgpContext, Config.prefRefNet);
				}

				SaveAdminOptions(&Config);
				DialogBoxParam(g_hInstance, MAKEINTRESOURCE(IDD_INSTALLER),
					hwndDlg, InstallerDlgProc, (LPARAM) &Config);
				Config.bSave = FALSE;

				PGPSetPrefBoolean(Config.prefRef, kPGPPrefFirstKeyGenerated,
					bFirstKeyGenerated);
				PGPSetPrefNumber(Config.prefRef, kPGPPrefUserAccountStatus,
					nUserAccountStatus);
				PGPSetPrefString(Config.prefRef, kPGPPrefRNGSeedFile, szRNG);
				PGPSavePrefFile(Config.prefRef);

				if (!Config.bCopyNetHosts)
				{
					PGPSetPrefArray(Config.prefRefNet, kPGPNetPrefHostArray,
						pArray);
					PGPFreePrefArray(pArray);
					PGPSavePrefFile(Config.prefRefNet);
					PGPWritePrefsHash(Config.pgpContext, Config.prefRefNet);
				}

				bReturn = TRUE;
				break;
			}
		}
		break;

	case WM_CLOSE:
		if (Config.bSave)
		{
			char szTitle[255];
			char szMsg[255];
			int nResult;

			LoadString(g_hInstance, IDS_TITLE, szTitle, 254);
			LoadString(g_hInstance, IDS_E_NOTSAVED, szMsg, 254);

			nResult = MessageBox(hwndDlg, szMsg, szTitle, MB_YESNO | 
						MB_ICONQUESTION);

			if (nResult == IDNO)
				break;
		}
		HtmlHelp(NULL, NULL, HH_CLOSE_ALL, 0);
		EndDialog(hwndDlg, 0);
		break;
	}

	return bReturn;
}


//-------------------------------------------------------------------|
// Load DIB bitmap and associated palette

static HPALETTE 
CreateDIBPalette (LPBITMAPINFO lpbmi, 
				  LPINT lpiNumColors) 
{
	LPBITMAPINFOHEADER lpbi;
	LPLOGPALETTE lpPal;
	HANDLE hLogPal;
	HPALETTE hPal = NULL;
	INT i;
 
	lpbi = (LPBITMAPINFOHEADER)lpbmi;
	if (lpbi->biBitCount <= 8) {
		*lpiNumColors = (1 << lpbi->biBitCount);
	}
	else
		*lpiNumColors = 0;  // No palette needed for 24 BPP DIB
 
	if (*lpiNumColors) {
		hLogPal = GlobalAlloc (GHND, sizeof (LOGPALETTE) +
                             sizeof (PALETTEENTRY) * (*lpiNumColors));
		lpPal = (LPLOGPALETTE) GlobalLock (hLogPal);
		lpPal->palVersion = 0x300;
		lpPal->palNumEntries = *lpiNumColors;
 
		for (i = 0;  i < *lpiNumColors;  i++) {
			lpPal->palPalEntry[i].peRed   = lpbmi->bmiColors[i].rgbRed;
			lpPal->palPalEntry[i].peGreen = lpbmi->bmiColors[i].rgbGreen;
			lpPal->palPalEntry[i].peBlue  = lpbmi->bmiColors[i].rgbBlue;
			lpPal->palPalEntry[i].peFlags = 0;
		}
		hPal = CreatePalette (lpPal);
		GlobalUnlock (hLogPal);
		GlobalFree (hLogPal);
   }
   return hPal;
}


static HBITMAP 
LoadResourceBitmap (HINSTANCE hInstance, 
					LPSTR lpString,
					HPALETTE FAR* lphPalette) 
{
	HRSRC  hRsrc;
	HGLOBAL hGlobal;
	HBITMAP hBitmapFinal = NULL;
	LPBITMAPINFOHEADER lpbi;
	HDC hdc;
    INT iNumColors;
 
	if (hRsrc = FindResource (hInstance, lpString, RT_BITMAP)) {
		hGlobal = LoadResource (hInstance, hRsrc);
		lpbi = (LPBITMAPINFOHEADER)LockResource (hGlobal);
 
		hdc = GetDC(NULL);
		*lphPalette =  CreateDIBPalette ((LPBITMAPINFO)lpbi, &iNumColors);
		if (*lphPalette) {
			SelectPalette (hdc,*lphPalette,FALSE);
			RealizePalette (hdc);
		}
 
		hBitmapFinal = CreateDIBitmap (hdc,
                   (LPBITMAPINFOHEADER)lpbi,
                   (LONG)CBM_INIT,
                   (LPSTR)lpbi + lpbi->biSize + iNumColors * sizeof(RGBQUAD),
                   (LPBITMAPINFO)lpbi,
                   DIB_RGB_COLORS );
 
		ReleaseDC (NULL,hdc);
		UnlockResource (hGlobal);
		FreeResource (hGlobal);
	}
	return (hBitmapFinal);
}


static void sNewPrefs()
{
	PFLFileSpecRef  prefFile;
	PGPPrefRef		prefRef = NULL;
	PGPPrefRef		prefRefNet = NULL;
	char			szPath[_MAX_PATH];

	InitAdminOptions(g_pgpContext, &Config, FALSE);
	Config.prefRef = NULL;
	Config.prefRefNet = NULL;

	GetTempPath(sizeof(Config.szClientPrefs), Config.szClientPrefs);
	strcpy(Config.szNetPrefs, Config.szClientPrefs);
	strcpy(Config.szDefaultKeys, Config.szClientPrefs);
	strcat(Config.szClientPrefs, "client.txt");
	strcat(Config.szNetPrefs, "net.txt");
	strcat(Config.szDefaultKeys, "keys.asc");

	CloseHandle(CreateFile(Config.szClientPrefs, GENERIC_WRITE, 0, NULL,
		OPEN_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL));
	CloseHandle(CreateFile(Config.szNetPrefs, GENERIC_WRITE, 0, NULL,
		OPEN_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL));
	CloseHandle(CreateFile(Config.szDefaultKeys, GENERIC_WRITE, 0, NULL, 
		OPEN_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL));

	PFLNewFileSpecFromFullPath(Config.memoryMgr, Config.szClientPrefs, 
		&prefFile);
	PGPOpenPrefFile(prefFile, clientDefaults, clientDefaultsSize, 
		&Config.prefRef);
	PFLFreeFileSpec(prefFile);
	PGPSavePrefFile(Config.prefRef);

	PFLNewFileSpecFromFullPath(Config.memoryMgr, Config.szNetPrefs, 
		&prefFile);
	PGPOpenPrefFile(prefFile, netDefaults, netDefaultsSize, 
		&Config.prefRefNet);
	PFLFreeFileSpec(prefFile);
	PGPSavePrefFile(Config.prefRefNet);

	PGPclPeekClientLibPrefRefs(&prefRef, &prefRefNet);
	PGPGetPrefStringBuffer(prefRef, kPGPPrefPublicKeyringFile, _MAX_PATH,
		szPath);
	PGPSetPrefString(Config.prefRef, kPGPPrefPublicKeyringFile, szPath);
	PGPGetPrefStringBuffer(prefRef, kPGPPrefPrivateKeyringFile, _MAX_PATH,
		szPath);
	PGPSetPrefString(Config.prefRef, kPGPPrefPrivateKeyringFile, szPath);
	PGPGetPrefStringBuffer(prefRef, kPGPPrefRNGSeedFile, _MAX_PATH,
		szPath);
	PGPSetPrefString(Config.prefRef, kPGPPrefRNGSeedFile, szPath);

	if (prefRefNet != NULL)
	{
		PGPGetPrefStringBuffer(prefRefNet, kPGPNetPrefPublicKeyringFile, 
			_MAX_PATH, szPath);
		PGPSetPrefString(Config.prefRefNet, kPGPNetPrefPublicKeyringFile, 
			szPath);
		PGPGetPrefStringBuffer(prefRefNet, kPGPNetPrefPrivateKeyringFile, 
			_MAX_PATH, szPath);
		PGPSetPrefString(Config.prefRefNet, kPGPNetPrefPrivateKeyringFile, 
			szPath);
	}

	return;
}


static void sSavePrefs(HWND hwndMain)
{
	OPENFILENAME openFile;
	char szFile[MAX_PATH];
	char szTitle[256];
				
	strcpy(szFile, "PGPPrefs.txt");
	LoadString(g_hInstance, IDS_SAVEPREFS, szTitle, 255);
				
	openFile.lStructSize = sizeof(OPENFILENAME);
	openFile.hwndOwner = hwndMain;
	openFile.lpstrFilter =	"Preference Files (*.txt)\0"
							"*.txt\0";
	openFile.lpstrCustomFilter = NULL;
	openFile.nFilterIndex = 1;
	openFile.lpstrFile = szFile;
	openFile.nMaxFile = MAX_PATH-1;
	openFile.lpstrFileTitle = NULL;
	openFile.lpstrInitialDir = NULL;
	openFile.lpstrTitle = szTitle;
	openFile.Flags = OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT | OFN_NOCHANGEDIR;
	openFile.lpstrDefExt = "txt";
				
	if (!GetSaveFileName(&openFile))
		return;

	CopyFile(Config.szClientPrefs, szFile, FALSE);

	strcpy(szFile, "PGPnetPrefs.txt");
	LoadString(g_hInstance, IDS_SAVENETPREFS, szTitle, 255);
	if (GetSaveFileName(&openFile))
		CopyFile(Config.szNetPrefs, szFile, FALSE);

	Config.bSave = FALSE;
	return;
}


static void sFreeData()
{
	FreeAdminOptions(&Config);
	
	if (Config.prefRef != NULL)
	{
		PGPFreePrefs(Config.prefRef);
		DeleteFile(Config.szClientPrefs);
	}

	if (Config.prefRefNet != NULL)
	{
		PGPFreePrefs(Config.prefRefNet);
		DeleteFile(Config.szNetPrefs);
	}

	if (strlen(Config.szDefaultKeys) > 0)
		DeleteFile(Config.szDefaultKeys);

	return;
}


/*__Editor_settings____

	Local Variables:
	tab-width: 4
	End:
	vi: ts=4 sw=4
	vim: si
_____________________*/
