/*____________________________________________________________________________
	Copyright (C) 2002 PGP Corporation
	All rights reserved.

	$Id: DefaultKeys.c,v 1.8 2002/10/07 16:20:09 wjb Exp $
____________________________________________________________________________*/

#include <windows.h>
#include "PGPadmin.h"
#include <commctrl.h>
#include "resource.h"
#include "Utils.h"
#include "keydrawitem.h"

#include "PGPadminHelp.h"
#include "pgpClientLib.h"

static DWORD aHelpIds[] = {
	IDC_DEFKEY_ID,	IDH_PGPADMIN_DEFKEY_ID,
    0,0
};

HFONT g_hFont;

BOOL CALLBACK DefaultKeysDlgProc(HWND hwndDlg, 
								 UINT uMsg, 
								 WPARAM wParam, 
								 LPARAM lParam)
{
	BOOL			bReturnCode = FALSE;
	pgpConfigInfo *	pConfig		= NULL;
	HWND			hList;

	g_hCurrentDlgWnd = hwndDlg;
	pConfig = (pgpConfigInfo *) GetWindowLong(hwndDlg, GWL_USERDATA);
	hList = GetDlgItem(hwndDlg, IDC_DEFKEY_ID);

	switch(uMsg)
	{
	case WM_INITDIALOG:
		{
			CommonDlgProc(hwndDlg, uMsg, wParam, lParam);

			pConfig = (pgpConfigInfo *) GetWindowLong(hwndDlg, GWL_USERDATA);
			
			ShowKeyring(hwndDlg, IDC_DEFKEY_ID, pConfig->pgpContext, 
				pConfig->keyDB, NULL, TRUE, TRUE, FALSE, FALSE);

			SelectKeys(hwndDlg, IDC_DEFKEY_ID, pConfig->nNumDefaultKeys,
				pConfig->defaultKeys);

			// Property sheets use bad unicode font, so we must set
			// it ourselves for listviews
			g_hFont=SetUTF8Font(GetDlgItem(hwndDlg,IDC_DEFKEY_ID));
			break;
		}

    case WM_DRAWITEM: 
    {
        KeyDrawItem((LPDRAWITEMSTRUCT) lParam);
        return TRUE;
    }

	case WM_DESTROY:
		FreeKeyring(hwndDlg, IDC_DEFKEY_ID);
		DeleteObject(g_hFont);
		break;

	case WM_HELP:
	case WM_CONTEXTMENU:
		return PGPclHtmlHelp (hwndDlg, uMsg, wParam, lParam, 
				(char *) kPGPclAdminHelpFile, aHelpIds);

	case WM_NOTIFY:
		{
			LPNMHDR pnmh;

			pnmh = (LPNMHDR) lParam;
			switch(pnmh->code)
			{
			case PSN_HELP:
				PGPclHtmlHelp (hwndDlg, kPGPclHelpContext, 0, 0, 
						(char *) kPGPclAdminHelpFile, 
						(DWORD *) IDH_PGPADMIN_DEFAULTKEYSDIALOG);
				break;

			case PSN_KILLACTIVE:
				{
					// Save user data for this page

					AddSelectedKeys(hwndDlg, IDC_DEFKEY_ID, 
						pConfig->pgpContext, &(pConfig->nNumDefaultKeys),
						&(pConfig->defaultKeys));

					bReturnCode = TRUE;
					break;
				}

			case NM_CLICK:
			case TVN_KEYDOWN:
				if (pnmh->idFrom == IDC_DEFKEY_ID)
					PropSheet_Changed(GetParent(hwndDlg), hwndDlg);
				bReturnCode = CommonDlgProc(hwndDlg, uMsg, wParam, lParam);
				break;

			default:
				bReturnCode = CommonDlgProc(hwndDlg, uMsg, wParam, lParam);
				break;
			}
			
			break;
		}

	default:
		bReturnCode = CommonDlgProc(hwndDlg, uMsg, wParam, lParam);
		break;
	}

	return(bReturnCode);
}

/*__Editor_settings____

	Local Variables:
	tab-width: 4
	End:
	vi: ts=4 sw=4
	vim: si
_____________________*/
