/*____________________________________________________________________________
	Copyright (C) 2002 PGP Corporation
	All rights reserved.

	$Id: PGPadmin.h,v 1.30 2002/11/16 19:33:21 pbj Exp $
____________________________________________________________________________*/
#ifndef Included_PGPadmin_h	/* [ */
#define Included_PGPadmin_h

#include "pgpKeys.h"
#include "pgpKeyServer.h"
#include "pflPrefs.h"

#include "pgpClientLib.h"

PGP_BEGIN_C_DECLARATIONS

// Wizard pages

typedef enum _AdminPropPage
{
	Admin_Start=0,
	Admin_ADK=Admin_Start,
	Admin_PassPhrase,
	Admin_KeyGen,
	Admin_DefaultKeys,
	Admin_CorpKey,
	Admin_Revoker,
	Admin_ServerUpdates,
	Admin_Access,
	Admin_InstallOptions,
	Admin_Misc,
	NUM_ADMIN_PAGES
} AdminPropPage;

// PGP Option pages

#define ADMINKEYSPREFSPAGES		kPGPclGeneralPrefs			| \
								kPGPclHotkeyPrefs			| \
								kPGPclKeyserverPrefs		| \
								kPGPclCAPrefs				| \
								kPGPclAdvancedPrefs

#define ADMINMAILPREFSPAGES		kPGPclEmailPrefs

#define ADMINDISKPREFSPAGES		kPGPclPGPdiskPrefs

#define ADMINFIREPREFSPAGES		kPGPclPGPnetIDRPrefs
								

#define ADMINVPNPREFSPAGES		kPGPclPGPnetVPNPrefs		| \
								kPGPclPGPnetAuthPrefs		| \
								kPGPclPGPnetAdvancedPrefs

// Configuration information

typedef struct _pgpConfigInfo
{
	PGPContextRef			pgpContext;
	PGPtlsContextRef		tlsContext;
	PGPMemoryMgrRef			memoryMgr;
	PGPKeyDBRef				keyDB;
	PGPBoolean				bUseOutgoingADK;
	PGPBoolean				bUseIncomingADK;
	PGPBoolean				bUseDiskADK;
	PGPKeyID 				outgoingADKID;
	PGPKeyID	 			incomingADKID;
	PGPKeyID				diskADKID;
	PGPBoolean				bEnforceIncomingADK;
	PGPBoolean				bEnforceOutgoingADK;
	PGPBoolean				bEnforceRemoteADK;
	PGPBoolean				bEnforceMinChars;
	PGPUInt32				nMinChars;
	PGPBoolean				bEnforceMinQuality;
	PGPUInt32				nMinQuality;
	PGPKeyID	 			corpKeyID;
	PGPBoolean				bAutoSignTrustCorp;
	PGPBoolean				bMetaIntroducerCorp;
	PGPUInt32				nCorpKeyTrustDepth;
	PGPBoolean				bAutoAddRevoker;
	PGPKeyID				revokerKeyID;
	PGPBoolean				bKeyGenCertRequest;
	PGPBoolean				bAllowManualCertRequest;
	PGPBoolean				bAutoUpdateCRL;
	PGPKeyServerClass		nCAType;
	PGPKeyServerClass		nOldCAType;
	PGPByte	*				avData;
	PGPSize					avDataSize;
	PGPUInt32				nCertRequestType;
	PGPBoolean				bAllowKeyGen;
	PGPBoolean				bSetKeyGen;
	PGPBoolean				bUseSmartCard;
	PGPPublicKeyAlgorithm	keyType;
	PGPTime					keyExpiration;
	PGPUInt32				nKeySize;
	PGPBoolean				bAlwaysSendKeys;
	PGPBoolean				bAutoKeyReconstruction;
	PGPBoolean				bAutoSignRootCAKey;
	char *					szReconServer;
	PGPKeyServerClass		nReconServerType;
	PGPBoolean				bUpdateAdminPrefs;
	PGPBoolean				bUpdateAllKeys;
	PGPBoolean				bUpdateTrustedIntroducers;
	PGPUInt32				nDaysUpdatePrefs;
	PGPUInt32				nDaysUpdateAllKeys;
	PGPUInt32				nDaysUpdateTrustedIntroducers;
	char *					szLDAPServer;
	PGPBoolean				bAllowConventionalEncryption;
	PGPBoolean				bAllowEncryptInvalidKeys;
	PGPBoolean				bAllowKeySigning;
	PGPBoolean				bAutoAddExchangeServerAddress;
	PGPBoolean				bAutoAddLotusNotesAddress;
	PGPKeySetRef			userKeySet;
	PGPKeyID *				defaultKeys;
	PGPUInt32				nNumDefaultKeys;
	char *					szAdminInstaller;
	char *					szClientInstaller;
	PGPBoolean				bCopyClientPrefs;
	PGPBoolean				bCopyNetHosts;
	PGPBoolean				bMergeNetHosts;
	PGPBoolean				bPreselectInstall;
	char *					szUserInstallDir;
	PGPBoolean				bRemainSilentAfterInstall;
	PGPBoolean				bInstallPrograms;
	PGPBoolean				bInstallLogin;
	PGPBoolean				bInstallNet;
	PGPBoolean				bInstallFire;
	PGPBoolean				bInstallDisk;
	PGPBoolean				bInstallEudora;
	PGPBoolean				bInstallOutlook;
	PGPBoolean				bInstallOutExpress;
	PGPBoolean				bInstallICQ;
	PGPBoolean				bInstallLotus;
	PGPBoolean				bInstallGroupwise;
	PGPBoolean				bInstallManual;
	PGPUInt32				nInstallCount;
	PGPBoolean				bUninstallOld;
	PGPBoolean				bAutoReboot;
	PGPBoolean				bDisableAutoUpgrade;
	PGPBoolean				bSave;
	PGPBoolean				bApplied;
	PGPBoolean				bCancel;
	PGPBoolean				bCenter;
	PGPUInt32				nPageCount;
	PGPUInt32				nApplyCount;
	PGPPrefRef				prefRef;
	PGPPrefRef				prefRefNet;
	char					szClientPrefs[_MAX_PATH];
	char					szNetPrefs[_MAX_PATH];
	char					szDefaultKeys[_MAX_PATH];
	PGPBoolean				bActiveX;
	PGPBoolean				bDiskCreate;
	PGPUInt32				nDiskSize;
	PGPUInt32				nDiskAlgorithm;
	PGPUInt32				nDiskFileSystem;
	char *					szDefaultKeysBuffer;
	PGPSize					nDefaultKeysBufferSize;
	char *					szProductKey;
} pgpConfigInfo;

// Global variables

extern HINSTANCE g_hInstance;
extern HWND g_hCurrentDlgWnd;

// Admin Options functions

void InitAdminOptions(PGPContextRef pgpContext, pgpConfigInfo *pConfig,
					  PGPBoolean bIsActiveX);
void LoadAdminOptions(pgpConfigInfo *pConfig);
void AdminOptions(HWND hwndMain, pgpConfigInfo *pConfig);
void FreeAdminOptions(pgpConfigInfo *pConfig);
void SaveAdminOptions(pgpConfigInfo *pConfig);

// Installer functions

BOOL CALLBACK InstallerDlgProc(HWND hwndDlg, 
							   UINT uMsg, 
							   WPARAM wParam, 
							   LPARAM lParam);

BOOL CALLBACK PlatformDlgProc(HWND hwndDlg, 
							  UINT uMsg, 
							  WPARAM wParam, 
							  LPARAM lParam);

// Property page dialog procedures

BOOL CALLBACK AccessDlgProc(HWND hwndDlg,
							UINT uMsg,
							WPARAM wParam,
							LPARAM lParam);

BOOL CALLBACK CommonDlgProc(HWND hwndDlg, 
							UINT uMsg, 
							WPARAM wParam, 
							LPARAM lParam);

BOOL CALLBACK ADKDlgProc(HWND hwndDlg, 
						 UINT uMsg, 
						 WPARAM wParam, 
						 LPARAM lParam);

BOOL CALLBACK PassPhraseDlgProc(HWND hwndDlg, 
								UINT uMsg, 
								WPARAM wParam, 
								LPARAM lParam);

BOOL CALLBACK CorpKeyDlgProc(HWND hwndDlg, 
							 UINT uMsg, 
							 WPARAM wParam, 
							 LPARAM lParam);

BOOL CALLBACK RevokerDlgProc(HWND hwndDlg, 
							 UINT uMsg, 
							 WPARAM wParam, 
							 LPARAM lParam);

BOOL CALLBACK KeyGenDlgProc(HWND hwndDlg, 
							UINT uMsg, 
							WPARAM wParam, 
							LPARAM lParam);

BOOL CALLBACK DefaultKeysDlgProc(HWND hwndDlg, 
								 UINT uMsg, 
								 WPARAM wParam, 
								 LPARAM lParam);

BOOL CALLBACK ServerUpdatesDlgProc(HWND hwndDlg, 
								   UINT uMsg, 
								   WPARAM wParam, 
								   LPARAM lParam);

BOOL CALLBACK MiscDlgProc(HWND hwndDlg, 
						  UINT uMsg, 
						  WPARAM wParam, 
						  LPARAM lParam);

BOOL CALLBACK InstallOptionsDlgProc(HWND hwndDlg, 
									UINT uMsg, 
									WPARAM wParam, 
									LPARAM lParam);

PGP_END_C_DECLARATIONS

#endif /* ] Included_PGPadmin_h */


/*__Editor_settings____

	Local Variables:
	tab-width: 4
	End:
	vi: ts=4 sw=4
	vim: si
_____________________*/
