/*____________________________________________________________________________
	Copyright (C) 2002 PGP Corporation
	All rights reserved.

	$Id: Utils.h,v 1.9 2002/10/07 16:20:09 wjb Exp $
____________________________________________________________________________*/
#ifndef Included_Utils_h	/* [ */
#define Included_Utils_h

#include "pgpKeys.h"

typedef enum _InstallerProduct
{
	Installer_None			= 0,

	Installer_PGPds			= 1,
	Installer_PGPmail		= 2,
	Installer_PGPdisk		= 4,
	Installer_PGPvpn		= 8,
	Installer_PGPfire		= 16,

	Installer_All			= 127,
	Installer_AtLeastOne	= 128
}
InstallerProduct;

PGP_BEGIN_C_DECLARATIONS

void ShowKeyring(HWND hWnd, 
				 int nListCtrl,
				 PGPContextRef pgpContext,
				 PGPKeyDBRef keyDB,
				 PGPKeySetRef onlyThisKeySet,
				 PGPBoolean bShowRSA,
				 PGPBoolean bShowV4,
				 PGPBoolean bMustEncrypt,
				 PGPBoolean bMustSign);

BOOL SelectKeys(HWND hWnd,
				int nListCtrl,
				PGPUInt32 nNumKeys,
				PGPKeyID *pConfigKeyID);

void AddSelectedKeys(HWND hWnd, 
					 int nListCtrl, 
					 PGPContextRef pgpContext,
					 PGPUInt32 *pnNumKeys,
					 PGPKeyID **pKeyIDs);

void FreeKeyring(HWND hWnd, 
				 int nListCtrl);

void PaintWizBitmap(HWND hWnd, HBITMAP hBitmap);

void SecondsToSystemTime(PGPUInt32 nSeconds, SYSTEMTIME *sysTime);

void PGPTimeToSystemTime(PGPTime pgpTime, SYSTEMTIME *sysTime);

void SystemTimeToPGPTime(SYSTEMTIME *sysTime, PGPTime *pgpTime);

InstallerProduct GetInstalledProduct(char *szProductKey);

PGP_END_C_DECLARATIONS

#endif /* ] Included_Utils_h */


/*__Editor_settings____

	Local Variables:
	tab-width: 4
	End:
	vi: ts=4 sw=4
	vim: si
_____________________*/
