/*____________________________________________________________________________
	Copyright (C) 2002 PGP Corporation
	All rights reserved.
	
	CLabout.c - display "help about" dialog
	
	$Id: CLabout.c,v 1.75 2002/11/20 14:28:33 pbj Exp $
____________________________________________________________________________*/
#include "pgpPFLConfig.h"
#include "pgpUnicode.h"
#include "pgpUnicodeWin32.h"

#define LNABOUT 1

// project header files
#include "pgpclx.h"
#include "pgpBuild.h"

#if LNABOUT
#include "stdio.h"
#endif

// system header files
#include <shellapi.h>
#include <process.h>


#define DISPLAY_CREDITS		1
	
#define ADDWIDTH			0
#define ADDHEIGHT			0
#define NAGADDWIDTH			6
#define NAGADDHEIGHT		6
#define XINCREMENT			6
#define YINCREMENT			10
#define EDGEWIDTH			6

#define VERSIONPOSY			0.30
#define BETATEXTPOSY		0.40
#define NOLICENSEPOSY		0.38
#define NOLICENSETEXT1POSY	0.44
#define NOLICENSETEXT2POSY	0.73

#define LICENSEEPOSY		0.36
#define CORPPOSDELTAY		0.04
#define SEATSPOSDELTAY		0.06
#define EXPIREPOSDELTAY		0.06

#define LEFTCOLUMNLEFT		0.02
#define LEFTCOLUMNRIGHT		0.40
#define RIGHTCOLUMNLEFT		0.20
#define RIGHTCOLUMNRIGHT	0.50

#define FULLLENGTH			1.00

#define UPGRADEBUTTONXPOS	0.03
#define UPGRADEBUTTONYPOS	0.92

#define NAGBUTTONXPOS		0.58
#define NAGBUTTON1YPOS		0.21
#define NAGBUTTON2YPOS		0.52
#define NAGBUTTON3YPOS		0.62

#define NAGTEXTXPOS			0.05
#define NAGTEXTYPOS			0.10
#define NAGTEXTWIDTH		0.40
#define NAGTEXTHEIGHT		0.80
#define VERSIONXPOS			0.99
#define VERSIONYPOS			0.02

#define CONGRATSXPOS		0.25
#define CONGRATSYPOSMAN		0.60
#define CONGRATSYPOSAUTO	0.40

#define MINSCROLLYPOS		0.55
#define MAXSCROLLYPOS		0.85
#define SCROLLXPOS			0.79

#define TOPFADEZONE			18
#define BOTFADEZONE			18

#define TOPFADECOLOR		180
#define TOPFADECOLORRED		240
#define TOPFADECOLORBLUE	200
#define TOPFADECOLORGREEN	110

#define BOTFADECOLOR		200
#define BOTFADECOLORRED		235
#define BOTFADECOLORBLUE	210
#define BOTFADECOLORGREEN	145

#define REFRESH_TIMER		77
#if DISPLAY_CREDITS
#define REFRESH_TIME		40
#else
#define REFRESH_TIME		1000
#endif

#define	FONT_NORMAL			0
#define FONT_ITALIC			1
#define FONT_BOLD			2

#define BUTTON_X_OFFSET		12
#define BUTTON_Y_OFFSET		8

#define MAX_TEXT_LENGTH		32

typedef struct _DIALOGINFOSTRUCT {
	HWND			hWndParent;
	LPSTR			pszText;
	HBITMAP			hBitmapMain;
	COLORREF		crTextColor;
	COLORREF		crTextScrollColor;
	HPALETTE		hPaletteMain;
	BOOL			bFirstTime;
	BOOL			bRoundedButton;

	UINT			uXsize;
	UINT			uYsize;
	UINT			uXpos;
	UINT			uYpos;

	INT				iMinPos;
	INT				iMaxPos;
	INT				iScrollPos;
	INT				iTextIndex;

	HFONT			hfont;
	HFONT			hfontItalic;
	HFONT			hfontBold;
	INT				iRowHeight;
	INT				iTextXPos;

} DIALOGINFOSTRUCT, *PDIALOGINFOSTRUCT;

// external globals
extern HINSTANCE	g_hInst;

#if DISPLAY_CREDITS

// scrolling text
typedef struct {
	INT		iFont;
	CHAR	szText[MAX_TEXT_LENGTH];
} TEXTSTRUCT;

static TEXTSTRUCT	s_tsText[] = {
	{FONT_BOLD,		"Credits"},
	{FONT_NORMAL,	""},
	{FONT_BOLD,		"Engineering"},
	{FONT_NORMAL,	"David Allen"},
	{FONT_NORMAL,	"Bill Blanke"},
	{FONT_NORMAL,	"Jason Bobier"},
	{FONT_NORMAL,	"Jeff Cruikshank"},
	{FONT_NORMAL,	"Satya Das"},
	{FONT_NORMAL,	"Andrey Jivsov"},
	{FONT_NORMAL,	"Paul Johnson"},
	{FONT_NORMAL,	""},
	{FONT_BOLD,		"Engineering Management"},
	{FONT_NORMAL,	"Will Price"},
	{FONT_NORMAL,	""},
	{FONT_BOLD,		"Quality Engineering"},
	{FONT_NORMAL,	"Jim Agua"},
	{FONT_NORMAL,	"Sean McLean"},
	{FONT_NORMAL,	"Glen Sonnenberg"},
	{FONT_NORMAL,	""},
	{FONT_BOLD,		"Documentation"},
	{FONT_NORMAL,	"Scott Wilson"},
	{FONT_NORMAL,	""},
	{FONT_BOLD,		"Management"},
	{FONT_NORMAL,	"Steve Abbott"},
	{FONT_NORMAL,	"Jon Callas"},
	{FONT_NORMAL,	"Michael Doherty"},
	{FONT_NORMAL,	"Alex Doll"},
	{FONT_NORMAL,	"Phil Dunkelberger"},
	{FONT_NORMAL,	"Andrew Krcik"},
	{FONT_NORMAL,	"Spencer Snedecor"},
	{FONT_NORMAL,	"Stephan Somogyi"},
	{FONT_NORMAL,	""},
	{FONT_BOLD,		"Special Advisor"},
	{FONT_NORMAL,	"Philip Zimmermann"},
	{FONT_NORMAL,	""},
	{FONT_BOLD,		"Artwork"},
	{FONT_NORMAL,	"The Iconfactory"},
	{FONT_NORMAL,	""},
	{FONT_BOLD,		"Thanks"},
	{FONT_NORMAL,	"Doll Capital"},
	{FONT_NORMAL,	"Paul Ryan"},
	{FONT_NORMAL,	"Jeffrey Schiller"},
	{FONT_NORMAL,	"Stale Schumacher"},
	{FONT_NORMAL,	"Venrock Associates"},
	{FONT_NORMAL,	""},
	{FONT_NORMAL,	""},
	{FONT_NORMAL,	""},
	{FONT_NORMAL,	""},
	{FONT_NORMAL,	""},
	{FONT_NORMAL,	""},
	{FONT_NORMAL,	""} };

#define NUM_TEXT_ROWS	(sizeof(s_tsText) / sizeof(TEXTSTRUCT))


//	___________________________________________________
//
//	Paint scrolling text

VOID
sPaintScrollingText (
		PDIALOGINFOSTRUCT	pdis,
		HWND				hwnd,
		HDC					hdc)
{
	HFONT		hFontOld;
	UINT		uTAOld;
	INT			iText, iYpos;
	INT			iColorRed, iColorBlue, iColorGreen;
	LPSTR		psz;
	HFONT		hfont;

	SetBkMode (hdc, TRANSPARENT);
	uTAOld = SetTextAlign (hdc, TA_CENTER);
	hFontOld = SelectObject (hdc, pdis->hfont);

	// scrolling text
	iYpos = pdis->iScrollPos;
	iText = pdis->iTextIndex;

	while (iYpos < pdis->iMaxPos)
	{
		psz = s_tsText[iText].szText;
		switch (s_tsText[iText].iFont) {
			case FONT_NORMAL :	hfont = pdis->hfont;		break;
			case FONT_ITALIC :	hfont = pdis->hfontItalic;	break;
			case FONT_BOLD :	hfont = pdis->hfontBold;	break;
		}
		SelectObject (hdc, hfont);

		iColorRed = GetRValue (pdis->crTextScrollColor);
		iColorBlue = GetBValue (pdis->crTextScrollColor);
		iColorGreen = GetGValue (pdis->crTextScrollColor);

		if (iYpos > (pdis->iMaxPos - BOTFADEZONE))
		{
			if (iYpos >= pdis->iMaxPos)
			{
				iColorRed = BOTFADECOLORRED;
				iColorBlue = BOTFADECOLORBLUE;
				iColorGreen = BOTFADECOLORGREEN;
			}
			else
			{
				iColorRed = (INT)((float)BOTFADECOLORRED + 
					(float)(iColorRed - BOTFADECOLORRED)*
					((float)(pdis->iMaxPos - iYpos) / (float)BOTFADEZONE));

				iColorBlue = (INT)((float)BOTFADECOLORBLUE + 
					(float)(iColorBlue - BOTFADECOLORBLUE)*
					((float)(pdis->iMaxPos - iYpos) / (float)BOTFADEZONE));

				iColorGreen = (INT)((float)BOTFADECOLORGREEN + 
					(float)(iColorGreen - BOTFADECOLORGREEN)*
					((float)(pdis->iMaxPos - iYpos) / (float)BOTFADEZONE));
			}
		}
		else if (iYpos < (pdis->iMinPos + TOPFADEZONE))
		{
			if (iYpos <= pdis->iMinPos)
			{
				iColorRed = TOPFADECOLORRED;
				iColorBlue = TOPFADECOLORBLUE;
				iColorGreen = TOPFADECOLORGREEN;
			}
			else
			{
				iColorRed = (INT)((float)TOPFADECOLORRED + 
					(float)(iColorRed - TOPFADECOLORRED)*
					((float)(iYpos - pdis->iMinPos) / (float)TOPFADEZONE));

				iColorBlue = (INT)((float)TOPFADECOLORBLUE + 
					(float)(iColorBlue - TOPFADECOLORBLUE)*
					((float)(iYpos - pdis->iMinPos) / (float)TOPFADEZONE));

				iColorGreen = (INT)((float)TOPFADECOLORGREEN + 
					(float)(iColorGreen - TOPFADECOLORGREEN)*
					((float)(iYpos - pdis->iMinPos) / (float)TOPFADEZONE));
			}
		}

		// draw text
		SetTextColor (hdc, RGB (iColorRed, iColorBlue, iColorGreen));
		TextOut (hdc, pdis->iTextXPos, iYpos, psz, lstrlen (psz));

		if (++iText >= NUM_TEXT_ROWS)
			iText = 0;

		iYpos += pdis->iRowHeight;
	}

	SetTextAlign (hdc, uTAOld);
	SelectObject (hdc, hFontOld);
}

#endif // DISPLAY_CREDITS

//	___________________________________________________
//
//	set the drawing rectangle based on window rect and scaling values

VOID
sSetDrawingRect (
		LPRECT	prcIn,
		double	fLeft,
		double	fTop,
		double	fRight,
		double	fBottom,
		LPRECT	prcOut)
{
	prcOut->left = (long)((prcIn->right-prcIn->left) * fLeft +
			prcIn->left +2);
	prcOut->top = (long)((prcIn->bottom-prcIn->top) * fTop +
			prcIn->top +2);
	prcOut->right = (long)((prcIn->right-prcIn->left) * fRight +
			prcIn->left +2);
	prcOut->bottom = (long)((prcIn->bottom-prcIn->top) * fBottom +
			prcIn->top +2);
}

//	___________________________________________________
//
//	Paint version info text

VOID
sPaintVersionInfo (
		PDIALOGINFOSTRUCT	pdis,
		HWND				hwnd,
		HDC					hdc,
		LPSTR				pszVersion)
{
	HFONT		hFontOld;
	CHAR		sz[256];
	RECT		rc, rcWindow;

	GetClientRect (hwnd, &rcWindow);
	SetBkMode (hdc, TRANSPARENT);
	SetTextAlign (hdc, TA_LEFT);

	SetTextColor (hdc, pdis->crTextColor);
	hFontOld = SelectObject (hdc, pdis->hfontBold);

	sSetDrawingRect (&rcWindow, 
			LEFTCOLUMNLEFT, VERSIONPOSY, 
			LEFTCOLUMNRIGHT, FULLLENGTH, 
			&rc);
	LoadString (g_hInst, IDS_VERSION, sz, sizeof(sz));
	DrawText (hdc, sz, lstrlen(sz), &rc, 
			DT_LEFT|DT_NOPREFIX);

	sSetDrawingRect (&rcWindow, 
			RIGHTCOLUMNLEFT, VERSIONPOSY, 
			RIGHTCOLUMNRIGHT, FULLLENGTH, 
			&rc);
	if (pszVersion)
		lstrcpy (sz, pszVersion);
	else
		lstrcpy (sz, PGPVERSIONSTRING);

	SelectObject (hdc, pdis->hfont);
	DrawText (hdc, sz, lstrlen(sz), &rc, 
			DT_LEFT|DT_NOPREFIX);

	SelectObject (hdc, hFontOld);
}

static void TMToSystemTime (
	struct tm*	ptm, 
	SYSTEMTIME* pst) 
{
	pst->wYear = ptm->tm_year + 1900;
	pst->wMonth = ptm->tm_mon + 1;
	pst->wDay = ptm->tm_mday;
	pst->wDayOfWeek = ptm->tm_wday;
	pst->wHour = ptm->tm_hour;
	pst->wMinute = ptm->tm_min;
	pst->wSecond = ptm->tm_sec;
	pst->wMilliseconds = 0;
}

//	___________________________________________________
//
//	Paint license info text

VOID
sPaintLicenseInfo (
		PDIALOGINFOSTRUCT	pdis,
		HWND				hwnd,
		HDC					hdc)
{
	HFONT		hFontOld;
	RECT		rc,rcWindow;
	CHAR		szString[512];
	CHAR		sz[128];
	INT			iDays;

	GetClientRect (hwnd, &rcWindow);
	SetBkMode (hdc, TRANSPARENT);
	SetTextAlign (hdc, TA_LEFT);
	szString[0] = '\0';

	SetTextColor (hdc, pdis->crTextColor);
	hFontOld = SelectObject (hdc, pdis->hfont);

#if !PGP_LICENSENUMBERS
#if PGP_BETA
	{
		time_t	timeEnd, timeNow;

		sSetDrawingRect (&rcWindow, 
				LEFTCOLUMNLEFT, BETATEXTPOSY, 
				RIGHTCOLUMNRIGHT, FULLLENGTH, 
				&rc);

		PGPlnBetaTimeOut (&timeEnd);
		time (&timeNow);

		iDays = (timeEnd-timeNow) / (60*60*24);

		if (iDays > 0)
		{
			LoadString (g_hInst, IDS_BETAEXPIRES, szString, sizeof(szString));
			wsprintf (sz, szString, iDays);
		}
		else if (iDays == 0)
			LoadString (g_hInst, IDS_BETAEXPIRESTODAY, sz, sizeof(sz));
		else
			LoadString (g_hInst, IDS_BETAEXPIRED, sz, sizeof(sz));

		SelectObject (hdc, pdis->hfontBold);
		DrawText (hdc, sz, lstrlen (sz), &rc,
				DT_WORDBREAK|DT_LEFT|DT_NOPREFIX);
	}
#endif // PGP_BETA
#else // !PGP_LICENSENUMBERS
	{
#if PGP_DEBUG && PGP_DEBUG_LICENSEE
		if (FALSE)
#else
		if (!PGPlnWasAuthorized ())
#endif
		{
			sSetDrawingRect (&rcWindow, 
					LEFTCOLUMNLEFT, NOLICENSEPOSY, 
					RIGHTCOLUMNRIGHT, FULLLENGTH, 
					&rc);
			LoadString (g_hInst, IDS_NOLICENSE, 
					szString, sizeof(szString));
			SelectObject (hdc, pdis->hfontBold);
			DrawText (hdc, szString, lstrlen(szString), 
					&rc, DT_LEFT|DT_NOPREFIX);

			sSetDrawingRect (&rcWindow, 
					LEFTCOLUMNLEFT, NOLICENSETEXT1POSY, 
					RIGHTCOLUMNRIGHT, FULLLENGTH, 
					&rc);
			LoadString (g_hInst, IDS_NOLICENSETEXT1, 
					szString, sizeof(szString));
			SelectObject (hdc, pdis->hfont);
			DrawText (hdc, szString, lstrlen(szString), 
					&rc, DT_LEFT|DT_NOPREFIX|DT_WORDBREAK);

			sSetDrawingRect (&rcWindow, 
					LEFTCOLUMNLEFT, NOLICENSETEXT2POSY, 
					RIGHTCOLUMNRIGHT, FULLLENGTH, 
					&rc);
			LoadString (g_hInst, IDS_NOLICENSETEXT2, 
					szString, sizeof(szString));
			SelectObject (hdc, pdis->hfont);
			DrawText (hdc, szString, lstrlen(szString), 
					&rc, DT_LEFT|DT_NOPREFIX|DT_WORDBREAK);
		}
		else
		{
			CHAR	szName[100];
			CHAR	szCorp[100];
			WCHAR	wsz[100];
			double	fY;

#if PGP_DEBUG && PGP_DEBUG_LICENSEE
			lstrcpy (szName, "Rolie Polie Olie");
			lstrcpy (szCorp, "Big Bad Bozo, Inc., Chatanooga, Tennessee, USA");
#else
			PGPlnLicenseName (szName, sizeof(szName));
			PGPlnLicenseCorp (szCorp, sizeof(szCorp));
#endif
			fY = LICENSEEPOSY;
			sSetDrawingRect (&rcWindow, 
					LEFTCOLUMNLEFT, fY, 
					RIGHTCOLUMNRIGHT, FULLLENGTH, 
					&rc);
			LoadString (g_hInst, IDS_LICENSEDTO, sz, sizeof(sz));
			SelectObject (hdc, pdis->hfontBold);
			DrawText (hdc, sz, lstrlen(sz), 
					&rc, DT_LEFT|DT_WORDBREAK);

			sSetDrawingRect (&rcWindow, 
					RIGHTCOLUMNLEFT, fY, 
					RIGHTCOLUMNRIGHT, FULLLENGTH, 
					&rc);
			SelectObject (hdc, pdis->hfont);

			if (PGPlnLicenseQuantity () == 1)
			{
				pgpUTF8StringToUCS2 (szName, kPGPUnicodeNullTerminated, 
						wsz, sizeof(wsz)/sizeof(WCHAR), NULL);
				TextOutW (hdc, rc.left, rc.top, wsz, lstrlenW (wsz));

				fY += CORPPOSDELTAY;

				sSetDrawingRect (&rcWindow, 
						RIGHTCOLUMNLEFT, fY, 
						RIGHTCOLUMNRIGHT, FULLLENGTH, 
						&rc);
			}
			pgpUTF8StringToUCS2 (szCorp, kPGPUnicodeNullTerminated, 
					wsz, sizeof(wsz)/sizeof(WCHAR), NULL);
			TextOutW (hdc, rc.left, rc.top, wsz, lstrlenW (wsz));

			if (PGPlnLicenseQuantity () > 1)
			{
				fY += SEATSPOSDELTAY;

				sSetDrawingRect (&rcWindow, 
						LEFTCOLUMNLEFT, fY, 
						RIGHTCOLUMNRIGHT, FULLLENGTH, 
						&rc);
				SelectObject (hdc, pdis->hfontBold);
				LoadString (g_hInst, IDS_LICENSESEATS, sz, sizeof(sz));
				DrawText (hdc, sz, lstrlen(sz), 
						&rc, DT_LEFT|DT_NOPREFIX);

				sSetDrawingRect (&rcWindow, 
						RIGHTCOLUMNLEFT, fY, 
						RIGHTCOLUMNRIGHT, FULLLENGTH, 
						&rc);
				SelectObject (hdc, pdis->hfont);
				wsprintf (sz, "%d", PGPlnLicenseQuantity ());
				DrawText (hdc, sz, lstrlen(sz), 
						&rc, DT_LEFT|DT_NOPREFIX);
			}

			iDays = PGPlnLicenseDays ();
			if (iDays != 0x7FFFFFFF)
			{
				fY += EXPIREPOSDELTAY;

				sSetDrawingRect (&rcWindow, 
						LEFTCOLUMNLEFT, fY, 
						RIGHTCOLUMNRIGHT, FULLLENGTH, 
						&rc);
				SelectObject (hdc, pdis->hfontBold);
				LoadString (g_hInst, IDS_LICENSEEXPIRES, sz, sizeof(sz));
				DrawText (hdc, sz, lstrlen(sz), 
						&rc, DT_LEFT|DT_NOPREFIX);

				sSetDrawingRect (&rcWindow, 
						RIGHTCOLUMNLEFT, fY, 
						RIGHTCOLUMNRIGHT, FULLLENGTH, 
						&rc);
				SelectObject (hdc, pdis->hfont);

				if (iDays < 0)
					iDays = 0;

				if (iDays == 0x7FFFFFFF)
				{
					LoadString (g_hInst, 
							IDS_LICENSEEXPIRENEVER, sz, sizeof(sz));
				}
				else if (iDays <= 60)
				{
					if(PGPlnEvaluation())
					{
						LoadString (g_hInst, IDS_LICENSEEVALDAYS, 
								szString, sizeof(szString));
					}
					else
					{
						LoadString (g_hInst, IDS_LICENSEDAYS, 
								szString, sizeof(szString));
					}

					wsprintf(sz, szString, iDays);
				}
				else
				{
					struct tm when;
					time_t now;
					SYSTEMTIME systemtime;
		
					time( &now );
					when = *localtime( &now );

					when.tm_mday = when.tm_mday + iDays;

					mktime(&when);
					
					TMToSystemTime (&when, &systemtime);

					GetDateFormat (LOCALE_USER_DEFAULT, DATE_SHORTDATE, 
							&systemtime, NULL, sz, sizeof(sz));
				}
				DrawText (hdc, sz, lstrlen(sz), 
						&rc, DT_LEFT|DT_NOPREFIX);
			}
		}
	}
#endif // !PGP_LICENSENUMBERS

	SelectObject (hdc, hFontOld);
}


//	______________________________________
//
//	Thread routine to delay and then open URL.
//	If we don't wait for calling dialog box to
//	close, browser will be launched and then forced
//	to background as parent window of calling
//	dialog box is activated.

#define THREAD_DELAY_MS	150

static DWORD
sExecuteShellThread (LPVOID lpvoid) 
{
	LPSTR pszURL;
	pszURL = (LPSTR)lpvoid;

	// delay to allow calling dialog box to close
	// and activate parent
	Sleep (THREAD_DELAY_MS);

	// now that parent is active, open the URL
	if ((ULONG)ShellExecute (NULL, "open", pszURL, NULL, 
				  "C:\\", SW_SHOWNORMAL) <= 32) 
	{
		PGPclMessageBox (NULL, IDS_CAPTIONERROR, 
			IDS_BROWSERERROR, MB_OK|MB_ICONHAND);
	}

	free (pszURL);

	return 0;
}

//	_______________________________________________
//
//	launch web browser with specified link

PGPError PGPclExport 
PGPclWebBrowse (LPSTR pszURL)
{
	LPSTR	pszURLbuffer;

	if (!pszURL) return kPGPError_BadParams;

	pszURLbuffer = malloc (lstrlen(pszURL) +1);
	lstrcpy (pszURLbuffer, pszURL);

	_beginthread (sExecuteShellThread, 0, (LPVOID)pszURLbuffer);

	return kPGPError_NoErr;
}

//	______________________________________
//
//	draw the custom "upgrade" button

void 
sDrawUpgradeButton (
		LPDRAWITEMSTRUCT	pdis,
		PDIALOGINFOSTRUCT	pdis2)
{
	HBRUSH	hBrush, hBrushOld;
	HPEN	hPen, hPenOld;
	CHAR	sz[32];

	if (pdis2->bRoundedButton)
	{
		hBrush = CreateSolidBrush (RGB(165,156,123));
		FillRect (pdis->hDC, &pdis->rcItem, hBrush);
		DeleteObject (hBrush);

		hPen = CreatePen (PS_NULL, 0, 0);
		hBrush = CreateSolidBrush (RGB(70,70,70));

		hBrushOld = SelectObject (pdis->hDC, hBrush);
		hPenOld = SelectObject (pdis->hDC, hPen);
		
		RoundRect (pdis->hDC, pdis->rcItem.left, pdis->rcItem.top, 
				pdis->rcItem.right+1, pdis->rcItem.bottom+1, 22, 22);

		SelectObject (pdis->hDC, hPenOld);
		SelectObject (pdis->hDC, hBrushOld);
		DeleteObject (hPen);
		DeleteObject (hBrush);
	}

	SetTextAlign (pdis->hDC, TA_LEFT);
	SetBkMode (pdis->hDC, TRANSPARENT);
	if (pdis->itemState & ODS_SELECTED)
		SetTextColor (pdis->hDC, RGB(255,255,255));
	else if (pdis2->bRoundedButton)
		SetTextColor (pdis->hDC, RGB(165,156,123));
	else
		SetTextColor (pdis->hDC, pdis2->crTextColor);

	LoadString (g_hInst, IDS_LICENSEUPGRADEBUTTON, sz, sizeof(sz));
	DrawText (pdis->hDC, sz, lstrlen(sz), &pdis->rcItem, 
			DT_CENTER|DT_VCENTER|DT_SINGLELINE);
}

//	______________________________________
//
//	Dialog procedure for Help About dialog

static BOOL CALLBACK 
sHelpAboutDlgProc (
		HWND	hwnd, 
		UINT	uMsg, 
		WPARAM	wParam,
		LPARAM	lParam) 
{
	PDIALOGINFOSTRUCT	pdis;

	switch(uMsg) {

	case WM_INITDIALOG:
	{
		HWND hWndControl;
		RECT rc;
		int uX,uY;

		SetWindowLong (hwnd, GWL_USERDATA, lParam);
		pdis = (PDIALOGINFOSTRUCT)lParam;

		SetWindowPos (hwnd, HWND_TOP, pdis->uXpos, pdis->uYpos, 
					pdis->uXsize+ADDWIDTH, pdis->uYsize+ADDHEIGHT, 0);

		hWndControl = GetDlgItem (hwnd, IDC_UPGRADE);
		GetClientRect (hWndControl, &rc);
		uY = (long)(pdis->uYsize * UPGRADEBUTTONYPOS);
		uX = (long)(pdis->uXsize * UPGRADEBUTTONXPOS);
		SetWindowPos (hWndControl, NULL, uX, uY, 
				0, 0, SWP_NOSIZE|SWP_NOZORDER|SWP_NOACTIVATE);

		if((PGPlnIsAuthorized())||(!PGP_LICENSENUMBERS))
		{
			ShowWindow(hWndControl,SW_HIDE);
			EnableWindow(hWndControl,FALSE);
		}

		pdis->iScrollPos = pdis->iMaxPos;
		pdis->iTextIndex = 0;
		SetTimer (hwnd, REFRESH_TIMER, REFRESH_TIME, NULL);
		return TRUE;
	}

	case WM_TIMER :
	{
		RECT rc;

#if DISPLAY_CREDITS
		pdis = (PDIALOGINFOSTRUCT)GetWindowLong (hwnd, GWL_USERDATA);
		pdis->iScrollPos--;
		if (pdis->iScrollPos < pdis->iMinPos)
		{
			pdis->iScrollPos += pdis->iRowHeight;
			pdis->iTextIndex++;
			if (pdis->iTextIndex >= NUM_TEXT_ROWS)
			{
				pdis->iTextIndex = 0;
			}
		}
#endif // DISPLAY_CREDITS
		GetClientRect(hwnd,&rc);

		rc.bottom=(long)(rc.bottom*UPGRADEBUTTONYPOS);
		InvalidateRect (hwnd, &rc, FALSE);
		break;
	}

	case WM_PAINT:
	{
		HDC			hdc;
		HDC			hdcMem;
		PAINTSTRUCT	ps;
		HBITMAP		hbmpOld;

		pdis = (PDIALOGINFOSTRUCT)GetWindowLong (hwnd, GWL_USERDATA);

		hdc = BeginPaint (hwnd, &ps);
		hdcMem = CreateCompatibleDC (hdc);
		hbmpOld = SelectObject (hdcMem, pdis->hBitmapMain);

		if (pdis->bFirstTime) 
		{
			pdis->bFirstTime = FALSE;

			if (pdis->hPaletteMain)
			{
				SelectPalette (hdc, pdis->hPaletteMain, FALSE);
				RealizePalette (hdc);
			}

			sPaintVersionInfo (pdis, hwnd, hdcMem, pdis->pszText);
			sPaintLicenseInfo (pdis, hwnd, hdcMem);

			BitBlt (hdcMem, 0, pdis->uYsize+1, pdis->uXsize, 
					pdis->uYsize, hdcMem, 0, 0, SRCCOPY);
		}
#if DISPLAY_CREDITS
		else
		{
			BitBlt (hdcMem, 0, 0, pdis->uXsize, 
					pdis->uYsize, hdcMem, 0, pdis->uYsize+1, SRCCOPY);
		}

		sPaintScrollingText (pdis, hwnd, hdcMem);
#endif // DISPLAY_CREDITS

		BitBlt (hdc, ps.rcPaint.left, ps.rcPaint.top,
			ps.rcPaint.right-ps.rcPaint.left,
			ps.rcPaint.bottom-ps.rcPaint.top,
			hdcMem, 
			ps.rcPaint.left,ps.rcPaint.top,
			SRCCOPY);

		SelectObject (hdcMem, hbmpOld);
		DeleteDC (hdcMem);

		EndPaint (hwnd, &ps);
		return FALSE;
	}

	case WM_DRAWITEM :
		pdis = (PDIALOGINFOSTRUCT)GetWindowLong (hwnd, GWL_USERDATA);
		sDrawUpgradeButton ((LPDRAWITEMSTRUCT)lParam, pdis);
		return TRUE;

	case WM_LBUTTONDOWN :
		PostMessage (hwnd, WM_COMMAND, IDOK, 0);
		break;

	case WM_ACTIVATE :
		if (wParam == WA_INACTIVE)
			PostMessage (hwnd, WM_COMMAND, IDOK, 0);
		break;

	case WM_COMMAND:
		pdis = (PDIALOGINFOSTRUCT)GetWindowLong (hwnd, GWL_USERDATA);

		switch (LOWORD (wParam)) {

		case IDOK: 
		case IDCANCEL:
			EndDialog (hwnd, 0);
			break;
		case IDC_UPGRADE:
		{
			char szWebLink[100];

			Sleep (150);
			LoadString (g_hInst, IDS_PGPSTORE, szWebLink, sizeof (szWebLink));
			PGPclWebBrowse (szWebLink);
			break;
		}
		}
		return TRUE;
	}
	return FALSE;
}


//	_______________________________________________
//
//	Post Help About dialog

PGPError PGPclExport 
PGPclHelpAbout (
		PGPContextRef	context,
		HWND			hwnd, 
		LPSTR			pszVersion,
		LPSTR			pszLinkText, 
		LPSTR			pszLink) 
{
	DIALOGINFOSTRUCT	dis;
	BITMAP				bm;
	HBITMAP				hbmpTemp, hbmpOld1, hbmpOld2;
	HDC					hdc, hdcMem1, hdcMem2;
	INT					iAboutBitmap;
	INT					iNumBits;
	RECT				rcMonitor;
	LOGFONT				lf;

#if DISPLAY_CREDITS
	TEXTMETRIC			tm;
#endif // DISPLAY_CREDITS

	PGPlnLicenseCheck (context);

	memset(&dis,0x00,sizeof(DIALOGINFOSTRUCT));

	dis.hWndParent = hwnd;
	dis.pszText = pszVersion;

	hdc = GetDC (NULL);		// DC for desktop
	iNumBits = GetDeviceCaps (hdc, BITSPIXEL) * GetDeviceCaps (hdc, PLANES);

	if (iNumBits <= 1) 
	{
		iAboutBitmap = IDB_ABOUT1;
		dis.crTextColor = RGB (0,0,0);
		dis.crTextScrollColor = RGB (0,0,0);
		dis.bRoundedButton = FALSE;
	}
	else if (iNumBits <= 8)
	{
		iAboutBitmap = IDB_ABOUT4;
		dis.crTextColor = RGB (0,0,0);
		dis.crTextScrollColor = RGB (0,0,0);
		dis.bRoundedButton = FALSE;
	}
	else
	{
		iAboutBitmap = IDB_ABOUT8;
		dis.crTextColor = RGB (70,70,70);
		dis.crTextScrollColor = RGB (70,70,70);
		dis.bRoundedButton = TRUE;
	}

	// load the background bitmap
	hbmpTemp = CLLoadResourceBitmap (g_hInst, 
			MAKEINTRESOURCE (iAboutBitmap), &dis.hPaletteMain);
	GetObject (hbmpTemp, sizeof(BITMAP), (LPSTR)&bm);

	dis.uXsize = bm.bmWidth;
	dis.uYsize = bm.bmHeight;

	// create temporary DCs
	hdcMem1 = CreateCompatibleDC (hdc);
	hdcMem2 = CreateCompatibleDC (hdc);

	// create fonts and do text metric calculations
	ZeroMemory (&lf, sizeof(lf));
	lf.lfWeight = FW_NORMAL;
	lf.lfHeight = -11;
	lstrcpy (lf.lfFaceName, "Arial");

	dis.hfont = CreateFontIndirect (&lf);
	lf.lfItalic = !lf.lfItalic;
	dis.hfontItalic = CreateFontIndirect (&lf);
	lf.lfItalic = !lf.lfItalic;
	lf.lfWeight = FW_BOLD;
	dis.hfontBold = CreateFontIndirect (&lf);

#if DISPLAY_CREDITS
	SelectObject (hdcMem1, dis.hfont);
	GetTextMetrics (hdcMem1, &tm);
	dis.iRowHeight = tm.tmHeight + 2;

	dis.iMinPos = (INT)(MINSCROLLYPOS * dis.uYsize);
	dis.iMaxPos = (INT)(MAXSCROLLYPOS * dis.uYsize);
	dis.iTextXPos = (INT)(SCROLLXPOS * dis.uXsize);
#endif // DISPLAY_CREDITS

	// manipulate the bitmap
	dis.hBitmapMain = CreateCompatibleBitmap (hdc, dis.uXsize, 2*dis.uYsize);

	hbmpOld1 = SelectObject (hdcMem1, dis.hBitmapMain);
	hbmpOld2 = SelectObject (hdcMem2, hbmpTemp);

	BitBlt (hdcMem1, 0, 0, dis.uXsize, 
			dis.uYsize, hdcMem2, 0, 0, SRCCOPY);

	// set the "active" module text
	SelectObject (hdcMem2, hbmpOld2);
	DeleteObject (hbmpTemp);

	ReleaseDC (NULL, hdc);
	DeleteDC (hdcMem1);
	DeleteDC (hdcMem2);

	dis.bFirstTime = TRUE;

	PGPclGetMonitorRect (hwnd, kPGPclWindowMonitor, &rcMonitor);
	dis.uXpos = (rcMonitor.left + 
			((rcMonitor.right - rcMonitor.left)
				- dis.uXsize - EDGEWIDTH) / 2);
	dis.uYpos = (rcMonitor.top + 
			((rcMonitor.bottom - rcMonitor.top)
				- dis.uYsize) / 2);

	DialogBoxParam (g_hInst, MAKEINTRESOURCE (IDD_HELPABOUT), 
			hwnd, sHelpAboutDlgProc, (LPARAM)&dis);

	DeleteObject (dis.hBitmapMain);
	DeleteObject (dis.hPaletteMain);
	DeleteObject (dis.hfont);
	DeleteObject (dis.hfontItalic);
	DeleteObject (dis.hfontBold);

	return kPGPError_NoErr;
}


//	___________________________________________________
//
//	Paint version info text

VOID
sPaintText (
		PDIALOGINFOSTRUCT	pdis,
		HWND				hwnd,
		HDC					hdc)
{
	HFONT		hFontOld;
	UINT		uTAOld;
	CHAR		szText[512];
	CHAR		szFmt[256];
	RECT		rc;

	GetClientRect (hwnd, &rc);
	rc.left = (INT)(CONGRATSXPOS * rc.right);

	SetTextColor (hdc, pdis->crTextColor);
	SetBkMode (hdc, TRANSPARENT);
	uTAOld = SetTextAlign (hdc, TA_LEFT);
	hFontOld = SelectObject (hdc, GetStockObject (DEFAULT_GUI_FONT));

	LoadString (g_hInst, IDS_CONGRATULATIONS, szFmt, sizeof(szFmt));
	wsprintf (szText, szFmt, pdis->pszText);

	switch (pdis->iTextIndex) {
	case kPGPclManualRetrieval :
		rc.top = (INT)(CONGRATSYPOSMAN * rc.bottom);
		break;

	case kPGPclAutoRetrievalUsingCert :
		rc.top = (INT)(CONGRATSYPOSAUTO * rc.bottom);
		LoadString (g_hInst, IDS_WILLUSECERTASAUTH, szFmt, sizeof(szFmt));
		lstrcat (szText, szFmt);
		break;

	case kPGPclAutoRetrievalQueryUse :
		rc.top = (INT)(CONGRATSYPOSAUTO * rc.bottom);
		LoadString (g_hInst, IDS_QUERYUSECERTASAUTH, szFmt, sizeof(szFmt));
		lstrcat (szText, szFmt);
		break;
	}

	DrawText (hdc, szText, lstrlen (szText), &rc, DT_LEFT);

	SelectObject (hdc, hFontOld);
}


//	______________________________________
//
//	Dialog procedure for congratulations dialog

static BOOL CALLBACK 
sCongratsDlgProc (
		HWND	hwnd, 
		UINT	uMsg, 
		WPARAM	wParam,
		LPARAM	lParam) 
{
	PDIALOGINFOSTRUCT	pdis;

	switch(uMsg) {

	case WM_INITDIALOG:
	{
		RECT	rcWin;
		RECT	rcButton;

		SetWindowLong (hwnd, GWL_USERDATA, lParam);
		pdis = (PDIALOGINFOSTRUCT)lParam;

		SetWindowPos (hwnd, HWND_TOP, pdis->uXpos, pdis->uYpos, 
					pdis->uXsize+ADDWIDTH, pdis->uYsize+ADDHEIGHT, 0);

		GetClientRect (hwnd, &rcWin);
		if (pdis->iTextIndex == kPGPclAutoRetrievalQueryUse)
		{
			EnableWindow (GetDlgItem (hwnd, IDOK), FALSE);
			ShowWindow (GetDlgItem (hwnd, IDOK), SW_HIDE);

			GetClientRect (GetDlgItem (hwnd, IDCANCEL), &rcButton);
			rcButton.top = rcWin.bottom - rcButton.bottom - BUTTON_Y_OFFSET;
			rcButton.left = rcWin.right - rcButton.right - BUTTON_X_OFFSET;
			SetWindowPos (GetDlgItem (hwnd, IDCANCEL), NULL, 
					rcButton.left, rcButton.top, 0, 0, SWP_NOSIZE);

			GetClientRect (GetDlgItem (hwnd, IDYES), &rcButton);
			rcButton.top = rcWin.bottom - rcButton.bottom - BUTTON_Y_OFFSET;
			rcButton.left = rcWin.right - 2*(rcButton.right + BUTTON_X_OFFSET);
			SetWindowPos (GetDlgItem (hwnd, IDYES), NULL, 
					rcButton.left, rcButton.top, 0, 0, SWP_NOSIZE);
		}
		else
		{
			EnableWindow (GetDlgItem (hwnd, IDCANCEL), FALSE);
			ShowWindow (GetDlgItem (hwnd, IDCANCEL), SW_HIDE);
			EnableWindow (GetDlgItem (hwnd, IDYES), FALSE);
			ShowWindow (GetDlgItem (hwnd, IDYES), SW_HIDE);

			GetClientRect (GetDlgItem (hwnd, IDOK), &rcButton);
			rcButton.top = rcWin.bottom - rcButton.bottom - BUTTON_Y_OFFSET;
			rcButton.left = rcWin.right - rcButton.right - BUTTON_X_OFFSET;
			SetWindowPos (GetDlgItem (hwnd, IDOK), NULL, 
					rcButton.left, rcButton.top, 0, 0, SWP_NOSIZE);
		}

		return TRUE;
	}

	case WM_PAINT:
	{
		HDC			hdc;
		HDC			hdcMem;
		PAINTSTRUCT	ps;
		HBITMAP		hbmpOld;

		pdis = (PDIALOGINFOSTRUCT)GetWindowLong (hwnd, GWL_USERDATA);

		hdc = BeginPaint (hwnd, &ps);
		hdcMem = CreateCompatibleDC (hdc);
		hbmpOld = SelectObject (hdcMem, pdis->hBitmapMain);

		if (pdis->bFirstTime) 
		{
			pdis->bFirstTime = FALSE;

			if (pdis->hPaletteMain)
			{
				SelectPalette (hdc, pdis->hPaletteMain, FALSE);
				RealizePalette (hdc);
			}

			sPaintText (pdis, hwnd, hdcMem);
			BitBlt (hdcMem, 0, pdis->uYsize+1, pdis->uXsize, 
					pdis->uYsize, hdcMem, 0, 0, SRCCOPY);
		}

		BitBlt (hdc, 0, 0, pdis->uXsize, 
				pdis->uYsize, hdcMem, 0, 0, SRCCOPY);

		SelectObject (hdcMem, hbmpOld);
		DeleteDC (hdcMem);

		EndPaint (hwnd, &ps);
		return FALSE;
	}

	case WM_COMMAND:
		pdis = (PDIALOGINFOSTRUCT)GetWindowLong (hwnd, GWL_USERDATA);

		switch (LOWORD (wParam)) {

		case IDOK: 
		case IDYES: 
			EndDialog (hwnd, 1);
			break;

		case IDCANCEL:
			EndDialog (hwnd, 0);
			break;
		}
		return TRUE;
	}
	return FALSE;
}


//	_______________________________________________
//
//	Post certificate retrieved congrats dialog 

PGPError PGPclExport 
PGPclCertCongrats (
		HWND			hwnd,
		PGPUInt32		uCongratsType,				
		char*			pszUTF8UserID) 
{
	DIALOGINFOSTRUCT	dis;
	BITMAP				bm;
	HBITMAP				hbmpTemp, hbmpOld1, hbmpOld2;
	HDC					hdc, hdcMem1, hdcMem2;
	INT					iAboutBitmap;
	INT					iNumBits;
	RECT				rcMonitor;
	TEXTMETRIC			tm;
	LOGFONT				lf;
	PGPError			err;

	dis.hWndParent = hwnd;
	dis.pszText = pszUTF8UserID;
	dis.iTextIndex = (INT)uCongratsType;

	hdc = GetDC (NULL);		// DC for desktop
	iNumBits = GetDeviceCaps (hdc, BITSPIXEL) * GetDeviceCaps (hdc, PLANES);

	if (iNumBits <= 1) 
	{
		iAboutBitmap = IDB_CERTIFICATE1;
		dis.crTextColor = RGB (0,0,0);
	}
	else if (iNumBits <= 4) 
	{
		iAboutBitmap = IDB_CERTIFICATE4;
		dis.crTextColor = RGB (0,0,0);
	}
	else 
	{
		iAboutBitmap = IDB_CERTIFICATE8;
		dis.crTextColor = RGB (0,0,0);
	}

	// load the background bitmap
	hbmpTemp = CLLoadResourceBitmap (g_hInst, 
			MAKEINTRESOURCE (iAboutBitmap), &dis.hPaletteMain);
	GetObject (hbmpTemp, sizeof(BITMAP), (LPSTR)&bm);

	dis.uXsize = bm.bmWidth;
	dis.uYsize = bm.bmHeight;

	// create temporary DCs
	hdcMem1 = CreateCompatibleDC (hdc);
	hdcMem2 = CreateCompatibleDC (hdc);

	dis.hfont = CreateFontIndirect (&lf);

	SelectObject (hdcMem1, dis.hfont);
	GetTextMetrics (hdcMem1, &tm);

	dis.iMinPos = (INT)(MINSCROLLYPOS * dis.uYsize);
	dis.iMaxPos = (INT)(MAXSCROLLYPOS * dis.uYsize);
	dis.iTextXPos = (INT)(SCROLLXPOS * dis.uXsize);

	// manipulate the bitmap
	dis.hBitmapMain = CreateCompatibleBitmap (hdc, dis.uXsize, 2*dis.uYsize);

	hbmpOld1 = SelectObject (hdcMem1, dis.hBitmapMain);
	hbmpOld2 = SelectObject (hdcMem2, hbmpTemp);

	BitBlt (hdcMem1, 0, 0, dis.uXsize, 
			dis.uYsize, hdcMem2, 0, 0, SRCCOPY);

	// cleanup the DCs
	SelectObject (hdcMem1, hbmpOld1);
	SelectObject (hdcMem2, hbmpOld2);

	DeleteObject (hbmpTemp);
	ReleaseDC (NULL, hdc);
	DeleteDC (hdcMem1);
	DeleteDC (hdcMem2);

	dis.bFirstTime = TRUE;

	PGPclGetMonitorRect (hwnd, kPGPclWindowMonitor, &rcMonitor);
	dis.uXpos = (rcMonitor.left + 
			((rcMonitor.right - rcMonitor.left)
				- dis.uXsize - EDGEWIDTH) / 2);
	dis.uYpos = (rcMonitor.top + 
			((rcMonitor.bottom - rcMonitor.top)
				- dis.uYsize) / 2);

	if (DialogBoxParam (g_hInst, MAKEINTRESOURCE (IDD_CONGRATS), 
			hwnd, sCongratsDlgProc, (LPARAM)&dis))
	{
		err = kPGPError_NoErr;
	}
	else
		err = kPGPError_Win32_NegativeResponse;

	DeleteObject (dis.hBitmapMain);
	DeleteObject (dis.hPaletteMain);

	return err;
}

