/*____________________________________________________________________________
	Copyright (C) 2002 PGP Corporation
	All rights reserved.

	CLlicense.c - code to handle displaying and entering lns

	$Id: CLlicense.c,v 1.47.2.1 2002/11/28 00:03:51 jeffc Exp $
____________________________________________________________________________*/
#include "pgpPFLConfig.h"

// project header files
#include "pgpclx.h"
#include "transbmp.h"
#include "pgpsockets.h"
#include "stdio.h"
#include "pgpBuild.h"
#include "UTF8Edit.h"
#include "pgpUnicodeWin32.h"

#include <process.h>


extern HINSTANCE g_hInst;

#include "..\..\..\libs2\shared\pgplicensenumber.h"
#include "resource.h"

typedef struct _ECL
{
	HWND hwndLNEdit[6];
	HWND hwndLicense;
	HWND hwndAuthorize;
	WNDPROC origEditProc;
	PGPContextRef context;
	BOOL bManual;
	HBITMAP hLNKey;
	HPALETTE hPalette;
} ECL;

typedef struct _PNL
{
	char *szNotifyText;
	char *szLicenseReq;
} PNL;

typedef struct _PROGRESSSTRUCT
{
	HWND	hwndParent;
	BOOL	bDestroy;
	INT		iStatusValue;
	INT		iStatusDirection;

} PROGRESSSTRUCT;

#define VERTICAL_SHIFT		8
#define PROGRESSTIMERID		222
#define LEDTIMERPERIOD		150L
#define NUMLEDS				12
#define LEDSPACING			4
#define LEDWIDTH			9
#define HORSIZEDIF			2
#define VERTSIZEDIF			2
#define TOTALLEDWIDTH		(NUMLEDS*(LEDWIDTH+LEDSPACING+1))

// local globals
static DWORD aNoLicenseIds[] = {			// Help IDs
    IDC_UPGRADE,		IDH_PGPCLLIC_NOLICENSEUPGRADE, 
    0,0 
}; 

static DWORD aLicenseDisplayIds[] = {		// Help IDs
	IDC_LENAME,				IDH_PGPCLLIC_DISPLAYUSERNAME,
	IDC_LEORG,				IDH_PGPCLLIC_DISPLAYCOMPANYNAME,
	IDC_LESEAT,				IDH_PGPCLLIC_DISPLAYSEATS,
	IDC_LEDATE,				IDH_PGPCLLIC_DISPLAYEXPIRATION,
	IDC_CHANGE,				IDH_PGPCLLIC_DISPLAYCHANGE,
    IDC_PURCHASE,			IDH_PGPCLLIC_DISPLAYPURCHASE,
	IDC_ENTERPRISESTATUS,	IDH_PGPCLLIC_DISPLAYENTERPRISE,
	IDC_DESKTOPSTATUS,		IDH_PGPCLLIC_DISPLAYDESKTOP,
	IDC_PGPDISKSTATUS,		IDH_PGPCLLIC_DISPLAYPGPDISK,
	IDC_PGPMAILSTATUS,		IDH_PGPCLLIC_DISPLAYPGPMAIL,
    0,0 
}; 

static DWORD aEnterLicenseIds[] = {			// Help IDs
	IDC_LNUSER,			IDH_PGPCLLIC_ENTERUSERNAME,
	IDC_LNCOMPANY,		IDH_PGPCLLIC_ENTERCOMPANYNAME,
	IDC_LNEDIT1,		IDH_PGPCLLIC_ENTERLN,
	IDC_LNEDIT2,		IDH_PGPCLLIC_ENTERLN,
	IDC_LNEDIT3,		IDH_PGPCLLIC_ENTERLN,
	IDC_LNEDIT4,		IDH_PGPCLLIC_ENTERLN,
	IDC_LNEDIT5,		IDH_PGPCLLIC_ENTERLN,
	IDC_LNEDIT6,		IDH_PGPCLLIC_ENTERLN,
	IDC_MANUALEDIT,		IDH_PGPCLLIC_ENTERMANUALLA,
	IDCANCEL,			IDH_PGPCLLIC_ENTERLATER,
	IDOK,				IDH_PGPCLLIC_ENTERAUTHORIZE,
	IDC_MANUAL,			IDH_PGPCLLIC_ENTERMANUAL,
    IDC_PURCHASE,		IDH_PGPCLLIC_ENTERPURCHASE, 
    0,0 
}; 

///#if PGP_BETA
#if FALSE
#define NUM_AUTHORIZE_URLS	1
static char* s_pszAuthorizeURLs[] = {
		"http://authorize.foo.com/authorize1"};
#else
#define NUM_AUTHORIZE_URLS	3
static char* s_pszAuthorizeURLs[] = {
		"http://authorize1.pgp.com/authorize1",	
		"http://authorize2.pgp.com/authorize1",
		"http://authorize3.pgp.com/authorize1"};
#endif

#define NUMBASE32SYMBOLS 65

static int base32[NUMBASE32SYMBOLS][2]={
	{'A','A'},{'C','C'},{'D','D'},{'E','E'},{'F','F'},{'G','G'},{'H','H'},
	{'J','J'},{'K','K'},{'L','L'},{'M','M'},{'N','N'},{'P','P'},{'Q','Q'},{'R','R'},
	{'T','T'},{'U','U'},{'V','V'},{'W','W'},{'X','X'},{'Y','Y'},{'Z','Z'},{'2','2'},
	{'3','3'},{'4','4'},{'6','6'},{'7','7'},{'9','9'},{'B','B'},{'0','0'},{'1','1'},
	{'5','5'},{'8','8'},{'O','O'},{'I','I'},{'S','S'},
	{'a','A'},{'c','C'},{'d','D'},{'e','E'},{'f','F'},{'g','G'},{'h','H'},
	{'j','J'},{'k','K'},{'l','L'},{'m','M'},{'n','N'},{'p','P'},{'q','Q'},{'r','R'},
	{'t','T'},{'u','U'},{'v','V'},{'w','W'},{'x','X'},{'y','Y'},{'z','Z'},
	{'b','B'},
	{'o','O'},{'i','I'},{'s','S'}};

static void*
sRetrieveClipboardData(HWND hwnd, UINT* pClipboardFormat, 
							DWORD* pDataSize)
{
	void* ReturnValue = 0;
	DWORD dwBufferSize = 0;
	void* pLocalDataBuffer = NULL;
	void* pClipboardBuffer = NULL;
	HANDLE hClipboardData = NULL;

	// See if we can gain access to the clipboard
	if(OpenClipboard(hwnd)) 
	{
		*pClipboardFormat = CF_TEXT;

		hClipboardData = GetClipboardData(*pClipboardFormat);

		if(hClipboardData && IsClipboardFormatAvailable(CF_TEXT))
		{
			pClipboardBuffer = GlobalLock(hClipboardData);
			if(pClipboardBuffer)
			{
				dwBufferSize = lstrlen (pClipboardBuffer) +1;
				pLocalDataBuffer = malloc(dwBufferSize);
				memset(pLocalDataBuffer, '\0', 
					dwBufferSize * sizeof(BYTE));

				if(pLocalDataBuffer)
				{
					*pDataSize = dwBufferSize -1;
					memcpy(pLocalDataBuffer, pClipboardBuffer, dwBufferSize);

					ReturnValue = pLocalDataBuffer;
				}

				GlobalUnlock(hClipboardData);
			}
		}
		CloseClipboard();
	}
	return ReturnValue;
}

static int 
sLicenseChar(int in)
{
	int i,out;

	i=0;

	do
	{
		if(in==base32[i][0])
		{
			out=base32[i][1];
			break;
		}

		i++;
	} while(i<NUMBASE32SYMBOLS);

	if(i==NUMBASE32SYMBOLS)
		return (-1);

	return out;
}

static PGPBoolean 
sCheckLicenseLength(HWND hwnd,ECL *ecl)
{
	PGPBoolean bAuthorize;
	int i;

	bAuthorize=TRUE;

	for(i=0;i<5;i++)
	{
		if(GetWindowTextLength (ecl->hwndLNEdit[i]) != 5)
			bAuthorize=FALSE;
	}

	if(GetWindowTextLength (ecl->hwndLNEdit[5]) != 3)
		bAuthorize=FALSE;

	return bAuthorize;
}

static LRESULT WINAPI 
sLNMaskedEditWndProc(HWND hwnd, UINT msg, 
                     WPARAM wParam, LPARAM lParam)
{
	ECL *ecl;

	ecl=(ECL *)GetWindowLong (GetParent(hwnd), GWL_USERDATA);

    switch(msg)
    {
		case WM_PASTE:
		{
			char *szClip;
			DWORD dwSize,ClipFormat;
			int ClipIndex,PasteIndex;
			char szPaste[29];
			char c;

//			if(hwnd==ecl->hwndLNEdit[0]) //better this way?
			{
				szClip=sRetrieveClipboardData(hwnd,&ClipFormat,&dwSize);

				if(szClip)
				{
					PasteIndex=0;
					memset(szPaste,0x00,29);

					// Filter out bad characters
					for(ClipIndex=0;
							((ClipIndex<(int)dwSize)&&(PasteIndex<28));
							ClipIndex++)
					{
						c=sLicenseChar(szClip[ClipIndex]);
			
						if(c!=(-1))
						{
							szPaste[PasteIndex]=c;
							PasteIndex++;
						}
					}

					// OK now paste em in
					SetWindowText(ecl->hwndLNEdit[5],&(szPaste[25]));
					szPaste[25]=0;
					SetWindowText(ecl->hwndLNEdit[4],&(szPaste[20]));
					szPaste[20]=0;
					SetWindowText(ecl->hwndLNEdit[3],&(szPaste[15]));
					szPaste[15]=0;
					SetWindowText(ecl->hwndLNEdit[2],&(szPaste[10]));
					szPaste[10]=0;
					SetWindowText(ecl->hwndLNEdit[1],&(szPaste[5]));
					szPaste[5]=0;
					SetWindowText(ecl->hwndLNEdit[0],&(szPaste[0]));
					szPaste[0]=0;

					free(szClip);

					EnableWindow(ecl->hwndAuthorize,
							sCheckLicenseLength(hwnd,ecl));
				}

				return 0;
			}
			break;
		}

		case WM_CHAR:
		{
			int index,i;

			if(isprint(wParam))
			{
				wParam=sLicenseChar(wParam);
		
				if(wParam==(-1))
					return 0;
			}

			CallWindowProc (ecl->origEditProc, hwnd, msg, wParam, lParam); 

			EnableWindow(ecl->hwndAuthorize,sCheckLicenseLength(hwnd,ecl));

			for(i=0;i<6;i++)
			{
				if(hwnd==ecl->hwndLNEdit[i])
					index=i;
			}

			if((GetWindowTextLength (hwnd) == 5)&&(index!=5))
				SetFocus(ecl->hwndLNEdit[index+1]);

			return 0;
		}
	}

    //  Pass all non-custom messages to old window proc
    return CallWindowProc(ecl->origEditProc, hwnd, 
                           msg, wParam, lParam ) ;
}

static BOOL 
sResizeLicenseDialog(HWND hdlg,ECL *ecl)
{
	int show;
	BOOL enable;
	int buttbase;
	int purchasebase;
	int windowsize;
	RECT rc,rcclient;
	CHAR sz[16];

	if(!(ecl->bManual))
	{
		LoadString (g_hInst, IDS_LICENSEMANUAL, sz, sizeof(sz));
		SetWindowText(GetDlgItem(hdlg,IDC_MANUAL),sz);
		show=SW_HIDE;
		enable=FALSE;
		GetWindowRect(GetDlgItem(hdlg,IDC_MANUALSTATIC),&rc);
		ScreenToClient(hdlg, (LPPOINT)&rc);
		buttbase=purchasebase=rc.top;
		GetClientRect(GetDlgItem(hdlg,IDC_PURCHASESTATIC),&rc);
		buttbase=buttbase+(rc.bottom-rc.top);
		buttbase=buttbase+10;
		GetClientRect(GetDlgItem(hdlg,IDOK),&rc);
		windowsize=buttbase+(rc.bottom-rc.top)+10;
	}
	else
	{
		LoadString (g_hInst, IDS_LICENSEAUTO, sz, sizeof(sz));
		SetWindowText(GetDlgItem(hdlg,IDC_MANUAL),sz);
		show=SW_SHOW;
		enable=TRUE;
		GetWindowRect(GetDlgItem(hdlg,IDC_MANUALEDIT),&rc);
		ScreenToClient(hdlg, (LPPOINT)&(rc.right));
		buttbase=purchasebase=rc.bottom+10;
		GetClientRect(GetDlgItem(hdlg,IDC_PURCHASESTATIC),&rc);
		buttbase=buttbase+(rc.bottom-rc.top);
		buttbase=buttbase+10;
		GetClientRect(GetDlgItem(hdlg,IDOK),&rc);
		windowsize=buttbase+(rc.bottom-rc.top)+10;
	}

	EnableWindow(GetDlgItem(hdlg,IDC_MANUALSTATIC),enable);
	EnableWindow(GetDlgItem(hdlg,IDC_MANUALEDIT),enable);
	ShowWindow(GetDlgItem(hdlg,IDC_MANUALSTATIC),show);
	ShowWindow(GetDlgItem(hdlg,IDC_MANUALEDIT),show);

	GetWindowRect(GetDlgItem(hdlg,IDC_MANUAL),&rc);
	ScreenToClient(hdlg, (LPPOINT)&rc);
	ScreenToClient(hdlg, (LPPOINT)&(rc.right));
	MoveWindow(GetDlgItem(hdlg,IDC_MANUAL),
		rc.left,buttbase,rc.right-rc.left,rc.bottom-rc.top,TRUE);
	GetWindowRect(GetDlgItem(hdlg,IDOK),&rc);
	ScreenToClient(hdlg, (LPPOINT)&rc);
	ScreenToClient(hdlg, (LPPOINT)&(rc.right));
	MoveWindow(GetDlgItem(hdlg,IDOK),
		rc.left,buttbase,rc.right-rc.left,rc.bottom-rc.top,TRUE);
	GetWindowRect(GetDlgItem(hdlg,IDCANCEL),&rc);
	ScreenToClient(hdlg, (LPPOINT)&rc);
	ScreenToClient(hdlg, (LPPOINT)&(rc.right));
	MoveWindow(GetDlgItem(hdlg,IDCANCEL),
		rc.left,buttbase,rc.right-rc.left,rc.bottom-rc.top,TRUE);
	GetWindowRect(GetDlgItem(hdlg,IDC_PURCHASE),&rc);
	ScreenToClient(hdlg, (LPPOINT)&rc);
	ScreenToClient(hdlg, (LPPOINT)&(rc.right));
	MoveWindow(GetDlgItem(hdlg,IDC_PURCHASE),
		rc.left,buttbase,rc.right-rc.left,rc.bottom-rc.top,TRUE);
	GetWindowRect(GetDlgItem(hdlg,IDC_PURCHASESTATIC),&rc);
	ScreenToClient(hdlg, (LPPOINT)&rc);
	ScreenToClient(hdlg, (LPPOINT)&(rc.right));
	MoveWindow(GetDlgItem(hdlg,IDC_PURCHASESTATIC),
		rc.left,purchasebase,rc.right-rc.left,rc.bottom-rc.top,TRUE);

	GetWindowRect(hdlg,&rc);
	ScreenToClient(hdlg,(LPPOINT)&rc);
	GetClientRect(hdlg,&rcclient);

	// include titlebar
	windowsize=windowsize+(rcclient.top-rc.top);

	GetWindowRect(hdlg,&rc);
	SetWindowPos(hdlg,0,0,0,rc.right-rc.left,windowsize,SWP_NOMOVE|SWP_NOZORDER);
	
	return TRUE;
}

static PGPError
sLicenseErrorBox (
		HWND		hwnd,
		UINT		iLocString,
		PGPError	errIn) 
{
	PGPError	err				= kPGPError_NoErr;
	UINT		uIDS			= 0;
	CHAR		szMessage[768];
	CHAR		szCaption[64];
	UINT		uCaptionID;
	UINT		uCaptionType;
	UINT		uFlags;
	UINT		len;

	LoadString(g_hInst,iLocString,szMessage,768);

	strcat(szMessage,"\n\n");
	len=strlen(szMessage);

	switch (iLocString) {
	case IDS_IMPORTLN :
		switch (errIn) {
		case kPGPError_CorruptData :
		case kPGPError_LNCorrupt :
			uIDS = IDS_LICENSEINVALIDLN;
			uCaptionType = kPGPclErrorType_Alert;
			break;
		}
		break;

	case IDS_IMPORTLA :
		uIDS = IDS_LICENSEMALFORMEDLA;
		uCaptionType = kPGPclErrorType_Alert;
		break;

	case IDS_OBTAINLA :
		if ((errIn >= kPGPError_SocketsNetworkDown) &&
			(errIn < kPGPError_X509AttributeNotSupported))
		{
			// these should all be PGP Sockets errors
			uIDS = IDS_LICENSELANETWORKERROR;
			uCaptionType = kPGPclErrorType_Information;
		}
		else
		{
			switch (errIn) {
			case kPGPError_NetworkOpFailed :
			case kPGPError_NetLARefused :
				uIDS = IDS_LICENSELASERVERERROR;
				uCaptionType = kPGPclErrorType_Information;
				break;

			case kPGPError_NetLAMismatch :
				uIDS = IDS_LICENSELAMISMATCH;
				uCaptionType = kPGPclErrorType_Alert;
				break;

			case kPGPError_NetLATooManyRetrievals :
				uIDS = IDS_LICENSETOOMANYTRIES;
				uCaptionType = kPGPclErrorType_Alert;
				break;
			}
		}
		break;

	case IDS_VERIFYLA :
		uIDS = IDS_LICENSEINVALIDLA;
		uCaptionType = kPGPclErrorType_Alert;
		break;
	}

	if (uIDS != 0)
	{
		LoadString (g_hInst, uIDS, &(szMessage[len]), sizeof(szMessage)-len);
		err = errIn;
	}
	else
	{
		err = PGPclErrorToString (errIn, 
				&(szMessage[len]), sizeof(szMessage)-len, &uCaptionType);
	}

	if (IsPGPError (err)) 
	{
		uFlags = MB_OK|MB_SETFOREGROUND|MB_TASKMODAL|MB_TOPMOST;

		switch (uCaptionType) {
		case kPGPclErrorType_Warning :
			uFlags |= MB_ICONEXCLAMATION;
			uCaptionID = IDS_CAPTIONWARNING;
			break;

		case kPGPclErrorType_Alert :
			uFlags |= MB_ICONEXCLAMATION;
			uCaptionID = IDS_CAPTIONALERT;
			break;

		case kPGPclErrorType_Information :
			uFlags |= MB_ICONINFORMATION;
			uCaptionID = IDS_CAPTIONINFO;
			break;

		default :
			uFlags |= MB_ICONSTOP;
			uCaptionID = IDS_CAPTIONERROR;
			break;
		}

		LoadString (g_hInst, uCaptionID, szCaption, sizeof(szCaption));
		MessageBox (hwnd, szMessage, szCaption, uFlags);
	}

	return errIn;
}

//	____________________________________
//
//  Draw the "LED" progress indicator

static VOID
sDrawStatus (
		HWND			hwnd,
		PROGRESSSTRUCT*	pps)
{
	HBRUSH			hBrushLit, hBrushOld;
	HPEN			hPen, hPenOld;
	INT				i, itop, ibot, ileft, iright;
	HDC				hdc;
	RECT			rc;
	PAINTSTRUCT		ps;

	if (pps->iStatusValue < -1) 
		return;
	
	hdc = BeginPaint (hwnd, &ps);

	// draw 3D shadow
	GetClientRect (hwnd, &rc);
	itop = rc.top;
	ibot = rc.bottom;

	hPen = CreatePen (PS_SOLID, 0, RGB (128, 128, 128));
	hPenOld = SelectObject (hdc, hPen);
	hBrushLit = CreateSolidBrush (RGB (0, 255, 0));

	ileft = rc.left + 4;

	// draw "Knight Rider" LEDs
	if (pps->iStatusDirection) 
	{
		hBrushOld = SelectObject (hdc, hBrushLit);
		for (i=0; i<NUMLEDS; i++) 
		{
			iright = ileft + LEDWIDTH;
	
			if (i == pps->iStatusValue) 
				Rectangle (hdc, ileft, itop, iright, ibot);
			else
			{
				//repaint the existing lit LED if any with standard system color
				RECT rectOfLitLed={ileft, itop, iright, ibot};
				FillRect(hdc, &rectOfLitLed, (HBRUSH)(COLOR_3DFACE+1));

				//now draw the unlit LED
				Rectangle (hdc, ileft+HORSIZEDIF, itop+VERTSIZEDIF, 
						iright-HORSIZEDIF, ibot-VERTSIZEDIF);
			}
	
			ileft += LEDWIDTH + LEDSPACING;
		}
	}

	// draw "progress bar" LEDs
	else 
	{ 
		if (pps->iStatusValue >= 0) 
		{
			hBrushOld = SelectObject (hdc, hBrushLit);

			for (i=0; i<NUMLEDS; i++) 
			{
				iright = ileft + LEDWIDTH;
		
				if (i <= pps->iStatusValue) 
					Rectangle (hdc, ileft, itop, iright, ibot);
			
				ileft += LEDWIDTH + LEDSPACING;
			}
		}
	}

	SelectObject (hdc, hBrushOld);
	SelectObject (hdc, hPenOld);
	DeleteObject (hPen);
	DeleteObject (hBrushLit);
}


static VOID
sInvalidateLEDs (
		HWND		hwnd,
		UINT		idc)
{
	RECT	rc;

	GetWindowRect (GetDlgItem (hwnd, idc), &rc);
	MapWindowPoints (NULL, hwnd, (LPPOINT)&rc, 2);
	InvalidateRect (hwnd, &rc, FALSE);
}

static INT_PTR CALLBACK 
sAuthProgressProc (
		HWND	hwnd, 
		UINT	uMsg, 
		WPARAM	wParam, 
		LPARAM	lParam)
{
	switch (uMsg) {
	case WM_INITDIALOG:
	{
		PROGRESSSTRUCT*	pps	= (PROGRESSSTRUCT*)lParam;
		RECT	rc1, rc2;
		INT		ileft, itop;

		SetWindowLong (hwnd, GWL_USERDATA, lParam);
		pps->iStatusDirection = 1;
		pps->iStatusValue = 0;
		SetTimer (hwnd, PROGRESSTIMERID, LEDTIMERPERIOD, 0);

		GetWindowRect (pps->hwndParent, &rc1);
		GetWindowRect (hwnd, &rc2);
		ileft = (rc1.right-rc1.left)/2 + rc1.left;
		ileft -= (rc2.right-rc2.left)/2;
		itop = (rc1.bottom-rc1.top)/2 + rc1.top;
		itop -= (rc2.bottom-rc2.top)/2;
		SetWindowPos (hwnd, NULL, ileft, itop, 0, 0, SWP_NOZORDER|SWP_NOSIZE);

		ShowWindow (hwnd, SW_SHOW);
		return FALSE;
	}

	case WM_PAINT :
	{
		PROGRESSSTRUCT*	pps	= (PROGRESSSTRUCT*)GetWindowLong (hwnd, GWL_USERDATA);
		sDrawStatus (GetDlgItem (hwnd, IDC_PROGRESS), pps);
		break;
	}

	case WM_TIMER:
	{
		PROGRESSSTRUCT*	pps	= (PROGRESSSTRUCT*)GetWindowLong (hwnd, GWL_USERDATA);
		if (pps->bDestroy)
			EndDialog (hwnd, 0);
		else
		{
			pps->iStatusValue += pps->iStatusDirection;
			if (pps->iStatusValue <= 0)
			{
				pps->iStatusValue = 0;
				pps->iStatusDirection = 1;
			}
			else if (pps->iStatusValue >= NUMLEDS-1)
			{
				pps->iStatusValue = NUMLEDS-1;
				pps->iStatusDirection = -1;
			}
			sInvalidateLEDs (hwnd, IDC_PROGRESS);
		}
		break;
	}

	case WM_DESTROY:
		KillTimer (hwnd, PROGRESSTIMERID);
		break;
	}

	return FALSE;
}

static VOID
sProgressThread (
	void	*pArgs)
{
	PROGRESSSTRUCT*	pps	= (PROGRESSSTRUCT*)pArgs;

	DialogBoxParam (g_hInst, 
			MAKEINTRESOURCE(IDD_AUTHORIZATIONPROGRESS), NULL, 
			sAuthProgressProc, (LPARAM)pps);
}

static VOID
sStartProgress (
	HWND			hdlg,
	PROGRESSSTRUCT*	pps)
{
	DWORD	dwThreadID;

	pps->bDestroy = FALSE;
	pps->hwndParent = hdlg;

	_beginthreadex (NULL, 0,
			(LPTHREAD_START_ROUTINE)sProgressThread,
			(void *)pps, 0, &dwThreadID);
}

static VOID
sStopProgress (
	PROGRESSSTRUCT*	pps)
{
	EnableWindow (pps->hwndParent, TRUE);
	pps->bDestroy = TRUE;
}

static VOID
sAuthorize (HWND hdlg)
{
	char szUser[512];
	char szOrganization[512];
	char szLN[100];
	char szLA[512];
	PGPError err;
	PGPPrefRef prefRef;
	PGPLicenseNumberRef pn;
	PGPLicenseAuthorizationRef la;
	ECL *ecl;
	PGPByte *laout;
	PGPByte lnout[kPGPLicenseNumberMaxSize];
	UINT errLoc;

	errLoc=0;

	ecl=(ECL *)GetWindowLong (hdlg, GWL_USERDATA);

	err = PGPclPeekClientLibPrefRefs (&prefRef, NULL);

	if(IsntPGPError(err))
	{
		GetWindowText(GetDlgItem(hdlg,IDC_LNEDIT1),&(szLN[0]),6);
		GetWindowText(GetDlgItem(hdlg,IDC_LNEDIT2),&(szLN[5]),6);
		GetWindowText(GetDlgItem(hdlg,IDC_LNEDIT3),&(szLN[10]),6);
		GetWindowText(GetDlgItem(hdlg,IDC_LNEDIT4),&(szLN[15]),6);
		GetWindowText(GetDlgItem(hdlg,IDC_LNEDIT5),&(szLN[20]),6);
		GetWindowText(GetDlgItem(hdlg,IDC_LNEDIT6),&(szLN[25]),4);

		err=PGPLNImportBase32(ecl->context,szLN,&pn);

		if(IsntPGPError(err))
		{
			PGPUInt8	uProductID;

			PGPLNGetProductID(ecl->context,pn,&uProductID);
			if (uProductID != PGPPRODUCTID)
				err = kPGPError_LNCorrupt;
		}

		if(IsPGPError(err))
		{
			errLoc=IDS_IMPORTLN;
		}
		else
		{
			UTF8EditGetText(GetDlgItem(hdlg,IDC_LNUSER),szUser,512);
			UTF8EditGetText(GetDlgItem(hdlg,IDC_LNCOMPANY),szOrganization,512);

			if(ecl->bManual)
			{
				GetWindowText(GetDlgItem(hdlg,IDC_MANUALEDIT),szLA,512);

				err=PGPLAImportBlocked(ecl->context,szLA,&la);
			}
			else
			{
				PGPSocketsThreadStorageRef storage;

				err = PGPsdkNetworkLibInit( 0 );

				if(IsntPGPError(err))
				{
					err=PGPSocketsInit();

					if(IsntPGPError(err))
					{
						err=PGPSocketsCreateThreadStorage(&storage);

						if(IsntPGPError(err))
						{
							PROGRESSSTRUCT	ps;
							int				i;

							i=0;
							sStartProgress (hdlg, &ps);

							do 
							{
								err = PGPLACreate( ecl->context, s_pszAuthorizeURLs[i++],
									pn, szUser, szOrganization, &la );

								if (err == kPGPError_NetLARefused)
									break;

								if (err == kPGPError_NetLAMismatch)
									break;

								if (err == kPGPError_NetLATooManyRetrievals)
									break;

							} while ((IsPGPError (err)) && 
									(i < NUM_AUTHORIZE_URLS));
					
							sStopProgress (&ps);

							PGPSocketsDisposeThreadStorage(storage);
						}
					PGPSocketsCleanup();
					}
				PGPsdkNetworkLibCleanup();
				}
			}

			if(IsPGPError(err))
			{
				if(ecl->bManual)
					errLoc=IDS_IMPORTLA;
				else
					errLoc=IDS_OBTAINLA;
			}
			else
			{
				err=PGPLAVerify(ecl->context,pn,la,szUser,szOrganization); 

				if(IsPGPError(err))
				{
					errLoc=IDS_VERIFYLA;
				}
				else
				{
					err=PGPLNExportBase32(ecl->context,pn,NULL,lnout);

					if(IsntPGPError(err))
					{
						err=PGPLAExportBase64(ecl->context,la,&laout);

						if(IsntPGPError(err))
						{
							err=PGPSetPrefString(prefRef, kPGPPrefLicenseName, szUser);

							if(IsntPGPError(err))
							{
								err=PGPSetPrefString(prefRef, kPGPPrefLicenseCompany, szOrganization);

								if(IsntPGPError(err))
								{
									err=PGPSetPrefData (prefRef, 
										kPGPPrefLicenseNumber, strlen(lnout)+1, lnout); // w/ NULL

									if(IsntPGPError(err))
									{
										err=PGPSetPrefData (prefRef, 
											kPGPPrefLicenseAuthorization, strlen(laout)+1,laout); // w/ NULL

										if(IsntPGPError(err))
										{
											err = PGPclFlushClientLibPrefs (prefRef, NULL); 
										}
									}
								}
							}

							PGPFreeData(laout);
						}
					}
				}

 				PGPLAFree(la);
			}

			PGPLNFree(pn);
		}

	}

	if (IsPGPError (err))
	{
		if (errLoc != 0)
		{
			sLicenseErrorBox (hdlg, errLoc, err);
		}
		else
		{
			PGPclErrorBox(hdlg, err);
		}
	}
	else
		EndDialog(hdlg, TRUE);
}


static BOOL WINAPI 
sEnterChangeLicenseDlgProc(HWND hdlg, UINT uMsg, 
							  WPARAM wParam, LPARAM lParam)
{
	switch(uMsg)
	{
		case WM_INITDIALOG:
		{
			ECL *ecl;

			ecl=(ECL *)lParam;
			SetWindowLong(hdlg,GWL_USERDATA,(long)lParam);

			UTF8EditInit (GetDlgItem (hdlg, IDC_LNUSER));
			UTF8EditInit (GetDlgItem (hdlg, IDC_LNCOMPANY));

			ecl->hwndLNEdit[0]=GetDlgItem(hdlg,IDC_LNEDIT1);
			ecl->hwndLNEdit[1]=GetDlgItem(hdlg,IDC_LNEDIT2);
			ecl->hwndLNEdit[2]=GetDlgItem(hdlg,IDC_LNEDIT3);
			ecl->hwndLNEdit[3]=GetDlgItem(hdlg,IDC_LNEDIT4);
			ecl->hwndLNEdit[4]=GetDlgItem(hdlg,IDC_LNEDIT5);
			ecl->hwndLNEdit[5]=GetDlgItem(hdlg,IDC_LNEDIT6);
			ecl->hwndAuthorize=GetDlgItem(hdlg,IDOK);

			SendMessage (ecl->hwndLNEdit[0], EM_SETLIMITTEXT, 5, 0);
			SendMessage (ecl->hwndLNEdit[1], EM_SETLIMITTEXT, 5, 0);
			SendMessage (ecl->hwndLNEdit[2], EM_SETLIMITTEXT, 5, 0);
			SendMessage (ecl->hwndLNEdit[3], EM_SETLIMITTEXT, 5, 0);
			SendMessage (ecl->hwndLNEdit[4], EM_SETLIMITTEXT, 5, 0);
			SendMessage (ecl->hwndLNEdit[5], EM_SETLIMITTEXT, 3, 0);

			ecl->origEditProc=(WNDPROC)SetWindowLong(ecl->hwndLNEdit[0], 
					GWL_WNDPROC, (LONG) sLNMaskedEditWndProc); 
			SetWindowLong(ecl->hwndLNEdit[1], 
					GWL_WNDPROC, (LONG) sLNMaskedEditWndProc); 
			SetWindowLong(ecl->hwndLNEdit[2], 
					GWL_WNDPROC, (LONG) sLNMaskedEditWndProc); 
			SetWindowLong(ecl->hwndLNEdit[3], 
					GWL_WNDPROC, (LONG) sLNMaskedEditWndProc); 
			SetWindowLong(ecl->hwndLNEdit[4], 
					GWL_WNDPROC, (LONG) sLNMaskedEditWndProc); 
			SetWindowLong(ecl->hwndLNEdit[5], 
					GWL_WNDPROC, (LONG) sLNMaskedEditWndProc); 

			sResizeLicenseDialog(hdlg,ecl);	
			return TRUE;
		}
	
		case WM_DESTROY:
		{
			int i;
			ECL *ecl;

			ecl=(ECL *)GetWindowLong (hdlg, GWL_USERDATA);

			for(i=0;i<6;i++)
			{
				SetWindowLong(ecl->hwndLNEdit[i], 
					GWL_WNDPROC, (LONG) ecl->origEditProc); 
			}

			UTF8EditDestroy (GetDlgItem (hdlg, IDC_LNUSER));
			UTF8EditDestroy (GetDlgItem (hdlg, IDC_LNCOMPANY));
			break;
		}

		case WM_HELP:
		case WM_CONTEXTMENU:
		{
			return PGPclHtmlHelp (hdlg, uMsg, wParam, lParam, 
					(char*)kPGPclHelpFile, aEnterLicenseIds);
		}

		case WM_QUIT:
		case WM_CLOSE:
		{
			EndDialog (hdlg, FALSE);
			break;
		} 
/*
		case WM_PAINT:
		{
			HDC	hDC;
			PAINTSTRUCT ps;
			ECL *ecl;
					
			ecl=(ECL *)GetWindowLong (hdlg, GWL_USERDATA);

			hDC = BeginPaint (hdlg, &ps);
			SelectPalette (hDC, ecl->hPalette, FALSE);
			RealizePalette (hDC);

			TransparentBitmap(ecl->hLNKey,72,88,RGB(255,0,0),hDC,15,10);
			
			EndPaint (hdlg, &ps);
			break;
		}
*/		
		case WM_COMMAND:
		{
			switch(wParam)
			{
				case IDC_MANUAL:
				{
					ECL *ecl;
					
					ecl=(ECL *)GetWindowLong (hdlg, GWL_USERDATA);

					ecl->bManual = !(ecl->bManual);

					sResizeLicenseDialog (hdlg, ecl);					
					break;
				}

				case IDOK:
				{
					sAuthorize (hdlg);
					break;
				}
				case IDCANCEL:
				{
					EndDialog (hdlg, FALSE);
					break;
				}

				case IDC_PURCHASE:
				{
					char szWebLink[100];

					Sleep (150);
					LoadString (g_hInst, IDS_PGPSTORE, 
							szWebLink, sizeof (szWebLink));
					PGPclWebBrowse (szWebLink);
					break;
				}
			}
			return TRUE;
		}

	}
	return FALSE;
}

static void 
sTMToSystemTime (
	struct tm*	ptm, 
	SYSTEMTIME* pst) 
{
	pst->wYear			= ptm->tm_year + 1900;
	pst->wMonth			= ptm->tm_mon + 1;
	pst->wDay			= ptm->tm_mday;
	pst->wDayOfWeek		= ptm->tm_wday;
	pst->wHour			= ptm->tm_hour;
	pst->wMinute		= ptm->tm_min;
	pst->wSecond		= ptm->tm_sec;
	pst->wMilliseconds	= 0;
}


static BOOL WINAPI 
sNoLicenseDlgProc(HWND hdlg, UINT uMsg, 
				 WPARAM wParam, LPARAM lParam)
{
	switch(uMsg)
	{
		case WM_INITDIALOG:
		{
			PNL *pnl;

			pnl=(PNL *)lParam;

			if (pnl->szLicenseReq[0])
				ShowWindow (GetDlgItem (hdlg, IDC_LICENSEREQGROUP), SW_SHOW);

			SetWindowText (GetDlgItem(hdlg,IDC_NOTIFYTEXT), pnl->szNotifyText);
			SetWindowText (GetDlgItem(hdlg,IDC_LICENSEREQ), pnl->szLicenseReq);

			return TRUE;
		}
	
		case WM_DESTROY:
		{
			break;
		}

		case WM_HELP:
		case WM_CONTEXTMENU:
		{
			return PGPclHtmlHelp (hdlg, uMsg, wParam, lParam, 
					(char*)kPGPclHelpFile, aNoLicenseIds);
		}

		case WM_QUIT:
		case WM_CLOSE:
		{
			EndDialog (hdlg, FALSE);
			break;
		} 

		case WM_COMMAND:
		{
			switch (wParam)
			{
				case IDC_UPGRADE:
				{
					char szWebLink[100];

					Sleep (150);
					LoadString (g_hInst, IDS_PGPSTORE, 
							szWebLink, sizeof (szWebLink));
					PGPclWebBrowse (szWebLink);
					break;
				}

				case IDCANCEL:
				{
					EndDialog(hdlg, FALSE);
					break;
				}
			}
			return TRUE;
		}

	}
	return FALSE;
}

PGPError PGPclExport 
PGPclNoLicense(
		HWND				hwndParent,
		PGPclComponentIndex	index)
{
	PNL			pnl;
	BOOL		DialogReturn;
	WNDCLASS	wndclass;
	INT			iIDS;
	char		szNotifyText[200];
	char		szLicenseReq[100];

	if (PGPlnIsAuthorized ())
		iIDS = IDS_NOLICENSESOME;
	else
		iIDS = IDS_NOLICENSENONE;
	LoadString (g_hInst, iIDS, szNotifyText, sizeof(szNotifyText));

	switch (index) {
		case kPGPclPGPEnterprise :
		case kPGPclPGPadmin :
			iIDS = IDS_PGPENTERPRISE;
			break;

		case kPGPclPGPDesktop :
		case kPGPclGroupwisePlugin :
		case kPGPclLotusNotesPlugin :
			iIDS = IDS_PGPDESKTOP;
			break;

		case kPGPclPGPPersonal :
		case kPGPclPGPdisk :
		case kPGPclICQplugin :
		case kPGPclEudoraPlugin :
		case kPGPclExchangePlugin :
		case kPGPclOutlookExpressPlugin :
		case kPGPclPGPmailPlugin :
			iIDS = IDS_PGPPERSONAL;
			break;

		default :
			iIDS = 0;
			break;
	}
	if (iIDS)
		LoadString (g_hInst, iIDS, szLicenseReq, sizeof(szLicenseReq));
	else
		szLicenseReq[0] = '\0';

	pnl.szNotifyText = szNotifyText;
	pnl.szLicenseReq = szLicenseReq;

	memset (&wndclass, 0x00, sizeof(WNDCLASS));

    wndclass.style = CS_HREDRAW | CS_VREDRAW;                     
    wndclass.lpfnWndProc = (WNDPROC)DefDlgProc; 
    wndclass.cbClsExtra = 0;              
    wndclass.cbWndExtra = DLGWINDOWEXTRA;              
    wndclass.hInstance = g_hInst;       
    wndclass.hIcon = LoadIcon (g_hInst, MAKEINTRESOURCE(IDI_KEYICON));
    wndclass.hCursor = LoadCursor (NULL, IDC_ARROW);
    wndclass.hbrBackground = (HBRUSH)(COLOR_WINDOW+1); 
	wndclass.lpszMenuName = NULL;
	wndclass.lpszClassName = "PGPLICENSECLASS";

	RegisterClass (&wndclass);

	DialogReturn = DialogBoxParam(g_hInst, 
			MAKEINTRESOURCE(IDD_NOLICENSE), hwndParent, 
			sNoLicenseDlgProc, (LPARAM) &pnl);

	return kPGPError_NoErr;
}

static BOOL WINAPI 
sDisplayLicenseDlgProc(HWND hdlg, UINT uMsg, 
					WPARAM wParam, LPARAM lParam)
{
	switch(uMsg)
	{
		case WM_INITDIALOG:
		{
			ECL *ecl;
			char *szText,*szLocal;
			int memamt;
			char name[100];
			char corp[100];
			PGPPrefRef prefref;
			PGPUInt32 u;
			HWND hwnd,hwndButton;

			ecl=(ECL *)lParam;

			memamt=512+200;

			SetWindowLong(hdlg,GWL_USERDATA,(long)lParam);

			UTF8EditInit (GetDlgItem(hdlg,IDC_LENAME));
			UTF8EditInit (GetDlgItem(hdlg,IDC_LEORG));
			UTF8EditInit (GetDlgItem(hdlg,IDC_LESEAT));
			UTF8EditInit (GetDlgItem(hdlg,IDC_LEDATE));

			szText=malloc(memamt);

			if (szText != NULL)
			{
				int days;

				PGPlnLicenseName(name,100);
				PGPlnLicenseCorp(corp,100);

				if (PGPlnLicenseQuantity() > 1)
				{
					RECT	rc;

					hwnd = GetDlgItem(hdlg,IDC_LTNAME);
					ShowWindow (hwnd,SW_HIDE);
					EnableWindow (hwnd,FALSE);

					hwnd = UTF8EditGetHandle (GetDlgItem(hdlg,IDC_LENAME));
					ShowWindow (hwnd,SW_HIDE);
					EnableWindow (hwnd,FALSE);

					hwnd = GetDlgItem(hdlg,IDC_LTORG);
					GetWindowRect (hwnd, &rc);
					MapWindowPoints (NULL, hdlg, (LPPOINT)&rc, 2);
					SetWindowPos (hwnd, NULL, rc.left, rc.top-VERTICAL_SHIFT, 
							0, 0, SWP_NOZORDER|SWP_NOSIZE);

					hwnd = UTF8EditGetHandle (GetDlgItem(hdlg,IDC_LEORG));
					GetWindowRect (hwnd, &rc);
					MapWindowPoints (NULL, hdlg, (LPPOINT)&rc, 2);
					SetWindowPos (hwnd, NULL, rc.left, rc.top-VERTICAL_SHIFT, 
							0, 0, SWP_NOZORDER|SWP_NOSIZE);

					hwnd = GetDlgItem(hdlg,IDC_LTSEAT);
					GetWindowRect (hwnd, &rc);
					MapWindowPoints (NULL, hdlg, (LPPOINT)&rc, 2);
					SetWindowPos (hwnd, NULL, rc.left, rc.top-VERTICAL_SHIFT, 
							0, 0, SWP_NOZORDER|SWP_NOSIZE);

					hwnd = UTF8EditGetHandle (GetDlgItem(hdlg,IDC_LESEAT));
					GetWindowRect (hwnd, &rc);
					MapWindowPoints (NULL, hdlg, (LPPOINT)&rc, 2);
					SetWindowPos (hwnd, NULL, rc.left, rc.top-VERTICAL_SHIFT, 
							0, 0, SWP_NOZORDER|SWP_NOSIZE);

					hwnd = GetDlgItem(hdlg,IDC_LTDATE);
					GetWindowRect (hwnd, &rc);
					MapWindowPoints (NULL, hdlg, (LPPOINT)&rc, 2);
					SetWindowPos (hwnd, NULL, rc.left, rc.top-VERTICAL_SHIFT, 
							0, 0, SWP_NOZORDER|SWP_NOSIZE);

					hwnd = UTF8EditGetHandle (GetDlgItem(hdlg,IDC_LEDATE));
					GetWindowRect (hwnd, &rc);
					MapWindowPoints (NULL, hdlg, (LPPOINT)&rc, 2);
					SetWindowPos (hwnd, NULL, rc.left, rc.top-VERTICAL_SHIFT, 
							0, 0, SWP_NOZORDER|SWP_NOSIZE);
				}
				else
					UTF8EditSetText (GetDlgItem(hdlg,IDC_LENAME), name);

				UTF8EditSetText (GetDlgItem(hdlg,IDC_LEORG), corp);

				wsprintf(szText,"%d",PGPlnLicenseQuantity());

				UTF8EditSetText (GetDlgItem(hdlg,IDC_LESEAT), szText);

				days = PGPlnLicenseDays ();
				if (days < 0)
					days = 0;

				if (days == 0x7fffffff)
				{
					LoadString (g_hInst, IDS_LICENSEEXPIRENEVER, 
							szText, memamt);
				}
				else if (days <= 60)
				{
					char szFmt[128];

					if (PGPlnEvaluation())
					{
						LoadString (g_hInst, IDS_DAYSLEFTINEVAL, 
							szFmt, sizeof(szFmt));
					}
					else
					{
						LoadString (g_hInst, IDS_DAYSLEFTINLICENSE, 
							szFmt, sizeof(szFmt));
					}
					wsprintf (szText, szFmt, days);
				}
				else
				{
					struct tm when;
					time_t now;
					SYSTEMTIME systemtime;
		
					time (&now);
					when = *localtime (&now);

					when.tm_mday = when.tm_mday + days;

					mktime (&when);
					
					sTMToSystemTime (&when, &systemtime);
	
					GetDateFormat (LOCALE_USER_DEFAULT, DATE_SHORTDATE, 
							&systemtime, NULL, szText, memamt);
				}

				UTF8EditSetText (GetDlgItem (hdlg, IDC_LEDATE), szText);

				szLocal = (char *)malloc(memamt);

				if (PGPlnEvaluation ())
				{
					hwnd = GetDlgItem (hdlg,IDC_ENTERPRISETEXT);
					ShowWindow (hwnd, SW_HIDE);
					EnableWindow (hwnd, FALSE);

					hwnd = GetDlgItem (hdlg,IDC_ENTERPRISESTATUS);
					ShowWindow (hwnd, SW_HIDE);
					EnableWindow (hwnd, FALSE);

					hwnd = GetDlgItem (hdlg,IDC_DESKTOPTEXT);
					ShowWindow (hwnd, SW_HIDE);
					EnableWindow (hwnd, FALSE);

					hwnd = GetDlgItem (hdlg,IDC_DESKTOPSTATUS);
					ShowWindow (hwnd, SW_HIDE);
					EnableWindow (hwnd, FALSE);

					hwnd = GetDlgItem (hdlg,IDC_PGPDISKTEXT);
					ShowWindow (hwnd, SW_HIDE);
					EnableWindow (hwnd, FALSE);

					hwnd = GetDlgItem (hdlg,IDC_PGPDISKSTATUS);
					ShowWindow (hwnd, SW_HIDE);
					EnableWindow (hwnd, FALSE);

					hwnd = GetDlgItem (hdlg,IDC_PGPMAILTEXT);
					ShowWindow (hwnd, SW_HIDE);
					EnableWindow (hwnd, FALSE);

					hwnd = GetDlgItem (hdlg,IDC_PGPMAILSTATUS);
					ShowWindow (hwnd, SW_HIDE);
					EnableWindow (hwnd, FALSE);

				}
				else
				{
					hwnd=GetDlgItem(hdlg,IDC_PURCHASE);
					ShowWindow(hwnd,SW_HIDE);
					EnableWindow(hwnd,FALSE);

					hwnd=GetDlgItem(hdlg,IDC_EVALTEXT);
					ShowWindow(hwnd,SW_HIDE);
					EnableWindow(hwnd,FALSE);

					if (PGPlnEnterprise())
						u = IDS_ENABLED;
					else
						u = IDS_DISABLED;
					LoadString (g_hInst, u, szText, memamt);
					SetDlgItemText (hdlg, IDC_ENTERPRISESTATUS, szText);

					if (PGPlnDesktop())
						u = IDS_ENABLED;
					else
						u = IDS_DISABLED;
					LoadString (g_hInst, u, szText, memamt);
					SetDlgItemText (hdlg, IDC_DESKTOPSTATUS, szText);

					if (PGPlnPGPdiskEnabled())
						u = IDS_ENABLED;
					else
						u = IDS_DISABLED;
					LoadString (g_hInst, u, szText, memamt);
					SetDlgItemText (hdlg, IDC_PGPDISKSTATUS, szText);

					if (PGPlnPGPmailEnabled())
						u = IDS_ENABLED;
					else
						u = IDS_DISABLED;
					LoadString (g_hInst, u, szText, memamt);
					SetDlgItemText (hdlg, IDC_PGPMAILSTATUS, szText);

					SetWindowText(GetDlgItem(hdlg,IDC_PRODUCTTEXT),szText);
				}

				free(szText);
			}

			if(!PGPclIsAdminInstall())
			{
				// Hide upgrade for a locked LN
				if(IsntPGPError(PGPclPeekClientLibPrefRefs(&prefref,NULL)))
				{
					if (IsntPGPError (
							PGPGetPrefFlags( prefref, kPGPPrefLicenseNumber, &u)))
					{
						if (u & kPGPPrefFlags_DisableGUI)
						{
							hwndButton=GetDlgItem(hdlg,IDC_CHANGE);

							ShowWindow(hwndButton,SW_HIDE);
							EnableWindow(hwndButton,FALSE);

							hwndButton=GetDlgItem(hdlg,IDC_PURCHASE);

							ShowWindow(hwndButton,SW_HIDE);
							EnableWindow(hwndButton,FALSE);
						}
					}
				}
			}

			return TRUE;
		}
	
		case WM_DESTROY:
		{
			UTF8EditDestroy (GetDlgItem(hdlg,IDC_LENAME));
			UTF8EditDestroy (GetDlgItem(hdlg,IDC_LEORG));
			UTF8EditDestroy (GetDlgItem(hdlg,IDC_LESEAT));
			UTF8EditDestroy (GetDlgItem(hdlg,IDC_LEDATE));
			break;
		}

		case WM_HELP:
		case WM_CONTEXTMENU:
		{
			return PGPclHtmlHelp (hdlg, uMsg, wParam, lParam, 
					(char*)kPGPclHelpFile, aLicenseDisplayIds);
		}

		case WM_QUIT:
		case WM_CLOSE:
		{
			EndDialog(hdlg, FALSE);
			break;
		} 
/*
		case WM_PAINT:
		{
			HDC	hDC;
			PAINTSTRUCT ps;
			ECL *ecl;
					
			ecl=(ECL *)GetWindowLong (hdlg, GWL_USERDATA);

			hDC = BeginPaint (hdlg, &ps);
			SelectPalette (hDC, ecl->hPalette, FALSE);
			RealizePalette (hDC);

			TransparentBitmap(ecl->hLNKey,72,88,RGB(255,0,0),hDC,15,10);
			
			EndPaint (hdlg, &ps);
			break;
		}
*/		
		case WM_COMMAND:
		{
			switch(wParam)
			{
				case IDC_PURCHASE:
				{
					char szWebLink[100];

					Sleep (150);
					LoadString (g_hInst, IDS_PGPSTORE, 
							szWebLink, sizeof (szWebLink));
					PGPclWebBrowse (szWebLink);
					break;
				}

				case IDOK:
				{
					EndDialog(hdlg, FALSE);
					break;
				}

				case IDC_CHANGE:
				{
					EndDialog(hdlg, TRUE);
				}
			}
			return TRUE;
		}

	}
	return FALSE;
}

PGPError PGPclExport 
PGPclDisplayLicense(
		PGPContextRef	context,
		HWND			hwndParent)
{
	ECL ecl;
	BOOL DialogReturn;
	WNDCLASS wndclass;

	memset (&wndclass, 0x00, sizeof(WNDCLASS));

    wndclass.style = CS_HREDRAW | CS_VREDRAW;                     
    wndclass.lpfnWndProc = (WNDPROC)DefDlgProc; 
    wndclass.cbClsExtra = 0;              
    wndclass.cbWndExtra = DLGWINDOWEXTRA;              
    wndclass.hInstance = g_hInst;       
    wndclass.hIcon = LoadIcon (g_hInst, MAKEINTRESOURCE(IDI_KEYICON));
    wndclass.hCursor = LoadCursor (NULL, IDC_ARROW);
    wndclass.hbrBackground = (HBRUSH)(COLOR_WINDOW+1); 
	wndclass.lpszMenuName = NULL;
	wndclass.lpszClassName = "PGPLICENSECLASS";

	RegisterClass (&wndclass);

	ecl.context=context;

	DialogReturn = DialogBoxParam(g_hInst, 
			MAKEINTRESOURCE(IDD_DISPLAYLICENSE), hwndParent, 
			sDisplayLicenseDlgProc, (LPARAM) &ecl);

	if (DialogReturn)
		return PGPclEnterLicense(context,hwndParent);

	return kPGPError_NoErr;
}

PGPError PGPclExport 
PGPclEnterLicense(
		PGPContextRef	context,
		HWND			hwndParent)
{
	ECL ecl;
	BOOL DialogReturn;
	WNDCLASS wndclass;

	memset (&wndclass, 0x00, sizeof(WNDCLASS));

    wndclass.style = CS_HREDRAW | CS_VREDRAW;                     
    wndclass.lpfnWndProc = (WNDPROC)DefDlgProc; 
    wndclass.cbClsExtra = 0;              
    wndclass.cbWndExtra = DLGWINDOWEXTRA;              
    wndclass.hInstance = g_hInst;       
    wndclass.hIcon = LoadIcon (g_hInst, MAKEINTRESOURCE(IDI_KEYICON));
    wndclass.hCursor = LoadCursor (NULL, IDC_ARROW);
    wndclass.hbrBackground = (HBRUSH)(COLOR_WINDOW+1); 
	wndclass.lpszMenuName = NULL;
	wndclass.lpszClassName = "PGPLICENSECLASS";

	RegisterClass (&wndclass);

	ecl.context=context;
	ecl.bManual=FALSE;

	ecl.hLNKey = CLLoadResourceBitmap(
			g_hInst, MAKEINTRESOURCE(IDB_LNKEY), &(ecl.hPalette));

	DialogReturn = DialogBoxParam(g_hInst, 
			MAKEINTRESOURCE(IDD_ENTERLICENSE), hwndParent, 
			sEnterChangeLicenseDlgProc, (LPARAM) &ecl);

	DeleteObject (ecl.hLNKey);
	DeleteObject (ecl.hPalette);

	if (DialogReturn)
	{
		PGPlnLicenseCheck (context);

		return PGPclDisplayLicense (context, hwndParent); 
	}

	return kPGPError_NoErr;
}

/*__Editor_settings____

	Local Variables:
	tab-width: 4
	End:
	vi: ts=4 sw=4
	vim: si
_____________________*/
