/*____________________________________________________________________________
	Copyright (C) 2002 PGP Corporation
	All rights reserved.

	CLprefs.h - internal header for PGPcl prefs source files


	$Id: CLprefs.h,v 1.21 2002/11/19 21:58:41 pbj Exp $
____________________________________________________________________________*/
#ifndef Included_CLpref_h	/* [ */
#define Included_CLpref_h

#include "pgpNetPrefs.h"
#include "TreeList.h"

// definitions

// typedefs
typedef struct {
	HWND			hwndCacheDuration;
	SYSTEMTIME		stCacheDuration;
} GENPREFSTRUCT, *PGENPREFSTRUCT;

typedef struct {
	CHAR			szInitDir[MAX_PATH];
	BOOL			bMediaNotInserted;
	BOOL			bCopiedKeyrings;
	BOOL			bKeyringCopyError;
} FILEPREFSTRUCT, *PFILEPREFSTRUCT;

typedef struct {
	HWND			hwndFocus;
} HOTKEYSPREFSTRUCT, *PHOTKEYSPREFSTRUCT;

typedef struct {
	HWND			hwndTree;
	BOOL			bDisabled;
	BOOL			bPrefsModified;
	UINT			uNumberOfServers;

	HTLITEM			hTSelected;
	HTLITEM			hTDefault;
	INT				iSelectedType;
	BOOL			bSelectedRoot;
	BOOL			bFirstInList;
	BOOL			bLastInList;
} SERVERSPREFSTRUCT, *PSERVERSPREFSTRUCT;

typedef struct {
	BOOL			bUrlModified;
	BOOL			bRevUrlModified;
	BOOL			bCertSet;
	PGPKeyDBObjRef	sigCert;
} CAPREFSTRUCT, *PCAPREFSTRUCT;

typedef struct {
	BOOL			bPrefsEnabled;
	BOOL			bPrefsModified;
} DISKPREFSTRUCT, *PDISKPREFSTRUCT;

typedef struct {
	// general
	BOOL				bPrefsModified;
	BOOL				bKeyringModified;

	// IDR

	// firewall
	HWND				hwndToolTip;
	WNDPROC				wpOrigProc;
	PGPBoolean			bCustomLevel;
	BOOL				bRulesRenumbered;
	PGPInt32			iSelectedRule;
	PGPInt32			iSelectedCount;
	PGPUInt32			uRuleCount;
	PGPNetPrefFirewallRule*	pruleList;

	// VPN
	BOOL				bVPNPrefsEnabled;
	HWND				hwndIKETimeExpire;
	HWND				hwndIPSECTimeExpire;

	// authentication
	CHAR				szPubringFile[MAX_PATH];
	CHAR				szSecringFile[MAX_PATH];
	PGPKeyDBRef			keydb;
	HWND				hwndPGPKeyList;
	PGPBoolean			bUsePGPAuthKey;
	PGPKeyID			keyidPGPAuth;
	PGPBoolean			bUseX509AuthKey;
	PGPKeyID			keyidX509Auth;
	PGPByte*			pX509AuthCertIASN;
	PGPUInt32			uX509AuthCertIASNLength;

	// advanced
	BOOL				bIKEProposalsDisabled;
	BOOL				bIPSECProposalsDisabled;
	UINT							uNumIKEProposals;
	PGPNetPrefIKEProposalEntry*		pIKEProposals;
	UINT							uNumIPSECProposals;
	PGPNetPrefIPSECProposalEntry*	pIPSECProposals;

	INT					iSelectedIkeItem;
	INT					iSelectedIpsecItem;
	INT					iFocusedProposalList;
} NETPREFSTRUCT, *PNETPREFSTRUCT;

typedef struct {
	PGPContextRef		context;
	HWND				hwndParent;
	BOOL				bAdminCalled;
	BOOL				bNeedsCentering;
	BOOL				bRespectDisables;
	BOOL				bToolsPrefsEnabled;

	BOOL				bUseClientLibPrefs;
	PGPPrefRef			prefref;
	BOOL				bUseClientLibNetPrefs;
	PGPPrefRef			prefrefNet;

	CHAR				szPubringFile[MAX_PATH];
	CHAR				szSecringFile[MAX_PATH];
	CHAR				szRandseedFile[MAX_PATH];

	PGPKeyDBRef			keydbMain;
	PGPError			returnErr;

	INT					iFilePage;
	BOOL				bPrefsModified;
	BOOL				bKeyringModified;

	BOOL				bSmartCardComboFocus;
	CHAR				szSmartCardDriver[MAX_PATH];
	BOOL				bSmartCardExpirationWarned;

	GENPREFSTRUCT		gen;
	FILEPREFSTRUCT		file;
	HOTKEYSPREFSTRUCT	hk;
	SERVERSPREFSTRUCT	ks;
	CAPREFSTRUCT		ca;
	DISKPREFSTRUCT		disk;
	NETPREFSTRUCT		net;
} PREFSDLGSTRUCT, *PPREFSDLGSTRUCT;



// prototypes
// CLprefs.c
PGPBoolean
CLSaveCheckBoxPref (
		HWND			hwnd,
		INT				idc,
		PGPPrefRef		prefref,
		UINT			uPref);

PGPBoolean
CLLoadCheckBoxPref (
		HWND			hwnd,
		INT				idc,
		PPREFSDLGSTRUCT ppds,
		PGPPrefRef		prefref,
		UINT			uPref);

PGPBoolean
CLDisablePrefControl (
		HWND			hwnd,
		INT				idc,
		PPREFSDLGSTRUCT ppds,
		PGPPrefRef		prefref,
		UINT			uPref);

PGPPrefRef
CLGetPrefRef (
		PPREFSDLGSTRUCT	ppds);

PGPPrefRef
CLGetPrefRefNet (
		PPREFSDLGSTRUCT	ppds);

// CLprefsAdvanced.c
LRESULT WINAPI
CLAdvancedPropDlgProc (
		HWND		hwnd,
		UINT		uMsg,
		WPARAM		wParam,
		LPARAM		lParam);

// CLprefsCA.c
LRESULT WINAPI
CLCAPropDlgProc (
		HWND		hwnd,
		UINT		uMsg,
		WPARAM		wParam,
		LPARAM		lParam);

// CLprefsDisk.c
LRESULT WINAPI
CLDiskPropDlgProc (
		HWND		hwnd,
		UINT		uMsg,
		WPARAM		wParam,
		LPARAM		lParam);

// CLprefsEmail.c
LRESULT WINAPI
CLEmailPropDlgProc (
		HWND		hwnd,
		UINT		uMsg,
		WPARAM		wParam,
		LPARAM		lParam);

// CLprefsFiles.c
LRESULT WINAPI
CLFilePropDlgProc (
		HWND		hwnd,
		UINT		uMsg,
		WPARAM		wParam,
		LPARAM		lParam);

// CLprefsGeneral.c
LRESULT WINAPI
CLGeneralPropDlgProc (
		HWND		hwnd,
		UINT		uMsg,
		WPARAM		wParam,
		LPARAM		lParam);

// CLprefsHotkeys.c
LRESULT WINAPI
CLHotkeyPropDlgProc (
		HWND		hwnd,
		UINT		uMsg,
		WPARAM		wParam,
		LPARAM		lParam);

// CLprefsKeyservers.c
LRESULT WINAPI
CLKeyserverPropDlgProc (
		HWND		hwnd,
		UINT		uMsg,
		WPARAM		wParam,
		LPARAM		lParam);

// CLprefsNetAdv.c
LRESULT WINAPI
CLNetAdvPropDlgProc (
		HWND		hwnd,
		UINT		uMsg,
		WPARAM		wParam,
		LPARAM		lParam);

// CLprefsNetAuth.c
LRESULT WINAPI
CLNetAuthPropDlgProc (
		HWND		hwnd,
		UINT		uMsg,
		WPARAM		wParam,
		LPARAM		lParam);

// CLprefsNetFirewall.c
LRESULT WINAPI
CLNetFirewallPropDlgProc (
		HWND		hwnd,
		UINT		uMsg,
		WPARAM		wParam,
		LPARAM		lParam);

// CLprefsNetIDR.c
LRESULT WINAPI
CLNetIDRPropDlgProc (
		HWND		hwnd,
		UINT		uMsg,
		WPARAM		wParam,
		LPARAM		lParam);

// CLprefsNetVPN.c
LRESULT WINAPI
CLNetVPNPropDlgProc (
		HWND		hwnd,
		UINT		uMsg,
		WPARAM		wParam,
		LPARAM		lParam);


#endif /* ] Included_CLpref_h */


/*__Editor_settings____

	Local Variables:
	tab-width: 4
	End:
	vi: ts=4 sw=4
	vim: si
_____________________*/
