/*____________________________________________________________________________
	Copyright (C) 2002 PGP Corporation
	All rights reserved.

	CLrecip.c - Glue code to allow clients to access
	            recipient dialog in PGPsdkUI

	$Id: CLrecip.c,v 1.26 2002/10/31 04:13:35 pbj Exp $
____________________________________________________________________________*/
#include "pgpPFLConfig.h"

#include "PGPclx.h"
#include "pgpUserInterface.h"
extern HINSTANCE g_hInst;

#define SDKUITEST 0


/*
old RECIPIENTDIALOGSTRUCT for reference

typedef struct _recipientdialogstruct
{
	DWORD			Version;
	HWND			hwndParent;
	char *			szTitle;
	PGPContextRef	Context;
	PGPKeySetRef 	OriginalKeySetRef;
	PGPKeySetRef 	SelectedKeySetRef;
	char **			szRecipientArray;
	DWORD			dwNumRecipients;
	DWORD			dwOptions;
	DWORD			dwFlags;
	DWORD			dwDisableFlags;
} RECIPIENTDIALOGSTRUCT, *PRECIPIENTDIALOGSTRUCT;
*/

BOOL DefaultKeyCheck(HWND hwnd,
				PGPKeyDBObjRef DefaultKey,
				PGPKeyDBRef SelectedKeyDB)
{
    PGPKeyDBObjRef key;
	PGPError err;

	// We don't even know their default key!
	if(!PGPKeyDBObjRefIsValid(DefaultKey))
		return FALSE;

	err=PGPclGetDefaultPrivateKey(SelectedKeyDB,&key);

	if(IsPGPError(err))
		return FALSE;

	return TRUE;
}

BOOL RSACheck(HWND hwnd,
			   PGPKeyDBRef SelectedKeyDB)
{
	PGPKeySetRef SelectedKeySet;
    PGPKeyIterRef iter;
    PGPKeyDBObjRef key;
	PGPBoolean FoundRSAKey;
	PGPInt32 algorithm;

  	PGPNewKeySet( SelectedKeyDB, &SelectedKeySet );
	PGPNewKeyIterFromKeySet (SelectedKeySet, &iter);

	FoundRSAKey=FALSE;

    while (IsntPGPError(PGPKeyIterNextKeyDBObj(
							iter,
							kPGPKeyDBObjType_Key,
							&key)))
    {
		PGPGetKeyDBObjNumericProperty( key, 
			kPGPKeyProperty_AlgorithmID, &algorithm );
		if(algorithm == kPGPPublicKeyAlgorithm_RSA)
			FoundRSAKey=TRUE;
	}

	PGPFreeKeyIter(iter);
	PGPFreeKeySet(SelectedKeySet);

	return FoundRSAKey;

	return FALSE;
}
/*
BOOL CorpCheck(HWND hwnd,
			   PGPKeyDBRef MainKeyDB,
			   PGPKeyDBRef SelectedKeyDB,
			   PGPKeyDBObjRef CorpKey)
{
    PGPKeyDBObjRef userID;
	PGPKeySetRef SelectedKeySet;
    PGPKeyIterRef iter;
    PGPKeyDBObjRef key;
	char UserIDStr[kPGPMaxUserIDSize+1];
	int len;
	PGPBoolean SignedByCorp;
	PGPError err;
  	PGPKeyDBObjRef sig;
	PGPKeyDBObjRef certifierKey;

	PGPNewKeySet( SelectedKeyDB, &SelectedKeySet );
	PGPNewKeyIterFromKeySet (SelectedKeySet, &iter);

    while (IsntPGPError(PGPKeyIterNextKeyDBObj(
								iter,
								kPGPKeyDBObjType_Key,
								&key)))
    {
		SignedByCorp=FALSE;

        while (IsntPGPError(PGPKeyIterNextKeyDBObj(
								iter,
								kPGPKeyDBObjType_UserID,
								&userID)))
        {
			while(IsntPGPError(PGPKeyIterNextKeyDBObj(
								iter,
								kPGPKeyDBObjType_Signature,
								&sig)))
			{
				err = PGPGetSigCertifierKey(
					sig, MainKeyDB, &certifierKey);

				if(IsntPGPError(err))
				{
					if(certifierKey == CorpKey)
						SignedByCorp=TRUE;
				}
			}
		}

		if(!SignedByCorp)
		{
			UINT msgrst;
			char StrRes[500];

			err = PGPGetPrimaryUserIDName (key,
					UserIDStr, kPGPMaxUserIDSize, &len); 

			LoadString (g_hInst, IDS_KEYNOTSIGNEDBYCORP,
											StrRes, sizeof(StrRes));

			msgrst=MessageBox(hwnd,StrRes,UserIDStr,
				MB_YESNO|MB_ICONEXCLAMATION|MB_SETFOREGROUND);

			if(msgrst==IDNO)
			{
				PGPFreeKeyIter(iter);
				PGPFreeKeySet(SelectedKeySet);

				return FALSE;
			}
		}
	}

	PGPFreeKeyIter(iter);
	PGPFreeKeySet(SelectedKeySet);

	return TRUE;
}
*/
BOOL InvalidCheck(HWND hwnd,
			   PGPKeyDBRef MainKeyDB,
			   PGPKeyDBRef SelectedKeyDB)
{
	PGPKeySetRef SelectedKeySet;
    PGPKeyIterRef iter;
    PGPKeyDBObjRef key;
	PGPBoolean bAllValid;
	PGPBoolean bAxiomatic;
	DWORD Validity;

	bAllValid=TRUE;

	PGPNewKeySet( SelectedKeyDB, &SelectedKeySet );
	PGPNewKeyIterFromKeySet (SelectedKeySet, &iter);

    while (IsntPGPError(PGPKeyIterNextKeyDBObj(
								iter,
								kPGPKeyDBObjType_Key,
								&key)))
    {
		PGPGetKeyDBObjNumericProperty(key,
			kPGPKeyProperty_Validity,
			&Validity);
	    PGPGetKeyDBObjBooleanProperty (key, 
			kPGPKeyProperty_IsAxiomatic, 
			&bAxiomatic);

		if(bAxiomatic)
		{
			// Implicit Trust
		}
		else switch(Validity)
		{
			case kPGPValidity_Marginal :
			{
				// Marginal Key
				break;
			}
			case kPGPValidity_Complete :
			{
				// Valid Key;
				break;
			}
			default :
			{
				// Invalid Key
				bAllValid=FALSE;
				break;
			}
		}  
	}

	PGPFreeKeyIter(iter);
	PGPFreeKeySet(SelectedKeySet);

	return bAllValid;
}

typedef struct
{
	// Admins Prefs
	PGPBoolean allowConvEncrypt;
	PGPBoolean WarnNotCorpSigned;
	PGPBoolean haveOutgoingADK;
	PGPBoolean enforceOutgoingADK;
	PGPBoolean enforceRemoteADKClass;
	PGPBoolean allowInvalidEncrypt;
//	PGPKeyDBObjRef corpKey;
	PGPKeyDBObjRef outgoingADK;

	// Client Prefs
	PGPBoolean bWarnOnADK;
	PGPBoolean showMarginalValidity;
	PGPBoolean marginalIsInvalid;
	PGPBoolean encryptToSelf;
	PGPBoolean synchUnknown;
	PGPKeyDBObjRef defaultKey;

	// KeyServer (Client) Prefs
	PGPKeyServerEntry *ksEntries;
	PGPUInt32 numKSEntries;
	PGPKeyServerSpec *serverList;
	PCLIENTSERVERSTRUCT	pcss;
	PGPBoolean bKeyserversInited;
} APREF;

void NoDefaultKey(HWND hwnd)
{
	PGPclMessageBox(hwnd,IDS_CAPTIONALERT,IDS_NOVALIDDEFAULTKEY,
		MB_OK|MB_ICONEXCLAMATION);
}

void NoOutADKKey(HWND hwnd)
{
	PGPclMessageBox(hwnd,IDS_CAPTIONERROR,IDS_NOOUTADK,
		MB_OK|MB_ICONSTOP);
}


void EncryptingToInvalidKeys(HWND hwnd)
{
	PGPclMessageBox(hwnd,IDS_CAPTIONERROR,IDS_ENCRYPTINVALID,
		MB_OK|MB_ICONSTOP);
}

/*
void NoCorpKey(HWND hwnd)
{
	PGPclMessageBox(hwnd,IDS_CAPTIONERROR,IDS_NOCORPSIGNKEY,
		MB_OK|MB_ICONSTOP);
}
*/
PGPError GrabRecipClientPrefs(HWND hwndParent,
							  PGPContextRef context,
							  PGPKeyDBRef keydb,
							  APREF *apref)
{
	PGPError		err;
	PGPPrefRef		prefRef;

	err=CLInitKeyServerPrefs(
		kPGPclAllServers,NULL,
		hwndParent,
		context,
		keydb,
		"",
		&(apref->pcss),
		&(apref->ksEntries),
		&(apref->serverList),
		&(apref->numKSEntries));

	if(IsntPGPError(err))
	{
		apref->bKeyserversInited=TRUE;
	}

	err = PGPclPeekClientLibPrefRefs(&prefRef,NULL);

	if (IsntPGPError (err))
	{
		PGPGetPrefBoolean(prefRef, kPGPPrefWarnOnADK,
				&(apref->bWarnOnADK));
		PGPGetPrefBoolean(prefRef, kPGPPrefDisplayMarginalValidity,
				&(apref->showMarginalValidity));
		PGPGetPrefBoolean(prefRef, kPGPPrefMarginalIsInvalid,
				&(apref->marginalIsInvalid));
		PGPGetPrefBoolean(prefRef, kPGPPrefEncryptToSelf,
				&(apref->encryptToSelf));
		PGPGetPrefBoolean(prefRef, kPGPPrefKeyServerSyncUnknownKeys,
				&(apref->synchUnknown));

		if(IsntPGPError(err))
		{

			err=PGPclGetDefaultPrivateKey(keydb,&(apref->defaultKey));

			if(IsPGPError(err))
			{
				// Warning message here
				apref->defaultKey=NULL;
				err=kPGPError_NoErr;
			}
		}
	}

	return err;
}

PGPError GrabRecipAdminPrefs(HWND hwndParent,
							 PGPContextRef context,
							 PGPKeyDBRef keydb,
							 APREF *apref)
{
	PGPKeyID	*adKeyID;
	PGPSize		adKeyIDSize;
//	PGPKeyID	*corpKeyID;
//	PGPSize		corpKeyIDSize;
	PGPError	err;
	PGPPrefRef	prefRef;

	err = PGPclPeekClientLibPrefRefs(&prefRef,NULL);
	if (IsPGPError (err))
		return err;

	// Allow Conventional
	PGPGetPrefBoolean(prefRef,
		kPGPPrefAllowConventionalEncryption,
		&(apref->allowConvEncrypt));

	// Warn if recipient not signed by corp key
/*	PGPGetPrefBoolean(prefRef,
		kPGPPrefWarnNotCertByCorp,
		&(apref->WarnNotCorpSigned));*/

	// Use an outgoing ADK
	PGPGetPrefBoolean(prefRef,
		kPGPPrefUseOutgoingADK,
		&(apref->haveOutgoingADK));

	// Enforce this outgoing ADK
	PGPGetPrefBoolean(prefRef,
		kPGPPrefEnforceOutgoingADK,
		&(apref->enforceOutgoingADK));

	// Enforce remote ADKs
	PGPGetPrefBoolean(prefRef,
		kPGPPrefEnforceRemoteADKClass,
		&(apref->enforceRemoteADKClass));

	// Allow encryption to invalid keys
	PGPGetPrefBoolean(prefRef,
		kPGPPrefAllowEncryptInvalidKeys,
		&(apref->allowInvalidEncrypt));

	// Get corp key ref
/*	PGPGetPrefData(prefRef,
		kPGPPrefCorpKeyID,
		&corpKeyIDSize,
		&corpKeyID);*/

	// Get outgoing adk key
	PGPGetPrefData(prefRef,
		kPGPPrefOutgoingADKID,
		&adKeyIDSize, &adKeyID );

	if((apref->haveOutgoingADK)&&(IsntPGPError(err)))
	{
		err=PGPFindKeyByKeyID(
			keydb,
			adKeyID,
			&(apref->outgoingADK));

		if(IsPGPError(err))
		{
			// Warning message here
			apref->outgoingADK=NULL;
			err=kPGPError_NoErr;
		}
	}

	if(adKeyID)
		PGPFreeData(adKeyID);
/*
	if((apref->WarnNotCorpSigned)&&(IsntPGPError(err)))
	{
		err=PGPFindKeyByKeyID(
			keydb,
			corpKeyID,
			&(apref->corpKey));

		if(IsPGPError(err))
		{
			// Warning message here
			apref->corpKey=NULL;
			err=kPGPError_NoErr;
		}
	}

	if(corpKeyID)
		PGPFreeData(corpKeyID);*/

	return err;
}

UINT PGPclExport PGPclRecipientDialog(PPGPclRecipientDialogStruct prds)
{
	PGPOptionListRef			rdoptionList;
	PGPOptionListRef			ksupoptionList;
	PGPOptionListRef			optionList;
	PGPUInt32					conventionalEncrypt,
								textOutput,
								wipeOriginal,
								fyeo,
								sda,
								inputIsText;
	PGPBoolean					haveFileOptions;
	PGPclGroupFile				*pGroup;
	PGPKeyDBRef					foundKeys;
	PGPUInt32					numKeys;
	APREF						apref;
	PGPUInt32					arrEnforcement;
	PGPError					err;
	char						StrRes1[100],StrRes2[300],StrRes3[100];
	DWORD						dwDisableFlags;

	dwDisableFlags=prds->dwDisableFlags;

	memset(&apref,0x00,sizeof(APREF));
	apref.allowConvEncrypt = TRUE;

	pGroup=NULL;
	err=kPGPError_NoErr;
	foundKeys=NULL;
	rdoptionList = kInvalidPGPOptionListRef;
	optionList = kInvalidPGPOptionListRef;
	ksupoptionList = kInvalidPGPOptionListRef;
	haveFileOptions=FALSE;
	arrEnforcement = kPGPARREnforcement_Warn;
	inputIsText=textOutput=conventionalEncrypt=wipeOriginal=fyeo=sda=0;

	// Create Null Option List for recipient dialog
	err = PGPBuildOptionList( prds->context, &rdoptionList,
		PGPOLastOption( prds->context ) );

// ******************BUSINESS SECURITY***********************
	if(PGPlnEnterprise())
	{
		if(IsntPGPError(err))
		{
			err=GrabRecipAdminPrefs(prds->hwndParent,
						prds->context,
						prds->keydbOriginal,
						&apref);
		}

		if(IsntPGPError(err))
		{
			arrEnforcement = kPGPARREnforcement_Warn;

			if(apref.enforceRemoteADKClass)
				arrEnforcement=kPGPARREnforcement_Strict;
	/*
			if(apref.WarnNotCorpSigned)
			{
				if(apref.corpKey==NULL)
				{
	// Warn if we can't find it AND exit since required.
					NoCorpKey(prds->hwndParent);
					return FALSE;
				}
			}*/

			if(apref.haveOutgoingADK)
			{
				if(PGPKeyDBObjRefIsValid(apref.outgoingADK))
				{
					PGPRecipientSpec	spec;
					PGPBoolean			bDisabled;

					bDisabled=TRUE;

					err = PGPGetKeyDBObjBooleanProperty( apref.outgoingADK, 
						kPGPKeyProperty_IsDisabled, &bDisabled );

					if(!bDisabled)
					{
						pgpClearMemory( &spec, sizeof( spec ) );

						spec.type	= kPGPRecipientSpecType_Key;
						if(apref.enforceOutgoingADK)
							spec.flags	= kPGPRecipientSpecFlags_Locked;
						spec.u.key	= apref.outgoingADK;

						err = PGPAppendOptionList( rdoptionList,
							PGPOUIDefaultRecipients( prds->context, 1, &spec ),
							PGPOLastOption( prds->context ) );
					}
					else
					{
						if(apref.enforceOutgoingADK)
						{
							// HaveOutgoing, Enforced, but disabled? No way!
							NoOutADKKey(prds->hwndParent);
							err = kPGPError_UserAbort;
						}
					}
				}
				else
				{
					if(apref.enforceOutgoingADK)
					{
						// HaveOutgoing, Enforced, but no key? No way!
						NoOutADKKey(prds->hwndParent);
						err = kPGPError_UserAbort;
					}
					else
					{
						err = kPGPError_NoErr;
					}
				}
			}
		}
	}
// ******************END BUSINESS SECURITY*******************

	// Get client prefs
	if(IsntPGPError(err))
	{
		err=GrabRecipClientPrefs(prds->hwndParent,
			prds->context,
			prds->keydbOriginal,
			&apref);
	}

	// Add recipients
	if((IsntPGPError(err))&&
		(prds->szRecipientArray!=NULL)&&
		(prds->dwNumRecipients!=0))
	{
		PGPRecipientSpec	*spec;
		int memamt,i;

		memamt=sizeof(PGPRecipientSpec)*prds->dwNumRecipients;
		spec=(PGPRecipientSpec *)malloc(memamt);
		memset(spec,0x00,memamt);

		for(i=0;i<(int)prds->dwNumRecipients;i++)
		{
			spec[i].type=kPGPRecipientSpecType_UserID;
			strcpy(spec[i].u.userIDStr,prds->szRecipientArray[i]);
		}

		err = PGPAppendOptionList( rdoptionList,
			PGPOUIDefaultRecipients( prds->context,
										prds->dwNumRecipients,spec),
			PGPOLastOption( prds->context ) );

		free(spec);
	}

	// Open groups file
	if( IsntPGPError( err ) )
	{
		err=PGPclOpenGroupFile (prds->context,&pGroup);

		if(IsntPGPError(err))
		{
			err = PGPAppendOptionList( rdoptionList,
				PGPOUIRecipientGroups( prds->context, pGroup->groupset ),
				PGPOLastOption( prds->context ) );
		}
	}

	// AddDefaultKey
	if( IsntPGPError( err ) && apref.encryptToSelf )
	{
		if(PGPKeyDBObjRefIsValid(apref.defaultKey))
		{
			PGPRecipientSpec	spec;

			pgpClearMemory( &spec, sizeof( spec ) );

			spec.type	= kPGPRecipientSpecType_Key;
			spec.u.key	= apref.defaultKey;

			err = PGPAppendOptionList( rdoptionList,
				PGPOUIDefaultRecipients( prds->context, 1, &spec ),
				PGPOLastOption( prds->context ) );
		}
		else
		{
			NoDefaultKey(prds->hwndParent);

			// Don't let the recipient dialog automatically 
			// proceed
			dwDisableFlags=dwDisableFlags|kPGPclDisableAutoMode;
		}
	}

	// Make options control
	if( IsntPGPError( err ) )
	{
		err = PGPBuildOptionList( prds->context, &optionList,
			PGPOLastOption( prds->context ) );

		if(prds->dwOptions&kPGPclASCIIArmor)
			textOutput=1;

		if(prds->dwOptions&kPGPclInputIsText)
			inputIsText=1;

		if((prds->dwOptions&kPGPclPassOnly)&&(apref.allowConvEncrypt))
			conventionalEncrypt=1;

		if(prds->dwOptions&kPGPclWipeOriginal)
			wipeOriginal=1;

		if(prds->dwOptions&kPGPclSecureViewer)
			fyeo=1;

		if(prds->dwOptions&kPGPclSelfDecryptingArchive)
			sda=1;

#if SDKUITEST
		// Just some code here to stress test the sdkUI options....
		{
			static char one[]="one";
			static char two[]="two";
			char *list[2];
			static char descript[]=
				"She smiled at a sorrowful stranger. "
				"The smile seemed to make him feel better. "
				"He remembered past kindnesses of a friend "
				"And wrote him a thank you letter.";

			list[0]=one;
			list[1]=two;

			err = PGPAppendOptionList( optionList,
					PGPOUIPopupList( prds->context, 900, one, descript, 2,
						list,0, &sda,
						PGPOUIPopupList( prds->context, 901, two, descript, 2,
							list,0, &sda,
							PGPOLastOption( prds->context ) ),
						PGPOLastOption( prds->context ) ),
					PGPOLastOption( prds->context ) );

			err = PGPAppendOptionList( optionList,
					PGPOUIPopupList( prds->context, 902, one, descript, 2,
						list,0, &sda,
						PGPOUIPopupList( prds->context, 903, two, descript, 2,
							list,0, &sda,
							PGPOLastOption( prds->context ) ),
						PGPOLastOption( prds->context ) ),
					PGPOLastOption( prds->context ) );
		}
#endif

		if(!(dwDisableFlags&kPGPclDisableASCIIArmor))
		{
			haveFileOptions=TRUE;
			LoadString (g_hInst, IDS_TEXTOUTPUT, StrRes1, sizeof(StrRes1));

			err = PGPAppendOptionList( optionList,
						PGPOUICheckbox( prds->context, 801,
							StrRes1,NULL,
							textOutput, &textOutput,
							PGPOLastOption( prds->context ) ),
						PGPOLastOption( prds->context ) );
		}

		if(!(dwDisableFlags&kPGPclDisableInputIsText))
		{
			haveFileOptions=TRUE;
			LoadString (g_hInst, IDS_INPUTISTEXT, StrRes1, sizeof(StrRes1));

			err = PGPAppendOptionList( optionList,
						PGPOUICheckbox( prds->context, 807,
							StrRes1,NULL,
							inputIsText, &inputIsText,
							PGPOLastOption( prds->context ) ),
						PGPOLastOption( prds->context ) );
		}

		if(!(dwDisableFlags&kPGPclDisableWipeOriginal))
		{
			haveFileOptions=TRUE;
			LoadString (g_hInst, IDS_WIPEORIGINAL, StrRes3, sizeof(StrRes3));

			err = PGPAppendOptionList( optionList,
						PGPOUICheckbox( prds->context, 803,
							StrRes3,NULL,
							wipeOriginal, &wipeOriginal,
							PGPOLastOption( prds->context ) ),
						PGPOLastOption( prds->context ) );
		}

		if(!(dwDisableFlags&kPGPclDisableSecureViewer))
		{
			haveFileOptions=TRUE;
			LoadString (g_hInst, IDS_FYEO, StrRes3, sizeof(StrRes3));

			err = PGPAppendOptionList( optionList,
						PGPOUICheckbox( prds->context, 805,
							StrRes3,NULL,
							fyeo, &fyeo, PGPOLastOption( prds->context ) ),
						PGPOLastOption( prds->context ) );
		}

		if((!(dwDisableFlags&kPGPclDisablePassOnly))&&
			(apref.allowConvEncrypt))
		{
			PGPOptionListRef			ConvOptionList;

			// Create NULL suboption list for conventional encryption
			err = PGPBuildOptionList( prds->context, &ConvOptionList,
				PGPOLastOption( prds->context ) );

			// If SDA is specified, make it a suboption
			if(!(dwDisableFlags&kPGPclDisableSelfDecryptingArchive))
			{
				haveFileOptions=TRUE;
				LoadString (g_hInst, IDS_SDA, StrRes3, sizeof(StrRes3));

				err = PGPAppendOptionList( ConvOptionList,
						PGPOUICheckbox( prds->context, 806,
							StrRes3,NULL,
							sda, &sda, PGPOLastOption( prds->context ) ),
						PGPOLastOption( prds->context ) );
			}

			haveFileOptions=TRUE;
			LoadString (g_hInst, IDS_CONVENCRYPTION,
										StrRes2, sizeof(StrRes2));

			err = PGPAppendOptionList( optionList,
						PGPOUICheckbox( prds->context, 802,
							StrRes2,NULL,
							conventionalEncrypt, &conventionalEncrypt,
							ConvOptionList,
							PGPOLastOption( prds->context ) ),
						PGPOLastOption( prds->context ) );

			PGPFreeOptionList(ConvOptionList);
		}
	}

	if( IsntPGPError( err ) && ( haveFileOptions ))
	{
		err = PGPAppendOptionList( rdoptionList,
				PGPOUIDialogOptions( prds->context,
					optionList,
					PGPOLastOption( prds->context ) ),
				PGPOLastOption( prds->context ) );
	}

	if( IsntPGPError( err ))
	{
		PGPOptionListRef ksup;

		// Create Option List for keyservers in case something
		// goes wrong in the parsing
		ksup=PGPOUIKeyServerUpdateParams(prds->context,
				apref.numKSEntries,
				apref.serverList, prds->tlsContext,
				apref.synchUnknown,&foundKeys,
				PGPOLastOption( prds->context ) );

		if(ksup==(PGPOptionListRef)(-3L))
		{
			err=kPGPError_BadParams;

			PGPclMessageBox(prds->hwndParent,
					IDS_CAPTIONINFO,IDS_ERRORPARSINGKEYSERVERS,
					MB_OK|MB_ICONSTOP);
		}
		else
		{
			err = PGPBuildOptionList( prds->context, &ksupoptionList,
				ksup,
				PGPOLastOption( prds->context ) );
		}
	}

	// Call recipient dialog
	if( IsntPGPError( err ))
	{
/*		Test for the options dialog. Leave commented out.
		err=PGPOptionsDialog(prds->context,
			optionList,
			PGPOLastOption( prds->context ));
*/
		err=PGPRecipientDialog(prds->context,
			prds->keydbOriginal,
			(unsigned char)(dwDisableFlags&kPGPclDisableAutoMode),
			&(prds->keydbSelected),
			rdoptionList,
			PGPOUIParentWindowHandle(prds->context,prds->hwndParent),
			PGPOUIWindowTitle(prds->context,prds->szTitle),
			PGPOUIDisplayMarginalValidity( prds->context,
				apref.showMarginalValidity ),
			PGPOUIIgnoreMarginalValidity( prds->context,
				apref.marginalIsInvalid ),
			ksupoptionList,
			PGPOUIEnforceAdditionalRecipientRequests( prds->context,
				arrEnforcement, apref.bWarnOnADK ),
			PGPOLastOption( prds->context ) );

		// If we had options, read the results and send em back
		if( IsntPGPError( err ) && haveFileOptions )
		{
			prds->dwOptions&=(~kPGPclASCIIArmor);

			if( textOutput != 0 )
				prds->dwOptions |= kPGPclASCIIArmor;

			prds->dwOptions&=(~kPGPclInputIsText);

			if( inputIsText != 0 )
				prds->dwOptions |= kPGPclInputIsText;

			prds->dwOptions&=(~kPGPclPassOnly);

			if( conventionalEncrypt != 0 )
				prds->dwOptions |= kPGPclPassOnly;

			prds->dwOptions&=(~kPGPclWipeOriginal);

			if( wipeOriginal != 0 )
				prds->dwOptions |= kPGPclWipeOriginal;

			prds->dwOptions&=(~kPGPclSecureViewer);

			if( fyeo != 0 )
				prds->dwOptions |= kPGPclSecureViewer;

			prds->dwOptions&=(~kPGPclSelfDecryptingArchive);

			if( sda != 0 )
				prds->dwOptions |= kPGPclSelfDecryptingArchive;
		}
	}

	if(apref.bKeyserversInited)
	{
		CLUninitKeyServerPrefs(kPGPclDefaultServer,
			apref.pcss,apref.ksEntries,
			apref.serverList,apref.numKSEntries);
	}

	if(optionList)
		PGPFreeOptionList( optionList );

	if(rdoptionList)
		PGPFreeOptionList( rdoptionList );

	if(ksupoptionList)
		PGPFreeOptionList( ksupoptionList );

	if(pGroup)
		PGPclCloseGroupFile(pGroup);

	prds->keydbAdded=foundKeys;

	// Do some last minute checks
	if(IsntPGPError(err))
	{
		PGPCountKeysInKeyDB( prds->keydbSelected, &numKeys );

		if((numKeys==0)&&(!conventionalEncrypt)&&(!sda))
		{
			PGPclMessageBox(prds->hwndParent,
					IDS_CAPTIONINFO,IDS_ATLEASTONEORCONV,
					MB_OK|MB_ICONINFORMATION);
			return FALSE;
		}

		// Check to make sure they have encrypted to
		// themselves if WIPEORIG is checked.
		if((prds->dwOptions&kPGPclWipeOriginal)&&
			((prds->dwOptions&kPGPclPassOnly)==0)&&
			((prds->dwOptions&kPGPclSelfDecryptingArchive)==0))
		{
			if(!DefaultKeyCheck(prds->hwndParent,
				apref.defaultKey,
				prds->keydbSelected))
			{
				int msgrst;

				LoadString (g_hInst, IDS_CAPTIONWARNING,
					StrRes1, sizeof(StrRes1));
				LoadString (g_hInst, IDS_WIPEWODEFAULT,
					StrRes2, sizeof(StrRes2));

				msgrst=MessageBox(prds->hwndParent,StrRes2,StrRes1,
					MB_YESNO|MB_ICONEXCLAMATION|MB_SETFOREGROUND);

				if(msgrst==IDNO)
					return FALSE;
			}
		}

		prds->dwFlags&=(~kPGPclRSAEncrypt);

		// So passphrase dialog can check for DSS/RSA combo
		if(RSACheck(prds->hwndParent,
			prds->keydbSelected))
		{
			prds->dwFlags |= kPGPclRSAEncrypt;
		}

// ******************BUSINESS SECURITY***********************
		if(PGPlnEnterprise())
		{
			/*
			if((apref.WarnNotCorpSigned)&&(!conventionalEncrypt))
			{
				if(!CorpCheck(prds->hwndParent,
					prds->keydbOriginal,
					prds->keydbSelected,
					apref.corpKey))
					err=kPGPError_UserAbort;
			}*/
			if((!(apref.allowInvalidEncrypt))&&(!conventionalEncrypt))
			{
				if(!InvalidCheck(prds->hwndParent,
					prds->keydbOriginal,
					prds->keydbSelected))
				{
					EncryptingToInvalidKeys(prds->hwndParent);
					err=kPGPError_UserAbort;
				}
			}
		}
// ******************END BUSINESS SECURITY*******************
	}

	if(IsPGPError(err))
		return FALSE;

	return TRUE;
}
