/*____________________________________________________________________________
		Copyright (C) 2002 PGP Corporation
        All rights reserved.

        $Id: DllMain.cpp,v 1.4 2002/08/06 20:09:22 dallen Exp $
____________________________________________________________________________*/

#include "pgpClassesConfig.h"

#include "CPFLImpFactoryWin32.h"
#include "UModuleInstance.h"

#include "CInstallHelper.h"

_USING_PGP

_UNNAMED_BEGIN

// Constants

#define PGPdiskIHExport __declspec(dllexport) __stdcall

_UNNAMED_END

// Dll functions

PGPBoolean 
PGPdiskIHInitDll()
{
	try
	{
		CPFLImpFactoryWin32::CreateInstance();
		return TRUE;
	}
	catch (CComboError&)
	{
		return FALSE;
	}
}

void 
PGPdiskIHCleanupDll()
{
	try
	{
		CPFLImpFactoryWin32::DestroyInstance();
	}
	catch (CComboError&) { }
}

BOOL 
WINAPI 
DllMain(HINSTANCE hInstDll, DWORD dwReason, LPVOID lpvReserved)
{
	switch (dwReason)
	{
	case DLL_PROCESS_ATTACH:
		UModuleInstance::Set(hInstDll);
		break;

	case DLL_PROCESS_DETACH:
	case DLL_THREAD_ATTACH:
	case DLL_THREAD_DETACH:
		break;

	default:
		pgpAssert(FALSE);
		break;
	}

	return TRUE;
}


// Exported functions

extern "C" 
void 
PGPdiskIHExport 
KillPGPdiskResident()
{
	PGPdiskIHInitDll();
	
	try
	{
		CInstallHelper	installHelper;
		installHelper.KillPGPdiskResident();
	}
	catch (CComboError&) { }

	PGPdiskIHCleanupDll();
}

extern "C" 
void 
PGPdiskIHExport 
PGPdiskCleanup()
{
	PGPdiskIHInitDll();
	
	try
	{
		CInstallHelper	installHelper;
		installHelper.PGPdiskCleanup();
	}
	catch (CComboError&) { }

	PGPdiskIHCleanupDll();
}

extern "C" 
BOOL 
PGPdiskIHExport 
AreAnyPGPdisksMounted()
{
	BOOL	result	= FALSE;
	PGPdiskIHInitDll();
	
	try
	{
		CInstallHelper	installHelper;
		result =  installHelper.AreAnyPGPdisksMounted();
	}
	catch (CComboError&) { }

	PGPdiskIHCleanupDll();

	return result;
}

extern "C" 
BOOL 
PGPdiskIHExport 
IsVolumeAPGPdisk(int drive)
{
	BOOL	result	= FALSE;
	PGPdiskIHInitDll();
	
	try
	{
		CInstallHelper	installHelper;
		result = installHelper.IsVolumeAPGPdisk(drive);
	}
	catch (CComboError&) { }

	PGPdiskIHCleanupDll();

	return result;
}

extern "C" 
BOOL 
PGPdiskIHExport 
UnmountAllPGPdisks()
{
	BOOL	result	= FALSE;
	PGPdiskIHInitDll();
	
	try
	{
		CInstallHelper	installHelper;
		installHelper.UnmountAllPGPdisks();

		result = TRUE;
	}
	catch (CComboError&) { }

	PGPdiskIHCleanupDll();

	return result;
}

extern "C" 
void 
PGPdiskIHExport 
PGPdiskPostInstall()
{
}
