/*____________________________________________________________________________
		Copyright (C) 2002 PGP Corporation
        All rights reserved.

        $Id: CCommandClaimer.h,v 1.6 2002/08/06 20:09:23 dallen Exp $
____________________________________________________________________________*/

#ifndef Included_CCommandClaimer_h	// [
#define Included_CCommandClaimer_h

#include "CNamedMutex.h"

#include "CSharedMemory.h"
#include "CSubsystem.h"

_PGP_BEGIN

// Class CCommandClaimer

class CCommandClaimer : public CSubsystem
{
	friend class CUISubsystemsWin32;

public:
	enum CommandID
	{
		kChooseDisk, 
		kMountDisk, 
		kMountStartupDisks, 
		kUnmountDisk, 
		kUnmountAllDisks, 
		kEditDisk, 
		kCreateNewDisk, 
		kInvokeDeleteHook, 
		kShowDiskOptions
	};

private:
	enum {kMaxNumCommands = 20};

	struct CCCommandInfo;

private:
	CCommandClaimer() { }

public:
	void	ClaimCommand(CommandID commandID, const char *pathOrRoot = NULL);
	void	ReleaseCommand(CommandID commandID, const char *pathOrRoot);

private:
	CNamedMutex		mCommandsMutex;
	CSharedMemory	mCommands;

	void	Startup();
	void	Shutdown() { }

	PGPBoolean	AreCommandsSimilar(const CCCommandInfo& cmd1, 
		const CCCommandInfo& cmd2) const;
	PGPUInt32	MakeCRCFromString(const char *str) const;

	static BOOL CALLBACK	ShowFirstVisibleWndFunc(HWND hwnd, LPARAM lParam);
};

_PGP_END

#endif	// ] Included_CCommandClaimer_h
