/*____________________________________________________________________________
		Copyright (C) 2002 PGP Corporation
        All rights reserved.

        $Id: CConfirmPassphraseDialog.h,v 1.4 2002/08/06 20:09:23 dallen Exp $
____________________________________________________________________________*/

#ifndef Included_CConfirmPassphraseDialog_h	// [
#define Included_CConfirmPassphraseDialog_h

#include "CButton.h"
#include "CDialog.h"
#include "CPath.h"
#include "CProgressBar.h"
#include "CSecureRichEdit.h"
#include "CStatic.h"

#include "CInfoBar.h"

_PGP_BEGIN

// Types

class CPGPdiskContext;


// Class CConfirmPassphraseDialog

class CConfirmPassphraseDialog : public CDialog
{
public:
	CConfirmPassphraseDialog() : mIHadFocus(NULL) { }
	~CConfirmPassphraseDialog() { }

	PGPUInt16	GetDialogId() const;

	const CSecureString&	Passphrase() const
	{
		return mPassphraseEdit.Contents();
	}

	void	AskPassphrase(const CPGPdiskContext& context, HWND parentWnd, 
		const char *passText, const char *passSubString);

private:
	CButton			mHideTypingCheck;
	CInfoBar		mCapsLockBar;
	CProgressBar	mMinQualityBar;
	CProgressBar	mQualityBar;
	CSecureRichEdit	mPassphraseEdit;
	CSecureRichEdit	mConfirmEdit;
	CStatic			mMessageText;
	CStatic			mMinQualityText;
	CStatic			mPhraseLengthText;

	const CPGPdiskContext	*mPContext;
	
	CString	mFormatText;
	CString	mFormatSubString;

	PGPUInt32	mPixelMarginControl;
	PGPUInt32	mPixelMarginDialog;

	PGPBoolean	mEnforceMinLength;
	PGPBoolean	mEnforceMinQuality;
	PGPUInt32	mMinPassLength;
	PGPUInt32	mMinPassQuality;

	CSecureRichEdit	*mIHadFocus;

	void	CreateCapsLockBar();
	void	InitControls();
	void	InitDialogText();
	void	InitQualityPrefs();
	void	UpdatePassphraseQuality();

	void	SetCapsLockMessageState();
	void	WarnCapsLock(PGPBoolean warn);

	void	OnHideTypeCheck();
	void	OnOk();

	BOOL		OnCommand(PGPUInt16 notifyCode, PGPUInt16 itemId, HWND ctrl);
	void		OnContextMenu(HWND menuWnd, CPoint coords);
	void		OnHelp(HELPINFO *pInfo);
	BOOL		OnInitDialog(HWND focusCtrl);
	void		OnKeyUp(PGPUInt32 vKey, PGPUInt32 keyData);
	PGPUInt32	OnSecureEditEvent(HWND view, PGPUInt32 event);
	
	PGPBoolean	PreProcess(const CMessage& msg, LRESULT& result);
};

_PGP_END

#endif	// ] Included_CConfirmPassphraseDialog_h
