/*____________________________________________________________________________
		Copyright (C) 2002 PGP Corporation
        All rights reserved.

        $Id: CInfoBar.h,v 1.3 2002/08/06 20:09:23 dallen Exp $
____________________________________________________________________________*/

#ifndef Included_CInfoBar_h	// [
#define Included_CInfoBar_h

#include "CString.h"

#include "CBrush.h"
#include "CFont.h"
#include "CIcon.h"
#include "CList.h"
#include "CPen.h"
#include "CPoint.h"
#include "CWindow.h"

_PGP_BEGIN

// Class CInfoBar

class CInfoBar : public CWindow
{
public:
	enum InfoBarIcon {kInfoIcon, kStopIcon};

private:
	struct LineInfo;

public:
	CInfoBar() { }
	CInfoBar(HWND hWnd) : CWindow(hWnd) { }
	~CInfoBar() { }

	PGPInt32	NumLines() const {return mLines.Count();}
	PGPUInt32	Height() const;

	PGPUInt32		GetIdOfIndex(PGPInt32 index) const;
	PGPInt32		GetIndexOfId(PGPUInt32 id) const;
	const char *	GetStringAtIndex(PGPInt32 index) const;

	void	SetIcon(InfoBarIcon icon);

	void	AddString(PGPInt32 index, const char *string, PGPUInt32 id = 0);
	void	RemoveString(PGPInt32 index);

	void	Create(HINSTANCE instance, HWND parent, CPoint origin, 
		PGPUInt32 width, PGPBoolean showIcon = TRUE);

	void	Empty();
	void	ResizeRedraw();

	static void	InitClass();
	static void	CleanupClass();

private:
	CBrush	mBackBrush;
	CFont	mInfoFont;
	CIcon	mInfoIcon;
	CPen	mBorderPen;

	CList<LineInfo>	mLines;

	HINSTANCE	mInstance;
	PGPBoolean	mShowIcon;

	PGPUInt32	mWidth;
	PGPUInt32	mLineHeight;
	PGPUInt32	mTopMargin;
	PGPUInt32	mBottomMargin;
	PGPUInt32	mRightMargin;
	PGPUInt32	mLeftMargin;

	LineInfo *	GetAtIndex(PGPInt32 index) const;

	PGPInt32	OnCreate(LPCREATESTRUCT pCS);
	void		OnNcDestroy();
	void		OnPaint(HDC paintDC);
};

_PGP_END

#endif	// ] Included_CInfoBar_h
