/*____________________________________________________________________________
		Copyright (C) 2002 PGP Corporation
        All rights reserved.

        $Id: CNewUserPages.h,v 1.6 2002/08/06 20:09:23 dallen Exp $
____________________________________________________________________________*/

#ifndef Included_CNewUserPages_h	// [
#define Included_CNewUserPages_h

#include "CBitmap.h"
#include "CPalette.h"

#include "CPropertySheet.h"

_PGP_BEGIN

// Types

class CPGPdiskContext;
class CPGPdiskUser;
class CPGPdiskUserSet;
class CPGPKey;
class CSecureString;

class CNewUserAskChoicePage;
class CNewUserBadPassPage;
class CNewUserAskPassPage;
class CNewUserAskPubKeyPage;
class CPGPdiskPage;

// Class CNewUserPages

class CNewUserPages
{
public:
	struct PagesInfo;

public:
	CNewUserPages();
	~CNewUserPages();

	PGPBoolean	IsCreated() const {return mIsCreated;}

	// Add in this order!
	CPGPdiskPage *	GetAskChoicePage();
	CPGPdiskPage *	GetAskPassPage();
	CPGPdiskPage *	GetBadPassPage();
	CPGPdiskPage *	GetAskPubKeyPage();

	void	Create(const CPGPdiskContext *pContext, 
		const CPGPdiskUserSet *pDiskUsers, const char *title, 
		const char *msgWarnTitle, PGPBoolean singleSelect, 
		PGPBoolean isForAdminUser = FALSE, 
		PGPBoolean ignoreDiskADK = FALSE);

	void	GetChoices(PGPBoolean& userChosePub, CPGPKey* pubKey, 
		PGPUInt32& uNumPubKeys, CString& userName, CSecureString& securePass, PGPBoolean &readOnly);

	void	Clear();

private:
	PGPBoolean	mIsCreated;
	PagesInfo	*mPInfo;

	CNewUserAskChoicePage	*mPAskChoicePage;
	CNewUserAskPassPage		*mPAskPassPage;
	CNewUserBadPassPage		*mPBadPassPage;
	CNewUserAskPubKeyPage	*mPAskPubKeyPage;

	void	PreCalcKeysToChoose();
};

_PGP_END

#endif	// ] Included_CNewUserPages_h
