/*____________________________________________________________________________
		Copyright (C) 2002 PGP Corporation
        All rights reserved.

        $Id: CPGPKeyPicker.h,v 1.3 2002/08/06 20:09:23 dallen Exp $
____________________________________________________________________________*/

#ifndef Included_CPGPKeyPicker_h	// [
#define Included_CPGPKeyPicker_h

#include "CDialog.h"
#include "CStatic.h"

#include "CPublicKeysView.h"

_PGP_BEGIN

// Types

class CPGPdiskContext;
class CPGPKeySet;


// Class CPGPKeyPicker

class CPGPKeyPicker : public CDialog
{
public:
	CPGPKeyPicker();
	~CPGPKeyPicker();

	PGPUInt16	GetDialogId() const;

	void	Display(const CPGPdiskContext& context, HWND parent, 
		const char *title, const char *message, const CPGPKeySet& inKeys, 
		CPGPKeySet& pickedKeys, PGPBoolean singleSelect = FALSE);

private:
	CPublicKeysView	mKeysView;
	CStatic			mPickText;

	const CPGPdiskContext	*mPContext;
	const CPGPKeySet		*mPInKeys;
	CPGPKeySet				*mPPickedKeys;

	const char	*mTitle;
	const char	*mMessage;
	PGPBoolean	mSingleSelect;

	void	InitControls();
	void	InitDialogText();
	void	OnOk();

	void		OnContextMenu(HWND menuWnd, CPoint coords);
	void		OnHelp(HELPINFO *pInfo);
	BOOL		OnInitDialog(HWND focusCtrl);
	PGPUInt32	OnNotify(PGPUInt16 ctrlId, LPNMHDR pNMHDR);
};

_PGP_END

#endif	// ] Included_CPGPKeyPicker_h
