/*____________________________________________________________________________
		Copyright (C) 2002 PGP Corporation
        All rights reserved.

        $Id: CPGPdiskCreatorImpWin32.cpp,v 1.6 2002/08/06 20:09:23 dallen Exp $
____________________________________________________________________________*/

#include "pgpClassesConfig.h"

#include "CMessageBox.h"
#include "CPath.h"
#include "CWindow.h"
#include "USecurity.h"
#include "UWinVersion.h"

#include "PGPdiskEngine.h"
#include "UCommonStrings.h"

#include "CNewDiskWizard.h"
#include "CPGPdiskCreatorImpWin32.h"
#include "SClaimedCommand.h"

_USING_PGP

// Class CPGPdiskCreatorImpWin32 member functions

void 
CPGPdiskCreatorImpWin32::AskCreate(
	const CPGPdiskContext&	context, 
	const char				*defaultPath, 
	void					*parentWnd)
{
	// Need valid parent window.
	HWND	hwndParent	= static_cast<HWND>(parentWnd);

	if (IsNull(hwndParent))
		hwndParent = CWindow::GetDesktopWindow();

	SClaimedCommand	command(CCommandClaimer::kCreateNewDisk, NULL);

	// not from a remote terminal you don't
	if (USecurity::IsRemoteSession())
	{
		using namespace UCommonStrings;

		CMessageBox	msgBox;
		msgBox.Display(Get(kTellCantCreateInWin2kTerm), 
			Get(kGenericMsgBoxTitle));

		THROW_PGPERROR(kPGPError_UserAbort);
	}

	// Invoke the wizard.
	CNewDiskWizard	newDiskWizard;
	newDiskWizard.Display(context, defaultPath, hwndParent);
}
