/*____________________________________________________________________________
		Copyright (C) 2002 PGP Corporation
        All rights reserved.

        $Id: CPassphraseDialog.h,v 1.8 2002/08/06 20:09:24 dallen Exp $
____________________________________________________________________________*/

#ifndef Included_CPassphraseDialog_h	// [
#define Included_CPassphraseDialog_h

#include "CButton.h"
#include "CDialog.h"
#include "CPath.h"
#include "CSecureRichEdit.h"
#include "CStatic.h"

#include "CInfoBar.h"

_PGP_BEGIN

// Types

class CPGPdiskContext;
class CPGPdiskDisk;
class CPGPdiskUser;
class CPGPdiskUserSet;
class CPGPKeySet;


// Class CPassphraseDialog

class CPassphraseDialog : public CDialog
{
public:
	CPassphraseDialog();
	~CPassphraseDialog() { }

	PGPUInt16	GetDialogId() const;

	const CSecureString&	Passphrase() const;
	PGPBoolean				ReadOnly() const;
	const char *			Root() const;

	void	AskForPassphrase(const CPGPdiskDisk& disk, 
		const CPGPdiskUserSet& userSet, HWND parentWnd, 
		CPGPdiskUser& matchingUser, const char *formatText, 
		const char *formatSubString, PGPBoolean showOptions = FALSE, 
		PGPBoolean defaultRO = FALSE, PGPBoolean forceRO = FALSE);

private:
	CButton		mCancelButton;
	CButton		mHideTypingCheck;
	CButton		mJoinButton;
	CButton		mOkButton;
	CButton		mOptionsButton;
	CInfoBar	mInfoBar1;
	CInfoBar	mInfoBar2;
	CStatic		mCaptionText;
	CStatic		mMessageText;
	CSecureRichEdit	mPassphraseEdit;

	PGPUInt32	mCurHeightInfoBar1;

	const CPGPdiskDisk		*mPDisk;
	const CPGPdiskContext	*mPContext;
	const CPGPdiskUserSet	*mPDiskUsers;
	CPGPdiskUser			*mPUser;

	CPGPKeySet	*mPSplitKeys;

	CString	mFormatText;
	CString	mFormatSubString;

	PGPBoolean	mForceRO;
	PGPBoolean	mChoseRO;
	PGPBoolean	mShowOptions;

	PGPUInt8	mDrive;
	CPath		mMountPoint;
	PGPBoolean	mChoseDrive;

	CPath		mRoot;

	void	PrepareDriveCombo();
	void	PrepareInfoBars();
	void	PrepareJoinButton();
	void	PrepareDialogText();

	void	Resize();
	void	Wiggle();

	void	TellBadPassphrase(PGPBoolean warn);
	void	WarnCapsLock(PGPBoolean warn);
	void	SetCapsLockMessageState();

	void		JoinAKey();
	PGPBoolean	ValidatePassphrase();
	PGPBoolean	ValidateJoinedPassphrase(PGPByte *pPassphrase,
		PGPUInt32 length);

	void	OnHideTypeCheck();
	void	OnJoinButton();
	void	OnOk();
	void	OnOptionsButton();

	BOOL		OnCommand(PGPUInt16 notifyCode, PGPUInt16 itemId, HWND ctrl);
	void		OnContextMenu(HWND menuWnd, CPoint coords);
	void		OnHelp(HELPINFO *pInfo);
	BOOL		OnInitDialog(HWND focusCtrl);
	void		OnKeyUp(PGPUInt32 vKey, PGPUInt32 keyData);
	void		OnNcDestroy();
	PGPUInt32	OnSecureEditEvent(HWND view, PGPUInt32 event);
	
	PGPBoolean	PreProcess(const CMessage& msg, LRESULT& result);
};

_PGP_END

#endif	// ] Included_CPassphraseDialog_h
