/*____________________________________________________________________________
		Copyright (C) 2002 PGP Corporation
        All rights reserved.

        $Id: CRandomDataPage.h,v 1.5 2002/08/06 20:09:24 dallen Exp $
____________________________________________________________________________*/

#ifndef Included_CRandomDataPage_h	// [
#define Included_CRandomDataPage_h

#include "CProgressBar.h"

#include "pgpDiskPubTypes.h"
#include "CPercentDone.h"
#include "CPGPdiskPage.h"

_PGP_BEGIN

// Types

class CPGPGlobalRandomPool;


// Class CRandomDataPage

class CRandomDataPage : public CPGPdiskPage
{
public:
	CRandomDataPage::CRandomDataPage(
		const PGPdiskEncryptionAlgorithm *pAlgorithm, 
		CPGPGlobalRandomPool *pRandomPool) : 
	
		mPAlgorithm(pAlgorithm), mPRandomPool(pRandomPool)
	{
		pgpAssertAddrValid(pAlgorithm, PGPdiskEncryptionAlgorithm);
		pgpAssertAddrValid(pRandomPool, CPGPGlobalRandomPool);
	}

	CRandomDataPage::~CRandomDataPage()
	{
	}

	PGPUInt16	GetDialogId() const;
	
private:
	const PGPdiskEncryptionAlgorithm	*mPAlgorithm;
	CPGPGlobalRandomPool				*mPRandomPool;

	CPercentDone	mRandomPercent;
	CProgressBar	mRandomBar;

	PGPUInt32	mEntropyNeeded;
	PGPBoolean	mBegunGathering;
	PGPBoolean	mCheated;

	static LRESULT CALLBACK	KeyboardHook(INT iCode, WPARAM wParam, 
		LPARAM lParam);

	DWORD	GetPageHelpId() const;
	PVOID	GetPageHelpIds() const;

	void	ProcessChar(unsigned char Char);
	void	SetDoneCollecting();
	void	UpdateBar();

	BOOL		OnInitDialog(HWND focusCtrl);
	void		OnLButtonDown(PGPUInt32 keyFlags, CPoint coords);
	void		OnMouseMove(PGPUInt32 keyFlags, CPoint coords);
	PGPBoolean	OnPsnKillActive();
	PGPInt32	OnPsnSetActive();
};

_PGP_END

#endif	// ] Included_CRandomDataPage_h
