/*____________________________________________________________________________
		Copyright (C) 2002 PGP Corporation
        All rights reserved.

        $Id: CUISubsystemsWin32.cpp,v 1.2 2002/08/06 20:09:24 dallen Exp $
____________________________________________________________________________*/

#include "pgpClassesConfig.h"

#include "CCommandClaimer.h"
#include "CUISubsystemsWin32.h"
#include "CWindowRegistrar.h"

_USING_PGP

// Class CUISubsystemsWin32 generated member functions

DEFINE_SINGLETON_NEWDELFUNCS(CUISubsystemsWin32)

DEFINE_SUBSYSTEM(CCommandClaimer, CUISubsystemsWin32, CommandClaimer)
DEFINE_SUBSYSTEM(CWindowRegistrar, CUISubsystemsWin32, WindowRegistrar)

void 
CUISubsystemsWin32::CreateSubsystemsAux()
{
	try
	{
		CUISubsystems::CreateSubsystemsAux();

		CALL_MAKE_SUBSYSTEM(WindowRegistrar);
		CALL_MAKE_SUBSYSTEM(CommandClaimer);
	}
	catch (CComboError&)
	{
		CUISubsystems::DestroySubsystemsAux();
		throw;
	}
}

void 
CUISubsystemsWin32::DestroySubsystemsAux()
{
	try
	{
		CALL_DESTROY_SUBSYSTEM(CommandClaimer);
		CALL_DESTROY_SUBSYSTEM(WindowRegistrar);

		CUISubsystems::DestroySubsystemsAux();
	}
	catch (CComboError&) { }
}
