/*____________________________________________________________________________
		Copyright (C) 2002 PGP Corporation
        All rights reserved.

        $Id: SClaimedCommand.h,v 1.3 2002/08/06 20:09:24 dallen Exp $
____________________________________________________________________________*/

#ifndef Included_SClaimedCommand_h	// [
#define Included_SClaimedCommand_h

#include "CCommandClaimer.h"
#include "CUISubsystemsWin32.h"

_PGP_BEGIN

// Class SClaimedCommand

class SClaimedCommand
{
	NOT_COPYABLE(SClaimedCommand)

public:
	SClaimedCommand(CCommandClaimer::CommandID commandID, 
		const char *pathOrRoot = NULL);
	~SClaimedCommand();

	CCommandClaimer::CommandID	CommandID() const {return mCommandID;}
	const char *				PathOrRoot() const {return mPathOrRoot;}

private:
	CCommandClaimer::CommandID	mCommandID;
	const char					*mPathOrRoot;
};


// Class SClaimedCommand member functions

inline 
SClaimedCommand::SClaimedCommand(
	CCommandClaimer::CommandID	commandID, 
	const char *				pathOrRoot) : 

	mCommandID(commandID), mPathOrRoot(pathOrRoot)
{
	CUISubsystemsWin32::CommandClaimer().ClaimCommand(mCommandID, 
		mPathOrRoot);
}

inline 
SClaimedCommand::~SClaimedCommand()
{
	try
	{
		CUISubsystemsWin32::CommandClaimer().ReleaseCommand(mCommandID, 
			mPathOrRoot);
	}
	catch (CComboError&) { }
}

_PGP_END

#endif	// ] Included_SClaimedCommand_h
