/*____________________________________________________________________________
		Copyright (C) 2002 PGP Corporation
        All rights reserved.

        $Id: UEditMount.h,v 1.4 2002/08/06 20:09:24 dallen Exp $
____________________________________________________________________________*/

#ifndef Included_UEditMount_h	// [
#define Included_UEditMount_h

_PGP_BEGIN

// Types

class CPath;
class CPGPdiskContext;
class CPGPdiskDisk;


// UEditMount functions

namespace UEditMount
{
	PGPBoolean	ShouldWeForceReadOnly(const CPath& path, HWND parentWnd);

	void	GetStartupPathArray(const char *pathGlob, 
		CArray<CPath>& pathArray, PGPUInt32& numPaths);
	void	MakeStartupPathGlob(const CArray<CPath>& pathArray, 
		PGPUInt32 numPaths, CString& pathGlob);

	PGPBoolean	IsDiskMarkedForStartup(const CPGPdiskContext& context, 
		const char *path);
	void		MarkDiskForStartup(const CPGPdiskContext& context, 
		const char *path);
	void		UnmarkDiskForStartup(const CPGPdiskContext& context, 
		const char *path);

	PGPBoolean	CheckWarnCanModifyDisk(const CPGPdiskContext& context, 
		const CPath& path, HWND parentWnd, const char *msgBoxTitle);

	void	DetectAndHandleInProgressReEncrypts(
		const CPGPdiskContext& context, CPGPdiskDisk& disk, 
		const CPath& path, HWND parentWnd);

	void	DetectAndHandleOldPGPdisks(const CPGPdiskContext& context, 
		CPGPdiskDisk& disk, const CPath& path, HWND parentWnd, 
		PGPBoolean& forceReadOnly);

	void	DetectAndHandleWipedPGPdisks(const CPGPdiskContext& context, 
		CPGPdiskDisk& disk, const CPath& path, HWND parentWnd);
};

_PGP_END

#endif	// ] Included_UEditMount_h
