/*____________________________________________________________________________
		Copyright (C) 2002 PGP Corporation
        All rights reserved.

        $Id: CCommandLine.h,v 1.2 2002/08/06 20:09:30 dallen Exp $
____________________________________________________________________________*/

#ifndef Included_CCommandLine_h	// [
#define Included_CCommandLine_h

#include "CArray.h"
#include "CList.h"
#include "CString.h"

_PGP_BEGIN

// Types

class CParameter;

// Class CCommandLine

class CCommandLine
{
public:
	struct Rule
	{
		const char	*command;
		const char	*validOptions;
		PGPUInt32	minArgs;
		PGPUInt32	maxArgs;
	};

public:
	CCommandLine();
	CCommandLine(const char *cmdLine, Rule *pRules, PGPUInt32 numRules);
	~CCommandLine();

	void	AllowCatchAll(PGPBoolean allow, Rule& catchAllRule);

	PGPBoolean	Parse(const char *& command, CArray<char>& options, 
		PGPUInt32& numOptions, CArray<const char *>& args, 
		PGPUInt32& numArgs);

	void	Init(const char *cmdLine, Rule *pRules, PGPUInt32 numRules);
	void	Clear();

private:
	CList<CParameter>	mParams;
	CParameter			*mPCurParam;
	
	CArray<Rule>	mRules;
	PGPUInt32		mNumRules;

	PGPBoolean	mAllowCatchAll;
	Rule		mCatchAllRule;
};

_PGP_END

#endif	// Included_CCommandLine_h
