/*____________________________________________________________________________
		Copyright (C) 2002 PGP Corporation
        All rights reserved.

        $Id: CDcb.cpp,v 1.2 2002/08/06 20:09:30 dallen Exp $
____________________________________________________________________________*/

#include "pgpClassesConfig.h"

#include "CDcb.h"
#include "CDriverSubsystemsDrv98.h"
#include "CIosInterface.h"

_USING_PGP

// Class CDcb member functions

CDcb::~CDcb()
{
	if (WeCreated())
		Destroy();
}

CComboError 
CDcb::GetDcbOfDrive(PGPUInt8 drive)
{
	CComboError	error;
	mDcb = CDriverSubsystemsDrv98::IosInterface().IspGetDcb(drive);

	if (IsNull(mDcb))
		error.pgpErr = kPGPError_VolumeOpFailed;

	return error;
}

CComboError 
CDcb::Create()
{
	pgpAssert(!WeCreated());

	CComboError	error;

	if (IsNull(mDcb = new DCB))
		error.pgpErr = kPGPError_OutOfMemory;

	if (error.IsntError())
	{
		mWeCreated = TRUE;

		pgpClearMemory(mDcb, sizeof(DCB));
		Sig() = kDcbSignature;
	}

	return error;
}

void 
CDcb::Destroy()
{
	pgpAssert(WeCreated());

	delete mDcb;
	mDcb = NULL;

	mWeCreated = FALSE;
}
