/*____________________________________________________________________________
		Copyright (C) 2002 PGP Corporation
        All rights reserved.

        $Id: CDiskInactivityImpDrv98.cpp,v 1.4 2002/08/06 20:09:30 dallen Exp $
____________________________________________________________________________*/

#include "pgpClassesConfig.h"
#include "CDiskInactivityImpDrv98.h"

_USING_PGP

_UNNAMED_BEGIN

// Constants

static const char	*kPGPsdkDriverName	= "PGPSDK  ";

_UNNAMED_END


// Class CDiskInactivityImpDrv98 member functions

CComboError 
CDiskInactivityImpDrv98::AttachToDriver()
{
	CComboError	error;

	if (IsNull(mPGPsdkDDB))
	{
		mPGPsdkDDB = Get_DDB(0, const_cast<char *>(kPGPsdkDriverName));

		if (IsNull(mPGPsdkDDB))
			error.pgpErr = kPGPError_SyncObjOpFailed;
	}

	return error;
}

CComboError 
CDiskInactivityImpDrv98::SendInactivityCommand(
	PGPINACTIVITYSTRUCT&	pgpIS) const
{
	CComboError	error;

	Directed_Sys_Control(mPGPsdkDDB, kPGPUDControl_Inactivity, 0, 0, 
		reinterpret_cast<ULONG>(&pgpIS), 0);

	error.pgpErr = pgpIS.ulError;

	return error;
}

void 
CDiskInactivityImpDrv98::Shutdown()
{
	mPGPsdkDDB = NULL;
}
