/*____________________________________________________________________________
		Copyright (C) 2002 PGP Corporation
        All rights reserved.

        $Id: CDriverSubsystemsDrv98.cpp,v 1.3 2002/08/06 20:09:30 dallen Exp $
____________________________________________________________________________*/

#include "pgpClassesConfig.h"

#include "CFilesystemWatcher.h"
#include "CIosInterface.h"
#include "CDriverSubsystemsDrv98.h"

_USING_PGP

// Class CDriverSubsystemsDrv98 member functions

DEFINE_SINGLETON_NEWDELFUNCS(CDriverSubsystemsDrv98)

DEFINE_SUBSYSTEM(CFilesystemWatcher, CDriverSubsystemsDrv98, 
	FilesystemWatcher)
DEFINE_SUBSYSTEM(CIosInterface, CDriverSubsystemsDrv98, IosInterface)

CComboError 
CDriverSubsystemsDrv98::CreateSubsystemsAux()
{
	CComboError	error;

	error = CDriverSubsystems::CreateSubsystemsAux();

	CALL_MAKE_SUBSYSTEM(FilesystemWatcher);

	// Do IOS last since it isn't undoable.
	CALL_MAKE_SUBSYSTEM(IosInterface);

	if (error.IsError())
		DestroySubsystemsAux();

	return error;
}

void 
CDriverSubsystemsDrv98::DestroySubsystemsAux()
{
	CDriverSubsystems::DestroySubsystemsAux();

	CALL_DESTROY_SUBSYSTEM(FilesystemWatcher);
	CALL_DESTROY_SUBSYSTEM(IosInterface);
}
