/*____________________________________________________________________________
		Copyright (C) 2002 PGP Corporation
        All rights reserved.

        $Id: CIosInterface.h,v 1.4 2002/08/06 20:09:30 dallen Exp $
____________________________________________________________________________*/

#ifndef Included_CIosInterface_h	// [
#define Included_CIosInterface_h

#include "CSubsystem.h"
#include "CIop.h"

_PGP_BEGIN

// Class CIosInterface

class CIosInterface : public CSubsystem
{
	friend class CDriverSubsystemsDrv98;

private:
	CIosInterface() : mIlbRef(*mIlb) { }

public:
	PIOP		IlbDequeueIop(PDCB pDcb) const;
	VOID		IlbEnqueueIop(PIOP pIop, PDCB pDcb) const;
	VOID		IlbInternalRequest(PIOP pIop, PDCB pDcb, 
		void *calldown) const;
	PGPBoolean	IlbIntIoCriteria(PIOP pIop) const;
	PGPBoolean	IlbIoCriteria(PIOR pIor) const;
	PGPUInt32	IlbService(PISP pIsp) const;
	VOID		IlbWait10thSec() const;

	DWORD		IrsGetDriveInfo(PGPUInt8 drive) const;
	PGPBoolean	IrsIsDriveCompressed(PGPUInt8 drive, 
		PGPUInt8& hostDrive) const;

	PGPBoolean	IspAssociateDcb(PDCB pDcb, PGPUInt8 drive, 
		PGPUInt8 flags) const;
	PDDB		IspCreateDdb(PGPUInt16 size, PGPUInt8 flags) const;
	PIOP		IspCreateIop(PGPUInt16 size, PGPUInt32 delta, 
		PGPUInt8 flags, PIOP pIop = NULL) const;	
	PGPBoolean	IspDeallocMem(void *pMem) const;
	PGPBoolean	IspDisassociateDcb(PGPUInt8 drive) const;
	PGPUInt8	IspDriveLetterPick(PDCB pDcb, PGPUInt8 flags) const;
	PDCB		IspGetDcb(PGPUInt8 drive) const;
	PGPBoolean	IspInsertCalldown(PDCB pDcb, void *req, PGPUInt16 expan, 
		PGPUInt32 flags) const;
	void *		IspAllocMem(PGPUInt16 memsize, PGPUInt8 flags) const;

	void	ProcessAep(PAEP pAep);
	
private:
	PDRP		mDrp;
	PILB		mIlb;
	PDDB		mDdb;
	PGPUInt8	mLoadGroupNum;

	ILB&	mIlbRef;

	CComboError	Startup();
	void		Shutdown() { }

	PGPUInt16	AepDeviceInquiry(PAEP_inquiry_device pAEP);
	PGPUInt16	AepInitialize(PAEP_bi_init pAep);
	PGPUInt16	AepIopTimeout(PAEP_iop_timeout_occurred pAEP);
};

_PGP_END

#endif	// Included_CIosInterface_h
