/*____________________________________________________________________________
		Copyright (C) 2002 PGP Corporation
        All rights reserved.

        $Id: CDeviceCache.h,v 1.3 2002/08/06 20:09:31 dallen Exp $
____________________________________________________________________________*/

#ifndef Included_CDeviceCache_h	// [
#define Included_CDeviceCache_h

#include "CList.h"
#include "CLookasideList.h"
#include "CRMWOLock.h"
#include "CSubsystem.h"

_PGP_BEGIN

// Types

class CDevice;
class CUnicodeString;

// Class CDeviceCache

class CDeviceCache : public CSubsystem
{
	friend class CDriverSubsystemsDrvNT;

private:
	struct CachedCDeviceInfo;

private:
	CDeviceCache();

public:
	PGPBoolean	DoesEntryExist(const char *name) const;

	CComboError	CreateEntry(const char *name);
	void		DeleteEntry(const char *name);

	CComboError	SetEntryDevice(const char *name, CDevice *pDevice);
	CComboError	GetEntryDevice(const char *name, CDevice *&pDevice) const;

	CComboError	SetEntryVolId(const char *name, const CUnicodeString& volId);
	CComboError	GetEntryVolId(const char *name, CUnicodeString& volId) const;

	CComboError	SetEntryCurLink(const char *name, 
		const UNICODE_STRING& curLink);
	CComboError	GetEntryCurLink(const char *name, 
		CUnicodeString& curLink) const;

private:
	CLookasideList<CachedCDeviceInfo>	mCDIAllocator;
	CList<CachedCDeviceInfo>			mCDIList;
	mutable CRMWOLock					mCDILock;

	CComboError	Startup() {return CComboError();}
	void		Shutdown();

	CachedCDeviceInfo *	FindEntry(const char *name) const;
};

_PGP_END

#endif	// Included_CDeviceCache_h
