/*____________________________________________________________________________
		Copyright (C) 2002 PGP Corporation
        All rights reserved.

        $Id: CDiskInactivity.h,v 1.2 2002/08/06 20:09:34 dallen Exp $
____________________________________________________________________________*/

#ifndef Included_CDiskInactivity_h	// [
#define Included_CDiskInactivity_h

#include "CDriverImpFactory.h"
#include "CSubsystem.h"

_PGP_BEGIN

// Class CDiskInactivity

class CDiskInactivity : public CSubsystem
{
	DECLARE_IMPHOST(CDiskInactivity)
	friend class CDriverSubsystems;

public:
	typedef VOID (* InactivityCallbackFunc)(ULONG userVal);

public:
	CComboError	CreateInactivityTimer(PGPUInt32 seconds, 
		PGPBoolean repeating, InactivityCallbackFunc pfnCallback, 
		ULONG userVal, PGPUInt32& timerID);
	CComboError	DestroyInactivityTimer(PGPUInt32 timerID);

	CComboError	AttachToDriver();

private:
	CComboError	Startup();
	void		Shutdown();
};

_PGP_END

#endif	// Included_CDiskInactivity_h
