/*____________________________________________________________________________
		Copyright (C) 2002 PGP Corporation
        All rights reserved.

        $Id: CDriverImpFactory.h,v 1.2 2002/08/06 20:09:34 dallen Exp $
____________________________________________________________________________*/

#ifndef Included_CDriverImpFactory_h	// [
#define Included_CDriverImpFactory_h

#include "CImpFactory.h"

_PGP_BEGIN

// Types

class CDiskInactivityImp;
class CInterfaceImp;
class CMemoryLockerImp;
class CPGPdiskDriverImp;
class CPGPdiskHandlerImp;
class CPGPdiskImp;
class CVolumeImp;


// Class CDriverImpFactory

class CDriverImpFactory : public CErrorState
{
	NOT_COPYABLE(CDriverImpFactory)

	DECLARE_SINGLETON_VARIABLE(CDriverImpFactory)

	DECLARE_IMP_NEWFUNCS_PURE(CDiskInactivityImp, DiskInactivityImp);
	DECLARE_IMP_NEWFUNCS_PURE(CInterfaceImp, InterfaceImp);
	DECLARE_IMP_NEWFUNCS_PURE(CMemoryLockerImp, MemoryLockerImp);
	DECLARE_IMP_NEWFUNCS_PURE(CPGPdiskDriverImp, PGPdiskDriverImp);
	DECLARE_IMP_NEWFUNCS_PURE(CPGPdiskHandlerImp, PGPdiskHandlerImp);
	DECLARE_IMP_NEWFUNCS_PURE(CPGPdiskImp, PGPdiskImp);
	DECLARE_IMP_NEWFUNCS_PURE(CVolumeImp, VolumeImp);

public:
			CDriverImpFactory() { }
	virtual	~CDriverImpFactory() = 0 { }
};

_PGP_END

#endif	// Included_CDriverImpFactory_h
