/*____________________________________________________________________________
		Copyright (C) 2002 PGP Corporation
        All rights reserved.

        $Id: CDriverSubsystems.cpp,v 1.3 2002/08/06 20:09:34 dallen Exp $
____________________________________________________________________________*/

#include "pgpClassesConfig.h"

#include "CDiskInactivity.h"
#include "CDriverSubsystems.h"
#include "CInterface.h"
#include "CMemoryLocker.h"
#include "CPGPdiskDriver.h"
#include "CPGPdiskHandler.h"

_USING_PGP

// Class CDriverSubsystems member functions

DEFINE_SUBSYSTEM(CDiskInactivity, CDriverSubsystems, DiskInactivity)
DEFINE_SUBSYSTEM(CInterface, CDriverSubsystems, Interface)
DEFINE_SUBSYSTEM(CMemoryLocker, CDriverSubsystems, MemoryLocker)
DEFINE_SUBSYSTEM(CPGPdiskDriver, CDriverSubsystems, PGPdiskDriver)
DEFINE_SUBSYSTEM(CPGPdiskHandler, CDriverSubsystems, PGPdiskHandler)

CComboError 
CDriverSubsystems::CreateSubsystemsAux()
{
	CComboError	error;

	CALL_MAKE_SUBSYSTEM(PGPdiskDriver);
	CALL_MAKE_SUBSYSTEM(DiskInactivity);
	CALL_MAKE_SUBSYSTEM(Interface);
	CALL_MAKE_SUBSYSTEM(MemoryLocker);
	CALL_MAKE_SUBSYSTEM(PGPdiskHandler);

	if (error.IsError())
		DestroySubsystems();

	return error;
}

void 
CDriverSubsystems::DestroySubsystemsAux()
{
	CALL_DESTROY_SUBSYSTEM(PGPdiskHandler);
	CALL_DESTROY_SUBSYSTEM(MemoryLocker);
	CALL_DESTROY_SUBSYSTEM(DiskInactivity);
	CALL_DESTROY_SUBSYSTEM(Interface);
	CALL_DESTROY_SUBSYSTEM(PGPdiskDriver);
}
