/*____________________________________________________________________________
		Copyright (C) 2002 PGP Corporation
        All rights reserved.

        $Id: CPGPdisk.cpp,v 1.4 2002/08/06 20:09:34 dallen Exp $
____________________________________________________________________________*/

#include "pgpClassesConfig.h"

#include "CPGPdisk.h"
#include "CPGPdiskImp.h"

_USING_PGP

// Class CPGPdisk member functions

DEFINE_IMPHOST(CPGPdisk, PGPdiskImp, CDriverImpFactory)

PGPBoolean 
CPGPdisk::HasInactivityTimedOut() const
{
	return Imp()->HasInactivityTimedOut();
}

PGPBoolean 
CPGPdisk::IsMounted() const
{
	return Imp()->IsMounted();
}

PGPBoolean 
CPGPdisk::IsUnmounted() const
{
	return Imp()->IsUnmounted();
}

PGPBoolean 
CPGPdisk::IsReadOnly() const
{
	return Imp()->IsReadOnly();
}

const char * 
CPGPdisk::Path() const
{
	return Imp()->Path();
}

const char * 
CPGPdisk::Root() const
{
	return Imp()->Root();
}

const char * 
CPGPdisk::DeviceName() const
{
	return Imp()->DeviceName();
}

PGPUInt64 
CPGPdisk::TotalBlocks() const
{
	return Imp()->TotalBlocks();
}

PGPBoolean 
CPGPdisk::HasOpenFiles()
{
	return Imp()->HasOpenFiles();
}

void 
CPGPdisk::FlipContexts()
{
	Imp()->FlipContexts();
}

CComboError 
CPGPdisk::ValidateContexts()
{
	return Imp()->ValidateContexts();
}

CComboError 
CPGPdisk::SetInactivityTimeout(PGPUInt32 seconds)
{
	return Imp()->SetInactivityTimeout(seconds);
}

void 
CPGPdisk::ResetTimedOut()
{
	Imp()->ResetTimedOut();
}

PGPUInt32 
CPGPdisk::ProcessExternalIo(void *ioPacket, PGPBoolean& wasCompleted)
{
	return Imp()->ProcessExternalIo(ioPacket, wasCompleted);
}

CComboError 
CPGPdisk::Mount(
	const char	*path, 
	const char	*root, 
	const char	*deviceName, 
	PGPdiskEncryptionAlgorithm	algorithm, 
	const void	*exportedContext, 
	PGPUInt32	sizeContext, 
	PGPUInt64	firstDataBlock, 
	PGPUInt64	numDataBlocks, 
	const void	*ioHandlerFunc, 
	PGPUInt32	procId, 
	PGPBoolean	readOnly)
{
	return Imp()->Mount(path, root, deviceName, algorithm, exportedContext, 
		sizeContext, firstDataBlock, numDataBlocks, ioHandlerFunc, this, 
		procId, readOnly);
}

CComboError 
CPGPdisk::Unmount(PGPBoolean isForced)
{
	return Imp()->Unmount(isForced);
}

CComboError 
CPGPdisk::Read(void *buf, PGPUInt32 pos, PGPUInt32 nBlocks) const
{
	return Imp()->Read(buf, pos, nBlocks);
}

CComboError 
CPGPdisk::Write(const void *buf, PGPUInt32 pos, PGPUInt32 nBlocks)
{
	return Imp()->Write(buf, pos, nBlocks);
}
