/*____________________________________________________________________________
		Copyright (C) 2002 PGP Corporation
        All rights reserved.

        $Id: CPGPdiskHandler.h,v 1.6 2002/08/06 20:09:34 dallen Exp $
____________________________________________________________________________*/

#ifndef Included_CPGPdiskHandler_h	// [
#define Included_CPGPdiskHandler_h

#include "pgpDiskPubTypes.h"

#include "CSubsystem.h"
#include "CDriverImpFactory.h"

_PGP_BEGIN

// Class CPGPdiskHandler

class CPGPdiskHandler : public CSubsystem
{
	DECLARE_IMPHOST(CPGPdiskHandler)
	friend class CDriverSubsystems;

public:
	PGPBoolean	IsFileAMountedPGPdisk(const char *path) const;
	PGPBoolean	IsRootAMountedPGPdisk(const char *root) const;

	const char *	GetDiskDevNameByPath(const char *path) const;
	const char *	GetDiskDevNameByRoot(const char *root) const;

	PGPUInt32	NumPGPdisks() const;

	CComboError	ExportPGPdiskInfo(PGPdiskInfo *pInfoArray, 
		PGPUInt32 numElems, PGPUInt32 &elemsFilled);

	void		TurnOnUnmountAllMode();

	CComboError	SetInactivityTimeout(const char *root, PGPUInt32 seconds);
	PGPBoolean	AreDisksTimedOut();
	void		ResetTimedOutDisk(const char *root);

	CComboError	MountPGPdisk(const char *path, const char *root, 
		PGPdiskEncryptionAlgorithm algorithm, const void *exportedContext, 
		PGPUInt32 sizeContext, PGPUInt64 firstDataBlock, 
		PGPUInt64 numDataBlocks, char *deviceName, 
		PGPBoolean readOnly = FALSE);

	CComboError	UnmountPGPdisk(const char *root, PGPBoolean isForced = FALSE);
	CComboError	UnmountAllPGPdisks(PGPBoolean isForced = FALSE);

private:
	CComboError	Startup();
	void		Shutdown();
};

_PGP_END

#endif	// Included_CPGPdiskHandlerImp_h
