/*____________________________________________________________________________
		Copyright (C) 2002 PGP Corporation
        All rights reserved.

        $Id: CVolume.cpp,v 1.5 2002/08/06 20:09:34 dallen Exp $
____________________________________________________________________________*/

#include "pgpClassesConfig.h"

#include "CVolume.h"
#include "CVolumeImp.h"

_USING_PGP

// Class CVolume member functions

DEFINE_IMPHOST(CVolume, VolumeImp, CDriverImpFactory)

PGPBoolean 
CVolume::IsMounted() const
{
	return Imp()->IsMounted();
}

PGPBoolean 
CVolume::IsUnmounted() const
{
	return Imp()->IsUnmounted();
}

PGPBoolean 
CVolume::IsAttachedToVolume() const
{
	return Imp()->IsAttachedToVolume();
}

PGPBoolean 
CVolume::IsLockedForIO() const
{
	return Imp()->IsLockedForIO();
}

PGPBoolean 
CVolume::IsLockedForFormat() const
{
	return Imp()->IsLockedForFormat();
}

const char * 
CVolume::Root() const
{
	return Imp()->Root();
}

const char * 
CVolume::DeviceName() const
{
	return Imp()->DeviceName();
}

PGPUInt32 
CVolume::BlockSize() const
{
	return Imp()->BlockSize();
}

PGPUInt64 
CVolume::TotalBlocks() const
{
	return Imp()->TotalBlocks();
}

PGPBoolean 
CVolume::RootsEqual(const char *root) const
{
	return Imp()->RootsEqual(root);
}

PGPBoolean 
CVolume::HasOpenFiles()
{
	return Imp()->HasOpenFiles();
}

CComboError 
CVolume::AttachVolume(const char *root, const char *deviceName)
{
	return Imp()->AttachVolume(root, deviceName);
}

void 
CVolume::DetachVolume()
{
	Imp()->DetachVolume();
}

CComboError 
CVolume::Mount(
	const char *deviceName, 
	const char *root, 
	PGPUInt64	totalBlocks, 
	PGPUInt32	blockSize, 
	const void	*ioHandlerFunc, 
	void		*refPtr, 
	PGPBoolean	readOnly)
{
	return Imp()->Mount(deviceName, root, totalBlocks, blockSize, 
		ioHandlerFunc, refPtr, readOnly);
}

CComboError 
CVolume::Unmount(PGPBoolean isForced)
{
	return Imp()->Unmount(isForced);
}

CComboError 
CVolume::LockForIO()
{
	return Imp()->LockForIO();
}

CComboError 
CVolume::LockForFormat()
{
	return Imp()->LockForFormat();
}

CComboError 
CVolume::Unlock()
{
	return Imp()->UnlockVolume();
}

CComboError 
CVolume::Read(void *buf, PGPUInt64 pos, PGPUInt32 nBlocks) const
{
	return Imp()->Read(buf, pos, nBlocks);
}

CComboError 
CVolume::Write(const void *buf, PGPUInt64 pos, PGPUInt32 nBlocks)
{
	return Imp()->Write(buf, pos, nBlocks);
}
