////////////////////////////////////////////////////////////////////////////////
//
//  File : EventMonitor.h
//
//  Copyright (C) 2002 PGP Corporation
//
//  ABSTRACT
//		This interface is passed to monitor "low level" actions that occur in GW.
// 
//  Author: Satya S. Das
//
////////////////////////////////////////////////////////////////////////////////

class EventMonitor : public IEventMonitor
{
public:
    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj);
	STDMETHOD_(ULONG, AddRef)(THIS)
		{ return m_pUnkOuter->AddRef(); }
    STDMETHOD_(ULONG, Release)(THIS)
		{ return m_pUnkOuter->Release(); }

    /* IEventMonitor methods */
    STDMETHOD(Notify)(THIS_ BSTR bstrContext, IDispatch * pIDispGWEvent);
	
	EventMonitor(IUnknown *pUnk);
	~EventMonitor();

private:
	IUnknown	*m_pUnkOuter;	
	IUnknown	*m_pIUnkDispFact;

private:	
	/*internal methods*/
	STDMETHOD(InitPGP)();

};

