////////////////////////////////////////////////////////////////////////////////
//
//  File : IconFactory.h
//
//  Copyright (C) 2002 PGP Corporation
//
//  ABSTRACT
//		This interface is used to retrieve icons that represent the state of 
//		C3PO record types.
// 
//  Author: Satya S. Das
//
////////////////////////////////////////////////////////////////////////////////

class IconFactory : public IIconFactory
{
public:
    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj);
	STDMETHOD_(ULONG, AddRef)(THIS)
		{ return m_pUnkOuter->AddRef(); }
    STDMETHOD_(ULONG, Release)(THIS)
		{ return m_pUnkOuter->Release(); }

    /* IconFactory methods */
    STDMETHOD(GetIcons)(THIS_ BSTR bstrObjClass, BSTR FAR* pbstrIconFile, long FAR* plUnOpenIcon, long FAR* plOpenIcon);

	IconFactory(IUnknown *pUnk);
	~IconFactory();

private:
	IUnknown	*m_pUnkOuter;	
	IUnknown	*m_pIUnkDispFact;

};



