////////////////////////////////////////////////////////////////////////////////
//
//  File : Util.h
//
//  Copyright (C) 2002 PGP Corporation
//
//  ABSTRACT
//		Header file
// 
//  Author: Satya S. Das
//
////////////////////////////////////////////////////////////////////////////////


#ifndef UTIL_H
#define UTIL_H

#include <windows.h>
#include <commctrl.h>
#include "pgpsc.h"
#include "pgpclientprefs.h"

const int STRCONVERT_MAXLEN = 300;
const int FOLDERNAME_MAXLEN = 50;

enum GETWINDOWENUM
{
	GWO_CURRENTMAIL_WINDOW,
	GWO_CURRENTATTVIEWER_WINDOW,
	GWO_CURRENTTOPLEVEL_WINDOW,
	GWO_CURRENTREBAR_WINDOW
};

#ifdef _DEBUG
#define _VERIFY(expr) _ASSERT(expr)
#else
#define _VERIFY(expr) ((void)(expr))
#endif


//==== PROTOTYPES ====
#ifdef UNICODE
	#define FROM_OLE_STRING(str) str
	#define TO_OLE_STRING(str) str
	#define FREE_OLE_STRING(str)	((void)0)
#else
    #define STRCONVERT_MAXLEN 300

	#define FROM_OLE_STRING(str) ConvertToAnsi(str)
	#define TO_OLE_STRING(str) ConvertToUnicode(str)
	#define FREE_OLE_STRING(str)	delete [] str

	char* ConvertToAnsi(OLECHAR FAR* szW);
	OLECHAR* ConvertToUnicode(char* szA);
#endif

void ErrorMessage(LPSTR lpsz);
BOOL TV_GetString(HWND hwndTV, HTREEITEM hItem, TCHAR *szText, UINT cchTextMax);
BSTR A2WBSTR(LPCSTR lp, int nLen = -1);
char *GetIconsFilePath();
void DisplayMessage(HWND hwnd, UINT uiResourceID, ...);
void PgpGwTrace(LPCTSTR lpszFormat, ...);
void TraceRefCount(LPUNKNOWN lpUnkIntfPtr);
HWND GetWindow(DWORD dwWhichWindow);
BOOL SafeLoadString(UINT uiResourceId, char **ppszString);
BOOL PgpGwGetBoolPref(PGPPrefIndex ppiPrefToQuery, PGPBoolean& refpbPrefValue);
BOOL PgpGwExLicenseChk();
#endif //UTIL_H
