////////////////////////////////////////////////////////////////////////////////
//  File : globals.h
//
//  Copyright (C) 2002 PGP Corporation
//
//  ABSTRACT
//		extern definitions for module global data. anyone referencing to the 
//		global module data should include this file. all the data is inited
//		in pgpgw.cpp. if you add new global data add that here and init it in
//		pgpgw.cpp.
// 
//  Author: Satya S. Das
////////////////////////////////////////////////////////////////////////////////

#ifndef _GLOBALS_H_
#define _GLOBALS_H_

#include "odma.h"
#include "ofcmndr.h"
#include "pgpclientlib.h"
#include "gwcmdinfohash.h"

#ifndef TOKENINFO_DEFINED
typedef struct _stGwTokenInfo
{
	WORD wTokenID;
	HWND hLinkWnd;
	BSTR bstrMessageId;
	BOOL bIsMailMsg;
} GWTOKENINFO;
#define TOKENINFO_DEFINED
#endif

//module global data
extern HMODULE g_hInstance;
//extern ODMHANDLE g_hODMA;
extern IGWCommander *g_pigwcCommander;
extern BSTR g_bstrValidateCmd;
extern PGPContextRef g_pgpContext;
extern BOOL g_bPlugInExpired;
extern DWORD g_dwModuleOptions;
extern GWTOKENINFO g_gtiLastTokenInfo;
extern CCmdInfoHash *g_pccihCmdHash;

#endif