////////////////////////////////////////////////////////////////////////////////
//  File : globdefs.h
//
//  Copyright (C) 2002 PGP Corporation
//
//  ABSTRACT
//		definitions in use throughout the module
// 
//  Author: Satya S. Das
////////////////////////////////////////////////////////////////////////////////

#ifndef _GLOBDEFS_H_
#define _GLOBDEFS_H_


//module global definitions in use

//registry keys we manipulate
#define C3POKEY "Software\\Novell\\GroupWise\\5.0\\C3PO\\DataTypes"
#define TPHKEY  "Software\\Novell\\GroupWise\\Client\\Third Party"

//mail client name string
#define CLIENTNAME "GroupWise"

//module name string
#define MODULENAME "PGPGW"

//names of dll's we deal with
#define MODULEFILENAME "pgpgw.dll"
#define ICONSFILENAME  "pgpgw.dll"

//module description
#define MODULEDESCRIPTION "PGP Extension module for GroupWise"

//module guid
#define MODULECLSID "{DA5387C4-3B69-11D2-9DEC-00805F0E694C}"

//minimum major and minor versions supported by us
const int MINIMUMGWMAJORVERSUPPORTED=5;
const int MINIMUMGWMINORVERSUPPORTED=0;

//other strings
#define PGPEXTENSIONA ".asc"
#define PGPEXTENSIONW L".asc"

#define CLIENTCONTEXTA "GW.CLIENT"
#define CLIENTCONTEXTW L"GW.CLIENT"

#define MAILMESSAGECONTEXTA "GW.MESSAGE.MAIL"
#define MAILMESSAGECONTEXTW L"GW.MESSAGE.MAIL"

#define DISCUSSIONCONTEXTA "GW.MESSAGE.MAIL.NGW.DISCUSS"
#define DISCUSSIONCONTEXTW L"GW.MESSAGE.MAIL.NGW.DISCUSS"

#define MAINWINDOWCONTEXTA "GW.CLIENT.WINDOW.BROWSER"
#define MAINWINDOWCONTEXTW L"GW.CLIENT.WINDOW.BROWSER"

#define ATTCHVIEWERCONTEXTA "GW.CLIENT.WINDOW.ATTACHVIEWER"
#define ATTCHVIEWERCONTEXTW L"GW.CLIENT.WINDOW.ATTACHVIEWER"

//mail message type
#define MAILMESSAGETYPEA "2"
#define MAILMESSAGETYPEW L"2"

//new GW message id
#define NEWMESSAGEMSGIDA "X00"
#define NEWMESSAGEMSGIDW L"X00"

//window class name strings
#define MAINWINDOWCLASSNAMEA "OFCalView"
#define MAINWINDOWCLASSNAMEW L"OFCalView"

#define MAILVIEWWINDOWCLASSNAMEA "OFMailView"
#define MAILVIEWWINDOWCLASSNAMEW L"OFMailView"

#define ATTACHMENTVIEWERWINDOWCLASSNAMEA "OFAttViewer"
#define ATTACHMENTVIEWERWINDOWCLASSNAMEW L"OFAttViewer"



#ifndef TOKENINFO_DEFINED
typedef struct _stGwTokenInfo
{
	WORD wTokenID;
	HWND hLinkWnd;
	BSTR bstrMessageId;
	BOOL bIsMailMsg;
} GWTOKENINFO;
#define TOKENINFO_DEFINED
#endif

//trace related flags
enum 
{
	GWMO_TRACE
};

DEFINE_GUID(LIBID_GroupWiseCommander,0x025B5FE0L,0x7049,0x11CF,0xA6,0xB0,0x00,0x60,0x8C,0x85,0xAA,0x11);
DEFINE_GUID(IID_IGWCommander,0x85DE0780L,0x7D75,0x11CF,0x86,0xA3,0x00,0x80,0x5F,0x9C,0xB9,0x9C);
DEFINE_GUID(DIID_DIGWCommander,0x025B5FE2L,0x7049,0x11CF,0xA6,0xB0,0x00,0x60,0x8C,0x85,0xAA,0x11);
DEFINE_GUID(CLSID_GWCommander,0x514D4088L,0x5AED,0x11CF,0xA6,0xB0,0x00,0x60,0x8C,0x85,0xAA,0x11);

#endif
