////////////////////////////////////////////////////////////////////////////////
//  File : Gwc3cmd.h
//
//  Copyright (C) 2002 PGP Corporation
//
//  ABSTRACT
//		Header file
// 
//  Author: Satya S. Das
//
////////////////////////////////////////////////////////////////////////////////
#ifndef GWC3CMD_H
#define GWC3CMD_H

//Menu positions
    //Main Menu
typedef enum {
    eGW_MAINMENU_FILEMENU = 1,
    eGW_MAINMENU_EDITMENU = 2,
    eGW_MAINMENU_VIEWMENU = 3,
    eGW_MAINMENU_ACTIONSMENU = 4,
    eGW_MAINMENU_TOOLSMENU = 5,
    eGW_MAINMENU_WINDOWMENU = 6,
    eGW_MAINMENU_HELPMENU = 7
} GwMainMenu;

    //File Menu
typedef enum {
    eGW_FILEMENU_NEWMENU = 1,
    eGW_FILEMENU_OPENARCHIVE = 2,
    eGW_FILEMENU_OPENVIEW = 3,
    eGW_FILEMENU_SAVEAS = 4,
    eGW_FILEMENU_IMPORTDOCUMENTS = 5,
    eGW_FILEMENU_PROXY = 6,
    eGW_FILEMENU_SHARING = 7,
    eGW_FILEMENU_PROPERTIES = 8,
    eGW_FILEMENU_PRINT = 10,
    eGW_FILEMENU_PRINTCALENDAR = 11,
    eGW_FILEMENU_EXIT = 13
} GwFileMenu;

    //Edit Menu
typedef enum {
    eGW_EDITMENU_CUT = 1,
    eGW_EDITMENU_COPY = 2,
    eGW_EDITMENU_PASTE = 3,
    eGW_EDITMENU_SELECTALL = 4,
    eGW_EDITMENU_DELETE = 6,
    eGW_EDITMENU_UNDELETE = 7,
    eGW_EDITMENU_EMPTYTRASH = 8,
    eGW_EDITMENU_CHANGE = 9,
    eGW_EDITMENU_FOLDERS = 11,
    eGW_EDITMENU_MOVELINK = 12,
    eGW_EDITMENU_FINDTEXT = 14,
    eGW_EDITMENU_FINDNEXT = 15,
    eGW_EDITMENU_FINDPREVIOUS = 16
} GwEditMenu;

    //View Menu
typedef enum {
    eGW_VIEWMENU_TOOLBAR = 1,
    eGW_VIEWMENU_FOLDERLIST = 2,
    eGW_VIEWMENU_QUICKVIEWER = 3,
    eGW_VIEWMENU_DETAILS = 5,
    eGW_VIEWMENU_THREADS = 6,
    eGW_VIEWMENU_CALENDAR = 7,
    eGW_VIEWMENU_RECEIVEDITEMS = 9,
    eGW_VIEWMENU_SENTITEMS = 10,
    eGW_VIEWMENU_PERSONALITEMS = 11,
    eGW_VIEWMENU_DRAFTITEMS = 12,
    eGW_VIEWMENU_SORT = 14,
    eGW_VIEWMENU_FILTER = 15,
    eGW_VIEWMENU_REFRESH = 17
} GwViewMenu;

    //Action Menu
typedef enum {
    eGW_ACTIONMENU_OPEN = 1,
    eGW_ACTIONMENU_VIEW = 2,
    eGW_ACTIONMENU_REPLY = 4,
    eGW_ACTIONMENU_FORWARD = 5,
    eGW_ACTIONMENU_ACCEPT = 6,
    eGW_ACTIONMENU_DECLINE = 7,
    eGW_ACTIONMENU_DELEGATE = 8,
    eGW_ACTIONMENU_RESEND = 9,
    eGW_ACTIONMENU_ARCHIVE = 10,
    eGW_ACTIONMENU_VERSIONLIST = 12,
    eGW_ACTIONMENU_COPYDOCUMENT = 13,
    eGW_ACTIONMENU_CHECKOUT = 14,
    eGW_ACTIONMENU_CHECKIN = 15,
    eGW_ACTIONMENU_SETALARM = 17,
    eGW_ACTIONMENU_MARKPRIVATE = 18,
    eGW_ACTIONMENU_MARKCOMPLETED = 19,
    eGW_ACTIONMENU_READLATER = 20
} GwActionMenu;

    //Tools Menu
typedef enum {
    eGW_TOOLSMENU_ADDRESSBOOK = 1,
    eGW_TOOLSMENU_CONVERSATIONPLACE = 2,
    eGW_TOOLSMENU_DIALSENDER = 3,
    eGW_TOOLSMENU_RULES = 5,
    eGW_TOOLSMENU_FIND = 6,
    eGW_TOOLSMENU_BUSYSEARCH = 7,
    eGW_TOOLSMENU_HITTHEROAD = 8,
    eGW_TOOLSMENU_OPTIONS = 10
} GwToolsMenu;

    //Window Menu
typedef enum {
    eGW_WINDOWMENU_MINIMIZE = 1,
    eGW_WINDOWMENU_CLOSE = 2,
    eGW_WINDOWMENU_NEWMAINWINDOW = 4,
    eGW_WINDOWMENU_CALENDAR = 5
} GwWindowMenu;

    //Help Menu
typedef enum {
    eGW_HELPMENU_HELPTOPICS = 1,
    eGW_HELPMENU_GUIDE = 2,
    eGW_HELPMENU_INOTHERWORDS = 3,
    eGW_HELPMENU_ABOUT = 5
} GwHelpMenu;

    //New Menu
typedef enum {
    eGW_NEWMENU_MAIL = 1,
    eGW_NEWMENU_APPOINTMENT = 2,
    eGW_NEWMENU_TASK = 3,
    eGW_NEWMENU_NOTE = 4,
    eGW_NEWMENU_DISCUSSION = 5,
    eGW_NEWMENU_PHONEMESSAGE = 6,
    eGW_NEWMENU_DOCUMENT = 8,
    eGW_NEWMENU_DOCUMENTVERSION = 9,
    eGW_NEWMENU_DOCUMENTREFERENCE = 10,
    eGW_NEWMENU_FOLDER = 12
} GwNewMenu;

    //Change To Menu
typedef enum {
    eGW_CHANGETOMENU_MAIL = 1,
    eGW_CHANGETOMENU_APPOINTMENT = 2,
    eGW_CHANGETOMENU_TASK = 3,
    eGW_CHANGETOMENU_NOTE = 4,
    eGW_CHANGETOMENU_PHONEMESSAGE = 5,
    eGW_CHANGETOMENU_MORE = 7
} GwChangeToMenu;

//Prebuilt Command ID"s
#define eGW_CMDID_ACCEPT			"GW#C#ACCEPT"
#define eGW_CMDID_ARCHIVE			"GW#C#ARCHIVE"
#define eGW_CMDID_COMPLETE			"GW#C#COMPLETE"
#define eGW_CMDID_COMPOSE			"GW#C#COMPOSE"
#define eGW_CMDID_DECLINE			"GW#C#DECLINE"
#define eGW_CMDID_DELEGATE			"GW#C#DELEGATE"
#define eGW_CMDID_DELETE			"GW#C#DELETE"
#define eGW_CMDID_DOC_CHECKIN		"GW#C#DOC_CHECKIN"
#define eGW_CMDID_DOC_CHECKOUT		"GW#C#DOC_CHECKOUT"
#define eGW_CMDID_DOC_RESETINUSE	"GW#C#DOC_RESETINUSE"
#define eGW_CMDID_FORWARD			"GW#C#FORWARD"
#define eGW_CMDID_INFO				"GW#C#INFO"
#define eGW_CMDID_OPEN				"GW#C#OPEN"
#define eGW_CMDID_PRINT				"GW#C#PRINT"
#define eGW_CMDID_PROPERTIES		"GW#C#PROPERTIES"
#define eGW_CMDID_REPLY				"GW#C#REPLY"
#define eGW_CMDID_RESEND			"GW#C#RESEND"
#define eGW_CMDID_SAVE				"GW#C#SAVE"
#define eGW_CMDID_SAVEAS			"GW#C#SAVEAS"
#define eGW_CMDID_SETALARMS			"GW#C#SETALARMS"
#define eGW_CMDID_UNDELETE			"GW#C#UNDELETE"
#define eGW_CMDID_VIEW				"GW#C#VIEW"

//Event Command ID"s
#define eGW_CMDEVTID_ONREADY		"GW#E#0"
#define eGW_CMDEVTID_DELIVERY		"GW#E#1"
#define eGW_CMDEVTID_ONSHUTDOWN		"GW#E#2"

//Prebuilt Command ID"s
#define wceGW_CMDID_ACCEPT			L"GW#C#ACCEPT"
#define wceGW_CMDID_ARCHIVE			L"GW#C#ARCHIVE"
#define wceGW_CMDID_COMPLETE		L"GW#C#COMPLETE"
#define wceGW_CMDID_COMPOSE			L"GW#C#COMPOSE"
#define wceGW_CMDID_DECLINE			L"GW#C#DECLINE"
#define wceGW_CMDID_DELEGATE		L"GW#C#DELEGATE"
#define wceGW_CMDID_DELETE			L"GW#C#DELETE"
#define wceGW_CMDID_DOC_CHECKIN		L"GW#C#DOC_CHECKIN"
#define wceGW_CMDID_DOC_CHECKOUT	L"GW#C#DOC_CHECKOUT"
#define wceGW_CMDID_DOC_RESETINUSE	L"GW#C#DOC_RESETINUSE"
#define wceGW_CMDID_FORWARD			L"GW#C#FORWARD"
#define wceGW_CMDID_INFO			L"GW#C#INFO"
#define wceGW_CMDID_OPEN			L"GW#C#OPEN"
#define wceGW_CMDID_PRINT			L"GW#C#PRINT"
#define wceGW_CMDID_PROPERTIES		L"GW#C#PROPERTIES"
#define wceGW_CMDID_REPLY			L"GW#C#REPLY"
#define wceGW_CMDID_RESEND			L"GW#C#RESEND"
#define wceGW_CMDID_SAVE			L"GW#C#SAVE"
#define wceGW_CMDID_SAVEAS			L"GW#C#SAVEAS"
#define wceGW_CMDID_SETALARMS		L"GW#C#SETALARMS"
#define wceGW_CMDID_UNDELETE		L"GW#C#UNDELETE"
#define wceGW_CMDID_VIEW			L"GW#C#VIEW"

//Event Command ID"s
#define wceGW_CMDEVTID_ONREADY		L"GW#E#0"
#define wceGW_CMDEVTID_DELIVERY		L"GW#E#1"
#define wceGW_CMDEVTID_ONSHUTDOWN	L"GW#E#2"

#endif
