////////////////////////////////////////////////////////////////////////////////
//
//  File : gwc3po.h
//
//  Copyright (C) 2002 PGP Corporation
//
//  ABSTRACT
//		Header file
// 
//  Author: Satya S. Das
//
////////////////////////////////////////////////////////////////////////////////

#ifndef _GWC3PO_H_
#define _GWC3PO_H_

DEFINE_GUID(LIBID_PgpGwTypeLibrary,0xB79C7BA0L,0xF9AC,0x11CE,0x83,0x2C,0x44,0x45,0x53,0x54,0x00,0x00);
#ifndef BEGIN_INTERFACE
#define BEGIN_INTERFACE
#endif

interface DIC3POManager;

interface DICommandBlock;

interface DIMessageBlock;

interface IC3POManager;

interface ICommandBlock;

interface IMessageBlock;

typedef enum {
    eGW_CMDINIT_MENUS = 1,
    eGW_CMDINIT_VOLATILE_MENUS = 2,
    eGW_CMDINIT_TOOLBARS = 4,
    eGW_CMDINIT_VOLATILE_TOOLBARS = 8,
    eGW_CMDINIT_CONTEXT_MENUS = 16,
    eGW_CMDINIT_NO_PREDEFINED = 32
} GwCmdInit;

typedef enum {
    eGW_CMDVAL_CHECKED = 2,
    eGW_CMDVAL_DISABLED = 4
} GWCMDVALIDATION;

typedef enum {
    eGW_C3PO_NONE = 0,
    eGW_C3PO_APPT = 1,
    eGW_C3PO_DOCREF = 2,
    eGW_C3PO_MAIL = 4,
    eGW_C3PO_MESSAGE = 8,
    eGW_C3PO_NOTE = 16,
    eGW_C3PO_PHONE = 32,
    eGW_C3PO_TASK = 64
} GWC3POFLAGS;

typedef enum {
    eGW_GWMENU = 1,
    eGW_GWMENUACTION,
    eGW_GWMENUSEPARATOR
} GWOBJTYPE;

typedef enum {
    eGW_CMD_UNKNOWN,
    eGW_CMD_ACCEPT,
    eGW_CMD_ARCHIVE,
    eGW_CMD_COMPLETE,
    eGW_CMD_COMPOSE,
    eGW_CMD_DECLINE,
    eGW_CMD_DELEGATE,
    eGW_CMD_DELETE,
    eGW_CMD_DOC_CHECKIN,
    eGW_CMD_DOC_CHECKOUT,
    eGW_CMD_DOC_RESETINUSE,
    eGW_CMD_FORWARD,
    eGW_CMD_OPEN,
    eGW_CMD_PRINT,
    eGW_CMD_PROPERTIES,
    eGW_CMD_REPLY,
    eGW_CMD_RESEND,
    eGW_CMD_SAVE,
    eGW_CMD_SAVEAS,
    eGW_CMD_SETALARMS,
    eGW_CMD_UNDELETE,
    eGW_CMD_END_OF_LIST
} GW_COMMAND;

typedef enum {
    eGW_EVT_READY,
    eGW_EVT_DELIVERY,
    eGW_EVT_SHUTDOWN,
    eGW_EVT_OVERFLOW
} GW_EVENT;

DEFINE_GUID(IID_IC3POServer,0x5AAD2AA0L,0x7690,0x11CF,0x82,0x71,0x00,0x80,0x5F,0x8C,0x5D,0xE4);

/* Definition of interface: IC3POServer */
#undef INTERFACE
#define INTERFACE IC3POServer

DECLARE_INTERFACE_(IC3POServer, IUnknown)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;
#endif

    /* IC3POServer methods */
    STDMETHOD(get_CommandFactory)(THIS_ IDispatch * FAR* ppIDispCommandFactory) PURE;
    STDMETHOD(get_Description)(THIS_ BSTR FAR* pbstrDescription) PURE;
    STDMETHOD(get_EventMonitor)(THIS_ IDispatch * FAR* ppIDispEventMonitor) PURE;
    STDMETHOD(get_IconFactory)(THIS_ IDispatch * FAR* ppIDispIconFactory) PURE;
    STDMETHOD(CanShutdown)(THIS_ VARIANT_BOOL FAR* pbCanShutdown) PURE;
    STDMETHOD(DeInit)(THIS) PURE;
    STDMETHOD(Init)(THIS_ IDispatch * pIDispManager) PURE;
};

DEFINE_GUID(DIID_DIC3POServer,0x5AAD2AA1L,0x7690,0x11CF,0x82,0x71,0x00,0x80,0x5F,0x8C,0x5D,0xE4);

/* Definition of dispatch interface: DIC3POServer */
#undef INTERFACE
#define INTERFACE DIC3POServer

DECLARE_INTERFACE_(DIC3POServer, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;
#endif

/* Capable of dispatching all the methods of interface IC3POServer */
};

DEFINE_GUID(CLSID_C3POServer,0xCB210D80L,0xE920,0x11CF,0xB7,0x36,0x00,0x80,0x5F,0xAC,0x66,0x6A);

#ifdef __cplusplus
class C3POServer;
#endif

DEFINE_GUID(IID_IClientState,0x52A8BE60L,0xA1A5,0x11CF,0x82,0x71,0x00,0x80,0x5F,0x8C,0x5D,0xE4);

/* Definition of interface: IClientState */
#undef INTERFACE
#define INTERFACE IClientState

DECLARE_INTERFACE_(IClientState, IUnknown)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;
#endif

    /* IClientState methods */
    STDMETHOD(get_ClientName)(THIS_ BSTR FAR* pbstrClientName) PURE;
    STDMETHOD(get_MajorVersion)(THIS_ long FAR* plMajorVersion) PURE;
    STDMETHOD(get_MinorVersion)(THIS_ long FAR* plMinorVersion) PURE;
    STDMETHOD(BuildCommand)(THIS_ BSTR bstrContext, BSTR bstrPersistentID, IDispatch * pIDispBaseCommand, IDispatch * pIDispParameters, IDispatch * FAR* ppIDispGWCommand) PURE;
    STDMETHOD(BuildPersistentID)(THIS_ long lID, VARIANT vObjFrom, BSTR FAR* pbstrPersistentID) PURE;
};

DEFINE_GUID(DIID_DIClientState,0x52A8BE61L,0xA1A5,0x11CF,0x82,0x71,0x00,0x80,0x5F,0x8C,0x5D,0xE4);

/* Definition of dispatch interface: DIClientState */
#undef INTERFACE
#define INTERFACE DIClientState

DECLARE_INTERFACE_(DIClientState, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;
#endif

/* Capable of dispatching all the methods of interface IClientState */
};

DEFINE_GUID(CLSID_ClientState,0xCB210D81L,0xE920,0x11CF,0xB7,0x36,0x00,0x80,0x5F,0xAC,0x66,0x6A);

#ifdef __cplusplus
class ClientState;
#endif

DEFINE_GUID(IID_ICommandFactory,0xAA45EBA0L,0x24C5,0x11CF,0xB7,0x35,0x00,0x80,0x5F,0xAC,0x66,0x6A);

/* Definition of interface: ICommandFactory */
#undef INTERFACE
#define INTERFACE ICommandFactory

DECLARE_INTERFACE_(ICommandFactory, IUnknown)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;
#endif

    /* ICommandFactory methods */
    STDMETHOD(BuildCommand)(THIS_ BSTR bstrContext, BSTR bstrPersistentID, IDispatch * pIDispBaseCommand, IDispatch * pIDispParameters, IDispatch * FAR* ppIDispGWCommand) PURE;
    STDMETHOD(CustomizeContextMenu)(THIS_ BSTR bstrContext, IDispatch * pIDispGWMenu) PURE;
    STDMETHOD(CustomizeMenu)(THIS_ BSTR bstrContext, IDispatch * pIDispGWMenu, VARIANT_BOOL FAR* pbChanged) PURE;
    STDMETHOD(CustomizeToolbar)(THIS_ BSTR bstrContext, IDispatch * pIDispGWToolbar, VARIANT_BOOL FAR* pbChanged) PURE;
    STDMETHOD(Init)(THIS_ long lcid, long FAR* plCmdFlags) PURE;
    STDMETHOD(WantCommand)(THIS_ BSTR bstrContext, BSTR bstrPersistentID, VARIANT_BOOL FAR* pbChanged) PURE;
};

DEFINE_GUID(DIID_DICommandFactory,0x0457D7A9L,0x7374,0x11CF,0x82,0x71,0x00,0x80,0x5F,0x8C,0x5D,0xE4);

/* Definition of dispatch interface: DICommandFactory */
#undef INTERFACE
#define INTERFACE DICommandFactory

DECLARE_INTERFACE_(DICommandFactory, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;
#endif

/* Capable of dispatching all the methods of interface ICommandFactory */
};

DEFINE_GUID(CLSID_CommandFactory,0xCB210D82L,0xE920,0x11CF,0xB7,0x36,0x00,0x80,0x5F,0xAC,0x66,0x6A);

#ifdef __cplusplus
class CommandFactory;
#endif

DEFINE_GUID(IID_IEventMonitor,0xBF2DDE65L,0x8C8F,0x11CF,0x82,0x71,0x00,0x80,0x5F,0x8C,0x5D,0xE4);

/* Definition of interface: IEventMonitor */
#undef INTERFACE
#define INTERFACE IEventMonitor

DECLARE_INTERFACE_(IEventMonitor, IUnknown)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;
#endif

    /* IEventMonitor methods */
    STDMETHOD(Notify)(THIS_ BSTR bstrContext, IDispatch * pIDispGWEvent) PURE;
};

DEFINE_GUID(DIID_DIEventMonitor,0xBF2DDE64L,0x8C8F,0x11CF,0x82,0x71,0x00,0x80,0x5F,0x8C,0x5D,0xE4);

/* Definition of dispatch interface: DIEventMonitor */
#undef INTERFACE
#define INTERFACE DIEventMonitor

DECLARE_INTERFACE_(DIEventMonitor, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;
#endif

/* Capable of dispatching all the methods of interface IEventMonitor */
};

DEFINE_GUID(CLSID_EventMonitor,0xCB210D83L,0xE920,0x11CF,0xB7,0x36,0x00,0x80,0x5F,0xAC,0x66,0x6A);

#ifdef __cplusplus
class EventMonitor;
#endif

DEFINE_GUID(IID_IGWClientState,0xBF2DDE62L,0x8C8F,0x11CF,0x82,0x71,0x00,0x80,0x5F,0x8C,0x5D,0xE4);

/* Definition of interface: IGWClientState */
#undef INTERFACE
#define INTERFACE IGWClientState

DECLARE_INTERFACE_(IGWClientState, IClientState)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IClientState methods */
    STDMETHOD(get_ClientName)(THIS_ BSTR FAR* pbstrClientName) PURE;
    STDMETHOD(get_MajorVersion)(THIS_ long FAR* plMajorVersion) PURE;
    STDMETHOD(get_MinorVersion)(THIS_ long FAR* plMinorVersion) PURE;
    STDMETHOD(BuildCommand)(THIS_ BSTR bstrContext, BSTR bstrPersistentID, IDispatch * pIDispBaseCommand, IDispatch * pIDispParameters, IDispatch * FAR* ppIDispGWCommand) PURE;
    STDMETHOD(BuildPersistentID)(THIS_ long lID, VARIANT vObjFrom, BSTR FAR* pbstrPersistentID) PURE;
#endif

    /* IGWClientState methods */
    STDMETHOD(get_CommandMessage)(THIS_ IDispatch * FAR* ppMsgDisp) PURE;
    STDMETHOD(get_SelectedFolder)(THIS_ IDispatch * FAR* ppIDisp) PURE;
    STDMETHOD(get_SelectedMessages)(THIS_ IDispatch * FAR* ppIDisp) PURE;
    STDMETHOD(RevokeDeliveryFolder)(THIS_ BSTR bstrMessageClass, VARIANT vTarget) PURE;
    STDMETHOD(SetupDeliveryFolder)(THIS_ BSTR bstrMessageClass, VARIANT vTarget) PURE;
};

DEFINE_GUID(DIID_DIGWClientState,0xBF2DDE63L,0x8C8F,0x11CF,0x82,0x71,0x00,0x80,0x5F,0x8C,0x5D,0xE4);

/* Definition of dispatch interface: DIGWClientState */
#undef INTERFACE
#define INTERFACE DIGWClientState

DECLARE_INTERFACE_(DIGWClientState, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;
#endif

/* Capable of dispatching all the methods of interface IGWClientState */
};

DEFINE_GUID(CLSID_GWClientState,0xCB210D84L,0xE920,0x11CF,0xB7,0x36,0x00,0x80,0x5F,0xAC,0x66,0x6A);

#ifdef __cplusplus
class GWClientState;
#endif

DEFINE_GUID(IID_IGWClientState2,0xA3D88B88L,0x3B79,0x11D2,0x89,0xA2,0x00,0x80,0x5F,0xC1,0xA8,0x96);

/* Definition of interface: IGWClientState2 */
#undef INTERFACE
#define INTERFACE IGWClientState2

DECLARE_INTERFACE_(IGWClientState2, IGWClientState)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IClientState methods */
    STDMETHOD(get_ClientName)(THIS_ BSTR FAR* pbstrClientName) PURE;
    STDMETHOD(get_MajorVersion)(THIS_ long FAR* plMajorVersion) PURE;
    STDMETHOD(get_MinorVersion)(THIS_ long FAR* plMinorVersion) PURE;
    STDMETHOD(BuildCommand)(THIS_ BSTR bstrContext, BSTR bstrPersistentID, IDispatch * pIDispBaseCommand, IDispatch * pIDispParameters, IDispatch * FAR* ppIDispGWCommand) PURE;
    STDMETHOD(BuildPersistentID)(THIS_ long lID, VARIANT vObjFrom, BSTR FAR* pbstrPersistentID) PURE;

    /* IGWClientState methods */
    STDMETHOD(get_CommandMessage)(THIS_ IDispatch * FAR* ppMsgDisp) PURE;
    STDMETHOD(get_SelectedFolder)(THIS_ IDispatch * FAR* ppIDisp) PURE;
    STDMETHOD(get_SelectedMessages)(THIS_ IDispatch * FAR* ppIDisp) PURE;
    STDMETHOD(RevokeDeliveryFolder)(THIS_ BSTR bstrMessageClass, VARIANT vTarget) PURE;
    STDMETHOD(SetupDeliveryFolder)(THIS_ BSTR bstrMessageClass, VARIANT vTarget) PURE;
#endif

    /* IGWClientState2 methods */
    STDMETHOD(get_CurrentAccount)(THIS_ IDispatch * FAR* ppIDisp) PURE;
};

DEFINE_GUID(DIID_DIGWClientState2,0xA3D88B89L,0x3B79,0x11D2,0x89,0xA2,0x00,0x80,0x5F,0xC1,0xA8,0x96);

/* Definition of dispatch interface: DIGWClientState2 */
#undef INTERFACE
#define INTERFACE DIGWClientState2

DECLARE_INTERFACE_(DIGWClientState2, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;
#endif

/* Capable of dispatching all the methods of interface IGWClientState2 */
};

DEFINE_GUID(CLSID_GWClientState2,0xA3D88B8AL,0x3B79,0x11D2,0x89,0xA2,0x00,0x80,0x5F,0xC1,0xA8,0x96);

#ifdef __cplusplus
class GWClientState2;
#endif

DEFINE_GUID(IID_IGWCommand,0xBF2DDE60L,0x8C8F,0x11CF,0x82,0x71,0x00,0x80,0x5F,0x8C,0x5D,0xE4);

/* Definition of interface: IGWCommand */
#undef INTERFACE
#define INTERFACE IGWCommand

DECLARE_INTERFACE_(IGWCommand, IUnknown)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;
#endif

    /* IGWCommand methods */
    STDMETHOD(get_BaseCmd)(THIS_ IDispatch * FAR* ppIDispBaseCmd) PURE;
    STDMETHOD(get_LongPrompt)(THIS_ BSTR FAR* pbstrLongPrompt) PURE;
    STDMETHOD(get_Parameters)(THIS_ IDispatch * FAR* ppIDispBaseCmd) PURE;
    STDMETHOD(get_PersistentID)(THIS_ BSTR FAR* pbstrPersistentID) PURE;
    STDMETHOD(get_ToolTip)(THIS_ BSTR FAR* pbstrToolTip) PURE;
    STDMETHOD(Execute)(THIS) PURE;
    STDMETHOD(Help)(THIS) PURE;
    STDMETHOD(Undo)(THIS) PURE;
    STDMETHOD(Validate)(THIS_ long FAR* plValidate) PURE;
};

DEFINE_GUID(DIID_DIGWCommand,0xBF2DDE61L,0x8C8F,0x11CF,0x82,0x71,0x00,0x80,0x5F,0x8C,0x5D,0xE4);

/* Definition of dispatch interface: DIGWCommand */
#undef INTERFACE
#define INTERFACE DIGWCommand

DECLARE_INTERFACE_(DIGWCommand, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;
#endif

/* Capable of dispatching all the methods of interface IGWCommand */
};

DEFINE_GUID(CLSID_GWCommand,0xCB210D85L,0xE920,0x11CF,0xB7,0x36,0x00,0x80,0x5F,0xAC,0x66,0x6A);

#ifdef __cplusplus
class GWCommand;
#endif

DEFINE_GUID(IID_IGWEvent,0xC9FA8F40L,0x8CA4,0x11CF,0x82,0x71,0x00,0x80,0x5F,0x8C,0x5D,0xE4);

/* Definition of interface: IGWEvent */
#undef INTERFACE
#define INTERFACE IGWEvent

DECLARE_INTERFACE_(IGWEvent, IUnknown)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;
#endif

    /* IGWEvent methods */
    STDMETHOD(get_PersistentID)(THIS_ BSTR FAR* pbstrPersistentID) PURE;
};

DEFINE_GUID(DIID_DIGWEvent,0xC9FA8F41L,0x8CA4,0x11CF,0x82,0x71,0x00,0x80,0x5F,0x8C,0x5D,0xE4);

/* Definition of dispatch interface: DIGWEvent */
#undef INTERFACE
#define INTERFACE DIGWEvent

DECLARE_INTERFACE_(DIGWEvent, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;
#endif

/* Capable of dispatching all the methods of interface IGWEvent */
};

DEFINE_GUID(CLSID_GWEvent,0xCB210D86L,0xE920,0x11CF,0xB7,0x36,0x00,0x80,0x5F,0xAC,0x66,0x6A);

#ifdef __cplusplus
class GWEvent;
#endif

DEFINE_GUID(IID_IGWMenuItem,0xBF2DDE68L,0x8C8F,0x11CF,0x82,0x71,0x00,0x80,0x5F,0x8C,0x5D,0xE4);

/* Definition of interface: IGWMenuItem */
#undef INTERFACE
#define INTERFACE IGWMenuItem

DECLARE_INTERFACE_(IGWMenuItem, IUnknown)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;
#endif

    /* IGWMenuItem methods */
    STDMETHOD(get_Caption)(THIS_ BSTR FAR* pbstrCaption) PURE;
    STDMETHOD(put_Caption)(THIS_ BSTR bstrCaption) PURE;
    STDMETHOD(get_GWCommand)(THIS_ IDispatch * FAR* ppIDispGWCommand) PURE;
    STDMETHOD(put_GWCommand)(THIS_ IDispatch * pIDispGWCommand) PURE;
    STDMETHOD(get_ObjType)(THIS_ GWOBJTYPE FAR* peObjType) PURE;
    STDMETHOD(get_Parent)(THIS_ IDispatch * FAR* ppIDispGWMenuItems) PURE;
    STDMETHOD(Delete)(THIS) PURE;
};

DEFINE_GUID(DIID_DIGWMenuItem,0xBF2DDE69L,0x8C8F,0x11CF,0x82,0x71,0x00,0x80,0x5F,0x8C,0x5D,0xE4);

/* Definition of dispatch interface: DIGWMenuItem */
#undef INTERFACE
#define INTERFACE DIGWMenuItem

DECLARE_INTERFACE_(DIGWMenuItem, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;
#endif

/* Capable of dispatching all the methods of interface IGWMenuItem */
};

DEFINE_GUID(CLSID_GWMenuItem,0xCB210D87L,0xE920,0x11CF,0xB7,0x36,0x00,0x80,0x5F,0xAC,0x66,0x6A);

#ifdef __cplusplus
class GWMenuItem;
#endif

DEFINE_GUID(IID_IGWMenu,0xBF2DDE66L,0x8C8F,0x11CF,0x82,0x71,0x00,0x80,0x5F,0x8C,0x5D,0xE4);

/* Definition of interface: IGWMenu */
#undef INTERFACE
#define INTERFACE IGWMenu

DECLARE_INTERFACE_(IGWMenu, IGWMenuItem)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IGWMenuItem methods */
    STDMETHOD(get_Caption)(THIS_ BSTR FAR* pbstrCaption) PURE;
    STDMETHOD(put_Caption)(THIS_ BSTR bstrCaption) PURE;
    STDMETHOD(get_GWCommand)(THIS_ IDispatch * FAR* ppIDispGWCommand) PURE;
    STDMETHOD(put_GWCommand)(THIS_ IDispatch * pIDispGWCommand) PURE;
    STDMETHOD(get_ObjType)(THIS_ GWOBJTYPE FAR* peObjType) PURE;
    STDMETHOD(get_Parent)(THIS_ IDispatch * FAR* ppIDispGWMenuItems) PURE;
    STDMETHOD(Delete)(THIS) PURE;
#endif

    /* IGWMenu methods */
    STDMETHOD(get_IsModified)(THIS_ VARIANT_BOOL FAR* pbModified) PURE;
    STDMETHOD(get_MenuItems)(THIS_ IDispatch * FAR* ppIDispGWMenuItems) PURE;
};

DEFINE_GUID(DIID_DIGWMenu,0xBF2DDE67L,0x8C8F,0x11CF,0x82,0x71,0x00,0x80,0x5F,0x8C,0x5D,0xE4);

/* Definition of dispatch interface: DIGWMenu */
#undef INTERFACE
#define INTERFACE DIGWMenu

DECLARE_INTERFACE_(DIGWMenu, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;
#endif

/* Capable of dispatching all the methods of interface IGWMenu */
};

DEFINE_GUID(CLSID_GWMenu,0xCB210D88L,0xE920,0x11CF,0xB7,0x36,0x00,0x80,0x5F,0xAC,0x66,0x6A);

#ifdef __cplusplus
class GWMenu;
#endif

DEFINE_GUID(IID_IGWMenuAction,0x1EFC9D00L,0x9450,0x11CF,0x82,0x71,0x00,0x80,0x5F,0x8C,0x5D,0xE4);

/* Definition of interface: IGWMenuAction */
#undef INTERFACE
#define INTERFACE IGWMenuAction

DECLARE_INTERFACE_(IGWMenuAction, IGWMenuItem)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IGWMenuItem methods */
    STDMETHOD(get_Caption)(THIS_ BSTR FAR* pbstrCaption) PURE;
    STDMETHOD(put_Caption)(THIS_ BSTR bstrCaption) PURE;
    STDMETHOD(get_GWCommand)(THIS_ IDispatch * FAR* ppIDispGWCommand) PURE;
    STDMETHOD(put_GWCommand)(THIS_ IDispatch * pIDispGWCommand) PURE;
    STDMETHOD(get_ObjType)(THIS_ GWOBJTYPE FAR* peObjType) PURE;
    STDMETHOD(get_Parent)(THIS_ IDispatch * FAR* ppIDispGWMenuItems) PURE;
    STDMETHOD(Delete)(THIS) PURE;
#endif

    /* IGWMenuAction methods */
    STDMETHOD(get_MenuID)(THIS_ long FAR* plMenuID) PURE;
};

DEFINE_GUID(DIID_DIGWMenuAction,0x1EFC9D01L,0x9450,0x11CF,0x82,0x71,0x00,0x80,0x5F,0x8C,0x5D,0xE4);

/* Definition of dispatch interface: DIGWMenuAction */
#undef INTERFACE
#define INTERFACE DIGWMenuAction

DECLARE_INTERFACE_(DIGWMenuAction, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;
#endif

/* Capable of dispatching all the methods of interface IGWMenuAction */
};

DEFINE_GUID(CLSID_GWMenuAction,0xCB210D89L,0xE920,0x11CF,0xB7,0x36,0x00,0x80,0x5F,0xAC,0x66,0x6A);

#ifdef __cplusplus
class GWMenuAction;
#endif

DEFINE_GUID(IID_IGWMenuSeparator,0xBDE47820L,0xB223,0x11CF,0x82,0x71,0x00,0x80,0x5F,0x8C,0x5D,0xE4);

/* Definition of interface: IGWMenuSeparator */
#undef INTERFACE
#define INTERFACE IGWMenuSeparator

DECLARE_INTERFACE_(IGWMenuSeparator, IGWMenuItem)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IGWMenuItem methods */
    STDMETHOD(get_Caption)(THIS_ BSTR FAR* pbstrCaption) PURE;
    STDMETHOD(put_Caption)(THIS_ BSTR bstrCaption) PURE;
    STDMETHOD(get_GWCommand)(THIS_ IDispatch * FAR* ppIDispGWCommand) PURE;
    STDMETHOD(put_GWCommand)(THIS_ IDispatch * pIDispGWCommand) PURE;
    STDMETHOD(get_ObjType)(THIS_ GWOBJTYPE FAR* peObjType) PURE;
    STDMETHOD(get_Parent)(THIS_ IDispatch * FAR* ppIDispGWMenuItems) PURE;
    STDMETHOD(Delete)(THIS) PURE;
#endif

    /* IGWMenuSeparator methods */
};

DEFINE_GUID(DIID_DIGWMenuSeparator,0xBDE47821L,0xB223,0x11CF,0x82,0x71,0x00,0x80,0x5F,0x8C,0x5D,0xE4);

/* Definition of dispatch interface: DIGWMenuSeparator */
#undef INTERFACE
#define INTERFACE DIGWMenuSeparator

DECLARE_INTERFACE_(DIGWMenuSeparator, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;
#endif

/* Capable of dispatching all the methods of interface IGWMenuSeparator */
};

DEFINE_GUID(CLSID_GWMenuSeparator,0xCB210D8AL,0xE920,0x11CF,0xB7,0x36,0x00,0x80,0x5F,0xAC,0x66,0x6A);

#ifdef __cplusplus
class GWMenuSeparator;
#endif

DEFINE_GUID(IID_IGWMenuItems,0xBF2DDE6AL,0x8C8F,0x11CF,0x82,0x71,0x00,0x80,0x5F,0x8C,0x5D,0xE4);

/* Definition of interface: IGWMenuItems */
#undef INTERFACE
#define INTERFACE IGWMenuItems

DECLARE_INTERFACE_(IGWMenuItems, IUnknown)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;
#endif

    /* IGWMenuItems methods */
    STDMETHOD(get_Count)(THIS_ long FAR* retval) PURE;
    STDMETHOD(get_Parent)(THIS_ IDispatch * FAR* ppIDispGWMenu) PURE;
    STDMETHOD(get__NewEnum)(THIS_ IUnknown * FAR* retval) PURE;
    STDMETHOD(Add)(THIS_ BSTR bstrCaption, IDispatch * pIDispGWCommand, VARIANT vAddBefore, IDispatch * FAR* ppIDispGWMenuAction) PURE;
    STDMETHOD(AddMenu)(THIS_ BSTR bstrCaption, VARIANT vGWCommand, VARIANT vAddBefore, IDispatch * FAR* ppIDispGWMenu) PURE;
    STDMETHOD(AddSeparator)(THIS_ VARIANT vAddBefore, IDispatch * FAR* ppIDispGWMenuSeparator) PURE;
    STDMETHOD(Item)(THIS_ VARIANT vIndex, IDispatch * FAR* ppIDispGWMenuItem) PURE;
    STDMETHOD(FindByHMenu)(THIS_ long lhMenu, IDispatch * FAR* ppIDispGWMenuItem) PURE;
    STDMETHOD(FindByID)(THIS_ VARIANT vID, IDispatch * FAR* ppIDispGWMenuItem) PURE;
};

DEFINE_GUID(DIID_DIGWMenuItems,0xBF2DDE6BL,0x8C8F,0x11CF,0x82,0x71,0x00,0x80,0x5F,0x8C,0x5D,0xE4);

/* Definition of dispatch interface: DIGWMenuItems */
#undef INTERFACE
#define INTERFACE DIGWMenuItems

DECLARE_INTERFACE_(DIGWMenuItems, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;
#endif

/* Capable of dispatching all the methods of interface IGWMenuItems */
};

DEFINE_GUID(CLSID_GWMenuItems,0xCB210D8BL,0xE920,0x11CF,0xB7,0x36,0x00,0x80,0x5F,0xAC,0x66,0x6A);

#ifdef __cplusplus
class GWMenuItems;
#endif

DEFINE_GUID(IID_IGWToolbar,0xBF2DDE6CL,0x8C8F,0x11CF,0x82,0x71,0x00,0x80,0x5F,0x8C,0x5D,0xE4);

/* Definition of interface: IGWToolbar */
#undef INTERFACE
#define INTERFACE IGWToolbar

DECLARE_INTERFACE_(IGWToolbar, IUnknown)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;
#endif

    /* IGWToolbar methods */
    STDMETHOD(get_ToolbarItems)(THIS_ IDispatch * FAR* ppIDispGWToolbarItems) PURE;
    STDMETHOD(get_IsModified)(THIS_ VARIANT_BOOL FAR* pbModified) PURE;
};

DEFINE_GUID(DIID_DIGWToolbar,0xBF2DDE6DL,0x8C8F,0x11CF,0x82,0x71,0x00,0x80,0x5F,0x8C,0x5D,0xE4);

/* Definition of dispatch interface: DIGWToolbar */
#undef INTERFACE
#define INTERFACE DIGWToolbar

DECLARE_INTERFACE_(DIGWToolbar, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;
#endif

/* Capable of dispatching all the methods of interface IGWToolbar */
};

DEFINE_GUID(CLSID_GWToolbar,0xCB210D8CL,0xE920,0x11CF,0xB7,0x36,0x00,0x80,0x5F,0xAC,0x66,0x6A);

#ifdef __cplusplus
class GWToolbar;
#endif

DEFINE_GUID(IID_IGWToolbarItem,0x753C8D20L,0x9454,0x11CF,0x82,0x71,0x00,0x80,0x5F,0x8C,0x5D,0xE4);

/* Definition of interface: IGWToolbarItem */
#undef INTERFACE
#define INTERFACE IGWToolbarItem

DECLARE_INTERFACE_(IGWToolbarItem, IUnknown)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;
#endif

    /* IGWToolbarItem methods */
    STDMETHOD(get_GWCommand)(THIS_ IDispatch * FAR* ppIDispGWCommand) PURE;
    STDMETHOD(put_GWCommand)(THIS_ IDispatch * pIDispGWCommand) PURE;
    STDMETHOD(get_Parent)(THIS_ IDispatch * FAR* ppIDispGWToolbarItems) PURE;
    STDMETHOD(get_ToolbarID)(THIS_ long FAR* plToolbar) PURE;
    STDMETHOD(Delete)(THIS) PURE;
    STDMETHOD(SetBitmap)(THIS_ BSTR bstrFilename, VARIANT vResID) PURE;
};

DEFINE_GUID(DIID_DIGWToolbarItem,0x753C8D21L,0x9454,0x11CF,0x82,0x71,0x00,0x80,0x5F,0x8C,0x5D,0xE4);

/* Definition of dispatch interface: DIGWToolbarItem */
#undef INTERFACE
#define INTERFACE DIGWToolbarItem

DECLARE_INTERFACE_(DIGWToolbarItem, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;
#endif

/* Capable of dispatching all the methods of interface IGWToolbarItem */
};

DEFINE_GUID(CLSID_GWToolbarItem,0xCB210D8DL,0xE920,0x11CF,0xB7,0x36,0x00,0x80,0x5F,0xAC,0x66,0x6A);

#ifdef __cplusplus
class GWToolbarItem;
#endif

DEFINE_GUID(IID_IGWToolbarItems,0x1EFC9D02L,0x9450,0x11CF,0x82,0x71,0x00,0x80,0x5F,0x8C,0x5D,0xE4);

/* Definition of interface: IGWToolbarItems */
#undef INTERFACE
#define INTERFACE IGWToolbarItems

DECLARE_INTERFACE_(IGWToolbarItems, IUnknown)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;
#endif

    /* IGWToolbarItems methods */
    STDMETHOD(get_Count)(THIS_ long FAR* retval) PURE;
    STDMETHOD(get__NewEnum)(THIS_ IUnknown * FAR* retval) PURE;
    STDMETHOD(Add)(THIS_ BSTR bstrCaption, IDispatch * pIDispGWCommand, VARIANT vAddBefore, IDispatch * FAR* ppIDispGWToolbarItem) PURE;
    STDMETHOD(Item)(THIS_ VARIANT vIndex, IDispatch * FAR* ppIDispGWToolbarItem) PURE;
    STDMETHOD(FindByID)(THIS_ VARIANT vID, IDispatch * FAR* ppIDispGWToolbarItem) PURE;
};

DEFINE_GUID(DIID_DIGWToolbarItems,0x753C8D22L,0x9454,0x11CF,0x82,0x71,0x00,0x80,0x5F,0x8C,0x5D,0xE4);

/* Definition of dispatch interface: DIGWToolbarItems */
#undef INTERFACE
#define INTERFACE DIGWToolbarItems

DECLARE_INTERFACE_(DIGWToolbarItems, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;
#endif

/* Capable of dispatching all the methods of interface IGWToolbarItems */
};

DEFINE_GUID(CLSID_GWToolbarItems,0xCB210D8EL,0xE920,0x11CF,0xB7,0x36,0x00,0x80,0x5F,0xAC,0x66,0x6A);

#ifdef __cplusplus
class GWToolbarItems;
#endif

DEFINE_GUID(IID_IIconFactory,0x365BDE64L,0x28D1,0x11CF,0x82,0x71,0x00,0x80,0x5F,0x8C,0x5D,0xE4);

/* Definition of interface: IIconFactory */
#undef INTERFACE
#define INTERFACE IIconFactory

DECLARE_INTERFACE_(IIconFactory, IUnknown)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;
#endif

    /* IIconFactory methods */
    STDMETHOD(GetIcons)(THIS_ BSTR bstrObjClass, BSTR FAR* pbstrIconFile, long FAR* plUnOpenIcon, long FAR* plOpenIcon) PURE;
};

DEFINE_GUID(DIID_DIIconFactory,0x0457D7A6L,0x7374,0x11CF,0x82,0x71,0x00,0x80,0x5F,0x8C,0x5D,0xE4);

/* Definition of dispatch interface: DIIconFactory */
#undef INTERFACE
#define INTERFACE DIIconFactory

DECLARE_INTERFACE_(DIIconFactory, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;
#endif

/* Capable of dispatching all the methods of interface IIconFactory */
};

DEFINE_GUID(CLSID_IconFactory,0xCB210D8FL,0xE920,0x11CF,0xB7,0x36,0x00,0x80,0x5F,0xAC,0x66,0x6A);

#ifdef __cplusplus
class IconFactory;
#endif

DEFINE_GUID(IID_ICommandBlock,0x9298F885L,0x2E25,0x11CF,0x82,0x71,0x00,0x80,0x5F,0x8C,0x5D,0xE4);

/* Definition of interface: ICommandBlock */
#undef INTERFACE
#define INTERFACE ICommandBlock

DECLARE_INTERFACE_(ICommandBlock, IUnknown)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;
#endif

    /* ICommandBlock methods */
    STDMETHOD(BroadcastEvent)(THIS_ BSTR bstrContext, IDispatch * pIDispEvent) PURE;
    STDMETHOD(CreateCommandAggregate)(THIS_ BSTR bstrContext, BSTR bstrPersistentID, IDispatch * pIDispBaseCommand, IDispatch * pIDispParameters, IDispatch * FAR* ppIDispGWCommand) PURE;
    STDMETHOD(CustomizeContextMenu)(THIS_ BSTR bstrContext, IDispatch * pIDispGWMenu) PURE;
    STDMETHOD(CustomizeMenu)(THIS_ BSTR bstrContext, IDispatch * pIDispGWMenu, VARIANT_BOOL FAR* pbVolatile) PURE;
    STDMETHOD(CustomizeToolbar)(THIS_ BSTR bstrContext, IDispatch * pIDispGWToolbar, VARIANT_BOOL FAR* pbVolatile) PURE;
    STDMETHOD(WantCommand)(THIS_ BSTR bstrContext, BSTR bstrPersistentID, VARIANT_BOOL FAR* pbWantCommand) PURE;
};

DEFINE_GUID(DIID_DICommandBlock,0x0457D7ACL,0x7374,0x11CF,0x82,0x71,0x00,0x80,0x5F,0x8C,0x5D,0xE4);

/* Definition of dispatch interface: DICommandBlock */
#undef INTERFACE
#define INTERFACE DICommandBlock

DECLARE_INTERFACE_(DICommandBlock, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;
#endif

/* Capable of dispatching all the methods of interface ICommandBlock */
};

DEFINE_GUID(CLSID_CommandBlock,0xCB210D90L,0xE920,0x11CF,0xB7,0x36,0x00,0x80,0x5F,0xAC,0x66,0x6A);

#ifdef __cplusplus
class CommandBlock;
#endif

DEFINE_GUID(IID_IMessageBlock,0x9298F886L,0x2E25,0x11CF,0x82,0x71,0x00,0x80,0x5F,0x8C,0x5D,0xE4);

/* Definition of interface: IMessageBlock */
#undef INTERFACE
#define INTERFACE IMessageBlock

DECLARE_INTERFACE_(IMessageBlock, IUnknown)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;
#endif

    /* IMessageBlock methods */
    STDMETHOD(GetIcons)(THIS_ BSTR bstrObjClass, BSTR FAR* pbstrIconFile, long FAR* plUnOpenIcon, long FAR* plOpenIcon) PURE;
};

DEFINE_GUID(DIID_DIMessageBlock,0x0457D7ADL,0x7374,0x11CF,0x82,0x71,0x00,0x80,0x5F,0x8C,0x5D,0xE4);

/* Definition of dispatch interface: DIMessageBlock */
#undef INTERFACE
#define INTERFACE DIMessageBlock

DECLARE_INTERFACE_(DIMessageBlock, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;
#endif

/* Capable of dispatching all the methods of interface IMessageBlock */
};

DEFINE_GUID(CLSID_MessageBlock,0xCB210D91L,0xE920,0x11CF,0xB7,0x36,0x00,0x80,0x5F,0xAC,0x66,0x6A);

#ifdef __cplusplus
class MessageBlock;
#endif

DEFINE_GUID(IID_IC3POManager,0x9298F882L,0x2E25,0x11CF,0x82,0x71,0x00,0x80,0x5F,0x8C,0x5D,0xE4);

/* Definition of interface: IC3POManager */
#undef INTERFACE
#define INTERFACE IC3POManager

DECLARE_INTERFACE_(IC3POManager, IUnknown)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;
#endif

    /* IC3POManager methods */
    STDMETHOD(get_CanShutdown)(THIS_ VARIANT_BOOL FAR* pbCanShutdown) PURE;
    STDMETHOD(get_ClientState)(THIS_ IDispatch * FAR* ppIDispClientState) PURE;
    STDMETHOD(get_CommandBlock)(THIS_ IDispatch * FAR* ppIDispCommandBlock) PURE;
    STDMETHOD(get_MessageBlock)(THIS_ IDispatch * FAR* ppIDispMessageBlock) PURE;
    STDMETHOD(get_Version)(THIS_ long FAR* plVersion) PURE;
    STDMETHOD(BuildGWMenu)(THIS_ long lMenu, BSTR bstrContext, long lCmdBegin, long lCmdEnd, IDispatch * FAR* ppIDispGWMenu) PURE;
    STDMETHOD(BuildGWToolbar)(THIS_ long lToolbar, BSTR bstrContext, long lCmdBegin, long lCmdEnd, IDispatch * FAR* ppIDispGWToolbar) PURE;
    STDMETHOD(CreateGWCommand)(THIS_ IDispatch * pIDispCommand, IUnknown * FAR* ppIUnkCommand) PURE;
    STDMETHOD(DeInit)(THIS) PURE;
    STDMETHOD(Init)(THIS_ long lC3POVersion, long lcid, VARIANT vClientState) PURE;
    STDMETHOD(Refresh)(THIS) PURE;
};

DEFINE_GUID(DIID_DIC3POManager,0x0457D7ABL,0x7374,0x11CF,0x82,0x71,0x00,0x80,0x5F,0x8C,0x5D,0xE4);

/* Definition of dispatch interface: DIC3POManager */
#undef INTERFACE
#define INTERFACE DIC3POManager

DECLARE_INTERFACE_(DIC3POManager, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;
#endif

/* Capable of dispatching all the methods of interface IC3POManager */
};

DEFINE_GUID(CLSID_C3POManager,0x41D9D120L,0xFA73,0x11CE,0x83,0x2C,0x44,0x45,0x53,0x54,0x00,0x00);

#ifdef __cplusplus
class C3POManager;
#endif

#endif
