////////////////////////////////////////////////////////////////////////////////
//
//  File : pgpgwServer.h
//
//  Copyright (C) 2002 PGP Corporation
//
//  ABSTRACT
//		Header file
// 
//  Author: Satya S. Das
//
////////////////////////////////////////////////////////////////////////////////

#ifndef _PGPGWSERVER_H
#define _PGPGWSERVER_H

/** include files **/
#include "gwc3po.h"

/** local definitions **/
/* default settings */

/** external functions **/

/** external data **/

/** internal functions **/

/** public data **/

/** private data **/

/** public functions **/

/** private functions **/


class CCommandFactory;
class EventMonitor;

/***********************************************************
   Class Name:  CPgpGwC3PO sub classed from IC3POServer.

   Description:  Every C3PO must support this interface.  It is used to
                 initialize the C3PO.

************************************************************/
class CPgpGwC3PO : public IC3POServer  
{
public:
	// IUnknown methods
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj);
    STDMETHOD_(ULONG, AddRef)(THIS);
    STDMETHOD_(ULONG, Release)(THIS);
	
    /* IC3POServer methods */
    STDMETHOD(get_CommandFactory)(THIS_ IDispatch * FAR* ppIDispCommandFactory);
    STDMETHOD(get_Description)(THIS_ BSTR FAR* pbstrDescription);
    STDMETHOD(get_EventMonitor)(THIS_ IDispatch * FAR* ppIDispEventMonitor);
    STDMETHOD(get_IconFactory)(THIS_ IDispatch * FAR* ppIDispIconFactory);
    STDMETHOD(CanShutdown)(THIS_ VARIANT_BOOL FAR* pbCanShutdown);
	STDMETHOD(DeInit)(THIS);
    STDMETHOD(Init)(THIS_ IDispatch * pIDispManager);

	// Constructor
	CPgpGwC3PO();

	// Destructor
	virtual ~CPgpGwC3PO();

	// Create Objects
	BOOL Create();

private:
	ULONG m_cRef;
	CCommandFactory 	*m_pICmdFact;
	EventMonitor		*m_pIEventMonitor;
	IconFactory			*m_pIIconFactory;
	IUnknown			*m_pIUnkDispServ;
};

#endif


