#include "precomp.h"
/*#include "windows.h"
#include "windowsx.h"
#include "commctrl.h"
#include "richedit.h"
#include "richole.h"
#include "resource.h"
#include "stdio.h"
#include "stdlib.h"*/
#include "ImageDataObject.h"

extern "C" HINSTANCE g_hinst;

void CImageDataObject::InsertBitmap(IRichEditOle* pRichEditOle, HBITMAP hBitmap,DWORD dwPos)
{
	SCODE sc;

	// Get the image data object
	//
	CImageDataObject *pods = new CImageDataObject;
	LPDATAOBJECT lpDataObject;
	pods->QueryInterface(IID_IDataObject, (void **)&lpDataObject);

	pods->SetBitmap(hBitmap);

	// Get the RichEdit container site
	//
	IOleClientSite *pOleClientSite;	
	pRichEditOle->GetClientSite(&pOleClientSite);

	// Initialize a Storage Object
	//
	IStorage *pStorage;	

	LPLOCKBYTES lpLockBytes = NULL;
	sc = ::CreateILockBytesOnHGlobal(NULL, TRUE, &lpLockBytes);
//	if (sc != S_OK)
//		AfxThrowOleException(sc);
//	ASSERT(lpLockBytes != NULL);
	
	sc = ::StgCreateDocfileOnILockBytes(lpLockBytes,
		STGM_SHARE_EXCLUSIVE|STGM_CREATE|STGM_READWRITE, 0, &pStorage);
	if (sc != S_OK)
	{
//		VERIFY(lpLockBytes->Release() == 0);
		lpLockBytes = NULL;
//		AfxThrowOleException(sc);
	}
//	ASSERT(pStorage != NULL);

	// The final ole object which will be inserted in the richedit control
	//
	IOleObject *pOleObject; 
	pOleObject = pods->GetOleObject(pOleClientSite, pStorage);

	// all items are "contained" -- this makes our reference to this object
	//  weak -- which is needed for links to embedding silent update.
	OleSetContainedObject(pOleObject, TRUE);

	// Now Add the object to the RichEdit 
	//
	REOBJECT reobject;
	ZeroMemory(&reobject, sizeof(REOBJECT));
	reobject.cbStruct = sizeof(REOBJECT);
	
	CLSID clsid;
	sc = pOleObject->GetUserClassID(&clsid);
//	if (sc != S_OK)
//		AfxThrowOleException(sc);

	reobject.clsid = clsid;
	reobject.cp = dwPos;//REO_CP_SELECTION;
	reobject.dvaspect = DVASPECT_CONTENT;
	reobject.poleobj = pOleObject;
	reobject.polesite = pOleClientSite;
	reobject.pstg = pStorage;

	// Insert the bitmap at the current location in the richedit control
	//
	sc=pRichEditOle->InsertObject(&reobject);

	// Release all unnecessary interfaces
	//
	pOleObject->Release();
	pOleClientSite->Release();
	pStorage->Release();
	lpDataObject->Release();
}

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

void CImageDataObject::SetBitmap(HBITMAP hBitmap)
{
//	ASSERT(hBitmap);

	STGMEDIUM stgm;
	stgm.tymed = TYMED_GDI;					// Storage medium = HBITMAP handle		
	stgm.hBitmap = hBitmap;
	stgm.pUnkForRelease = NULL;				// Use ReleaseStgMedium

	FORMATETC fm;
	fm.cfFormat = CF_BITMAP;				// Clipboard format = CF_BITMAP
	fm.ptd = NULL;							// Target Device = Screen
	fm.dwAspect = DVASPECT_CONTENT;			// Level of detail = Full content
	fm.lindex = -1;							// Index = Not applicaple
	fm.tymed = TYMED_GDI;					// Storage medium = HBITMAP handle

	this->SetData(&fm, &stgm, TRUE);		
}

IOleObject *CImageDataObject::GetOleObject(IOleClientSite *pOleClientSite, IStorage *pStorage)
{
//	ASSERT(m_stgmed.hBitmap);

	SCODE sc;
	IOleObject *pOleObject;
	sc = ::OleCreateStaticFromData(this, IID_IOleObject, OLERENDER_FORMAT, 
			&m_fromat, pOleClientSite, pStorage, (void **)&pOleObject);
//	if (sc != S_OK)
//		AfxThrowOleException(sc);
	return pOleObject;
}

CImageDataObject cido;
HANDLE hRichEd20=NULL;

//extern "C" DoBitmap(void * pRichEditOle, HBITMAP hBitmap)
//{
//	cido.InsertBitmap((IRichEditOle*) pRichEditOle,hBitmap);
//}


extern "C" void InsertRichOLE(HWND hwndRichEdit,DWORD dwType,DWORD dwPos)
{
	IRichEditOle *pRichEditOle;
	HBITMAP hBmp;
	char szError[200];

	if(hRichEd20==NULL)
	{
		OleInitialize(NULL);
		hRichEd20=LoadLibrary("riched20");
		LoadLibrary("riched32");
		InitCommonControls();
	}

	pRichEditOle=NULL;

//	SendMessage(hwndRichEdit, EM_SETOLECALLBACK, 0, 
//		(LPARAM) 0);
	SendMessage(hwndRichEdit, EM_GETOLEINTERFACE, 0, 
		(LPARAM) (LPVOID*) &pRichEditOle);

	if(pRichEditOle==NULL)
	{
		sprintf(szError,"Richedit %x has no OLE",hwndRichEdit);
		MessageBox(hwndRichEdit,szError,"PGP",MB_OK);
		return;
	}

	switch(dwType)
	{
		case OBL_LOCK:
			hBmp=LoadBitmap(g_hinst,MAKEINTRESOURCE(IDB_LOCK));
			break;
		case OBL_SIG:
			hBmp=LoadBitmap(g_hinst,MAKEINTRESOURCE(IDB_LOCK));
			break;
		case OBL_END:
			hBmp=LoadBitmap(g_hinst,MAKEINTRESOURCE(IDB_END));
			break;
		case OBL_LOCK|OBL_SIG:
			hBmp=LoadBitmap(g_hinst,MAKEINTRESOURCE(IDB_LOCK));
			break;
	}

	cido.InsertBitmap(pRichEditOle,hBmp,dwPos);

	DeleteObject(hBmp);
//	OleUninitialize();
//	((CICQreole *)(plugin->pDoc))->InsertObject(dwType,dwPos);
}

void DeleteRichOLE(PPLUGININFO plugin)
{
//	delete ((CICQreole *)(plugin->pDoc));

//	plugin->pDoc=NULL;
}


void SetRichOLE(PPLUGININFO plugin,HWND hwndEdit)
{
//	plugin->pDoc=new CICQreole(hwndEdit);

//    ((CICQreole *)(plugin->pDoc))->Initialize();
}
