/*____________________________________________________________________________
	Copyright (C) 2002 PGP Corporation
	All rights reserved.
	
	PKIDropTarget.cpp - implements OLE IDropTarget for drag and drop

	$Id: PKIDropTarget.h,v 1.2 2002/08/06 20:09:46 dallen Exp $
____________________________________________________________________________*/

#define PK_IDROP_KEYLIST		0x0001
#define PK_IDROP_GROUPLIST		0x0002
#define PK_IDROP_SPLITLIST		0x0004


class FAR CDropTarget : public IDropTarget
{
public:    
    CDropTarget(HWND hwnd, ULONG uWindowType, VOID* pUserStruct);
	void Enable(BOOL bEnable);

    // IUnknown methods
    STDMETHOD(QueryInterface)(REFIID riid, void FAR* FAR* ppvObj);
    STDMETHOD_(ULONG, AddRef)(void);
    STDMETHOD_(ULONG, Release)(void);

    // IDropTarget methods
    STDMETHOD(DragEnter)(LPDATAOBJECT pDataObj, DWORD grfKeyState, 
		POINTL pt, LPDWORD pdwEffect);
    STDMETHOD(DragOver)(DWORD grfKeyState, POINTL pt, LPDWORD pdwEffect);
    STDMETHOD(DragLeave)();
    STDMETHOD(Drop)(LPDATAOBJECT pDataObj, DWORD grfKeyState, 
		POINTL pt, LPDWORD pdwEffect); 
    
private:
    ULONG	m_refs;  
	HWND	m_hwnd;
    BOOL	m_bAcceptFmt;
    ULONG	m_fmtDrop;
	BOOL	m_bEnabled;
	ULONG	m_uWindowType;
	VOID*	m_pUserStruct;
	POINT	m_ptPrevious;
	ULONG	m_uDEPrevious;
};  

