/*__________________________________________________________________________
 Copyright (C) 2002 PGP Corporation
 All rights reserved.
 
 $Id: Progress.c,v 1.3 2002/10/01 23:15:25 wjb Exp $
__________________________________________________________________________*/
#include <windows.h>
#include <windowsx.h>
#include <commctrl.h>
#include <stdlib.h>
#include <stdio.h>
#include "pgpErrors.h"
#include "resource.h"

#ifndef IDC_PRGAVI
#define IDC_PRGAVI 100 // dummy if no resource is spec'ed
#endif

extern HINSTANCE g_hinst;

#define UPDATETIMERID 100
#define UPDATETIME 75 // milliseconds between updates

typedef UINT (*USERFUNCTION)(HWND,void *);

typedef struct _PRGDLG
{
	HWND			hwnd;

	HWND			hwndParent;
	USERFUNCTION	UserFunction;
	void			*pUserValue;
	DWORD			dwBar;
	char			*szTitle;
	char			*szFile;
	char			*szInfo;
	DWORD			dwAVIClip;

	DWORD			dwNewValue;
	DWORD			dwOldValue;
	HANDLE			hSemaphore;
	DWORD			dwThreadID;
	UINT			err;
	BOOL			bCancel;
	BOOL			bAVIPlaying;

	int				uXsize;
	int				uYsize;
	HBITMAP			hBitmapMain;
	HPALETTE		hPaletteMain;
	BOOL			bFirstTime;
} PRGDLG, *HPRGDLG;

DWORD WINAPI
PrgDlgThreadRoutine (LPVOID lpvoid) 
{
	HPRGDLG hPrgDlg;

	hPrgDlg=(HPRGDLG)lpvoid;

	hPrgDlg->err=(hPrgDlg->UserFunction)(hPrgDlg->hwnd,hPrgDlg->pUserValue);

	SendMessage(hPrgDlg->hwnd,WM_DESTROY,0,0);
	ReleaseSemaphore(hPrgDlg->hSemaphore, 1, NULL);
	return 0;
}

BOOL CALLBACK PrgDlgProc (HWND hDlg, 
							  UINT uMsg, 
							  WPARAM wParam,
							  LPARAM lParam)
{
	HPRGDLG hPrgDlg;

	switch (uMsg) 
	{
		case WM_INITDIALOG:
		{    
//			RECT rc;

			SetWindowLong (hDlg, GWL_USERDATA, lParam);
			hPrgDlg=(HPRGDLG)lParam;
			hPrgDlg->hwnd=hDlg;

			// Initialize GUI elements
			SendDlgItemMessage (hDlg, IDC_PROGRESS, PBM_SETRANGE, 
				0, MAKELPARAM(0, 100));
			SendDlgItemMessage (hDlg, IDC_PROGRESS, PBM_SETPOS,
				(WPARAM)hPrgDlg->dwBar, 0);

			if(hPrgDlg->szTitle)
				SetWindowText(hDlg,hPrgDlg->szTitle);

			if(hPrgDlg->szFile)
				SetWindowText(GetDlgItem(hPrgDlg->hwnd,IDC_PRGFILE),hPrgDlg->szFile);

			if(hPrgDlg->szInfo)
				SetWindowText(GetDlgItem(hPrgDlg->hwnd,IDC_PRGINFO),hPrgDlg->szInfo);

			if(hPrgDlg->dwAVIClip!=0)
			{
				hPrgDlg->bAVIPlaying=TRUE;
				Animate_Open(GetDlgItem(hPrgDlg->hwnd,IDC_PRGAVI),
					MAKEINTRESOURCE(hPrgDlg->dwAVIClip));
			}

			// Center window and set to foreground
 	//		GetWindowRect (hDlg, &rc);
			SetWindowPos (hDlg, NULL,
				(GetSystemMetrics(SM_CXSCREEN) - (hPrgDlg->uXsize)) / 2,
				(GetSystemMetrics(SM_CYSCREEN) - (hPrgDlg->uYsize)) / 2,
				hPrgDlg->uXsize+GetSystemMetrics(SM_CXDLGFRAME)*2, 
				hPrgDlg->uYsize+GetSystemMetrics(SM_CYDLGFRAME)*2+GetSystemMetrics(SM_CYCAPTION), 
				SWP_NOZORDER);

			MoveWindow(GetDlgItem(hDlg,IDC_PROGRESS),
				10,(int)(hPrgDlg->uYsize*0.72),
				hPrgDlg->uXsize-20,15,
				TRUE);

			MoveWindow(GetDlgItem(hDlg,IDCANCEL),
				(hPrgDlg->uXsize-70)/2,(int)(hPrgDlg->uYsize*0.82),
				70,25,
				TRUE);

			SetForegroundWindow(hDlg);

			// Create update timer
			SetTimer(hDlg,UPDATETIMERID,UPDATETIME,NULL);

			return TRUE;
		}

		case WM_PAINT:
		{
			HDC			hdc;
			HDC			hdcMem;
			PAINTSTRUCT	ps;
			HBITMAP		hbmpOld;

			hPrgDlg = (HPRGDLG) GetWindowLong(hDlg, GWL_USERDATA);

			hdc = BeginPaint (hDlg, &ps);
			hdcMem = CreateCompatibleDC (hdc);
			hbmpOld = SelectObject (hdcMem, hPrgDlg->hBitmapMain);

			if (hPrgDlg->bFirstTime) 
			{
				hPrgDlg->bFirstTime = FALSE;

				if (hPrgDlg->hPaletteMain)
				{
					SelectPalette (hdc, hPrgDlg->hPaletteMain, FALSE);
					RealizePalette (hdc);
				}
			}

			BitBlt (hdc, ps.rcPaint.left, ps.rcPaint.top,
				ps.rcPaint.right-ps.rcPaint.left,
				ps.rcPaint.bottom-ps.rcPaint.top,
				hdcMem, 
				ps.rcPaint.left,ps.rcPaint.top,  
				SRCCOPY);

			SelectObject (hdcMem, hbmpOld);
			DeleteDC (hdcMem);

			EndPaint (hDlg, &ps);
			return FALSE;
		}

		case WM_CTLCOLOR:
		{          
 			if(wParam!=0)
			{ 
				DWORD color;

				color=GetSysColor(COLOR_BTNFACE);
				
			  	SetBkColor ((HDC)wParam, color);
			  	SetTextColor ((HDC)wParam, GetSysColor (COLOR_WINDOWTEXT));
			  	return (BOOL)CreateSolidBrush (color);
			} 	 
			break;
		}

		case WM_TIMER:
		{
			BOOL bWindowEnabled;

			hPrgDlg = (HPRGDLG) GetWindowLong(hDlg, GWL_USERDATA);

			if(hPrgDlg->dwThreadID==0)
			{
				// Spawn work thread
				CreateThread (NULL, 0, PrgDlgThreadRoutine, 
					(LPVOID)hPrgDlg, 0, &(hPrgDlg->dwThreadID));
			}

			if(hPrgDlg->dwAVIClip!=0)
			{
				bWindowEnabled=IsWindowEnabled(hPrgDlg->hwnd);

				if((!bWindowEnabled)&&(hPrgDlg->bAVIPlaying))
				{
					hPrgDlg->bAVIPlaying=FALSE;
					Animate_Stop(GetDlgItem(hPrgDlg->hwnd,IDC_PRGAVI));
				}

				if((bWindowEnabled)&&(!hPrgDlg->bAVIPlaying))
				{
					hPrgDlg->bAVIPlaying=TRUE;
					Animate_Play(GetDlgItem(hPrgDlg->hwnd,IDC_PRGAVI), 0, -1, -1);
				}
			}

			// If there has been a change, process it
			if(hPrgDlg->dwNewValue!=hPrgDlg->dwOldValue)
			{
				hPrgDlg->dwOldValue=hPrgDlg->dwNewValue;

				SendDlgItemMessage (hDlg, IDC_PROGRESS, PBM_SETPOS,
					(WPARAM)hPrgDlg->dwNewValue, 0);
			}

			break;
		}

		case WM_CLOSE:
		case WM_QUIT:
		case WM_DESTROY:
		{
			EndDialog(hDlg, FALSE);
			break;
		}

		case WM_COMMAND:
		{
			switch(LOWORD (wParam)) 
			{
				case IDCANCEL:
				{
					hPrgDlg = (HPRGDLG) GetWindowLong(hDlg, GWL_USERDATA);
					ShowWindow(hDlg,SW_HIDE);

					hPrgDlg->bCancel=TRUE;
					break;
				}
			}
			break;
		}
	}
	return FALSE;
}



//	___________________________________________________
//
//	create logical palette from bitmap color table

static HPALETTE
sCreateDIBPalette (
		  LPBITMAPINFO	lpbmi,
		  LPINT			lpiNumColors)
{
	LPBITMAPINFOHEADER	lpbi;
	LPLOGPALETTE		lpPal;
	HANDLE				hLogPal;
	HPALETTE			hPal = NULL;
	INT					i;

	lpbi = (LPBITMAPINFOHEADER)lpbmi;
	if (lpbi->biBitCount <= 8)
		*lpiNumColors = (1 << lpbi->biBitCount);
	else
		*lpiNumColors = 0;  // No palette needed for 24 BPP DIB

	if (*lpiNumColors)
	{
		hLogPal = GlobalAlloc (GHND, sizeof (LOGPALETTE) +
				sizeof (PALETTEENTRY) * (*lpiNumColors));
		lpPal = (LPLOGPALETTE) GlobalLock (hLogPal);
		lpPal->palVersion = 0x300;
		lpPal->palNumEntries = *lpiNumColors;

		for (i = 0;  i < *lpiNumColors;  i++)
		{
			lpPal->palPalEntry[i].peRed   = lpbmi->bmiColors[i].rgbRed;
			lpPal->palPalEntry[i].peGreen = lpbmi->bmiColors[i].rgbGreen;
			lpPal->palPalEntry[i].peBlue  = lpbmi->bmiColors[i].rgbBlue;
			lpPal->palPalEntry[i].peFlags = 0;
		}
		hPal = CreatePalette (lpPal);
		GlobalUnlock (hLogPal);
		GlobalFree (hLogPal);
   }
   return hPal;
}

//	___________________________________________________
//
//	Load DIB bitmap and associated palette

HBITMAP
SEALoadResourceBitmap (
		HINSTANCE		hInstance,
		LPSTR			lpString,
		HPALETTE FAR*	lphPalette)
{
	HRSRC				hRsrc;
	HGLOBAL				hGlobal;
	HBITMAP				hBitmapFinal = NULL;
	LPBITMAPINFOHEADER	lpbi;
	HDC					hdc;
    INT					iNumColors;

	if (hRsrc = FindResource (hInstance, lpString, RT_BITMAP))
	{
		hGlobal = LoadResource (hInstance, hRsrc);
		lpbi = (LPBITMAPINFOHEADER)LockResource (hGlobal);

		hdc = GetDC(NULL);
		*lphPalette =  sCreateDIBPalette ((LPBITMAPINFO)lpbi, &iNumColors);
		if (*lphPalette)
		{
			SelectPalette (hdc,*lphPalette,FALSE);
			RealizePalette (hdc);
		}

		hBitmapFinal = CreateDIBitmap (hdc,
                   (LPBITMAPINFOHEADER)lpbi,
                   (LONG)CBM_INIT,
                   (LPSTR)lpbi + lpbi->biSize + iNumColors * sizeof(RGBQUAD),
                   (LPBITMAPINFO)lpbi,
                   DIB_RGB_COLORS );

		ReleaseDC (NULL,hdc);
		UnlockResource (hGlobal);
		FreeResource (hGlobal);
	}
	return (hBitmapFinal);
}

UINT PGPscProgressDialog(HWND hwndParent,USERFUNCTION UserFunction,
						  void *pUserValue,DWORD dwBar,char *szTitle,
						  char *szFile,char *szInfo,DWORD dwAVIClip)
{
	HPRGDLG hPrgDlg;
	PGPError err;
	int iAboutBitmap;
	BITMAP bm;
	HDC hdc;
	int iNumBits;

	hPrgDlg=(HPRGDLG)malloc(sizeof(PRGDLG));

	if(hPrgDlg==NULL)
	{
		return kPGPError_OutOfMemory;
	}

	memset(hPrgDlg,0x00,sizeof(PRGDLG));

	hPrgDlg->hwndParent=hwndParent;
	hPrgDlg->UserFunction=UserFunction;
	hPrgDlg->pUserValue=pUserValue;
	hPrgDlg->dwBar=dwBar;
	hPrgDlg->szTitle=szTitle;
	hPrgDlg->szFile=szFile;
	hPrgDlg->szInfo=szInfo;
//	hPrgDlg->dwAVIClip=0;
	hPrgDlg->dwAVIClip=dwAVIClip;

	// Just to be sure, a semaphore reinforces the barrier
	// made by the DialogBox.
	hPrgDlg->hSemaphore = CreateSemaphore(NULL, 0, 1, NULL);

	hdc = GetDC (NULL);		// DC for desktop
	iNumBits = GetDeviceCaps (hdc, BITSPIXEL) * GetDeviceCaps (hdc, PLANES);

	if (iNumBits <= 1) 
	{
		iAboutBitmap = IDB_INTRO1;
	}
	else if (iNumBits <= 4) 
	{
		iAboutBitmap = IDB_INTRO4;
	}
	else
	{
		iAboutBitmap = IDB_INTRO8;
	}

	hPrgDlg->hBitmapMain = SEALoadResourceBitmap (g_hinst, 
			MAKEINTRESOURCE (iAboutBitmap), &(hPrgDlg->hPaletteMain));
	GetObject (hPrgDlg->hBitmapMain, sizeof(BITMAP), (LPSTR)&bm);

	hPrgDlg->uXsize = bm.bmWidth;
	hPrgDlg->uYsize = bm.bmHeight;
	hPrgDlg->bFirstTime=TRUE;

	DialogBoxParam (g_hinst, 
		MAKEINTRESOURCE(IDD_PRGDLG),
		hwndParent, 
		(DLGPROC)PrgDlgProc, 
		(LPARAM)hPrgDlg);

	WaitForSingleObject (hPrgDlg->hSemaphore, INFINITE);
	CloseHandle (hPrgDlg->hSemaphore);

	err=hPrgDlg->err;

	if(hPrgDlg->hBitmapMain!=NULL)
		DeleteObject(hPrgDlg->hBitmapMain);
	if(hPrgDlg->hPaletteMain!=NULL)
		DeleteObject(hPrgDlg->hPaletteMain);
	free(hPrgDlg);

	return err;
}

UINT PGPscProgressSetBar(HWND hwnd,DWORD dwBarValue,BOOL bForce)
{
	HPRGDLG hPrgDlg;

	hPrgDlg = (HPRGDLG) GetWindowLong(hwnd, GWL_USERDATA);

	if(hPrgDlg==0)
		return kPGPError_NoErr;

	hPrgDlg->dwNewValue=dwBarValue;

	if(bForce)
	{
		hPrgDlg->dwOldValue=hPrgDlg->dwNewValue;

		SendDlgItemMessage (hPrgDlg->hwnd, IDC_PROGRESS, PBM_SETPOS,
				(WPARAM)dwBarValue, 0);
	}

	if(hPrgDlg->bCancel)
		return kPGPError_UserAbort;

	return kPGPError_NoErr;
}

UINT PGPscProgressSetTitle(HWND hwnd,char *szTitle)
{
	HPRGDLG hPrgDlg;

	hPrgDlg = (HPRGDLG) GetWindowLong(hwnd, GWL_USERDATA);

	SetWindowText(hPrgDlg->hwnd,szTitle);

	return kPGPError_NoErr;
}

UINT PGPscProgressSetFile(HWND hwnd,char *szFile)
{
	HPRGDLG hPrgDlg;

	hPrgDlg = (HPRGDLG) GetWindowLong(hwnd, GWL_USERDATA);

	SetWindowText(GetDlgItem(hPrgDlg->hwnd,IDC_PRGFILE),szFile);

	return kPGPError_NoErr;
}

UINT PGPscProgressSetInfo(HWND hwnd,char *szInfo)
{
	HPRGDLG hPrgDlg;

	hPrgDlg = (HPRGDLG) GetWindowLong(hwnd, GWL_USERDATA);

	SetWindowText(GetDlgItem(hPrgDlg->hwnd,IDC_PRGINFO),szInfo);

	return kPGPError_NoErr;
}

UINT PGPscProgressSetAVI(HWND hwnd,DWORD dwAVIClip)
{
	HWND hwndAVI;
	HPRGDLG hPrgDlg;

	hPrgDlg = (HPRGDLG) GetWindowLong(hwnd, GWL_USERDATA);

	hwndAVI=GetDlgItem(hPrgDlg->hwnd,IDC_PRGAVI);

	hPrgDlg->dwAVIClip=dwAVIClip;

	if(hPrgDlg->dwAVIClip!=0)
	{
		hPrgDlg->bAVIPlaying=TRUE;
		
		Animate_Open(hwndAVI,
			MAKEINTRESOURCE(hPrgDlg->dwAVIClip));
		ShowWindow(hwndAVI,SW_SHOW);
	}
	else
	{
		hPrgDlg->bAVIPlaying=FALSE;

		ShowWindow(hwndAVI,SW_HIDE);
		Animate_Close(hwndAVI);
	}
	
	return kPGPError_NoErr;
}

BOOL PGPscProgressGetCancel(HWND hwnd)
{
	HPRGDLG hPrgDlg;

	hPrgDlg = (HPRGDLG) GetWindowLong(hwnd, GWL_USERDATA);

	// No progress dialog, so no cancel. Tough luck

	if(hPrgDlg==0)
		return FALSE;

	return hPrgDlg->bCancel;
}

void *PGPscProgressGetUserValue(HWND hwnd)
{
	HPRGDLG hPrgDlg;

	hPrgDlg = (HPRGDLG) GetWindowLong(hwnd, GWL_USERDATA);

	return hPrgDlg->pUserValue;
}

void PGPscProgressSetNewFilename(HWND hwnd,char *szInfoFormat,
							  char *infile,BOOL bResetBar)
{
	char *p;
	char *name;
	char *directory;
	char filename[1000];
	char info[1000];
	HPRGDLG hPrgDlg;

	hPrgDlg = (HPRGDLG) GetWindowLong(hwnd, GWL_USERDATA);

	name=directory=NULL;

	strcpy(filename,infile);

	// Just get the filename
	p=strrchr(filename,'\\');

	if(p!=NULL)
	{
		*p=0;
		p++;
		name=p;

		// Now look for directory
		p=strrchr(filename,'\\');

		if(p!=NULL)
		{
			*p=0;
			p++;
			directory=p;
		}
		else
		{
			directory=filename;
		}
	}
	else
	{
		// oops... must be in the root or something
		name=filename;
	}

	if(directory!=NULL)
	{
		sprintf(info,szInfoFormat,directory,directory);
	}
	else
	{
		strcpy(info,"");
	}

	PGPscProgressSetFile(hPrgDlg->hwnd,name);
	PGPscProgressSetInfo(hPrgDlg->hwnd,info);

	if(bResetBar)
		PGPscProgressSetBar(hPrgDlg->hwnd,0,TRUE);
}


/*__Editor_settings____

	Local Variables:
	tab-width: 4
	End:
	vi: ts=4 sw=4
	vim: si
_____________________*/
