/*__________________________________________________________________________
 Copyright (C) 2002 PGP Corporation
 All rights reserved.
 
 $Id: MNdisk.h,v 1.2 2002/08/06 20:09:50 dallen Exp $
__________________________________________________________________________*/
#ifndef Included_MNdisk_h	/* [ */
#define Included_MNdisk_h

#include "pgpPubTypes.h"
#include "pflPrefTypes.h"

PGP_BEGIN_C_DECLARATIONS

/*
	MNdiskCleanup forces the PGPdisk code to release resources and unload 
	.dlls.
*/

VOID 
MNdiskCleanup();

/*
	MNdiskIsPathPGPdisk must be passed either a path to a file or a path to
	a volume in root format (e.g. "C:\"). It sets "*pIsPGPdisk" to TRUE if 
	the item is a PGPdisk, and FALSE otherwise. If "*pIsPGPdisk" is TRUE,
	"*pIsMounted" will also be set to reflect the mounted/unmounted state of
	the PGPdisk.

	NOTE - this function WILL NOT load the PGPdisk .dlls if the path is 
	not a drive letter and not a PGPdisk file (ends in .pgd). But even so, 
	the user will have PGPtray running, and thus the PGPdisk .dlls are 
	already mapped in, so there is no or minimal slowdown in other cases.
*/

VOID
MNdiskIsPathPGPdisk(const char *path, BOOL *pIsPGPdisk, BOOL *pIsMounted);

/*
	The following three functions have obvious functionality.
*/

VOID 
MNdiskEditPGPdisk(const char *path, HWND parent);

VOID 
MNdiskMountPGPdisk(const char *path, HWND parent);

VOID 
MNdiskUnmountPGPdisk(const char *pathOrRoot, HWND parent);

PGP_END_C_DECLARATIONS

#endif /* ] Included_MNdisk_h */


/*__Editor_settings____

	Local Variables:
	tab-width: 4
	End:
	vi: ts=4 sw=4
	vim: si
_____________________*/
