/*______________________________________________________________________________
	Copyright (C) 2002 PGP Corporation
	All rights reserved.


	$Id: LibFileSystem.h,v 1.7 2002/09/09 00:31:43 sdas Exp $
______________________________________________________________________________*/

/*::: FUNCTIONAL OVERVIEW ::::::::::
Declares utility functions useful in file-system handling.

--- revision history --------
9/16/00 Version 1.0.1: Paul Ryan
+ added ei_FileAccess() wrapper for ANSI access() function

8/6/99 Version 1.0: Paul Ryan
::::::::::::::::::::::::::::::::::::*/

#ifndef Included_LibFileSystem_h	/* [ */
#define Included_LibFileSystem_h


extern const int  ei_ERR_ACCESS, ei_ERR_EXIST, ei_FILE_ACCS_EXIST, 
					ei_FILE_ACCS_WRITE, ei_FILE_ACCS_READ, 
					ei_FILE_ACCS_READWRITE;


char * epc_getTempDirNm( char *const, const unsigned int);
BOOL ef_LoadTextFileEntire( const char[], char * *const);
BOOL ef_LoadBinaryFile( const char[], void *const, const int);
int ei_FileAccess( const char[], const int, const BOOL);
BOOL ef_WriteMemToFile( const unsigned char *const, const unsigned long, 
																const char[]);


#endif /* ] Included_LibFileSystem_h */
