/*______________________________________________________________________________
	Copyright (C) 2002 PGP Corporation
	All rights reserved.


	$Id: LibObject.h,v 1.6 2002/09/09 00:31:43 sdas Exp $
______________________________________________________________________________*/

/*::: FUNCTIONAL OVERVIEW ::::::::::
Facilitates object handling within a Notes database.

--- revision history --------
?/?/02 Version 1.2 Paul Ryan
+ added eus_getAttachInfoNext()
+ extended eus_getAttachmentInfo() to allow output of object host type

8/9/00 Version 1.1.2 Paul Ryan
+ added eus_AttachFileAsObject()

9/12/99 Version 1.1: Paul Ryan
+ genericized eus_getObjectContentsInBuffer()
+ added compression-flag return to eus_getAttachmentInfo()

12/10/98 Version 1.0: Paul Ryan
::::::::::::::::::::::::::::::::::::*/

#ifndef Included_LibObject_h	/* [ */
#define Included_LibObject_h


STATUS eus_AttachBufferAsObject( const BYTE *const, const DWORD, DBHANDLE, 
								NOTEHANDLE, char[], const char[], const WORD);
STATUS eus_getAttachmentInfo( NOTEHANDLE, char[], const char[], DWORD *const, 
										DWORD *const, BOOL *const, WORD *const, 
										BLOCKID *const, BLOCKID *const);
STATUS eus_getAttachInfoNext( NOTEHANDLE, char[], BLOCKID *const, char[], 
									DWORD *const, DWORD *const, BOOL *const, 
									WORD *const, BLOCKID *const);
STATUS eus_getObjectContentsInBuffer( const DWORD, const BLOCKID, 
													const DWORD, NOTEHANDLE, 
													DBHANDLE, HANDLE *const);
STATUS eus_AttachFileAsObject( const char[], DBHANDLE, NOTEHANDLE, char[], 
													const char[], const WORD);
STATUS eus_DeleteAttachment( NOTEHANDLE, const char[], char[]);


#endif /* ] Included_LibObject_h */
