/*______________________________________________________________________________
	Copyright (C) 2002 PGP Corporation
	All rights reserved.


	$Id: LibString.h,v 1.5 2002/09/09 00:31:43 sdas Exp $
______________________________________________________________________________*/

/*::: FUNCTIONAL OVERVIEW ::::::::::
Provides various string-handling services.

--- revision history --------
6/20/01 Version 1.2: Paul Ryan
+ added ei_verCmp() for comparing version strings

1/9/99 Version 1.0: Paul Ryan
::::::::::::::::::::::::::::::::::::*/

#ifndef Included_LibString_h	/* [ */
#define Included_LibString_h


#include "LibLinkList.h"


extern char epc_ALPHALWR[], epc_ALPHAUPR[], epc_NUM10[], epc_ALPHANUMLWR[], 
			epc_ALPHANUMUPR[], epc_ALPHANUM[], ec_DOT;

typedef struct _StringNode	{
	char * pc;
	struct _StringNode * pt_next;
}  StringNode;


void e_FreeStringArray( char * * *const, const unsigned long);
void e_FreeStringArrayElements( char * *const, const unsigned long);
BOOL ef_AddStringNodeFifo( char *const, const BOOL, StringNode * *const);
BOOL ef_AddStringNodeFifoUnique( char *const, const BOOL, const BOOL, 
														StringNode * *const);
BOOL ef_ListContainsString( const char[], const StringNode *, const BOOL);
char * epc_strtokStrict( char *const  pc, const char[]);
int ei_verCmp( const char[], const char[], int *const);


#endif /* ] Included_LibString_h */
