/*______________________________________________________________________________
	Copyright (C) 2002 PGP Corporation
	All rights reserved.


	$Id: PstGlobals.h,v 1.8 2002/09/09 00:31:43 sdas Exp $
______________________________________________________________________________*/

/*::: FUNCTIONAL OVERVIEW ::::::::::
Provides global declarations defined by Process Stream Technologies for 
universal use.

--- revision history --------
9/6/02 Version 1.0.1.1 Paul Ryan
+ listing format adjustment

9/16/00 Version 1.0.1 Paul Ryan
+ adjusted to include certain universal error codes
+ added this standard documentation

1/5/99 Version 1.0 Paul Ryan
::::::::::::::::::::::::::::::::::::*/

#ifndef Included_PstGlobals_h	/* [ */
#define Included_PstGlobals_h


char  epc_NULL[] = {'\0'};
const char  epc_CRLF[] = "\r\n", 
			ec_PATH_SPECIFIER = '\\', 
			epc_PATH_SPECIFIER[] = "\\";
			ec_SPACE = ' ';
const int  ei_NOT_FOUND = -1, ei_FAIL = -1, 
			ei_SAME, 				//used with "cmp" functions to signify 
							//	sameness
			ei_LEN_CRLF = sizeof( epc_CRLF) - 1;

const unsigned short  eus_SUCCESS = (unsigned short) NULL,	//same as NOERROR
						eus_ERR_INVLD_ARG = 0x0241;			//same as 
							//	ERR_BAD_PARAM


#endif /* ] Included_PstGlobals_h */
