/*____________________________________________________________________________
	Copyright (C) 2002 PGP Corporation
	All rights reserved.

	$Id: TextIO.c,v 1.10 2002/10/28 20:00:41 sdas Exp $
____________________________________________________________________________*/

#include <windows.h>
#include <richedit.h>
#include <process.h>
#include "resource.h"
#include "PluginInfo.h"
#include "UIutils.h"
#include "PGPsc.h"
#include "pgpClientLib.h"

#define SET_FOCUS_SLEEP		250

BOOL CopyRichEditCtrl(HWND hwnd, char **szText);
BOOL GetNextLine(char *szBuffer, UINT *pnIndex, char *szLine, int nMax);


BOOL GetRecipientText(HWND hwnd, char **szRecipients)
{
	HWND hContainer;
	HWND hTo, hCc, hBcc;
	char *szTo = NULL;
	char *szCc = NULL;
	char *szBcc = NULL;
	BOOL bSuccess = FALSE;
	PluginInfo *plugin;
	char *szWindowClass = "RICHEDIT";

	plugin = GetPluginInfo(hwnd);

	if (plugin->bOE5)
		hContainer = FindWindowEx(hwnd, NULL, "OE_Envelope", NULL);
	else
		hContainer = FindWindowEx(hwnd, NULL, "ATH_NoteHdr", NULL);

	hTo = FindWindowEx(hContainer, NULL, szWindowClass, NULL);
	if (hTo == NULL)
	{
		szWindowClass = "RichEdit20W";
		hTo = FindWindowEx(hContainer, NULL, szWindowClass, NULL);
	}

	hCc = FindWindowEx(hContainer, hTo, szWindowClass, NULL);
	hBcc = FindWindowEx(hContainer, hCc, szWindowClass, NULL);

	if (!CopyRichEditCtrl(hTo, &szTo))
		goto GetRecipientTextError;

	if (!CopyRichEditCtrl(hCc, &szCc))
		goto GetRecipientTextError;

	if (!CopyRichEditCtrl(hBcc, &szBcc))
		goto GetRecipientTextError;

	*szRecipients = (char *) calloc(strlen(szTo) + 
								strlen(szCc) + strlen(szBcc) + 3, 1);
	
	if (szTo[0] != '\r')
		strcat(*szRecipients, szTo);

	if (szCc[0] != '\r')
	{
		if (szTo[0] != '\r')
			strcat(*szRecipients, ",");

		strcat(*szRecipients, szCc);
	}
	
	if (szBcc[0] != '\r')
	{
		if ((szTo[0] != '\r') || (szCc[0] != '\r'))
			strcat(*szRecipients, ",");

		strcat(*szRecipients, szBcc);
	}

	bSuccess = TRUE;

GetRecipientTextError:

	if (szTo != NULL)
		free(szTo);

	if (szCc != NULL)
		free(szCc);

	if (szBcc != NULL)
		free(szBcc);

	return bSuccess;
}


BOOL SaveClipboardText(HWND hwnd)
{
	HANDLE hText;
	char *szText = NULL;
	BOOL bSuccess = TRUE;
	PluginInfo *plugin;

	plugin = GetPluginInfo(hwnd);

	OpenClipboard(hwnd);
	hText = GetClipboardData(CF_TEXT);
	szText = (char *) GlobalLock(hText);

	if (szText != NULL)
	{
		if (plugin->szOldText != NULL)
		{
			free(plugin->szOldText);
			plugin->szOldText = NULL;
		}

		plugin->szOldText = (char *) calloc(strlen(szText)+1, 1);
		if(NULL != plugin->szOldText)
			strcpy(plugin->szOldText, szText);
	}

	GlobalUnlock(hText);
	CloseClipboard();

	return bSuccess;
}


BOOL RestoreClipboardText(HWND hwnd)
{
	HANDLE hText;
	char *szText = NULL;
	BOOL bSuccess = TRUE;
	PluginInfo *plugin = NULL;

	plugin = GetPluginInfo(hwnd);

	OpenClipboard(hwnd);
	EmptyClipboard();

	if ((NULL != plugin) && (NULL != plugin->szOldText))
	{
		hText = GlobalAlloc(GHND | GMEM_DDESHARE, 
					strlen(plugin->szOldText)+1);

		szText = (char *) GlobalLock(hText);
		strcpy(szText, plugin->szOldText);
		GlobalUnlock(hText);

		if (!SetClipboardData(CF_TEXT, hText))
		{
			DWORD dwError;
			char szError[255];
			
			dwError = GetLastError();
			wsprintf(szError, "Error %d", dwError);
			MessageBox(hwnd, szError, NULL, MB_ICONEXCLAMATION);
			bSuccess = FALSE;
			
			goto RestoreClipboardTextError;
		}
	}

RestoreClipboardTextError:

	CloseClipboard();

	if ((NULL != plugin) && (NULL != plugin->szOldText))
	{
		free(plugin->szOldText);
		plugin->szOldText = NULL;
	}

	return bSuccess;
}


BOOL GetMessageText(HWND hwnd, BOOL bCut, char **szMessage)
{
	HANDLE hText;
	char *szText = NULL;
	BOOL bSuccess = TRUE;
	PluginInfo *plugin;

	plugin = GetPluginInfo(hwnd);

	OpenClipboard(hwnd);
	hText = GetClipboardData(CF_TEXT);
	szText = (char *) GlobalLock(hText);
	if (szText == NULL)
	{
		GlobalUnlock(hText);
		bSuccess = FALSE;
		goto GetMessageTextError;
	}

	if (strlen(szText) >= 65535)
	{
		PGPclWindowsFamily nFamily;

		PGPclGetWindowsVersion(&nFamily, NULL, NULL);
		if (nFamily == kPGPclWindowsFamily9x)
		{
			UIDisplayStringID(hwnd, IDS_E_BUFFERTOOBIG);
			bSuccess = FALSE;
		}
	}

	if (bSuccess == TRUE)
	{
		*szMessage = (char *) calloc(strlen(szText)+1, 1);
		if(NULL != *szMessage)
			strcpy(*szMessage, szText);
	}

	GlobalUnlock(hText);

GetMessageTextError:

	CloseClipboard();

	return bSuccess;
}


BOOL SetMessageText(HWND hwnd, char *szMessage)
{
	HANDLE hText;
	char *szText = NULL;
	BOOL bSuccess = TRUE;
	PluginInfo *plugin;

	plugin = GetPluginInfo(hwnd);
	
	if (strlen(szMessage) >= 65535)
	{
		PGPclWindowsFamily nFamily;

		PGPclGetWindowsVersion(&nFamily, NULL, NULL);
		if (nFamily == kPGPclWindowsFamily9x)
		{
			UIDisplayStringID(hwnd, IDS_E_BUFFERTOOBIG);
			bSuccess = FALSE;
			goto SetMessageTextError;
		}
	}

	OpenClipboard(hwnd);
	EmptyClipboard();
	
	hText = GlobalAlloc(GHND | GMEM_DDESHARE, strlen(szMessage)+1);
	szText = (char *) GlobalLock(hText);
	if (szText != NULL)
	{
		strcpy(szText, szMessage);
		GlobalUnlock(hText);
		
		if (!SetClipboardData(CF_TEXT, hText))
		{
			DWORD dwError;
			char szError[255];
			
			dwError = GetLastError();
			wsprintf(szError, "Error %d", dwError);
			MessageBox(hwnd, szError, NULL, MB_ICONEXCLAMATION);
			bSuccess = FALSE;
			
			goto SetMessageTextError;
		}
	}

SetMessageTextError:

	CloseClipboard();

	return bSuccess;
}


BOOL CopyRichEditCtrl(HWND hwnd, char **szText)
{
	CHARRANGE chRange;
	HANDLE hText;
	char *szLocalText = NULL;
	char *szOldText = NULL;
	BOOL bSuccess = FALSE;

	OpenClipboard(hwnd);
	hText = GetClipboardData(CF_TEXT);
	szLocalText = (char *) GlobalLock(hText);

	if (szLocalText != NULL)
	{
		szOldText = (char *) calloc(strlen(szLocalText)+1, 1);
		if(NULL == szOldText)
			goto CopyRichEditCtrlError;
		strcpy(szOldText, szLocalText);
	}

	GlobalUnlock(hText);
	CloseClipboard();

	chRange.cpMin = 0;
	chRange.cpMax = -1;
	SendMessage(hwnd, EM_EXSETSEL, 0, (LPARAM) &chRange);
	SendMessage(hwnd, WM_COPY, 0, 0);
	
	OpenClipboard(hwnd);
	hText = GetClipboardData(CF_TEXT);
	szLocalText = (char *) GlobalLock(hText);

	if (szLocalText != NULL)
	{
		*szText = (char *) calloc(strlen(szLocalText)+1, 1);
		if(NULL == *szText)
			goto CopyRichEditCtrlError;
		strcpy(*szText, szLocalText);
	}

	GlobalUnlock(hText);
	EmptyClipboard();

	if (szOldText != NULL)
	{
		hText = GlobalAlloc(GHND | GMEM_DDESHARE, strlen(szOldText)+1);
		szLocalText = (char *) GlobalLock(hText);
		strcpy(szLocalText, szOldText);
		GlobalUnlock(hText);
		
		if (!SetClipboardData(CF_TEXT, hText))
		{
			DWORD dwError;
			char szError[255];
			
			dwError = GetLastError();
			wsprintf(szError, "Error %d", dwError);
			MessageBox(hwnd, szError, NULL, MB_ICONEXCLAMATION);
			
			goto CopyRichEditCtrlError;
		}
	}

	bSuccess = TRUE;

CopyRichEditCtrlError:

	CloseClipboard();

	if (szOldText != NULL)
	{
		free(szOldText);
		szOldText = NULL;
	}

	return bSuccess;
}


BOOL FindReplyHeader(char *szReplyHeader)
{
	char szLine[1024];
	UINT nIndex;
	int nStop;
	BOOL bEnd = FALSE;
	char szDate[256];
	char szSent[256];

	UIGetString(szDate, 255, IDS_REPLY_DATE);
	UIGetString(szSent, 255, IDS_REPLY_SENT);

	nIndex = 0;
	do
	{
		bEnd = GetNextLine(szReplyHeader, &nIndex, szLine, 1023);
		if (bEnd)
			break;

		szLine[5] = '\0';
	}
	while (strcmp(szLine, szDate) && strcmp(szLine, szSent));

	if (bEnd)
		return FALSE;

	do
	{
		nStop = nIndex;
		bEnd = GetNextLine(szReplyHeader, &nIndex, szLine, 1023);
		if (bEnd)
			break;
	}
	while (szLine[0] != '\r');

	if (bEnd)
		return FALSE;

	szReplyHeader[nStop] = 0;
	return TRUE;
}


void AddReply(char *szHeader, char *szReply)
{
	char szLine[1024];
	UINT nIndex = 0;

	strcat(szHeader, "\r\n\r\n");

	while (!GetNextLine(szReply, &nIndex, szLine, 1023))
	{
		strcat(szHeader, ">");
		strcat(szHeader, szLine);
	}

	return;
}


BOOL GetNextLine(char *szBuffer, UINT *pnIndex, char *szLine, int nMax)
{
	char cCopy;
	int nLength;

	if (*pnIndex > strlen(szBuffer))
		return TRUE;

	nLength = 0;
	do
	{
		cCopy = szBuffer[(*pnIndex)++];
		szLine[nLength] = cCopy;
	}
	while ((cCopy != '\n') && (cCopy != 0) && (nLength++ < nMax));

	szLine[nLength] = 0;
	return FALSE;
}


void FixBadSpaces(char *szInput)
{
	int nIndex = 0;
	int nLength;

	if (szInput == NULL)
		return;

	nLength = strlen(szInput);
	while (nIndex <= nLength)
	{
		if (szInput[nIndex] == (char) 0xa0)
			szInput[nIndex] = 0x20;

		nIndex++;
	}

	return;
}


static void SetMessageWindowFocus(HWND hDlg, PluginInfo *plugin)
{
	HWND hDocHost;
	HWND hMimeEdit;
	HWND hMessage;

	SetWindowPos(hDlg, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE);
	SetFocus(hDlg);

	if (plugin->bOE5)
	{
		hDocHost = FindWindowEx(hDlg, NULL, "ME_DocHost", NULL);
		hMimeEdit = FindWindowEx(hDocHost, NULL, "##MimeEdit_Server", NULL);
		hMessage = FindWindowEx(hMimeEdit, NULL, "Internet Explorer_Server", 
					NULL);
		
		SetFocus(hDocHost);
		SetFocus(hMimeEdit);
		SetFocus(hMessage);
	}
	else
	{
		hDocHost = FindWindowEx(hDlg, NULL, "Ath_DocHost", NULL);
		hMessage = FindWindowEx(hDocHost, NULL, "Internet Explorer_Server", 
					NULL);
					
		SetFocus(hDocHost);
		SetFocus(hMessage);
	}

	return;
}


void DoCopyThread(void *args)
{
	HWND hwnd;
	HWND hwndFocus;
	PluginInfo *plugin;
	BOOL bSuccess;
	BOOL bStartingCR;

	hwnd = (HWND) args;
	plugin = GetPluginInfo(hwnd);
	AttachThreadInput(GetCurrentThreadId(),
		GetWindowThreadProcessId(hwnd, NULL), TRUE);
	SetMessageWindowFocus(hwnd, plugin);

	Sleep(SET_FOCUS_SLEEP);
	SetMessageWindowFocus(hwnd, plugin);
	bSuccess = PGPscDoCopy(hwnd, plugin->pgpContext, TRUE, &hwndFocus,&bStartingCR);
	PostMessage(hwnd, plugin->nCopyDoneMsg, bSuccess, 0);

	_endthread();
}


void DoPasteThread(void *args)
{
	HWND hwnd;
	PluginInfo *plugin;

	hwnd = (HWND) args;
	plugin = GetPluginInfo(hwnd);
	AttachThreadInput(GetCurrentThreadId(),
		GetWindowThreadProcessId(hwnd, NULL), TRUE);
	SetMessageWindowFocus(hwnd, plugin);

	Sleep(SET_FOCUS_SLEEP);
	SetMessageWindowFocus(hwnd, plugin);
	PGPscDoPaste(TRUE, hwnd);
	PostMessage(hwnd, plugin->nPasteDoneMsg, 0, 0);

	_endthread();
}


/*__Editor_settings____

	Local Variables:
	tab-width: 4
	End:
	vi: ts=4 sw=4
	vim: si
_____________________*/
