/*__________________________________________________________________________
 Copyright 2002 PGP Corporation
 All rights reserved.
 
 $Id: SCfiledlg.c,v 1.9 2002/10/19 00:18:59 wjb Exp $
__________________________________________________________________________*/
#include "precomp.h"
#include "tchar.h"

BOOL AlterEncryptedFileName(char *FileName,DWORD Actions)
{
	char DefaultExtension[5] = ".pgp";

	if((Actions & kPGPclDetachedSignature) == kPGPclDetachedSignature)
	{
		strcpy(DefaultExtension, ".sig");
	}
	else
	{
		if((Actions & kPGPclASCIIArmor) == kPGPclASCIIArmor)
		{
			strcpy(DefaultExtension, ".asc");
		}
	}

	if (strlen(FileName) + 4 >= MAX_PATH)
	{
		char *szTrunc = strrchr(FileName, '.');
		
		if (szTrunc)
			strcpy(szTrunc - 4, szTrunc);
		else
		{
			szTrunc = FileName + strlen(FileName) - 4;
			*szTrunc = 0;
		}
	}

	strcat(FileName, DefaultExtension);

	return TRUE;
}

BOOL AlterDecryptedFileName(char *FileName,char *SuggestedName)
{
	char *p;

	p = strrchr(FileName, '\\');

	if(p!=0)
		*(p+1)=0;
	else
		*FileName=0;

	if (strlen(FileName) + strlen(SuggestedName) >= MAX_PATH)
	{
		char *szTrunc = strrchr(SuggestedName, '.');
		UINT nTrunc = strlen(FileName) + strlen(SuggestedName) - MAX_PATH + 1;
		
		if (nTrunc >= strlen(SuggestedName))
			return FALSE;

		if (szTrunc)
			strcpy(szTrunc - nTrunc, szTrunc);
		else
		{
			szTrunc = SuggestedName + strlen(SuggestedName) - nTrunc;
			*szTrunc = 0;
		}
	}

	strcat(FileName,SuggestedName);

	return TRUE;
}

BOOL DoFileSave (HWND hWnd,TCHAR *wszTitle,TCHAR *wszFilename,BOOL bForce)
{
	TCHAR *p;
	BOOL bRst;
	OPENFILENAME SaveFileName;
	HANDLE *hFile;
	TCHAR StrRes[500];
	BOOL bAskUser,bRetry,bAddDefault;
	TCHAR DefaultExtension[MAX_PATH];
	int FileStart,FileExtensionStart;

	bAskUser=bForce;

	do
	{
		FileStart=FileExtensionStart=0;
		bRetry=FALSE;
		bRst=TRUE;
		_tcscpy(DefaultExtension,TEXT("\0"));

		if((p = _tcsrchr(wszFilename, (TCHAR)'\\')))
		{
			p++;
			FileStart = p - wszFilename;
		}

		if((p = _tcsrchr(wszFilename, (TCHAR)'.')))
		{
			p++;

			FileExtensionStart = p - wszFilename;
			_tcscpy(DefaultExtension,p); // Save old extension
									// it might get stripped
		}

		// Ask the user
		if(bAskUser)
		{
			memset (&SaveFileName, 0x00, sizeof (OPENFILENAME));

			LoadString (g_hinst, IDS_SAVEFILTER, StrRes, sizeof(StrRes));
			while (p = _tcsrchr (StrRes, '@')) *p = '\0';

			SaveFileName.lStructSize=sizeof(SaveFileName); 
			SaveFileName.hwndOwner=hWnd; 
			SaveFileName.hInstance=NULL; 
			SaveFileName.lpstrFilter=StrRes;
			SaveFileName.lpstrCustomFilter=NULL; 
			SaveFileName.nMaxCustFilter=0; 
			SaveFileName.nFilterIndex=1; 
  			SaveFileName.lpstrFile=wszFilename; 
			SaveFileName.nMaxFile=MAX_PATH; 
			SaveFileName.lpstrFileTitle=NULL; 
			SaveFileName.nMaxFileTitle=0; 
			SaveFileName.lpstrInitialDir=NULL; 
			SaveFileName.lpstrTitle=wszTitle; 
			SaveFileName.Flags= OFN_HIDEREADONLY|OFN_NOCHANGEDIR;
			SaveFileName.nFileOffset=FileStart; 
			SaveFileName.nFileExtension=FileExtensionStart; 
			SaveFileName.lpstrDefExt=DefaultExtension; 
			SaveFileName.lCustData=(long)NULL; 
			SaveFileName.lpfnHook=NULL;
			SaveFileName.lpTemplateName=NULL; 

			bRst = GetSaveFileName(&SaveFileName);
		}

		if(bRst)
		{
			// We'll likely always have some kind of extension
			if(DefaultExtension[0]!=0)
			{
				bAddDefault=FALSE;

				p = _tcsrchr(wszFilename, '.');

				if(p)
				{
					p++;

					// Extension found
					if(!_tcsicmp(DefaultExtension,p))
					{
						// They are the same. Woohoo! Do nothing
						bAddDefault=FALSE;
					}
					else
					{
						bAddDefault=TRUE;
					}
				}
				else
				{
					bAddDefault=TRUE;
				}

				if(bAddDefault)
				{
					int lastone;
					BOOL bDot;

					// They are different. Must be that 
					// pesky hide extensions option.
					lastone=_tcslen(wszFilename)-1;
					bDot=FALSE;

					if(lastone>=0)
					{
						if(wszFilename[lastone]==L'.')
							bDot=TRUE;
					}

					if (lastone+4 >= MAX_PATH-1)
					{
						wszFilename[MAX_PATH-5] = 0;
						bDot = FALSE;
					}

					if(!bDot)
						_tcscat(wszFilename,TEXT("."));
					_tcscat(wszFilename,DefaultExtension);
				}
			}

			hFile=CreateFile (wszFilename, GENERIC_READ,
				0, NULL,OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);

			// If we could open the file, we need to ask the user
			if(hFile!=INVALID_HANDLE_VALUE)
			{
				CloseHandle(hFile);

				if(!bAskUser)
				{
					// If we haven't asked, don't error out just yet. Show dlg
					bAskUser=bRetry=TRUE;
					continue;
				}
				else
				{
					TCHAR szMsg[MAX_PATH+100];

					_stprintf(szMsg,
						TEXT("%s already exists.\nDo you want to replace it?"),
						wszFilename);

					// We've been here before. Error before doing anything
					if(IDNO==MessageBox(hWnd,
						szMsg,TEXT("PGP Save As"),
						MB_YESNO|MB_ICONWARNING|MB_SETFOREGROUND))
					{
						// Do over
						bAskUser=bRetry=TRUE;
						continue;
					}
				}

				// File doesn't exist, but can we create it?
				hFile=CreateFile (wszFilename, GENERIC_READ|GENERIC_WRITE,
					0, NULL,CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);

				if(hFile==INVALID_HANDLE_VALUE)
				{
					if(!bAskUser)
					{
						// Couldn't create it, but don't error out yet. Dlg.
						bAskUser=bRetry=TRUE;
						continue;
					}
					else
					{
						// Been here before. Show error and do over
						MessageBox(hWnd,
							wszFilename,TEXT("Could not write to file!"),
							MB_OK|MB_ICONSTOP|MB_SETFOREGROUND);
						bAskUser=bRetry=TRUE;
						continue;
					}
				}
				else
				{
					// We can create the file. Close it and erase it
					CloseHandle(hFile);
					DeleteFile(wszFilename);
					// Should be done after this!
				}
			}
		}
	} while(bRetry);

	return(bRst);
}

BOOL SaveOutputFile(PGPContextRef Context,
					 HWND hwnd, 
					 char *Title,
					 char *InputFile, 
					 PGPFileSpecRef *pOutputFileRef,
					 BOOL Force)
{
	char OutputFile[MAX_PATH];
	BOOL bOK;

	strcpy(OutputFile,InputFile);

	bOK=DoFileSave(hwnd,Title,OutputFile,Force);

	if(bOK)
	{
		PGPNewFileSpecFromFullPath(Context,OutputFile,pOutputFileRef);
	}

	return(!bOK); // TRUE if user Cancels
}

BOOL GetOriginalFileRef(HWND hwnd,PGPContextRef context,
						char *InputFile,
						char *OutputFile,
						PGPFileSpecRef *OriginalFileRef,
						HWND hwndWorking)
{
	char OriginalFile[MAX_PATH + 1], *p;
	char *pDefaultExtension;
	unsigned short FileStart, FileExtensionStart;
	BOOL UserCancel = FALSE;
	OPENFILENAME OriginalFileName;
	FILE *ftest;
	char StrRes[500];
	char StrRes2[500];

	assert(InputFile);
	assert(OriginalFileRef);

	strcpy(OriginalFile, InputFile);

	if((p = strrchr(OriginalFile, '\\')))
		FileStart = p - OriginalFile + 1;
	else
		FileStart = 0;

	// Get rid of the .sig extension

	if((p = strrchr(OriginalFile, '.')))
	{
		*p = '\0';
	}

	ftest=fopen(OriginalFile,"rb");
	if(ftest!=0)
	{
		fclose(ftest);
		strcpy(OutputFile,OriginalFile);
		PGPNewFileSpecFromFullPath( context,OriginalFile, OriginalFileRef);
		return FALSE;
	}

	// Don't add any default extensions to the file

	pDefaultExtension=0;
	FileExtensionStart=strlen(OriginalFile);

	LoadString (g_hinst, IDS_SAVEFILTER, StrRes, sizeof(StrRes));
	while (p = strrchr (StrRes, '@')) *p = '\0';

	LoadString (g_hinst, IDS_SELSIGNFILE, StrRes2, sizeof(StrRes2));

	OriginalFileName.lStructSize=sizeof(OriginalFileName); 
    OriginalFileName.hwndOwner=hwnd; 
    OriginalFileName.hInstance=NULL; 
    OriginalFileName.lpstrFilter=StrRes; 
    OriginalFileName.lpstrCustomFilter=NULL; 
    OriginalFileName.nMaxCustFilter=0; 
    OriginalFileName.nFilterIndex=1; 
    OriginalFileName.lpstrFile=OriginalFile; 
    OriginalFileName.nMaxFile=MAX_PATH; 
    OriginalFileName.lpstrFileTitle=NULL; 
    OriginalFileName.nMaxFileTitle=0; 
    OriginalFileName.lpstrInitialDir=NULL; 
    OriginalFileName.lpstrTitle=StrRes2; 
    OriginalFileName.Flags=OFN_OVERWRITEPROMPT | OFN_HIDEREADONLY |
						   OFN_FILEMUSTEXIST | OFN_PATHMUSTEXIST | OFN_NOCHANGEDIR;
#ifdef WIN32
	OriginalFileName.Flags=OriginalFileName.Flags | OFN_EXPLORER;
#endif
    OriginalFileName.nFileOffset=FileStart; 
    OriginalFileName.nFileExtension=FileExtensionStart; 
    OriginalFileName.lpstrDefExt=pDefaultExtension; 
    OriginalFileName.lCustData=(long)NULL; 
    OriginalFileName.lpfnHook=NULL;
    OriginalFileName.lpTemplateName=NULL; 

	if(GetOpenFileName(&OriginalFileName))
	{
		strcpy(OutputFile,OriginalFile);
		PGPNewFileSpecFromFullPath( context,OriginalFile, OriginalFileRef);
	}
	else
		UserCancel = TRUE;

	return(UserCancel);
}


/*__Editor_settings____

	Local Variables:
	tab-width: 4
	End:
	vi: ts=4 sw=4
	vim: si
_____________________*/

