/*__________________________________________________________________________
 Copyright (C) 2002 PGP Corporation
 All rights reserved.
 
 $Id: SCutils.c,v 1.39 2002/11/20 00:15:37 wjb Exp $
__________________________________________________________________________*/
#include "precomp.h"

//DWORD g_uPurgePassphraseCacheMessage;
/*
#pragma data_seg(".SHARDAT")
static UINT g_KeyArray[4]={0,0,0,0};
static UINT * lpJournalKeys = 0;
static UINT g_KeyIndex = 0;
static UINT g_NumKeys = 0;
static HHOOK  g_hJournalHook=NULL ;
static BOOL g_fDelay=TRUE;
#pragma data_seg()
*/

typedef struct
{
	UINT g_KeyArray[4];
	UINT * lpJournalKeys;
	UINT g_KeyIndex;
	UINT g_NumKeys;
	HHOOK  g_hJournalHook;
	BOOL g_fDelay;
} SCSHARED;

SCSHARED *SCGetSharedMem(HANDLE *hMapObject)
{
	void *mem;

	*hMapObject=CreateFileMapping
		((HANDLE)0xFFFFFFFF,
		NULL,
		PAGE_READWRITE,
		0,
		sizeof(SCSHARED),
		"PGPscSharedMemory");

	if(*hMapObject==NULL)
		return NULL;

	mem=MapViewOfFile(*hMapObject,FILE_MAP_WRITE,0,0,0);

	return mem;
}

void SCReleaseSharedMem(SCSHARED *hkShared,HANDLE hMapObject)
{
	UnmapViewOfFile(hkShared);
	
	CloseHandle(hMapObject);
}

#define LAUNCHKEYS_TIMER		53
#define MILLISECONDS_PER_DAY	86400000

#define SK_KEYDOWN  0x8000
#define SK_SYSKEY   0x4000

BOOL WINAPI SendKeys( UINT *lpKeys, UINT nKeys );

BOOL PGPscSchedPGPdirwipe(HWND hwnd,void *PGPsc,char *Directory)
{
	PGPError err;
	PGPPrefRef prefRef;
	PGPUInt32 Passes;

	err=PGPclPeekClientLibPrefRefs(&prefRef,NULL);

	if(IsntPGPError(err))
	{
		PGPGetPrefNumber (prefRef,
			kPGPPrefFileWipePasses, 
			(PGPUInt32*)&Passes);
	}

	SchedulePGPdirwipe(hwnd,PGPsc,Directory,Passes);

	return TRUE;
}

BOOL PGPscGetSecureViewerPref(void *PGPsc)
{
	PGPBoolean	bSecure		= FALSE;
	PGPPrefRef	prefRef;
	PGPError err;

	err=PGPclPeekClientLibPrefRefs(&prefRef,NULL);

	if(IsntPGPError(err))
	{
		PGPGetPrefBoolean (prefRef, 
			kPGPPrefAlwaysUseSecureViewer, &bSecure);
	}

	return (BOOL) bSecure;
}

BOOL PGPscHookCBTWin(void *PGPsc)
{
	PGPBoolean	bCBT		= TRUE;
	PGPPrefRef	prefRef;
	PGPError err;

	err=PGPclPeekClientLibPrefRefs(&prefRef,NULL);

	if(IsntPGPError(err))
	{
		PGPGetPrefBoolean (prefRef, 
			kPGPPrefHookCBTWin, &bCBT);
	}

	return (BOOL) bCBT;
}

LRESULT 
PGPscMessageBox (
		 HWND	hWnd, 
		 INT	iCaption, 
		 INT	iMessage,
		 ULONG	ulFlags) 
{
	CHAR szCaption [128];
	CHAR szMessage [500];

	LoadString (g_hinst, iCaption, szCaption, sizeof(szCaption));
	LoadString (g_hinst, iMessage, szMessage, sizeof(szMessage));

	ulFlags |= MB_SETFOREGROUND;
	return (MessageBox (hWnd, szMessage, szCaption, ulFlags));
}

BOOL PGPscWindowExists (LPSTR lpszName, BOOL bShow) 
{
	HWND hWndMe;
    HANDLE			hSem;

	// Create or open a named semaphore. 
    hSem = CreateSemaphore (NULL, 0, 1, lpszName);

	// Close handle and return NULL if existing semaphore was opened.
    if ((hSem != NULL) && (GetLastError() == ERROR_ALREADY_EXISTS)) 
	{
        CloseHandle(hSem);

		if(bShow)
		{
			hWndMe = FindWindow (lpszName, lpszName);
			if (hWndMe) 
			{
				if (!IsZoomed (hWndMe)) 
					ShowWindow (hWndMe, SW_RESTORE);
				BringWindowToTop(hWndMe);
				SetForegroundWindow(hWndMe);
			}
		}

		return TRUE;
	}

    // If new semaphore was created, return FALSE.
    return FALSE;
}


BOOL PGPscInit(HWND hwnd,void **PGPsc,void **PGPtls,int Flags)
{
	PGPError err;
	PGPContextRef context;
	PGPtlsContextRef tls;
	DWORD OLERetVal;

	err=PGPclInitLibrary(&context, Flags);

	if( IsPGPError(err) )
	{
		if(err == kPGPError_IncompatibleAPI)
		{
			PGPscMessageBox (hwnd,IDS_PGPERROR,IDS_WRONGSDK,
					MB_OK|MB_ICONSTOP);
		}
		else
		if(err == kPGPError_FeatureNotAvailable)
		{
			PGPscMessageBox (hwnd,IDS_PGPERROR,IDS_EVALEXPIRED,
					MB_OK|MB_ICONSTOP);
		}
		else
			PGPclErrorBox(hwnd,err);

		return FALSE;
	}

	PGPlnLicenseCheck (context);
///	if(IsPGPError(PGPlnIsExpired(hwnd,kPGPlnGraceExpiration)))
///	{
///		PGPclCloseLibrary();
///		return FALSE;
///	}

	if(err==kPGPError_UserAbort)
		return FALSE;

	err=PGPNewTLSContext (context, &tls);

	if( IsPGPError(err) )
	{
		PGPclErrorBox(hwnd,err);
		return FALSE;
	}

	OLERetVal=OleInitialize (NULL);

	switch(OLERetVal)
	{
		case S_OK:
			// The COM library and additional functionality were 
			// initialized successfully on this apartment. 
			break;

		case S_FALSE:
		{
			// The COM library is already initialized on this 
			// apartment.
			break;
		}

		case OLE_E_WRONGCOMPOBJ:
		{
			MessageBox(hwnd,
				"The versions of COMPOBJ.DLL and OLE2.DLL on\n"
				"your machine are incompatible with each other.",
				"OLE Error",MB_OK);
			return FALSE;
		}

		default:
		{
			MessageBox(hwnd,
				"Error initializing OLE.",
				"OLE Error",MB_OK);
			return FALSE;
		}
	}

	*PGPsc=(void *)context;
	*PGPtls=(void *)tls;

//	g_uPurgePassphraseCacheMessage = 
//		RegisterWindowMessage (kPGPclPurgePassphraseCacheMsg);

	// register the reload messages
	g_uAddedKeysMessage = 
		RegisterWindowMessage (kPGPscAddedKeysMsg);

	return TRUE;
}

BOOL PGPscDestroy(HWND hwnd,void *PGPsc,void *PGPtls)
{
	PGPError err;
	PGPContextRef context;
	PGPtlsContextRef tls;

	context=(PGPContextRef)PGPsc;
	tls=(PGPtlsContextRef)PGPtls;

	err=PGPFreeTLSContext(tls);

	PGPclCloseLibrary ();

	OleUninitialize();

	if(IsntPGPError(err))
		return TRUE;

	return FALSE;
}

BOOL PGPscInitDirectory(void)
{
	PGPError err;
	char szInitDir[MAX_PATH];

	err=PGPclGetPath (kPGPclDefaultOpenFolder, 
		szInitDir, sizeof(szInitDir));

	if(IsntPGPError(err))
	{
		SetCurrentDirectory(szInitDir);

		return TRUE;
	}

	return FALSE;
}

BOOL PGPscCheckForPurge(UINT uMsg,WPARAM wParam)
{
// There is no longer a local cache

//	if (uMsg == g_uPurgePassphraseCacheMessage)
//	{
//		PGPclPurgeCachedPassphrase (wParam);
//			return TRUE;
//	}

//	return FALSE;
	return TRUE;
}

OUTBUFFLIST *PGPscMakeOutBuffItem(OUTBUFFLIST **obl)
{
	OUTBUFFLIST *nobl,*lastobl,*indexobl;

	nobl=(OUTBUFFLIST *)malloc(sizeof(OUTBUFFLIST));
	memset(nobl,0x00,sizeof(OUTBUFFLIST));

	lastobl=indexobl=*obl;

	while(indexobl!=0)
	{
		lastobl=indexobl;
		indexobl=indexobl->next;
	}

	if(lastobl==0)
		*obl=nobl;
	else
		lastobl->next=nobl;

	return nobl;
}

BOOL PGPscConcatOutBuffList(void *PGPsc,
					   OUTBUFFLIST *obl,
					   char **pBuff,
					   DWORD *dwBuffSize,
					   BOOL *FYEO)
{
	OUTBUFFLIST *indexobl,*prevobl;
	DWORD memindex;
	PGPMemoryMgrRef	memmgr;
	PGPContextRef context;

	context=(PGPContextRef)PGPsc;

	*pBuff=0;
	*dwBuffSize=0;
	*FYEO=FALSE;

	if(obl==NULL)
		return TRUE;

	memmgr = PGPPeekContextMemoryMgr (context);

	// Find size and whether complete block is FYEO or not
	indexobl=obl;
	*dwBuffSize=0;
	*FYEO=FALSE;

	while(indexobl!=0)
	{
		if(indexobl->FYEO)
		{
			*FYEO=TRUE;
		}
		*dwBuffSize=*dwBuffSize+indexobl->dwBuffSize;
		indexobl=indexobl->next;
	}

	// Allocate new memory buffer
	if(*FYEO)
	{
		*pBuff=PGPNewSecureData (memmgr, *dwBuffSize+1, 0);
	}
	else
	{
		*pBuff=PGPNewData (memmgr, *dwBuffSize+1, 0);
	}

	if(*pBuff==NULL)
	{
		return FALSE;
	}

	// +1 for terminating null
	memset(*pBuff,0x00,*dwBuffSize+1);

	// Concatenate memory blocks and free originals/linked list
	indexobl=obl;
	memindex=0;

	while(indexobl!=0)
	{
		if(indexobl->pBuff!=0)
		{
			memcpy(&((*pBuff)[memindex]),indexobl->pBuff,indexobl->dwBuffSize);
			memset(indexobl->pBuff,0x00,indexobl->dwBuffSize);
			PGPFreeData(indexobl->pBuff);
			memindex=memindex+indexobl->dwBuffSize;
		}

		prevobl=indexobl;
		indexobl=indexobl->next;
		free(prevobl);
	}

	return TRUE;
}

void PGPscEnsureWindowIsOnMonitor(HWND hwnd)
{
	PGPclEnsureWindowIsOnMonitor(hwnd,NULL);
}

void FreePhrases(MYSTATE *ms)
{
	if(ms->PassPhrase)
	{
		PGPclFreeCachedPhrase(ms->PassPhrase);
		ms->PassPhrase=NULL;
	}

	if(ms->PassKey)
	{
		memset(ms->PassKey,0x00,ms->PassKeyLen);
		PGPFreeData(ms->PassKey);
		ms->PassKey=NULL;
	}

	if(ms->ConvPassPhrase)
	{
		PGPclFreePhrase(ms->ConvPassPhrase);
		ms->ConvPassPhrase=NULL;
	}
}

void AddKeys(HWND hwnd,PGPKeyDBRef AddKeyDB,MYSTATE *ms)
{
	PGPUInt32		numKeys;
	PGPError		err;

	if(PGPKeyDBRefIsValid(AddKeyDB))
	{
		PGPCountKeysInKeyDB( AddKeyDB, &numKeys );

		if ( numKeys > 0) 
		{	
			if(ms->bMutable==FALSE)
			{
				PGPscReadOnlyWarning(hwnd);
			}
			else
			{
				PGPKeySetRef keysetToAdd;

				PGPNewKeySet (AddKeyDB, &keysetToAdd);
		
				err=PGPclImportKeys (ms->context, ms->tlsContext, ms->hwndWorking,
					keysetToAdd, ms->KeyDB, kPGPclDefaultImportFlags);

				if(IsntPGPError(err))
				{
					PostMessage (HWND_BROADCAST, g_uAddedKeysMessage,0,0);
				}

				PGPFreeKeySet (keysetToAdd);
			}
		}
		PGPFreeKeyDB (AddKeyDB);
	}
}

static BOOL CALLBACK 
sReadOnlyDlgProc (
		HWND	hWndDlg, 
		UINT	uMsg, 
		WPARAM	wParam, 
		LPARAM	lParam) 
{
	switch (uMsg) {
	case WM_COMMAND:

		switch (LOWORD(wParam)) {
		case IDOK:
			if (IsDlgButtonChecked (hWndDlg, IDC_WARNNOMORE) == BST_CHECKED)
				EndDialog (hWndDlg, 1);
			else 
				EndDialog (hWndDlg, 0);
			break;
		}
		return TRUE;
	}
	return FALSE;
}


//	____________________________________
//
// Warn user that keyrings are read-only

VOID 
PGPscReadOnlyWarning(HWND hWnd) 
{
	PGPBoolean		bWarn		= TRUE;
	PGPPrefRef		prefref		= kInvalidPGPPrefRef;
	PGPError		err;

	err = PGPclPeekClientLibPrefRefs (&prefref, NULL);

	if (IsntPGPError (err)) 
	{
		PGPGetPrefBoolean (prefref, kPGPPrefWarnOnReadOnlyKeyRings, &bWarn);

		if (bWarn) 
		{
			if (DialogBox (g_hinst, MAKEINTRESOURCE (IDD_READONLY), 
						hWnd, sReadOnlyDlgProc)) 
			{
				bWarn = FALSE;
				PGPSetPrefBoolean (
						prefref, kPGPPrefWarnOnReadOnlyKeyRings, bWarn);
				PGPclFlushClientLibPrefs (prefref, NULL);
			}
		}
	}
}

BOOL OpenRings(HWND hwnd,PGPContextRef context,PGPKeyDBRef *pkeydb,PGPBoolean *bMutable)
{
	PGPError err;

	*bMutable=TRUE;

	err=PGPclOpenDefaultKeyrings(context,
		kPGPOpenKeyDBFileOptions_Mutable,pkeydb);

	if(IsPGPError(err))
	{
		err=PGPclOpenDefaultKeyrings(context,
			kPGPOpenKeyDBFileOptions_None,pkeydb);

		if(IsntPGPError(err))
		{
			*bMutable=FALSE;
		}
		else
		{
			PGPscMessageBox (hwnd,IDS_PGPERROR,IDS_CANTOPENRINGS,
				MB_OK|MB_ICONSTOP);
			return FALSE;
		}
	}
	
	return TRUE;
}

void PGPscPGPpath(char *szPath)
{
	strcpy(szPath,"");

	PGPclGetPath (kPGPclInstallFolder,szPath,MAX_PATH);
}

char *PGPscJustFile(char *filename)
{
	char *p;

	p = strrchr(filename, '\\');

	if(p!=0)
		return (p+1);
	else
		return filename;
}

BOOL PGPscGetValidityDrawPrefs(void *PGPsc,
						  BOOL *pbInputBool)
{
	PGPBoolean  bDisplayMarginal=FALSE;
	PGPPrefRef	prefRef;
	PGPError err;

	err=PGPclPeekClientLibPrefRefs(&prefRef,NULL);

	bDisplayMarginal=FALSE;

	if(IsntPGPError(err))
	{
		PGPGetPrefBoolean (prefRef,
			kPGPPrefDisplayMarginalValidity, &bDisplayMarginal);
	}

	*pbInputBool=FALSE;

	if(bDisplayMarginal)
		*pbInputBool=TRUE;

	return TRUE;
}

BOOL PGPscGetMarginalInvalidPref(void *PGPsc,
							BOOL *pbInputBool)
{
	PGPBoolean  bMarginalInvalid;
	PGPPrefRef	prefRef;
	PGPError err;

	err=PGPclPeekClientLibPrefRefs(&prefRef,NULL);

	bMarginalInvalid=FALSE;

	if(IsntPGPError(err))
	{
		PGPGetPrefBoolean (prefRef,
			kPGPPrefMarginalIsInvalid, &bMarginalInvalid);
	}

	*pbInputBool=FALSE;

	if(bMarginalInvalid)
		*pbInputBool=TRUE;
		
	return TRUE;
}

BOOL PGPscGetWipeOnDeletePrefs(void *PGPsc,
		BOOL *pbWipeOnDelete, BOOL *pbWipeProgress,DWORD *pdwPasses)
{
	PGPBoolean pgpbWipeOnDelete,pgpbWipeProgress;
	DWORD pgpdwPasses;
	PGPPrefRef	prefRef;
	PGPError err;

	pgpbWipeOnDelete=pgpbWipeProgress=FALSE;
	pgpdwPasses=1;

	err=PGPclPeekClientLibPrefRefs(&prefRef,NULL);

	if(IsntPGPError(err))
	{
		PGPGetPrefBoolean (prefRef,
			kPGPPrefAutoWipeOnDelete, &pgpbWipeOnDelete);
		pgpbWipeProgress=FALSE;
//		PGPGetPrefBoolean (prefRef,
//			kPGPPrefShowWipeProgress, &pgpbWipeProgress);
		PGPGetPrefNumber (prefRef,
			kPGPPrefFileWipePasses, 
			(PGPUInt32*)&pgpdwPasses);
	}

	*pbWipeOnDelete=(BOOL)pgpbWipeOnDelete;
	*pbWipeProgress=(BOOL)pgpbWipeProgress;
	*pdwPasses=pgpdwPasses;

	return TRUE;
}

// This creates a filelist entry for files or directories,
// and also does the callback/cancel test
UINT FileListFromFile(FILELIST **filelist,char *filename,BOOL IsDirectory,
					  ADDFILELISTCALLBACK UserProc,void *pUserValue)
{
	FILELIST *Current;
	BOOL UserCancel;

	Current=(FILELIST *)malloc(sizeof(FILELIST));

	if(Current!=NULL)
	{
		memset(Current,0x00,sizeof(FILELIST));

		Current->name=(char *)malloc(strlen(filename)+1);

		if(Current->name==NULL)
		{
			free(Current);
			Current=NULL;
		}
		else
		{
			strcpy(Current->name,filename);
			Current->next=*filelist;
			Current->IsDirectory=IsDirectory;
			*filelist=Current;
		}
	}

	// Do the callback, if we've successfully made a filelist
	if((UserProc!=NULL)&&(Current!=NULL))
	{
		UserCancel=(UserProc)(Current,pUserValue);

		if(UserCancel)
		{
			return FALSE;
		}
	}

	return TRUE;
}

UINT FileListFromDirectory(FILELIST **filelist,char *directory,
						   ADDFILELISTCALLBACK UserProc,void *pUserValue)
{
	HANDLE hFindFile;
	WIN32_FIND_DATAW FindFileDataW;
	WIN32_FIND_DATAA FindFileDataA;
	BOOL RetVal=FALSE;
	BOOL KeepGoing;
	char *search;
	char *filename;
	char *name;
	LPWSTR wide;
	int widelen;
	int namelen;
	int retval;
	BOOL IsNT=FALSE;
	DWORD dwFileAttributes;
	OSVERSIONINFO osid;

	hFindFile=INVALID_HANDLE_VALUE;

	memset(&osid,0x00,sizeof(OSVERSIONINFO));

	osid.dwOSVersionInfoSize = sizeof (OSVERSIONINFO);
	GetVersionEx (&osid);   
	IsNT=(osid.dwPlatformId == VER_PLATFORM_WIN32_NT);

	if(directory[strlen(directory)-1]!='\\')
		strcat(directory,"\\");

	if(IsNT)
	{
		search=(char *)malloc(25+strlen(directory)); // 25 for prepend plus *.*

		if(search==NULL)
		{
			;
		}
		else
		{
			if(!strncmp(directory,"\\\\",2))
			{
				// Build network search path with UNC prepend
				strcpy(search,"\\\\?\\UNC\\");
				strcat(search,&(directory[2]));
				strcat(search,"*.*");
			}
			else
			{
				// Build local drive search path
				strcpy(search,"\\\\?\\");
				strcat(search,directory);
				strcat(search,"*.*");
			}

			widelen=MultiByteToWideChar(_getmbcp(), 0, search, -1, 0,0);

			wide=(LPWSTR)malloc(widelen*sizeof(WCHAR));

			if(wide==NULL)
			{
				;
			}
			else
			{
				memset(wide,0x00,widelen*sizeof(WCHAR));

				retval=MultiByteToWideChar(_getmbcp(), 0, search,
					-1, wide,widelen);

				hFindFile=FindFirstFileW(wide,&FindFileDataW);
			
				free(wide);
			}
			memset(search,0x00,sizeof(search));
			free(search);
		}
	}
	else	
	{
		int bufsize;
		char shrtpath[MAX_PATH+1];

		bufsize=strlen(directory)+strlen("*.*")+1;

		GetShortPathName(directory,shrtpath,MAX_PATH);

		strcat(shrtpath,"*.*");

		hFindFile=FindFirstFileA(shrtpath,&FindFileDataA);

		memset(shrtpath,0x00,MAX_PATH);
	}

	if(hFindFile!=INVALID_HANDLE_VALUE)
	{
		RetVal=TRUE;

		while(RetVal==TRUE)
		{
			if(IsNT)
			{
				namelen=WideCharToMultiByte(_getmbcp(), 0, FindFileDataW.cFileName,
					-1, 0,0,NULL,NULL);
				namelen++; // If we need to add directory slash

				name=(char *)malloc(namelen);
				memset(name,0x00,namelen);

				WideCharToMultiByte(_getmbcp(), 0, FindFileDataW.cFileName,
					-1, name,namelen,NULL,NULL);

				filename=(char *)malloc(strlen(directory)+namelen+1);

				strcpy(filename,directory);
				strcat(filename,name);

				dwFileAttributes=FindFileDataW.dwFileAttributes;
			}
			else
			{
				namelen=strlen(FindFileDataA.cFileName);
				namelen++;

				name=(char *)malloc(namelen);
				strcpy(name,FindFileDataA.cFileName);

				filename=(char *)malloc(strlen(directory)+namelen+1);
				strcpy(filename,directory);
				strcat(filename,name);

				dwFileAttributes=FindFileDataA.dwFileAttributes;
			}
	
			if((dwFileAttributes&FILE_ATTRIBUTE_DIRECTORY)
				!=FILE_ATTRIBUTE_DIRECTORY)
			{
				FileListFromFile(filelist,filename,FALSE,
					UserProc,pUserValue);
			}
			else
			{
				if((strcmp(name,"."))&&
					(strcmp(name,"..")))
				{
					KeepGoing=FileListFromFile(filelist,filename,TRUE,
						UserProc,pUserValue);
					if(!KeepGoing)
					{
						FindClose(hFindFile);
						return FALSE;
					}

					KeepGoing=FileListFromDirectory(filelist,filename,UserProc,pUserValue);

					if(!KeepGoing)
					{
						FindClose(hFindFile);
						return FALSE;
					}
				}
			}

			memset(name,0x00,strlen(name));
			free(name);
			memset(filename,0x00,strlen(filename));
			free(filename);

			if(IsNT)
			{
				RetVal=FindNextFileW(hFindFile,&FindFileDataW);
			}
			else
			{
				RetVal=FindNextFileA(hFindFile,&FindFileDataA);
			}
		}

		FindClose(hFindFile);
	}

	return TRUE;
} 

BOOL PGPscAddToFileList(FILELIST **filelist,char *filename,
						ADDFILELISTCALLBACK UserProc,void *pUserValue)
{
	DWORD dwFileAttributes;
	UINT RetVal;

	dwFileAttributes=GetFileAttributes(filename);

	if(dwFileAttributes==0xFFFFFFFF)
		return TRUE;

	if((dwFileAttributes&FILE_ATTRIBUTE_DIRECTORY)
		==FILE_ATTRIBUTE_DIRECTORY)
	{
		RetVal=FileListFromFile(filelist,filename,TRUE,
			UserProc,pUserValue);

		if(!RetVal)
			return FALSE;

		RetVal=FileListFromDirectory(filelist,filename,UserProc,pUserValue);
	}
	else
	{
		RetVal=FileListFromFile(filelist,filename,FALSE,
			UserProc,pUserValue);
	}

	return RetVal;
}

BOOL PGPscFreeFileList(FILELIST *FileList)
{
	FILELIST *FreeAtLast;

	while(FileList!=0)
	{
		FreeAtLast=FileList;
		FileList=FileList->next;
		memset(FreeAtLast->name,0x00,strlen(FreeAtLast->name));
		free(FreeAtLast->name);
		memset(FreeAtLast,0x00,sizeof(FILELIST));
		free(FreeAtLast);
	}

	return TRUE;
}

FILELIST *PGPscHDropToFileList(HDROP hDrop)
{
	char szFile[5000+1];
	int NumFiles,i,ReturnCode;
	FILELIST *ListHead;

	NumFiles=DragQueryFile(hDrop,0xFFFFFFFF,NULL,0);
	ListHead=0;
	ReturnCode=TRUE;

	if(NumFiles==0)
		return 0;

	for(i=0;i<NumFiles && ReturnCode == TRUE;i++)
	{
		DragQueryFile(hDrop,i,szFile,5000);
		PGPscAddToFileList(&ListHead,szFile,NULL,NULL);
	}

	return ListHead;
}

FILELIST *PGPscCmdLineToFileList(char *szCmdLine)
{
	char *szNext,*szNow;
	FILELIST *ListHead;
	HANDLE hFindFile;
	WIN32_FIND_DATAA FindFileDataA;
	char szLongName[MAX_PATH+1];
	char *name;
	char *path;

	szNext=szCmdLine;
	ListHead=0;

	while(szNext!=NULL)
	{
		szNow=szNext;
			
		szNext=strstr(szNext," ");
		
		if(szNext!=NULL)
		{
			szNext=strstr(szNext,":\\");

			if(szNext!=NULL)
			{
				szNext=szNext-2;
				if(szNext>szCmdLine)
				{
					*szNext=0;
					szNext++;
				}
				else
				{
					szNext=NULL;
				}
			}
		}
		
		strcpy(szLongName,szNow);

		hFindFile=FindFirstFileA(szNow,&FindFileDataA);

		if(hFindFile!=NULL)
		{
			name=strrchr(szNow,'\\');

			if(name!=NULL)
			{
				path=szNow;
				*name=0;
				name++;

				strcpy(szLongName,path);
				strcat(szLongName,"\\");
				strcat(szLongName,FindFileDataA.cFileName);
			}
			else
			{	
				strcpy(szLongName,FindFileDataA.cFileName);
			}

			CloseHandle(hFindFile);
		}

		PGPscAddToFileList(&ListHead,szLongName,NULL,NULL);
	}

	return ListHead;
}

UINT PGPscQueryCacheSecsRemaining (void)
{
// There is no longer a local cache

//	UINT SignCacheSecs;
//	UINT DecCacheSecs;

//	SignCacheSecs=PGPclQuerySigningCacheSecsRemaining();
//	DecCacheSecs=PGPclQueryDecryptionCacheSecsRemaining ();

//	if(SignCacheSecs>DecCacheSecs)
//		return SignCacheSecs;

//	return DecCacheSecs;

	return 0;
}

BOOL PGPscPreferences(HWND hwnd,void *PGPsc,void *PGPtls)
{
	PGPContextRef context;
	PGPtlsContextRef tls;

	context=(PGPContextRef)PGPsc;
	tls=(PGPtlsContextRef)PGPtls;

	PGPclPreferences(context,hwnd, kPGPclGeneralPrefs, NULL);

	return TRUE;
}

BOOL PGPscAbout (HWND hwnd,void *PGPsc)
{
	PGPContextRef context;

	context=(PGPContextRef)PGPsc;

	PGPclHelpAbout (context,hwnd,NULL,NULL,NULL);

	return TRUE;
}

BOOL PGPscDoLaunchKeys(HWND hwnd)
{  
	char PGPkeys[MAX_PATH];
	char StrRes[500];
	
	PGPscPGPpath(PGPkeys);

// Since Windows can't handle tray launched from CD
	SetCurrentDirectory(PGPkeys);

	strcat(PGPkeys,"PGPkeys.exe");
 
	if(!PGPclExecute(PGPkeys, SW_SHOW))
	{ 
		LoadString (g_hinst, IDS_CANTOPENPGPKEYS, StrRes, sizeof(StrRes));

		MessageBox(hwnd,PGPkeys,
			StrRes,
			MB_OK|MB_ICONSTOP|MB_SETFOREGROUND);

		return FALSE;
	}

	return TRUE;
}

BOOL PGPscDoLaunchNet(HWND hwnd)
{  
	char PGPnet[MAX_PATH];
	int error;
	char StrRes[500];
	
	PGPscPGPpath(PGPnet);

// Since Windows can't handle tray launched from CD
	SetCurrentDirectory(PGPnet);

	strcat(PGPnet,"PGPnet.exe");
	error=WinExec(PGPnet, SW_SHOW);
 
	if(error<=31)
	{ 
		LoadString (g_hinst, IDS_CANTOPENPGPNET, StrRes, sizeof(StrRes));

		MessageBox(hwnd,PGPnet,
			StrRes,
			MB_OK|MB_ICONSTOP|MB_SETFOREGROUND);

		return FALSE;
	}

	return TRUE;
}

BOOL PGPscDoLaunchTools(HWND hwnd)
{  
	char PGPtools[MAX_PATH];
	char StrRes[500];

	PGPscPGPpath(PGPtools);

// Since Windows can't handle tray launched from CD
	SetCurrentDirectory(PGPtools);

	strcat(PGPtools,"PGPmail.exe");
 
	if(!PGPclExecute(PGPtools, SW_SHOW))
	{ 
		LoadString (g_hinst, IDS_CANTOPENPGPTOOLS, StrRes, sizeof(StrRes));

		MessageBox(hwnd,PGPtools,
			StrRes,
			MB_OK|MB_ICONSTOP|MB_SETFOREGROUND);

		return FALSE;
	}

	return TRUE;
}

BOOL PGPscDoLaunchDisk(HWND hwnd)
{  
	char PGPtools[MAX_PATH];
	char StrRes[500];

	PGPscPGPpath(PGPtools);

// Since Windows can't handle tray launched from CD
	SetCurrentDirectory(PGPtools);

	strcat(PGPtools,"PGPdisk.exe");
 
	if(!PGPclExecute(PGPtools, SW_SHOW))
	{ 
		LoadString (g_hinst, IDS_CANTOPENPGPDISK, StrRes, sizeof(StrRes));

		MessageBox(hwnd,PGPtools,
			StrRes,
			MB_OK|MB_ICONSTOP|MB_SETFOREGROUND);

		return FALSE;
	}

	return TRUE;
}

BOOL ReadWipePref(PGPContextRef context,
				  PGPBoolean *pbWarnOnWipe)
{
	PGPPrefRef prefRef;
	PGPError err;

	*pbWarnOnWipe=TRUE;

	err=PGPclPeekClientLibPrefRefs(&prefRef,NULL);
	
	if(IsntPGPError(err))
	{
		PGPGetPrefBoolean (prefRef,
			kPGPPrefWarnOnWipe, pbWarnOnWipe);
	}

	return TRUE;
}

BOOL PGPscEraseClipboard(HWND hwnd,void *PGPsc)
{
	int result;
	PGPBoolean bWarnOnWipe;
	PGPContextRef context;
	int rst;

	context=(PGPContextRef)PGPsc;

	if(hwnd!=NULL)
	{
		ReadWipePref(context,&bWarnOnWipe);

		if(bWarnOnWipe)
		{
			rst=PGPscMessageBox (hwnd,IDS_LASTCHANCE,IDS_REALLYWIPECLIPBOARD,
					MB_YESNO|MB_DEFBUTTON2|MB_ICONEXCLAMATION);	

			if(rst==IDNO)
				return FALSE;
		}
	}

	OpenClipboard(NULL);

	result=EmptyClipboard();

	CloseClipboard();

	return result;
}

BOOL CheckClipboard()
{
	char *pInput;
	DWORD dwInputSize;
	UINT ClipboardFormat;
	BOOL RetVal;

	RetVal=FALSE;

	pInput=RetrieveClipboardData
			(NULL,&ClipboardFormat,&dwInputSize);

	if((ClipboardFormat == CF_TEXT)&&(pInput!=0))
	{
		if(*pInput!=0)
		{
			RetVal=TRUE;
		}
	}

	if(pInput!=0)
	{
		memset(pInput,0x00,dwInputSize);
		free(pInput);
	}

	return RetVal;
}

void ControlA(SCSHARED *scShared)
{
	scShared->g_KeyArray[0]=VK_CONTROL|SK_KEYDOWN;
	scShared->g_KeyArray[1]='A'|SK_KEYDOWN;
	scShared->g_KeyArray[2]='A';
	scShared->g_KeyArray[3]=VK_CONTROL;

	SendKeys( scShared->g_KeyArray, 4 );
}

void ControlC(SCSHARED *scShared)
{
	scShared->g_KeyArray[0]=VK_CONTROL|SK_KEYDOWN;
	scShared->g_KeyArray[1]='C'|SK_KEYDOWN;
	scShared->g_KeyArray[2]='C';
	scShared->g_KeyArray[3]=VK_CONTROL;

	SendKeys( scShared->g_KeyArray, 4 );
}

void ControlV(SCSHARED *scShared)
{
	scShared->g_KeyArray[0]=VK_CONTROL|SK_KEYDOWN;
	scShared->g_KeyArray[1]='V'|SK_KEYDOWN;
	scShared->g_KeyArray[2]='V';
	scShared->g_KeyArray[3]=VK_CONTROL;

	SendKeys( scShared->g_KeyArray, 4 );
}

void EMSetSel(HWND hwndEdit)
{
	SendMessage(hwndEdit,EM_SETSEL,0,-1);
}

void WMCopy(HWND hwndEdit)
{
	SendMessage(hwndEdit,WM_COPY,0,0);
}

HWND PGPscReadCurrentFocus()
{
	return PGPhkReadCurrentFocus();
}

BOOL PGPscDoCopy(HWND hwnd,void *PGPsc,BOOL bUseCurrent,HWND *hwndFocus,BOOL *bStartingCR)
{
	BOOL ClipOK;
	HWND hwndEdit;
	BOOL RetVal=TRUE;
	char WinClass[256];
	PGPContextRef context;
	DWORD OtherAppThreadID;
	DWORD OtherAppProcessID;
	HWND hwndOldFocus;
	DWORD TrayThreadID;
	SCSHARED *scShared;
	HANDLE hMapObject;
	
	*bStartingCR=FALSE;

	// Lots of overhead here but the only way to do it for
	// terminal services and XP. .
	scShared=SCGetSharedMem(&hMapObject);

	context=(PGPContextRef)PGPsc;

	*hwndFocus=NULL;

	if(bUseCurrent)
	{
		TrayThreadID=GetCurrentThreadId();
		hwndEdit=PGPhkReadCurrentFocus();
		*hwndFocus=hwndEdit;

		GetClassName(hwndEdit,WinClass,255);

		PGPscEraseClipboard(NULL,context);

		// We can key off WinClass if something else
		// needs to be done 

		OtherAppThreadID = GetWindowThreadProcessId( hwndEdit, 
			&OtherAppProcessID);

		AttachThreadInput( TrayThreadID, OtherAppThreadID, TRUE );

		hwndOldFocus=SetFocus(hwndEdit);

		*bStartingCR=TRUE; // Selected text

		WMCopy(hwndEdit);

		ClipOK=CheckClipboard();
		if(!ClipOK)
		{
			*bStartingCR=FALSE; // Needed CTRL A

			// We can key off WinClass if something else
			// needs to be done 
			EMSetSel(hwndEdit);
			WMCopy(hwndEdit);

			ClipOK=CheckClipboard();
			if(!ClipOK)
			{
				*bStartingCR=TRUE; // Selected Text

				ControlC(scShared);
			
				ClipOK=CheckClipboard();
				if(!ClipOK)
				{
					*bStartingCR=FALSE; // Needed CTRL A

					ControlA(scShared);
					ControlC(scShared);

					ClipOK=CheckClipboard();
					if(!ClipOK)
					{
						RetVal=FALSE;
					}
				}
			}
		}

		AttachThreadInput( TrayThreadID, OtherAppThreadID, FALSE );
		SetFocus(hwndOldFocus);
	}

	if(!RetVal)
	{
#if _DEBUG
		char szInfo[256];

		sprintf(szInfo,"Class %s HWND %x",WinClass,hwndEdit);

		MessageBox(hwnd,szInfo,"Couldn't get text. _DEBUG VERSION ONLY_ info",
			MB_OK|MB_ICONSTOP|MB_SETFOREGROUND);
#else
		PGPscMessageBox (hwnd,IDS_PGPERROR,IDS_CANTAUTOCOPY,
			MB_OK|MB_ICONSTOP);
#endif
	}

	SCReleaseSharedMem(scShared,hMapObject);

	return RetVal;
}

void PGPscDoPaste(BOOL bUseCurrent,HWND hwndFocus)
{
	HWND hwndEdit;
	char WinClass[256];
	DWORD OtherAppThreadID;
	DWORD OtherAppProcessID;
	DWORD TrayThreadID;
	SCSHARED *scShared;
	HANDLE hMapObject;
	
	// Lots of overhead here but the only way to do it for
	// terminal services and XP. .
	scShared=SCGetSharedMem(&hMapObject);

	if(bUseCurrent)
	{
		TrayThreadID=GetCurrentThreadId();
		hwndEdit=hwndFocus; 
		GetClassName(hwndEdit,WinClass,255);

		OtherAppThreadID = GetWindowThreadProcessId( hwndEdit, 
			&OtherAppProcessID);

		AttachThreadInput( TrayThreadID, OtherAppThreadID, TRUE );

		// We can key off WinClass if something else
		// needs to be done 

		SetFocus(hwndEdit);

		ControlV(scShared);

		AttachThreadInput( TrayThreadID, OtherAppThreadID, FALSE );
	}

	SCReleaseSharedMem(scShared,hMapObject);
}

void PGPscDoFocus(BOOL bUseCurrent,HWND hwndFocus)
{
	HWND hwndEdit;
	char WinClass[256];
	DWORD OtherAppThreadID;
	DWORD OtherAppProcessID;
	DWORD TrayThreadID;

	if(bUseCurrent)
	{
		TrayThreadID=GetCurrentThreadId();
		hwndEdit=hwndFocus; 
		GetClassName(hwndEdit,WinClass,255);

		OtherAppThreadID = GetWindowThreadProcessId( hwndEdit, 
			&OtherAppProcessID);

		AttachThreadInput( TrayThreadID, OtherAppThreadID, TRUE );

		// We can key off WinClass if something else
		// needs to be done 

		SetFocus(hwndEdit);

		AttachThreadInput( TrayThreadID, OtherAppThreadID, FALSE );
	}
}

 
BOOL FileHasThisExtension(char *filename,char *extension)
{
	char *p;

	if(filename!=NULL)
	{
		if((p = strrchr(filename, '\\')))
			filename=p; // we just want the filename not path

		if((p = strrchr(filename, '.')))
		{
			p++;

			if(!strcmpi(p,extension))
				return TRUE;
		}
	}

	return FALSE;
}
	
LRESULT CALLBACK PlaybackHook( int nCode, WPARAM wParam,
                 LPARAM lParam )
{
	LPEVENTMSG lpEM;
	SCSHARED *scShared;
	HANDLE hMapObject;
	
	// Lots of overhead here but the only way to do it for
	// terminal services and XP. .
	scShared=SCGetSharedMem(&hMapObject);

	switch(nCode) 
	{
		case HC_SKIP:
		{
			scShared->g_fDelay = TRUE;      // CORRECT PLACE TO RESET fDelay

			scShared->g_KeyIndex++;
			if( scShared->g_KeyIndex == scShared->g_NumKeys ) 
			{  
				// no more keys?
				// remove hook
				UnhookWindowsHookEx(scShared->g_hJournalHook);
				scShared->g_hJournalHook = NULL;
			}
			SCReleaseSharedMem(scShared,hMapObject);
			return 0;
		}

		case HC_GETNEXT:
		{
			lpEM = (LPEVENTMSG)lParam;
			if( scShared->lpJournalKeys[scShared->g_KeyIndex] & SK_KEYDOWN )
				lpEM->message = scShared->lpJournalKeys[scShared->g_KeyIndex] & SK_SYSKEY
                                        ? WM_SYSKEYDOWN : WM_KEYDOWN;
			else
				lpEM->message = scShared->lpJournalKeys[scShared->g_KeyIndex] & SK_SYSKEY 
                                        ? WM_SYSKEYUP : WM_KEYUP;
			lpEM->paramL = LOBYTE(scShared->lpJournalKeys[scShared->g_KeyIndex])
               | (MapVirtualKey(LOBYTE(scShared->lpJournalKeys[scShared->g_KeyIndex]),0)<<8);
			lpEM->paramH = 1;
			lpEM->time = GetCurrentTime();

			if( scShared->g_fDelay )
			{
				// Toggle pause variable so that the next call will not
				// pause. Return the pause length specified by
				// ticks_delay since this is the first time the event
				// has been requested.

				scShared->g_fDelay = FALSE; // <<<< CORRECT PLACE TO CLEAR fDelay

				SCReleaseSharedMem(scShared,hMapObject);
				return( 100 ); // 50 milliseconds changed to 100 for termserver
			}
			else
			{
				SCReleaseSharedMem(scShared,hMapObject);
				// Duplicate event. Return 0 delay
				return 0;
			}
		}

		default:
		{
			HHOOK hJournalHook;

			hJournalHook=scShared->g_hJournalHook;

			SCReleaseSharedMem(scShared,hMapObject);
			return CallNextHookEx(hJournalHook,nCode,wParam,lParam);
		}
	}
}

BOOL ClearMessageLoop(void)
{
	MSG msg;

	// Clear the message loop
	while( PeekMessage(&msg,NULL,0,0,PM_REMOVE) ) 
	{
		if( msg.message == WM_QUIT ) 
		{
			PostMessage(msg.hwnd,msg.message,msg.wParam,msg.lParam);
			return FALSE;
		}
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}

	return TRUE;
}

#define KeyDown( uKey ) ( GetAsyncKeyState(uKey) & 0x8000 )

BOOL WINAPI SendKeys( UINT *lpKeys, UINT nKeys )
{
	MSG msg;
	SCSHARED *scShared;
	HANDLE hMapObject;
	
	// Lots of overhead here but the only way to do it for
	// terminal services and XP. .
	scShared=SCGetSharedMem(&hMapObject);

	if( scShared->g_hJournalHook )
	{
#ifdef _DEBUG
		// Should never get here...
		MessageBox(NULL,"Hook already exists? Exiting...",
			"DEBUG INFO ONLY!",
			MB_OK);
#endif
		SCReleaseSharedMem(scShared,hMapObject);
		return FALSE;
	}

	if(!ClearMessageLoop())
	{
		SCReleaseSharedMem(scShared,hMapObject);
		return FALSE;
	}

	// Sit and spin until control keys are released
	while( KeyDown(VK_MENU) || KeyDown(VK_SHIFT) || KeyDown(VK_CONTROL) ) 
	{
		if( PeekMessage(&msg,NULL,0,0,PM_REMOVE) ) 
		{
			if( msg.message == WM_QUIT ) 
			{
				PostMessage(msg.hwnd,msg.message,msg.wParam,msg.lParam);
				SCReleaseSharedMem(scShared,hMapObject);
				return FALSE;
			}
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	if(!ClearMessageLoop())
	{
		SCReleaseSharedMem(scShared,hMapObject);
		return FALSE;
	}

	scShared->lpJournalKeys = lpKeys;
	scShared->g_KeyIndex =   0;
	scShared->g_NumKeys =  nKeys;
	scShared->g_fDelay = TRUE;

	scShared->g_hJournalHook = SetWindowsHookEx(WH_JOURNALPLAYBACK,
      (HOOKPROC)PlaybackHook,g_hinst,0);

	// While hooking, pump the messages
	while(scShared->g_hJournalHook) 
	{
		if( PeekMessage(&msg,NULL,0,0,PM_REMOVE) ) 
		{
			if( msg.message == WM_QUIT ) 
			{
				if( scShared->g_hJournalHook )
				{
					UnhookWindowsHookEx(scShared->g_hJournalHook);
				}
				PostMessage(msg.hwnd,msg.message,msg.wParam,msg.lParam);
				SCReleaseSharedMem(scShared,hMapObject);
				return FALSE;
			}
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	if(!ClearMessageLoop())
	{
		SCReleaseSharedMem(scShared,hMapObject);
		return FALSE;
	}

	SCReleaseSharedMem(scShared,hMapObject);
	return TRUE;
}
		
/*__Editor_settings____

	Local Variables:
	tab-width: 4
	End:
	vi: ts=4 sw=4
	vim: si
_____________________*/
