/*__________________________________________________________________________
 Copyright (C) 2002 PGP Corporation
 All rights reserved.
 
 $Id: SCwipe.c,v 1.23 2002/11/17 18:46:10 wjb Exp $
__________________________________________________________________________*/
#include "precomp.h"
#include <time.h>
#include <sys/types.h>
#include <sys/stat.h>
#include "shlobj.h"

#include "PGPsdkDriver.h"
#include "NotifyShell.h"

BOOL WipeError(HWND hwnd,FILELIST *FileEntry,UINT error)
{
	int ErrMsg;
	char StrRes[500];
	int nMsgBoxResult;
	BOOL bCancel = FALSE;
	UINT MBoxFlag;

	MBoxFlag=MB_OKCANCEL;

	switch(error)
	{
		case WIPE_NOTOPEN:
			ErrMsg=IDS_WIPENOTOPEN;
			break;
		case WIPE_USERABORT:
			ErrMsg=IDS_WIPEUSERABORT;
			bCancel = TRUE;
			break;
		case WIPE_NOSTATS:
			ErrMsg=IDS_WIPENOSTATS;
			break;

		case WIPE_NOREMOVE:
			ErrMsg=IDS_WIPENOREMOVE;
			break;
	
		case WIPE_NOFLUSH:
			ErrMsg=IDS_WIPENOFLUSH;
			break;

		case WIPE_NOFILEMAP:
			ErrMsg=IDS_WIPENOFILEMAP;
			break;

		case WIPE_NOMEMMAP:
			ErrMsg=IDS_WIPENOMEMMAP;
			break;

		case WIPE_ALREADYOPEN:
			ErrMsg=IDS_WIPEALREADYOPEN;
			break;

		case WIPE_WRITEPROTECT:
			ErrMsg=IDS_WIPEPROTECT;
			break;
	}

	LoadString (g_hinst, ErrMsg, StrRes, sizeof(StrRes));

	// There is no next file, so we don't put up both...
	if(FileEntry->next==NULL)
		MBoxFlag=MB_OK;

	nMsgBoxResult = MessageBox(hwnd,StrRes,PGPscJustFile(FileEntry->name),
						MBoxFlag|MB_ICONSTOP|MB_SETFOREGROUND);

	if (nMsgBoxResult == IDCANCEL)
		bCancel = TRUE;

	return bCancel;
}

BOOL WINAPI DeleteDlgProc(HWND hdlg, UINT uMsg, 
                             WPARAM wParam, LPARAM lParam)
{
    switch(uMsg)
    {
        case WM_INITDIALOG:
		{
			FILELIST *flist;
			int maxwidth,namelen;
			SIZE sizeString;
			HDC hdc;
			HWND hwndLB;
			int retval;
			HBITMAP hBmp;
			DWORD bits,bmp;
			HFONT hFont,hOldFont;

			flist=(FILELIST *)lParam;
			maxwidth=0;

			hwndLB=GetDlgItem(hdlg,IDC_FILELIST);

			hFont = (HFONT) GetStockObject(ANSI_VAR_FONT);
			SendMessage(hwndLB, WM_SETFONT, (WPARAM) hFont, 
				MAKELPARAM(TRUE, 0));

			hdc=GetDC(hwndLB);

			hOldFont=SelectObject(hdc,hFont);

			// Determine which bitmap will be displayed 
			bits = GetDeviceCaps (hdc, BITSPIXEL) * GetDeviceCaps (hdc, PLANES);

			if (bits <= 1)
				bmp = IDB_WIPEWIZ1;
			else if (bits <= 8) 
				bmp = IDB_WIPEWIZ4;
			else 
				bmp = IDB_WIPEWIZ8; 

			hBmp = LoadBitmap(g_hinst, MAKEINTRESOURCE(bmp));

			SendDlgItemMessage(	hdlg, 
				IDC_SECUREPIC, 
				STM_SETIMAGE, 
				IMAGE_BITMAP, 
				(LPARAM) hBmp);

			while(flist!=0)
			{
				SendMessage(hwndLB,
					LB_ADDSTRING,0,(LPARAM)flist->name);

				namelen=strlen(flist->name);
				retval=GetTextExtentPoint32(hdc, flist->name, namelen, &sizeString);
				
				sizeString.cx+=GetSystemMetrics(SM_CXVSCROLL);

				if(sizeString.cx>maxwidth)
					maxwidth=sizeString.cx;

				flist=flist->next;
			}

			SelectObject(hdc,hOldFont);

			ReleaseDC(hwndLB,hdc);

			SendMessage(hwndLB,
				LB_SETHORIZONTALEXTENT,(WPARAM)maxwidth,0);

			ShowWindow(hdlg,SW_SHOW);
			SetForegroundWindow(hdlg);

			return TRUE;
		}

		case WM_CLOSE:
		case WM_QUIT:
		case WM_DESTROY:
		{
			EndDialog(hdlg, FALSE);
			break;
		}

        case WM_COMMAND:
        {
            switch(wParam)
            {
				case IDYES:
				{
					EndDialog(hdlg, TRUE);
					break;
				}

				case IDNO:
				{
					EndDialog(hdlg, FALSE);
					break;
				}
			}
			break;
		}
	}
	return FALSE;
}

PGPError WipeFileListStub (MYSTATE *ms) 
{
	PGPContextRef context;
	FILELIST *FileCurrent;
	UINT WipeReturn;
	char StrRes[500];
	PGPError err;

	err=kPGPError_NoErr;

	context=ms->context;

	FileCurrent=ms->ListHead;

	while(!(PGPscProgressGetCancel(ms->hwndWorking))&&(FileCurrent!=0)&&(IsntPGPError(err)))
	{    
		if(FileCurrent->IsDirectory)
		{
			int result;

			result=_rmdir(FileCurrent->name);

			if(result!=0)
			{
				LoadString (g_hinst, IDS_DIRNOTREMOVED, StrRes, sizeof(StrRes));

				MessageBox(ms->hwndWorking,FileCurrent->name,StrRes,
					MB_OK|MB_ICONSTOP|MB_SETFOREGROUND);
				err=kPGPError_UnknownError;
			}

			FileCurrent=FileCurrent->next;
			continue;
		}

		WipeReturn=WipeStreams(ms->context,
			ms->hwndWorking,
			FileCurrent->name,WIPE_DEFAULT,0);

//		return WIPE_OK; For testing wiping of streams

		if(WipeReturn!=WIPE_OK)
		{
			if(!((BOOL)(ms->dwWipeFlags&WIPE_DONOTERROR)))
			{
				if (WipeError(ms->hwndWorking,FileCurrent,WipeReturn))
					err=kPGPError_UnknownError;
			}
		}
		else
		{
			WipeReturn=InternalFileWipe(ms->context,
				ms->hwndWorking,FileCurrent->name,ms->dwWipeFlags,
				ms->dwPasses,0);

			if(WipeReturn!=WIPE_OK)
			{
				if(!((BOOL)(ms->dwWipeFlags&WIPE_DONOTERROR)))
				{
					if (WipeError(ms->hwndWorking,FileCurrent,WipeReturn))
						err=kPGPError_UnknownError;
				}
			}
		}

		FileCurrent=FileCurrent->next;				
	}

	return err;
}


BOOL PGPscWipeFileList(HWND hwnd,void *PGPsc,FILELIST *ListHead,DWORD dwWipeFlags,
					   DWORD dwPasses)
{
	MYSTATE *ms;
	PGPBoolean bWarnOnWipe;
	BOOL DeleteThem;
	PGPContextRef context;
	PGPError err;

	err=kPGPError_NoErr;

	context=(PGPContextRef)PGPsc;

	bWarnOnWipe=FALSE;

	if(!(BOOL)(dwWipeFlags&WIPE_DONOTWARN))
	{
		// This way we can avoid the pref via WIPE_DONOTWARN
		ReadWipePref(context,&bWarnOnWipe);
	}

	if(bWarnOnWipe)
	{
		DeleteThem=DialogBoxParam(g_hinst, 
			MAKEINTRESOURCE( IDD_DELETEDLG),
            hwnd, 
            (DLGPROC) DeleteDlgProc, 
            (LPARAM) ListHead);

		if(!DeleteThem)
		{
			return FALSE;
		}
	}

	ms=(MYSTATE *)malloc(sizeof(MYSTATE));

	if(ms)
	{
		memset(ms, 0x00, sizeof(MYSTATE) );

		ms->context=context;
		ms->ListHead=ListHead;
		ms->Operation=MS_WIPEFILELIST;
		ms->dwWipeFlags=dwWipeFlags;
		ms->dwPasses=dwPasses;
	
		if((BOOL)(dwWipeFlags&WIPE_DONOTPROGRESS))
		{
			err=WipeFileListStub (ms);
		}
		else
		{
			err=PGPscProgressDialog(hwnd,DoWorkThread,ms,
			  0,"Wiping File(s)...",
			  "","",IDR_ERASEAVI);
		}

		free(ms);
	}
	
	PGPscFreeFileList(ListHead);

	if(IsPGPError(err))
		return FALSE;

	return TRUE;
}

// Windows 95 IFSmgr _VolFlush call
BOOL Win95Flush(HANDLE hDriver,char *szFilename)
{
	PGPWIPEDELETESTRUCT pwds;
	DWORD dwLen;

	memset(&pwds,0x00,sizeof(PGPWIPEDELETESTRUCT));

	pwds.ulVolume=toupper(szFilename[0])-'A'; // zero based
	pwds.ulOperation=kPGPUDOperation_VolFlush;

	if(hDriver!=0)
	{
		if(DeviceIoControl(hDriver, IOCTL_PGPUTIL_WIPEDELETE,
			&pwds, sizeof(PGPWIPEDELETESTRUCT),
			&pwds, sizeof(PGPWIPEDELETESTRUCT),
			&dwLen, NULL ))
		{
//			MessageBox(NULL,"DeviceIO OK!","Ha!",MB_OK);
			return TRUE;
		}
	}

	return FALSE;
}

static const char	kPGPMemLockDriver95Name[] = "\\\\.\\PGPsdk.vxd";

#define MEGABYTE (1024*1024)
#define ONETWENTYEIGHT 128*1024

#define LOLONG(l)           ((PGPUInt32)(l))
#define HILONG(l)           ((PGPUInt32)(((PGPUInt64)(l) >> 32) & 0xFFFFFFFF))

UINT InternalFileWipe(PGPContextRef context,HWND hwnd,
					  char *FileName,DWORD dwWipeFlags,
					  DWORD dwPasses,PGPUInt64 dwSizeADS)
{

	PGPUInt64 ui64Size;
	PGPUInt64 Zap64Size;
	DWORD dwPageSize;
	PGPUInt64 ui64NumPages;
	DWORD lastError;

	SYSTEM_INFO sysinfo;
	HANDLE hFile;
	HANDLE hMap;
	LPSTR lpFile;
	int count = 0;
    BOOL CancelOperation;
	BOOL bMoveFileSuccess;
	struct _stati64 buf;
	UINT wipe_err = 0;
	MYSTATE *ms;
	int staterror;
	char NewFileName[MAX_PATH+1];
	int retval;
	DWORD dwFileAttributes;
	char *name;
	char letter;
	FILE *ftest;

	PGPError		error			= kPGPError_NoErr;
	PGPDiskWipeRef	wipeRef			= NULL;
	PGPInt32		buffer[256];
	PGPInt32		passes			= kPGPNumPatterns;
	OSVERSIONINFO osid;
	BOOL bIsNT;
	HANDLE hDriver;
	PGPError err;
	int numletters;
	DWORD quanta;

	osid.dwOSVersionInfoSize = sizeof (osid);
	GetVersionEx (&osid);   
	bIsNT=(osid.dwPlatformId == VER_PLATFORM_WIN32_NT);

	CancelOperation=FALSE;

	if((dwPasses==0)||(dwPasses>32))
	{
		PGPPrefRef prefRef;
		
		prefRef=NULL;
		passes=1;

		err=PGPclPeekClientLibPrefRefs(&prefRef,NULL);

		if(IsntPGPError(err))
		{
			PGPGetPrefNumber (prefRef,
				kPGPPrefFileWipePasses, 
				(PGPUInt32*)&passes);
		}
	}
	else
	{
		passes=dwPasses;
	}

	GetSystemInfo(&sysinfo);

	dwPageSize = sysinfo.dwPageSize;

	if((dwWipeFlags&WIPE_ADS)==WIPE_ADS)
	{
		ui64Size=dwSizeADS;
	}
	else
	{
		staterror=_stati64(FileName, &buf );
		ui64Size = buf.st_size;        //  Get the file's size

		if(staterror!=0)
			return WIPE_NOTOPEN; // check to make sure still around
	}

    if(hwnd!=NULL)
	{
		ms=(MYSTATE *)PGPscProgressGetUserValue(hwnd);
	}
	
	if(hwnd!=NULL)
	{
		PGPscProgressSetNewFilename(ms->hwndWorking,"From '%s'",FileName,TRUE);
	}
	
	// Movefile can't handle file names more than MAX_PATH
	if(strlen(FileName)>=MAX_PATH-11)
		return WIPE_NOTOPEN;

	strcpy(NewFileName,FileName);

	if((dwWipeFlags&WIPE_ADS)!=WIPE_ADS)
	{
		name=strrchr(NewFileName,'\\');

		if(name==NULL)
			name=NewFileName;
		else
			name++;

		// Set the filename to a's as much as MAX_PATH
		// will allow to write over old filename entries
		letter='a';
		ftest=0;

		do
		{
			if(ftest!=0)
				fclose(ftest);

			numletters=&(NewFileName[MAX_PATH])-name;
			memset(name,letter,numletters);
			memset(name,'a',8);
			NewFileName[MAX_PATH-10]=0;
			letter=letter+1;

			ftest=fopen(NewFileName,"r");
		} while ((letter<='z')&&(ftest!=0));

		if(ftest!=0)
		{
			fclose(ftest);
			return WIPE_NOTOPEN;
		}
	}

	// Try to make writable if readonly
	dwFileAttributes=GetFileAttributes(FileName);
	dwFileAttributes&=~FILE_ATTRIBUTE_READONLY;
	retval=SetFileAttributes(FileName,dwFileAttributes);

	if((dwWipeFlags&WIPE_ADS)!=WIPE_ADS)
	{
		bMoveFileSuccess = NotifyShellRename(FileName, NewFileName);
		if (!bMoveFileSuccess)
		{
			DWORD dwLastError;

			dwLastError = GetLastError();

			switch (dwLastError)
			{
				case ERROR_SHARING_VIOLATION:
					return WIPE_ALREADYOPEN;

				case ERROR_WRITE_PROTECT:
					return WIPE_WRITEPROTECT;

				case ERROR_REQUEST_ABORTED:
					return WIPE_USERABORT;

				case ERROR_ACCESS_DENIED:
				default:
					return WIPE_NOTOPEN;
			}
		}
	}

	if( ui64Size==0 ) 
	{
		if(dwWipeFlags&WIPE_DONOTDELETE)
			NotifyShellRename(NewFileName,FileName);
		else
		{
			NotifyShellOperation(NewFileName,PGPNS_DELETE);
//			NotifyShellOperation(FileName,PGPNS_FORCEDELNOTIFY); // For brain dead XP NTFS shell
		}
		return WIPE_OK;
	}

	/* we want to wipe out to next page boundary */

	// Get up to one more page to make fit
	ui64NumPages = (ui64Size+(PGPUInt64)dwPageSize-(PGPUInt64)1)/
		((PGPUInt64)dwPageSize);
			
	ui64Size = ui64NumPages * (PGPUInt64)dwPageSize;

	// Code to blow out 64K lazy write buffer on NTFS
	Zap64Size = ((ONETWENTYEIGHT+(PGPUInt64)dwPageSize-1)/(PGPUInt64)dwPageSize)*dwPageSize;
	if(Zap64Size<ui64Size)
		Zap64Size=ui64Size;

	quanta=(MEGABYTE/dwPageSize)*dwPageSize;

	// This is their last chance before it goes FUBAR!!!!!
	if(hwnd!=NULL)
	{
		if(PGPscProgressGetCancel(hwnd))
			CancelOperation=TRUE;
		
		if(CancelOperation)
		{
			// Back from deaths door
			NotifyShellRename(NewFileName,FileName);
			return WIPE_USERABORT;
		}
	}

	// Support for Windows 95 IFSmgr _VolFlush call
	if(!bIsNT)
	{
		hDriver = 
				CreateFile (	kPGPMemLockDriver95Name, 
								0, 
								0, 
								NULL, 
								0, 
								0, 
								NULL );
	}
	
	hFile = CreateFile(	NewFileName, 
						GENERIC_READ | GENERIC_WRITE,
						0, 
						NULL,
						OPEN_EXISTING, 
						FILE_ATTRIBUTE_NORMAL|FILE_FLAG_WRITE_THROUGH, 
						NULL );

	if( hFile == INVALID_HANDLE_VALUE )  //  If unable to open, skip it
	{
		lastError = GetLastError();       //  These calls are for debugging
		NotifyShellRename(NewFileName,FileName);
		return WIPE_NOTOPEN;
	}

	//  Create a file mapping object
/*	hMap = CreateFileMapping( hFile, NULL, PAGE_READWRITE, 
						HILONG(Zap64Size),
						LOLONG(Zap64Size),
						NULL );

	if(hMap!=NULL)
	{
		// There was enough extra room so go for the bigger size
		ui64Size=Zap64Size;
	}
	else*/
	{
		// Not enough space--punt and just do the normal size
		hMap = CreateFileMapping( hFile, NULL, PAGE_READWRITE, 
						HILONG(ui64Size),
						LOLONG(ui64Size),
						NULL );
	}

	if(hMap==NULL)
	{
		lastError = GetLastError();        //  If it didn't work, next file
		CloseHandle( hFile );
		NotifyShellRename(NewFileName,FileName);
		return WIPE_NOFILEMAP;
	}
	
	// we are now using Colin's patterns
	error = PGPCreateDiskWiper(	context, &wipeRef, passes);

	if( IsntPGPError(error) )
	{
		DWORD reps;

		reps=0;

		while( IsntPGPError( PGPGetDiskWipeBuffer(wipeRef, buffer) ) )
		{	
			DWORD count;
			DWORD numbytes;
			PGPUInt64 ui64NumIters;
			PGPUInt64 ui64Iter;
			PGPUInt64 ui64MapLoc;

			ui64NumIters=(ui64Size+((PGPUInt64)quanta-1))/((PGPUInt64)quanta);
			
			for(ui64Iter=0;ui64Iter<ui64NumIters;ui64Iter++)
			{
				if(hwnd!=NULL)
				{
					MSG msg;
					DWORD percent;

					while(PeekMessage(&msg,hwnd,0,0,PM_REMOVE))
					{
						if(!IsDialogMessage(hwnd,&msg))
						{
							TranslateMessage(&msg);
							DispatchMessage(&msg);
						}
					}

					percent=(DWORD)
						(((((PGPUInt64)reps*ui64NumIters)+ui64Iter)*(PGPUInt64)100)/
						((PGPUInt64)passes*ui64NumIters));
					if(IsPGPError(PGPscProgressSetBar(hwnd,percent,FALSE)))
					{
						CancelOperation=TRUE;
						break;
					}
				}

				numbytes=(DWORD)(ui64Size-ui64Iter*((PGPUInt64)quanta));

				if(numbytes>quanta)
					numbytes=quanta;

				ui64MapLoc=ui64Iter*(PGPUInt64)quanta;

				lpFile = MapViewOfFile( hMap, FILE_MAP_WRITE, 
					HILONG(ui64MapLoc),
					LOLONG(ui64MapLoc),
					numbytes );

				if( lpFile == NULL )
				{
					lastError = GetLastError();              //  On error, back way out
					CloseHandle( hMap );
					CloseHandle( hFile );
					NotifyShellRename(NewFileName,FileName);
					PGPDestroyDiskWiper(wipeRef);
					return WIPE_NOMEMMAP;
				}
				else
				{
					char *view;

					view=(char *)lpFile;

					for( count = 0; count < numbytes; count += 1024)
					{
						memcpy(lpFile + count, buffer, 1024);
					}

					if(numbytes%1024!=0)
					{
						memcpy(lpFile+((numbytes/1024)*1024), 
							buffer, numbytes%1024);
					}

					FlushViewOfFile( lpFile, numbytes );  //  Flush it to disk
					FlushFileBuffers( hFile );

					// Windows 95 IFSmgr _VolFlush call
					if(!bIsNT)
					{
						if(hDriver!=NULL)
						{
							Win95Flush(hDriver,NewFileName);
						}
					}
				}

				UnmapViewOfFile( lpFile );			//  Kill mapped area
				FlushFileBuffers( hFile );

				// Windows 95 IFSmgr _VolFlush call
				if(!bIsNT)
				{
					if(hDriver!=NULL)
					{
						Win95Flush(hDriver,NewFileName);
					}
				}
			}

			reps++;
		}

		error = PGPDestroyDiskWiper(wipeRef);
	}

	CloseHandle(hMap);
	CloseHandle( hFile );

	// Windows 95 IFSmgr _VolFlush call
	if(!bIsNT)
	{
		if(hDriver!=NULL)
		{
			Win95Flush(hDriver,NewFileName);

			CloseHandle(hDriver);
		}
	}

	if(dwWipeFlags&WIPE_DONOTDELETE)
		NotifyShellRename(NewFileName,FileName);
	else
	{
		NotifyShellOperation(NewFileName,PGPNS_DELETE);
//		NotifyShellOperation(FileName,PGPNS_FORCEDELNOTIFY); // For brain dead XP NTFS shell
	}
	
	if(CancelOperation)
		return WIPE_USERABORT;

	if(hwnd!=NULL)
	{
		PGPscProgressSetBar(hwnd,100,TRUE);
	}

	return WIPE_OK;
}

/*__Editor_settings____

	Local Variables:
	tab-width: 4
	End:
	vi: ts=4 sw=4
	vim: si
_____________________*/
