/*__________________________________________________________________________
 Copyright (C) 2002 PGP Corporation
 All rights reserved.
 
 $Id: SCwork.c,v 1.4 2002/08/06 20:10:10 dallen Exp $
__________________________________________________________________________*/
#include "precomp.h"

UINT DoWorkThread(HWND hwndWorking,void *pUserValue)
{
	MYSTATE *myState;
	PGPError err;
	DWORD nOleErr;

	err=kPGPError_UnknownError;

	myState=(MYSTATE *)pUserValue;

	myState->hwndWorking=hwndWorking;

	nOleErr = OleInitialize(NULL);

	if ((nOleErr == S_OK) || (nOleErr == S_FALSE))
	{
		switch(myState->Operation)
		{
			case MS_ENCRYPTFILELIST:
				err=EncryptFileListStub (myState);
				break;

			case MS_CREATESDAFILELIST:
				err=CreateSDAFileListStub (myState);
				break;

			case MS_ENCRYPTCLIPBOARD:
				err=EncryptClipboardStub (myState);
				break;

			case MS_DECRYPTFILELIST:
				err=DecryptFileListStub (myState);
				break;

			case MS_DECRYPTCLIPBOARD:
				err=DecryptClipboardStub (myState);
				break;

			case MS_ADDKEYFILELIST:
				err=AddKeyFileListStub (myState);
				break;

			case MS_ADDKEYCLIPBOARD:
				err=AddKeyClipboardStub (myState);
				break;

			case MS_WIPEFILELIST:
				err=WipeFileListStub (myState); 
				break;
		}
		OleUninitialize();
	}

	return err;
}

/*__Editor_settings____

	Local Variables:
	tab-width: 4
	End:
	vi: ts=4 sw=4
	vim: si
_____________________*/
