/*____________________________________________________________________________
	Copyright (C) 2002 PGP Corporation
	All rights reserved.
	
	DecodeStub.h - Header file for decoding SDA/SEA's
	

	$Id: DecodeStub.h,v 1.5 2002/08/06 20:10:16 dallen Exp $
____________________________________________________________________________*/
#ifndef Included_PGPsda_h	/* [ */
#define Included_PGPsda_h

#ifdef WIN32
#include <windows.h>
#include <direct.h>
#include <commctrl.h>
#include <io.h>
#elif PGP_UNIX	/* !WIN32 */
#include <unistd.h>
#include "pgpTypes.h"
#endif /* WIN32 */
#include "pgpSDACreate.h"
#ifdef WIN32
#include "Progress.h"
#include "resource.h"
#endif /* WIN32 */

#if PGP_UNIX
#define MAX_PATH PATH_MAX
#endif /* PGP_UNIX */

#ifdef WIN32
typedef struct
{
	char filename[MAX_PATH+1];
	HWND hwndWorking;
	SDAHEADER *SDAHeader;
#ifdef PGPREADER
	PGPUInt32	dwFileNum;
	EBIZHEADER	*EBIZHeader;
	char		szAutoRun[MAX_PATH+1];
#endif /* PGPREADER */
} SDAWORK;
#endif /* WIN32 */

PGPUInt32 FileListFromFile(FILELIST **filelist,char *filename,PGPBoolean *UserCancel);
void RemoveFiles(FILELIST *fl);

PGPError SDADecryptFiles(SDAHEADER *SDAHeader,
						PGPUInt32 *ExpandedKey,
						FILELIST **fl,
						char *szInFileName,
						char *szPrefixPath,
						SDACREATECALLBACK UserProc,void *pUserValue);

int getc_buffer(void *pUserValue);
int putc_buffer(int c,void *pUserValue);

#ifdef WIN32
extern HINSTANCE g_hinst;
#endif /* WIN32 */

#ifndef IS_SEA
#include "sdautil.h"
#include "DeflateWrapper.h"
#else
#include "seautil.h"
#endif // IS_SEA

#endif /* ] Included_PGPsda_h */

/*__Editor_settings____

	Local Variables:
	tab-width: 4
	End:
	vi: ts=4 sw=4
	vim: si
_____________________*/
