/*____________________________________________________________________________
		Copyright (C) 2002 PGP Corporation
        All rights reserved.

        $Id: UCryptoFactory.h,v 1.3 2002/08/06 20:10:18 dallen Exp $
____________________________________________________________________________*/

#ifndef Included_UCryptoFactory_h	// [
#define Included_UCryptoFactory_h

#include "CArray.h"
#include "Crypto.h"

_PGP_BEGIN

// Types

class CString;

// UCryptoFactory functions

namespace UCryptoFactory
{
	PGPUInt32		GetNumAlgorithms();
	SMART_ERROR		GetAlgorithmIdString(
		PGPdiskEncryptionAlgorithm algorithm, CString& idString);

	SMART_ERROR		GetSupportedAlgorithms(
		CArray<PGPdiskEncryptionAlgorithm>& algArray, PGPUInt32 &usedLength);

	SMART_ERROR	RegisterModuleClient(PGPdiskEncryptionAlgorithm algorithm, 
		Crypto::CipherVTable& vTable);
	void		DeregisterModuleClient(PGPdiskEncryptionAlgorithm algorithm);
};

_PGP_END

#endif	// Included_UCryptoFactory_h
