/*____________________________________________________________________________
	Copyright (C) 2002 PGP Corporation
	All rights reserved.

	$Id: pgpClientErrors.h,v 1.17 2002/08/06 20:10:16 dallen Exp $
____________________________________________________________________________*/
#ifndef Included_pgpClientErrors_h	/* [ */
#define Included_pgpClientErrors_h

#include "pgpErrors.h"

enum PGPClientError_
{
	kPGPClientError_FirstError					=	-12500,
	kPGPClientError_Last						=	-12001,

	/* Share errors */
	kPGPClientError_NotEnoughSharesInObject		=	-12500,
	kPGPClientError_DifferentSplitKeys			=	-12499,
	kPGPClientError_DifferentSharePool			=	-12498,
	kPGPClientError_IdenticalShares				=	-12497,

	/* SKEP errors */
	kPGPClientError_IncorrectSKEPVersion		=	-12479,
	kPGPClientError_RejectedSKEPAuthentication	=	-12478,

	/* Pref errors */
	kPGPClientError_AdminPrefsNotFound			=	-12450,
	
	/* Reconstitution errors */
	kPGPClientError_UnsplitPrivateKeyNotFound	=	-12425,
	kPGPClientError_PrefsHashBad				=	-12424,
	
	/* PGPdisk errors */
	kPGPClientError_BadDiskAlgorithm			=	-12400, 
	kPGPClientError_BadDiskCommandLine			=	-12399, 
	kPGPClientError_BadDiskPassphrase			=	-12398, 
	kPGPClientError_CorruptDiskHeader			=	-12397, 
	kPGPClientError_DiskTooNew					=	-12396, 
	kPGPClientError_DiskTooOld					=	-12395, 
	kPGPClientError_DiskUserError				=	-12394, 
	kPGPClientError_FilesOpenOnDisk				=	-12393, 
	kPGPClientError_DiskAlreadyMounted			=	-12392, 
	kPGPClientError_DiskDriverIncompat			=	-12391, 
	kPGPClientError_DiskAdkFuncOnPersonalBuild	=	-12390, 
	kPGPClientError_DiskDiskIsWriteProtected	=	-12389, 
	kPGPClientError_DiskDiskUsersAreWiped		=	-12388, 
	kPGPClientError_DiskDiskIsBeingReEncrypted	=	-12387, 
	kPGPClientError_DiskReEncryptWithBadADK		=	-12386, 
	kPGPClientError_BadDiskPassKeyNotInRing		=	-12385, 
	kPGPClientError_DiskEngineIncompat			=	-12384, 
	kPGPClientError_DiskDriverNotInstalled		=	-12383, 
	kPGPClientError_DiskDriverCommFailed		=	-12382, 
	kPGPClientError_DiskTriedNTFSOnWin95		=	-12381, 
	kPGPClientError_DiskTriedReadOnlyNTFS		=	-12380, 
	kPGPClientError_DiskDiskAlreadyInUse		=	-12379, 
	kPGPClientError_DiskCantRemoveCompression	=	-12378, 
	kPGPClientError_DiskNoDrivesFree			=	-12377, 
	kPGPClientError_DiskDirNotFound				=	-12376, 
	kPGPClientError_DiskDirWriteProtected		=	-12375, 
	kPGPClientError_InvalidCmdLine				=	-12374, 
	kPGPClientError_DiskNotMounted				=	-12373, 
	kPGPClientError_MaxDisksMounted				=	-12372, 
	kPGPClientError_NeedPubKeyToWipeDisk		=	-12371, 
	kPGPClientError_DiskTriedFAT32OnNT4			=	-12370,

	kPGPClientError_Dummy
};


PGP_BEGIN_C_DECLARATIONS

PGPError 	PGPGetClientErrorString( PGPError theError,
				PGPSize bufferSize, char * theString );

PGP_END_C_DECLARATIONS


#endif /* ] Included_pgpClientErrors_h */


/*__Editor_settings____

	Local Variables:
	tab-width: 4
	End:
	vi: ts=4 sw=4
	vim: si
_____________________*/
