/*____________________________________________________________________________
	Copyright (C) 2002 PGP Corporation
	All rights reserved.

	$Id: pgpClientLib.h,v 1.14 2002/11/18 01:45:00 sdas Exp $
____________________________________________________________________________*/
#ifndef Included_pgpClientLib_h	/* [ */
#define Included_pgpClientLib_h

#include "pgpPubTypes.h"

#if PGP_MACINTOSH
#define PGPclExport
#include "pgpClientLibMac.h"
#endif


#if PGP_WIN32
#ifdef PGPCLIENTLIB_EXPORTS
# define PGPclExport __declspec( dllexport ) __stdcall
#else
# define PGPclExport __declspec( dllimport ) __stdcall
#endif

#include "pgpClientLibWin32.h"
#endif

#if PGP_UNIX_LINUX
#define PGPclExport
#include "pgpClientLibLinux.h"
#endif

#if PGP_UNIX_DARWIN
#define PGPclExport
#include "pgpClientLibOSX.h"
#endif

PGP_BEGIN_C_DECLARATIONS

enum
{
	kPGPclSelect509CanSignOnly		= (1L << 0),
	kPGPclSelect509NoSplit			= (1L << 1),

	kPGPclSelect509Default 			= 0
};

#define CKERR		if (IsPGPError (err)) goto done

	PGPError PGPclExport
PGPclX509CertFromExport(
	PGPContextRef		context,
	PGPKeyID*			pkeyidX509,
	PGPByte*			pIASNX509,
	PGPUInt32			uX509IASNLength,
	PGPKeyDBRef			keyDB,
	PGPKeyDBObjRef*		psigX509 );

	PGPError PGPclExport
PGPclX509CertToExport(
	PGPContextRef		context,
	PGPKeyDBObjRef		sigCert,
	PGPKeyID*			pkeyidX509,
	PGPByte**			ppIASNX509,
	PGPUInt32*			puX509IASNLength );


/* Caller must free data with PGPFreeData */
	PGPError PGPclExport
PGPclAVPairsToData(
	PGPMemoryMgrRef		memoryMgr,
	PGPAttributeValue*	avPairs,
	PGPUInt32			numAV,
	PGPByte**			data,
	PGPSize*			dataSize );

/* Caller must supply function to free data allocated for the avPairs
   array */

	PGPError PGPclExport
PGPclDataToAVPairs(
	PGPMemoryMgrRef		memoryMgr,
	PGPByte*			data,
	PGPSize				dataSize,
	PGPAttributeValue**	avPairs,
	PGPUInt32*			numAV);

/* Caller must call PGPFreeData on any non-null pointer returned */

	PGPError PGPclExport
PGPclParseCommonName(
	PGPMemoryMgrRef		memoryMgr,
	char*				commonname,
	char**				pfirstname,
	char**				pmiddlename,
	char**				plastname);

#if !PGP_OSX
	PGPError PGPclExport
PGPclOpenDefaultKeyrings(
	PGPContextRef				context,
	PGPOpenKeyDBFileOptions		options,
	PGPKeyDBRef					*outDB );
#endif

/* Merges prefsToAdd into prefs.
   NB: prefsToAdd can be modified by this call */

	PGPError PGPclExport
PGPclMergePrefs(
	PGPPrefRef			prefsToAdd,
	PGPPrefRef			prefs );

	PGPError PGPclExport
PGPclMergeNetPrefs(
	PGPPrefRef			prefsToAdd,
	PGPPrefRef			prefs );

/* License checking */

#if !PGP_WIN32
	PGPError PGPclExport
PGPclLicenseCheck(
        PGPContextRef context);

	PGPError PGPclExport
PGPclLicenseFree(
        PGPContextRef context);

	PGPError PGPclExport
PGPclLicenseName(PGPByte *buffer,PGPSize len);

	PGPError PGPclExport
PGPclLicenseCorp(PGPByte *buffer,PGPSize len);

	PGPUInt8 PGPclExport
PGPclLicenseProductID();

	PGPUInt16 PGPclExport
PGPclLicenseEvalPeriod();

	PGPUInt32 PGPclExport
PGPclLicenseQuantity();

	PGPUInt32 PGPclExport
PGPclLicenseSerial();

	PGPInt32 PGPclExport
PGPclLicenseDaysLeft();

	PGPBoolean PGPclExport
PGPclEnterprise();

	PGPBoolean PGPclExport
PGPclDesktop();

	PGPBoolean PGPclExport
PGPclPGPdiskEnabled();

	PGPBoolean PGPclExport
PGPclPGPmailEnabled();

	PGPBoolean PGPclExport
PGPclPGPdesktopEnabled();

	PGPBoolean PGPclExport
PGPclEvaluation();

	PGPBoolean PGPclExport
PGPclIsAuthorized();
#endif

PGP_END_C_DECLARATIONS

#endif /* ] Included_pgpClientLib_h */


/*__Editor_settings____

	Local Variables:
	tab-width: 4
	End:
	vi: ts=4 sw=4
	vim: si
_____________________*/
