/*____________________________________________________________________________
	Copyright (C) 2002 PGP Corporation
	All rights reserved.

	$Id: pgpReconstructPriv.h,v 1.7 2002/08/06 20:10:16 dallen Exp $
____________________________________________________________________________*/
#ifndef Included_pgpReconstructPriv_h	/* [ */
#define Included_pgpReconstructPriv_h

#include "pgpReconstruct.h"

#define kReconstructWrapKeySize		16
#define kReconCipherBlockSize		8
#define kPGPShareHeaderSize			4
#define kReconNaturalShareSize		( kReconstructWrapKeySize + kPGPShareHeaderSize )
#define kReconShareSize				( kReconNaturalShareSize + 4 )
#define kReconMaxHashReps			16384
#define kReconInnerMagic			0x750A0F2E
#define kReconOuterMagic			0x21B8E41F
#define kPGPShare_Version1			0x21
#define kReconMinBlobSize			(	sizeof(PGPKeyID) * 2 + sizeof(PGPReconPrompts) +	\
										sizeof(PGPUInt16) * 2 + sizeof(PGPUInt32) * 2 +		\
										kReconShareSize * kPGPRecon_NumShares * 2 )

#define kPGPReconCertIDAttr			"pgpReconCertID"
#define kPGPReconDataAttr			"pgpReconData"
#define kPGPReconPromptsAttr		"pgpReconPrompts"
#define kPGPReconHashRepsAttr		"pgpReconHashRepetitions"
#define kPGPCertIDAttr				"pgpCertID"
#define kPGPKeyAttr					"pgpKeyV2"
#define kPGPOwnerAttr				"owner"
#define kPGPObjectclassAttr			"objectclass"
#define kPGPObjectclassAny			"(objectclass=*)"
#define kPGPCertIDVirtual			"virtual"
#define kPGPReconElementObjectclass	"pgpReconElement"
#define kPGPCertserverVersion		"version"
#define kPGPServerInfoCN			"cn=PGPServerInfo"
#define kPGPBaseKeyspaceDN			"baseKeyspaceDN"
#define kPGPBaseReconDN				"baseReconDN"
#define kPGPUserIDVariables			{ "$USERID", "%USERID%" }


typedef struct PGPReconContextPriv
{
	PGPContextRef				context;
	PGPMemoryMgrRef				memMgr;
	PGPPrefRef					clientPrefs;
	PGPKeyDBObjRef				targetKey;
	PGPReconstructEventHandler	handler;
	PGPUserValue				userValue;
	char						authUser[kPGPRecon_MaxUserNameLen + 1];
	char						authPass[kPGPRecon_MaxPasswordLen + 1];
	PGPByte						*blobData;
	PGPSize						blobDataSize;
	PGPUInt16					hashReps;
#ifdef PGP_CMDLINE
	PGPUInt32					serverType;
	char						szServerURL[kPGPRecon_MaxPassLen + 1];
#endif /* PGP_CMDLINE */
} PGPReconContextPriv;



#endif /* ] Included_pgpReconstructPriv_h */


/*__Editor_settings____

	Local Variables:
	tab-width: 4
	End:
	vi: ts=4 sw=4
	vim: si
_____________________*/
