/*____________________________________________________________________________
	Copyright (C) 2002 PGP Corporation
	All rights reserved.

	$Id: pgpSDA.h,v 1.10 2002/08/06 20:10:16 dallen Exp $
____________________________________________________________________________*/
#ifndef Included_PGPSDA_h	/* [ */
#define Included_PGPSDA_h

//#define NOCOMPRESSION_SDA 1

#include "pgpPubTypes.h"

#define kBlockSize			512
#define	kBlockSizeInUInt32	(kBlockSize / sizeof( PGPUInt32 ))

#ifdef WIN32
#pragma pack(1)
#endif /* WIN32 */
typedef union PassphraseSalt
	{
	PGPUInt8	saltBytes[ 8 ];
	PGPUInt32	saltLongs[ 8 / sizeof( PGPUInt32 ) ];
	} PassphraseSalt;

typedef struct
{
	char szPGPSDA[6];
	PGPUInt32 offset;     // This will always be small (stub)
#ifdef NO_64INT
	PGPUInt32 CompLength[2];
	PGPUInt32 NumFiles[2];
#else /* !NO_64INT */
	PGPUInt64 CompLength; // This may be huge
	PGPUInt64 NumFiles;   // What the heck, why not
#endif /* NO_64INT */

	PassphraseSalt Salt;
	PGPUInt16 hashReps;
	char CheckBytes[8];
}
#ifdef PGP_UNIX
__attribute__((packed))
#endif /* PGP_UNIX */
SDAHEADER;

#ifdef WIN32
#pragma pack()
#endif /* WIN32 */

#if defined(E_BUSINESS_SERVER) || defined (PGPREADER)
typedef struct
{
	/*	New fields for future releases need to be placed above these. */
	PGPUInt32	autoExecNum;
	PGPByte		encryptedBlock[1024];
	PGPUInt32	size;
	PGPBoolean	bEncryptedToADK;
	PGPByte		MinorVersion;
	PGPByte		MajorVersion;
	char		szPGPEBIZ[7];	/*	PGPEBIZ	*/
} EBIZHEADER, *LPEBIZHEADER;

#define		PGPEBIZ		"PGPEBIZ"
#endif /* E_BUSINESS_SERVER || PGPREADER */

#endif /* ] Included_PGPSDA_h */

/*__Editor_settings____

	Local Variables:
	tab-width: 4
	End:
	vi: ts=4 sw=4
	vim: si
_____________________*/
