/*____________________________________________________________________________
	Copyright (C) 2002 PGP Corporation
	All rights reserved.

	$Id: PGPpda.h,v 1.9 2002/08/06 20:10:28 dallen Exp $
____________________________________________________________________________*/
#ifndef Included_PGPpda_h	/* [ */
#define Included_PGPpda_h

#include <windows.h>
#include "pgpPubTypes.h"

// defines
#ifdef PGPPDA_EXPORTS
# define PGPpdaExport __declspec( dllexport )
#else
# define PGPpdaExport __declspec( dllimport )
#endif

// API version defined by this header file
#define kPGPpda_APIVersion					0x00010002

#define kPGPpda_PlatformPalmOS				0x00010000
#define kPGPpda_PlatformWinCE				0x00020000
#define kPGPpda_PlatformSymbian				0x00030000

#define kMaxPGPpdaStringSize				127

#define kPGPpdaString_VersionString			0x00
#define kPGPpdaString_OpenKeyringMenuText	0x01
#define kPGPpdaString_OperationMenuText		0x80

#define kPGPpdaOpType_MainWindow			0x00
#define kPGPpdaOpType_PDAWindow				0x01

	
// typedefs
#if PGP_WIN32
#pragma pack (8)
#endif
typedef struct {
	PGPUInt32		uPGPkeysVersion;	// PGPkeys -> plugin
	PGPUInt32		uPGPkeysAPIVersion;	// PGPkeys -> plugin
	PGPUInt32		uPGPkeysAPIFlags;	// PGPkeys -> plugin
	PGPUInt32		uPluginVersion;		// plugin -> PGPkeys
	PGPUInt32		uPluginAPIVersion;	// plugin -> PGPkeys
	PGPUInt32		uPluginAPIFlags;	// plugin -> PGPkeys
	PGPUInt32		reserved[16];
} PGPpdaAPIStruct;						// added in API v1.2

typedef struct {
	PGPUInt32		uStringIndex;
	char			szString[kMaxPGPpdaStringSize +1];
} PGPpdaStringStruct;

typedef struct {
	PGPContextRef	context;
	HWND			hwndParent;
	PGPKeyDBRef		keydb;
	char			szTitle[kMaxPGPpdaStringSize +1];
} PGPpdaOpenStruct;

typedef struct {
	PGPContextRef	context;
	HWND			hwndParent;
	PGPKeySetRef	keyset;
	PGPBoolean		bClose;
} PGPpdaSaveStruct;

typedef struct {
	PGPContextRef	context;
	HWND			hwndParent;
	PGPUInt32		uOperation;
	PGPUInt32		reserved[16];
} PGPpdaOpStruct;

typedef struct {
	PGPUInt32		uPlatform;
	PGPUInt32		uVersion;
	PGPUInt32		uFlags;
	PGPUInt32		reserved[16];
} PGPpdaIdStruct;
#if PGP_WIN32
#pragma pack ()
#endif

#ifdef __cplusplus
extern "C" {
#endif

// prototypes
PGPUInt32 PGPpdaExport
PGPpdaGetAPIVersion (void);

PGPError PGPpdaExport						// added in API v1.2
PGPpdaAPIVersionInfo (
		PGPpdaAPIStruct*		ppas);

PGPError PGPpdaExport
PGPpdaGetString (
		PGPpdaStringStruct*		ppss);

PGPError PGPpdaExport
PGPpdaOpenKeyset (
		PGPpdaOpenStruct*		ppos);

PGPError PGPpdaExport
PGPpdaSaveKeyset (
		PGPpdaSaveStruct*		ppss);

PGPUInt32 PGPpdaExport
PGPpdaGetOperationCount (void);

PGPUInt32 PGPpdaExport						// added in API v1.2
PGPpdaGetOperationCountEx (
		PGPUInt32				uOpType);

PGPError PGPpdaExport
PGPpdaOperation (
		PGPpdaOpStruct*			ppos);

PGPError PGPpdaExport
PGPpdaGetIdentification (
		PGPpdaIdStruct*			ppis);

#ifdef __cplusplus
}
#endif

#endif /* ] Included_PGPpda_h */


/*__Editor_settings____

	Local Variables:
	tab-width: 4
	End:
	vi: ts=4 sw=4
	vim: si
_____________________*/
