/*____________________________________________________________________________
	Copyright (C) 2002 PGP Corporation
	All rights reserved.

	$Id: ParseMime.h,v 1.4 2002/11/19 03:54:13 sdas Exp $
____________________________________________________________________________*/
#ifndef Included_ParseMime_h	/* [ */
#define Included_ParseMime_h

#ifdef __cplusplus
extern "C" {
#endif

#include "pgpErrors.h"

typedef enum _MimeContentType
{
	ContentType_TextPlain,
	ContentType_TextHTML,
	ContentType_MultipartMixed,
	ContentType_MultipartAlternative,
	ContentType_Other
} MimeContentType;

typedef struct MimePart	MimePart;

struct MimePart
{
	MimePart *	nextPart;
	MimePart *	previousPart;
	MimePart *	subPart;
	MimePart *	parentPart;

	char *				szHeader;
	char *				szBody;
	char *				szFooter;
	char *				szBoundary;
	UINT				nHeaderLength;
	UINT				nBodyLength;
	UINT				nFooterLength;
	UINT				nBoundaryLength;
	MimeContentType		nContentType;
	BOOL				bAttachment;
};


PGPError ParseMime(char *szInput, MimePart **ppMimeList);

void FreeMimeList(MimePart *pMimeList);

#ifdef __cplusplus
}
#endif

#endif /* ] Included_ParseMime_h */


/*__Editor_settings____

	Local Variables:
	tab-width: 4
	End:
	vi: ts=4 sw=4
	vim: si
_____________________*/
