/*____________________________________________________________________________
	Copyright (C) 2002 PGP Corporation
	All rights reserved.
	
	License Number Library header file.

	$Id: pgpLnLib.h,v 1.5 2002/11/19 14:10:28 pbj Exp $
____________________________________________________________________________*/
#ifndef Included_pgpLnLib_h	/* [ */
#define Included_pgpLnLib_h

#include "pgpPubTypes.h"
#include <windows.h>
#include <time.h>

typedef enum PGPlnExpType
{
	kPGPlnOperationGraceExpiration				= 1,
	kPGPlnOperationStandardExpiration			= 2,
	kPGPlnModuleGraceExpiration					= 3,
	kPGPlnModuleStandardExpiration				= 4,
	kPGPlnDiskWriteExpiration					= 5,
	kPGPlnModuleGraceExpirationNoMessage		= 6,
	kPGPlnModuleStandardExpirationNoMessage		= 7
} PGPlnExpType;


PGP_BEGIN_C_DECLARATIONS

	PGPError 
PGPlnIsExpired (
		HWND			hwnd, 
		PGPlnExpType	index);
		
	PGPError 
PGPlnBetaTimeOut (time_t *timeEnd);


/* License checking */

	PGPError
PGPlnLicenseCheck (PGPContextRef context);

	PGPError
PGPlnLicenseCheckLite (PGPContextRef context);

	PGPError
PGPlnLicenseFree (PGPContextRef context);

	PGPError
PGPlnLicenseName (PGPByte *buffer, PGPSize len);

	PGPError
PGPlnLicenseCorp (PGPByte *buffer, PGPSize len);

	PGPUInt8
PGPlnLicenseProductID (void);

	PGPInt32
PGPlnLicenseDays (void);

	PGPUInt32
PGPlnLicenseQuantity (void);

	PGPUInt32
PGPlnLicenseSerial (void);

	PGPBoolean
PGPlnEnterprise (void);

	PGPBoolean
PGPlnDesktop (void);

	PGPBoolean
PGPlnPGPdiskEnabled (void);

	PGPBoolean
PGPlnPGPmailEnabled (void);

	PGPBoolean
PGPlnEvaluation (void);

	PGPBoolean
PGPlnIsAuthorized (void);

	PGPBoolean
PGPlnWasAuthorized (void);

PGP_END_C_DECLARATIONS

#endif /* ] Included_pgpLnLib_h */


/*__Editor_settings____

	Local Variables:
	tab-width: 4
	End:
	vi: ts=4 sw=4
	vim: si
_____________________*/
