/*____________________________________________________________________________
	Copyright (C) 2002 PGP Corporation
	All rights reserved.

	PGPWerr.h	- 	common Windows error return codes

	$Id: pgpWin32Errors.h,v 1.15 2002/10/29 17:37:46 pbj Exp $

____________________________________________________________________________*/
#ifndef Included_pgpWErr_h	/* [ */
#define Included_pgpWErr_h


#include "pgpPubTypes.h"
#include "pgpClientErrors.h"

enum PGPErrorWin32_
{
	kPGPError_Win32_FirstError = 1000,

	kPGPError_Win32_AlreadyOpen,		/* common dialog already open */
	kPGPError_Win32_NoSecretKeys,		/* no secret keys in keyring  */
	kPGPError_Win32_Expired,			/* eval period expired        */
	kPGPError_Win32_NegativeResponse,	/* user responded "No"		  */
	kPGPError_Win32_NoSigningKey,		/* no signing key for search  */

	kPGPError_Win32_InvalidImage,		/* corrupt or unsupported image */
	kPGPError_Win32_ImageTooBig,		/* image beyond limits          */

	kPGPError_Win32_InvalidComctl32,	/* incorrect version of COMCTL32*/

	kPGPError_Win32_NoRootCACertPrefs,	/* no root CA cert is set in prefs */
	kPGPError_Win32_NoCAServerPrefs,	/* no CA server is set in prefs */

	kPGPError_Win32_NoNewCRL,			/* no new CRL for root CA key	*/

	kPGPError_Win32_InvalidCurrentDate,	/* current date is out of range	*/

	kPGPError_Win32_PrefRefNoLongerValid,
	kPGPError_Win32_InvalidSHFolder,	/* couldn't find SHGetFolderPath*/
	kPGPError_Win32_PrefsHashBad,		/* the prefs file hash is no good*/
	kPGPError_Win32_NetPrefsHashBad,	/* the prefs file hash is no good*/
	kPGPError_Win32_CantChangePrefsFile,/* error changing prefs file    */
	kPGPError_Win32_NoPrefsServiceResponse, /* prefs service seems dead */

	kPGPError_Win32_IPHelperLibError,	/* cannot link to IPhelper DLL  */
	kPGPError_Win32_WsControlError,		/* WsControl entry problems		*/

	kPGPError_Win32_UserNotInitialized,	/* user has not initialized her */
										/* PGP installation				*/
	kPGPError_Win32_UnsupportedPlatform,/* PGP cannot run on this system*/
	kPGPError_Win32_UnsupportedKeyType, /* some "exotic" key format     */
	
	kPGPError_Win32_TokenNotInserted, 	/* needed smart card is missing */
	kPGPError_Win32_TokenParameterError,/* parameters not valid for token*/
	
	kPGPError_Win32_InvalidUnicodeChar, /* error converting to/from UTF8*/
	
	kPGPError_Win32_InvalidKeyIDString, /* error converting keyid string*/	
	
	kPGPError_Win32_Last
};


#endif /* ] Included_pgpWErr_h */
