/*____________________________________________________________________________
	Copyright (C) 2002 PGP Corporation
	All rights reserved.
	
	$Id: SpaceEdit.h,v 1.4 2002/10/16 19:05:21 wjb Exp $
____________________________________________________________________________*/

#ifndef Included_SpaceEdit_h	/* [ */
#define Included_SpaceEdit_h

// if we are building as part of the Self Decrypting Archive code,
// then we do not have access to the PGP SDK
#ifndef PGP_SDA
  #define PGP_SDA		0
#endif

#if PGP_SDA
  #define PGP_SDK_AVAILABLE		0
#else
  #define PGP_SDK_AVAILABLE		1
#endif


// Format of the user defined callback
typedef VOID (*USERCALLBACK)(HWND,void *pUserValue);

PGP_BEGIN_C_DECLARATIONS

#if PRAGMA_IMPORT_SUPPORTED
#pragma import on
#endif

// SEInit
//
// Sets up a standard edit box for PGPstyle hide typing
// random spaces. UserCallback w/ pUserValue is called
// when a letter is typed into the edit box or the user
// presses the CAPSLOCK key. This way the application can
// update progress bars, caps warnings, min length etc.
VOID
SEInit(
#if PGP_SDK_AVAILABLE
	   PGPContextRef	context,
#endif
	   HWND				hwndEdit,
	   BOOL				bHideTyping,
	   USERCALLBACK		UserCallback,
	   void*			pUserValue);

// SEDestroy
//
// Please call this as it gets rid of the passphrase
// in memory (even though it is secalloced and XOR
// obsfucated
VOID 
SEDestroy(HWND hwndEdit);

// SEWipeEditBox
//
// Resets the edit box (like for a bad passphrase). 
VOID 
SEWipeEditBox (HWND hwndEdit);

// SEChangeHideTyping
//
// Switches from hidden typing to normal
VOID 
SEChangeHideTyping (HWND hwndEdit, BOOL bHideTyping);

// SESetMaxLength
//
// Sets maximum passphrase length accepted
VOID 
SESetMaxLength (HWND hwndEdit, int iMaxLen);

// SEGetText
//
// Use this call instead of WM_GETTEXT
VOID 
SEGetText(HWND hwndEdit,char *buf,int ibuflen);

// SEGetTextLength
//
// Use this call instead of WM_GETTEXTLENGTH
DWORD
SEGetTextLength(HWND hwndEdit);

// SEGetShowWarning
//
// Usually used in conjunction with the user callback
BOOL
SEGetShowWarning(HWND hwndEdit);

// SEGetSpecialKey
//
// returns the last "special key" typed
DWORD
SEGetSpecialKey(HWND hwndEdit);

#if PGP_SDK_AVAILABLE
// SEGetTextQuality
//
// Usually used in conjunction with the user callback
DWORD
SEGetTextQuality(HWND hwndEdit);
#endif


#if PRAGMA_IMPORT_SUPPORTED
#pragma import reset
#endif

PGP_END_C_DECLARATIONS

#endif /* ] Included_SpaceEdit_h */

/*__Editor_settings____

	Local Variables:
	tab-width: 4
	End:
	vi: ts=4 sw=4
	vim: si
_____________________*/

