/*____________________________________________________________________________
		Copyright (C) 2002 PGP Corporation
        All rights reserved.

        $Id: NewAndDeleteDrvNT.cpp,v 1.4 2002/08/06 20:10:51 dallen Exp $
____________________________________________________________________________*/

#include "pgpClassesConfig.h"
#include "pgpMemoryMgr.h"

_USING_PGP

_UNNAMED_BEGIN

// Constants

enum
{
	kPGPDriverNTPoolTag	= 'DPGP'
};

_UNNAMED_END


// Operator new and delete helper functions

void * 
NewAndDelete::NewHelper(size_t size, MemoryType memType, PGPBoolean throws)
{
	pgpAssert(!throws);

	if (size == 0)
		size = 1;	// required by standard!

#if PGP_DEBUG
	void	*pMem	= ExAllocatePoolWithTag(NonPagedPool, size, 
		kPGPDriverNTPoolTag);
#else	// !PGPDISK_DEBUG
	void	*pMem	= ExAllocatePool(NonPagedPool, size);
#endif	// PGPDISK_DEBUG

#if PGP_DEBUG
	if (IsntNull(pMem))
		pgpDebugWhackMemory(pMem, size);
#endif	// PGP_DEBUG

	return pMem;
};

void 
NewAndDelete::DeleteHelper(void *p)
{
	if (IsntNull(p))
		ExFreePool(p);
}
