/*____________________________________________________________________________
	Copyright (C) 2002 PGP Corporation
	All rights reserved.
	
	$Id: pgpSDKBuildFlags.h,v 1.25 2002/11/10 08:38:05 wprice Exp $
____________________________________________________________________________*/

#ifndef Included_pgpSDKBuildFlags_h	/* [ */
#define Included_pgpSDKBuildFlags_h

#ifdef OVERRIDE_BUILDFLAGS

#if PGP_OVID
#include "../../../../ovid/build/build.h"
#else
#include "../../../../clients2/build/MastrBld.h"
#endif

#else
/*____________________________________________________________________________
	Algorithm support
____________________________________________________________________________*/

#define PGP_RSA				1
#define PGP_RSA_KEYGEN		1

#define PGP_USECAPIFORRSA	0	/* Try to use Microsoft CAPI library for RSA */
#define PGP_USECAPIFORMD2	0	/* Try to use Microsoft CAPI library for MD2 */
#define PGP_USEBSAFEFORRSA  0	/* Use RSA's BSAFE library for RSA support */
#define PGP_USEPGPFORRSA	1	/* Use the PGP implementation for RSA support */
#define PGP_USERSAREF		0	/* Use the non-commercial RSAREF library for RSA */

#define PGP_EC				0	/* Elliptic Curve support */

/* These probably will always be on */
#define PGP_CAST5		1
#define PGP_DES3		1
#define PGP_IDEA		1
#define PGP_TWOFISH		1
#define PGP_AES			1

/*____________________________________________________________________________
	Version information
____________________________________________________________________________*/

#define PGPSDK_SHORT_VERSION_STRING		"3.0"

#define PGPSDK_MAJOR_VERSION			3
#define PGPSDK_MINOR_VERSION			0
#define PGPSDK_SUBMINOR_VERSION			0
#define PGPSDK_RELEASE_STAGE			1	/* 0 = Development, 1 = Alpha, */
											/* 2 = Beta, 3 = Release */
#define PGPSDK_BUILD					1

#define PGPSDK_BUILDNUMBER				"1"
#define PGPSDK_INSTALLEDWITH			"PGP 8.0"

#define PGPCOMPANYNAME		"PGP Corporation"
#define PGPSDK_COPYRIGHT 	"(C) 2002 PGP Corporation"
#define PGPTRADEMARKS		"Pretty Good Privacy, PGP"
/*____________________________________________________________________________
	Other optional flags
____________________________________________________________________________*/

#ifdef PGP_WIN32
	#define PGP_INTEL_RNG_SUPPORT	1
#else
	#define PGP_INTEL_RNG_SUPPORT	0
#endif

/* Allows turning off signing/verification capability in library */
#ifndef PGP_SIGN_DISABLE
	#define PGP_SIGN_DISABLE	0
#endif

#ifndef PGP_VERIFY_DISABLE
	#define PGP_VERIFY_DISABLE	0
#endif

/* Allows turning off encryption/decryption capability in library */
#ifndef PGP_ENCRYPT_DISABLE
	#define PGP_ENCRYPT_DISABLE	0
#endif

#ifndef PGP_DECRYPT_DISABLE
	#define PGP_DECRYPT_DISABLE	0
#endif

#endif /* OVERRIDE_BUILDFLAGS */

#endif /* ] Included_pgpSDKBuildFlags_h */


/*__Editor_settings____

	Local Variables:
	tab-width: 4
	End:
	vi: ts=4 sw=4
	vim: si
_____________________*/
