/*____________________________________________________________________________
	Copyright (C) 2002 PGP Corporation
	All rights reserved.

	$Id: pgpRPCPwdCache.c,v 1.9 2002/08/06 20:11:21 dallen Exp $
____________________________________________________________________________*/
#include <windows.h>
#include "pgpPubTypes.h"
#include "pgpRPCMsg.h"
#include "pgpPassCach.h"
#include "pgpKeyPriv.h"
#include "pgpThreads.h"

#define CACHETIME	10000
#define TOKENTIME	 5000

extern PGPMutex_t sRpcMutex;
extern PGPContextRef gCtx;

void
pgpRPCThread(void *dummy)
{
	int count = 0;

	for(;;) {
		SleepEx( TOKENTIME, FALSE );

		PGPMutexLock( &sRpcMutex );
		pgpPollTokens( gCtx );
		PGPMutexUnlock( &sRpcMutex );

		if( ++count >= (CACHETIME/TOKENTIME) )
		{
			pgpExpirePassphraseCache( gCtx );

			PGPMutexLock( &sRpcMutex );
			pgpExpireKeyDBCache( gCtx );
			PGPMutexUnlock( &sRpcMutex );

			count = 0;
		}
	}
}
