////////////////////////////////////////////////////////////////////////////////
//
//  File : gwoapi.h
//
//  Copyright (C) 2002 PGP Corporation
//
//  ABSTRACT
//		Header file
// 
//  Author: Satya S. Das
//
////////////////////////////////////////////////////////////////////////////////

#ifndef _GroupwareTypeLibrary_H_
#define _GroupwareTypeLibrary_H_

DEFINE_GUID( CLSID_GroupWare, 0x761C9540, 0xBAFD, 0x11CE, 0xB6, 0xF9, 0x00, 0x60, 0x8C, 0x84, 0xE1, 0xC4 );
DEFINE_GUID(LIBID_GroupwareTypeLibrary,0xE775D180L,0xD9FB,0x11CE,0xB6,0xF9,0x00,0x60,0x8C,0x84,0xE1,0xC4);
#ifndef BEGIN_INTERFACE
#define BEGIN_INTERFACE
#endif

interface DIGWAccount;

interface DIGWAddresses;

interface DIGWAddressBooks;

interface DIGWCAddressBook;

interface DIGWAllMessages;

interface DIGWAllMessagesIterator;

interface DIGWAppointment;

interface DIGWAppointment2;

interface DIGWFolder;

interface DIGWFolders;

interface DIGWFormattedText;

interface DIGWMail;

interface DIGWMail2;

interface DIGWMessage;

interface DIGWMessage2;

interface DIGWMessageList;

interface DIGWMessages;

interface DIGWAddress;

interface DIGWAddressBookEntry;

interface DIGWAddressBookEntries;

interface DIGWAddressBookRightsCollection;

interface DIGWFieldDefinition;

interface DIGWFieldDefinitions;

interface DIGWFields;

interface DIGWFormattedText;

interface DIGWQuery;

interface DIGWLocations;

interface DIGWFilter;

interface DIGWFilters;

interface DIGWDocumentLibrary;

interface DIGWDocumentLibraries;

interface DIGWTimeBlocks;

interface DIGWBusySearchResult;

interface DIGWBusySearchElement;

interface DIGWBusySearchElements;

interface DIGWDocument;

interface DIGWDocuments;

interface DIGWDocumentVersion;

interface DIGWDocumentVersions;

interface DIGWDocumentType;

interface DIGWDocumentTypes;

interface DIGWDocumentReference;

interface DIGWDocumentReference2;

interface DIGWDocumentVersionEvent;

interface DIGWDocumentVersionEvents;

interface DIGWDownloadStatus;

interface DIGWNote;

interface DIGWNote2;

interface DIGWPhoneMessage;

interface DIGWPhoneMessage2;

interface DIGWRecipients;

interface DIGWRecipient;

interface DIGWSession;

interface DIGWSession2;

interface DIGWSharedNotification;

interface DIGWTask;

interface DIGWTask2;

interface DIGWAttachment;

interface DIGWAttachments;

interface DIGWAccounts;

interface DIGWAccountRights;

interface DIGWAccountRightsCollection;

interface DIGWFolderRightsCollection;

interface DIGWFolderRights;

interface DIGWDocumentIterator;

interface DIGWDocumentRights;

interface DIGWDocumentRights2;

interface DIGWDocumentAccessRights;

interface DIGWDocumentAccessRightsCollection;

interface DIGWDocumentAccessRightsCollection2;

interface DIGWTrash;

interface DIGWTrashEntry;

interface DIGWTrashEntries;

interface DIGWGroupMembers;

interface DIGWLookupTableEntry;

interface DIGWLookupTableEntries;

typedef enum {
    egwCanArchive = 1,
    egwPrefsRulesGroups = 2,
    egwReadAppointments = 4,
    egwReadMailAndPhone = 8,
    egwReadNotes = 16,
    egwReadPrivate = 32,
    egwReadTasks = 64,
    egwReceiveAlarms = 128,
    egwReceiveNotifications = 256,
    egwWriteAppointments = 512,
    egwWriteMailAndPhone = 1024,
    egwWriteNotes = 2048,
    egwWriteTasks = 4096
} AccountRightsConstants;

typedef enum {
    egwReadOnly = 0,
    egwFullAccess
} AddressBookRightsConstants;

typedef enum {
    egwOther = 0,
    egwFrequentContact
} AddressBookSubtypeConstants;

typedef enum {
    egwUnknownBook = 0,
    egwNovellPersonal,
    egwNovellSystem
} AddressBookTypeConstants;

typedef enum {
    egwUnknown = 0,
    egwUser,
    egwCompany,
    egwResource,
    egwGroup
} AddressTypeConstants;

typedef enum {
    egwTo = 0,
    egwCC,
    egwBC
} AddressTargetTypeConstants;

typedef enum {
    egwUnknownAttachment = 0,
    egwFile = 1,
    egwMessage,
    egwMovie,
    egwOLEEmbedded,
    egwOLELinked,
    egwSoundAnnotation
} AttachmentTypeConstants;

typedef enum {
    egwDoCheckIn = 0,
    egwLeaveCheckedOut
} CheckInConstants;

typedef enum {
    egwDisposeByArchive = 1,
    egwDisposeByDelete
} DisposalMethodConstants;

typedef enum {
    egwARAllowDelete = 1,
    egwARAllowEdit = 2,
    egwARAllowView = 4,
    egwARModifySecurity = 8,
    egwARRevokeAllRights = 16,
    egwARAllowShare = 32
} DocumentAccessRightsConstants;

typedef enum {
    egwOfficial = 0,
    egwCurrent,
    egwSpecific
} DocumentReferenceTypeConstants;

typedef enum {
    egwAvailable = 0,
    egwNotDownloaded
} DownloadStateConstants;

typedef enum {
    egwEmailAddress4x = 0,
    egwEmailAddress5x
} EmailAddressFormatConstants;

typedef enum {
    egwDoEndRetrieve = 0,
    egwLeaveInUse
} EndRetrieveStatus;

typedef enum {
    egwUnknownEvent = 0,
    egwAdd,
    egwCheckIn,
    egwCheckInRequest,
    egwCheckOut,
    egwCheckOutRequest,
    egwCopyIn,
    egwCopyOut,
    egwCopyVersion,
    egwDeleteVersion,
    egwDeleteVersionRequest,
    egwDownloadRequest,
    egwEndRetrieve,
    egwPreview,
    egwRetrieve,
    egwSyncWithMasterRequest,
    egwUploadRequest,
    egwCopyOutForPrint,
    egwCopyOutForJefferson,
    egwSecurityChange,
    egwDocumentShared,
    egwMakeVersionOfficial,
    egwUpdateFields,
    egwDocUpAddServer,
    egwDocUpModServer,
    egwRemoteResetInMaster,
    egwVersionDownClientRemote,
    egwDocUpClientRemote,
    egwRemoteReset,
    egwMove,
    egwStatusReset,
    egwArchived,
    egwRestored,
    egwBackedUp,
    egwRestoredBackUp,
    egwRemoveSyncWithMasterRequest,
    egwDocumentAvailableOnServer,
    egwDownloadFailed,
    egwVersionDeleteFailed
} EventTypeConstants;

typedef enum {
    egwString = 1,
    egwNumeric = 2,
    egwDate = 3,
    egwBinary = 4,
    egwReserved = 5
} FieldTypeConstants;

typedef enum {
    egwUpperCase = 1,
    egwLowerCase,
    egwMixedCase
} FieldDefinitionCase;

typedef enum {
    egwAllowDelete = 1,
    egwAllowAdd = 2,
    egwAllowModify = 4
} FolderRightsConstants;

typedef enum {
    egwDeleted = 1,
    egwModified = 2,
    egwNew = 3
} FolderRightsNotifyConstants;

typedef enum {
    egwUnknownFolder = 0,
    egwMailbox,
    egwRoot,
    egwQuery,
    egwPersonalFolder,
    egwCabinet,
    egwCalendar,
    egwWork,
    egwDocuments
} FolderTypeConstants;

typedef enum {
    egwPromptIfNeeded = 0,
    egwNeverPrompt
} LoginConstants;

typedef enum {
    egwIncoming = 1,
    egwOutgoing = 2,
    egwPersonal = 3,
    egwDraft = 4
} MessageBoxTypeConstants;

typedef enum {
    egwLow = 1,
    egwNormal = 2,
    egwHigh = 3
} MessagePriorityConstants;

typedef enum {
    egwNoNotify = 0,
    egwSendReceipt,
    egwNotify,
    egwSendAndNotify
} NotifyMessageConstants;

typedef enum {
    egwNoReply = 0,
    egwWhenConvenient,
    egwWithinDaysRequested
} ReplyRequestedConstants;

typedef enum {
    egwNotResolved = 0,
    egwNotFound,
    egwAmbiguous,
    egwResolved
} ResolvedConstants;

typedef enum {
    egwNotShared = 0,
    egwSharedOutgoing,
    egwSharedIncoming
} SharedFolderConstants;

typedef enum {
    egwSharedFolder = 0,
    egwSharedAddressBook
} SharedNotificationTypeConstants;

typedef enum {
    egwAscending = 0,
    egwDescending
} SortConstants;

typedef enum {
    egwFree = 0,
    egwBlocked = 1,
    egwOutOfOffice = 2,
    egwTentative = 3
} TimeBlockConstants;

DEFINE_GUID(IID_IGWMessage,0x7D2266E0L,0xE158,0x11CE,0x87,0xEB,0x00,0x80,0x5F,0xB4,0xB2,0xBE);

/* Definition of interface: IGWMessage */
#undef INTERFACE
#define INTERFACE IGWMessage                     

DECLARE_INTERFACE_(IGWMessage, IUnknown)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;
#endif

    /* IGWMessage methods */
    STDMETHOD(get_Application)(THIS_ DIGWSession FAR* FAR* retval) PURE;
    STDMETHOD(get_Attachments)(THIS_ DIGWAttachments FAR* FAR* retval) PURE;
    STDMETHOD(get_BodyText)(THIS_ DIGWFormattedText FAR* FAR* retval) PURE;
    STDMETHOD(get_BoxType)(THIS_ MessageBoxTypeConstants FAR* retval) PURE;
    STDMETHOD(get_ClassName)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(put_ClassName)(THIS_ BSTR pClass) PURE;
    STDMETHOD(get_ConvertAttachments)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_ConvertAttachments)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_CreationDate)(THIS_ DATE FAR* retval) PURE;
    STDMETHOD(get_Deleted)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(get_DownloadStatus)(THIS_ DIGWDownloadStatus FAR* FAR* retval) PURE;
    STDMETHOD(get_EnclosingFolders)(THIS_ DIGWFolders FAR* FAR* retval) PURE;
    STDMETHOD(get_ExpandedRecipients)(THIS_ DIGWRecipients FAR* FAR* retval) PURE;
    STDMETHOD(get_Fields)(THIS_ DIGWFields FAR* FAR* retval) PURE;
    STDMETHOD(get_FromText)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(put_FromText)(THIS_ BSTR Text) PURE;
    STDMETHOD(get_Hidden)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Hidden)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_MessageID)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(get_NotifyWhenDeleted)(THIS_ NotifyMessageConstants FAR* retval) PURE;
    STDMETHOD(put_NotifyWhenDeleted)(THIS_ NotifyMessageConstants How) PURE;
    STDMETHOD(get_NotifyWhenOpened)(THIS_ NotifyMessageConstants FAR* retval) PURE;
    STDMETHOD(put_NotifyWhenOpened)(THIS_ NotifyMessageConstants How) PURE;
    STDMETHOD(get_Opened)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Opened)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_Parent)(THIS_ DIGWAccount FAR* FAR* retval) PURE;
    STDMETHOD(get_Priority)(THIS_ MessagePriorityConstants FAR* retval) PURE;
    STDMETHOD(put_Priority)(THIS_ MessagePriorityConstants Priority) PURE;
    STDMETHOD(get_Read)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Read)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_Recipients)(THIS_ DIGWRecipients FAR* FAR* retval) PURE;
    STDMETHOD(get_ReplyChildren)(THIS_ DIGWMessageList FAR* FAR* retval) PURE;
    STDMETHOD(get_ReplyDaysRequested)(THIS_ int FAR* retval) PURE;
    STDMETHOD(put_ReplyDaysRequested)(THIS_ int Days) PURE;
    STDMETHOD(get_ReplyParent)(THIS_ DIGWMessage FAR* FAR* retval) PURE;
    STDMETHOD(get_ReplyRequested)(THIS_ ReplyRequestedConstants FAR* retval) PURE;
    STDMETHOD(put_ReplyRequested)(THIS_ ReplyRequestedConstants When) PURE;
    STDMETHOD(get_ReplyRoot)(THIS_ DIGWMessage FAR* FAR* retval) PURE;
    STDMETHOD(get_Routed)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Routed)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_RoutingEndOfLine)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(get_Sender)(THIS_ DIGWAddress FAR* FAR* retval) PURE;
    STDMETHOD(get_Subject)(THIS_ DIGWFormattedText FAR* FAR* retval) PURE;
    STDMETHOD(get_ViewName)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(put_ViewName)(THIS_ BSTR pClass) PURE;
    STDMETHOD(Annotate)(THIS_ DIGWNote2 FAR* Note) PURE;
    STDMETHOD(Clone)(THIS_ DIGWMessage FAR* FAR* retval) PURE;
    STDMETHOD(Delete)(THIS) PURE;
    STDMETHOD(Forward)(THIS_ DIGWMail FAR* FAR* retval) PURE;
    STDMETHOD(Refresh)(THIS) PURE;
    STDMETHOD(Reply)(THIS_ VARIANT ClassName, VARIANT ReplyToAll, VARIANT IncludeSenderMessageText, VARIANT AttachOriginalMessage, DIGWMessage FAR* FAR* retval) PURE;
    STDMETHOD(Retract)(THIS) PURE;
    STDMETHOD(Send)(THIS_ DIGWMessage FAR* FAR* retval) PURE;
};

DEFINE_GUID(DIID_DIGWMessage,0x7D2266E1L,0xE158,0x11CE,0x87,0xEB,0x00,0x80,0x5F,0xB4,0xB2,0xBE);

/* Definition of dispatch interface: DIGWMessage */
#undef INTERFACE
#define INTERFACE DIGWMessage

DECLARE_INTERFACE_(DIGWMessage, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;
#endif

/* Capable of dispatching all the methods of interface IGWMessage */
};

DEFINE_GUID(IID_IGWMessage2,0x7D2376E0L,0xE158,0x11CE,0x87,0xEB,0x00,0x80,0x5F,0xB4,0xB2,0xBE);

/* Definition of interface: IGWMessage2 */
#undef INTERFACE
#define INTERFACE IGWMessage2

DECLARE_INTERFACE_(IGWMessage2, IGWMessage)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IGWMessage methods */
    STDMETHOD(get_Application)(THIS_ DIGWSession FAR* FAR* retval) PURE;
    STDMETHOD(get_Attachments)(THIS_ DIGWAttachments FAR* FAR* retval) PURE;
    STDMETHOD(get_BodyText)(THIS_ DIGWFormattedText FAR* FAR* retval) PURE;
    STDMETHOD(get_BoxType)(THIS_ MessageBoxTypeConstants FAR* retval) PURE;
    STDMETHOD(get_ClassName)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(put_ClassName)(THIS_ BSTR pClass) PURE;
    STDMETHOD(get_ConvertAttachments)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_ConvertAttachments)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_CreationDate)(THIS_ DATE FAR* retval) PURE;
    STDMETHOD(get_Deleted)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(get_DownloadStatus)(THIS_ DIGWDownloadStatus FAR* FAR* retval) PURE;
    STDMETHOD(get_EnclosingFolders)(THIS_ DIGWFolders FAR* FAR* retval) PURE;
    STDMETHOD(get_ExpandedRecipients)(THIS_ DIGWRecipients FAR* FAR* retval) PURE;
    STDMETHOD(get_Fields)(THIS_ DIGWFields FAR* FAR* retval) PURE;
    STDMETHOD(get_FromText)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(put_FromText)(THIS_ BSTR Text) PURE;
    STDMETHOD(get_Hidden)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Hidden)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_MessageID)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(get_NotifyWhenDeleted)(THIS_ NotifyMessageConstants FAR* retval) PURE;
    STDMETHOD(put_NotifyWhenDeleted)(THIS_ NotifyMessageConstants How) PURE;
    STDMETHOD(get_NotifyWhenOpened)(THIS_ NotifyMessageConstants FAR* retval) PURE;
    STDMETHOD(put_NotifyWhenOpened)(THIS_ NotifyMessageConstants How) PURE;
    STDMETHOD(get_Opened)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Opened)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_Parent)(THIS_ DIGWAccount FAR* FAR* retval) PURE;
    STDMETHOD(get_Priority)(THIS_ MessagePriorityConstants FAR* retval) PURE;
    STDMETHOD(put_Priority)(THIS_ MessagePriorityConstants Priority) PURE;
    STDMETHOD(get_Read)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Read)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_Recipients)(THIS_ DIGWRecipients FAR* FAR* retval) PURE;
    STDMETHOD(get_ReplyChildren)(THIS_ DIGWMessageList FAR* FAR* retval) PURE;
    STDMETHOD(get_ReplyDaysRequested)(THIS_ int FAR* retval) PURE;
    STDMETHOD(put_ReplyDaysRequested)(THIS_ int Days) PURE;
    STDMETHOD(get_ReplyParent)(THIS_ DIGWMessage FAR* FAR* retval) PURE;
    STDMETHOD(get_ReplyRequested)(THIS_ ReplyRequestedConstants FAR* retval) PURE;
    STDMETHOD(put_ReplyRequested)(THIS_ ReplyRequestedConstants When) PURE;
    STDMETHOD(get_ReplyRoot)(THIS_ DIGWMessage FAR* FAR* retval) PURE;
    STDMETHOD(get_Routed)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Routed)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_RoutingEndOfLine)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(get_Sender)(THIS_ DIGWAddress FAR* FAR* retval) PURE;
    STDMETHOD(get_Subject)(THIS_ DIGWFormattedText FAR* FAR* retval) PURE;
    STDMETHOD(get_ViewName)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(put_ViewName)(THIS_ BSTR pClass) PURE;
    STDMETHOD(Annotate)(THIS_ DIGWNote2 FAR* Note) PURE;
    STDMETHOD(Clone)(THIS_ DIGWMessage FAR* FAR* retval) PURE;
    STDMETHOD(Delete)(THIS) PURE;
    STDMETHOD(Forward)(THIS_ DIGWMail FAR* FAR* retval) PURE;
    STDMETHOD(Refresh)(THIS) PURE;
    STDMETHOD(Reply)(THIS_ VARIANT ClassName, VARIANT ReplyToAll, VARIANT IncludeSenderMessageText, VARIANT AttachOriginalMessage, DIGWMessage FAR* FAR* retval) PURE;
    STDMETHOD(Retract)(THIS) PURE;
    STDMETHOD(Send)(THIS_ DIGWMessage FAR* FAR* retval) PURE;
#endif

    /* IGWMessage2 methods */
    STDMETHOD(get_ModifiedDate)(THIS_ DATE FAR* retval) PURE;
    STDMETHOD(get_Private)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Private)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_RevisionNumber)(THIS_ long FAR* retval) PURE;
    STDMETHOD(get_MasterRevisionNumber)(THIS_ long FAR* retval) PURE;
};

DEFINE_GUID(IID_IGWMessage3,0x481ED625L,0x4EFF,0x11D1,0x8D,0x79,0x00,0x80,0x5F,0xC1,0x28,0xBA);

/* Definition of interface: IGWMessage3 */
#undef INTERFACE
#define INTERFACE IGWMessage3

DECLARE_INTERFACE_(IGWMessage3, IGWMessage2)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IGWMessage methods */
    STDMETHOD(get_Application)(THIS_ DIGWSession FAR* FAR* retval) PURE;
    STDMETHOD(get_Attachments)(THIS_ DIGWAttachments FAR* FAR* retval) PURE;
    STDMETHOD(get_BodyText)(THIS_ DIGWFormattedText FAR* FAR* retval) PURE;
    STDMETHOD(get_BoxType)(THIS_ MessageBoxTypeConstants FAR* retval) PURE;
    STDMETHOD(get_ClassName)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(put_ClassName)(THIS_ BSTR pClass) PURE;
    STDMETHOD(get_ConvertAttachments)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_ConvertAttachments)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_CreationDate)(THIS_ DATE FAR* retval) PURE;
    STDMETHOD(get_Deleted)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(get_DownloadStatus)(THIS_ DIGWDownloadStatus FAR* FAR* retval) PURE;
    STDMETHOD(get_EnclosingFolders)(THIS_ DIGWFolders FAR* FAR* retval) PURE;
    STDMETHOD(get_ExpandedRecipients)(THIS_ DIGWRecipients FAR* FAR* retval) PURE;
    STDMETHOD(get_Fields)(THIS_ DIGWFields FAR* FAR* retval) PURE;
    STDMETHOD(get_FromText)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(put_FromText)(THIS_ BSTR Text) PURE;
    STDMETHOD(get_Hidden)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Hidden)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_MessageID)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(get_NotifyWhenDeleted)(THIS_ NotifyMessageConstants FAR* retval) PURE;
    STDMETHOD(put_NotifyWhenDeleted)(THIS_ NotifyMessageConstants How) PURE;
    STDMETHOD(get_NotifyWhenOpened)(THIS_ NotifyMessageConstants FAR* retval) PURE;
    STDMETHOD(put_NotifyWhenOpened)(THIS_ NotifyMessageConstants How) PURE;
    STDMETHOD(get_Opened)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Opened)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_Parent)(THIS_ DIGWAccount FAR* FAR* retval) PURE;
    STDMETHOD(get_Priority)(THIS_ MessagePriorityConstants FAR* retval) PURE;
    STDMETHOD(put_Priority)(THIS_ MessagePriorityConstants Priority) PURE;
    STDMETHOD(get_Read)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Read)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_Recipients)(THIS_ DIGWRecipients FAR* FAR* retval) PURE;
    STDMETHOD(get_ReplyChildren)(THIS_ DIGWMessageList FAR* FAR* retval) PURE;
    STDMETHOD(get_ReplyDaysRequested)(THIS_ int FAR* retval) PURE;
    STDMETHOD(put_ReplyDaysRequested)(THIS_ int Days) PURE;
    STDMETHOD(get_ReplyParent)(THIS_ DIGWMessage FAR* FAR* retval) PURE;
    STDMETHOD(get_ReplyRequested)(THIS_ ReplyRequestedConstants FAR* retval) PURE;
    STDMETHOD(put_ReplyRequested)(THIS_ ReplyRequestedConstants When) PURE;
    STDMETHOD(get_ReplyRoot)(THIS_ DIGWMessage FAR* FAR* retval) PURE;
    STDMETHOD(get_Routed)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Routed)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_RoutingEndOfLine)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(get_Sender)(THIS_ DIGWAddress FAR* FAR* retval) PURE;
    STDMETHOD(get_Subject)(THIS_ DIGWFormattedText FAR* FAR* retval) PURE;
    STDMETHOD(get_ViewName)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(put_ViewName)(THIS_ BSTR pClass) PURE;
    STDMETHOD(Annotate)(THIS_ DIGWNote2 FAR* Note) PURE;
    STDMETHOD(Clone)(THIS_ DIGWMessage FAR* FAR* retval) PURE;
    STDMETHOD(Delete)(THIS) PURE;
    STDMETHOD(Forward)(THIS_ DIGWMail FAR* FAR* retval) PURE;
    STDMETHOD(Refresh)(THIS) PURE;
    STDMETHOD(Reply)(THIS_ VARIANT ClassName, VARIANT ReplyToAll, VARIANT IncludeSenderMessageText, VARIANT AttachOriginalMessage, DIGWMessage FAR* FAR* retval) PURE;
    STDMETHOD(Retract)(THIS) PURE;
    STDMETHOD(Send)(THIS_ DIGWMessage FAR* FAR* retval) PURE;

    /* IGWMessage2 methods */
    STDMETHOD(get_ModifiedDate)(THIS_ DATE FAR* retval) PURE;
    STDMETHOD(get_Private)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Private)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_RevisionNumber)(THIS_ long FAR* retval) PURE;
    STDMETHOD(get_MasterRevisionNumber)(THIS_ long FAR* retval) PURE;
#endif

    /* IGWMessage3 methods */
    STDMETHOD(get_Archived)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Archived)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_Sharer)(THIS_ DIGWAddress FAR* FAR* retval) PURE;
    STDMETHOD(LocalDelete)(THIS) PURE;
};

DEFINE_GUID(DIID_DIGWMessage2,0x7D2276E1L,0xE158,0x11CE,0x87,0xEB,0x00,0x80,0x5F,0xB4,0xB2,0xBE);

/* Definition of dispatch interface: DIGWMessage2 */
#undef INTERFACE
#define INTERFACE DIGWMessage2

DECLARE_INTERFACE_(DIGWMessage2, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;
#endif

/* Capable of dispatching all the methods of interface IGWMessage2 */
};

DEFINE_GUID(DIID_DIGWMessage3,0x37D763A2L,0xF4BE,0x11D1,0x8D,0x8F,0x00,0x80,0x5F,0xC1,0x00,0xD4);

/* Definition of dispatch interface: DIGWMessage3 */
#undef INTERFACE
#define INTERFACE DIGWMessage3

DECLARE_INTERFACE_(DIGWMessage3, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;
#endif

/* Capable of dispatching all the methods of interface IGWMessage3 */
};

DEFINE_GUID(CLSID_Message,0xC89C2F61L,0x04AF,0x11CF,0xB0,0x49,0x00,0x80,0x5F,0x88,0xE6,0x02);

#ifdef __cplusplus
class Message;
#endif

DEFINE_GUID(CLSID_Message2,0xC89C2F69L,0x04AF,0x11CF,0xB0,0x49,0x00,0x80,0x5F,0x88,0xE6,0x02);

#ifdef __cplusplus
class Message2;
#endif

DEFINE_GUID(CLSID_Message3,0x65ABF7ACL,0xF4BE,0x11D1,0x8D,0x8F,0x00,0x80,0x5F,0xC1,0x00,0xD4);

#ifdef __cplusplus
class Message3;
#endif

DEFINE_GUID(IID_IGWAccount,0xA293EB40L,0x9C30,0x11CF,0x8C,0x91,0x00,0x80,0x5F,0x6C,0x4B,0xEF);

/* Definition of interface: IGWAccount */
#undef INTERFACE
#define INTERFACE IGWAccount

DECLARE_INTERFACE_(IGWAccount, IUnknown)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;
#endif

    /* IGWAccount methods */
    STDMETHOD(get_AccountRights)(THIS_ DIGWAccountRightsCollection FAR* FAR* retval) PURE;
    STDMETHOD(get_AddressBooks)(THIS_ DIGWAddressBooks FAR* FAR* retval) PURE;
    STDMETHOD(get_AllFolders)(THIS_ DIGWFolders FAR* FAR* retval) PURE;
    STDMETHOD(get_AllMessages)(THIS_ DIGWAllMessages FAR* FAR* retval) PURE;
    STDMETHOD(get_Application)(THIS_ DIGWSession FAR* FAR* retval) PURE;
    STDMETHOD(get_Cabinet)(THIS_ DIGWFolder FAR* FAR* retval) PURE;
    STDMETHOD(get_Calendar)(THIS_ DIGWFolder FAR* FAR* retval) PURE;
    STDMETHOD(get_DefaultAccountRights)(THIS_ DIGWAccountRights FAR* FAR* retval) PURE;
    STDMETHOD(get_DefaultAddressBook)(THIS_ DIGWCAddressBook FAR* FAR* retval) PURE;
    STDMETHOD(put_DefaultAddressBook)(THIS_ DIGWCAddressBook FAR* retval) PURE;
    STDMETHOD(get_DefaultDocumentLibrary)(THIS_ DIGWDocumentLibrary FAR* FAR* retval) PURE;
    STDMETHOD(get_DocumentLibraries)(THIS_ DIGWDocumentLibraries FAR* FAR* retval) PURE;
    STDMETHOD(get_FieldDefinitions)(THIS_ DIGWFieldDefinitions FAR* FAR* ppFieldDefs) PURE;
    STDMETHOD(get_Filters)(THIS_ DIGWFilters FAR* FAR* retval) PURE;
    STDMETHOD(get_FrequentContacts)(THIS_ DIGWCAddressBook FAR* FAR* retval) PURE;
    STDMETHOD(get_MailBox)(THIS_ DIGWFolder FAR* FAR* retval) PURE;
    STDMETHOD(get_ObjType)(THIS_ AddressTypeConstants FAR* retval) PURE;
    STDMETHOD(get_Owner)(THIS_ DIGWAddress FAR* FAR* retval) PURE;
    STDMETHOD(get_Parent)(THIS_ DIGWSession FAR* FAR* retval) PURE;
    STDMETHOD(get_PathToHost)(THIS_ BSTR FAR* pPathToHost) PURE;
    STDMETHOD(get_Proxied)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(get_Remote)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(get_RootFolder)(THIS_ DIGWFolder FAR* FAR* retval) PURE;
    STDMETHOD(get_SystemAddressBook)(THIS_ DIGWCAddressBook FAR* FAR* retval) PURE;
    STDMETHOD(get_TCPIPAddress)(THIS_ BSTR FAR* pTCPAddress) PURE;
    STDMETHOD(get_TCPIPPort)(THIS_ long FAR* pTCPPort) PURE;
    STDMETHOD(get_Trash)(THIS_ DIGWTrash FAR* FAR* retval) PURE;
    STDMETHOD(get_WorkFolder)(THIS_ DIGWFolder FAR* FAR* retval) PURE;
    STDMETHOD(get__Client)(THIS_ IUnknown * FAR* ppClient) PURE;
    STDMETHOD(get_MAPIHandler)(THIS_ VARIANT_BOOL spool, IUnknown * FAR* retval) PURE;
    STDMETHOD(CreateQuery)(THIS_ DIGWQuery FAR* FAR* retval) PURE;
    STDMETHOD(GetFolder)(THIS_ BSTR FolderID, DIGWFolder FAR* FAR* retval) PURE;
    STDMETHOD(GetMessage)(THIS_ BSTR MessageID, DIGWMessage FAR* FAR* retval) PURE;
    STDMETHOD(Refresh)(THIS) PURE;
    STDMETHOD(ReleaseMAPIHandle)(THIS) PURE;
    STDMETHOD(NGWTrap)(THIS_ VARIANT vTrapID, VARIANT vArg, VARIANT FAR* pvRet) PURE;
};

DEFINE_GUID(IID_IGWAccount2,0xF61EC4C6L,0xBD82,0x11D0,0xB3,0x34,0x00,0x80,0x5F,0x36,0xA3,0x75);

/* Definition of interface: IGWAccount2 */
#undef INTERFACE
#define INTERFACE IGWAccount2

DECLARE_INTERFACE_(IGWAccount2, IGWAccount)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IGWAccount methods */
    STDMETHOD(get_AccountRights)(THIS_ DIGWAccountRightsCollection FAR* FAR* retval) PURE;
    STDMETHOD(get_AddressBooks)(THIS_ DIGWAddressBooks FAR* FAR* retval) PURE;
    STDMETHOD(get_AllFolders)(THIS_ DIGWFolders FAR* FAR* retval) PURE;
    STDMETHOD(get_AllMessages)(THIS_ DIGWAllMessages FAR* FAR* retval) PURE;
    STDMETHOD(get_Application)(THIS_ DIGWSession FAR* FAR* retval) PURE;
    STDMETHOD(get_Cabinet)(THIS_ DIGWFolder FAR* FAR* retval) PURE;
    STDMETHOD(get_Calendar)(THIS_ DIGWFolder FAR* FAR* retval) PURE;
    STDMETHOD(get_DefaultAccountRights)(THIS_ DIGWAccountRights FAR* FAR* retval) PURE;
    STDMETHOD(get_DefaultAddressBook)(THIS_ DIGWCAddressBook FAR* FAR* retval) PURE;
    STDMETHOD(put_DefaultAddressBook)(THIS_ DIGWCAddressBook FAR* retval) PURE;
    STDMETHOD(get_DefaultDocumentLibrary)(THIS_ DIGWDocumentLibrary FAR* FAR* retval) PURE;
    STDMETHOD(get_DocumentLibraries)(THIS_ DIGWDocumentLibraries FAR* FAR* retval) PURE;
    STDMETHOD(get_FieldDefinitions)(THIS_ DIGWFieldDefinitions FAR* FAR* ppFieldDefs) PURE;
    STDMETHOD(get_Filters)(THIS_ DIGWFilters FAR* FAR* retval) PURE;
    STDMETHOD(get_FrequentContacts)(THIS_ DIGWCAddressBook FAR* FAR* retval) PURE;
    STDMETHOD(get_MailBox)(THIS_ DIGWFolder FAR* FAR* retval) PURE;
    STDMETHOD(get_ObjType)(THIS_ AddressTypeConstants FAR* retval) PURE;
    STDMETHOD(get_Owner)(THIS_ DIGWAddress FAR* FAR* retval) PURE;
    STDMETHOD(get_Parent)(THIS_ DIGWSession FAR* FAR* retval) PURE;
    STDMETHOD(get_PathToHost)(THIS_ BSTR FAR* pPathToHost) PURE;
    STDMETHOD(get_Proxied)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(get_Remote)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(get_RootFolder)(THIS_ DIGWFolder FAR* FAR* retval) PURE;
    STDMETHOD(get_SystemAddressBook)(THIS_ DIGWCAddressBook FAR* FAR* retval) PURE;
    STDMETHOD(get_TCPIPAddress)(THIS_ BSTR FAR* pTCPAddress) PURE;
    STDMETHOD(get_TCPIPPort)(THIS_ long FAR* pTCPPort) PURE;
    STDMETHOD(get_Trash)(THIS_ DIGWTrash FAR* FAR* retval) PURE;
    STDMETHOD(get_WorkFolder)(THIS_ DIGWFolder FAR* FAR* retval) PURE;
    STDMETHOD(get__Client)(THIS_ IUnknown * FAR* ppClient) PURE;
    STDMETHOD(get_MAPIHandler)(THIS_ VARIANT_BOOL spool, IUnknown * FAR* retval) PURE;
    STDMETHOD(CreateQuery)(THIS_ DIGWQuery FAR* FAR* retval) PURE;
    STDMETHOD(GetFolder)(THIS_ BSTR FolderID, DIGWFolder FAR* FAR* retval) PURE;
    STDMETHOD(GetMessage)(THIS_ BSTR MessageID, DIGWMessage FAR* FAR* retval) PURE;
    STDMETHOD(Refresh)(THIS) PURE;
    STDMETHOD(ReleaseMAPIHandle)(THIS) PURE;
    STDMETHOD(NGWTrap)(THIS_ VARIANT vTrapID, VARIANT vArg, VARIANT FAR* pvRet) PURE;
#endif

    /* IGWAccount2 methods */
    STDMETHOD(get_ProxyAccounts)(THIS_ DIGWAccounts FAR* FAR* retval) PURE;
    STDMETHOD(Proxy)(THIS_ VARIANT vUser, DIGWAccount FAR* FAR* retval) PURE;
    STDMETHOD(get_DocumentsFolder)(THIS_ DIGWFolder FAR* FAR* retval) PURE;
    STDMETHOD(GetArchiveAccount)(THIS_ VARIANT vPath, DIGWAccount FAR* FAR* retval) PURE;
    STDMETHOD(SetArchiveTo)(THIS_ VARIANT vr) PURE;
    STDMETHOD(MergeArchive)(THIS_ DIGWAccount FAR* pDestArchiveAcct) PURE;
    STDMETHOD(get_Archived)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(get_PathToArchive)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(get_DefaultPathToArchive)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(ConvertEmailAddress)(THIS_ VARIANT vEmail, VARIANT vEmailAddressFormats, BSTR FAR* retval) PURE;
};

DEFINE_GUID(DIID_DIGWAccount,0xA293EB41L,0x9C30,0x11CF,0x8C,0x91,0x00,0x80,0x5F,0x6C,0x4B,0xEF);

/* Definition of dispatch interface: DIGWAccount */
#undef INTERFACE
#define INTERFACE DIGWAccount

DECLARE_INTERFACE_(DIGWAccount, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;
#endif

/* Capable of dispatching all the methods of interface IGWAccount */
};

DEFINE_GUID(DIID_DIGWAccount2,0xA293EB43L,0x9C30,0x11CF,0x8C,0x91,0x00,0x80,0x5F,0x6C,0x4B,0xEF);

/* Definition of dispatch interface: DIGWAccount2 */
#undef INTERFACE
#define INTERFACE DIGWAccount2

DECLARE_INTERFACE_(DIGWAccount2, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;
#endif

/* Capable of dispatching all the methods of interface IGWAccount2 */
};

DEFINE_GUID(CLSID_Account,0xA293EB42L,0x9C30,0x11CF,0x8C,0x91,0x00,0x80,0x5F,0x6C,0x4B,0xEF);

#ifdef __cplusplus
class Account;
#endif

DEFINE_GUID(CLSID_Account2,0xA293EB45L,0x9C30,0x11CF,0x8C,0x91,0x00,0x80,0x5F,0x6C,0x4B,0xEF);

#ifdef __cplusplus
class Account2;
#endif

DEFINE_GUID(IID_IGWAccounts,0x5A549660L,0x2E2E,0x11CF,0x8C,0xF5,0x00,0x60,0x8C,0xE8,0x94,0xD9);

/* Definition of interface: IGWAccounts */
#undef INTERFACE
#define INTERFACE IGWAccounts

DECLARE_INTERFACE_(IGWAccounts, IUnknown)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;
#endif

    /* IGWAccounts methods */
    STDMETHOD(Item)(THIS_ long lIndex, DIGWAccount FAR* FAR* retval) PURE;
    STDMETHOD(get_Count)(THIS_ long FAR* retval) PURE;
    STDMETHOD(get__NewEnum)(THIS_ IUnknown * FAR* retval) PURE;
    STDMETHOD(get_Application)(THIS_ DIGWSession FAR* FAR* retval) PURE;
    STDMETHOD(get_Parent)(THIS_ DIGWSession FAR* FAR* retval) PURE;
};

DEFINE_GUID(DIID_DIGWAccounts,0xBA7E1EA0L,0x2E2C,0x11CF,0x8C,0xF5,0x00,0x60,0x8C,0xE8,0x94,0xD9);

/* Definition of dispatch interface: DIGWAccounts */
#undef INTERFACE
#define INTERFACE DIGWAccounts

DECLARE_INTERFACE_(DIGWAccounts, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;
#endif

/* Capable of dispatching all the methods of interface IGWAccounts */
};

DEFINE_GUID(CLSID_Accounts,0xC89C2D21L,0x04AF,0x11CF,0xB0,0x49,0x00,0x80,0x5F,0x88,0xE6,0x02);

#ifdef __cplusplus
class Accounts;
#endif

DEFINE_GUID(IID_IGWAccountRights,0x256ECDA0L,0x78EB,0x11CF,0x97,0x81,0x00,0x80,0x5F,0x02,0x9A,0x88);

/* Definition of interface: IGWAccountRights */
#undef INTERFACE
#define INTERFACE IGWAccountRights

DECLARE_INTERFACE_(IGWAccountRights, IUnknown)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;
#endif

    /* IGWAccountRights methods */
    STDMETHOD(Delete)(THIS) PURE;
    STDMETHOD(get_Address)(THIS_ DIGWAddress FAR* FAR* retval) PURE;
    STDMETHOD(get_Application)(THIS_ DIGWSession FAR* FAR* retval) PURE;
    STDMETHOD(put_Archive)(THIS_ VARIANT_BOOL Param) PURE;
    STDMETHOD(get_Archive)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_BitMask)(THIS_ long Param) PURE;
    STDMETHOD(get_BitMask)(THIS_ long FAR* retval) PURE;
    STDMETHOD(put_ModifyPrefsRulesGroups)(THIS_ VARIANT_BOOL Param) PURE;
    STDMETHOD(get_ModifyPrefsRulesGroups)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(get_Parent)(THIS_ IDispatch * FAR* retval) PURE;
    STDMETHOD(put_ReadAppointments)(THIS_ VARIANT_BOOL Param) PURE;
    STDMETHOD(get_ReadAppointments)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_ReadMailPhone)(THIS_ VARIANT_BOOL Param) PURE;
    STDMETHOD(get_ReadMailPhone)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_ReadNotes)(THIS_ VARIANT_BOOL Param) PURE;
    STDMETHOD(get_ReadNotes)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_ReadPrivate)(THIS_ VARIANT_BOOL Param) PURE;
    STDMETHOD(get_ReadPrivate)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_ReadTasks)(THIS_ VARIANT_BOOL Param) PURE;
    STDMETHOD(get_ReadTasks)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_ReceiveAlarms)(THIS_ VARIANT_BOOL Param) PURE;
    STDMETHOD(get_ReceiveAlarms)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_ReceiveNotifications)(THIS_ VARIANT_BOOL Param) PURE;
    STDMETHOD(get_ReceiveNotifications)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_WriteAppointments)(THIS_ VARIANT_BOOL Param) PURE;
    STDMETHOD(get_WriteAppointments)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_WriteMailPhone)(THIS_ VARIANT_BOOL Param) PURE;
    STDMETHOD(get_WriteMailPhone)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_WriteNotes)(THIS_ VARIANT_BOOL Param) PURE;
    STDMETHOD(get_WriteNotes)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_WriteTasks)(THIS_ VARIANT_BOOL Param) PURE;
    STDMETHOD(get_WriteTasks)(THIS_ VARIANT_BOOL FAR* retval) PURE;
};

DEFINE_GUID(DIID_DIGWAccountRights,0x256ECDA1L,0x78EB,0x11CF,0x97,0x81,0x00,0x80,0x5F,0x02,0x9A,0x88);

/* Definition of dispatch interface: DIGWAccountRights */
#undef INTERFACE
#define INTERFACE DIGWAccountRights

DECLARE_INTERFACE_(DIGWAccountRights, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;
#endif

/* Capable of dispatching all the methods of interface IGWAccountRights */
};

DEFINE_GUID(CLSID_AccountRights,0x842EBDE0L,0x7E46,0x11CF,0x97,0x81,0x00,0x80,0x5F,0x02,0x9A,0x88);

#ifdef __cplusplus
class AccountRights;
#endif

DEFINE_GUID(IID_IGWAccountRightsCollection,0x256ECDA3L,0x78EB,0x11CF,0x97,0x81,0x00,0x80,0x5F,0x02,0x9A,0x88);

/* Definition of interface: IGWAccountRightsCollection */
#undef INTERFACE
#define INTERFACE IGWAccountRightsCollection

DECLARE_INTERFACE_(IGWAccountRightsCollection, IUnknown)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;
#endif

    /* IGWAccountRightsCollection methods */
    STDMETHOD(Add)(THIS_ VARIANT Address, long Rights) PURE;
    STDMETHOD(Item)(THIS_ long Index, DIGWAccountRights FAR* FAR* retval) PURE;
    STDMETHOD(get_Application)(THIS_ DIGWSession FAR* FAR* retval) PURE;
    STDMETHOD(get_Count)(THIS_ long FAR* retval) PURE;
    STDMETHOD(get__NewEnum)(THIS_ IUnknown * FAR* retval) PURE;
    STDMETHOD(get_Parent)(THIS_ DIGWAccount FAR* FAR* retval) PURE;
};

DEFINE_GUID(DIID_DIGWAccountRightsCollection,0x256ECDA4L,0x78EB,0x11CF,0x97,0x81,0x00,0x80,0x5F,0x02,0x9A,0x88);

/* Definition of dispatch interface: DIGWAccountRightsCollection */
#undef INTERFACE
#define INTERFACE DIGWAccountRightsCollection

DECLARE_INTERFACE_(DIGWAccountRightsCollection, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;
#endif

/* Capable of dispatching all the methods of interface IGWAccountRightsCollection */
};

DEFINE_GUID(CLSID_AccountRightsCollection,0x842EBDE1L,0x7E46,0x11CF,0x97,0x81,0x00,0x80,0x5F,0x02,0x9A,0x88);

#ifdef __cplusplus
class AccountRightsCollection;
#endif

DEFINE_GUID(IID_IGWAddress,0xB9C2AD00L,0x03DE,0x11CF,0xB0,0x49,0x00,0x80,0x5F,0x88,0xE6,0x02);

/* Definition of interface: IGWAddress */
#undef INTERFACE
#define INTERFACE IGWAddress

DECLARE_INTERFACE_(IGWAddress, IUnknown)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;
#endif

    /* IGWAddress methods */
    STDMETHOD(get_DisplayName)(THIS_ BSTR FAR* ppName) PURE;
    STDMETHOD(put_DisplayName)(THIS_ BSTR pName) PURE;
    STDMETHOD(get_EmailAddress)(THIS_ BSTR FAR* ppAddress) PURE;
    STDMETHOD(put_EmailAddress)(THIS_ BSTR pAddress) PURE;
    STDMETHOD(get_EmailType)(THIS_ BSTR FAR* ppType) PURE;
    STDMETHOD(put_EmailType)(THIS_ BSTR pType) PURE;
    STDMETHOD(get_ObjType)(THIS_ AddressTypeConstants FAR* pEType) PURE;
    STDMETHOD(put_ObjType)(THIS_ AddressTypeConstants etType) PURE;
    STDMETHOD(get_Application)(THIS_ DIGWSession FAR* FAR* retval) PURE;
    STDMETHOD(get_Parent)(THIS_ IDispatch * FAR* retval) PURE;
};

DEFINE_GUID(DIID_DIGWAddress,0xA7508D00L,0x03E2,0x11CF,0xB0,0x49,0x00,0x80,0x5F,0x88,0xE6,0x02);

/* Definition of dispatch interface: DIGWAddress */
#undef INTERFACE
#define INTERFACE DIGWAddress

DECLARE_INTERFACE_(DIGWAddress, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;
#endif

/* Capable of dispatching all the methods of interface IGWAddress */
};

DEFINE_GUID(CLSID_Address,0xC89C2D22L,0x04AF,0x11CF,0xB0,0x49,0x00,0x80,0x5F,0x88,0xE6,0x02);

#ifdef __cplusplus
class Address;
#endif

DEFINE_GUID(IID_IGWAddresses,0x1A597A60L,0x45E6,0x11CF,0x97,0xF6,0x00,0x60,0x8C,0xE8,0x2F,0x4D);

/* Definition of interface: IGWAddresses */
#undef INTERFACE
#define INTERFACE IGWAddresses

DECLARE_INTERFACE_(IGWAddresses, IUnknown)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;
#endif

    /* IGWAddresses methods */
    STDMETHOD(Add)(THIS_ VARIANT vAddr) PURE;
    STDMETHOD(Item)(THIS_ VARIANT Index, DIGWAddress FAR* FAR* retval) PURE;
    STDMETHOD(Remove)(THIS_ VARIANT Index) PURE;
    STDMETHOD(get__NewEnum)(THIS_ IUnknown * FAR* retval) PURE;
    STDMETHOD(get_Application)(THIS_ DIGWSession FAR* FAR* retval) PURE;
    STDMETHOD(get_Count)(THIS_ long FAR* retval) PURE;
    STDMETHOD(get_Parent)(THIS_ IDispatch * FAR* retval) PURE;
};

DEFINE_GUID(DIID_DIGWAddresses,0x1A597A61L,0x45E6,0x11CF,0x97,0xF6,0x00,0x60,0x8C,0xE8,0x2F,0x4D);

/* Definition of dispatch interface: DIGWAddresses */
#undef INTERFACE
#define INTERFACE DIGWAddresses

DECLARE_INTERFACE_(DIGWAddresses, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;
#endif

/* Capable of dispatching all the methods of interface IGWAddresses */
};

DEFINE_GUID(CLSID_Addresses,0xC89C2D23L,0x04AF,0x11CF,0xB0,0x49,0x00,0x80,0x5F,0x88,0xE6,0x02);

#ifdef __cplusplus
class Addresses;
#endif

DEFINE_GUID(IID_IGWCAddressBook,0x4A1E6840L,0x03E3,0x11CF,0xB0,0x49,0x00,0x80,0x5F,0x88,0xE6,0x02);

/* Definition of interface: IGWCAddressBook */
#undef INTERFACE
#define INTERFACE IGWCAddressBook

DECLARE_INTERFACE_(IGWCAddressBook, IUnknown)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;
#endif

    /* IGWCAddressBook methods */
    STDMETHOD(Delete)(THIS) PURE;
    STDMETHOD(get_Name)(THIS_ BSTR FAR* pName) PURE;
    STDMETHOD(get_ProviderID)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(get_ObjType)(THIS_ AddressBookTypeConstants FAR* pType) PURE;
    STDMETHOD(get_Subtype)(THIS_ AddressBookSubtypeConstants FAR* pType) PURE;
    STDMETHOD(get_AddressBookEntries)(THIS_ DIGWAddressBookEntries FAR* FAR* ppABEntries) PURE;
    STDMETHOD(get_FieldDefinitions)(THIS_ DIGWFieldDefinitions FAR* FAR* ppFieldDefs) PURE;
    STDMETHOD(get_SortOrder)(THIS_ SortConstants FAR* pSortOrder) PURE;
    STDMETHOD(put_SortOrder)(THIS_ SortConstants etSortOrder) PURE;
    STDMETHOD(get_Application)(THIS_ DIGWSession FAR* FAR* retval) PURE;
    STDMETHOD(get_Parent)(THIS_ DIGWAddressBooks FAR* FAR* retval) PURE;
    STDMETHOD(get_Default)(THIS_ VARIANT_BOOL FAR* retval) PURE;
};

DEFINE_GUID(IID_IGWCAddressBook2,0x366DD0AEL,0x4989,0x11D1,0x8B,0x4A,0x00,0x80,0x5F,0xC1,0x40,0x33);

/* Definition of interface: IGWCAddressBook2 */
#undef INTERFACE
#define INTERFACE IGWCAddressBook2

DECLARE_INTERFACE_(IGWCAddressBook2, IGWCAddressBook)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IGWCAddressBook methods */
    STDMETHOD(Delete)(THIS) PURE;
    STDMETHOD(get_Name)(THIS_ BSTR FAR* pName) PURE;
    STDMETHOD(get_ProviderID)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(get_ObjType)(THIS_ AddressBookTypeConstants FAR* pType) PURE;
    STDMETHOD(get_Subtype)(THIS_ AddressBookSubtypeConstants FAR* pType) PURE;
    STDMETHOD(get_AddressBookEntries)(THIS_ DIGWAddressBookEntries FAR* FAR* ppABEntries) PURE;
    STDMETHOD(get_FieldDefinitions)(THIS_ DIGWFieldDefinitions FAR* FAR* ppFieldDefs) PURE;
    STDMETHOD(get_SortOrder)(THIS_ SortConstants FAR* pSortOrder) PURE;
    STDMETHOD(put_SortOrder)(THIS_ SortConstants etSortOrder) PURE;
    STDMETHOD(get_Application)(THIS_ DIGWSession FAR* FAR* retval) PURE;
    STDMETHOD(get_Parent)(THIS_ DIGWAddressBooks FAR* FAR* retval) PURE;
    STDMETHOD(get_Default)(THIS_ VARIANT_BOOL FAR* retval) PURE;
#endif

    /* IGWCAddressBook2 methods */
    STDMETHOD(get_AddressBookRights)(THIS_ DIGWAddressBookRightsCollection FAR* FAR* retval) PURE;
    STDMETHOD(Refresh)(THIS) PURE;
};

DEFINE_GUID(DIID_DIGWCAddressBook,0x5FDED6A0L,0x03E4,0x11CF,0xB0,0x49,0x00,0x80,0x5F,0x88,0xE6,0x02);

/* Definition of dispatch interface: DIGWCAddressBook */
#undef INTERFACE
#define INTERFACE DIGWCAddressBook

DECLARE_INTERFACE_(DIGWCAddressBook, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;
#endif

/* Capable of dispatching all the methods of interface IGWCAddressBook */
};

DEFINE_GUID(DIID_DIGWCAddressBook2,0x5FDED6A1L,0x03E4,0x11CF,0xB0,0x49,0x00,0x80,0x5F,0x88,0xE6,0x02);

/* Definition of dispatch interface: DIGWCAddressBook2 */
#undef INTERFACE
#define INTERFACE DIGWCAddressBook2

DECLARE_INTERFACE_(DIGWCAddressBook2, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;
#endif

/* Capable of dispatching all the methods of interface IGWCAddressBook2 */
};

DEFINE_GUID(CLSID_AddressBook,0xC89C2D24L,0x04AF,0x11CF,0xB0,0x49,0x00,0x80,0x5F,0x88,0xE6,0x02);

#ifdef __cplusplus
class AddressBook;
#endif

DEFINE_GUID(CLSID_AddressBook2,0xC89C2D29L,0x04AF,0x11CF,0xB0,0x49,0x00,0x80,0x5F,0x88,0xE6,0x02);

#ifdef __cplusplus
class AddressBook2;
#endif

DEFINE_GUID(IID_IGWAddressBooks,0x7B022A40L,0x03E4,0x11CF,0xB0,0x49,0x00,0x80,0x5F,0x88,0xE6,0x02);

/* Definition of interface: IGWAddressBooks */
#undef INTERFACE
#define INTERFACE IGWAddressBooks

DECLARE_INTERFACE_(IGWAddressBooks, IUnknown)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;
#endif

    /* IGWAddressBooks methods */
    STDMETHOD(Item)(THIS_ VARIANT vTarget, DIGWCAddressBook FAR* FAR* retval) PURE;
    STDMETHOD(Add)(THIS_ BSTR Name, DIGWCAddressBook FAR* FAR* retval) PURE;
    STDMETHOD(get_Count)(THIS_ long FAR* retval) PURE;
    STDMETHOD(get__NewEnum)(THIS_ IUnknown * FAR* retval) PURE;
    STDMETHOD(get_Application)(THIS_ DIGWSession FAR* FAR* retval) PURE;
    STDMETHOD(get_Parent)(THIS_ DIGWAccount FAR* FAR* retval) PURE;
};

DEFINE_GUID(IID_IGWAddressBooks2,0x366DD0AFL,0x4989,0x11D1,0x8B,0x4A,0x00,0x80,0x5F,0xC1,0x40,0x33);

/* Definition of interface: IGWAddressBooks2 */
#undef INTERFACE
#define INTERFACE IGWAddressBooks2

DECLARE_INTERFACE_(IGWAddressBooks2, IGWAddressBooks)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IGWAddressBooks methods */
    STDMETHOD(Item)(THIS_ VARIANT vTarget, DIGWCAddressBook FAR* FAR* retval) PURE;
    STDMETHOD(Add)(THIS_ BSTR Name, DIGWCAddressBook FAR* FAR* retval) PURE;
    STDMETHOD(get_Count)(THIS_ long FAR* retval) PURE;
    STDMETHOD(get__NewEnum)(THIS_ IUnknown * FAR* retval) PURE;
    STDMETHOD(get_Application)(THIS_ DIGWSession FAR* FAR* retval) PURE;
    STDMETHOD(get_Parent)(THIS_ DIGWAccount FAR* FAR* retval) PURE;
#endif

    /* IGWAddressBooks2 methods */
    STDMETHOD(AddEx)(THIS_ DIGWSharedNotification FAR* SharedAddressBookNotify, VARIANT Name, DIGWCAddressBook FAR* FAR* retval) PURE;
};

DEFINE_GUID(DIID_DIGWAddressBooks,0xA1A4E980L,0x03E4,0x11CF,0xB0,0x49,0x00,0x80,0x5F,0x88,0xE6,0x02);

/* Definition of dispatch interface: DIGWAddressBooks */
#undef INTERFACE
#define INTERFACE DIGWAddressBooks

DECLARE_INTERFACE_(DIGWAddressBooks, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;
#endif

/* Capable of dispatching all the methods of interface IGWAddressBooks */
};

DEFINE_GUID(DIID_DIGWAddressBooks2,0xA1A4E981L,0x03E4,0x11CF,0xB0,0x49,0x00,0x80,0x5F,0x88,0xE6,0x02);

/* Definition of dispatch interface: DIGWAddressBooks2 */
#undef INTERFACE
#define INTERFACE DIGWAddressBooks2

DECLARE_INTERFACE_(DIGWAddressBooks2, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;
#endif

/* Capable of dispatching all the methods of interface IGWAddressBooks2 */
};

DEFINE_GUID(CLSID_AddressBooks,0xC89C2D25L,0x04AF,0x11CF,0xB0,0x49,0x00,0x80,0x5F,0x88,0xE6,0x02);

#ifdef __cplusplus
class AddressBooks;
#endif

DEFINE_GUID(CLSID_AddressBooks2,0xC89C2D2BL,0x04AF,0x11CF,0xB0,0x49,0x00,0x80,0x5F,0x88,0xE6,0x02);

#ifdef __cplusplus
class AddressBooks2;
#endif

DEFINE_GUID(IID_IGWAddressBookEntry,0x52302500L,0x0D52,0x11CF,0xB0,0x49,0x00,0x80,0x5F,0x88,0xE6,0x02);

/* Definition of interface: IGWAddressBookEntry */
#undef INTERFACE
#define INTERFACE IGWAddressBookEntry

DECLARE_INTERFACE_(IGWAddressBookEntry, IGWAddress)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IGWAddress methods */
    STDMETHOD(get_DisplayName)(THIS_ BSTR FAR* ppName) PURE;
    STDMETHOD(put_DisplayName)(THIS_ BSTR pName) PURE;
    STDMETHOD(get_EmailAddress)(THIS_ BSTR FAR* ppAddress) PURE;
    STDMETHOD(put_EmailAddress)(THIS_ BSTR pAddress) PURE;
    STDMETHOD(get_EmailType)(THIS_ BSTR FAR* ppType) PURE;
    STDMETHOD(put_EmailType)(THIS_ BSTR pType) PURE;
    STDMETHOD(get_ObjType)(THIS_ AddressTypeConstants FAR* pEType) PURE;
    STDMETHOD(put_ObjType)(THIS_ AddressTypeConstants etType) PURE;
    STDMETHOD(get_Application)(THIS_ DIGWSession FAR* FAR* retval) PURE;
    STDMETHOD(get_Parent)(THIS_ IDispatch * FAR* retval) PURE;
#endif

    /* IGWAddressBookEntry methods */
    STDMETHOD(Delete)(THIS) PURE;
    STDMETHOD(get_Fields)(THIS_ DIGWFields FAR* FAR* pFields) PURE;
    STDMETHOD(get_Members)(THIS_ DIGWGroupMembers FAR* FAR* pMembers) PURE;
    STDMETHOD(Refresh)(THIS) PURE;
};

DEFINE_GUID(DIID_DIGWAddressBookEntry,0xE6056F40L,0x0D59,0x11CF,0xB0,0x49,0x00,0x80,0x5F,0x88,0xE6,0x02);

/* Definition of dispatch interface: DIGWAddressBookEntry */
#undef INTERFACE
#define INTERFACE DIGWAddressBookEntry

DECLARE_INTERFACE_(DIGWAddressBookEntry, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;
#endif

/* Capable of dispatching all the methods of interface IGWAddressBookEntry */
};

DEFINE_GUID(IID_IGWAddressBookEntry2,0xE31BE010L,0xC893,0x11D0,0xB3,0x43,0x00,0x80,0x5F,0x36,0xA3,0x75);

/* Definition of interface: IGWAddressBookEntry2 */
#undef INTERFACE
#define INTERFACE IGWAddressBookEntry2

DECLARE_INTERFACE_(IGWAddressBookEntry2, IGWAddressBookEntry)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IGWAddress methods */
    STDMETHOD(get_DisplayName)(THIS_ BSTR FAR* ppName) PURE;
    STDMETHOD(put_DisplayName)(THIS_ BSTR pName) PURE;
    STDMETHOD(get_EmailAddress)(THIS_ BSTR FAR* ppAddress) PURE;
    STDMETHOD(put_EmailAddress)(THIS_ BSTR pAddress) PURE;
    STDMETHOD(get_EmailType)(THIS_ BSTR FAR* ppType) PURE;
    STDMETHOD(put_EmailType)(THIS_ BSTR pType) PURE;
    STDMETHOD(get_ObjType)(THIS_ AddressTypeConstants FAR* pEType) PURE;
    STDMETHOD(put_ObjType)(THIS_ AddressTypeConstants etType) PURE;
    STDMETHOD(get_Application)(THIS_ DIGWSession FAR* FAR* retval) PURE;
    STDMETHOD(get_Parent)(THIS_ IDispatch * FAR* retval) PURE;

    /* IGWAddressBookEntry methods */
    STDMETHOD(Delete)(THIS) PURE;
    STDMETHOD(get_Fields)(THIS_ DIGWFields FAR* FAR* pFields) PURE;
    STDMETHOD(get_Members)(THIS_ DIGWGroupMembers FAR* FAR* pMembers) PURE;
    STDMETHOD(Refresh)(THIS) PURE;
#endif

    /* IGWAddressBookEntry2 methods */
    STDMETHOD(get_MasterRevisionNumber)(THIS_ long FAR* retval) PURE;
    STDMETHOD(get_RevisionNumber)(THIS_ long FAR* retval) PURE;
};

DEFINE_GUID(DIID_DIGWAddressBookEntry2,0xE31BE011L,0xC893,0x11D0,0xB3,0x43,0x00,0x80,0x5F,0x36,0xA3,0x75);

/* Definition of dispatch interface: DIGWAddressBookEntry2 */
#undef INTERFACE
#define INTERFACE DIGWAddressBookEntry2

DECLARE_INTERFACE_(DIGWAddressBookEntry2, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;
#endif

/* Capable of dispatching all the methods of interface IGWAddressBookEntry2 */
};

DEFINE_GUID(CLSID_AddressBookEntry,0xE31BE012L,0xC893,0x11D0,0xB3,0x43,0x00,0x80,0x5F,0x36,0xA3,0x75);

#ifdef __cplusplus
class AddressBookEntry;
#endif

DEFINE_GUID(CLSID_AddressBookEntry2,0xE31BE019L,0xC893,0x11D0,0xB3,0x43,0x00,0x80,0x5F,0x36,0xA3,0x75);

#ifdef __cplusplus
class AddressBookEntry2;
#endif

DEFINE_GUID(IID_IGWAddressBookEntries,0x1C199FC0L,0x03E1,0x11CF,0xB0,0x49,0x00,0x80,0x5F,0x88,0xE6,0x02);

/* Definition of interface: IGWAddressBookEntries */
#undef INTERFACE
#define INTERFACE IGWAddressBookEntries

DECLARE_INTERFACE_(IGWAddressBookEntries, IUnknown)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;
#endif

    /* IGWAddressBookEntries methods */
    STDMETHOD(Item)(THIS_ VARIANT index, DIGWAddressBookEntry FAR* FAR* ppABEntry) PURE;
    STDMETHOD(Add)(THIS_ VARIANT vParm1, VARIANT vParm2, VARIANT vParm3, VARIANT vParm4, DIGWAddressBookEntry FAR* FAR* ppABEntry) PURE;
    STDMETHOD(Find)(THIS_ BSTR Condition, DIGWAddresses FAR* FAR* ppAddresses) PURE;
    STDMETHOD(get_Count)(THIS_ long FAR* retval) PURE;
    STDMETHOD(get__NewEnum)(THIS_ IUnknown * FAR* retval) PURE;
    STDMETHOD(get_Application)(THIS_ DIGWSession FAR* FAR* retval) PURE;
    STDMETHOD(get_Parent)(THIS_ DIGWCAddressBook FAR* FAR* retval) PURE;
};

DEFINE_GUID(DIID_DIGWAddressBookEntries,0x2FC89340L,0x03E2,0x11CF,0xB0,0x49,0x00,0x80,0x5F,0x88,0xE6,0x02);

/* Definition of dispatch interface: DIGWAddressBookEntries */
#undef INTERFACE
#define INTERFACE DIGWAddressBookEntries

DECLARE_INTERFACE_(DIGWAddressBookEntries, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;
#endif

/* Capable of dispatching all the methods of interface IGWAddressBookEntries */
};

DEFINE_GUID(CLSID_AddressBookEntries,0xC89C2D27L,0x04AF,0x11CF,0xB0,0x49,0x00,0x80,0x5F,0x88,0xE6,0x02);

#ifdef __cplusplus
class AddressBookEntries;
#endif

DEFINE_GUID(IID_IGWAddressBookRights,0x0B9F9926L,0x4988,0x11D1,0x8B,0x4A,0x00,0x80,0x5F,0xC1,0x40,0x33);

/* Definition of interface: IGWAddressBookRights */
#undef INTERFACE
#define INTERFACE IGWAddressBookRights

DECLARE_INTERFACE_(IGWAddressBookRights, IUnknown)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;
#endif

    /* IGWAddressBookRights methods */
    STDMETHOD(Delete)(THIS) PURE;
    STDMETHOD(get_Access)(THIS_ AddressBookRightsConstants FAR* retval) PURE;
    STDMETHOD(put_Access)(THIS_ AddressBookRightsConstants etAccessRights) PURE;
    STDMETHOD(get_Address)(THIS_ DIGWAddress FAR* FAR* retval) PURE;
    STDMETHOD(get_Application)(THIS_ DIGWSession FAR* FAR* retval) PURE;
    STDMETHOD(get_Parent)(THIS_ DIGWAddressBookRightsCollection FAR* FAR* retval) PURE;
};

DEFINE_GUID(DIID_DIGWAddressBookRights,0x0B9F9927L,0x4988,0x11D1,0x8B,0x4A,0x00,0x80,0x5F,0xC1,0x40,0x33);

/* Definition of dispatch interface: DIGWAddressBookRights */
#undef INTERFACE
#define INTERFACE DIGWAddressBookRights

DECLARE_INTERFACE_(DIGWAddressBookRights, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;
#endif

/* Capable of dispatching all the methods of interface IGWAddressBookRights */
};

DEFINE_GUID(CLSID_AddressBookRights,0x0B9F9928L,0x4988,0x11D1,0x8B,0x4A,0x00,0x80,0x5F,0xC1,0x40,0x33);

#ifdef __cplusplus
class AddressBookRights;
#endif

DEFINE_GUID(IID_IGWAddressBookRightsCollection,0x0B9F9929L,0x4988,0x11D1,0x8B,0x4A,0x00,0x80,0x5F,0xC1,0x40,0x33);

/* Definition of interface: IGWAddressBookRightsCollection */
#undef INTERFACE
#define INTERFACE IGWAddressBookRightsCollection

DECLARE_INTERFACE_(IGWAddressBookRightsCollection, IUnknown)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;
#endif

    /* IGWAddressBookRightsCollection methods */
    STDMETHOD(Item)(THIS_ VARIANT index, DIGWAddressBookRights FAR* FAR* ppABRights) PURE;
    STDMETHOD(Add)(THIS_ VARIANT vAddress, AddressBookRightsConstants eAccessRights) PURE;
    STDMETHOD(Commit)(THIS_ BSTR Subject, BSTR BodyText) PURE;
    STDMETHOD(get_Count)(THIS_ long FAR* retval) PURE;
    STDMETHOD(get__NewEnum)(THIS_ IUnknown * FAR* retval) PURE;
    STDMETHOD(get_Application)(THIS_ DIGWSession FAR* FAR* retval) PURE;
    STDMETHOD(get_Parent)(THIS_ DIGWCAddressBook FAR* FAR* retval) PURE;
};

DEFINE_GUID(DIID_DIGWAddressBookRightsCollection,0x0B9F992AL,0x4988,0x11D1,0x8B,0x4A,0x00,0x80,0x5F,0xC1,0x40,0x33);

/* Definition of dispatch interface: DIGWAddressBookRightsCollection */
#undef INTERFACE
#define INTERFACE DIGWAddressBookRightsCollection

DECLARE_INTERFACE_(DIGWAddressBookRightsCollection, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;
#endif

/* Capable of dispatching all the methods of interface IGWAddressBookRightsCollection */
};

DEFINE_GUID(CLSID_AddressBookRightsCollection,0x0B9F992BL,0x4988,0x11D1,0x8B,0x4A,0x00,0x80,0x5F,0xC1,0x40,0x33);

#ifdef __cplusplus
class AddressBookRightsCollection;
#endif

DEFINE_GUID(IID_IGWAllMessages,0x7D2265F2L,0xE158,0x11CE,0x87,0xEB,0x00,0x80,0x5F,0xB4,0xB2,0xBE);

/* Definition of interface: IGWAllMessages */
#undef INTERFACE
#define INTERFACE IGWAllMessages

DECLARE_INTERFACE_(IGWAllMessages, IUnknown)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;
#endif

    /* IGWAllMessages methods */
    STDMETHOD(get_Application)(THIS_ DIGWSession FAR* FAR* retval) PURE;
    STDMETHOD(get__NewEnum)(THIS_ IUnknown * FAR* retval) PURE;
    STDMETHOD(get_Parent)(THIS_ DIGWAccount FAR* FAR* retval) PURE;
    STDMETHOD(CreateAllMessagesIterator)(THIS_ DIGWAllMessagesIterator FAR* FAR* retval) PURE;
    STDMETHOD(Find)(THIS_ VARIANT Condition, DIGWMessageList FAR* FAR* retval) PURE;
};

DEFINE_GUID(DIID_DIGWAllMessages,0x7D2265F3L,0xE158,0x11CE,0x87,0xEB,0x00,0x80,0x5F,0xB4,0xB2,0xBE);

/* Definition of dispatch interface: DIGWAllMessages */
#undef INTERFACE
#define INTERFACE DIGWAllMessages

DECLARE_INTERFACE_(DIGWAllMessages, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;
#endif

/* Capable of dispatching all the methods of interface IGWAllMessages */
};

DEFINE_GUID(CLSID_AllMessages,0xC89C2E72L,0x04AF,0x11CF,0xB0,0x49,0x00,0x80,0x5F,0x88,0xE6,0x02);

#ifdef __cplusplus
class AllMessages;
#endif

DEFINE_GUID(IID_IGWAllMessagesIterator,0x7D2265F4L,0xE158,0x11CE,0x87,0xEB,0x00,0x80,0x5F,0xB4,0xB2,0xBE);

/* Definition of interface: IGWAllMessagesIterator */
#undef INTERFACE
#define INTERFACE IGWAllMessagesIterator

DECLARE_INTERFACE_(IGWAllMessagesIterator, IUnknown)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;
#endif

    /* IGWAllMessagesIterator methods */
    STDMETHOD(get_Application)(THIS_ DIGWSession FAR* FAR* retval) PURE;
    STDMETHOD(get_Parent)(THIS_ DIGWAllMessages FAR* FAR* retval) PURE;
    STDMETHOD(Clone)(THIS_ DIGWAllMessagesIterator FAR* FAR* retval) PURE;
    STDMETHOD(Next)(THIS_ DIGWMessage FAR* FAR* retval) PURE;
    STDMETHOD(Reset)(THIS) PURE;
    STDMETHOD(Skip)(THIS_ long NumMessages) PURE;
};

DEFINE_GUID(DIID_DIGWAllMessagesIterator,0x7D2265F5L,0xE158,0x11CE,0x87,0xEB,0x00,0x80,0x5F,0xB4,0xB2,0xBE);

/* Definition of dispatch interface: DIGWAllMessagesIterator */
#undef INTERFACE
#define INTERFACE DIGWAllMessagesIterator

DECLARE_INTERFACE_(DIGWAllMessagesIterator, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;
#endif

/* Capable of dispatching all the methods of interface IGWAllMessagesIterator */
};

DEFINE_GUID(CLSID_AllMessagesIterator,0xC89C2E73L,0x04AF,0x11CF,0xB0,0x49,0x00,0x80,0x5F,0x88,0xE6,0x02);

#ifdef __cplusplus
class AllMessagesIterator;
#endif

DEFINE_GUID(IID_IGWSession,0x5CBCBA00L,0xBB12,0x11CE,0xB6,0xF9,0x00,0x60,0x8C,0x84,0xE1,0xC4);

/* Definition of interface: IGWSession */
#undef INTERFACE
#define INTERFACE IGWSession

DECLARE_INTERFACE_(IGWSession, IUnknown)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;
#endif

    /* IGWSession methods */
    STDMETHOD(get_ProxyAccounts)(THIS_ DIGWAccounts FAR* FAR* retval) PURE;
    STDMETHOD(get_Application)(THIS_ DIGWSession FAR* FAR* retval) PURE;
    STDMETHOD(get_CommandLine)(THIS_ BSTR FAR* cmdLine) PURE;
    STDMETHOD(get_FullName)(THIS_ BSTR FAR* fullName) PURE;
    STDMETHOD(get_MajorVersion)(THIS_ long FAR* retval) PURE;
    STDMETHOD(get_MinorVersion)(THIS_ long FAR* retval) PURE;
    STDMETHOD(get_Name)(THIS_ BSTR FAR* name) PURE;
    STDMETHOD(get_Parent)(THIS_ DIGWSession FAR* FAR* retval) PURE;
    STDMETHOD(get_RemoteAccount)(THIS_ DIGWAccount FAR* FAR* retval) PURE;
    STDMETHOD(get_RootAccount)(THIS_ DIGWAccount FAR* FAR* retval) PURE;
    STDMETHOD(Login)(THIS_ VARIANT vUserID, VARIANT vCommandLine, VARIANT vPassword, VARIANT vWhenToPrompt, VARIANT vReserved, DIGWAccount FAR* FAR* ppAcct) PURE;
    STDMETHOD(Proxy)(THIS_ VARIANT vUser, DIGWAccount FAR* FAR* retval) PURE;
    STDMETHOD(Quit)(THIS) PURE;
    STDMETHOD(DebugConfigure)(THIS) PURE;
    STDMETHOD(get_ProxyHistory)(THIS_ DIGWAddresses FAR* FAR* retval) PURE;
};

DEFINE_GUID(DIID_DIGWSession,0x5CBCBA01L,0xBB12,0x11CE,0xB6,0xF9,0x00,0x60,0x8C,0x84,0xE1,0xC4);

/* Definition of dispatch interface: DIGWSession */
#undef INTERFACE
#define INTERFACE DIGWSession

DECLARE_INTERFACE_(DIGWSession, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;
#endif

/* Capable of dispatching all the methods of interface IGWSession */
};

DEFINE_GUID(IID_IGWSession2,0xFBFB4A00L,0x57F8,0x11D0,0x9D,0xEB,0x00,0x80,0x5F,0x0E,0x69,0x4C);

/* Definition of interface: IGWSession2 */
#undef INTERFACE
#define INTERFACE IGWSession2

DECLARE_INTERFACE_(IGWSession2, IGWSession)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IGWSession methods */
    STDMETHOD(get_ProxyAccounts)(THIS_ DIGWAccounts FAR* FAR* retval) PURE;
    STDMETHOD(get_Application)(THIS_ DIGWSession FAR* FAR* retval) PURE;
    STDMETHOD(get_CommandLine)(THIS_ BSTR FAR* cmdLine) PURE;
    STDMETHOD(get_FullName)(THIS_ BSTR FAR* fullName) PURE;
    STDMETHOD(get_MajorVersion)(THIS_ long FAR* retval) PURE;
    STDMETHOD(get_MinorVersion)(THIS_ long FAR* retval) PURE;
    STDMETHOD(get_Name)(THIS_ BSTR FAR* name) PURE;
    STDMETHOD(get_Parent)(THIS_ DIGWSession FAR* FAR* retval) PURE;
    STDMETHOD(get_RemoteAccount)(THIS_ DIGWAccount FAR* FAR* retval) PURE;
    STDMETHOD(get_RootAccount)(THIS_ DIGWAccount FAR* FAR* retval) PURE;
    STDMETHOD(Login)(THIS_ VARIANT vUserID, VARIANT vCommandLine, VARIANT vPassword, VARIANT vWhenToPrompt, VARIANT vReserved, DIGWAccount FAR* FAR* ppAcct) PURE;
    STDMETHOD(Proxy)(THIS_ VARIANT vUser, DIGWAccount FAR* FAR* retval) PURE;
    STDMETHOD(Quit)(THIS) PURE;
    STDMETHOD(DebugConfigure)(THIS) PURE;
    STDMETHOD(get_ProxyHistory)(THIS_ DIGWAddresses FAR* FAR* retval) PURE;
#endif

    /* IGWSession2 methods */
    STDMETHOD(MultiLogin)(THIS_ BSTR vUserID, VARIANT vCommandLine, VARIANT vPassword, VARIANT vWhenToPrompt, VARIANT vReserved, DIGWAccount FAR* FAR* ppAcct) PURE;
    STDMETHOD(get_MainAccounts)(THIS_ DIGWAccounts FAR* FAR* retval) PURE;
};

DEFINE_GUID(DIID_DIGWSession2,0xD3779C40L,0x58E9,0x11D0,0x9D,0xEB,0x00,0x80,0x5F,0x0E,0x69,0x4C);

/* Definition of dispatch interface: DIGWSession2 */
#undef INTERFACE
#define INTERFACE DIGWSession2

DECLARE_INTERFACE_(DIGWSession2, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;
#endif

/* Capable of dispatching all the methods of interface IGWSession2 */
};

DEFINE_GUID(CLSID_Application,0x761C9540L,0xBAFD,0x11CE,0xB6,0xF9,0x00,0x60,0x8C,0x84,0xE1,0xC4);

#ifdef __cplusplus
class Application;
#endif

DEFINE_GUID(CLSID_Application2,0x761C954AL,0xBAFD,0x11CE,0xB6,0xF9,0x00,0x60,0x8C,0x84,0xE1,0xC4);

#ifdef __cplusplus
class Application2;
#endif

DEFINE_GUID(CLSID_GWSession,0xC9072F00L,0xD9FC,0x11CE,0xB6,0xF9,0x00,0x60,0x8C,0x84,0xE1,0xC4);

#ifdef __cplusplus
class GWSession;
#endif

DEFINE_GUID(CLSID_GWSession2,0xC9072F09L,0xD9FC,0x11CE,0xB6,0xF9,0x00,0x60,0x8C,0x84,0xE1,0xC4);

#ifdef __cplusplus
class GWSession2;
#endif

DEFINE_GUID(IID_IGWAppointment,0x7D2267E4L,0xE158,0x11CE,0x87,0xEB,0x00,0x80,0x5F,0xB4,0xB2,0xBE);

/* Definition of interface: IGWAppointment */
#undef INTERFACE
#define INTERFACE IGWAppointment

DECLARE_INTERFACE_(IGWAppointment, IGWMessage)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IGWMessage methods */
    STDMETHOD(get_Application)(THIS_ DIGWSession FAR* FAR* retval) PURE;
    STDMETHOD(get_Attachments)(THIS_ DIGWAttachments FAR* FAR* retval) PURE;
    STDMETHOD(get_BodyText)(THIS_ DIGWFormattedText FAR* FAR* retval) PURE;
    STDMETHOD(get_BoxType)(THIS_ MessageBoxTypeConstants FAR* retval) PURE;
    STDMETHOD(get_ClassName)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(put_ClassName)(THIS_ BSTR pClass) PURE;
    STDMETHOD(get_ConvertAttachments)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_ConvertAttachments)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_CreationDate)(THIS_ DATE FAR* retval) PURE;
    STDMETHOD(get_Deleted)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(get_DownloadStatus)(THIS_ DIGWDownloadStatus FAR* FAR* retval) PURE;
    STDMETHOD(get_EnclosingFolders)(THIS_ DIGWFolders FAR* FAR* retval) PURE;
    STDMETHOD(get_ExpandedRecipients)(THIS_ DIGWRecipients FAR* FAR* retval) PURE;
    STDMETHOD(get_Fields)(THIS_ DIGWFields FAR* FAR* retval) PURE;
    STDMETHOD(get_FromText)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(put_FromText)(THIS_ BSTR Text) PURE;
    STDMETHOD(get_Hidden)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Hidden)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_MessageID)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(get_NotifyWhenDeleted)(THIS_ NotifyMessageConstants FAR* retval) PURE;
    STDMETHOD(put_NotifyWhenDeleted)(THIS_ NotifyMessageConstants How) PURE;
    STDMETHOD(get_NotifyWhenOpened)(THIS_ NotifyMessageConstants FAR* retval) PURE;
    STDMETHOD(put_NotifyWhenOpened)(THIS_ NotifyMessageConstants How) PURE;
    STDMETHOD(get_Opened)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Opened)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_Parent)(THIS_ DIGWAccount FAR* FAR* retval) PURE;
    STDMETHOD(get_Priority)(THIS_ MessagePriorityConstants FAR* retval) PURE;
    STDMETHOD(put_Priority)(THIS_ MessagePriorityConstants Priority) PURE;
    STDMETHOD(get_Read)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Read)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_Recipients)(THIS_ DIGWRecipients FAR* FAR* retval) PURE;
    STDMETHOD(get_ReplyChildren)(THIS_ DIGWMessageList FAR* FAR* retval) PURE;
    STDMETHOD(get_ReplyDaysRequested)(THIS_ int FAR* retval) PURE;
    STDMETHOD(put_ReplyDaysRequested)(THIS_ int Days) PURE;
    STDMETHOD(get_ReplyParent)(THIS_ DIGWMessage FAR* FAR* retval) PURE;
    STDMETHOD(get_ReplyRequested)(THIS_ ReplyRequestedConstants FAR* retval) PURE;
    STDMETHOD(put_ReplyRequested)(THIS_ ReplyRequestedConstants When) PURE;
    STDMETHOD(get_ReplyRoot)(THIS_ DIGWMessage FAR* FAR* retval) PURE;
    STDMETHOD(get_Routed)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Routed)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_RoutingEndOfLine)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(get_Sender)(THIS_ DIGWAddress FAR* FAR* retval) PURE;
    STDMETHOD(get_Subject)(THIS_ DIGWFormattedText FAR* FAR* retval) PURE;
    STDMETHOD(get_ViewName)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(put_ViewName)(THIS_ BSTR pClass) PURE;
    STDMETHOD(Annotate)(THIS_ DIGWNote2 FAR* Note) PURE;
    STDMETHOD(Clone)(THIS_ DIGWMessage FAR* FAR* retval) PURE;
    STDMETHOD(Delete)(THIS) PURE;
    STDMETHOD(Forward)(THIS_ DIGWMail FAR* FAR* retval) PURE;
    STDMETHOD(Refresh)(THIS) PURE;
    STDMETHOD(Reply)(THIS_ VARIANT ClassName, VARIANT ReplyToAll, VARIANT IncludeSenderMessageText, VARIANT AttachOriginalMessage, DIGWMessage FAR* FAR* retval) PURE;
    STDMETHOD(Retract)(THIS) PURE;
    STDMETHOD(Send)(THIS_ DIGWMessage FAR* FAR* retval) PURE;
#endif

    /* IGWAppointment methods */
    STDMETHOD(get_Accepted)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(get_Autodate)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(get_AutodateMessages)(THIS_ DIGWMessageList FAR* FAR* retval) PURE;
    STDMETHOD(get_BusySearchResult)(THIS_ DIGWBusySearchResult FAR* FAR* retval) PURE;
    STDMETHOD(get_Delegated)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(get_Duration)(THIS_ double FAR* retval) PURE;
    STDMETHOD(put_Duration)(THIS_ double Days) PURE;
    STDMETHOD(get_EndDate)(THIS_ DATE FAR* retval) PURE;
    STDMETHOD(put_EndDate)(THIS_ DATE Date) PURE;
    STDMETHOD(get_OnCalendar)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_OnCalendar)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_Personal)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(get_Place)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(put_Place)(THIS_ BSTR Text) PURE;
    STDMETHOD(get_StartDate)(THIS_ DATE FAR* retval) PURE;
    STDMETHOD(put_StartDate)(THIS_ DATE Date) PURE;
    STDMETHOD(Accept)(THIS_ VARIANT Comment, VARIANT AllInstances) PURE;
    STDMETHOD(Decline)(THIS_ VARIANT Comment, VARIANT AllInstances) PURE;
    STDMETHOD(Delegate)(THIS_ VARIANT AllInstances, DIGWAppointment2 FAR* FAR* retval) PURE;
    STDMETHOD(GetDateAdjustment)(THIS_ BSTR FAR* Timezone, double FAR* retval) PURE;
    STDMETHOD(StartBusySearch)(THIS_ VARIANT StartDate, VARIANT Range, DIGWBusySearchResult FAR* FAR* retval) PURE;
};

DEFINE_GUID(DIID_DIGWAppointment,0x7D2267E5L,0xE158,0x11CE,0x87,0xEB,0x00,0x80,0x5F,0xB4,0xB2,0xBE);

/* Definition of dispatch interface: DIGWAppointment */
#undef INTERFACE
#define INTERFACE DIGWAppointment

DECLARE_INTERFACE_(DIGWAppointment, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;
#endif

/* Capable of dispatching all the methods of interface IGWAppointment */
};

DEFINE_GUID(IID_IGWAppointment_m2,0x7D2269E4L,0xE158,0x11CE,0x87,0xEB,0x00,0x80,0x5F,0xB4,0xB2,0xBE);

/* Definition of interface: IGWAppointment_m2 */
#undef INTERFACE
#define INTERFACE IGWAppointment_m2

DECLARE_INTERFACE_(IGWAppointment_m2, IGWMessage2)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IGWMessage methods */
    STDMETHOD(get_Application)(THIS_ DIGWSession FAR* FAR* retval) PURE;
    STDMETHOD(get_Attachments)(THIS_ DIGWAttachments FAR* FAR* retval) PURE;
    STDMETHOD(get_BodyText)(THIS_ DIGWFormattedText FAR* FAR* retval) PURE;
    STDMETHOD(get_BoxType)(THIS_ MessageBoxTypeConstants FAR* retval) PURE;
    STDMETHOD(get_ClassName)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(put_ClassName)(THIS_ BSTR pClass) PURE;
    STDMETHOD(get_ConvertAttachments)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_ConvertAttachments)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_CreationDate)(THIS_ DATE FAR* retval) PURE;
    STDMETHOD(get_Deleted)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(get_DownloadStatus)(THIS_ DIGWDownloadStatus FAR* FAR* retval) PURE;
    STDMETHOD(get_EnclosingFolders)(THIS_ DIGWFolders FAR* FAR* retval) PURE;
    STDMETHOD(get_ExpandedRecipients)(THIS_ DIGWRecipients FAR* FAR* retval) PURE;
    STDMETHOD(get_Fields)(THIS_ DIGWFields FAR* FAR* retval) PURE;
    STDMETHOD(get_FromText)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(put_FromText)(THIS_ BSTR Text) PURE;
    STDMETHOD(get_Hidden)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Hidden)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_MessageID)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(get_NotifyWhenDeleted)(THIS_ NotifyMessageConstants FAR* retval) PURE;
    STDMETHOD(put_NotifyWhenDeleted)(THIS_ NotifyMessageConstants How) PURE;
    STDMETHOD(get_NotifyWhenOpened)(THIS_ NotifyMessageConstants FAR* retval) PURE;
    STDMETHOD(put_NotifyWhenOpened)(THIS_ NotifyMessageConstants How) PURE;
    STDMETHOD(get_Opened)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Opened)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_Parent)(THIS_ DIGWAccount FAR* FAR* retval) PURE;
    STDMETHOD(get_Priority)(THIS_ MessagePriorityConstants FAR* retval) PURE;
    STDMETHOD(put_Priority)(THIS_ MessagePriorityConstants Priority) PURE;
    STDMETHOD(get_Read)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Read)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_Recipients)(THIS_ DIGWRecipients FAR* FAR* retval) PURE;
    STDMETHOD(get_ReplyChildren)(THIS_ DIGWMessageList FAR* FAR* retval) PURE;
    STDMETHOD(get_ReplyDaysRequested)(THIS_ int FAR* retval) PURE;
    STDMETHOD(put_ReplyDaysRequested)(THIS_ int Days) PURE;
    STDMETHOD(get_ReplyParent)(THIS_ DIGWMessage FAR* FAR* retval) PURE;
    STDMETHOD(get_ReplyRequested)(THIS_ ReplyRequestedConstants FAR* retval) PURE;
    STDMETHOD(put_ReplyRequested)(THIS_ ReplyRequestedConstants When) PURE;
    STDMETHOD(get_ReplyRoot)(THIS_ DIGWMessage FAR* FAR* retval) PURE;
    STDMETHOD(get_Routed)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Routed)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_RoutingEndOfLine)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(get_Sender)(THIS_ DIGWAddress FAR* FAR* retval) PURE;
    STDMETHOD(get_Subject)(THIS_ DIGWFormattedText FAR* FAR* retval) PURE;
    STDMETHOD(get_ViewName)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(put_ViewName)(THIS_ BSTR pClass) PURE;
    STDMETHOD(Annotate)(THIS_ DIGWNote2 FAR* Note) PURE;
    STDMETHOD(Clone)(THIS_ DIGWMessage FAR* FAR* retval) PURE;
    STDMETHOD(Delete)(THIS) PURE;
    STDMETHOD(Forward)(THIS_ DIGWMail FAR* FAR* retval) PURE;
    STDMETHOD(Refresh)(THIS) PURE;
    STDMETHOD(Reply)(THIS_ VARIANT ClassName, VARIANT ReplyToAll, VARIANT IncludeSenderMessageText, VARIANT AttachOriginalMessage, DIGWMessage FAR* FAR* retval) PURE;
    STDMETHOD(Retract)(THIS) PURE;
    STDMETHOD(Send)(THIS_ DIGWMessage FAR* FAR* retval) PURE;

    /* IGWMessage2 methods */
    STDMETHOD(get_ModifiedDate)(THIS_ DATE FAR* retval) PURE;
    STDMETHOD(get_Private)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Private)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_RevisionNumber)(THIS_ long FAR* retval) PURE;
    STDMETHOD(get_MasterRevisionNumber)(THIS_ long FAR* retval) PURE;
#endif

    /* IGWAppointment_m2 methods */
    STDMETHOD(get_Accepted)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(get_Autodate)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(get_AutodateMessages)(THIS_ DIGWMessageList FAR* FAR* retval) PURE;
    STDMETHOD(get_BusySearchResult)(THIS_ DIGWBusySearchResult FAR* FAR* retval) PURE;
    STDMETHOD(get_Delegated)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(get_Duration)(THIS_ double FAR* retval) PURE;
    STDMETHOD(put_Duration)(THIS_ double Days) PURE;
    STDMETHOD(get_EndDate)(THIS_ DATE FAR* retval) PURE;
    STDMETHOD(put_EndDate)(THIS_ DATE Date) PURE;
    STDMETHOD(get_OnCalendar)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_OnCalendar)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_Personal)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(get_Place)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(put_Place)(THIS_ BSTR Text) PURE;
    STDMETHOD(get_StartDate)(THIS_ DATE FAR* retval) PURE;
    STDMETHOD(put_StartDate)(THIS_ DATE Date) PURE;
    STDMETHOD(Accept)(THIS_ VARIANT Comment, VARIANT AllInstances) PURE;
    STDMETHOD(Decline)(THIS_ VARIANT Comment, VARIANT AllInstances) PURE;
    STDMETHOD(Delegate)(THIS_ VARIANT AllInstances, DIGWAppointment2 FAR* FAR* retval) PURE;
    STDMETHOD(GetDateAdjustment)(THIS_ BSTR FAR* Timezone, double FAR* retval) PURE;
    STDMETHOD(StartBusySearch)(THIS_ VARIANT StartDate, VARIANT Range, DIGWBusySearchResult FAR* FAR* retval) PURE;
};

DEFINE_GUID(IID_IGWAppointment2,0x7E000000L,0xE158,0x11CE,0x87,0xEB,0x00,0x80,0x5F,0xB4,0xB2,0xBE);

/* Definition of interface: IGWAppointment2 */
#undef INTERFACE
#define INTERFACE IGWAppointment2

DECLARE_INTERFACE_(IGWAppointment2, IGWAppointment_m2)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IGWMessage methods */
    STDMETHOD(get_Application)(THIS_ DIGWSession FAR* FAR* retval) PURE;
    STDMETHOD(get_Attachments)(THIS_ DIGWAttachments FAR* FAR* retval) PURE;
    STDMETHOD(get_BodyText)(THIS_ DIGWFormattedText FAR* FAR* retval) PURE;
    STDMETHOD(get_BoxType)(THIS_ MessageBoxTypeConstants FAR* retval) PURE;
    STDMETHOD(get_ClassName)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(put_ClassName)(THIS_ BSTR pClass) PURE;
    STDMETHOD(get_ConvertAttachments)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_ConvertAttachments)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_CreationDate)(THIS_ DATE FAR* retval) PURE;
    STDMETHOD(get_Deleted)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(get_DownloadStatus)(THIS_ DIGWDownloadStatus FAR* FAR* retval) PURE;
    STDMETHOD(get_EnclosingFolders)(THIS_ DIGWFolders FAR* FAR* retval) PURE;
    STDMETHOD(get_ExpandedRecipients)(THIS_ DIGWRecipients FAR* FAR* retval) PURE;
    STDMETHOD(get_Fields)(THIS_ DIGWFields FAR* FAR* retval) PURE;
    STDMETHOD(get_FromText)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(put_FromText)(THIS_ BSTR Text) PURE;
    STDMETHOD(get_Hidden)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Hidden)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_MessageID)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(get_NotifyWhenDeleted)(THIS_ NotifyMessageConstants FAR* retval) PURE;
    STDMETHOD(put_NotifyWhenDeleted)(THIS_ NotifyMessageConstants How) PURE;
    STDMETHOD(get_NotifyWhenOpened)(THIS_ NotifyMessageConstants FAR* retval) PURE;
    STDMETHOD(put_NotifyWhenOpened)(THIS_ NotifyMessageConstants How) PURE;
    STDMETHOD(get_Opened)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Opened)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_Parent)(THIS_ DIGWAccount FAR* FAR* retval) PURE;
    STDMETHOD(get_Priority)(THIS_ MessagePriorityConstants FAR* retval) PURE;
    STDMETHOD(put_Priority)(THIS_ MessagePriorityConstants Priority) PURE;
    STDMETHOD(get_Read)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Read)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_Recipients)(THIS_ DIGWRecipients FAR* FAR* retval) PURE;
    STDMETHOD(get_ReplyChildren)(THIS_ DIGWMessageList FAR* FAR* retval) PURE;
    STDMETHOD(get_ReplyDaysRequested)(THIS_ int FAR* retval) PURE;
    STDMETHOD(put_ReplyDaysRequested)(THIS_ int Days) PURE;
    STDMETHOD(get_ReplyParent)(THIS_ DIGWMessage FAR* FAR* retval) PURE;
    STDMETHOD(get_ReplyRequested)(THIS_ ReplyRequestedConstants FAR* retval) PURE;
    STDMETHOD(put_ReplyRequested)(THIS_ ReplyRequestedConstants When) PURE;
    STDMETHOD(get_ReplyRoot)(THIS_ DIGWMessage FAR* FAR* retval) PURE;
    STDMETHOD(get_Routed)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Routed)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_RoutingEndOfLine)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(get_Sender)(THIS_ DIGWAddress FAR* FAR* retval) PURE;
    STDMETHOD(get_Subject)(THIS_ DIGWFormattedText FAR* FAR* retval) PURE;
    STDMETHOD(get_ViewName)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(put_ViewName)(THIS_ BSTR pClass) PURE;
    STDMETHOD(Annotate)(THIS_ DIGWNote2 FAR* Note) PURE;
    STDMETHOD(Clone)(THIS_ DIGWMessage FAR* FAR* retval) PURE;
    STDMETHOD(Delete)(THIS) PURE;
    STDMETHOD(Forward)(THIS_ DIGWMail FAR* FAR* retval) PURE;
    STDMETHOD(Refresh)(THIS) PURE;
    STDMETHOD(Reply)(THIS_ VARIANT ClassName, VARIANT ReplyToAll, VARIANT IncludeSenderMessageText, VARIANT AttachOriginalMessage, DIGWMessage FAR* FAR* retval) PURE;
    STDMETHOD(Retract)(THIS) PURE;
    STDMETHOD(Send)(THIS_ DIGWMessage FAR* FAR* retval) PURE;

    /* IGWMessage2 methods */
    STDMETHOD(get_ModifiedDate)(THIS_ DATE FAR* retval) PURE;
    STDMETHOD(get_Private)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Private)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_RevisionNumber)(THIS_ long FAR* retval) PURE;
    STDMETHOD(get_MasterRevisionNumber)(THIS_ long FAR* retval) PURE;

    /* IGWAppointment_m2 methods */
    STDMETHOD(get_Accepted)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(get_Autodate)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(get_AutodateMessages)(THIS_ DIGWMessageList FAR* FAR* retval) PURE;
    STDMETHOD(get_BusySearchResult)(THIS_ DIGWBusySearchResult FAR* FAR* retval) PURE;
    STDMETHOD(get_Delegated)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(get_Duration)(THIS_ double FAR* retval) PURE;
    STDMETHOD(put_Duration)(THIS_ double Days) PURE;
    STDMETHOD(get_EndDate)(THIS_ DATE FAR* retval) PURE;
    STDMETHOD(put_EndDate)(THIS_ DATE Date) PURE;
    STDMETHOD(get_OnCalendar)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_OnCalendar)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_Personal)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(get_Place)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(put_Place)(THIS_ BSTR Text) PURE;
    STDMETHOD(get_StartDate)(THIS_ DATE FAR* retval) PURE;
    STDMETHOD(put_StartDate)(THIS_ DATE Date) PURE;
    STDMETHOD(Accept)(THIS_ VARIANT Comment, VARIANT AllInstances) PURE;
    STDMETHOD(Decline)(THIS_ VARIANT Comment, VARIANT AllInstances) PURE;
    STDMETHOD(Delegate)(THIS_ VARIANT AllInstances, DIGWAppointment2 FAR* FAR* retval) PURE;
    STDMETHOD(GetDateAdjustment)(THIS_ BSTR FAR* Timezone, double FAR* retval) PURE;
    STDMETHOD(StartBusySearch)(THIS_ VARIANT StartDate, VARIANT Range, DIGWBusySearchResult FAR* FAR* retval) PURE;
#endif

    /* IGWAppointment2 methods */
    STDMETHOD(get_NotifyWhenAccepted)(THIS_ NotifyMessageConstants FAR* retval) PURE;
    STDMETHOD(put_NotifyWhenAccepted)(THIS_ NotifyMessageConstants How) PURE;
    STDMETHOD(get_NotifyWhenDeclined)(THIS_ NotifyMessageConstants FAR* retval) PURE;
    STDMETHOD(put_NotifyWhenDeclined)(THIS_ NotifyMessageConstants How) PURE;
};

DEFINE_GUID(IID_IGWAppointment3,0xCC4C4F0AL,0xF4C0,0x11D1,0x8D,0x8F,0x00,0x80,0x5F,0xC1,0x00,0xD4);

/* Definition of interface: IGWAppointment3 */
#undef INTERFACE
#define INTERFACE IGWAppointment3

DECLARE_INTERFACE_(IGWAppointment3, IGWAppointment2)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IGWMessage methods */
    STDMETHOD(get_Application)(THIS_ DIGWSession FAR* FAR* retval) PURE;
    STDMETHOD(get_Attachments)(THIS_ DIGWAttachments FAR* FAR* retval) PURE;
    STDMETHOD(get_BodyText)(THIS_ DIGWFormattedText FAR* FAR* retval) PURE;
    STDMETHOD(get_BoxType)(THIS_ MessageBoxTypeConstants FAR* retval) PURE;
    STDMETHOD(get_ClassName)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(put_ClassName)(THIS_ BSTR pClass) PURE;
    STDMETHOD(get_ConvertAttachments)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_ConvertAttachments)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_CreationDate)(THIS_ DATE FAR* retval) PURE;
    STDMETHOD(get_Deleted)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(get_DownloadStatus)(THIS_ DIGWDownloadStatus FAR* FAR* retval) PURE;
    STDMETHOD(get_EnclosingFolders)(THIS_ DIGWFolders FAR* FAR* retval) PURE;
    STDMETHOD(get_ExpandedRecipients)(THIS_ DIGWRecipients FAR* FAR* retval) PURE;
    STDMETHOD(get_Fields)(THIS_ DIGWFields FAR* FAR* retval) PURE;
    STDMETHOD(get_FromText)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(put_FromText)(THIS_ BSTR Text) PURE;
    STDMETHOD(get_Hidden)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Hidden)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_MessageID)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(get_NotifyWhenDeleted)(THIS_ NotifyMessageConstants FAR* retval) PURE;
    STDMETHOD(put_NotifyWhenDeleted)(THIS_ NotifyMessageConstants How) PURE;
    STDMETHOD(get_NotifyWhenOpened)(THIS_ NotifyMessageConstants FAR* retval) PURE;
    STDMETHOD(put_NotifyWhenOpened)(THIS_ NotifyMessageConstants How) PURE;
    STDMETHOD(get_Opened)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Opened)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_Parent)(THIS_ DIGWAccount FAR* FAR* retval) PURE;
    STDMETHOD(get_Priority)(THIS_ MessagePriorityConstants FAR* retval) PURE;
    STDMETHOD(put_Priority)(THIS_ MessagePriorityConstants Priority) PURE;
    STDMETHOD(get_Read)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Read)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_Recipients)(THIS_ DIGWRecipients FAR* FAR* retval) PURE;
    STDMETHOD(get_ReplyChildren)(THIS_ DIGWMessageList FAR* FAR* retval) PURE;
    STDMETHOD(get_ReplyDaysRequested)(THIS_ int FAR* retval) PURE;
    STDMETHOD(put_ReplyDaysRequested)(THIS_ int Days) PURE;
    STDMETHOD(get_ReplyParent)(THIS_ DIGWMessage FAR* FAR* retval) PURE;
    STDMETHOD(get_ReplyRequested)(THIS_ ReplyRequestedConstants FAR* retval) PURE;
    STDMETHOD(put_ReplyRequested)(THIS_ ReplyRequestedConstants When) PURE;
    STDMETHOD(get_ReplyRoot)(THIS_ DIGWMessage FAR* FAR* retval) PURE;
    STDMETHOD(get_Routed)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Routed)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_RoutingEndOfLine)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(get_Sender)(THIS_ DIGWAddress FAR* FAR* retval) PURE;
    STDMETHOD(get_Subject)(THIS_ DIGWFormattedText FAR* FAR* retval) PURE;
    STDMETHOD(get_ViewName)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(put_ViewName)(THIS_ BSTR pClass) PURE;
    STDMETHOD(Annotate)(THIS_ DIGWNote2 FAR* Note) PURE;
    STDMETHOD(Clone)(THIS_ DIGWMessage FAR* FAR* retval) PURE;
    STDMETHOD(Delete)(THIS) PURE;
    STDMETHOD(Forward)(THIS_ DIGWMail FAR* FAR* retval) PURE;
    STDMETHOD(Refresh)(THIS) PURE;
    STDMETHOD(Reply)(THIS_ VARIANT ClassName, VARIANT ReplyToAll, VARIANT IncludeSenderMessageText, VARIANT AttachOriginalMessage, DIGWMessage FAR* FAR* retval) PURE;
    STDMETHOD(Retract)(THIS) PURE;
    STDMETHOD(Send)(THIS_ DIGWMessage FAR* FAR* retval) PURE;

    /* IGWMessage2 methods */
    STDMETHOD(get_ModifiedDate)(THIS_ DATE FAR* retval) PURE;
    STDMETHOD(get_Private)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Private)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_RevisionNumber)(THIS_ long FAR* retval) PURE;
    STDMETHOD(get_MasterRevisionNumber)(THIS_ long FAR* retval) PURE;

    /* IGWAppointment_m2 methods */
    STDMETHOD(get_Accepted)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(get_Autodate)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(get_AutodateMessages)(THIS_ DIGWMessageList FAR* FAR* retval) PURE;
    STDMETHOD(get_BusySearchResult)(THIS_ DIGWBusySearchResult FAR* FAR* retval) PURE;
    STDMETHOD(get_Delegated)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(get_Duration)(THIS_ double FAR* retval) PURE;
    STDMETHOD(put_Duration)(THIS_ double Days) PURE;
    STDMETHOD(get_EndDate)(THIS_ DATE FAR* retval) PURE;
    STDMETHOD(put_EndDate)(THIS_ DATE Date) PURE;
    STDMETHOD(get_OnCalendar)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_OnCalendar)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_Personal)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(get_Place)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(put_Place)(THIS_ BSTR Text) PURE;
    STDMETHOD(get_StartDate)(THIS_ DATE FAR* retval) PURE;
    STDMETHOD(put_StartDate)(THIS_ DATE Date) PURE;
    STDMETHOD(Accept)(THIS_ VARIANT Comment, VARIANT AllInstances) PURE;
    STDMETHOD(Decline)(THIS_ VARIANT Comment, VARIANT AllInstances) PURE;
    STDMETHOD(Delegate)(THIS_ VARIANT AllInstances, DIGWAppointment2 FAR* FAR* retval) PURE;
    STDMETHOD(GetDateAdjustment)(THIS_ BSTR FAR* Timezone, double FAR* retval) PURE;
    STDMETHOD(StartBusySearch)(THIS_ VARIANT StartDate, VARIANT Range, DIGWBusySearchResult FAR* FAR* retval) PURE;

    /* IGWAppointment2 methods */
    STDMETHOD(get_NotifyWhenAccepted)(THIS_ NotifyMessageConstants FAR* retval) PURE;
    STDMETHOD(put_NotifyWhenAccepted)(THIS_ NotifyMessageConstants How) PURE;
    STDMETHOD(get_NotifyWhenDeclined)(THIS_ NotifyMessageConstants FAR* retval) PURE;
    STDMETHOD(put_NotifyWhenDeclined)(THIS_ NotifyMessageConstants How) PURE;
#endif

    /* IGWAppointment3 methods */
    STDMETHOD(get_AlarmTime)(THIS_ DATE FAR* retval) PURE;
    STDMETHOD(put_AlarmTime)(THIS_ DATE Date) PURE;
    STDMETHOD(get_AlarmProgram)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(put_AlarmProgram)(THIS_ BSTR Path) PURE;
    STDMETHOD(get_Archived)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Archived)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_BusyType)(THIS_ TimeBlockConstants FAR* peBusyType) PURE;
    STDMETHOD(put_BusyType)(THIS_ TimeBlockConstants eBusyType) PURE;
    STDMETHOD(get_Sharer)(THIS_ DIGWAddress FAR* FAR* retval) PURE;
    STDMETHOD(LocalDelete)(THIS) PURE;
};

DEFINE_GUID(DIID_DIGWAppointment2,0x7E000001L,0xE158,0x11CE,0x87,0xEB,0x00,0x80,0x5F,0xB4,0xB2,0xBE);

/* Definition of dispatch interface: DIGWAppointment2 */
#undef INTERFACE
#define INTERFACE DIGWAppointment2

DECLARE_INTERFACE_(DIGWAppointment2, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;
#endif

/* Capable of dispatching all the methods of interface IGWAppointment2 */
};

DEFINE_GUID(DIID_DIGWAppointment3,0x48BB6A44L,0xF4C1,0x11D1,0x8D,0x8F,0x00,0x80,0x5F,0xC1,0x00,0xD4);

/* Definition of dispatch interface: DIGWAppointment3 */
#undef INTERFACE
#define INTERFACE DIGWAppointment3

DECLARE_INTERFACE_(DIGWAppointment3, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;
#endif

/* Capable of dispatching all the methods of interface IGWAppointment3 */
};

DEFINE_GUID(CLSID_Appointment,0xC89C3029L,0x04AF,0x11CF,0xB0,0x49,0x00,0x80,0x5F,0x88,0xE6,0x02);

#ifdef __cplusplus
class Appointment;
#endif

DEFINE_GUID(CLSID_Appointment2,0xC89C302BL,0x04AF,0x11CF,0xB0,0x49,0x00,0x80,0x5F,0x88,0xE6,0x02);

#ifdef __cplusplus
class Appointment2;
#endif

DEFINE_GUID(CLSID_Appointment3,0x6399CA86L,0xF4C1,0x11D1,0x8D,0x8F,0x00,0x80,0x5F,0xC1,0x00,0xD4);

#ifdef __cplusplus
class Appointment3;
#endif

DEFINE_GUID(IID_IGWAttachment,0xFB4B4420L,0x1465,0x11CF,0xA5,0x16,0x00,0x20,0xAF,0x05,0x81,0x17);

/* Definition of interface: IGWAttachment */
#undef INTERFACE
#define INTERFACE IGWAttachment

DECLARE_INTERFACE_(IGWAttachment, IUnknown)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;
#endif

    /* IGWAttachment methods */
    STDMETHOD(Delete)(THIS) PURE;
    STDMETHOD(Save)(THIS_ BSTR fileName) PURE;
    STDMETHOD(get_Application)(THIS_ DIGWSession FAR* FAR* retval) PURE;
    STDMETHOD(get_ObjType)(THIS_ AttachmentTypeConstants FAR* retval) PURE;
    STDMETHOD(get_DisplayName)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(get_FileName)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(get_Message)(THIS_ DIGWMessage FAR* FAR* retval) PURE;
    STDMETHOD(get_Parent)(THIS_ DIGWAttachments FAR* FAR* retval) PURE;
};

DEFINE_GUID(DIID_DIGWAttachment,0xFB4B4421L,0x1465,0x11CF,0xA5,0x16,0x00,0x20,0xAF,0x05,0x81,0x17);

/* Definition of dispatch interface: DIGWAttachment */
#undef INTERFACE
#define INTERFACE DIGWAttachment

DECLARE_INTERFACE_(DIGWAttachment, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;
#endif

/* Capable of dispatching all the methods of interface IGWAttachment */
};

DEFINE_GUID(CLSID_Attachment,0xC89C2D30L,0x04AF,0x11CF,0xB0,0x49,0x00,0x80,0x5F,0x88,0xE6,0x02);

#ifdef __cplusplus
class Attachment;
#endif

DEFINE_GUID(IID_IGWAttachments,0xFB4B4423L,0x1465,0x11CF,0xA5,0x16,0x00,0x20,0xAF,0x05,0x81,0x17);

/* Definition of interface: IGWAttachments */
#undef INTERFACE
#define INTERFACE IGWAttachments

DECLARE_INTERFACE_(IGWAttachments, IUnknown)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;
#endif

    /* IGWAttachments methods */
    STDMETHOD(Item)(THIS_ VARIANT index, DIGWAttachment FAR* FAR* retval) PURE;
    STDMETHOD(Add)(THIS_ VARIANT vr, VARIANT kind, VARIANT DisplayName, DIGWAttachment FAR* FAR* retVal) PURE;
    STDMETHOD(get_Application)(THIS_ DIGWSession FAR* FAR* retval) PURE;
    STDMETHOD(get_Count)(THIS_ long FAR* retval) PURE;
    STDMETHOD(get__NewEnum)(THIS_ IUnknown * FAR* retval) PURE;
    STDMETHOD(get_Parent)(THIS_ DIGWMessage FAR* FAR* retval) PURE;
};

DEFINE_GUID(DIID_DIGWAttachments,0xFB4B4424L,0x1465,0x11CF,0xA5,0x16,0x00,0x20,0xAF,0x05,0x81,0x17);

/* Definition of dispatch interface: DIGWAttachments */
#undef INTERFACE
#define INTERFACE DIGWAttachments

DECLARE_INTERFACE_(DIGWAttachments, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;
#endif

/* Capable of dispatching all the methods of interface IGWAttachments */
};

DEFINE_GUID(CLSID_Attachments,0xC89C2D31L,0x04AF,0x11CF,0xB0,0x49,0x00,0x80,0x5F,0x88,0xE6,0x02);

#ifdef __cplusplus
class Attachments;
#endif

DEFINE_GUID(IID_IGWBusySearchElement,0x95DF5422L,0x0AEA,0x11CF,0x97,0xF6,0x00,0x60,0x8C,0xE8,0x2F,0x4D);

/* Definition of interface: IGWBusySearchElement */
#undef INTERFACE
#define INTERFACE IGWBusySearchElement

DECLARE_INTERFACE_(IGWBusySearchElement, IUnknown)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;
#endif

    /* IGWBusySearchElement methods */
    STDMETHOD(get_Address)(THIS_ DIGWAddress FAR* FAR* retval) PURE;
    STDMETHOD(get_TimeBlocks)(THIS_ DIGWTimeBlocks FAR* FAR* retval) PURE;
    STDMETHOD(get_FreeBlocks)(THIS_ DIGWTimeBlocks FAR* FAR* retval) PURE;
    STDMETHOD(get_Completed)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(get_TargetType)(THIS_ AddressTargetTypeConstants FAR* pTType) PURE;
    STDMETHOD(get_Application)(THIS_ DIGWSession FAR* FAR* retval) PURE;
    STDMETHOD(get_Parent)(THIS_ IDispatch * FAR* retval) PURE;
};

DEFINE_GUID(DIID_DIGWBusySearchElement,0x95DF5423L,0x0AEA,0x11CF,0x97,0xF6,0x00,0x60,0x8C,0xE8,0x2F,0x4D);

/* Definition of dispatch interface: DIGWBusySearchElement */
#undef INTERFACE
#define INTERFACE DIGWBusySearchElement

DECLARE_INTERFACE_(DIGWBusySearchElement, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;
#endif

/* Capable of dispatching all the methods of interface IGWBusySearchElement */
};

DEFINE_GUID(CLSID_BusySearchElement,0xC89C2D32L,0x04AF,0x11CF,0xB0,0x49,0x00,0x80,0x5F,0x88,0xE6,0x02);

#ifdef __cplusplus
class BusySearchElement;
#endif

DEFINE_GUID(IID_IGWBusySearchElements,0x95DF5424L,0x0AEA,0x11CF,0x97,0xF6,0x00,0x60,0x8C,0xE8,0x2F,0x4D);

/* Definition of interface: IGWBusySearchElements */
#undef INTERFACE
#define INTERFACE IGWBusySearchElements

DECLARE_INTERFACE_(IGWBusySearchElements, IUnknown)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;
#endif

    /* IGWBusySearchElements methods */
    STDMETHOD(Item)(THIS_ long Index, DIGWBusySearchElement FAR* FAR* retval) PURE;
    STDMETHOD(get_Count)(THIS_ long FAR* retval) PURE;
    STDMETHOD(get__NewEnum)(THIS_ IUnknown * FAR* retval) PURE;
    STDMETHOD(get_Application)(THIS_ DIGWSession FAR* FAR* retval) PURE;
    STDMETHOD(get_Parent)(THIS_ DIGWBusySearchResult FAR* FAR* retval) PURE;
};

DEFINE_GUID(DIID_DIGWBusySearchElements,0x95DF5425L,0x0AEA,0x11CF,0x97,0xF6,0x00,0x60,0x8C,0xE8,0x2F,0x4D);

/* Definition of dispatch interface: DIGWBusySearchElements */
#undef INTERFACE
#define INTERFACE DIGWBusySearchElements

DECLARE_INTERFACE_(DIGWBusySearchElements, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;
#endif

/* Capable of dispatching all the methods of interface IGWBusySearchElements */
};

DEFINE_GUID(CLSID_BusySearchElements,0xC89C2D33L,0x04AF,0x11CF,0xB0,0x49,0x00,0x80,0x5F,0x88,0xE6,0x02);

#ifdef __cplusplus
class BusySearchElements;
#endif

DEFINE_GUID(IID_IGWBusySearchResult,0x95DF5520L,0x0AEA,0x11CF,0x97,0xF6,0x00,0x60,0x8C,0xE8,0x2F,0x4D);

/* Definition of interface: IGWBusySearchResult */
#undef INTERFACE
#define INTERFACE IGWBusySearchResult

DECLARE_INTERFACE_(IGWBusySearchResult, IUnknown)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;
#endif

    /* IGWBusySearchResult methods */
    STDMETHOD(Refresh)(THIS) PURE;
    STDMETHOD(get_BusySearchElements)(THIS_ DIGWBusySearchElements FAR* FAR* retval) PURE;
    STDMETHOD(get_CombinedResult)(THIS_ DIGWBusySearchElement FAR* FAR* retval) PURE;
    STDMETHOD(get_StartDate)(THIS_ DATE FAR* retval) PURE;
    STDMETHOD(get_Range)(THIS_ long FAR* retval) PURE;
    STDMETHOD(get_Completed)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(get_Application)(THIS_ DIGWSession FAR* FAR* retval) PURE;
    STDMETHOD(get_Parent)(THIS_ DIGWAppointment2 FAR* FAR* retval) PURE;
};

DEFINE_GUID(DIID_DIGWBusySearchResult,0x95DF5521L,0x0AEA,0x11CF,0x97,0xF6,0x00,0x60,0x8C,0xE8,0x2F,0x4D);

/* Definition of dispatch interface: DIGWBusySearchResult */
#undef INTERFACE
#define INTERFACE DIGWBusySearchResult

DECLARE_INTERFACE_(DIGWBusySearchResult, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;
#endif

/* Capable of dispatching all the methods of interface IGWBusySearchResult */
};

DEFINE_GUID(CLSID_BusySearchResult,0xC89C2D34L,0x04AF,0x11CF,0xB0,0x49,0x00,0x80,0x5F,0x88,0xE6,0x02);

#ifdef __cplusplus
class BusySearchResult;
#endif

DEFINE_GUID(IID_IGWDateHelper,0x7D226600L,0xE158,0x11CE,0x87,0xEB,0x00,0x80,0x5F,0xB4,0xB2,0xBE);

/* Definition of interface: IGWDateHelper */
#undef INTERFACE
#define INTERFACE IGWDateHelper

DECLARE_INTERFACE(IGWDateHelper)
{
BEGIN_INTERFACE

    /* IGWDateHelper methods */
    STDMETHOD(SecsToDATE)(THIS_ long val, DATE FAR* retval) PURE;
    STDMETHOD(DATEToSecs)(THIS_ DATE val, long FAR* retval) PURE;
};

DEFINE_GUID(IID_IGWDocumentLibrary,0x2DE8D400L,0x5184,0x11CF,0x87,0x78,0x00,0x60,0x8C,0x68,0xC0,0xBF);

/* Definition of interface: IGWDocumentLibrary */
#undef INTERFACE
#define INTERFACE IGWDocumentLibrary

DECLARE_INTERFACE_(IGWDocumentLibrary, IUnknown)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;
#endif

    /* IGWDocumentLibrary methods */
    STDMETHOD(get_Application)(THIS_ DIGWSession FAR* FAR* retval) PURE;
    STDMETHOD(get_CurrentArchiveBytes)(THIS_ long FAR* pValue) PURE;
    STDMETHOD(get_CurrentArchiveLocation)(THIS_ BSTR FAR* pTemplate) PURE;
    STDMETHOD(get_Description)(THIS_ BSTR FAR* pValue) PURE;
    STDMETHOD(get_Documents)(THIS_ DIGWDocuments FAR* FAR* ppDocs) PURE;
    STDMETHOD(get_FieldDefinitions)(THIS_ DIGWFieldDefinitions FAR* FAR* ppFields) PURE;
    STDMETHOD(get_LibraryID)(THIS_ BSTR FAR* pID) PURE;
    STDMETHOD(get_MaxArchiveBytes)(THIS_ long FAR* pValue) PURE;
    STDMETHOD(get_Name)(THIS_ BSTR FAR* pName) PURE;
    STDMETHOD(get_NextDocumentNumber)(THIS_ long FAR* pValue) PURE;
    STDMETHOD(get_Parent)(THIS_ DIGWDocumentLibraries FAR* FAR* retval) PURE;
    STDMETHOD(get_StartingVersionNumber)(THIS_ long FAR* pValue) PURE;
    STDMETHOD(GetDocument)(THIS_ long DocNumber, DIGWDocument FAR* FAR* retval) PURE;
    STDMETHOD(IncrementArchiveLocation)(THIS) PURE;
    STDMETHOD(Refresh)(THIS) PURE;
};

DEFINE_GUID(DIID_DIGWDocumentLibrary,0x2DE8D401L,0x5184,0x11CF,0x87,0x78,0x00,0x60,0x8C,0x68,0xC0,0xBF);

/* Definition of dispatch interface: DIGWDocumentLibrary */
#undef INTERFACE
#define INTERFACE DIGWDocumentLibrary

DECLARE_INTERFACE_(DIGWDocumentLibrary, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;
#endif

/* Capable of dispatching all the methods of interface IGWDocumentLibrary */
};

DEFINE_GUID(IID_IGWDocumentLibrary2,0x8AD7CAA6L,0xBB25,0x11D0,0xB3,0x31,0x00,0x80,0x5F,0x36,0xA3,0x75);

/* Definition of interface: IGWDocumentLibrary2 */
#undef INTERFACE
#define INTERFACE IGWDocumentLibrary2

DECLARE_INTERFACE_(IGWDocumentLibrary2, IGWDocumentLibrary)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IGWDocumentLibrary methods */
    STDMETHOD(get_Application)(THIS_ DIGWSession FAR* FAR* retval) PURE;
    STDMETHOD(get_CurrentArchiveBytes)(THIS_ long FAR* pValue) PURE;
    STDMETHOD(get_CurrentArchiveLocation)(THIS_ BSTR FAR* pTemplate) PURE;
    STDMETHOD(get_Description)(THIS_ BSTR FAR* pValue) PURE;
    STDMETHOD(get_Documents)(THIS_ DIGWDocuments FAR* FAR* ppDocs) PURE;
    STDMETHOD(get_FieldDefinitions)(THIS_ DIGWFieldDefinitions FAR* FAR* ppFields) PURE;
    STDMETHOD(get_LibraryID)(THIS_ BSTR FAR* pID) PURE;
    STDMETHOD(get_MaxArchiveBytes)(THIS_ long FAR* pValue) PURE;
    STDMETHOD(get_Name)(THIS_ BSTR FAR* pName) PURE;
    STDMETHOD(get_NextDocumentNumber)(THIS_ long FAR* pValue) PURE;
    STDMETHOD(get_Parent)(THIS_ DIGWDocumentLibraries FAR* FAR* retval) PURE;
    STDMETHOD(get_StartingVersionNumber)(THIS_ long FAR* pValue) PURE;
    STDMETHOD(GetDocument)(THIS_ long DocNumber, DIGWDocument FAR* FAR* retval) PURE;
    STDMETHOD(IncrementArchiveLocation)(THIS) PURE;
    STDMETHOD(Refresh)(THIS) PURE;
#endif

    /* IGWDocumentLibrary2 methods */
    STDMETHOD(get_DocumentTypes)(THIS_ DIGWDocumentTypes FAR* FAR* ppDocTypes) PURE;
    STDMETHOD(GetDocumentVersionEvents)(THIS_ long DocNumber, DIGWDocumentVersionEvents FAR* FAR* retval) PURE;
};

DEFINE_GUID(DIID_DIGWDocumentLibrary2,0x8AD7CAA7L,0xBB25,0x11D0,0xB3,0x31,0x00,0x80,0x5F,0x36,0xA3,0x75);

/* Definition of dispatch interface: DIGWDocumentLibrary2 */
#undef INTERFACE
#define INTERFACE DIGWDocumentLibrary2

DECLARE_INTERFACE_(DIGWDocumentLibrary2, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;
#endif

/* Capable of dispatching all the methods of interface IGWDocumentLibrary2 */
};

DEFINE_GUID(CLSID_DocumentLibrary,0xC89C2D37L,0x04AF,0x11CF,0xB0,0x49,0x00,0x80,0x5F,0x88,0xE6,0x02);

#ifdef __cplusplus
class DocumentLibrary;
#endif

DEFINE_GUID(CLSID_DocumentLibrary2,0x8AD7CAADL,0xBB25,0x11D0,0xB3,0x31,0x00,0x80,0x5F,0x36,0xA3,0x75);

#ifdef __cplusplus
class DocumentLibrary2;
#endif

DEFINE_GUID(IID_IGWDocumentLibraries,0xDA3F9BE6L,0x4CBF,0x11CF,0x87,0x78,0x00,0x60,0x8C,0x68,0xC0,0xBF);

/* Definition of interface: IGWDocumentLibraries */
#undef INTERFACE
#define INTERFACE IGWDocumentLibraries

DECLARE_INTERFACE_(IGWDocumentLibraries, IUnknown)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;
#endif

    /* IGWDocumentLibraries methods */
    STDMETHOD(Item)(THIS_ VARIANT Identifier, DIGWDocumentLibrary FAR* FAR* retval) PURE;
    STDMETHOD(get_Application)(THIS_ DIGWSession FAR* FAR* retval) PURE;
    STDMETHOD(get_Count)(THIS_ long FAR* retval) PURE;
    STDMETHOD(get__NewEnum)(THIS_ IUnknown * FAR* retval) PURE;
    STDMETHOD(get_Parent)(THIS_ DIGWAccount FAR* FAR* retval) PURE;
};

DEFINE_GUID(DIID_DIGWDocumentLibraries,0xDA3F9BE7L,0x4CBF,0x11CF,0x87,0x78,0x00,0x60,0x8C,0x68,0xC0,0xBF);

/* Definition of dispatch interface: DIGWDocumentLibraries */
#undef INTERFACE
#define INTERFACE DIGWDocumentLibraries

DECLARE_INTERFACE_(DIGWDocumentLibraries, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;
#endif

/* Capable of dispatching all the methods of interface IGWDocumentLibraries */
};

DEFINE_GUID(CLSID_DocumentLibraries,0xC89C2D38L,0x04AF,0x11CF,0xB0,0x49,0x00,0x80,0x5F,0x88,0xE6,0x02);

#ifdef __cplusplus
class DocumentLibraries;
#endif

DEFINE_GUID(IID_IGWDocumentReference,0xDD599EE0L,0x9C2E,0x11CF,0x8C,0x91,0x00,0x80,0x5F,0x6C,0x4B,0xEF);

/* Definition of interface: IGWDocumentReference */
#undef INTERFACE
#define INTERFACE IGWDocumentReference

DECLARE_INTERFACE_(IGWDocumentReference, IGWMessage)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IGWMessage methods */
    STDMETHOD(get_Application)(THIS_ DIGWSession FAR* FAR* retval) PURE;
    STDMETHOD(get_Attachments)(THIS_ DIGWAttachments FAR* FAR* retval) PURE;
    STDMETHOD(get_BodyText)(THIS_ DIGWFormattedText FAR* FAR* retval) PURE;
    STDMETHOD(get_BoxType)(THIS_ MessageBoxTypeConstants FAR* retval) PURE;
    STDMETHOD(get_ClassName)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(put_ClassName)(THIS_ BSTR pClass) PURE;
    STDMETHOD(get_ConvertAttachments)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_ConvertAttachments)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_CreationDate)(THIS_ DATE FAR* retval) PURE;
    STDMETHOD(get_Deleted)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(get_DownloadStatus)(THIS_ DIGWDownloadStatus FAR* FAR* retval) PURE;
    STDMETHOD(get_EnclosingFolders)(THIS_ DIGWFolders FAR* FAR* retval) PURE;
    STDMETHOD(get_ExpandedRecipients)(THIS_ DIGWRecipients FAR* FAR* retval) PURE;
    STDMETHOD(get_Fields)(THIS_ DIGWFields FAR* FAR* retval) PURE;
    STDMETHOD(get_FromText)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(put_FromText)(THIS_ BSTR Text) PURE;
    STDMETHOD(get_Hidden)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Hidden)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_MessageID)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(get_NotifyWhenDeleted)(THIS_ NotifyMessageConstants FAR* retval) PURE;
    STDMETHOD(put_NotifyWhenDeleted)(THIS_ NotifyMessageConstants How) PURE;
    STDMETHOD(get_NotifyWhenOpened)(THIS_ NotifyMessageConstants FAR* retval) PURE;
    STDMETHOD(put_NotifyWhenOpened)(THIS_ NotifyMessageConstants How) PURE;
    STDMETHOD(get_Opened)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Opened)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_Parent)(THIS_ DIGWAccount FAR* FAR* retval) PURE;
    STDMETHOD(get_Priority)(THIS_ MessagePriorityConstants FAR* retval) PURE;
    STDMETHOD(put_Priority)(THIS_ MessagePriorityConstants Priority) PURE;
    STDMETHOD(get_Read)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Read)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_Recipients)(THIS_ DIGWRecipients FAR* FAR* retval) PURE;
    STDMETHOD(get_ReplyChildren)(THIS_ DIGWMessageList FAR* FAR* retval) PURE;
    STDMETHOD(get_ReplyDaysRequested)(THIS_ int FAR* retval) PURE;
    STDMETHOD(put_ReplyDaysRequested)(THIS_ int Days) PURE;
    STDMETHOD(get_ReplyParent)(THIS_ DIGWMessage FAR* FAR* retval) PURE;
    STDMETHOD(get_ReplyRequested)(THIS_ ReplyRequestedConstants FAR* retval) PURE;
    STDMETHOD(put_ReplyRequested)(THIS_ ReplyRequestedConstants When) PURE;
    STDMETHOD(get_ReplyRoot)(THIS_ DIGWMessage FAR* FAR* retval) PURE;
    STDMETHOD(get_Routed)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Routed)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_RoutingEndOfLine)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(get_Sender)(THIS_ DIGWAddress FAR* FAR* retval) PURE;
    STDMETHOD(get_Subject)(THIS_ DIGWFormattedText FAR* FAR* retval) PURE;
    STDMETHOD(get_ViewName)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(put_ViewName)(THIS_ BSTR pClass) PURE;
    STDMETHOD(Annotate)(THIS_ DIGWNote2 FAR* Note) PURE;
    STDMETHOD(Clone)(THIS_ DIGWMessage FAR* FAR* retval) PURE;
    STDMETHOD(Delete)(THIS) PURE;
    STDMETHOD(Forward)(THIS_ DIGWMail FAR* FAR* retval) PURE;
    STDMETHOD(Refresh)(THIS) PURE;
    STDMETHOD(Reply)(THIS_ VARIANT ClassName, VARIANT ReplyToAll, VARIANT IncludeSenderMessageText, VARIANT AttachOriginalMessage, DIGWMessage FAR* FAR* retval) PURE;
    STDMETHOD(Retract)(THIS) PURE;
    STDMETHOD(Send)(THIS_ DIGWMessage FAR* FAR* retval) PURE;
#endif

    /* IGWDocumentReference methods */
    STDMETHOD(get_Document)(THIS_ DIGWDocument FAR* FAR* retval) PURE;
    STDMETHOD(get_DocumentLibrary)(THIS_ DIGWDocumentLibrary FAR* FAR* retval) PURE;
    STDMETHOD(get_DocumentVersion)(THIS_ DIGWDocumentVersion FAR* FAR* retval) PURE;
    STDMETHOD(get_RefType)(THIS_ DocumentReferenceTypeConstants FAR* retval) PURE;
};

DEFINE_GUID(DIID_DIGWDocumentReference,0xDD599DE1L,0x9C2E,0x11CF,0x8C,0x91,0x00,0x80,0x5F,0x6C,0x4B,0xEF);

/* Definition of dispatch interface: DIGWDocumentReference */
#undef INTERFACE
#define INTERFACE DIGWDocumentReference

DECLARE_INTERFACE_(DIGWDocumentReference, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;
#endif

/* Capable of dispatching all the methods of interface IGWDocumentReference */
};

DEFINE_GUID(IID_IGWDocumentReference2,0xDD59AEE0L,0x9C2E,0x11CF,0x8C,0x91,0x00,0x80,0x5F,0x6C,0x4B,0xEF);

/* Definition of interface: IGWDocumentReference2 */
#undef INTERFACE
#define INTERFACE IGWDocumentReference2

DECLARE_INTERFACE_(IGWDocumentReference2, IGWMessage2)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IGWMessage methods */
    STDMETHOD(get_Application)(THIS_ DIGWSession FAR* FAR* retval) PURE;
    STDMETHOD(get_Attachments)(THIS_ DIGWAttachments FAR* FAR* retval) PURE;
    STDMETHOD(get_BodyText)(THIS_ DIGWFormattedText FAR* FAR* retval) PURE;
    STDMETHOD(get_BoxType)(THIS_ MessageBoxTypeConstants FAR* retval) PURE;
    STDMETHOD(get_ClassName)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(put_ClassName)(THIS_ BSTR pClass) PURE;
    STDMETHOD(get_ConvertAttachments)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_ConvertAttachments)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_CreationDate)(THIS_ DATE FAR* retval) PURE;
    STDMETHOD(get_Deleted)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(get_DownloadStatus)(THIS_ DIGWDownloadStatus FAR* FAR* retval) PURE;
    STDMETHOD(get_EnclosingFolders)(THIS_ DIGWFolders FAR* FAR* retval) PURE;
    STDMETHOD(get_ExpandedRecipients)(THIS_ DIGWRecipients FAR* FAR* retval) PURE;
    STDMETHOD(get_Fields)(THIS_ DIGWFields FAR* FAR* retval) PURE;
    STDMETHOD(get_FromText)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(put_FromText)(THIS_ BSTR Text) PURE;
    STDMETHOD(get_Hidden)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Hidden)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_MessageID)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(get_NotifyWhenDeleted)(THIS_ NotifyMessageConstants FAR* retval) PURE;
    STDMETHOD(put_NotifyWhenDeleted)(THIS_ NotifyMessageConstants How) PURE;
    STDMETHOD(get_NotifyWhenOpened)(THIS_ NotifyMessageConstants FAR* retval) PURE;
    STDMETHOD(put_NotifyWhenOpened)(THIS_ NotifyMessageConstants How) PURE;
    STDMETHOD(get_Opened)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Opened)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_Parent)(THIS_ DIGWAccount FAR* FAR* retval) PURE;
    STDMETHOD(get_Priority)(THIS_ MessagePriorityConstants FAR* retval) PURE;
    STDMETHOD(put_Priority)(THIS_ MessagePriorityConstants Priority) PURE;
    STDMETHOD(get_Read)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Read)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_Recipients)(THIS_ DIGWRecipients FAR* FAR* retval) PURE;
    STDMETHOD(get_ReplyChildren)(THIS_ DIGWMessageList FAR* FAR* retval) PURE;
    STDMETHOD(get_ReplyDaysRequested)(THIS_ int FAR* retval) PURE;
    STDMETHOD(put_ReplyDaysRequested)(THIS_ int Days) PURE;
    STDMETHOD(get_ReplyParent)(THIS_ DIGWMessage FAR* FAR* retval) PURE;
    STDMETHOD(get_ReplyRequested)(THIS_ ReplyRequestedConstants FAR* retval) PURE;
    STDMETHOD(put_ReplyRequested)(THIS_ ReplyRequestedConstants When) PURE;
    STDMETHOD(get_ReplyRoot)(THIS_ DIGWMessage FAR* FAR* retval) PURE;
    STDMETHOD(get_Routed)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Routed)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_RoutingEndOfLine)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(get_Sender)(THIS_ DIGWAddress FAR* FAR* retval) PURE;
    STDMETHOD(get_Subject)(THIS_ DIGWFormattedText FAR* FAR* retval) PURE;
    STDMETHOD(get_ViewName)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(put_ViewName)(THIS_ BSTR pClass) PURE;
    STDMETHOD(Annotate)(THIS_ DIGWNote2 FAR* Note) PURE;
    STDMETHOD(Clone)(THIS_ DIGWMessage FAR* FAR* retval) PURE;
    STDMETHOD(Delete)(THIS) PURE;
    STDMETHOD(Forward)(THIS_ DIGWMail FAR* FAR* retval) PURE;
    STDMETHOD(Refresh)(THIS) PURE;
    STDMETHOD(Reply)(THIS_ VARIANT ClassName, VARIANT ReplyToAll, VARIANT IncludeSenderMessageText, VARIANT AttachOriginalMessage, DIGWMessage FAR* FAR* retval) PURE;
    STDMETHOD(Retract)(THIS) PURE;
    STDMETHOD(Send)(THIS_ DIGWMessage FAR* FAR* retval) PURE;

    /* IGWMessage2 methods */
    STDMETHOD(get_ModifiedDate)(THIS_ DATE FAR* retval) PURE;
    STDMETHOD(get_Private)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Private)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_RevisionNumber)(THIS_ long FAR* retval) PURE;
    STDMETHOD(get_MasterRevisionNumber)(THIS_ long FAR* retval) PURE;
#endif

    /* IGWDocumentReference2 methods */
    STDMETHOD(get_Document)(THIS_ DIGWDocument FAR* FAR* retval) PURE;
    STDMETHOD(get_DocumentLibrary)(THIS_ DIGWDocumentLibrary FAR* FAR* retval) PURE;
    STDMETHOD(get_DocumentVersion)(THIS_ DIGWDocumentVersion FAR* FAR* retval) PURE;
    STDMETHOD(get_RefType)(THIS_ DocumentReferenceTypeConstants FAR* retval) PURE;
};

DEFINE_GUID(IID_IGWDocumentReference3,0x481ED62AL,0x4EFF,0x11D1,0x8D,0x79,0x00,0x80,0x5F,0xC1,0x28,0xBA);

/* Definition of interface: IGWDocumentReference3 */
#undef INTERFACE
#define INTERFACE IGWDocumentReference3

DECLARE_INTERFACE_(IGWDocumentReference3, IGWMessage2)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IGWMessage methods */
    STDMETHOD(get_Application)(THIS_ DIGWSession FAR* FAR* retval) PURE;
    STDMETHOD(get_Attachments)(THIS_ DIGWAttachments FAR* FAR* retval) PURE;
    STDMETHOD(get_BodyText)(THIS_ DIGWFormattedText FAR* FAR* retval) PURE;
    STDMETHOD(get_BoxType)(THIS_ MessageBoxTypeConstants FAR* retval) PURE;
    STDMETHOD(get_ClassName)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(put_ClassName)(THIS_ BSTR pClass) PURE;
    STDMETHOD(get_ConvertAttachments)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_ConvertAttachments)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_CreationDate)(THIS_ DATE FAR* retval) PURE;
    STDMETHOD(get_Deleted)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(get_DownloadStatus)(THIS_ DIGWDownloadStatus FAR* FAR* retval) PURE;
    STDMETHOD(get_EnclosingFolders)(THIS_ DIGWFolders FAR* FAR* retval) PURE;
    STDMETHOD(get_ExpandedRecipients)(THIS_ DIGWRecipients FAR* FAR* retval) PURE;
    STDMETHOD(get_Fields)(THIS_ DIGWFields FAR* FAR* retval) PURE;
    STDMETHOD(get_FromText)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(put_FromText)(THIS_ BSTR Text) PURE;
    STDMETHOD(get_Hidden)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Hidden)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_MessageID)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(get_NotifyWhenDeleted)(THIS_ NotifyMessageConstants FAR* retval) PURE;
    STDMETHOD(put_NotifyWhenDeleted)(THIS_ NotifyMessageConstants How) PURE;
    STDMETHOD(get_NotifyWhenOpened)(THIS_ NotifyMessageConstants FAR* retval) PURE;
    STDMETHOD(put_NotifyWhenOpened)(THIS_ NotifyMessageConstants How) PURE;
    STDMETHOD(get_Opened)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Opened)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_Parent)(THIS_ DIGWAccount FAR* FAR* retval) PURE;
    STDMETHOD(get_Priority)(THIS_ MessagePriorityConstants FAR* retval) PURE;
    STDMETHOD(put_Priority)(THIS_ MessagePriorityConstants Priority) PURE;
    STDMETHOD(get_Read)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Read)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_Recipients)(THIS_ DIGWRecipients FAR* FAR* retval) PURE;
    STDMETHOD(get_ReplyChildren)(THIS_ DIGWMessageList FAR* FAR* retval) PURE;
    STDMETHOD(get_ReplyDaysRequested)(THIS_ int FAR* retval) PURE;
    STDMETHOD(put_ReplyDaysRequested)(THIS_ int Days) PURE;
    STDMETHOD(get_ReplyParent)(THIS_ DIGWMessage FAR* FAR* retval) PURE;
    STDMETHOD(get_ReplyRequested)(THIS_ ReplyRequestedConstants FAR* retval) PURE;
    STDMETHOD(put_ReplyRequested)(THIS_ ReplyRequestedConstants When) PURE;
    STDMETHOD(get_ReplyRoot)(THIS_ DIGWMessage FAR* FAR* retval) PURE;
    STDMETHOD(get_Routed)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Routed)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_RoutingEndOfLine)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(get_Sender)(THIS_ DIGWAddress FAR* FAR* retval) PURE;
    STDMETHOD(get_Subject)(THIS_ DIGWFormattedText FAR* FAR* retval) PURE;
    STDMETHOD(get_ViewName)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(put_ViewName)(THIS_ BSTR pClass) PURE;
    STDMETHOD(Annotate)(THIS_ DIGWNote2 FAR* Note) PURE;
    STDMETHOD(Clone)(THIS_ DIGWMessage FAR* FAR* retval) PURE;
    STDMETHOD(Delete)(THIS) PURE;
    STDMETHOD(Forward)(THIS_ DIGWMail FAR* FAR* retval) PURE;
    STDMETHOD(Refresh)(THIS) PURE;
    STDMETHOD(Reply)(THIS_ VARIANT ClassName, VARIANT ReplyToAll, VARIANT IncludeSenderMessageText, VARIANT AttachOriginalMessage, DIGWMessage FAR* FAR* retval) PURE;
    STDMETHOD(Retract)(THIS) PURE;
    STDMETHOD(Send)(THIS_ DIGWMessage FAR* FAR* retval) PURE;

    /* IGWMessage2 methods */
    STDMETHOD(get_ModifiedDate)(THIS_ DATE FAR* retval) PURE;
    STDMETHOD(get_Private)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Private)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_RevisionNumber)(THIS_ long FAR* retval) PURE;
    STDMETHOD(get_MasterRevisionNumber)(THIS_ long FAR* retval) PURE;
#endif

    /* IGWDocumentReference3 methods */
    STDMETHOD(get_Document)(THIS_ DIGWDocument FAR* FAR* retval) PURE;
    STDMETHOD(get_DocumentLibrary)(THIS_ DIGWDocumentLibrary FAR* FAR* retval) PURE;
    STDMETHOD(get_DocumentVersion)(THIS_ DIGWDocumentVersion FAR* FAR* retval) PURE;
    STDMETHOD(get_RefType)(THIS_ DocumentReferenceTypeConstants FAR* retval) PURE;
    STDMETHOD(get_Archived)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Archived)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_Sharer)(THIS_ DIGWAddress FAR* FAR* retval) PURE;
    STDMETHOD(LocalDelete)(THIS) PURE;
};

DEFINE_GUID(DIID_DIGWDocumentReference2,0xDD59ADE1L,0x9C2E,0x11CF,0x8C,0x91,0x00,0x80,0x5F,0x6C,0x4B,0xEF);

/* Definition of dispatch interface: DIGWDocumentReference2 */
#undef INTERFACE
#define INTERFACE DIGWDocumentReference2

DECLARE_INTERFACE_(DIGWDocumentReference2, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;
#endif

/* Capable of dispatching all the methods of interface IGWDocumentReference2 */
};

DEFINE_GUID(DIID_DIGWDocumentReference3,0xDD59ADE4L,0x9C2E,0x11CF,0x8C,0x91,0x00,0x80,0x5F,0x6C,0x4B,0xEF);

/* Definition of dispatch interface: DIGWDocumentReference3 */
#undef INTERFACE
#define INTERFACE DIGWDocumentReference3

DECLARE_INTERFACE_(DIGWDocumentReference3, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;
#endif

/* Capable of dispatching all the methods of interface IGWDocumentReference3 */
};

DEFINE_GUID(CLSID_DocumentReference,0xDD599DE2L,0x9C2E,0x11CF,0x8C,0x91,0x00,0x80,0x5F,0x6C,0x4B,0xEF);

#ifdef __cplusplus
class DocumentReference;
#endif

DEFINE_GUID(CLSID_DocumentReference2,0xDD599DE9L,0x9C2E,0x11CF,0x8C,0x91,0x00,0x80,0x5F,0x6C,0x4B,0xEF);

#ifdef __cplusplus
class DocumentReference2;
#endif

DEFINE_GUID(CLSID_DocumentReference3,0x150EAD58L,0xF4C8,0x11D1,0x8D,0x8F,0x00,0x80,0x5F,0xC1,0x00,0xD4);

#ifdef __cplusplus
class DocumentReference3;
#endif

DEFINE_GUID(IID_IGWDocumentRights,0xB57A7540L,0xBD18,0x11CF,0x8C,0x91,0x00,0x80,0x5F,0x6C,0x4B,0xEF);

/* Definition of interface: IGWDocumentRights */
#undef INTERFACE
#define INTERFACE IGWDocumentRights

DECLARE_INTERFACE_(IGWDocumentRights, IUnknown)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;
#endif

    /* IGWDocumentRights methods */
    STDMETHOD(get_AllowDelete)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_AllowDelete)(THIS_ VARIANT_BOOL bDelete) PURE;
    STDMETHOD(get_AllowEdit)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_AllowEdit)(THIS_ VARIANT_BOOL bEdit) PURE;
    STDMETHOD(get_AllowView)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_AllowView)(THIS_ VARIANT_BOOL bView) PURE;
    STDMETHOD(get_Application)(THIS_ DIGWSession FAR* FAR* retval) PURE;
    STDMETHOD(get_BitMask)(THIS_ long FAR* retval) PURE;
    STDMETHOD(put_BitMask)(THIS_ long lBitMask) PURE;
    STDMETHOD(get_Parent)(THIS_ DIGWDocumentAccessRights FAR* FAR* retval) PURE;
};

DEFINE_GUID(DIID_DIGWDocumentRights,0xB57A7541L,0xBD18,0x11CF,0x8C,0x91,0x00,0x80,0x5F,0x6C,0x4B,0xEF);

/* Definition of dispatch interface: DIGWDocumentRights */
#undef INTERFACE
#define INTERFACE DIGWDocumentRights

DECLARE_INTERFACE_(DIGWDocumentRights, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;
#endif

/* Capable of dispatching all the methods of interface IGWDocumentRights */
};

DEFINE_GUID(IID_IGWDocumentRights2,0x0E15B580L,0x9F10,0x11D0,0xB3,0x18,0x00,0x80,0x5F,0x36,0xA3,0x75);

/* Definition of interface: IGWDocumentRights2 */
#undef INTERFACE
#define INTERFACE IGWDocumentRights2

DECLARE_INTERFACE_(IGWDocumentRights2, IGWDocumentRights)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IGWDocumentRights methods */
    STDMETHOD(get_AllowDelete)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_AllowDelete)(THIS_ VARIANT_BOOL bDelete) PURE;
    STDMETHOD(get_AllowEdit)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_AllowEdit)(THIS_ VARIANT_BOOL bEdit) PURE;
    STDMETHOD(get_AllowView)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_AllowView)(THIS_ VARIANT_BOOL bView) PURE;
    STDMETHOD(get_Application)(THIS_ DIGWSession FAR* FAR* retval) PURE;
    STDMETHOD(get_BitMask)(THIS_ long FAR* retval) PURE;
    STDMETHOD(put_BitMask)(THIS_ long lBitMask) PURE;
    STDMETHOD(get_Parent)(THIS_ DIGWDocumentAccessRights FAR* FAR* retval) PURE;
#endif

    /* IGWDocumentRights2 methods */
    STDMETHOD(get_AllowShare)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_AllowShare)(THIS_ VARIANT_BOOL bShare) PURE;
};

DEFINE_GUID(DIID_DIGWDocumentRights2,0x0E15B581L,0x9F10,0x11D0,0xB3,0x18,0x00,0x80,0x5F,0x36,0xA3,0x75);

/* Definition of dispatch interface: DIGWDocumentRights2 */
#undef INTERFACE
#define INTERFACE DIGWDocumentRights2

DECLARE_INTERFACE_(DIGWDocumentRights2, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;
#endif

/* Capable of dispatching all the methods of interface IGWDocumentRights2 */
};

DEFINE_GUID(CLSID_DocumentRights,0x0E15B582L,0x9F10,0x11D0,0xB3,0x18,0x00,0x80,0x5F,0x36,0xA3,0x75);

#ifdef __cplusplus
class DocumentRights;
#endif

DEFINE_GUID(CLSID_DocumentRights2,0x0E15B58AL,0x9F10,0x11D0,0xB3,0x18,0x00,0x80,0x5F,0x36,0xA3,0x75);

#ifdef __cplusplus
class DocumentRights2;
#endif

DEFINE_GUID(IID_IGWDocumentAccessRights,0xB57A7543L,0xBD18,0x11CF,0x8C,0x91,0x00,0x80,0x5F,0x6C,0x4B,0xEF);

/* Definition of interface: IGWDocumentAccessRights */
#undef INTERFACE
#define INTERFACE IGWDocumentAccessRights

DECLARE_INTERFACE_(IGWDocumentAccessRights, IUnknown)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;
#endif

    /* IGWDocumentAccessRights methods */
    STDMETHOD(Delete)(THIS) PURE;
    STDMETHOD(get_Application)(THIS_ DIGWSession FAR* FAR* retval) PURE;
    STDMETHOD(get_ModifySecurity)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_ModifySecurity)(THIS_ VARIANT_BOOL bDelete) PURE;
    STDMETHOD(get_Parent)(THIS_ DIGWDocumentAccessRightsCollection2 FAR* FAR* retval) PURE;
    STDMETHOD(get_RevokeAllRights)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_RevokeAllRights)(THIS_ VARIANT_BOOL bDelete) PURE;
    STDMETHOD(get_SecurityCurrentVersions)(THIS_ DIGWDocumentRights2 FAR* FAR* retval) PURE;
    STDMETHOD(get_SecurityOfficialVersion)(THIS_ DIGWDocumentRights2 FAR* FAR* retval) PURE;
    STDMETHOD(get_SecurityOtherVersions)(THIS_ DIGWDocumentRights2 FAR* FAR* retval) PURE;
    STDMETHOD(get_User)(THIS_ DIGWAddress FAR* FAR* retval) PURE;
};

DEFINE_GUID(DIID_DIGWDocumentAccessRights,0xB57A7544L,0xBD18,0x11CF,0x8C,0x91,0x00,0x80,0x5F,0x6C,0x4B,0xEF);

/* Definition of dispatch interface: DIGWDocumentAccessRights */
#undef INTERFACE
#define INTERFACE DIGWDocumentAccessRights

DECLARE_INTERFACE_(DIGWDocumentAccessRights, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;
#endif

/* Capable of dispatching all the methods of interface IGWDocumentAccessRights */
};

DEFINE_GUID(CLSID_DocumentAccessRights,0xB57A7545L,0xBD18,0x11CF,0x8C,0x91,0x00,0x80,0x5F,0x6C,0x4B,0xEF);

#ifdef __cplusplus
class DocumentAccessRights;
#endif

DEFINE_GUID(IID_IGWDocumentAccessRightsCollection,0xB57A7546L,0xBD18,0x11CF,0x8C,0x91,0x00,0x80,0x5F,0x6C,0x4B,0xEF);

/* Definition of interface: IGWDocumentAccessRightsCollection */
#undef INTERFACE
#define INTERFACE IGWDocumentAccessRightsCollection

DECLARE_INTERFACE_(IGWDocumentAccessRightsCollection, IUnknown)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;
#endif

    /* IGWDocumentAccessRightsCollection methods */
    STDMETHOD(Add)(THIS_ DIGWAddress FAR* Address, long lRightsBitMask) PURE;
    STDMETHOD(Item)(THIS_ long lIndex, DIGWDocumentAccessRights FAR* FAR* retval) PURE;
    STDMETHOD(get_Application)(THIS_ DIGWSession FAR* FAR* retval) PURE;
    STDMETHOD(get_Count)(THIS_ long FAR* retval) PURE;
    STDMETHOD(get__NewEnum)(THIS_ IUnknown * FAR* retval) PURE;
    STDMETHOD(get_Parent)(THIS_ DIGWDocument FAR* FAR* retval) PURE;
};

DEFINE_GUID(DIID_DIGWDocumentAccessRightsCollection,0xB57A7547L,0xBD18,0x11CF,0x8C,0x91,0x00,0x80,0x5F,0x6C,0x4B,0xEF);

/* Definition of dispatch interface: DIGWDocumentAccessRightsCollection */
#undef INTERFACE
#define INTERFACE DIGWDocumentAccessRightsCollection

DECLARE_INTERFACE_(DIGWDocumentAccessRightsCollection, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;
#endif

/* Capable of dispatching all the methods of interface IGWDocumentAccessRightsCollection */
};

DEFINE_GUID(IID_IGWDocumentAccessRightsCollection2,0x3A0CB480L,0x5373,0x11D0,0x8C,0x92,0x00,0x80,0x5F,0x6C,0x4B,0xEF);

/* Definition of interface: IGWDocumentAccessRightsCollection2 */
#undef INTERFACE
#define INTERFACE IGWDocumentAccessRightsCollection2

DECLARE_INTERFACE_(IGWDocumentAccessRightsCollection2, IGWDocumentAccessRightsCollection)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IGWDocumentAccessRightsCollection methods */
    STDMETHOD(Add)(THIS_ DIGWAddress FAR* Address, long lRightsBitMask) PURE;
    STDMETHOD(Item)(THIS_ long lIndex, DIGWDocumentAccessRights FAR* FAR* retval) PURE;
    STDMETHOD(get_Application)(THIS_ DIGWSession FAR* FAR* retval) PURE;
    STDMETHOD(get_Count)(THIS_ long FAR* retval) PURE;
    STDMETHOD(get__NewEnum)(THIS_ IUnknown * FAR* retval) PURE;
    STDMETHOD(get_Parent)(THIS_ DIGWDocument FAR* FAR* retval) PURE;
#endif

    /* IGWDocumentAccessRightsCollection2 methods */
    STDMETHOD(Add)(THIS_ VARIANT vAddress, long lRightsBitMask) PURE;
};

DEFINE_GUID(DIID_DIGWDocumentAccessRightsCollection2,0x3A0CB481L,0x5373,0x11D0,0x8C,0x92,0x00,0x80,0x5F,0x6C,0x4B,0xEF);

/* Definition of dispatch interface: DIGWDocumentAccessRightsCollection2 */
#undef INTERFACE
#define INTERFACE DIGWDocumentAccessRightsCollection2

DECLARE_INTERFACE_(DIGWDocumentAccessRightsCollection2, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;
#endif

/* Capable of dispatching all the methods of interface IGWDocumentAccessRightsCollection2 */
};

DEFINE_GUID(CLSID_DocumentAccessRightsCollection,0xB57A7548L,0xBD18,0x11CF,0x8C,0x91,0x00,0x80,0x5F,0x6C,0x4B,0xEF);

#ifdef __cplusplus
class DocumentAccessRightsCollection;
#endif

DEFINE_GUID(CLSID_DocumentAccessRightsCollection2,0xB57A754BL,0xBD18,0x11CF,0x8C,0x91,0x00,0x80,0x5F,0x6C,0x4B,0xEF);

#ifdef __cplusplus
class DocumentAccessRightsCollection2;
#endif

DEFINE_GUID(IID_IGWDocumentType,0x2DE8D402L,0x5184,0x11CF,0x87,0x78,0x00,0x60,0x8C,0x68,0xC0,0xBF);

/* Definition of interface: IGWDocumentType */
#undef INTERFACE
#define INTERFACE IGWDocumentType

DECLARE_INTERFACE_(IGWDocumentType, IUnknown)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;
#endif

    /* IGWDocumentType methods */
    STDMETHOD(get_Application)(THIS_ DIGWSession FAR* FAR* retval) PURE;
    STDMETHOD(get_DisposalMethod)(THIS_ DisposalMethodConstants FAR* retval) PURE;
    STDMETHOD(get_DocumentLife)(THIS_ long FAR* retval) PURE;
    STDMETHOD(get_MaxVersionCount)(THIS_ long FAR* retval) PURE;
    STDMETHOD(get_Name)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(get_Parent)(THIS_ DIGWDocumentLibrary FAR* FAR* retval) PURE;
};

DEFINE_GUID(DIID_DIGWDocumentType,0x2DE8D403L,0x5184,0x11CF,0x87,0x78,0x00,0x60,0x8C,0x68,0xC0,0xBF);

/* Definition of dispatch interface: DIGWDocumentType */
#undef INTERFACE
#define INTERFACE DIGWDocumentType

DECLARE_INTERFACE_(DIGWDocumentType, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;
#endif

/* Capable of dispatching all the methods of interface IGWDocumentType */
};

DEFINE_GUID(IID_IGWDocumentType2,0x8AD7CAA0L,0xBB25,0x11D0,0xB3,0x31,0x00,0x80,0x5F,0x36,0xA3,0x75);

/* Definition of interface: IGWDocumentType2 */
#undef INTERFACE
#define INTERFACE IGWDocumentType2

DECLARE_INTERFACE_(IGWDocumentType2, IGWDocumentType)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IGWDocumentType methods */
    STDMETHOD(get_Application)(THIS_ DIGWSession FAR* FAR* retval) PURE;
    STDMETHOD(get_DisposalMethod)(THIS_ DisposalMethodConstants FAR* retval) PURE;
    STDMETHOD(get_DocumentLife)(THIS_ long FAR* retval) PURE;
    STDMETHOD(get_MaxVersionCount)(THIS_ long FAR* retval) PURE;
    STDMETHOD(get_Name)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(get_Parent)(THIS_ DIGWDocumentLibrary FAR* FAR* retval) PURE;
#endif

    /* IGWDocumentType2 methods */
    STDMETHOD(get_Parent)(THIS_ DIGWDocumentTypes FAR* FAR* retval) PURE;
};

DEFINE_GUID(DIID_DIGWDocumentType2,0x8AD7CAA1L,0xBB25,0x11D0,0xB3,0x31,0x00,0x80,0x5F,0x36,0xA3,0x75);

/* Definition of dispatch interface: DIGWDocumentType2 */
#undef INTERFACE
#define INTERFACE DIGWDocumentType2

DECLARE_INTERFACE_(DIGWDocumentType2, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;
#endif

/* Capable of dispatching all the methods of interface IGWDocumentType2 */
};

DEFINE_GUID(CLSID_DocumentType,0xC89C2D42L,0x04AF,0x11CF,0xB0,0x49,0x00,0x80,0x5F,0x88,0xE6,0x02);

#ifdef __cplusplus
class DocumentType;
#endif

DEFINE_GUID(CLSID_DocumentType2,0x8AD7CAAFL,0xBB25,0x11D0,0xB3,0x31,0x00,0x80,0x5F,0x36,0xA3,0x75);

#ifdef __cplusplus
class DocumentType2;
#endif

DEFINE_GUID(IID_IGWDocumentTypes,0x8AD7CAA2L,0xBB25,0x11D0,0xB3,0x31,0x00,0x80,0x5F,0x36,0xA3,0x75);

/* Definition of interface: IGWDocumentTypes */
#undef INTERFACE
#define INTERFACE IGWDocumentTypes

DECLARE_INTERFACE_(IGWDocumentTypes, IUnknown)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;
#endif

    /* IGWDocumentTypes methods */
    STDMETHOD(Item)(THIS_ VARIANT vr, DIGWDocumentType FAR* FAR* retval) PURE;
    STDMETHOD(get_Application)(THIS_ DIGWSession FAR* FAR* retval) PURE;
    STDMETHOD(get_Count)(THIS_ long FAR* retval) PURE;
    STDMETHOD(get__NewEnum)(THIS_ IUnknown * FAR* retval) PURE;
    STDMETHOD(get_Parent)(THIS_ DIGWDocumentLibrary FAR* FAR* retval) PURE;
};

DEFINE_GUID(DIID_DIGWDocumentTypes,0x8AD7CAA3L,0xBB25,0x11D0,0xB3,0x31,0x00,0x80,0x5F,0x36,0xA3,0x75);

/* Definition of dispatch interface: DIGWDocumentTypes */
#undef INTERFACE
#define INTERFACE DIGWDocumentTypes

DECLARE_INTERFACE_(DIGWDocumentTypes, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;
#endif

/* Capable of dispatching all the methods of interface IGWDocumentTypes */
};

DEFINE_GUID(CLSID_DocumentTypes,0x8AD7CAA4L,0xBB25,0x11D0,0xB3,0x31,0x00,0x80,0x5F,0x36,0xA3,0x75);

#ifdef __cplusplus
class DocumentTypes;
#endif

DEFINE_GUID(IID_IGWDocument,0x0E112B09L,0xBACA,0x11CF,0x8C,0x91,0x00,0x80,0x5F,0x6C,0x4B,0xEF);

/* Definition of interface: IGWDocument */
#undef INTERFACE
#define INTERFACE IGWDocument

DECLARE_INTERFACE_(IGWDocument, IUnknown)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;
#endif

    /* IGWDocument methods */
    STDMETHOD(Delete)(THIS) PURE;
    STDMETHOD(GetVersion)(THIS_ long lVersionNumber, DIGWDocumentVersion FAR* FAR* retval) PURE;
    STDMETHOD(Refresh)(THIS) PURE;
    STDMETHOD(SetDefaults)(THIS) PURE;
    STDMETHOD(get_AdditionalRights)(THIS_ DIGWDocumentAccessRightsCollection2 FAR* FAR* retval) PURE;
    STDMETHOD(get_Application)(THIS_ DIGWSession FAR* FAR* retval) PURE;
    STDMETHOD(get_Author)(THIS_ DIGWAddress FAR* FAR* retval) PURE;
    STDMETHOD(put_Author)(THIS_ DIGWAddress FAR* pAddress) PURE;
    STDMETHOD(get_AuthorCreatorRights)(THIS_ DIGWDocumentAccessRights FAR* FAR* retval) PURE;
    STDMETHOD(get_CreationDate)(THIS_ DATE FAR* retval) PURE;
    STDMETHOD(get_Creator)(THIS_ DIGWAddress FAR* FAR* pAddress) PURE;
    STDMETHOD(get_CurrentVersion)(THIS_ DIGWDocumentVersion FAR* FAR* retval) PURE;
    STDMETHOD(get_DefaultRights)(THIS_ DIGWDocumentAccessRights FAR* FAR* retval) PURE;
    STDMETHOD(get_DocumentLibrary)(THIS_ DIGWDocumentLibrary FAR* FAR* retval) PURE;
    STDMETHOD(get_DocumentNumber)(THIS_ long FAR* retval) PURE;
    STDMETHOD(get_Subject)(THIS_ BSTR FAR* Subject) PURE;
    STDMETHOD(put_Subject)(THIS_ BSTR Subject) PURE;
    STDMETHOD(get_DocumentType)(THIS_ DIGWDocumentType FAR* FAR* retval) PURE;
    STDMETHOD(put_DocumentType)(THIS_ DIGWDocumentType FAR* DocType) PURE;
    STDMETHOD(get_DocumentVersions)(THIS_ DIGWDocumentVersions FAR* FAR* retval) PURE;
    STDMETHOD(get_Fields)(THIS_ DIGWFields FAR* FAR* retval) PURE;
    STDMETHOD(get_OfficialVersion)(THIS_ DIGWDocumentVersion FAR* FAR* retval) PURE;
    STDMETHOD(put_OfficialVersion)(THIS_ DIGWDocumentVersion FAR* dpVersion) PURE;
    STDMETHOD(get_Parent)(THIS_ DIGWDocuments FAR* FAR* retval) PURE;
};

DEFINE_GUID(IID_IGWDocument2,0x7E000002L,0xE158,0x11CE,0x87,0xEB,0x00,0x80,0x5F,0xB4,0xB2,0xBE);

/* Definition of interface: IGWDocument2 */
#undef INTERFACE
#define INTERFACE IGWDocument2

DECLARE_INTERFACE_(IGWDocument2, IGWDocument)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IGWDocument methods */
    STDMETHOD(Delete)(THIS) PURE;
    STDMETHOD(GetVersion)(THIS_ long lVersionNumber, DIGWDocumentVersion FAR* FAR* retval) PURE;
    STDMETHOD(Refresh)(THIS) PURE;
    STDMETHOD(SetDefaults)(THIS) PURE;
    STDMETHOD(get_AdditionalRights)(THIS_ DIGWDocumentAccessRightsCollection2 FAR* FAR* retval) PURE;
    STDMETHOD(get_Application)(THIS_ DIGWSession FAR* FAR* retval) PURE;
    STDMETHOD(get_Author)(THIS_ DIGWAddress FAR* FAR* retval) PURE;
    STDMETHOD(put_Author)(THIS_ DIGWAddress FAR* pAddress) PURE;
    STDMETHOD(get_AuthorCreatorRights)(THIS_ DIGWDocumentAccessRights FAR* FAR* retval) PURE;
    STDMETHOD(get_CreationDate)(THIS_ DATE FAR* retval) PURE;
    STDMETHOD(get_Creator)(THIS_ DIGWAddress FAR* FAR* pAddress) PURE;
    STDMETHOD(get_CurrentVersion)(THIS_ DIGWDocumentVersion FAR* FAR* retval) PURE;
    STDMETHOD(get_DefaultRights)(THIS_ DIGWDocumentAccessRights FAR* FAR* retval) PURE;
    STDMETHOD(get_DocumentLibrary)(THIS_ DIGWDocumentLibrary FAR* FAR* retval) PURE;
    STDMETHOD(get_DocumentNumber)(THIS_ long FAR* retval) PURE;
    STDMETHOD(get_Subject)(THIS_ BSTR FAR* Subject) PURE;
    STDMETHOD(put_Subject)(THIS_ BSTR Subject) PURE;
    STDMETHOD(get_DocumentType)(THIS_ DIGWDocumentType FAR* FAR* retval) PURE;
    STDMETHOD(put_DocumentType)(THIS_ DIGWDocumentType FAR* DocType) PURE;
    STDMETHOD(get_DocumentVersions)(THIS_ DIGWDocumentVersions FAR* FAR* retval) PURE;
    STDMETHOD(get_Fields)(THIS_ DIGWFields FAR* FAR* retval) PURE;
    STDMETHOD(get_OfficialVersion)(THIS_ DIGWDocumentVersion FAR* FAR* retval) PURE;
    STDMETHOD(put_OfficialVersion)(THIS_ DIGWDocumentVersion FAR* dpVersion) PURE;
    STDMETHOD(get_Parent)(THIS_ DIGWDocuments FAR* FAR* retval) PURE;
#endif

    /* IGWDocument2 methods */
    STDMETHOD(LocalDelete)(THIS) PURE;
};

DEFINE_GUID(DIID_DIGWDocument,0x0E112B0AL,0xBACA,0x11CF,0x8C,0x91,0x00,0x80,0x5F,0x6C,0x4B,0xEF);

/* Definition of dispatch interface: DIGWDocument */
#undef INTERFACE
#define INTERFACE DIGWDocument

DECLARE_INTERFACE_(DIGWDocument, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;
#endif

/* Capable of dispatching all the methods of interface IGWDocument */
};

DEFINE_GUID(DIID_DIGWDocument2,0x0E112B0CL,0xBACA,0x11CF,0x8C,0x91,0x00,0x80,0x5F,0x6C,0x4B,0xEF);

/* Definition of dispatch interface: DIGWDocument2 */
#undef INTERFACE
#define INTERFACE DIGWDocument2

DECLARE_INTERFACE_(DIGWDocument2, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;
#endif

/* Capable of dispatching all the methods of interface IGWDocument2 */
};

DEFINE_GUID(CLSID_Document,0x0E112B0BL,0xBACA,0x11CF,0x8C,0x91,0x00,0x80,0x5F,0x6C,0x4B,0xEF);

#ifdef __cplusplus
class Document;
#endif

DEFINE_GUID(CLSID_Document2,0x0E112B0DL,0xBACA,0x11CF,0x8C,0x91,0x00,0x80,0x5F,0x6C,0x4B,0xEF);

#ifdef __cplusplus
class Document2;
#endif

DEFINE_GUID(IID_IGWDocuments,0x4C002FE2L,0x80CF,0x11CF,0x8C,0x91,0x00,0x80,0x5F,0x6C,0x4B,0xEF);

/* Definition of interface: IGWDocuments */
#undef INTERFACE
#define INTERFACE IGWDocuments

DECLARE_INTERFACE_(IGWDocuments, IUnknown)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;
#endif

    /* IGWDocuments methods */
    STDMETHOD(Add)(THIS_ BSTR bFileName, VARIANT DocType, DIGWDocument FAR* FAR* retval) PURE;
    STDMETHOD(CreateDocumentIterator)(THIS_ DIGWDocumentIterator FAR* FAR* retval) PURE;
    STDMETHOD(get_Application)(THIS_ DIGWSession FAR* FAR* retval) PURE;
    STDMETHOD(get__NewEnum)(THIS_ IUnknown * FAR* retval) PURE;
    STDMETHOD(get_Parent)(THIS_ DIGWDocumentLibrary FAR* FAR* retval) PURE;
};

DEFINE_GUID(IID_IGWDocuments2,0x4EB9D080L,0x0A80,0x11D1,0xB3,0x8B,0x00,0x80,0x5F,0x36,0xA3,0x75);

/* Definition of interface: IGWDocuments2 */
#undef INTERFACE
#define INTERFACE IGWDocuments2

DECLARE_INTERFACE_(IGWDocuments2, IGWDocuments)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IGWDocuments methods */
    STDMETHOD(Add)(THIS_ BSTR bFileName, VARIANT DocType, DIGWDocument FAR* FAR* retval) PURE;
    STDMETHOD(CreateDocumentIterator)(THIS_ DIGWDocumentIterator FAR* FAR* retval) PURE;
    STDMETHOD(get_Application)(THIS_ DIGWSession FAR* FAR* retval) PURE;
    STDMETHOD(get__NewEnum)(THIS_ IUnknown * FAR* retval) PURE;
    STDMETHOD(get_Parent)(THIS_ DIGWDocumentLibrary FAR* FAR* retval) PURE;
#endif

    /* IGWDocuments2 methods */
    STDMETHOD(AddEx)(THIS_ BSTR bFileName, VARIANT DocType, VARIANT DocRefFolder, DIGWDocument FAR* FAR* retval) PURE;
};

DEFINE_GUID(DIID_DIGWDocuments,0x4C002FE3L,0x80CF,0x11CF,0x8C,0x91,0x00,0x80,0x5F,0x6C,0x4B,0xEF);

/* Definition of dispatch interface: DIGWDocuments */
#undef INTERFACE
#define INTERFACE DIGWDocuments

DECLARE_INTERFACE_(DIGWDocuments, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;
#endif

/* Capable of dispatching all the methods of interface IGWDocuments */
};

DEFINE_GUID(DIID_DIGWDocuments2,0x4C002FE4L,0x80CF,0x11CF,0x8C,0x91,0x00,0x80,0x5F,0x6C,0x4B,0xEF);

/* Definition of dispatch interface: DIGWDocuments2 */
#undef INTERFACE
#define INTERFACE DIGWDocuments2

DECLARE_INTERFACE_(DIGWDocuments2, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;
#endif

/* Capable of dispatching all the methods of interface IGWDocuments2 */
};

DEFINE_GUID(CLSID_Documents,0xC89C2D44L,0x04AF,0x11CF,0xB0,0x49,0x00,0x80,0x5F,0x88,0xE6,0x02);

#ifdef __cplusplus
class Documents;
#endif

DEFINE_GUID(CLSID_Documents2,0xC89C2D4DL,0x04AF,0x11CF,0xB0,0x49,0x00,0x80,0x5F,0x88,0xE6,0x02);

#ifdef __cplusplus
class Documents2;
#endif

DEFINE_GUID(IID_IGWDocumentIterator,0x4C002FE0L,0x80CF,0x11CF,0x8C,0x91,0x00,0x80,0x5F,0x6C,0x4B,0xEF);

/* Definition of interface: IGWDocumentIterator */
#undef INTERFACE
#define INTERFACE IGWDocumentIterator

DECLARE_INTERFACE_(IGWDocumentIterator, IUnknown)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;
#endif

    /* IGWDocumentIterator methods */
    STDMETHOD(get_Application)(THIS_ DIGWSession FAR* FAR* retval) PURE;
    STDMETHOD(get_Parent)(THIS_ DIGWDocuments FAR* FAR* retval) PURE;
    STDMETHOD(Clone)(THIS_ DIGWDocumentIterator FAR* FAR* retval) PURE;
    STDMETHOD(Next)(THIS_ DIGWDocument FAR* FAR* retval) PURE;
    STDMETHOD(Reset)(THIS) PURE;
    STDMETHOD(Skip)(THIS_ long lNumDocuments) PURE;
};

DEFINE_GUID(DIID_DIGWDocumentIterator,0x4C002FE1L,0x80CF,0x11CF,0x8C,0x91,0x00,0x80,0x5F,0x6C,0x4B,0xEF);

/* Definition of dispatch interface: DIGWDocumentIterator */
#undef INTERFACE
#define INTERFACE DIGWDocumentIterator

DECLARE_INTERFACE_(DIGWDocumentIterator, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;
#endif

/* Capable of dispatching all the methods of interface IGWDocumentIterator */
};

DEFINE_GUID(CLSID_DocumentIterator,0x4F275080L,0x9C5A,0x11CF,0x93,0x03,0x00,0x80,0x5F,0xC2,0xA1,0xBB);

#ifdef __cplusplus
class DocumentIterator;
#endif

DEFINE_GUID(IID_IGWDocumentVersion,0x9F9E6D64L,0x5B13,0x11CF,0x87,0x78,0x00,0x60,0x8C,0x68,0xC0,0xBF);

/* Definition of interface: IGWDocumentVersion */
#undef INTERFACE
#define INTERFACE IGWDocumentVersion

DECLARE_INTERFACE_(IGWDocumentVersion, IUnknown)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;
#endif

    /* IGWDocumentVersion methods */
    STDMETHOD(CheckIn)(THIS_ VARIANT Filename, VARIANT StatusChange) PURE;
    STDMETHOD(CheckOut)(THIS_ VARIANT Filename) PURE;
    STDMETHOD(CopyOut)(THIS_ VARIANT Filename) PURE;
    STDMETHOD(Delete)(THIS) PURE;
    STDMETHOD(EndPreview)(THIS_ VARIANT Filename) PURE;
    STDMETHOD(EndRetrieve)(THIS_ VARIANT Filename, VARIANT StatusChange) PURE;
    STDMETHOD(GetElement)(THIS_ long lElementNumber, IDispatch * FAR* retval) PURE;
    STDMETHOD(Preview)(THIS_ VARIANT Filename) PURE;
    STDMETHOD(Refresh)(THIS) PURE;
    STDMETHOD(Retrieve)(THIS_ VARIANT Filename) PURE;
    STDMETHOD(get_Application)(THIS_ DIGWSession FAR* FAR* retval) PURE;
    STDMETHOD(get_Archived)(THIS_ VARIANT_BOOL FAR* bArchived) PURE;
    STDMETHOD(get_CheckedOut)(THIS_ VARIANT_BOOL FAR* bCheckedOut) PURE;
    STDMETHOD(get_ConnectedReadWrite)(THIS_ VARIANT_BOOL FAR* bReadWrite) PURE;
    STDMETHOD(get_CreationDate)(THIS_ DATE FAR* retval) PURE;
    STDMETHOD(get_Creator)(THIS_ DIGWAddress FAR* FAR* pAddress) PURE;
    STDMETHOD(get_Description)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(put_Description)(THIS_ BSTR retval) PURE;
    STDMETHOD(get_DocumentElements)(THIS_ IDispatch * FAR* retval) PURE;
    STDMETHOD(get_DocumentLibrary)(THIS_ DIGWDocumentLibrary FAR* FAR* retval) PURE;
    STDMETHOD(get_Document)(THIS_ DIGWDocument FAR* FAR* retval) PURE;
    STDMETHOD(get_DocumentVersionEvents)(THIS_ DIGWDocumentVersionEvents FAR* FAR* retval) PURE;
    STDMETHOD(get_ExpirationDate)(THIS_ DATE FAR* retval) PURE;
    STDMETHOD(get_InUse)(THIS_ VARIANT_BOOL FAR* bInUse) PURE;
    STDMETHOD(get_ODMADocumentID)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(get_Parent)(THIS_ DIGWDocumentVersions FAR* FAR* retval) PURE;
    STDMETHOD(get_RetrievalDate)(THIS_ DATE FAR* retval) PURE;
    STDMETHOD(get_Retriever)(THIS_ DIGWAddress FAR* FAR* pAddress) PURE;
    STDMETHOD(get_VersionNumber)(THIS_ long FAR* retval) PURE;
    STDMETHOD(get_OriginalFileType)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(get_StagedFilename)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(put_OriginalFileType)(THIS_ BSTR bFileType) PURE;
};

DEFINE_GUID(IID_IGWDocumentVersion2,0x4EB9D081L,0x0A80,0x11D1,0xB3,0x8B,0x00,0x80,0x5F,0x36,0xA3,0x75);

/* Definition of interface: IGWDocumentVersion2 */
#undef INTERFACE
#define INTERFACE IGWDocumentVersion2

DECLARE_INTERFACE_(IGWDocumentVersion2, IGWDocumentVersion)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IGWDocumentVersion methods */
    STDMETHOD(CheckIn)(THIS_ VARIANT Filename, VARIANT StatusChange) PURE;
    STDMETHOD(CheckOut)(THIS_ VARIANT Filename) PURE;
    STDMETHOD(CopyOut)(THIS_ VARIANT Filename) PURE;
    STDMETHOD(Delete)(THIS) PURE;
    STDMETHOD(EndPreview)(THIS_ VARIANT Filename) PURE;
    STDMETHOD(EndRetrieve)(THIS_ VARIANT Filename, VARIANT StatusChange) PURE;
    STDMETHOD(GetElement)(THIS_ long lElementNumber, IDispatch * FAR* retval) PURE;
    STDMETHOD(Preview)(THIS_ VARIANT Filename) PURE;
    STDMETHOD(Refresh)(THIS) PURE;
    STDMETHOD(Retrieve)(THIS_ VARIANT Filename) PURE;
    STDMETHOD(get_Application)(THIS_ DIGWSession FAR* FAR* retval) PURE;
    STDMETHOD(get_Archived)(THIS_ VARIANT_BOOL FAR* bArchived) PURE;
    STDMETHOD(get_CheckedOut)(THIS_ VARIANT_BOOL FAR* bCheckedOut) PURE;
    STDMETHOD(get_ConnectedReadWrite)(THIS_ VARIANT_BOOL FAR* bReadWrite) PURE;
    STDMETHOD(get_CreationDate)(THIS_ DATE FAR* retval) PURE;
    STDMETHOD(get_Creator)(THIS_ DIGWAddress FAR* FAR* pAddress) PURE;
    STDMETHOD(get_Description)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(put_Description)(THIS_ BSTR retval) PURE;
    STDMETHOD(get_DocumentElements)(THIS_ IDispatch * FAR* retval) PURE;
    STDMETHOD(get_DocumentLibrary)(THIS_ DIGWDocumentLibrary FAR* FAR* retval) PURE;
    STDMETHOD(get_Document)(THIS_ DIGWDocument FAR* FAR* retval) PURE;
    STDMETHOD(get_DocumentVersionEvents)(THIS_ DIGWDocumentVersionEvents FAR* FAR* retval) PURE;
    STDMETHOD(get_ExpirationDate)(THIS_ DATE FAR* retval) PURE;
    STDMETHOD(get_InUse)(THIS_ VARIANT_BOOL FAR* bInUse) PURE;
    STDMETHOD(get_ODMADocumentID)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(get_Parent)(THIS_ DIGWDocumentVersions FAR* FAR* retval) PURE;
    STDMETHOD(get_RetrievalDate)(THIS_ DATE FAR* retval) PURE;
    STDMETHOD(get_Retriever)(THIS_ DIGWAddress FAR* FAR* pAddress) PURE;
    STDMETHOD(get_VersionNumber)(THIS_ long FAR* retval) PURE;
    STDMETHOD(get_OriginalFileType)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(get_StagedFilename)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(put_OriginalFileType)(THIS_ BSTR bFileType) PURE;
#endif

    /* IGWDocumentVersion2 methods */
    STDMETHOD(RemoteEndRetrieve)(THIS_ VARIANT Filename, VARIANT StatusChange) PURE;
};

DEFINE_GUID(DIID_DIGWDocumentVersion,0x9F9E6D65L,0x5B13,0x11CF,0x87,0x78,0x00,0x60,0x8C,0x68,0xC0,0xBF);

/* Definition of dispatch interface: DIGWDocumentVersion */
#undef INTERFACE
#define INTERFACE DIGWDocumentVersion

DECLARE_INTERFACE_(DIGWDocumentVersion, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;
#endif

/* Capable of dispatching all the methods of interface IGWDocumentVersion */
};

DEFINE_GUID(DIID_DIGWDocumentVersion2,0x9F9E6D68L,0x5B13,0x11CF,0x87,0x78,0x00,0x60,0x8C,0x68,0xC0,0xBF);

/* Definition of dispatch interface: DIGWDocumentVersion2 */
#undef INTERFACE
#define INTERFACE DIGWDocumentVersion2

DECLARE_INTERFACE_(DIGWDocumentVersion2, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;
#endif

/* Capable of dispatching all the methods of interface IGWDocumentVersion2 */
};

DEFINE_GUID(CLSID_DocumentVersion,0xC89C2D45L,0x04AF,0x11CF,0xB0,0x49,0x00,0x80,0x5F,0x88,0xE6,0x02);

#ifdef __cplusplus
class DocumentVersion;
#endif

DEFINE_GUID(CLSID_DocumentVersion2,0xC89C2D4BL,0x04AF,0x11CF,0xB0,0x49,0x00,0x80,0x5F,0x88,0xE6,0x02);

#ifdef __cplusplus
class DocumentVersion2;
#endif

DEFINE_GUID(IID_IGWDocumentVersions,0x9F9E6D66L,0x5B13,0x11CF,0x87,0x78,0x00,0x60,0x8C,0x68,0xC0,0xBF);

/* Definition of interface: IGWDocumentVersions */
#undef INTERFACE
#define INTERFACE IGWDocumentVersions

DECLARE_INTERFACE_(IGWDocumentVersions, IUnknown)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;
#endif

    /* IGWDocumentVersions methods */
    STDMETHOD(Add)(THIS_ DIGWDocumentVersion FAR* FAR* retval) PURE;
    STDMETHOD(Item)(THIS_ VARIANT vr, DIGWDocumentVersion FAR* FAR* retval) PURE;
    STDMETHOD(get_Application)(THIS_ DIGWSession FAR* FAR* retval) PURE;
    STDMETHOD(get_Count)(THIS_ long FAR* retval) PURE;
    STDMETHOD(get__NewEnum)(THIS_ IUnknown * FAR* retval) PURE;
    STDMETHOD(get_Parent)(THIS_ DIGWDocument FAR* FAR* retval) PURE;
};

DEFINE_GUID(DIID_DIGWDocumentVersions,0x9F9E6D67L,0x5B13,0x11CF,0x87,0x78,0x00,0x60,0x8C,0x68,0xC0,0xBF);

/* Definition of dispatch interface: DIGWDocumentVersions */
#undef INTERFACE
#define INTERFACE DIGWDocumentVersions

DECLARE_INTERFACE_(DIGWDocumentVersions, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;
#endif

/* Capable of dispatching all the methods of interface IGWDocumentVersions */
};

DEFINE_GUID(CLSID_DocumentVersions,0xC89C2D46L,0x04AF,0x11CF,0xB0,0x49,0x00,0x80,0x5F,0x88,0xE6,0x02);

#ifdef __cplusplus
class DocumentVersions;
#endif

DEFINE_GUID(IID_IGWDocumentVersionEvent,0x057B62A4L,0x524F,0x11CF,0x87,0x78,0x00,0x60,0x8C,0x68,0xC0,0xBF);

/* Definition of interface: IGWDocumentVersionEvent */
#undef INTERFACE
#define INTERFACE IGWDocumentVersionEvent

DECLARE_INTERFACE_(IGWDocumentVersionEvent, IUnknown)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;
#endif

    /* IGWDocumentVersionEvent methods */
    STDMETHOD(get_Application)(THIS_ DIGWSession FAR* FAR* retval) PURE;
    STDMETHOD(get_CreationDate)(THIS_ DATE FAR* retval) PURE;
    STDMETHOD(get_DocumentLibrary)(THIS_ DIGWDocumentLibrary FAR* FAR* retval) PURE;
    STDMETHOD(get_Document)(THIS_ DIGWDocument FAR* FAR* retval) PURE;
    STDMETHOD(get_DocumentVersion)(THIS_ DIGWDocumentVersion FAR* FAR* retval) PURE;
    STDMETHOD(get_EventType)(THIS_ EventTypeConstants FAR* retval) PURE;
    STDMETHOD(get_Parent)(THIS_ DIGWDocumentVersionEvents FAR* FAR* retval) PURE;
    STDMETHOD(get_User)(THIS_ DIGWAddress FAR* FAR* pAddress) PURE;
};

DEFINE_GUID(DIID_DIGWDocumentVersionEvent,0x057B62A5L,0x524F,0x11CF,0x87,0x78,0x00,0x60,0x8C,0x68,0xC0,0xBF);

/* Definition of dispatch interface: DIGWDocumentVersionEvent */
#undef INTERFACE
#define INTERFACE DIGWDocumentVersionEvent

DECLARE_INTERFACE_(DIGWDocumentVersionEvent, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;
#endif

/* Capable of dispatching all the methods of interface IGWDocumentVersionEvent */
};

DEFINE_GUID(IID_IGWDocumentVersionEvent2,0x3B9BC5A0L,0xF7D3,0x11D0,0xB3,0x7A,0x00,0x80,0x5F,0x36,0xA3,0x75);

/* Definition of interface: IGWDocumentVersionEvent2 */
#undef INTERFACE
#define INTERFACE IGWDocumentVersionEvent2

DECLARE_INTERFACE_(IGWDocumentVersionEvent2, IGWDocumentVersionEvent)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IGWDocumentVersionEvent methods */
    STDMETHOD(get_Application)(THIS_ DIGWSession FAR* FAR* retval) PURE;
    STDMETHOD(get_CreationDate)(THIS_ DATE FAR* retval) PURE;
    STDMETHOD(get_DocumentLibrary)(THIS_ DIGWDocumentLibrary FAR* FAR* retval) PURE;
    STDMETHOD(get_Document)(THIS_ DIGWDocument FAR* FAR* retval) PURE;
    STDMETHOD(get_DocumentVersion)(THIS_ DIGWDocumentVersion FAR* FAR* retval) PURE;
    STDMETHOD(get_EventType)(THIS_ EventTypeConstants FAR* retval) PURE;
    STDMETHOD(get_Parent)(THIS_ DIGWDocumentVersionEvents FAR* FAR* retval) PURE;
    STDMETHOD(get_User)(THIS_ DIGWAddress FAR* FAR* pAddress) PURE;
#endif

    /* IGWDocumentVersionEvent2 methods */
    STDMETHOD(get_Filename)(THIS_ BSTR FAR* retval) PURE;
};

DEFINE_GUID(DIID_DIGWDocumentVersionEvent2,0x3B9BC5A1L,0xF7D3,0x11D0,0xB3,0x7A,0x00,0x80,0x5F,0x36,0xA3,0x75);

/* Definition of dispatch interface: DIGWDocumentVersionEvent2 */
#undef INTERFACE
#define INTERFACE DIGWDocumentVersionEvent2

DECLARE_INTERFACE_(DIGWDocumentVersionEvent2, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;
#endif

/* Capable of dispatching all the methods of interface IGWDocumentVersionEvent2 */
};

DEFINE_GUID(CLSID_DocumentVersionEvent,0xC89C2D47L,0x04AF,0x11CF,0xB0,0x49,0x00,0x80,0x5F,0x88,0xE6,0x02);

#ifdef __cplusplus
class DocumentVersionEvent;
#endif

DEFINE_GUID(CLSID_DocumentVersionEvent2,0x3B9BC5AAL,0xF7D3,0x11D0,0xB3,0x7A,0x00,0x80,0x5F,0x36,0xA3,0x75);

#ifdef __cplusplus
class DocumentVersionEvent2;
#endif

DEFINE_GUID(IID_IGWDocumentVersionEvents,0x057B62A6L,0x524F,0x11CF,0x87,0x78,0x00,0x60,0x8C,0x68,0xC0,0xBF);

/* Definition of interface: IGWDocumentVersionEvents */
#undef INTERFACE
#define INTERFACE IGWDocumentVersionEvents

DECLARE_INTERFACE_(IGWDocumentVersionEvents, IUnknown)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;
#endif

    /* IGWDocumentVersionEvents methods */
    STDMETHOD(Item)(THIS_ VARIANT vr, DIGWDocumentVersionEvent FAR* FAR* retval) PURE;
    STDMETHOD(get_Application)(THIS_ DIGWSession FAR* FAR* retval) PURE;
    STDMETHOD(get_Count)(THIS_ long FAR* retval) PURE;
    STDMETHOD(get__NewEnum)(THIS_ IUnknown * FAR* retval) PURE;
    STDMETHOD(get_Parent)(THIS_ DIGWDocumentVersion FAR* FAR* retval) PURE;
};

DEFINE_GUID(DIID_DIGWDocumentVersionEvents,0x057B62A7L,0x524F,0x11CF,0x87,0x78,0x00,0x60,0x8C,0x68,0xC0,0xBF);

/* Definition of dispatch interface: DIGWDocumentVersionEvents */
#undef INTERFACE
#define INTERFACE DIGWDocumentVersionEvents

DECLARE_INTERFACE_(DIGWDocumentVersionEvents, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;
#endif

/* Capable of dispatching all the methods of interface IGWDocumentVersionEvents */
};

DEFINE_GUID(CLSID_DocumentVersionEvents,0xC89C2D48L,0x04AF,0x11CF,0xB0,0x49,0x00,0x80,0x5F,0x88,0xE6,0x02);

#ifdef __cplusplus
class DocumentVersionEvents;
#endif

DEFINE_GUID(IID_IGWDownloadStatus,0x7D2266F2L,0xE158,0x11CE,0x87,0xEB,0x00,0x80,0x5F,0xB4,0xB2,0xBE);

/* Definition of interface: IGWDownloadStatus */
#undef INTERFACE
#define INTERFACE IGWDownloadStatus

DECLARE_INTERFACE_(IGWDownloadStatus, IUnknown)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;
#endif

    /* IGWDownloadStatus methods */
    STDMETHOD(get_AttachmentsState)(THIS_ DownloadStateConstants FAR* retval) PURE;
    STDMETHOD(get_BodyTextState)(THIS_ DownloadStateConstants FAR* retval) PURE;
    STDMETHOD(get_RecipientsState)(THIS_ DownloadStateConstants FAR* retval) PURE;
};

DEFINE_GUID(DIID_DIGWDownloadStatus,0x7D2266F3L,0xE158,0x11CE,0x87,0xEB,0x00,0x80,0x5F,0xB4,0xB2,0xBE);

/* Definition of dispatch interface: DIGWDownloadStatus */
#undef INTERFACE
#define INTERFACE DIGWDownloadStatus

DECLARE_INTERFACE_(DIGWDownloadStatus, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;
#endif

/* Capable of dispatching all the methods of interface IGWDownloadStatus */
};

DEFINE_GUID(CLSID_DownloadStatus,0xC89C2F65L,0x04AF,0x11CF,0xB0,0x49,0x00,0x80,0x5F,0x88,0xE6,0x02);

#ifdef __cplusplus
class DownloadStatus;
#endif

DEFINE_GUID(IID_IGWField,0x70238C20L,0x03DC,0x11CF,0xB0,0x49,0x00,0x80,0x5F,0x88,0xE6,0x02);

/* Definition of interface: IGWField */
#undef INTERFACE
#define INTERFACE IGWField

DECLARE_INTERFACE_(IGWField, IUnknown)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;
#endif

    /* IGWField methods */
    STDMETHOD(get_Name)(THIS_ BSTR FAR* pName) PURE;
    STDMETHOD(get_Value)(THIS_ VARIANT FAR* retval) PURE;
    STDMETHOD(put_Value)(THIS_ VARIANT Value) PURE;
    STDMETHOD(get_Parent)(THIS_ DIGWFields FAR* FAR* retval) PURE;
    STDMETHOD(get_Application)(THIS_ DIGWSession FAR* FAR* retval) PURE;
    STDMETHOD(Delete)(THIS) PURE;
};

DEFINE_GUID(DIID_DIGWField,0x81A81B00L,0x03DC,0x11CF,0xB0,0x49,0x00,0x80,0x5F,0x88,0xE6,0x02);

/* Definition of dispatch interface: DIGWField */
#undef INTERFACE
#define INTERFACE DIGWField

DECLARE_INTERFACE_(DIGWField, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;
#endif

/* Capable of dispatching all the methods of interface IGWField */
};

DEFINE_GUID(IID_IGWField2,0x67242E70L,0xC0AF,0x11D0,0xB3,0x37,0x00,0x80,0x5F,0x36,0xA3,0x75);

/* Definition of interface: IGWField2 */
#undef INTERFACE
#define INTERFACE IGWField2

DECLARE_INTERFACE_(IGWField2, IGWField)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IGWField methods */
    STDMETHOD(get_Name)(THIS_ BSTR FAR* pName) PURE;
    STDMETHOD(get_Value)(THIS_ VARIANT FAR* retval) PURE;
    STDMETHOD(put_Value)(THIS_ VARIANT Value) PURE;
    STDMETHOD(get_Parent)(THIS_ DIGWFields FAR* FAR* retval) PURE;
    STDMETHOD(get_Application)(THIS_ DIGWSession FAR* FAR* retval) PURE;
    STDMETHOD(Delete)(THIS) PURE;
#endif

    /* IGWField2 methods */
    STDMETHOD(Validate)(THIS_ VARIANT vr, VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(get_FieldDefinition)(THIS_ DIGWFieldDefinition FAR* FAR* retval) PURE;
    STDMETHOD(get_FieldID)(THIS_ long FAR* retval) PURE;
};

DEFINE_GUID(DIID_DIGWField2,0x67242E71L,0xC0AF,0x11D0,0xB3,0x37,0x00,0x80,0x5F,0x36,0xA3,0x75);

/* Definition of dispatch interface: DIGWField2 */
#undef INTERFACE
#define INTERFACE DIGWField2

DECLARE_INTERFACE_(DIGWField2, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;
#endif

/* Capable of dispatching all the methods of interface IGWField2 */
};

DEFINE_GUID(CLSID_Field,0xC89C2D49L,0x04AF,0x11CF,0xB0,0x49,0x00,0x80,0x5F,0x88,0xE6,0x02);

#ifdef __cplusplus
class Field;
#endif

DEFINE_GUID(CLSID_Field2,0x67242E79L,0xC0AF,0x11D0,0xB3,0x37,0x00,0x80,0x5F,0x36,0xA3,0x75);

#ifdef __cplusplus
class Field2;
#endif

DEFINE_GUID(IID_IGWFields,0x8D4791C0L,0x03DC,0x11CF,0xB0,0x49,0x00,0x80,0x5F,0x88,0xE6,0x02);

/* Definition of interface: IGWFields */
#undef INTERFACE
#define INTERFACE IGWFields

DECLARE_INTERFACE_(IGWFields, IUnknown)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;
#endif

    /* IGWFields methods */
    STDMETHOD(Item)(THIS_ VARIANT Key, VARIANT FldType, DIGWField FAR* FAR* retval) PURE;
    STDMETHOD(Add)(THIS_ BSTR FieldName, FieldTypeConstants FldType, VARIANT Value, DIGWField FAR* FAR* retval) PURE;
    STDMETHOD(get_Count)(THIS_ long FAR* retval) PURE;
    STDMETHOD(get__NewEnum)(THIS_ IUnknown * FAR* retval) PURE;
    STDMETHOD(get_Parent)(THIS_ IDispatch * FAR* retval) PURE;
    STDMETHOD(get_Application)(THIS_ DIGWSession FAR* FAR* retval) PURE;
};

DEFINE_GUID(DIID_DIGWFields,0x9B7D43C0L,0x03DC,0x11CF,0xB0,0x49,0x00,0x80,0x5F,0x88,0xE6,0x02);

/* Definition of dispatch interface: DIGWFields */
#undef INTERFACE
#define INTERFACE DIGWFields

DECLARE_INTERFACE_(DIGWFields, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;
#endif

/* Capable of dispatching all the methods of interface IGWFields */
};

DEFINE_GUID(CLSID_Fields,0xC89C2D50L,0x04AF,0x11CF,0xB0,0x49,0x00,0x80,0x5F,0x88,0xE6,0x02);

#ifdef __cplusplus
class Fields;
#endif

DEFINE_GUID(IID_IGWFieldDefinition,0xF33835A0L,0x2030,0x11CF,0x97,0x2B,0x00,0x60,0x8C,0x85,0xE0,0xF4);

/* Definition of interface: IGWFieldDefinition */
#undef INTERFACE
#define INTERFACE IGWFieldDefinition

DECLARE_INTERFACE_(IGWFieldDefinition, IUnknown)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;
#endif

    /* IGWFieldDefinition methods */
    STDMETHOD(get_Name)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(get_FieldType)(THIS_ FieldTypeConstants FAR* retval) PURE;
    STDMETHOD(get_Parent)(THIS_ DIGWFieldDefinitions FAR* FAR* retval) PURE;
    STDMETHOD(get_Application)(THIS_ DIGWSession FAR* FAR* retval) PURE;
};

DEFINE_GUID(DIID_DIGWFieldDefinition,0xF33835A1L,0x2030,0x11CF,0x97,0x2B,0x00,0x60,0x8C,0x85,0xE0,0xF4);

/* Definition of dispatch interface: DIGWFieldDefinition */
#undef INTERFACE
#define INTERFACE DIGWFieldDefinition

DECLARE_INTERFACE_(DIGWFieldDefinition, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;
#endif

/* Capable of dispatching all the methods of interface IGWFieldDefinition */
};

DEFINE_GUID(IID_IGWFieldDefinition2,0x67242E73L,0xC0AF,0x11D0,0xB3,0x37,0x00,0x80,0x5F,0x36,0xA3,0x75);

/* Definition of interface: IGWFieldDefinition2 */
#undef INTERFACE
#define INTERFACE IGWFieldDefinition2

DECLARE_INTERFACE_(IGWFieldDefinition2, IGWFieldDefinition)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IGWFieldDefinition methods */
    STDMETHOD(get_Name)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(get_FieldType)(THIS_ FieldTypeConstants FAR* retval) PURE;
    STDMETHOD(get_Parent)(THIS_ DIGWFieldDefinitions FAR* FAR* retval) PURE;
    STDMETHOD(get_Application)(THIS_ DIGWSession FAR* FAR* retval) PURE;
#endif

    /* IGWFieldDefinition2 methods */
    STDMETHOD(Delete)(THIS) PURE;
    STDMETHOD(GetLookupTable)(THIS_ VARIANT vValue, DIGWLookupTableEntries FAR* FAR* retval) PURE;
    STDMETHOD(get_HasLookupTable)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(get_Hidden)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(get_MaximumLength)(THIS_ long FAR* retval) PURE;
    STDMETHOD(get_MaximumValue)(THIS_ long FAR* retval) PURE;
    STDMETHOD(get_MinimumValue)(THIS_ long FAR* retval) PURE;
    STDMETHOD(get_ReadOnly)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(get_RelatedFieldDefinition)(THIS_ DIGWFieldDefinition FAR* FAR* retval) PURE;
    STDMETHOD(get_Required)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(get_StringCase)(THIS_ FieldDefinitionCase FAR* retval) PURE;
    STDMETHOD(get_FieldID)(THIS_ long FAR* retval) PURE;
};

DEFINE_GUID(DIID_DIGWFieldDefinition2,0x67242E74L,0xC0AF,0x11D0,0xB3,0x37,0x00,0x80,0x5F,0x36,0xA3,0x75);

/* Definition of dispatch interface: DIGWFieldDefinition2 */
#undef INTERFACE
#define INTERFACE DIGWFieldDefinition2

DECLARE_INTERFACE_(DIGWFieldDefinition2, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;
#endif

/* Capable of dispatching all the methods of interface IGWFieldDefinition2 */
};

DEFINE_GUID(CLSID_FieldDefinition,0xC89C2D51L,0x04AF,0x11CF,0xB0,0x49,0x00,0x80,0x5F,0x88,0xE6,0x02);

#ifdef __cplusplus
class FieldDefinition;
#endif

DEFINE_GUID(CLSID_FieldDefinition2,0x67242E7AL,0xC0AF,0x11D0,0xB3,0x37,0x00,0x80,0x5F,0x36,0xA3,0x75);

#ifdef __cplusplus
class FieldDefinition2;
#endif

DEFINE_GUID(IID_IGWFieldDefinitions,0xF33835A3L,0x2030,0x11CF,0x97,0x2B,0x00,0x60,0x8C,0x85,0xE0,0xF4);

/* Definition of interface: IGWFieldDefinitions */
#undef INTERFACE
#define INTERFACE IGWFieldDefinitions

DECLARE_INTERFACE_(IGWFieldDefinitions, IUnknown)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;
#endif

    /* IGWFieldDefinitions methods */
    STDMETHOD(Add)(THIS_ BSTR Name, FieldTypeConstants FieldType, DIGWFieldDefinition FAR* FAR* retval) PURE;
    STDMETHOD(Item)(THIS_ VARIANT Key, VARIANT Type, DIGWFieldDefinition FAR* FAR* retval) PURE;
    STDMETHOD(get_Count)(THIS_ long FAR* retval) PURE;
    STDMETHOD(get__NewEnum)(THIS_ IUnknown * FAR* retval) PURE;
    STDMETHOD(get_Parent)(THIS_ IDispatch * FAR* retval) PURE;
    STDMETHOD(get_Application)(THIS_ DIGWSession FAR* FAR* retval) PURE;
};

DEFINE_GUID(DIID_DIGWFieldDefinitions,0xF33835A4L,0x2030,0x11CF,0x97,0x2B,0x00,0x60,0x8C,0x85,0xE0,0xF4);

/* Definition of dispatch interface: DIGWFieldDefinitions */
#undef INTERFACE
#define INTERFACE DIGWFieldDefinitions

DECLARE_INTERFACE_(DIGWFieldDefinitions, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;
#endif

/* Capable of dispatching all the methods of interface IGWFieldDefinitions */
};

DEFINE_GUID(CLSID_FieldDefinitions,0xC89C2D52L,0x04AF,0x11CF,0xB0,0x49,0x00,0x80,0x5F,0x88,0xE6,0x02);

#ifdef __cplusplus
class FieldDefinitions;
#endif

DEFINE_GUID(IID_IGWFilter,0x6CC58240L,0x184F,0x11CF,0xAA,0x9E,0x00,0x60,0x8C,0xBB,0x87,0xCE);

/* Definition of interface: IGWFilter */
#undef INTERFACE
#define INTERFACE IGWFilter

DECLARE_INTERFACE_(IGWFilter, IUnknown)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;
#endif

    /* IGWFilter methods */
    STDMETHOD(Delete)(THIS) PURE;
    STDMETHOD(TouchAccessedDate)(THIS) PURE;
    STDMETHOD(put_Name)(THIS_ BSTR Param) PURE;
    STDMETHOD(get_Name)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(put_Expression)(THIS_ BSTR Param) PURE;
    STDMETHOD(get_Expression)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(get_LastAccessedDate)(THIS_ DATE FAR* retval) PURE;
    STDMETHOD(put_Description)(THIS_ BSTR Param) PURE;
    STDMETHOD(get_Description)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(get_Application)(THIS_ DIGWSession FAR* FAR* retval) PURE;
    STDMETHOD(get_Parent)(THIS_ IDispatch * FAR* retval) PURE;
};

DEFINE_GUID(DIID_DIGWFilter,0x6CC58241L,0x184F,0x11CF,0xAA,0x9E,0x00,0x60,0x8C,0xBB,0x87,0xCE);

/* Definition of dispatch interface: DIGWFilter */
#undef INTERFACE
#define INTERFACE DIGWFilter

DECLARE_INTERFACE_(DIGWFilter, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;
#endif

/* Capable of dispatching all the methods of interface IGWFilter */
};

DEFINE_GUID(CLSID_Filter,0xC89C2D53L,0x04AF,0x11CF,0xB0,0x49,0x00,0x80,0x5F,0x88,0xE6,0x02);

#ifdef __cplusplus
class Filter;
#endif

DEFINE_GUID(IID_IGWFilters,0x95461E60L,0x348C,0x11CF,0xAF,0xA5,0x00,0x60,0x8C,0x79,0xBC,0x42);

/* Definition of interface: IGWFilters */
#undef INTERFACE
#define INTERFACE IGWFilters

DECLARE_INTERFACE_(IGWFilters, IUnknown)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;
#endif

    /* IGWFilters methods */
    STDMETHOD(Item)(THIS_ VARIANT vr, DIGWFilter FAR* FAR* retval) PURE;
    STDMETHOD(Add)(THIS_ BSTR FilterName, BSTR Expression, DIGWFilter FAR* FAR* retval) PURE;
    STDMETHOD(Refresh)(THIS) PURE;
    STDMETHOD(get_Count)(THIS_ long FAR* retval) PURE;
    STDMETHOD(get__NewEnum)(THIS_ IUnknown * FAR* retval) PURE;
    STDMETHOD(get_Application)(THIS_ DIGWSession FAR* FAR* retval) PURE;
    STDMETHOD(get_Parent)(THIS_ IDispatch * FAR* retval) PURE;
};

DEFINE_GUID(DIID_DIGWFilters,0x95461E61L,0x348C,0x11CF,0xAF,0xA5,0x00,0x60,0x8C,0x79,0xBC,0x42);

/* Definition of dispatch interface: DIGWFilters */
#undef INTERFACE
#define INTERFACE DIGWFilters

DECLARE_INTERFACE_(DIGWFilters, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;
#endif

/* Capable of dispatching all the methods of interface IGWFilters */
};

DEFINE_GUID(CLSID_Filters,0xC89C2D54L,0x04AF,0x11CF,0xB0,0x49,0x00,0x80,0x5F,0x88,0xE6,0x02);

#ifdef __cplusplus
class Filters;
#endif

DEFINE_GUID(IID_IGWFolder,0x4A70F280L,0xA98E,0x11CF,0x8C,0x91,0x00,0x80,0x5F,0x6C,0x4B,0xEF);

/* Definition of interface: IGWFolder */
#undef INTERFACE
#define INTERFACE IGWFolder

DECLARE_INTERFACE_(IGWFolder, IUnknown)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;
#endif

    /* IGWFolder methods */
    STDMETHOD(Delete)(THIS) PURE;
    STDMETHOD(Move)(THIS_ DIGWFolder FAR* pDestination) PURE;
    STDMETHOD(Refresh)(THIS) PURE;
    STDMETHOD(get_AllFolders)(THIS_ DIGWFolders FAR* FAR* retval) PURE;
    STDMETHOD(get_Application)(THIS_ DIGWSession FAR* FAR* retval) PURE;
    STDMETHOD(get_Description)(THIS_ BSTR FAR* bDescription) PURE;
    STDMETHOD(put_Description)(THIS_ BSTR bDescription) PURE;
    STDMETHOD(get_FolderID)(THIS_ BSTR FAR* pName) PURE;
    STDMETHOD(get_FolderRights)(THIS_ DIGWFolderRightsCollection FAR* FAR* retval) PURE;
    STDMETHOD(get_Folders)(THIS_ DIGWFolders FAR* FAR* retval) PURE;
    STDMETHOD(get_Messages)(THIS_ DIGWMessages FAR* FAR* retval) PURE;
    STDMETHOD(get_Name)(THIS_ BSTR FAR* pName) PURE;
    STDMETHOD(put_Name)(THIS_ BSTR pName) PURE;
    STDMETHOD(get_ObjType)(THIS_ FolderTypeConstants FAR* retval) PURE;
    STDMETHOD(get_Owner)(THIS_ DIGWAddress FAR* FAR* pAddress) PURE;
    STDMETHOD(get_Parent)(THIS_ IDispatch * FAR* retval) PURE;
    STDMETHOD(get_ParentFolder)(THIS_ DIGWFolder FAR* FAR* ppParent) PURE;
    STDMETHOD(get_Query)(THIS_ DIGWQuery FAR* FAR* retval) PURE;
    STDMETHOD(FindMessages)(THIS_ VARIANT Condition, DIGWMessageList FAR* FAR* retval) PURE;
    STDMETHOD(get_Shared)(THIS_ SharedFolderConstants FAR* retval) PURE;
    STDMETHOD(get_System)(THIS_ VARIANT_BOOL FAR* fIsSystem) PURE;
    STDMETHOD(get_Fields)(THIS_ DIGWFields FAR* FAR* retval) PURE;
};

DEFINE_GUID(IID_IGWFolder2,0x4EB9D082L,0x0A80,0x11D1,0xB3,0x8B,0x00,0x80,0x5F,0x36,0xA3,0x75);

/* Definition of interface: IGWFolder2 */
#undef INTERFACE
#define INTERFACE IGWFolder2

DECLARE_INTERFACE_(IGWFolder2, IGWFolder)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IGWFolder methods */
    STDMETHOD(Delete)(THIS) PURE;
    STDMETHOD(Move)(THIS_ DIGWFolder FAR* pDestination) PURE;
    STDMETHOD(Refresh)(THIS) PURE;
    STDMETHOD(get_AllFolders)(THIS_ DIGWFolders FAR* FAR* retval) PURE;
    STDMETHOD(get_Application)(THIS_ DIGWSession FAR* FAR* retval) PURE;
    STDMETHOD(get_Description)(THIS_ BSTR FAR* bDescription) PURE;
    STDMETHOD(put_Description)(THIS_ BSTR bDescription) PURE;
    STDMETHOD(get_FolderID)(THIS_ BSTR FAR* pName) PURE;
    STDMETHOD(get_FolderRights)(THIS_ DIGWFolderRightsCollection FAR* FAR* retval) PURE;
    STDMETHOD(get_Folders)(THIS_ DIGWFolders FAR* FAR* retval) PURE;
    STDMETHOD(get_Messages)(THIS_ DIGWMessages FAR* FAR* retval) PURE;
    STDMETHOD(get_Name)(THIS_ BSTR FAR* pName) PURE;
    STDMETHOD(put_Name)(THIS_ BSTR pName) PURE;
    STDMETHOD(get_ObjType)(THIS_ FolderTypeConstants FAR* retval) PURE;
    STDMETHOD(get_Owner)(THIS_ DIGWAddress FAR* FAR* pAddress) PURE;
    STDMETHOD(get_Parent)(THIS_ IDispatch * FAR* retval) PURE;
    STDMETHOD(get_ParentFolder)(THIS_ DIGWFolder FAR* FAR* ppParent) PURE;
    STDMETHOD(get_Query)(THIS_ DIGWQuery FAR* FAR* retval) PURE;
    STDMETHOD(FindMessages)(THIS_ VARIANT Condition, DIGWMessageList FAR* FAR* retval) PURE;
    STDMETHOD(get_Shared)(THIS_ SharedFolderConstants FAR* retval) PURE;
    STDMETHOD(get_System)(THIS_ VARIANT_BOOL FAR* fIsSystem) PURE;
    STDMETHOD(get_Fields)(THIS_ DIGWFields FAR* FAR* retval) PURE;
#endif

    /* IGWFolder2 methods */
    STDMETHOD(put_Owner)(THIS_ DIGWAddress FAR* pAddress) PURE;
};

DEFINE_GUID(DIID_DIGWFolder,0x4A70F281L,0xA98E,0x11CF,0x8C,0x91,0x00,0x80,0x5F,0x6C,0x4B,0xEF);

/* Definition of dispatch interface: DIGWFolder */
#undef INTERFACE
#define INTERFACE DIGWFolder

DECLARE_INTERFACE_(DIGWFolder, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;
#endif

/* Capable of dispatching all the methods of interface IGWFolder */
};

DEFINE_GUID(DIID_DIGWFolder2,0x4A70F282L,0xA98E,0x11CF,0x8C,0x91,0x00,0x80,0x5F,0x6C,0x4B,0xEF);

/* Definition of dispatch interface: DIGWFolder2 */
#undef INTERFACE
#define INTERFACE DIGWFolder2

DECLARE_INTERFACE_(DIGWFolder2, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;
#endif

/* Capable of dispatching all the methods of interface IGWFolder2 */
};

DEFINE_GUID(CLSID_Folder,0xC89C2D55L,0x04AF,0x11CF,0xB0,0x49,0x00,0x80,0x5F,0x88,0xE6,0x02);

#ifdef __cplusplus
class Folder;
#endif

DEFINE_GUID(CLSID_Folder2,0xC89C2D5DL,0x04AF,0x11CF,0xB0,0x49,0x00,0x80,0x5F,0x88,0xE6,0x02);

#ifdef __cplusplus
class Folder2;
#endif

DEFINE_GUID(IID_IGWFolders,0xC40BC220L,0xAE2D,0x11CF,0x8C,0x91,0x00,0x80,0x5F,0x6C,0x4B,0xEF);

/* Definition of interface: IGWFolders */
#undef INTERFACE
#define INTERFACE IGWFolders

DECLARE_INTERFACE_(IGWFolders, IUnknown)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;
#endif

    /* IGWFolders methods */
    STDMETHOD(Add)(THIS_ VARIANT vrNameOrMessage, VARIANT vrName, DIGWFolder FAR* FAR* retval) PURE;
    STDMETHOD(Item)(THIS_ VARIANT vr, DIGWFolder FAR* FAR* retval) PURE;
    STDMETHOD(ItemByName)(THIS_ VARIANT vr, DIGWFolder FAR* FAR* retval) PURE;
    STDMETHOD(get_Application)(THIS_ DIGWSession FAR* FAR* retval) PURE;
    STDMETHOD(get_Count)(THIS_ long FAR* retval) PURE;
    STDMETHOD(get__NewEnum)(THIS_ IUnknown * FAR* retval) PURE;
    STDMETHOD(get_Parent)(THIS_ IDispatch * FAR* retval) PURE;
};

DEFINE_GUID(DIID_DIGWFolders,0xC40BC221L,0xAE2D,0x11CF,0x8C,0x91,0x00,0x80,0x5F,0x6C,0x4B,0xEF);

/* Definition of dispatch interface: DIGWFolders */
#undef INTERFACE
#define INTERFACE DIGWFolders

DECLARE_INTERFACE_(DIGWFolders, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;
#endif

/* Capable of dispatching all the methods of interface IGWFolders */
};

DEFINE_GUID(CLSID_Folders,0xC40BC222L,0xAE2D,0x11CF,0x8C,0x91,0x00,0x80,0x5F,0x6C,0x4B,0xEF);

#ifdef __cplusplus
class Folders;
#endif

DEFINE_GUID(IID_IGWFolderRights,0xF633D683L,0x4C2F,0x11CF,0x87,0xFD,0x00,0x80,0x5F,0xBC,0x9F,0x65);

/* Definition of interface: IGWFolderRights */
#undef INTERFACE
#define INTERFACE IGWFolderRights

DECLARE_INTERFACE_(IGWFolderRights, IUnknown)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;
#endif

    /* IGWFolderRights methods */
    STDMETHOD(Delete)(THIS) PURE;
    STDMETHOD(put_AllowAdd)(THIS_ VARIANT_BOOL Param) PURE;
    STDMETHOD(get_AllowAdd)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(get_Address)(THIS_ DIGWAddress FAR* FAR* retval) PURE;
    STDMETHOD(get_Application)(THIS_ DIGWSession FAR* FAR* retval) PURE;
    STDMETHOD(put_AllowDelete)(THIS_ VARIANT_BOOL Param) PURE;
    STDMETHOD(get_AllowDelete)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_AllowModify)(THIS_ VARIANT_BOOL Param) PURE;
    STDMETHOD(get_AllowModify)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(get_Parent)(THIS_ DIGWFolderRightsCollection FAR* FAR* retval) PURE;
    STDMETHOD(put_BitMask)(THIS_ long Param) PURE;
    STDMETHOD(get_BitMask)(THIS_ long FAR* retval) PURE;
};

DEFINE_GUID(DIID_DIGWFolderRights,0xF633D684L,0x4C2F,0x11CF,0x87,0xFD,0x00,0x80,0x5F,0xBC,0x9F,0x65);

/* Definition of dispatch interface: DIGWFolderRights */
#undef INTERFACE
#define INTERFACE DIGWFolderRights

DECLARE_INTERFACE_(DIGWFolderRights, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;
#endif

/* Capable of dispatching all the methods of interface IGWFolderRights */
};

DEFINE_GUID(CLSID_FolderRights,0xC89C2D57L,0x04AF,0x11CF,0xB0,0x49,0x00,0x80,0x5F,0x88,0xE6,0x02);

#ifdef __cplusplus
class FolderRights;
#endif

DEFINE_GUID(IID_IGWFolderRightsCollection,0xF633D680L,0x4C2F,0x11CF,0x87,0xFD,0x00,0x80,0x5F,0xBC,0x9F,0x65);

/* Definition of interface: IGWFolderRightsCollection */
#undef INTERFACE
#define INTERFACE IGWFolderRightsCollection

DECLARE_INTERFACE_(IGWFolderRightsCollection, IUnknown)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;
#endif

    /* IGWFolderRightsCollection methods */
    STDMETHOD(Add)(THIS_ VARIANT Address, long access) PURE;
    STDMETHOD(Commit)(THIS_ BSTR Subject, BSTR BodyText, VARIANT TypeCommit) PURE;
    STDMETHOD(Item)(THIS_ VARIANT index, DIGWFolderRights FAR* FAR* retval) PURE;
    STDMETHOD(get_Application)(THIS_ DIGWSession FAR* FAR* retval) PURE;
    STDMETHOD(get_Count)(THIS_ long FAR* retval) PURE;
    STDMETHOD(get__NewEnum)(THIS_ IUnknown * FAR* retval) PURE;
    STDMETHOD(get_Parent)(THIS_ DIGWFolder FAR* FAR* retval) PURE;
};

DEFINE_GUID(DIID_DIGWFolderRightsCollection,0xF633D681L,0x4C2F,0x11CF,0x87,0xFD,0x00,0x80,0x5F,0xBC,0x9F,0x65);

/* Definition of dispatch interface: DIGWFolderRightsCollection */
#undef INTERFACE
#define INTERFACE DIGWFolderRightsCollection

DECLARE_INTERFACE_(DIGWFolderRightsCollection, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;
#endif

/* Capable of dispatching all the methods of interface IGWFolderRightsCollection */
};

DEFINE_GUID(CLSID_FolderRightsCollection,0xC89C2D58L,0x04AF,0x11CF,0xB0,0x49,0x00,0x80,0x5F,0x88,0xE6,0x02);

#ifdef __cplusplus
class FolderRightsCollection;
#endif

DEFINE_GUID(IID_IGWFormattedText,0x7D2265F6L,0xE158,0x11CE,0x87,0xEB,0x00,0x80,0x5F,0xB4,0xB2,0xBE);

/* Definition of interface: IGWFormattedText */
#undef INTERFACE
#define INTERFACE IGWFormattedText

DECLARE_INTERFACE_(IGWFormattedText, IUnknown)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;
#endif

    /* IGWFormattedText methods */
    STDMETHOD(get_Application)(THIS_ DIGWSession FAR* FAR* retval) PURE;
    STDMETHOD(get_Parent)(THIS_ IDispatch * FAR* retval) PURE;
    STDMETHOD(get_PlainText)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(put_PlainText)(THIS_ BSTR Text) PURE;
    STDMETHOD(get_RTF)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(put_RTF)(THIS_ BSTR Text) PURE;
};

DEFINE_GUID(DIID_DIGWFormattedText,0x7D2265F7L,0xE158,0x11CE,0x87,0xEB,0x00,0x80,0x5F,0xB4,0xB2,0xBE);

/* Definition of dispatch interface: DIGWFormattedText */
#undef INTERFACE
#define INTERFACE DIGWFormattedText

DECLARE_INTERFACE_(DIGWFormattedText, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;
#endif

/* Capable of dispatching all the methods of interface IGWFormattedText */
};

DEFINE_GUID(IID_IGWFormattedText2,0x4B383D40L,0x411F,0x11D2,0xB4,0xF5,0x00,0x80,0x5F,0x36,0xA3,0x75);

/* Definition of interface: IGWFormattedText2 */
#undef INTERFACE
#define INTERFACE IGWFormattedText2

DECLARE_INTERFACE_(IGWFormattedText2, IGWFormattedText)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IGWFormattedText methods */
    STDMETHOD(get_Application)(THIS_ DIGWSession FAR* FAR* retval) PURE;
    STDMETHOD(get_Parent)(THIS_ IDispatch * FAR* retval) PURE;
    STDMETHOD(get_PlainText)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(put_PlainText)(THIS_ BSTR Text) PURE;
    STDMETHOD(get_RTF)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(put_RTF)(THIS_ BSTR Text) PURE;
#endif

    /* IGWFormattedText2 methods */
    STDMETHOD(get_Unicode)(THIS_ BSTR FAR* retval) PURE;
};

DEFINE_GUID(DIID_DIGWFormattedText2,0x4B383D41L,0x411F,0x11D2,0xB4,0xF5,0x00,0x80,0x5F,0x36,0xA3,0x75);

/* Definition of dispatch interface: DIGWFormattedText2 */
#undef INTERFACE
#define INTERFACE DIGWFormattedText2

DECLARE_INTERFACE_(DIGWFormattedText2, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;
#endif

/* Capable of dispatching all the methods of interface IGWFormattedText2 */
};

DEFINE_GUID(CLSID_FormattedText,0xC89C2E74L,0x04AF,0x11CF,0xB0,0x49,0x00,0x80,0x5F,0x88,0xE6,0x02);

#ifdef __cplusplus
class FormattedText;
#endif

DEFINE_GUID(CLSID_FormattedText2,0x4B383D42L,0x411F,0x11D2,0xB4,0xF5,0x00,0x80,0x5F,0x36,0xA3,0x75);

#ifdef __cplusplus
class FormattedText2;
#endif

DEFINE_GUID(IID_IGWTextHelper,0x7D2265F8L,0xE158,0x11CE,0x87,0xEB,0x00,0x80,0x5F,0xB4,0xB2,0xBE);

/* Definition of interface: IGWTextHelper */
#undef INTERFACE
#define INTERFACE IGWTextHelper

DECLARE_INTERFACE(IGWTextHelper)
{
BEGIN_INTERFACE

    /* IGWTextHelper methods */
    STDMETHOD(GetText)(THIS_ long Key, VARIANT_BOOL RTF, BSTR FAR* retval) PURE;
    STDMETHOD(PutText)(THIS_ long Key, VARIANT_BOOL RTF, BSTR Text) PURE;
    STDMETHOD(GetUnicodeText)(THIS_ long Key, BSTR FAR* retval) PURE;
};

DEFINE_GUID(IID_IGWGroupMember,0x16098583L,0xCA9E,0x11CF,0x97,0x81,0x00,0x80,0x5F,0x02,0x9A,0x88);

/* Definition of interface: IGWGroupMember */
#undef INTERFACE
#define INTERFACE IGWGroupMember

DECLARE_INTERFACE_(IGWGroupMember, IGWAddressBookEntry2)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IGWAddress methods */
    STDMETHOD(get_DisplayName)(THIS_ BSTR FAR* ppName) PURE;
    STDMETHOD(put_DisplayName)(THIS_ BSTR pName) PURE;
    STDMETHOD(get_EmailAddress)(THIS_ BSTR FAR* ppAddress) PURE;
    STDMETHOD(put_EmailAddress)(THIS_ BSTR pAddress) PURE;
    STDMETHOD(get_EmailType)(THIS_ BSTR FAR* ppType) PURE;
    STDMETHOD(put_EmailType)(THIS_ BSTR pType) PURE;
    STDMETHOD(get_ObjType)(THIS_ AddressTypeConstants FAR* pEType) PURE;
    STDMETHOD(put_ObjType)(THIS_ AddressTypeConstants etType) PURE;
    STDMETHOD(get_Application)(THIS_ DIGWSession FAR* FAR* retval) PURE;
    STDMETHOD(get_Parent)(THIS_ IDispatch * FAR* retval) PURE;

    /* IGWAddressBookEntry methods */
    STDMETHOD(Delete)(THIS) PURE;
    STDMETHOD(get_Fields)(THIS_ DIGWFields FAR* FAR* pFields) PURE;
    STDMETHOD(get_Members)(THIS_ DIGWGroupMembers FAR* FAR* pMembers) PURE;
    STDMETHOD(Refresh)(THIS) PURE;

    /* IGWAddressBookEntry2 methods */
    STDMETHOD(get_MasterRevisionNumber)(THIS_ long FAR* retval) PURE;
    STDMETHOD(get_RevisionNumber)(THIS_ long FAR* retval) PURE;
#endif

    /* IGWGroupMember methods */
    STDMETHOD(get_TargetType)(THIS_ AddressTargetTypeConstants FAR* retval) PURE;
};

DEFINE_GUID(DIID_DIGWGroupMember,0x16098584L,0xCA9E,0x11CF,0x97,0x81,0x00,0x80,0x5F,0x02,0x9A,0x88);

/* Definition of dispatch interface: DIGWGroupMember */
#undef INTERFACE
#define INTERFACE DIGWGroupMember

DECLARE_INTERFACE_(DIGWGroupMember, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;
#endif

/* Capable of dispatching all the methods of interface IGWGroupMember */
};

DEFINE_GUID(CLSID_GroupMember,0x7771EF01L,0xCA9F,0x11CF,0x97,0x81,0x00,0x80,0x5F,0x02,0x9A,0x88);

#ifdef __cplusplus
class GroupMember;
#endif

DEFINE_GUID(IID_IGWGroupMembers,0x16098580L,0xCA9E,0x11CF,0x97,0x81,0x00,0x80,0x5F,0x02,0x9A,0x88);

/* Definition of interface: IGWGroupMembers */
#undef INTERFACE
#define INTERFACE IGWGroupMembers

DECLARE_INTERFACE_(IGWGroupMembers, IUnknown)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;
#endif

    /* IGWGroupMembers methods */
    STDMETHOD(Add)(THIS_ VARIANT ABEntry, VARIANT vTargetType) PURE;
    STDMETHOD(Item)(THIS_ VARIANT Index, DIGWGroupMember FAR* FAR* retval) PURE;
    STDMETHOD(get_Count)(THIS_ long FAR* retval) PURE;
    STDMETHOD(get__NewEnum)(THIS_ IUnknown * FAR* retval) PURE;
    STDMETHOD(get_Application)(THIS_ DIGWSession FAR* FAR* retval) PURE;
    STDMETHOD(get_Parent)(THIS_ DIGWAddressBookEntry FAR* FAR* retval) PURE;
};

DEFINE_GUID(DIID_DIGWGroupMembers,0x16098581L,0xCA9E,0x11CF,0x97,0x81,0x00,0x80,0x5F,0x02,0x9A,0x88);

/* Definition of dispatch interface: DIGWGroupMembers */
#undef INTERFACE
#define INTERFACE DIGWGroupMembers

DECLARE_INTERFACE_(DIGWGroupMembers, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;
#endif

/* Capable of dispatching all the methods of interface IGWGroupMembers */
};

DEFINE_GUID(CLSID_GroupMembers,0x7771EF00L,0xCA9F,0x11CF,0x97,0x81,0x00,0x80,0x5F,0x02,0x9A,0x88);

#ifdef __cplusplus
class GroupMembers;
#endif

DEFINE_GUID(IID_IGWLocations,0xA77D4020L,0x6099,0x11CF,0xAF,0xA5,0x00,0x60,0x8C,0x79,0xBC,0x42);

/* Definition of interface: IGWLocations */
#undef INTERFACE
#define INTERFACE IGWLocations

DECLARE_INTERFACE_(IGWLocations, IUnknown)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;
#endif

    /* IGWLocations methods */
    STDMETHOD(Item)(THIS_ long lIndex, IDispatch * FAR* retval) PURE;
    STDMETHOD(Add)(THIS_ VARIANT vrObject) PURE;
    STDMETHOD(Remove)(THIS_ long lIndex) PURE;
    STDMETHOD(get_Count)(THIS_ long FAR* retval) PURE;
    STDMETHOD(get__NewEnum)(THIS_ IUnknown * FAR* retval) PURE;
    STDMETHOD(get_Parent)(THIS_ IDispatch * FAR* retval) PURE;
    STDMETHOD(get_Application)(THIS_ DIGWSession FAR* FAR* retval) PURE;
};

DEFINE_GUID(DIID_DIGWLocations,0xA77D4021L,0x6099,0x11CF,0xAF,0xA5,0x00,0x60,0x8C,0x79,0xBC,0x42);

/* Definition of dispatch interface: DIGWLocations */
#undef INTERFACE
#define INTERFACE DIGWLocations

DECLARE_INTERFACE_(DIGWLocations, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;
#endif

/* Capable of dispatching all the methods of interface IGWLocations */
};

DEFINE_GUID(CLSID_Locations,0xC89C2D59L,0x04AF,0x11CF,0xB0,0x49,0x00,0x80,0x5F,0x88,0xE6,0x02);

#ifdef __cplusplus
class Locations;
#endif

DEFINE_GUID(IID_IGWMail,0x7D2265E6L,0xE158,0x11CE,0x87,0xEB,0x00,0x80,0x5F,0xB4,0xB2,0xBE);

/* Definition of interface: IGWMail */
#undef INTERFACE
#define INTERFACE IGWMail

DECLARE_INTERFACE_(IGWMail, IGWMessage)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IGWMessage methods */
    STDMETHOD(get_Application)(THIS_ DIGWSession FAR* FAR* retval) PURE;
    STDMETHOD(get_Attachments)(THIS_ DIGWAttachments FAR* FAR* retval) PURE;
    STDMETHOD(get_BodyText)(THIS_ DIGWFormattedText FAR* FAR* retval) PURE;
    STDMETHOD(get_BoxType)(THIS_ MessageBoxTypeConstants FAR* retval) PURE;
    STDMETHOD(get_ClassName)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(put_ClassName)(THIS_ BSTR pClass) PURE;
    STDMETHOD(get_ConvertAttachments)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_ConvertAttachments)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_CreationDate)(THIS_ DATE FAR* retval) PURE;
    STDMETHOD(get_Deleted)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(get_DownloadStatus)(THIS_ DIGWDownloadStatus FAR* FAR* retval) PURE;
    STDMETHOD(get_EnclosingFolders)(THIS_ DIGWFolders FAR* FAR* retval) PURE;
    STDMETHOD(get_ExpandedRecipients)(THIS_ DIGWRecipients FAR* FAR* retval) PURE;
    STDMETHOD(get_Fields)(THIS_ DIGWFields FAR* FAR* retval) PURE;
    STDMETHOD(get_FromText)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(put_FromText)(THIS_ BSTR Text) PURE;
    STDMETHOD(get_Hidden)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Hidden)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_MessageID)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(get_NotifyWhenDeleted)(THIS_ NotifyMessageConstants FAR* retval) PURE;
    STDMETHOD(put_NotifyWhenDeleted)(THIS_ NotifyMessageConstants How) PURE;
    STDMETHOD(get_NotifyWhenOpened)(THIS_ NotifyMessageConstants FAR* retval) PURE;
    STDMETHOD(put_NotifyWhenOpened)(THIS_ NotifyMessageConstants How) PURE;
    STDMETHOD(get_Opened)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Opened)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_Parent)(THIS_ DIGWAccount FAR* FAR* retval) PURE;
    STDMETHOD(get_Priority)(THIS_ MessagePriorityConstants FAR* retval) PURE;
    STDMETHOD(put_Priority)(THIS_ MessagePriorityConstants Priority) PURE;
    STDMETHOD(get_Read)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Read)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_Recipients)(THIS_ DIGWRecipients FAR* FAR* retval) PURE;
    STDMETHOD(get_ReplyChildren)(THIS_ DIGWMessageList FAR* FAR* retval) PURE;
    STDMETHOD(get_ReplyDaysRequested)(THIS_ int FAR* retval) PURE;
    STDMETHOD(put_ReplyDaysRequested)(THIS_ int Days) PURE;
    STDMETHOD(get_ReplyParent)(THIS_ DIGWMessage FAR* FAR* retval) PURE;
    STDMETHOD(get_ReplyRequested)(THIS_ ReplyRequestedConstants FAR* retval) PURE;
    STDMETHOD(put_ReplyRequested)(THIS_ ReplyRequestedConstants When) PURE;
    STDMETHOD(get_ReplyRoot)(THIS_ DIGWMessage FAR* FAR* retval) PURE;
    STDMETHOD(get_Routed)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Routed)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_RoutingEndOfLine)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(get_Sender)(THIS_ DIGWAddress FAR* FAR* retval) PURE;
    STDMETHOD(get_Subject)(THIS_ DIGWFormattedText FAR* FAR* retval) PURE;
    STDMETHOD(get_ViewName)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(put_ViewName)(THIS_ BSTR pClass) PURE;
    STDMETHOD(Annotate)(THIS_ DIGWNote2 FAR* Note) PURE;
    STDMETHOD(Clone)(THIS_ DIGWMessage FAR* FAR* retval) PURE;
    STDMETHOD(Delete)(THIS) PURE;
    STDMETHOD(Forward)(THIS_ DIGWMail FAR* FAR* retval) PURE;
    STDMETHOD(Refresh)(THIS) PURE;
    STDMETHOD(Reply)(THIS_ VARIANT ClassName, VARIANT ReplyToAll, VARIANT IncludeSenderMessageText, VARIANT AttachOriginalMessage, DIGWMessage FAR* FAR* retval) PURE;
    STDMETHOD(Retract)(THIS) PURE;
    STDMETHOD(Send)(THIS_ DIGWMessage FAR* FAR* retval) PURE;
#endif

    /* IGWMail methods */
    STDMETHOD(get_Completed)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Completed)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_Delegated)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(get_NotifyWhenCompleted)(THIS_ NotifyMessageConstants FAR* retval) PURE;
    STDMETHOD(put_NotifyWhenCompleted)(THIS_ NotifyMessageConstants How) PURE;
    STDMETHOD(Delegate)(THIS_ DIGWMail FAR* FAR* retval) PURE;
};

DEFINE_GUID(DIID_DIGWMail,0x7D2265E7L,0xE158,0x11CE,0x87,0xEB,0x00,0x80,0x5F,0xB4,0xB2,0xBE);

/* Definition of dispatch interface: DIGWMail */
#undef INTERFACE
#define INTERFACE DIGWMail

DECLARE_INTERFACE_(DIGWMail, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;
#endif

/* Capable of dispatching all the methods of interface IGWMail */
};

DEFINE_GUID(IID_IGWMail2,0x7D2267E6L,0xE158,0x11CE,0x87,0xEB,0x00,0x80,0x5F,0xB4,0xB2,0xBE);

/* Definition of interface: IGWMail2 */
#undef INTERFACE
#define INTERFACE IGWMail2

DECLARE_INTERFACE_(IGWMail2, IGWMessage2)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IGWMessage methods */
    STDMETHOD(get_Application)(THIS_ DIGWSession FAR* FAR* retval) PURE;
    STDMETHOD(get_Attachments)(THIS_ DIGWAttachments FAR* FAR* retval) PURE;
    STDMETHOD(get_BodyText)(THIS_ DIGWFormattedText FAR* FAR* retval) PURE;
    STDMETHOD(get_BoxType)(THIS_ MessageBoxTypeConstants FAR* retval) PURE;
    STDMETHOD(get_ClassName)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(put_ClassName)(THIS_ BSTR pClass) PURE;
    STDMETHOD(get_ConvertAttachments)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_ConvertAttachments)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_CreationDate)(THIS_ DATE FAR* retval) PURE;
    STDMETHOD(get_Deleted)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(get_DownloadStatus)(THIS_ DIGWDownloadStatus FAR* FAR* retval) PURE;
    STDMETHOD(get_EnclosingFolders)(THIS_ DIGWFolders FAR* FAR* retval) PURE;
    STDMETHOD(get_ExpandedRecipients)(THIS_ DIGWRecipients FAR* FAR* retval) PURE;
    STDMETHOD(get_Fields)(THIS_ DIGWFields FAR* FAR* retval) PURE;
    STDMETHOD(get_FromText)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(put_FromText)(THIS_ BSTR Text) PURE;
    STDMETHOD(get_Hidden)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Hidden)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_MessageID)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(get_NotifyWhenDeleted)(THIS_ NotifyMessageConstants FAR* retval) PURE;
    STDMETHOD(put_NotifyWhenDeleted)(THIS_ NotifyMessageConstants How) PURE;
    STDMETHOD(get_NotifyWhenOpened)(THIS_ NotifyMessageConstants FAR* retval) PURE;
    STDMETHOD(put_NotifyWhenOpened)(THIS_ NotifyMessageConstants How) PURE;
    STDMETHOD(get_Opened)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Opened)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_Parent)(THIS_ DIGWAccount FAR* FAR* retval) PURE;
    STDMETHOD(get_Priority)(THIS_ MessagePriorityConstants FAR* retval) PURE;
    STDMETHOD(put_Priority)(THIS_ MessagePriorityConstants Priority) PURE;
    STDMETHOD(get_Read)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Read)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_Recipients)(THIS_ DIGWRecipients FAR* FAR* retval) PURE;
    STDMETHOD(get_ReplyChildren)(THIS_ DIGWMessageList FAR* FAR* retval) PURE;
    STDMETHOD(get_ReplyDaysRequested)(THIS_ int FAR* retval) PURE;
    STDMETHOD(put_ReplyDaysRequested)(THIS_ int Days) PURE;
    STDMETHOD(get_ReplyParent)(THIS_ DIGWMessage FAR* FAR* retval) PURE;
    STDMETHOD(get_ReplyRequested)(THIS_ ReplyRequestedConstants FAR* retval) PURE;
    STDMETHOD(put_ReplyRequested)(THIS_ ReplyRequestedConstants When) PURE;
    STDMETHOD(get_ReplyRoot)(THIS_ DIGWMessage FAR* FAR* retval) PURE;
    STDMETHOD(get_Routed)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Routed)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_RoutingEndOfLine)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(get_Sender)(THIS_ DIGWAddress FAR* FAR* retval) PURE;
    STDMETHOD(get_Subject)(THIS_ DIGWFormattedText FAR* FAR* retval) PURE;
    STDMETHOD(get_ViewName)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(put_ViewName)(THIS_ BSTR pClass) PURE;
    STDMETHOD(Annotate)(THIS_ DIGWNote2 FAR* Note) PURE;
    STDMETHOD(Clone)(THIS_ DIGWMessage FAR* FAR* retval) PURE;
    STDMETHOD(Delete)(THIS) PURE;
    STDMETHOD(Forward)(THIS_ DIGWMail FAR* FAR* retval) PURE;
    STDMETHOD(Refresh)(THIS) PURE;
    STDMETHOD(Reply)(THIS_ VARIANT ClassName, VARIANT ReplyToAll, VARIANT IncludeSenderMessageText, VARIANT AttachOriginalMessage, DIGWMessage FAR* FAR* retval) PURE;
    STDMETHOD(Retract)(THIS) PURE;
    STDMETHOD(Send)(THIS_ DIGWMessage FAR* FAR* retval) PURE;

    /* IGWMessage2 methods */
    STDMETHOD(get_ModifiedDate)(THIS_ DATE FAR* retval) PURE;
    STDMETHOD(get_Private)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Private)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_RevisionNumber)(THIS_ long FAR* retval) PURE;
    STDMETHOD(get_MasterRevisionNumber)(THIS_ long FAR* retval) PURE;
#endif

    /* IGWMail2 methods */
    STDMETHOD(get_Completed)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Completed)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_Delegated)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(get_NotifyWhenCompleted)(THIS_ NotifyMessageConstants FAR* retval) PURE;
    STDMETHOD(put_NotifyWhenCompleted)(THIS_ NotifyMessageConstants How) PURE;
    STDMETHOD(Delegate)(THIS_ DIGWMail FAR* FAR* retval) PURE;
};

DEFINE_GUID(IID_IGWMail3,0x481ED626L,0x4EFF,0x11D1,0x8D,0x79,0x00,0x80,0x5F,0xC1,0x28,0xBA);

/* Definition of interface: IGWMail3 */
#undef INTERFACE
#define INTERFACE IGWMail3

DECLARE_INTERFACE_(IGWMail3, IGWMessage2)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IGWMessage methods */
    STDMETHOD(get_Application)(THIS_ DIGWSession FAR* FAR* retval) PURE;
    STDMETHOD(get_Attachments)(THIS_ DIGWAttachments FAR* FAR* retval) PURE;
    STDMETHOD(get_BodyText)(THIS_ DIGWFormattedText FAR* FAR* retval) PURE;
    STDMETHOD(get_BoxType)(THIS_ MessageBoxTypeConstants FAR* retval) PURE;
    STDMETHOD(get_ClassName)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(put_ClassName)(THIS_ BSTR pClass) PURE;
    STDMETHOD(get_ConvertAttachments)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_ConvertAttachments)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_CreationDate)(THIS_ DATE FAR* retval) PURE;
    STDMETHOD(get_Deleted)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(get_DownloadStatus)(THIS_ DIGWDownloadStatus FAR* FAR* retval) PURE;
    STDMETHOD(get_EnclosingFolders)(THIS_ DIGWFolders FAR* FAR* retval) PURE;
    STDMETHOD(get_ExpandedRecipients)(THIS_ DIGWRecipients FAR* FAR* retval) PURE;
    STDMETHOD(get_Fields)(THIS_ DIGWFields FAR* FAR* retval) PURE;
    STDMETHOD(get_FromText)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(put_FromText)(THIS_ BSTR Text) PURE;
    STDMETHOD(get_Hidden)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Hidden)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_MessageID)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(get_NotifyWhenDeleted)(THIS_ NotifyMessageConstants FAR* retval) PURE;
    STDMETHOD(put_NotifyWhenDeleted)(THIS_ NotifyMessageConstants How) PURE;
    STDMETHOD(get_NotifyWhenOpened)(THIS_ NotifyMessageConstants FAR* retval) PURE;
    STDMETHOD(put_NotifyWhenOpened)(THIS_ NotifyMessageConstants How) PURE;
    STDMETHOD(get_Opened)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Opened)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_Parent)(THIS_ DIGWAccount FAR* FAR* retval) PURE;
    STDMETHOD(get_Priority)(THIS_ MessagePriorityConstants FAR* retval) PURE;
    STDMETHOD(put_Priority)(THIS_ MessagePriorityConstants Priority) PURE;
    STDMETHOD(get_Read)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Read)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_Recipients)(THIS_ DIGWRecipients FAR* FAR* retval) PURE;
    STDMETHOD(get_ReplyChildren)(THIS_ DIGWMessageList FAR* FAR* retval) PURE;
    STDMETHOD(get_ReplyDaysRequested)(THIS_ int FAR* retval) PURE;
    STDMETHOD(put_ReplyDaysRequested)(THIS_ int Days) PURE;
    STDMETHOD(get_ReplyParent)(THIS_ DIGWMessage FAR* FAR* retval) PURE;
    STDMETHOD(get_ReplyRequested)(THIS_ ReplyRequestedConstants FAR* retval) PURE;
    STDMETHOD(put_ReplyRequested)(THIS_ ReplyRequestedConstants When) PURE;
    STDMETHOD(get_ReplyRoot)(THIS_ DIGWMessage FAR* FAR* retval) PURE;
    STDMETHOD(get_Routed)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Routed)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_RoutingEndOfLine)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(get_Sender)(THIS_ DIGWAddress FAR* FAR* retval) PURE;
    STDMETHOD(get_Subject)(THIS_ DIGWFormattedText FAR* FAR* retval) PURE;
    STDMETHOD(get_ViewName)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(put_ViewName)(THIS_ BSTR pClass) PURE;
    STDMETHOD(Annotate)(THIS_ DIGWNote2 FAR* Note) PURE;
    STDMETHOD(Clone)(THIS_ DIGWMessage FAR* FAR* retval) PURE;
    STDMETHOD(Delete)(THIS) PURE;
    STDMETHOD(Forward)(THIS_ DIGWMail FAR* FAR* retval) PURE;
    STDMETHOD(Refresh)(THIS) PURE;
    STDMETHOD(Reply)(THIS_ VARIANT ClassName, VARIANT ReplyToAll, VARIANT IncludeSenderMessageText, VARIANT AttachOriginalMessage, DIGWMessage FAR* FAR* retval) PURE;
    STDMETHOD(Retract)(THIS) PURE;
    STDMETHOD(Send)(THIS_ DIGWMessage FAR* FAR* retval) PURE;

    /* IGWMessage2 methods */
    STDMETHOD(get_ModifiedDate)(THIS_ DATE FAR* retval) PURE;
    STDMETHOD(get_Private)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Private)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_RevisionNumber)(THIS_ long FAR* retval) PURE;
    STDMETHOD(get_MasterRevisionNumber)(THIS_ long FAR* retval) PURE;
#endif

    /* IGWMail3 methods */
    STDMETHOD(get_Completed)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Completed)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_Delegated)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(get_NotifyWhenCompleted)(THIS_ NotifyMessageConstants FAR* retval) PURE;
    STDMETHOD(put_NotifyWhenCompleted)(THIS_ NotifyMessageConstants How) PURE;
    STDMETHOD(Delegate)(THIS_ DIGWMail FAR* FAR* retval) PURE;
    STDMETHOD(get_Archived)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Archived)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_Sharer)(THIS_ DIGWAddress FAR* FAR* retval) PURE;
    STDMETHOD(LocalDelete)(THIS) PURE;
};

DEFINE_GUID(DIID_DIGWMail2,0x7D2267E7L,0xE158,0x11CE,0x87,0xEB,0x00,0x80,0x5F,0xB4,0xB2,0xBE);

/* Definition of dispatch interface: DIGWMail2 */
#undef INTERFACE
#define INTERFACE DIGWMail2

DECLARE_INTERFACE_(DIGWMail2, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;
#endif

/* Capable of dispatching all the methods of interface IGWMail2 */
};

DEFINE_GUID(DIID_DIGWMail3,0x7D2267EDL,0xE158,0x11CE,0x87,0xEB,0x00,0x80,0x5F,0xB4,0xB2,0xBE);

/* Definition of dispatch interface: DIGWMail3 */
#undef INTERFACE
#define INTERFACE DIGWMail3

DECLARE_INTERFACE_(DIGWMail3, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;
#endif

/* Capable of dispatching all the methods of interface IGWMail3 */
};

DEFINE_GUID(CLSID_Mail,0xC89C2E60L,0x04AF,0x11CF,0xB0,0x49,0x00,0x80,0x5F,0x88,0xE6,0x02);

#ifdef __cplusplus
class Mail;
#endif

DEFINE_GUID(CLSID_Mail2,0xC89C2E69L,0x04AF,0x11CF,0xB0,0x49,0x00,0x80,0x5F,0x88,0xE6,0x02);

#ifdef __cplusplus
class Mail2;
#endif

DEFINE_GUID(CLSID_Mail3,0x14BC3A8AL,0xF4CA,0x11D1,0x8D,0x8F,0x00,0x80,0x5F,0xC1,0x00,0xD4);

#ifdef __cplusplus
class Mail3;
#endif

DEFINE_GUID(IID_IGWMessages,0x7D2267E2L,0xE158,0x11CE,0x87,0xEB,0x00,0x80,0x5F,0xB4,0xB2,0xBE);

/* Definition of interface: IGWMessages */
#undef INTERFACE
#define INTERFACE IGWMessages

DECLARE_INTERFACE_(IGWMessages, IUnknown)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;
#endif

    /* IGWMessages methods */
    STDMETHOD(get_Application)(THIS_ DIGWSession FAR* FAR* retval) PURE;
    STDMETHOD(get_Count)(THIS_ long FAR* retval) PURE;
    STDMETHOD(get__NewEnum)(THIS_ IUnknown * FAR* retval) PURE;
    STDMETHOD(get_Parent)(THIS_ IDispatch * FAR* retval) PURE;
    STDMETHOD(Add)(THIS_ VARIANT Class, VARIANT Type, VARIANT Version, DIGWMessage FAR* FAR* retval) PURE;
    STDMETHOD(Find)(THIS_ VARIANT Condition, DIGWMessageList FAR* FAR* retval) PURE;
    STDMETHOD(Item)(THIS_ VARIANT Identifier, DIGWMessage FAR* FAR* retval) PURE;
    STDMETHOD(Move)(THIS_ VARIANT Identifier, DIGWMessages FAR* Message, DIGWMessage FAR* FAR* retval) PURE;
    STDMETHOD(Remove)(THIS_ VARIANT Identifier) PURE;
};

DEFINE_GUID(DIID_DIGWMessages,0x7D2265E3L,0xE158,0x11CE,0x87,0xEB,0x00,0x80,0x5F,0xB4,0xB2,0xBE);

/* Definition of dispatch interface: DIGWMessages */
#undef INTERFACE
#define INTERFACE DIGWMessages

DECLARE_INTERFACE_(DIGWMessages, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;
#endif

/* Capable of dispatching all the methods of interface IGWMessages */
};

DEFINE_GUID(CLSID_Messages,0xC89C2E62L,0x04AF,0x11CF,0xB0,0x49,0x00,0x80,0x5F,0x88,0xE6,0x02);

#ifdef __cplusplus
class Messages;
#endif

DEFINE_GUID(IID_IGWMessageList,0x7D2266F0L,0xE158,0x11CE,0x87,0xEB,0x00,0x80,0x5F,0xB4,0xB2,0xBE);

/* Definition of interface: IGWMessageList */
#undef INTERFACE
#define INTERFACE IGWMessageList

DECLARE_INTERFACE_(IGWMessageList, IUnknown)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;
#endif

    /* IGWMessageList methods */
    STDMETHOD(get_Application)(THIS_ DIGWSession FAR* FAR* retval) PURE;
    STDMETHOD(get_Count)(THIS_ long FAR* retval) PURE;
    STDMETHOD(get__NewEnum)(THIS_ IUnknown * FAR* retval) PURE;
    STDMETHOD(get_Parent)(THIS_ DIGWSession FAR* FAR* retval) PURE;
    STDMETHOD(Add)(THIS_ VARIANT Message) PURE;
    STDMETHOD(Find)(THIS_ VARIANT Condition, DIGWMessageList FAR* FAR* retval) PURE;
    STDMETHOD(Item)(THIS_ VARIANT Identifier, DIGWMessage FAR* FAR* retval) PURE;
    STDMETHOD(Remove)(THIS_ VARIANT Identifier) PURE;
};

DEFINE_GUID(DIID_DIGWMessageList,0x7D2266F1L,0xE158,0x11CE,0x87,0xEB,0x00,0x80,0x5F,0xB4,0xB2,0xBE);

/* Definition of dispatch interface: DIGWMessageList */
#undef INTERFACE
#define INTERFACE DIGWMessageList

DECLARE_INTERFACE_(DIGWMessageList, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;
#endif

/* Capable of dispatching all the methods of interface IGWMessageList */
};

DEFINE_GUID(CLSID_MessageList,0xC89C2F63L,0x04AF,0x11CF,0xB0,0x49,0x00,0x80,0x5F,0x88,0xE6,0x02);

#ifdef __cplusplus
class MessageList;
#endif

DEFINE_GUID(IID_IGWNote,0x7D2268E8L,0xE158,0x11CE,0x87,0xEB,0x00,0x80,0x5F,0xB4,0xB2,0xBE);

/* Definition of interface: IGWNote */
#undef INTERFACE
#define INTERFACE IGWNote

DECLARE_INTERFACE_(IGWNote, IGWMessage)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IGWMessage methods */
    STDMETHOD(get_Application)(THIS_ DIGWSession FAR* FAR* retval) PURE;
    STDMETHOD(get_Attachments)(THIS_ DIGWAttachments FAR* FAR* retval) PURE;
    STDMETHOD(get_BodyText)(THIS_ DIGWFormattedText FAR* FAR* retval) PURE;
    STDMETHOD(get_BoxType)(THIS_ MessageBoxTypeConstants FAR* retval) PURE;
    STDMETHOD(get_ClassName)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(put_ClassName)(THIS_ BSTR pClass) PURE;
    STDMETHOD(get_ConvertAttachments)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_ConvertAttachments)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_CreationDate)(THIS_ DATE FAR* retval) PURE;
    STDMETHOD(get_Deleted)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(get_DownloadStatus)(THIS_ DIGWDownloadStatus FAR* FAR* retval) PURE;
    STDMETHOD(get_EnclosingFolders)(THIS_ DIGWFolders FAR* FAR* retval) PURE;
    STDMETHOD(get_ExpandedRecipients)(THIS_ DIGWRecipients FAR* FAR* retval) PURE;
    STDMETHOD(get_Fields)(THIS_ DIGWFields FAR* FAR* retval) PURE;
    STDMETHOD(get_FromText)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(put_FromText)(THIS_ BSTR Text) PURE;
    STDMETHOD(get_Hidden)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Hidden)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_MessageID)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(get_NotifyWhenDeleted)(THIS_ NotifyMessageConstants FAR* retval) PURE;
    STDMETHOD(put_NotifyWhenDeleted)(THIS_ NotifyMessageConstants How) PURE;
    STDMETHOD(get_NotifyWhenOpened)(THIS_ NotifyMessageConstants FAR* retval) PURE;
    STDMETHOD(put_NotifyWhenOpened)(THIS_ NotifyMessageConstants How) PURE;
    STDMETHOD(get_Opened)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Opened)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_Parent)(THIS_ DIGWAccount FAR* FAR* retval) PURE;
    STDMETHOD(get_Priority)(THIS_ MessagePriorityConstants FAR* retval) PURE;
    STDMETHOD(put_Priority)(THIS_ MessagePriorityConstants Priority) PURE;
    STDMETHOD(get_Read)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Read)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_Recipients)(THIS_ DIGWRecipients FAR* FAR* retval) PURE;
    STDMETHOD(get_ReplyChildren)(THIS_ DIGWMessageList FAR* FAR* retval) PURE;
    STDMETHOD(get_ReplyDaysRequested)(THIS_ int FAR* retval) PURE;
    STDMETHOD(put_ReplyDaysRequested)(THIS_ int Days) PURE;
    STDMETHOD(get_ReplyParent)(THIS_ DIGWMessage FAR* FAR* retval) PURE;
    STDMETHOD(get_ReplyRequested)(THIS_ ReplyRequestedConstants FAR* retval) PURE;
    STDMETHOD(put_ReplyRequested)(THIS_ ReplyRequestedConstants When) PURE;
    STDMETHOD(get_ReplyRoot)(THIS_ DIGWMessage FAR* FAR* retval) PURE;
    STDMETHOD(get_Routed)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Routed)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_RoutingEndOfLine)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(get_Sender)(THIS_ DIGWAddress FAR* FAR* retval) PURE;
    STDMETHOD(get_Subject)(THIS_ DIGWFormattedText FAR* FAR* retval) PURE;
    STDMETHOD(get_ViewName)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(put_ViewName)(THIS_ BSTR pClass) PURE;
    STDMETHOD(Annotate)(THIS_ DIGWNote2 FAR* Note) PURE;
    STDMETHOD(Clone)(THIS_ DIGWMessage FAR* FAR* retval) PURE;
    STDMETHOD(Delete)(THIS) PURE;
    STDMETHOD(Forward)(THIS_ DIGWMail FAR* FAR* retval) PURE;
    STDMETHOD(Refresh)(THIS) PURE;
    STDMETHOD(Reply)(THIS_ VARIANT ClassName, VARIANT ReplyToAll, VARIANT IncludeSenderMessageText, VARIANT AttachOriginalMessage, DIGWMessage FAR* FAR* retval) PURE;
    STDMETHOD(Retract)(THIS) PURE;
    STDMETHOD(Send)(THIS_ DIGWMessage FAR* FAR* retval) PURE;
#endif

    /* IGWNote methods */
    STDMETHOD(get_Accepted)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(get_Autodate)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(get_AutodateMessages)(THIS_ DIGWMessageList FAR* FAR* retval) PURE;
    STDMETHOD(get_Completed)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Completed)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_Delegated)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(get_NotifyWhenCompleted)(THIS_ NotifyMessageConstants FAR* retval) PURE;
    STDMETHOD(put_NotifyWhenCompleted)(THIS_ NotifyMessageConstants How) PURE;
    STDMETHOD(get_OnCalendar)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_OnCalendar)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_Personal)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(get_StartDate)(THIS_ DATE FAR* retval) PURE;
    STDMETHOD(put_StartDate)(THIS_ DATE Date) PURE;
    STDMETHOD(Accept)(THIS_ VARIANT Comment, VARIANT AllInstances) PURE;
    STDMETHOD(Decline)(THIS_ VARIANT Comment, VARIANT AllInstances) PURE;
    STDMETHOD(Delegate)(THIS_ VARIANT AllInstances, DIGWNote2 FAR* FAR* retval) PURE;
};

DEFINE_GUID(DIID_DIGWNote,0x7D2268E9L,0xE158,0x11CE,0x87,0xEB,0x00,0x80,0x5F,0xB4,0xB2,0xBE);

/* Definition of dispatch interface: DIGWNote */
#undef INTERFACE
#define INTERFACE DIGWNote

DECLARE_INTERFACE_(DIGWNote, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;
#endif

/* Capable of dispatching all the methods of interface IGWNote */
};

DEFINE_GUID(IID_IGWNote_m2,0x7D2269E8L,0xE158,0x11CE,0x87,0xEB,0x00,0x80,0x5F,0xB4,0xB2,0xBE);

/* Definition of interface: IGWNote_m2 */
#undef INTERFACE
#define INTERFACE IGWNote_m2

DECLARE_INTERFACE_(IGWNote_m2, IGWMessage2)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IGWMessage methods */
    STDMETHOD(get_Application)(THIS_ DIGWSession FAR* FAR* retval) PURE;
    STDMETHOD(get_Attachments)(THIS_ DIGWAttachments FAR* FAR* retval) PURE;
    STDMETHOD(get_BodyText)(THIS_ DIGWFormattedText FAR* FAR* retval) PURE;
    STDMETHOD(get_BoxType)(THIS_ MessageBoxTypeConstants FAR* retval) PURE;
    STDMETHOD(get_ClassName)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(put_ClassName)(THIS_ BSTR pClass) PURE;
    STDMETHOD(get_ConvertAttachments)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_ConvertAttachments)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_CreationDate)(THIS_ DATE FAR* retval) PURE;
    STDMETHOD(get_Deleted)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(get_DownloadStatus)(THIS_ DIGWDownloadStatus FAR* FAR* retval) PURE;
    STDMETHOD(get_EnclosingFolders)(THIS_ DIGWFolders FAR* FAR* retval) PURE;
    STDMETHOD(get_ExpandedRecipients)(THIS_ DIGWRecipients FAR* FAR* retval) PURE;
    STDMETHOD(get_Fields)(THIS_ DIGWFields FAR* FAR* retval) PURE;
    STDMETHOD(get_FromText)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(put_FromText)(THIS_ BSTR Text) PURE;
    STDMETHOD(get_Hidden)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Hidden)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_MessageID)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(get_NotifyWhenDeleted)(THIS_ NotifyMessageConstants FAR* retval) PURE;
    STDMETHOD(put_NotifyWhenDeleted)(THIS_ NotifyMessageConstants How) PURE;
    STDMETHOD(get_NotifyWhenOpened)(THIS_ NotifyMessageConstants FAR* retval) PURE;
    STDMETHOD(put_NotifyWhenOpened)(THIS_ NotifyMessageConstants How) PURE;
    STDMETHOD(get_Opened)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Opened)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_Parent)(THIS_ DIGWAccount FAR* FAR* retval) PURE;
    STDMETHOD(get_Priority)(THIS_ MessagePriorityConstants FAR* retval) PURE;
    STDMETHOD(put_Priority)(THIS_ MessagePriorityConstants Priority) PURE;
    STDMETHOD(get_Read)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Read)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_Recipients)(THIS_ DIGWRecipients FAR* FAR* retval) PURE;
    STDMETHOD(get_ReplyChildren)(THIS_ DIGWMessageList FAR* FAR* retval) PURE;
    STDMETHOD(get_ReplyDaysRequested)(THIS_ int FAR* retval) PURE;
    STDMETHOD(put_ReplyDaysRequested)(THIS_ int Days) PURE;
    STDMETHOD(get_ReplyParent)(THIS_ DIGWMessage FAR* FAR* retval) PURE;
    STDMETHOD(get_ReplyRequested)(THIS_ ReplyRequestedConstants FAR* retval) PURE;
    STDMETHOD(put_ReplyRequested)(THIS_ ReplyRequestedConstants When) PURE;
    STDMETHOD(get_ReplyRoot)(THIS_ DIGWMessage FAR* FAR* retval) PURE;
    STDMETHOD(get_Routed)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Routed)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_RoutingEndOfLine)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(get_Sender)(THIS_ DIGWAddress FAR* FAR* retval) PURE;
    STDMETHOD(get_Subject)(THIS_ DIGWFormattedText FAR* FAR* retval) PURE;
    STDMETHOD(get_ViewName)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(put_ViewName)(THIS_ BSTR pClass) PURE;
    STDMETHOD(Annotate)(THIS_ DIGWNote2 FAR* Note) PURE;
    STDMETHOD(Clone)(THIS_ DIGWMessage FAR* FAR* retval) PURE;
    STDMETHOD(Delete)(THIS) PURE;
    STDMETHOD(Forward)(THIS_ DIGWMail FAR* FAR* retval) PURE;
    STDMETHOD(Refresh)(THIS) PURE;
    STDMETHOD(Reply)(THIS_ VARIANT ClassName, VARIANT ReplyToAll, VARIANT IncludeSenderMessageText, VARIANT AttachOriginalMessage, DIGWMessage FAR* FAR* retval) PURE;
    STDMETHOD(Retract)(THIS) PURE;
    STDMETHOD(Send)(THIS_ DIGWMessage FAR* FAR* retval) PURE;

    /* IGWMessage2 methods */
    STDMETHOD(get_ModifiedDate)(THIS_ DATE FAR* retval) PURE;
    STDMETHOD(get_Private)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Private)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_RevisionNumber)(THIS_ long FAR* retval) PURE;
    STDMETHOD(get_MasterRevisionNumber)(THIS_ long FAR* retval) PURE;
#endif

    /* IGWNote_m2 methods */
    STDMETHOD(get_Accepted)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(get_Autodate)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(get_AutodateMessages)(THIS_ DIGWMessageList FAR* FAR* retval) PURE;
    STDMETHOD(get_Completed)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Completed)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_Delegated)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(get_NotifyWhenCompleted)(THIS_ NotifyMessageConstants FAR* retval) PURE;
    STDMETHOD(put_NotifyWhenCompleted)(THIS_ NotifyMessageConstants How) PURE;
    STDMETHOD(get_OnCalendar)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_OnCalendar)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_Personal)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(get_StartDate)(THIS_ DATE FAR* retval) PURE;
    STDMETHOD(put_StartDate)(THIS_ DATE Date) PURE;
    STDMETHOD(Accept)(THIS_ VARIANT Comment, VARIANT AllInstances) PURE;
    STDMETHOD(Decline)(THIS_ VARIANT Comment, VARIANT AllInstances) PURE;
    STDMETHOD(Delegate)(THIS_ VARIANT AllInstances, DIGWNote2 FAR* FAR* retval) PURE;
};

DEFINE_GUID(IID_IGWNote2,0x7E000010L,0xE158,0x11CE,0x87,0xEB,0x00,0x80,0x5F,0xB4,0xB2,0xBE);

/* Definition of interface: IGWNote2 */
#undef INTERFACE
#define INTERFACE IGWNote2

DECLARE_INTERFACE_(IGWNote2, IGWNote_m2)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IGWMessage methods */
    STDMETHOD(get_Application)(THIS_ DIGWSession FAR* FAR* retval) PURE;
    STDMETHOD(get_Attachments)(THIS_ DIGWAttachments FAR* FAR* retval) PURE;
    STDMETHOD(get_BodyText)(THIS_ DIGWFormattedText FAR* FAR* retval) PURE;
    STDMETHOD(get_BoxType)(THIS_ MessageBoxTypeConstants FAR* retval) PURE;
    STDMETHOD(get_ClassName)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(put_ClassName)(THIS_ BSTR pClass) PURE;
    STDMETHOD(get_ConvertAttachments)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_ConvertAttachments)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_CreationDate)(THIS_ DATE FAR* retval) PURE;
    STDMETHOD(get_Deleted)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(get_DownloadStatus)(THIS_ DIGWDownloadStatus FAR* FAR* retval) PURE;
    STDMETHOD(get_EnclosingFolders)(THIS_ DIGWFolders FAR* FAR* retval) PURE;
    STDMETHOD(get_ExpandedRecipients)(THIS_ DIGWRecipients FAR* FAR* retval) PURE;
    STDMETHOD(get_Fields)(THIS_ DIGWFields FAR* FAR* retval) PURE;
    STDMETHOD(get_FromText)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(put_FromText)(THIS_ BSTR Text) PURE;
    STDMETHOD(get_Hidden)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Hidden)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_MessageID)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(get_NotifyWhenDeleted)(THIS_ NotifyMessageConstants FAR* retval) PURE;
    STDMETHOD(put_NotifyWhenDeleted)(THIS_ NotifyMessageConstants How) PURE;
    STDMETHOD(get_NotifyWhenOpened)(THIS_ NotifyMessageConstants FAR* retval) PURE;
    STDMETHOD(put_NotifyWhenOpened)(THIS_ NotifyMessageConstants How) PURE;
    STDMETHOD(get_Opened)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Opened)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_Parent)(THIS_ DIGWAccount FAR* FAR* retval) PURE;
    STDMETHOD(get_Priority)(THIS_ MessagePriorityConstants FAR* retval) PURE;
    STDMETHOD(put_Priority)(THIS_ MessagePriorityConstants Priority) PURE;
    STDMETHOD(get_Read)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Read)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_Recipients)(THIS_ DIGWRecipients FAR* FAR* retval) PURE;
    STDMETHOD(get_ReplyChildren)(THIS_ DIGWMessageList FAR* FAR* retval) PURE;
    STDMETHOD(get_ReplyDaysRequested)(THIS_ int FAR* retval) PURE;
    STDMETHOD(put_ReplyDaysRequested)(THIS_ int Days) PURE;
    STDMETHOD(get_ReplyParent)(THIS_ DIGWMessage FAR* FAR* retval) PURE;
    STDMETHOD(get_ReplyRequested)(THIS_ ReplyRequestedConstants FAR* retval) PURE;
    STDMETHOD(put_ReplyRequested)(THIS_ ReplyRequestedConstants When) PURE;
    STDMETHOD(get_ReplyRoot)(THIS_ DIGWMessage FAR* FAR* retval) PURE;
    STDMETHOD(get_Routed)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Routed)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_RoutingEndOfLine)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(get_Sender)(THIS_ DIGWAddress FAR* FAR* retval) PURE;
    STDMETHOD(get_Subject)(THIS_ DIGWFormattedText FAR* FAR* retval) PURE;
    STDMETHOD(get_ViewName)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(put_ViewName)(THIS_ BSTR pClass) PURE;
    STDMETHOD(Annotate)(THIS_ DIGWNote2 FAR* Note) PURE;
    STDMETHOD(Clone)(THIS_ DIGWMessage FAR* FAR* retval) PURE;
    STDMETHOD(Delete)(THIS) PURE;
    STDMETHOD(Forward)(THIS_ DIGWMail FAR* FAR* retval) PURE;
    STDMETHOD(Refresh)(THIS) PURE;
    STDMETHOD(Reply)(THIS_ VARIANT ClassName, VARIANT ReplyToAll, VARIANT IncludeSenderMessageText, VARIANT AttachOriginalMessage, DIGWMessage FAR* FAR* retval) PURE;
    STDMETHOD(Retract)(THIS) PURE;
    STDMETHOD(Send)(THIS_ DIGWMessage FAR* FAR* retval) PURE;

    /* IGWMessage2 methods */
    STDMETHOD(get_ModifiedDate)(THIS_ DATE FAR* retval) PURE;
    STDMETHOD(get_Private)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Private)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_RevisionNumber)(THIS_ long FAR* retval) PURE;
    STDMETHOD(get_MasterRevisionNumber)(THIS_ long FAR* retval) PURE;

    /* IGWNote_m2 methods */
    STDMETHOD(get_Accepted)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(get_Autodate)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(get_AutodateMessages)(THIS_ DIGWMessageList FAR* FAR* retval) PURE;
    STDMETHOD(get_Completed)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Completed)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_Delegated)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(get_NotifyWhenCompleted)(THIS_ NotifyMessageConstants FAR* retval) PURE;
    STDMETHOD(put_NotifyWhenCompleted)(THIS_ NotifyMessageConstants How) PURE;
    STDMETHOD(get_OnCalendar)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_OnCalendar)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_Personal)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(get_StartDate)(THIS_ DATE FAR* retval) PURE;
    STDMETHOD(put_StartDate)(THIS_ DATE Date) PURE;
    STDMETHOD(Accept)(THIS_ VARIANT Comment, VARIANT AllInstances) PURE;
    STDMETHOD(Decline)(THIS_ VARIANT Comment, VARIANT AllInstances) PURE;
    STDMETHOD(Delegate)(THIS_ VARIANT AllInstances, DIGWNote2 FAR* FAR* retval) PURE;
#endif

    /* IGWNote2 methods */
    STDMETHOD(get_NotifyWhenAccepted)(THIS_ NotifyMessageConstants FAR* retval) PURE;
    STDMETHOD(put_NotifyWhenAccepted)(THIS_ NotifyMessageConstants How) PURE;
    STDMETHOD(get_NotifyWhenDeclined)(THIS_ NotifyMessageConstants FAR* retval) PURE;
    STDMETHOD(put_NotifyWhenDeclined)(THIS_ NotifyMessageConstants How) PURE;
};

DEFINE_GUID(IID_IGWNote3,0x481ED627L,0x4EFF,0x11D1,0x8D,0x79,0x00,0x80,0x5F,0xC1,0x28,0xBA);

/* Definition of interface: IGWNote3 */
#undef INTERFACE
#define INTERFACE IGWNote3

DECLARE_INTERFACE_(IGWNote3, IGWNote_m2)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IGWMessage methods */
    STDMETHOD(get_Application)(THIS_ DIGWSession FAR* FAR* retval) PURE;
    STDMETHOD(get_Attachments)(THIS_ DIGWAttachments FAR* FAR* retval) PURE;
    STDMETHOD(get_BodyText)(THIS_ DIGWFormattedText FAR* FAR* retval) PURE;
    STDMETHOD(get_BoxType)(THIS_ MessageBoxTypeConstants FAR* retval) PURE;
    STDMETHOD(get_ClassName)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(put_ClassName)(THIS_ BSTR pClass) PURE;
    STDMETHOD(get_ConvertAttachments)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_ConvertAttachments)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_CreationDate)(THIS_ DATE FAR* retval) PURE;
    STDMETHOD(get_Deleted)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(get_DownloadStatus)(THIS_ DIGWDownloadStatus FAR* FAR* retval) PURE;
    STDMETHOD(get_EnclosingFolders)(THIS_ DIGWFolders FAR* FAR* retval) PURE;
    STDMETHOD(get_ExpandedRecipients)(THIS_ DIGWRecipients FAR* FAR* retval) PURE;
    STDMETHOD(get_Fields)(THIS_ DIGWFields FAR* FAR* retval) PURE;
    STDMETHOD(get_FromText)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(put_FromText)(THIS_ BSTR Text) PURE;
    STDMETHOD(get_Hidden)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Hidden)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_MessageID)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(get_NotifyWhenDeleted)(THIS_ NotifyMessageConstants FAR* retval) PURE;
    STDMETHOD(put_NotifyWhenDeleted)(THIS_ NotifyMessageConstants How) PURE;
    STDMETHOD(get_NotifyWhenOpened)(THIS_ NotifyMessageConstants FAR* retval) PURE;
    STDMETHOD(put_NotifyWhenOpened)(THIS_ NotifyMessageConstants How) PURE;
    STDMETHOD(get_Opened)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Opened)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_Parent)(THIS_ DIGWAccount FAR* FAR* retval) PURE;
    STDMETHOD(get_Priority)(THIS_ MessagePriorityConstants FAR* retval) PURE;
    STDMETHOD(put_Priority)(THIS_ MessagePriorityConstants Priority) PURE;
    STDMETHOD(get_Read)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Read)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_Recipients)(THIS_ DIGWRecipients FAR* FAR* retval) PURE;
    STDMETHOD(get_ReplyChildren)(THIS_ DIGWMessageList FAR* FAR* retval) PURE;
    STDMETHOD(get_ReplyDaysRequested)(THIS_ int FAR* retval) PURE;
    STDMETHOD(put_ReplyDaysRequested)(THIS_ int Days) PURE;
    STDMETHOD(get_ReplyParent)(THIS_ DIGWMessage FAR* FAR* retval) PURE;
    STDMETHOD(get_ReplyRequested)(THIS_ ReplyRequestedConstants FAR* retval) PURE;
    STDMETHOD(put_ReplyRequested)(THIS_ ReplyRequestedConstants When) PURE;
    STDMETHOD(get_ReplyRoot)(THIS_ DIGWMessage FAR* FAR* retval) PURE;
    STDMETHOD(get_Routed)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Routed)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_RoutingEndOfLine)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(get_Sender)(THIS_ DIGWAddress FAR* FAR* retval) PURE;
    STDMETHOD(get_Subject)(THIS_ DIGWFormattedText FAR* FAR* retval) PURE;
    STDMETHOD(get_ViewName)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(put_ViewName)(THIS_ BSTR pClass) PURE;
    STDMETHOD(Annotate)(THIS_ DIGWNote2 FAR* Note) PURE;
    STDMETHOD(Clone)(THIS_ DIGWMessage FAR* FAR* retval) PURE;
    STDMETHOD(Delete)(THIS) PURE;
    STDMETHOD(Forward)(THIS_ DIGWMail FAR* FAR* retval) PURE;
    STDMETHOD(Refresh)(THIS) PURE;
    STDMETHOD(Reply)(THIS_ VARIANT ClassName, VARIANT ReplyToAll, VARIANT IncludeSenderMessageText, VARIANT AttachOriginalMessage, DIGWMessage FAR* FAR* retval) PURE;
    STDMETHOD(Retract)(THIS) PURE;
    STDMETHOD(Send)(THIS_ DIGWMessage FAR* FAR* retval) PURE;

    /* IGWMessage2 methods */
    STDMETHOD(get_ModifiedDate)(THIS_ DATE FAR* retval) PURE;
    STDMETHOD(get_Private)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Private)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_RevisionNumber)(THIS_ long FAR* retval) PURE;
    STDMETHOD(get_MasterRevisionNumber)(THIS_ long FAR* retval) PURE;

    /* IGWNote_m2 methods */
    STDMETHOD(get_Accepted)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(get_Autodate)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(get_AutodateMessages)(THIS_ DIGWMessageList FAR* FAR* retval) PURE;
    STDMETHOD(get_Completed)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Completed)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_Delegated)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(get_NotifyWhenCompleted)(THIS_ NotifyMessageConstants FAR* retval) PURE;
    STDMETHOD(put_NotifyWhenCompleted)(THIS_ NotifyMessageConstants How) PURE;
    STDMETHOD(get_OnCalendar)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_OnCalendar)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_Personal)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(get_StartDate)(THIS_ DATE FAR* retval) PURE;
    STDMETHOD(put_StartDate)(THIS_ DATE Date) PURE;
    STDMETHOD(Accept)(THIS_ VARIANT Comment, VARIANT AllInstances) PURE;
    STDMETHOD(Decline)(THIS_ VARIANT Comment, VARIANT AllInstances) PURE;
    STDMETHOD(Delegate)(THIS_ VARIANT AllInstances, DIGWNote2 FAR* FAR* retval) PURE;
#endif

    /* IGWNote3 methods */
    STDMETHOD(get_NotifyWhenAccepted)(THIS_ NotifyMessageConstants FAR* retval) PURE;
    STDMETHOD(put_NotifyWhenAccepted)(THIS_ NotifyMessageConstants How) PURE;
    STDMETHOD(get_NotifyWhenDeclined)(THIS_ NotifyMessageConstants FAR* retval) PURE;
    STDMETHOD(put_NotifyWhenDeclined)(THIS_ NotifyMessageConstants How) PURE;
    STDMETHOD(get_Archived)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Archived)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_Sharer)(THIS_ DIGWAddress FAR* FAR* retval) PURE;
    STDMETHOD(LocalDelete)(THIS) PURE;
};

DEFINE_GUID(DIID_DIGWNote2,0x7E000011L,0xE158,0x11CE,0x87,0xEB,0x00,0x80,0x5F,0xB4,0xB2,0xBE);

/* Definition of dispatch interface: DIGWNote2 */
#undef INTERFACE
#define INTERFACE DIGWNote2

DECLARE_INTERFACE_(DIGWNote2, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;
#endif

/* Capable of dispatching all the methods of interface IGWNote2 */
};

DEFINE_GUID(DIID_DIGWNote3,0x7E000014L,0xE158,0x11CE,0x87,0xEB,0x00,0x80,0x5F,0xB4,0xB2,0xBE);

/* Definition of dispatch interface: DIGWNote3 */
#undef INTERFACE
#define INTERFACE DIGWNote3

DECLARE_INTERFACE_(DIGWNote3, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;
#endif

/* Capable of dispatching all the methods of interface IGWNote3 */
};

DEFINE_GUID(CLSID_Note,0xC89C3064L,0x04AF,0x11CF,0xB0,0x49,0x00,0x80,0x5F,0x88,0xE6,0x02);

#ifdef __cplusplus
class Note;
#endif

DEFINE_GUID(CLSID_Note2,0xC89C3069L,0x04AF,0x11CF,0xB0,0x49,0x00,0x80,0x5F,0x88,0xE6,0x02);

#ifdef __cplusplus
class Note2;
#endif

DEFINE_GUID(CLSID_Note3,0x72AB2066L,0xF4CA,0x11D1,0x8D,0x8F,0x00,0x80,0x5F,0xC1,0x00,0xD4);

#ifdef __cplusplus
class Note3;
#endif

DEFINE_GUID(IID_IGWPhoneMessage,0x7D2265EAL,0xE158,0x11CE,0x87,0xEB,0x00,0x80,0x5F,0xB4,0xB2,0xBE);

/* Definition of interface: IGWPhoneMessage */
#undef INTERFACE
#define INTERFACE IGWPhoneMessage

DECLARE_INTERFACE_(IGWPhoneMessage, IGWMessage)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IGWMessage methods */
    STDMETHOD(get_Application)(THIS_ DIGWSession FAR* FAR* retval) PURE;
    STDMETHOD(get_Attachments)(THIS_ DIGWAttachments FAR* FAR* retval) PURE;
    STDMETHOD(get_BodyText)(THIS_ DIGWFormattedText FAR* FAR* retval) PURE;
    STDMETHOD(get_BoxType)(THIS_ MessageBoxTypeConstants FAR* retval) PURE;
    STDMETHOD(get_ClassName)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(put_ClassName)(THIS_ BSTR pClass) PURE;
    STDMETHOD(get_ConvertAttachments)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_ConvertAttachments)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_CreationDate)(THIS_ DATE FAR* retval) PURE;
    STDMETHOD(get_Deleted)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(get_DownloadStatus)(THIS_ DIGWDownloadStatus FAR* FAR* retval) PURE;
    STDMETHOD(get_EnclosingFolders)(THIS_ DIGWFolders FAR* FAR* retval) PURE;
    STDMETHOD(get_ExpandedRecipients)(THIS_ DIGWRecipients FAR* FAR* retval) PURE;
    STDMETHOD(get_Fields)(THIS_ DIGWFields FAR* FAR* retval) PURE;
    STDMETHOD(get_FromText)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(put_FromText)(THIS_ BSTR Text) PURE;
    STDMETHOD(get_Hidden)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Hidden)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_MessageID)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(get_NotifyWhenDeleted)(THIS_ NotifyMessageConstants FAR* retval) PURE;
    STDMETHOD(put_NotifyWhenDeleted)(THIS_ NotifyMessageConstants How) PURE;
    STDMETHOD(get_NotifyWhenOpened)(THIS_ NotifyMessageConstants FAR* retval) PURE;
    STDMETHOD(put_NotifyWhenOpened)(THIS_ NotifyMessageConstants How) PURE;
    STDMETHOD(get_Opened)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Opened)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_Parent)(THIS_ DIGWAccount FAR* FAR* retval) PURE;
    STDMETHOD(get_Priority)(THIS_ MessagePriorityConstants FAR* retval) PURE;
    STDMETHOD(put_Priority)(THIS_ MessagePriorityConstants Priority) PURE;
    STDMETHOD(get_Read)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Read)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_Recipients)(THIS_ DIGWRecipients FAR* FAR* retval) PURE;
    STDMETHOD(get_ReplyChildren)(THIS_ DIGWMessageList FAR* FAR* retval) PURE;
    STDMETHOD(get_ReplyDaysRequested)(THIS_ int FAR* retval) PURE;
    STDMETHOD(put_ReplyDaysRequested)(THIS_ int Days) PURE;
    STDMETHOD(get_ReplyParent)(THIS_ DIGWMessage FAR* FAR* retval) PURE;
    STDMETHOD(get_ReplyRequested)(THIS_ ReplyRequestedConstants FAR* retval) PURE;
    STDMETHOD(put_ReplyRequested)(THIS_ ReplyRequestedConstants When) PURE;
    STDMETHOD(get_ReplyRoot)(THIS_ DIGWMessage FAR* FAR* retval) PURE;
    STDMETHOD(get_Routed)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Routed)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_RoutingEndOfLine)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(get_Sender)(THIS_ DIGWAddress FAR* FAR* retval) PURE;
    STDMETHOD(get_Subject)(THIS_ DIGWFormattedText FAR* FAR* retval) PURE;
    STDMETHOD(get_ViewName)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(put_ViewName)(THIS_ BSTR pClass) PURE;
    STDMETHOD(Annotate)(THIS_ DIGWNote2 FAR* Note) PURE;
    STDMETHOD(Clone)(THIS_ DIGWMessage FAR* FAR* retval) PURE;
    STDMETHOD(Delete)(THIS) PURE;
    STDMETHOD(Forward)(THIS_ DIGWMail FAR* FAR* retval) PURE;
    STDMETHOD(Refresh)(THIS) PURE;
    STDMETHOD(Reply)(THIS_ VARIANT ClassName, VARIANT ReplyToAll, VARIANT IncludeSenderMessageText, VARIANT AttachOriginalMessage, DIGWMessage FAR* FAR* retval) PURE;
    STDMETHOD(Retract)(THIS) PURE;
    STDMETHOD(Send)(THIS_ DIGWMessage FAR* FAR* retval) PURE;
#endif

    /* IGWPhoneMessage methods */
    STDMETHOD(get_CallerCompany)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(put_CallerCompany)(THIS_ BSTR name) PURE;
    STDMETHOD(get_CallerName)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(put_CallerName)(THIS_ BSTR name) PURE;
    STDMETHOD(get_CameToSee)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_CameToSee)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_PhoneNumber)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(put_PhoneNumber)(THIS_ BSTR Phone) PURE;
    STDMETHOD(get_PleaseCall)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_PleaseCall)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_ReturnedCall)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_ReturnedCall)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_Telephoned)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Telephoned)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_Urgent)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Urgent)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_WantsToSee)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_WantsToSee)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_WillCall)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_WillCall)(THIS_ VARIANT_BOOL Flag) PURE;
};

DEFINE_GUID(DIID_DIGWPhoneMessage,0x7D2265EBL,0xE158,0x11CE,0x87,0xEB,0x00,0x80,0x5F,0xB4,0xB2,0xBE);

/* Definition of dispatch interface: DIGWPhoneMessage */
#undef INTERFACE
#define INTERFACE DIGWPhoneMessage

DECLARE_INTERFACE_(DIGWPhoneMessage, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;
#endif

/* Capable of dispatching all the methods of interface IGWPhoneMessage */
};

DEFINE_GUID(IID_IGWPhoneMessage2,0x7D2267EAL,0xE158,0x11CE,0x87,0xEB,0x00,0x80,0x5F,0xB4,0xB2,0xBE);

/* Definition of interface: IGWPhoneMessage2 */
#undef INTERFACE
#define INTERFACE IGWPhoneMessage2

DECLARE_INTERFACE_(IGWPhoneMessage2, IGWMessage2)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IGWMessage methods */
    STDMETHOD(get_Application)(THIS_ DIGWSession FAR* FAR* retval) PURE;
    STDMETHOD(get_Attachments)(THIS_ DIGWAttachments FAR* FAR* retval) PURE;
    STDMETHOD(get_BodyText)(THIS_ DIGWFormattedText FAR* FAR* retval) PURE;
    STDMETHOD(get_BoxType)(THIS_ MessageBoxTypeConstants FAR* retval) PURE;
    STDMETHOD(get_ClassName)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(put_ClassName)(THIS_ BSTR pClass) PURE;
    STDMETHOD(get_ConvertAttachments)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_ConvertAttachments)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_CreationDate)(THIS_ DATE FAR* retval) PURE;
    STDMETHOD(get_Deleted)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(get_DownloadStatus)(THIS_ DIGWDownloadStatus FAR* FAR* retval) PURE;
    STDMETHOD(get_EnclosingFolders)(THIS_ DIGWFolders FAR* FAR* retval) PURE;
    STDMETHOD(get_ExpandedRecipients)(THIS_ DIGWRecipients FAR* FAR* retval) PURE;
    STDMETHOD(get_Fields)(THIS_ DIGWFields FAR* FAR* retval) PURE;
    STDMETHOD(get_FromText)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(put_FromText)(THIS_ BSTR Text) PURE;
    STDMETHOD(get_Hidden)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Hidden)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_MessageID)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(get_NotifyWhenDeleted)(THIS_ NotifyMessageConstants FAR* retval) PURE;
    STDMETHOD(put_NotifyWhenDeleted)(THIS_ NotifyMessageConstants How) PURE;
    STDMETHOD(get_NotifyWhenOpened)(THIS_ NotifyMessageConstants FAR* retval) PURE;
    STDMETHOD(put_NotifyWhenOpened)(THIS_ NotifyMessageConstants How) PURE;
    STDMETHOD(get_Opened)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Opened)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_Parent)(THIS_ DIGWAccount FAR* FAR* retval) PURE;
    STDMETHOD(get_Priority)(THIS_ MessagePriorityConstants FAR* retval) PURE;
    STDMETHOD(put_Priority)(THIS_ MessagePriorityConstants Priority) PURE;
    STDMETHOD(get_Read)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Read)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_Recipients)(THIS_ DIGWRecipients FAR* FAR* retval) PURE;
    STDMETHOD(get_ReplyChildren)(THIS_ DIGWMessageList FAR* FAR* retval) PURE;
    STDMETHOD(get_ReplyDaysRequested)(THIS_ int FAR* retval) PURE;
    STDMETHOD(put_ReplyDaysRequested)(THIS_ int Days) PURE;
    STDMETHOD(get_ReplyParent)(THIS_ DIGWMessage FAR* FAR* retval) PURE;
    STDMETHOD(get_ReplyRequested)(THIS_ ReplyRequestedConstants FAR* retval) PURE;
    STDMETHOD(put_ReplyRequested)(THIS_ ReplyRequestedConstants When) PURE;
    STDMETHOD(get_ReplyRoot)(THIS_ DIGWMessage FAR* FAR* retval) PURE;
    STDMETHOD(get_Routed)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Routed)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_RoutingEndOfLine)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(get_Sender)(THIS_ DIGWAddress FAR* FAR* retval) PURE;
    STDMETHOD(get_Subject)(THIS_ DIGWFormattedText FAR* FAR* retval) PURE;
    STDMETHOD(get_ViewName)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(put_ViewName)(THIS_ BSTR pClass) PURE;
    STDMETHOD(Annotate)(THIS_ DIGWNote2 FAR* Note) PURE;
    STDMETHOD(Clone)(THIS_ DIGWMessage FAR* FAR* retval) PURE;
    STDMETHOD(Delete)(THIS) PURE;
    STDMETHOD(Forward)(THIS_ DIGWMail FAR* FAR* retval) PURE;
    STDMETHOD(Refresh)(THIS) PURE;
    STDMETHOD(Reply)(THIS_ VARIANT ClassName, VARIANT ReplyToAll, VARIANT IncludeSenderMessageText, VARIANT AttachOriginalMessage, DIGWMessage FAR* FAR* retval) PURE;
    STDMETHOD(Retract)(THIS) PURE;
    STDMETHOD(Send)(THIS_ DIGWMessage FAR* FAR* retval) PURE;

    /* IGWMessage2 methods */
    STDMETHOD(get_ModifiedDate)(THIS_ DATE FAR* retval) PURE;
    STDMETHOD(get_Private)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Private)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_RevisionNumber)(THIS_ long FAR* retval) PURE;
    STDMETHOD(get_MasterRevisionNumber)(THIS_ long FAR* retval) PURE;
#endif

    /* IGWPhoneMessage2 methods */
    STDMETHOD(get_CallerCompany)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(put_CallerCompany)(THIS_ BSTR name) PURE;
    STDMETHOD(get_CallerName)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(put_CallerName)(THIS_ BSTR name) PURE;
    STDMETHOD(get_CameToSee)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_CameToSee)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_PhoneNumber)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(put_PhoneNumber)(THIS_ BSTR Phone) PURE;
    STDMETHOD(get_PleaseCall)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_PleaseCall)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_ReturnedCall)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_ReturnedCall)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_Telephoned)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Telephoned)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_Urgent)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Urgent)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_WantsToSee)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_WantsToSee)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_WillCall)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_WillCall)(THIS_ VARIANT_BOOL Flag) PURE;
};

DEFINE_GUID(IID_IGWPhoneMessage3,0x481ED628L,0x4EFF,0x11D1,0x8D,0x79,0x00,0x80,0x5F,0xC1,0x28,0xBA);

/* Definition of interface: IGWPhoneMessage3 */
#undef INTERFACE
#define INTERFACE IGWPhoneMessage3

DECLARE_INTERFACE_(IGWPhoneMessage3, IGWMessage2)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IGWMessage methods */
    STDMETHOD(get_Application)(THIS_ DIGWSession FAR* FAR* retval) PURE;
    STDMETHOD(get_Attachments)(THIS_ DIGWAttachments FAR* FAR* retval) PURE;
    STDMETHOD(get_BodyText)(THIS_ DIGWFormattedText FAR* FAR* retval) PURE;
    STDMETHOD(get_BoxType)(THIS_ MessageBoxTypeConstants FAR* retval) PURE;
    STDMETHOD(get_ClassName)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(put_ClassName)(THIS_ BSTR pClass) PURE;
    STDMETHOD(get_ConvertAttachments)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_ConvertAttachments)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_CreationDate)(THIS_ DATE FAR* retval) PURE;
    STDMETHOD(get_Deleted)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(get_DownloadStatus)(THIS_ DIGWDownloadStatus FAR* FAR* retval) PURE;
    STDMETHOD(get_EnclosingFolders)(THIS_ DIGWFolders FAR* FAR* retval) PURE;
    STDMETHOD(get_ExpandedRecipients)(THIS_ DIGWRecipients FAR* FAR* retval) PURE;
    STDMETHOD(get_Fields)(THIS_ DIGWFields FAR* FAR* retval) PURE;
    STDMETHOD(get_FromText)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(put_FromText)(THIS_ BSTR Text) PURE;
    STDMETHOD(get_Hidden)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Hidden)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_MessageID)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(get_NotifyWhenDeleted)(THIS_ NotifyMessageConstants FAR* retval) PURE;
    STDMETHOD(put_NotifyWhenDeleted)(THIS_ NotifyMessageConstants How) PURE;
    STDMETHOD(get_NotifyWhenOpened)(THIS_ NotifyMessageConstants FAR* retval) PURE;
    STDMETHOD(put_NotifyWhenOpened)(THIS_ NotifyMessageConstants How) PURE;
    STDMETHOD(get_Opened)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Opened)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_Parent)(THIS_ DIGWAccount FAR* FAR* retval) PURE;
    STDMETHOD(get_Priority)(THIS_ MessagePriorityConstants FAR* retval) PURE;
    STDMETHOD(put_Priority)(THIS_ MessagePriorityConstants Priority) PURE;
    STDMETHOD(get_Read)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Read)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_Recipients)(THIS_ DIGWRecipients FAR* FAR* retval) PURE;
    STDMETHOD(get_ReplyChildren)(THIS_ DIGWMessageList FAR* FAR* retval) PURE;
    STDMETHOD(get_ReplyDaysRequested)(THIS_ int FAR* retval) PURE;
    STDMETHOD(put_ReplyDaysRequested)(THIS_ int Days) PURE;
    STDMETHOD(get_ReplyParent)(THIS_ DIGWMessage FAR* FAR* retval) PURE;
    STDMETHOD(get_ReplyRequested)(THIS_ ReplyRequestedConstants FAR* retval) PURE;
    STDMETHOD(put_ReplyRequested)(THIS_ ReplyRequestedConstants When) PURE;
    STDMETHOD(get_ReplyRoot)(THIS_ DIGWMessage FAR* FAR* retval) PURE;
    STDMETHOD(get_Routed)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Routed)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_RoutingEndOfLine)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(get_Sender)(THIS_ DIGWAddress FAR* FAR* retval) PURE;
    STDMETHOD(get_Subject)(THIS_ DIGWFormattedText FAR* FAR* retval) PURE;
    STDMETHOD(get_ViewName)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(put_ViewName)(THIS_ BSTR pClass) PURE;
    STDMETHOD(Annotate)(THIS_ DIGWNote2 FAR* Note) PURE;
    STDMETHOD(Clone)(THIS_ DIGWMessage FAR* FAR* retval) PURE;
    STDMETHOD(Delete)(THIS) PURE;
    STDMETHOD(Forward)(THIS_ DIGWMail FAR* FAR* retval) PURE;
    STDMETHOD(Refresh)(THIS) PURE;
    STDMETHOD(Reply)(THIS_ VARIANT ClassName, VARIANT ReplyToAll, VARIANT IncludeSenderMessageText, VARIANT AttachOriginalMessage, DIGWMessage FAR* FAR* retval) PURE;
    STDMETHOD(Retract)(THIS) PURE;
    STDMETHOD(Send)(THIS_ DIGWMessage FAR* FAR* retval) PURE;

    /* IGWMessage2 methods */
    STDMETHOD(get_ModifiedDate)(THIS_ DATE FAR* retval) PURE;
    STDMETHOD(get_Private)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Private)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_RevisionNumber)(THIS_ long FAR* retval) PURE;
    STDMETHOD(get_MasterRevisionNumber)(THIS_ long FAR* retval) PURE;
#endif

    /* IGWPhoneMessage3 methods */
    STDMETHOD(get_CallerCompany)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(put_CallerCompany)(THIS_ BSTR name) PURE;
    STDMETHOD(get_CallerName)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(put_CallerName)(THIS_ BSTR name) PURE;
    STDMETHOD(get_CameToSee)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_CameToSee)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_PhoneNumber)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(put_PhoneNumber)(THIS_ BSTR Phone) PURE;
    STDMETHOD(get_PleaseCall)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_PleaseCall)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_ReturnedCall)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_ReturnedCall)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_Telephoned)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Telephoned)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_Urgent)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Urgent)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_WantsToSee)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_WantsToSee)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_WillCall)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_WillCall)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_Archived)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Archived)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_Sharer)(THIS_ DIGWAddress FAR* FAR* retval) PURE;
    STDMETHOD(LocalDelete)(THIS) PURE;
};

DEFINE_GUID(DIID_DIGWPhoneMessage2,0x7D2267EBL,0xE158,0x11CE,0x87,0xEB,0x00,0x80,0x5F,0xB4,0xB2,0xBE);

/* Definition of dispatch interface: DIGWPhoneMessage2 */
#undef INTERFACE
#define INTERFACE DIGWPhoneMessage2

DECLARE_INTERFACE_(DIGWPhoneMessage2, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;
#endif

/* Capable of dispatching all the methods of interface IGWPhoneMessage2 */
};

DEFINE_GUID(DIID_DIGWPhoneMessage3,0x7D2267EEL,0xE158,0x11CE,0x87,0xEB,0x00,0x80,0x5F,0xB4,0xB2,0xBE);

/* Definition of dispatch interface: DIGWPhoneMessage3 */
#undef INTERFACE
#define INTERFACE DIGWPhoneMessage3

DECLARE_INTERFACE_(DIGWPhoneMessage3, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;
#endif

/* Capable of dispatching all the methods of interface IGWPhoneMessage3 */
};

DEFINE_GUID(CLSID_PhoneMessage,0xC89C2E65L,0x04AF,0x11CF,0xB0,0x49,0x00,0x80,0x5F,0x88,0xE6,0x02);

#ifdef __cplusplus
class PhoneMessage;
#endif

DEFINE_GUID(CLSID_PhoneMessage2,0x7D2267EFL,0xE158,0x11CE,0x87,0xEB,0x00,0x80,0x5F,0xB4,0xB2,0xBE);

#ifdef __cplusplus
class PhoneMessage2;
#endif

DEFINE_GUID(CLSID_PhoneMessage3,0xAD9F05CAL,0xF4CA,0x11D1,0x8D,0x8F,0x00,0x80,0x5F,0xC1,0x00,0xD4);

#ifdef __cplusplus
class PhoneMessage3;
#endif

DEFINE_GUID(IID_IGWQuery,0x50E3D040L,0x6093,0x11CF,0xAF,0xA5,0x00,0x60,0x8C,0x79,0xBC,0x42);

/* Definition of interface: IGWQuery */
#undef INTERFACE
#define INTERFACE IGWQuery

DECLARE_INTERFACE_(IGWQuery, IUnknown)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;
#endif

    /* IGWQuery methods */
    STDMETHOD(CreateFolder)(THIS_ BSTR Name, VARIANT vr, DIGWFolder FAR* FAR* retval) PURE;
    STDMETHOD(Start)(THIS) PURE;
    STDMETHOD(Refresh)(THIS) PURE;
    STDMETHOD(get_Completed)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Expression)(THIS_ BSTR Param) PURE;
    STDMETHOD(get_Expression)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(get_Locations)(THIS_ DIGWLocations FAR* FAR* retval) PURE;
    STDMETHOD(get_QueryMessages)(THIS_ DIGWMessageList FAR* FAR* retval) PURE;
    STDMETHOD(put_SearchLocally)(THIS_ VARIANT_BOOL Param) PURE;
    STDMETHOD(get_SearchLocally)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_StartOnOpen)(THIS_ VARIANT_BOOL Param) PURE;
    STDMETHOD(get_StartOnOpen)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(get_Parent)(THIS_ IDispatch * FAR* retval) PURE;
    STDMETHOD(get_Application)(THIS_ DIGWSession FAR* FAR* retval) PURE;
    STDMETHOD(get_CompletionDate)(THIS_ DATE FAR* retval) PURE;
};

DEFINE_GUID(IID_IGWQuery2,0x14599540L,0xFF78,0x11D0,0xB3,0x84,0x00,0x80,0x5F,0x36,0xA3,0x75);

/* Definition of interface: IGWQuery2 */
#undef INTERFACE
#define INTERFACE IGWQuery2

DECLARE_INTERFACE_(IGWQuery2, IGWQuery)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IGWQuery methods */
    STDMETHOD(CreateFolder)(THIS_ BSTR Name, VARIANT vr, DIGWFolder FAR* FAR* retval) PURE;
    STDMETHOD(Start)(THIS) PURE;
    STDMETHOD(Refresh)(THIS) PURE;
    STDMETHOD(get_Completed)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Expression)(THIS_ BSTR Param) PURE;
    STDMETHOD(get_Expression)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(get_Locations)(THIS_ DIGWLocations FAR* FAR* retval) PURE;
    STDMETHOD(get_QueryMessages)(THIS_ DIGWMessageList FAR* FAR* retval) PURE;
    STDMETHOD(put_SearchLocally)(THIS_ VARIANT_BOOL Param) PURE;
    STDMETHOD(get_SearchLocally)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_StartOnOpen)(THIS_ VARIANT_BOOL Param) PURE;
    STDMETHOD(get_StartOnOpen)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(get_Parent)(THIS_ IDispatch * FAR* retval) PURE;
    STDMETHOD(get_Application)(THIS_ DIGWSession FAR* FAR* retval) PURE;
    STDMETHOD(get_CompletionDate)(THIS_ DATE FAR* retval) PURE;
#endif

    /* IGWQuery2 methods */
    STDMETHOD(Stop)(THIS) PURE;
};

DEFINE_GUID(DIID_DIGWQuery,0x50E3D041L,0x6093,0x11CF,0xAF,0xA5,0x00,0x60,0x8C,0x79,0xBC,0x42);

/* Definition of dispatch interface: DIGWQuery */
#undef INTERFACE
#define INTERFACE DIGWQuery

DECLARE_INTERFACE_(DIGWQuery, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;
#endif

/* Capable of dispatching all the methods of interface IGWQuery */
};

DEFINE_GUID(DIID_DIGWQuery2,0x50E3D042L,0x6093,0x11CF,0xAF,0xA5,0x00,0x60,0x8C,0x79,0xBC,0x42);

/* Definition of dispatch interface: DIGWQuery2 */
#undef INTERFACE
#define INTERFACE DIGWQuery2

DECLARE_INTERFACE_(DIGWQuery2, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;
#endif

/* Capable of dispatching all the methods of interface IGWQuery2 */
};

DEFINE_GUID(CLSID_Query,0xC89C2D66L,0x04AF,0x11CF,0xB0,0x49,0x00,0x80,0x5F,0x88,0xE6,0x02);

#ifdef __cplusplus
class Query;
#endif

DEFINE_GUID(CLSID_Query2,0xC89C2D6DL,0x04AF,0x11CF,0xB0,0x49,0x00,0x80,0x5F,0x88,0xE6,0x02);

#ifdef __cplusplus
class Query2;
#endif

DEFINE_GUID(IID_IGWRecipient,0x87A7E940L,0x19E4,0x11CF,0xA3,0x4D,0x00,0x60,0x8C,0x79,0xBC,0x4B);

/* Definition of interface: IGWRecipient */
#undef INTERFACE
#define INTERFACE IGWRecipient

DECLARE_INTERFACE_(IGWRecipient, IUnknown)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;
#endif

    /* IGWRecipient methods */
    STDMETHOD(Delete)(THIS) PURE;
    STDMETHOD(Resolve)(THIS_ VARIANT vResolveTo) PURE;
    STDMETHOD(get_Address)(THIS_ DIGWAddress FAR* FAR* pDAddress) PURE;
    STDMETHOD(get_Application)(THIS_ DIGWSession FAR* FAR* retval) PURE;
    STDMETHOD(get_DisplayName)(THIS_ BSTR FAR* DisplayName) PURE;
    STDMETHOD(put_DisplayName)(THIS_ BSTR DisplayName) PURE;
    STDMETHOD(get_EmailAddress)(THIS_ BSTR FAR* EmailAddress) PURE;
    STDMETHOD(put_EmailAddress)(THIS_ BSTR EmailAddress) PURE;
    STDMETHOD(get_EmailType)(THIS_ BSTR FAR* EmailType) PURE;
    STDMETHOD(put_EmailType)(THIS_ BSTR EmailType) PURE;
    STDMETHOD(get_Parent)(THIS_ DIGWRecipients FAR* FAR* pParent) PURE;
    STDMETHOD(get_Resolved)(THIS_ ResolvedConstants FAR* retval) PURE;
    STDMETHOD(put_Resolved)(THIS_ ResolvedConstants Resolved) PURE;
    STDMETHOD(get_TargetType)(THIS_ AddressTargetTypeConstants FAR* TargetType) PURE;
    STDMETHOD(put_TargetType)(THIS_ AddressTargetTypeConstants TargetType) PURE;
};

DEFINE_GUID(DIID_DIGWRecipient,0x87A7E941L,0x19E4,0x11CF,0xA3,0x4D,0x00,0x60,0x8C,0x79,0xBC,0x4B);

/* Definition of dispatch interface: DIGWRecipient */
#undef INTERFACE
#define INTERFACE DIGWRecipient

DECLARE_INTERFACE_(DIGWRecipient, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;
#endif

/* Capable of dispatching all the methods of interface IGWRecipient */
};

DEFINE_GUID(CLSID_Recipient,0xC89C2D68L,0x04AF,0x11CF,0xB0,0x49,0x00,0x80,0x5F,0x88,0xE6,0x02);

#ifdef __cplusplus
class Recipient;
#endif

DEFINE_GUID(IID_IGWRecipients,0xBE821CA0L,0x1B52,0x11CF,0xA3,0x4D,0x00,0x60,0x8C,0x79,0xBC,0x4B);

/* Definition of interface: IGWRecipients */
#undef INTERFACE
#define INTERFACE IGWRecipients

DECLARE_INTERFACE_(IGWRecipients, IUnknown)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;
#endif

    /* IGWRecipients methods */
    STDMETHOD(Add)(THIS_ VARIANT vParm1, VARIANT vParm2, VARIANT vParm3, DIGWRecipient FAR* FAR* pDRecipient) PURE;
    STDMETHOD(AddByDisplayName)(THIS_ BSTR pDisplayName, VARIANT vTargetType, DIGWRecipient FAR* FAR* pDRecipient) PURE;
    STDMETHOD(Item)(THIS_ long lIndex, DIGWRecipient FAR* FAR* pDRecipient) PURE;
    STDMETHOD(Resolve)(THIS_ VARIANT vResolveTo) PURE;
    STDMETHOD(get_Application)(THIS_ DIGWSession FAR* FAR* retval) PURE;
    STDMETHOD(get_Count)(THIS_ long FAR* lCount) PURE;
    STDMETHOD(get__NewEnum)(THIS_ IUnknown * FAR* retval) PURE;
    STDMETHOD(get_Parent)(THIS_ DIGWMessage FAR* FAR* pParent) PURE;
};

DEFINE_GUID(DIID_DIGWRecipients,0xBE821CA1L,0x1B52,0x11CF,0xA3,0x4D,0x00,0x60,0x8C,0x79,0xBC,0x4B);

/* Definition of dispatch interface: DIGWRecipients */
#undef INTERFACE
#define INTERFACE DIGWRecipients

DECLARE_INTERFACE_(DIGWRecipients, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;
#endif

/* Capable of dispatching all the methods of interface IGWRecipients */
};

DEFINE_GUID(CLSID_Recipients,0xC89C2D69L,0x04AF,0x11CF,0xB0,0x49,0x00,0x80,0x5F,0x88,0xE6,0x02);

#ifdef __cplusplus
class Recipients;
#endif

DEFINE_GUID(IID_IGWSetSession,0x3469E6C0L,0xE172,0x11CE,0xB6,0xF9,0x00,0x60,0x8C,0x84,0xE1,0xC4);

/* Definition of interface: IGWSetSession */
#undef INTERFACE
#define INTERFACE IGWSetSession

DECLARE_INTERFACE_(IGWSetSession, IUnknown)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;
#endif

    /* IGWSetSession methods */
    STDMETHOD(SetSession)(THIS_ IUnknown * pIGWSession) PURE;
};

DEFINE_GUID(IID_IGWTask,0x7D2266ECL,0xE158,0x11CE,0x87,0xEB,0x00,0x80,0x5F,0xB4,0xB2,0xBE);

/* Definition of interface: IGWTask */
#undef INTERFACE
#define INTERFACE IGWTask

DECLARE_INTERFACE_(IGWTask, IGWMessage)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IGWMessage methods */
    STDMETHOD(get_Application)(THIS_ DIGWSession FAR* FAR* retval) PURE;
    STDMETHOD(get_Attachments)(THIS_ DIGWAttachments FAR* FAR* retval) PURE;
    STDMETHOD(get_BodyText)(THIS_ DIGWFormattedText FAR* FAR* retval) PURE;
    STDMETHOD(get_BoxType)(THIS_ MessageBoxTypeConstants FAR* retval) PURE;
    STDMETHOD(get_ClassName)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(put_ClassName)(THIS_ BSTR pClass) PURE;
    STDMETHOD(get_ConvertAttachments)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_ConvertAttachments)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_CreationDate)(THIS_ DATE FAR* retval) PURE;
    STDMETHOD(get_Deleted)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(get_DownloadStatus)(THIS_ DIGWDownloadStatus FAR* FAR* retval) PURE;
    STDMETHOD(get_EnclosingFolders)(THIS_ DIGWFolders FAR* FAR* retval) PURE;
    STDMETHOD(get_ExpandedRecipients)(THIS_ DIGWRecipients FAR* FAR* retval) PURE;
    STDMETHOD(get_Fields)(THIS_ DIGWFields FAR* FAR* retval) PURE;
    STDMETHOD(get_FromText)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(put_FromText)(THIS_ BSTR Text) PURE;
    STDMETHOD(get_Hidden)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Hidden)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_MessageID)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(get_NotifyWhenDeleted)(THIS_ NotifyMessageConstants FAR* retval) PURE;
    STDMETHOD(put_NotifyWhenDeleted)(THIS_ NotifyMessageConstants How) PURE;
    STDMETHOD(get_NotifyWhenOpened)(THIS_ NotifyMessageConstants FAR* retval) PURE;
    STDMETHOD(put_NotifyWhenOpened)(THIS_ NotifyMessageConstants How) PURE;
    STDMETHOD(get_Opened)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Opened)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_Parent)(THIS_ DIGWAccount FAR* FAR* retval) PURE;
    STDMETHOD(get_Priority)(THIS_ MessagePriorityConstants FAR* retval) PURE;
    STDMETHOD(put_Priority)(THIS_ MessagePriorityConstants Priority) PURE;
    STDMETHOD(get_Read)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Read)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_Recipients)(THIS_ DIGWRecipients FAR* FAR* retval) PURE;
    STDMETHOD(get_ReplyChildren)(THIS_ DIGWMessageList FAR* FAR* retval) PURE;
    STDMETHOD(get_ReplyDaysRequested)(THIS_ int FAR* retval) PURE;
    STDMETHOD(put_ReplyDaysRequested)(THIS_ int Days) PURE;
    STDMETHOD(get_ReplyParent)(THIS_ DIGWMessage FAR* FAR* retval) PURE;
    STDMETHOD(get_ReplyRequested)(THIS_ ReplyRequestedConstants FAR* retval) PURE;
    STDMETHOD(put_ReplyRequested)(THIS_ ReplyRequestedConstants When) PURE;
    STDMETHOD(get_ReplyRoot)(THIS_ DIGWMessage FAR* FAR* retval) PURE;
    STDMETHOD(get_Routed)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Routed)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_RoutingEndOfLine)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(get_Sender)(THIS_ DIGWAddress FAR* FAR* retval) PURE;
    STDMETHOD(get_Subject)(THIS_ DIGWFormattedText FAR* FAR* retval) PURE;
    STDMETHOD(get_ViewName)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(put_ViewName)(THIS_ BSTR pClass) PURE;
    STDMETHOD(Annotate)(THIS_ DIGWNote2 FAR* Note) PURE;
    STDMETHOD(Clone)(THIS_ DIGWMessage FAR* FAR* retval) PURE;
    STDMETHOD(Delete)(THIS) PURE;
    STDMETHOD(Forward)(THIS_ DIGWMail FAR* FAR* retval) PURE;
    STDMETHOD(Refresh)(THIS) PURE;
    STDMETHOD(Reply)(THIS_ VARIANT ClassName, VARIANT ReplyToAll, VARIANT IncludeSenderMessageText, VARIANT AttachOriginalMessage, DIGWMessage FAR* FAR* retval) PURE;
    STDMETHOD(Retract)(THIS) PURE;
    STDMETHOD(Send)(THIS_ DIGWMessage FAR* FAR* retval) PURE;
#endif

    /* IGWTask methods */
    STDMETHOD(get_Accepted)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(get_AssignedDate)(THIS_ DATE FAR* retval) PURE;
    STDMETHOD(put_AssignedDate)(THIS_ DATE Date) PURE;
    STDMETHOD(get_Autodate)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(get_AutodateMessages)(THIS_ DIGWMessageList FAR* FAR* retval) PURE;
    STDMETHOD(get_Completed)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Completed)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_Delegated)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(get_DueDate)(THIS_ DATE FAR* retval) PURE;
    STDMETHOD(put_DueDate)(THIS_ DATE Date) PURE;
    STDMETHOD(get_NotifyWhenCompleted)(THIS_ NotifyMessageConstants FAR* retval) PURE;
    STDMETHOD(put_NotifyWhenCompleted)(THIS_ NotifyMessageConstants How) PURE;
    STDMETHOD(get_OnCalendar)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_OnCalendar)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_Personal)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(get_StartDate)(THIS_ DATE FAR* retval) PURE;
    STDMETHOD(put_StartDate)(THIS_ DATE Date) PURE;
    STDMETHOD(get_TaskCategory)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(put_TaskCategory)(THIS_ BSTR name) PURE;
    STDMETHOD(get_TaskPriority)(THIS_ int FAR* retval) PURE;
    STDMETHOD(put_TaskPriority)(THIS_ int Priority) PURE;
    STDMETHOD(Accept)(THIS_ VARIANT Comment, VARIANT AllInstances) PURE;
    STDMETHOD(Decline)(THIS_ VARIANT Comment, VARIANT AllInstances) PURE;
    STDMETHOD(Delegate)(THIS_ VARIANT AllInstances, DIGWTask2 FAR* FAR* retval) PURE;
    STDMETHOD(MoveToMasterTaskList)(THIS) PURE;
};

DEFINE_GUID(DIID_DIGWTask,0x7D2266EDL,0xE158,0x11CE,0x87,0xEB,0x00,0x80,0x5F,0xB4,0xB2,0xBE);

/* Definition of dispatch interface: DIGWTask */
#undef INTERFACE
#define INTERFACE DIGWTask

DECLARE_INTERFACE_(DIGWTask, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;
#endif

/* Capable of dispatching all the methods of interface IGWTask */
};

DEFINE_GUID(IID_IGWTask_m2,0x7D2269ECL,0xE158,0x11CE,0x87,0xEB,0x00,0x80,0x5F,0xB4,0xB2,0xBE);

/* Definition of interface: IGWTask_m2 */
#undef INTERFACE
#define INTERFACE IGWTask_m2

DECLARE_INTERFACE_(IGWTask_m2, IGWMessage2)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IGWMessage methods */
    STDMETHOD(get_Application)(THIS_ DIGWSession FAR* FAR* retval) PURE;
    STDMETHOD(get_Attachments)(THIS_ DIGWAttachments FAR* FAR* retval) PURE;
    STDMETHOD(get_BodyText)(THIS_ DIGWFormattedText FAR* FAR* retval) PURE;
    STDMETHOD(get_BoxType)(THIS_ MessageBoxTypeConstants FAR* retval) PURE;
    STDMETHOD(get_ClassName)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(put_ClassName)(THIS_ BSTR pClass) PURE;
    STDMETHOD(get_ConvertAttachments)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_ConvertAttachments)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_CreationDate)(THIS_ DATE FAR* retval) PURE;
    STDMETHOD(get_Deleted)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(get_DownloadStatus)(THIS_ DIGWDownloadStatus FAR* FAR* retval) PURE;
    STDMETHOD(get_EnclosingFolders)(THIS_ DIGWFolders FAR* FAR* retval) PURE;
    STDMETHOD(get_ExpandedRecipients)(THIS_ DIGWRecipients FAR* FAR* retval) PURE;
    STDMETHOD(get_Fields)(THIS_ DIGWFields FAR* FAR* retval) PURE;
    STDMETHOD(get_FromText)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(put_FromText)(THIS_ BSTR Text) PURE;
    STDMETHOD(get_Hidden)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Hidden)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_MessageID)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(get_NotifyWhenDeleted)(THIS_ NotifyMessageConstants FAR* retval) PURE;
    STDMETHOD(put_NotifyWhenDeleted)(THIS_ NotifyMessageConstants How) PURE;
    STDMETHOD(get_NotifyWhenOpened)(THIS_ NotifyMessageConstants FAR* retval) PURE;
    STDMETHOD(put_NotifyWhenOpened)(THIS_ NotifyMessageConstants How) PURE;
    STDMETHOD(get_Opened)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Opened)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_Parent)(THIS_ DIGWAccount FAR* FAR* retval) PURE;
    STDMETHOD(get_Priority)(THIS_ MessagePriorityConstants FAR* retval) PURE;
    STDMETHOD(put_Priority)(THIS_ MessagePriorityConstants Priority) PURE;
    STDMETHOD(get_Read)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Read)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_Recipients)(THIS_ DIGWRecipients FAR* FAR* retval) PURE;
    STDMETHOD(get_ReplyChildren)(THIS_ DIGWMessageList FAR* FAR* retval) PURE;
    STDMETHOD(get_ReplyDaysRequested)(THIS_ int FAR* retval) PURE;
    STDMETHOD(put_ReplyDaysRequested)(THIS_ int Days) PURE;
    STDMETHOD(get_ReplyParent)(THIS_ DIGWMessage FAR* FAR* retval) PURE;
    STDMETHOD(get_ReplyRequested)(THIS_ ReplyRequestedConstants FAR* retval) PURE;
    STDMETHOD(put_ReplyRequested)(THIS_ ReplyRequestedConstants When) PURE;
    STDMETHOD(get_ReplyRoot)(THIS_ DIGWMessage FAR* FAR* retval) PURE;
    STDMETHOD(get_Routed)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Routed)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_RoutingEndOfLine)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(get_Sender)(THIS_ DIGWAddress FAR* FAR* retval) PURE;
    STDMETHOD(get_Subject)(THIS_ DIGWFormattedText FAR* FAR* retval) PURE;
    STDMETHOD(get_ViewName)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(put_ViewName)(THIS_ BSTR pClass) PURE;
    STDMETHOD(Annotate)(THIS_ DIGWNote2 FAR* Note) PURE;
    STDMETHOD(Clone)(THIS_ DIGWMessage FAR* FAR* retval) PURE;
    STDMETHOD(Delete)(THIS) PURE;
    STDMETHOD(Forward)(THIS_ DIGWMail FAR* FAR* retval) PURE;
    STDMETHOD(Refresh)(THIS) PURE;
    STDMETHOD(Reply)(THIS_ VARIANT ClassName, VARIANT ReplyToAll, VARIANT IncludeSenderMessageText, VARIANT AttachOriginalMessage, DIGWMessage FAR* FAR* retval) PURE;
    STDMETHOD(Retract)(THIS) PURE;
    STDMETHOD(Send)(THIS_ DIGWMessage FAR* FAR* retval) PURE;

    /* IGWMessage2 methods */
    STDMETHOD(get_ModifiedDate)(THIS_ DATE FAR* retval) PURE;
    STDMETHOD(get_Private)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Private)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_RevisionNumber)(THIS_ long FAR* retval) PURE;
    STDMETHOD(get_MasterRevisionNumber)(THIS_ long FAR* retval) PURE;
#endif

    /* IGWTask_m2 methods */
    STDMETHOD(get_Accepted)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(get_AssignedDate)(THIS_ DATE FAR* retval) PURE;
    STDMETHOD(put_AssignedDate)(THIS_ DATE Date) PURE;
    STDMETHOD(get_Autodate)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(get_AutodateMessages)(THIS_ DIGWMessageList FAR* FAR* retval) PURE;
    STDMETHOD(get_Completed)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Completed)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_Delegated)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(get_DueDate)(THIS_ DATE FAR* retval) PURE;
    STDMETHOD(put_DueDate)(THIS_ DATE Date) PURE;
    STDMETHOD(get_NotifyWhenCompleted)(THIS_ NotifyMessageConstants FAR* retval) PURE;
    STDMETHOD(put_NotifyWhenCompleted)(THIS_ NotifyMessageConstants How) PURE;
    STDMETHOD(get_OnCalendar)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_OnCalendar)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_Personal)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(get_StartDate)(THIS_ DATE FAR* retval) PURE;
    STDMETHOD(put_StartDate)(THIS_ DATE Date) PURE;
    STDMETHOD(get_TaskCategory)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(put_TaskCategory)(THIS_ BSTR name) PURE;
    STDMETHOD(get_TaskPriority)(THIS_ int FAR* retval) PURE;
    STDMETHOD(put_TaskPriority)(THIS_ int Priority) PURE;
    STDMETHOD(Accept)(THIS_ VARIANT Comment, VARIANT AllInstances) PURE;
    STDMETHOD(Decline)(THIS_ VARIANT Comment, VARIANT AllInstances) PURE;
    STDMETHOD(Delegate)(THIS_ VARIANT AllInstances, DIGWTask2 FAR* FAR* retval) PURE;
    STDMETHOD(MoveToMasterTaskList)(THIS) PURE;
};

DEFINE_GUID(IID_IGWTask2,0x7E000020L,0xE158,0x11CE,0x87,0xEB,0x00,0x80,0x5F,0xB4,0xB2,0xBE);

/* Definition of interface: IGWTask2 */
#undef INTERFACE
#define INTERFACE IGWTask2

DECLARE_INTERFACE_(IGWTask2, IGWTask_m2)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IGWMessage methods */
    STDMETHOD(get_Application)(THIS_ DIGWSession FAR* FAR* retval) PURE;
    STDMETHOD(get_Attachments)(THIS_ DIGWAttachments FAR* FAR* retval) PURE;
    STDMETHOD(get_BodyText)(THIS_ DIGWFormattedText FAR* FAR* retval) PURE;
    STDMETHOD(get_BoxType)(THIS_ MessageBoxTypeConstants FAR* retval) PURE;
    STDMETHOD(get_ClassName)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(put_ClassName)(THIS_ BSTR pClass) PURE;
    STDMETHOD(get_ConvertAttachments)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_ConvertAttachments)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_CreationDate)(THIS_ DATE FAR* retval) PURE;
    STDMETHOD(get_Deleted)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(get_DownloadStatus)(THIS_ DIGWDownloadStatus FAR* FAR* retval) PURE;
    STDMETHOD(get_EnclosingFolders)(THIS_ DIGWFolders FAR* FAR* retval) PURE;
    STDMETHOD(get_ExpandedRecipients)(THIS_ DIGWRecipients FAR* FAR* retval) PURE;
    STDMETHOD(get_Fields)(THIS_ DIGWFields FAR* FAR* retval) PURE;
    STDMETHOD(get_FromText)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(put_FromText)(THIS_ BSTR Text) PURE;
    STDMETHOD(get_Hidden)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Hidden)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_MessageID)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(get_NotifyWhenDeleted)(THIS_ NotifyMessageConstants FAR* retval) PURE;
    STDMETHOD(put_NotifyWhenDeleted)(THIS_ NotifyMessageConstants How) PURE;
    STDMETHOD(get_NotifyWhenOpened)(THIS_ NotifyMessageConstants FAR* retval) PURE;
    STDMETHOD(put_NotifyWhenOpened)(THIS_ NotifyMessageConstants How) PURE;
    STDMETHOD(get_Opened)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Opened)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_Parent)(THIS_ DIGWAccount FAR* FAR* retval) PURE;
    STDMETHOD(get_Priority)(THIS_ MessagePriorityConstants FAR* retval) PURE;
    STDMETHOD(put_Priority)(THIS_ MessagePriorityConstants Priority) PURE;
    STDMETHOD(get_Read)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Read)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_Recipients)(THIS_ DIGWRecipients FAR* FAR* retval) PURE;
    STDMETHOD(get_ReplyChildren)(THIS_ DIGWMessageList FAR* FAR* retval) PURE;
    STDMETHOD(get_ReplyDaysRequested)(THIS_ int FAR* retval) PURE;
    STDMETHOD(put_ReplyDaysRequested)(THIS_ int Days) PURE;
    STDMETHOD(get_ReplyParent)(THIS_ DIGWMessage FAR* FAR* retval) PURE;
    STDMETHOD(get_ReplyRequested)(THIS_ ReplyRequestedConstants FAR* retval) PURE;
    STDMETHOD(put_ReplyRequested)(THIS_ ReplyRequestedConstants When) PURE;
    STDMETHOD(get_ReplyRoot)(THIS_ DIGWMessage FAR* FAR* retval) PURE;
    STDMETHOD(get_Routed)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Routed)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_RoutingEndOfLine)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(get_Sender)(THIS_ DIGWAddress FAR* FAR* retval) PURE;
    STDMETHOD(get_Subject)(THIS_ DIGWFormattedText FAR* FAR* retval) PURE;
    STDMETHOD(get_ViewName)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(put_ViewName)(THIS_ BSTR pClass) PURE;
    STDMETHOD(Annotate)(THIS_ DIGWNote2 FAR* Note) PURE;
    STDMETHOD(Clone)(THIS_ DIGWMessage FAR* FAR* retval) PURE;
    STDMETHOD(Delete)(THIS) PURE;
    STDMETHOD(Forward)(THIS_ DIGWMail FAR* FAR* retval) PURE;
    STDMETHOD(Refresh)(THIS) PURE;
    STDMETHOD(Reply)(THIS_ VARIANT ClassName, VARIANT ReplyToAll, VARIANT IncludeSenderMessageText, VARIANT AttachOriginalMessage, DIGWMessage FAR* FAR* retval) PURE;
    STDMETHOD(Retract)(THIS) PURE;
    STDMETHOD(Send)(THIS_ DIGWMessage FAR* FAR* retval) PURE;

    /* IGWMessage2 methods */
    STDMETHOD(get_ModifiedDate)(THIS_ DATE FAR* retval) PURE;
    STDMETHOD(get_Private)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Private)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_RevisionNumber)(THIS_ long FAR* retval) PURE;
    STDMETHOD(get_MasterRevisionNumber)(THIS_ long FAR* retval) PURE;

    /* IGWTask_m2 methods */
    STDMETHOD(get_Accepted)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(get_AssignedDate)(THIS_ DATE FAR* retval) PURE;
    STDMETHOD(put_AssignedDate)(THIS_ DATE Date) PURE;
    STDMETHOD(get_Autodate)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(get_AutodateMessages)(THIS_ DIGWMessageList FAR* FAR* retval) PURE;
    STDMETHOD(get_Completed)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Completed)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_Delegated)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(get_DueDate)(THIS_ DATE FAR* retval) PURE;
    STDMETHOD(put_DueDate)(THIS_ DATE Date) PURE;
    STDMETHOD(get_NotifyWhenCompleted)(THIS_ NotifyMessageConstants FAR* retval) PURE;
    STDMETHOD(put_NotifyWhenCompleted)(THIS_ NotifyMessageConstants How) PURE;
    STDMETHOD(get_OnCalendar)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_OnCalendar)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_Personal)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(get_StartDate)(THIS_ DATE FAR* retval) PURE;
    STDMETHOD(put_StartDate)(THIS_ DATE Date) PURE;
    STDMETHOD(get_TaskCategory)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(put_TaskCategory)(THIS_ BSTR name) PURE;
    STDMETHOD(get_TaskPriority)(THIS_ int FAR* retval) PURE;
    STDMETHOD(put_TaskPriority)(THIS_ int Priority) PURE;
    STDMETHOD(Accept)(THIS_ VARIANT Comment, VARIANT AllInstances) PURE;
    STDMETHOD(Decline)(THIS_ VARIANT Comment, VARIANT AllInstances) PURE;
    STDMETHOD(Delegate)(THIS_ VARIANT AllInstances, DIGWTask2 FAR* FAR* retval) PURE;
    STDMETHOD(MoveToMasterTaskList)(THIS) PURE;
#endif

    /* IGWTask2 methods */
    STDMETHOD(get_NotifyWhenAccepted)(THIS_ NotifyMessageConstants FAR* retval) PURE;
    STDMETHOD(put_NotifyWhenAccepted)(THIS_ NotifyMessageConstants How) PURE;
    STDMETHOD(get_NotifyWhenDeclined)(THIS_ NotifyMessageConstants FAR* retval) PURE;
    STDMETHOD(put_NotifyWhenDeclined)(THIS_ NotifyMessageConstants How) PURE;
};

DEFINE_GUID(IID_IGWTask3,0x481ED629L,0x4EFF,0x11D1,0x8D,0x79,0x00,0x80,0x5F,0xC1,0x28,0xBA);

/* Definition of interface: IGWTask3 */
#undef INTERFACE
#define INTERFACE IGWTask3

DECLARE_INTERFACE_(IGWTask3, IGWTask_m2)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IGWMessage methods */
    STDMETHOD(get_Application)(THIS_ DIGWSession FAR* FAR* retval) PURE;
    STDMETHOD(get_Attachments)(THIS_ DIGWAttachments FAR* FAR* retval) PURE;
    STDMETHOD(get_BodyText)(THIS_ DIGWFormattedText FAR* FAR* retval) PURE;
    STDMETHOD(get_BoxType)(THIS_ MessageBoxTypeConstants FAR* retval) PURE;
    STDMETHOD(get_ClassName)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(put_ClassName)(THIS_ BSTR pClass) PURE;
    STDMETHOD(get_ConvertAttachments)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_ConvertAttachments)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_CreationDate)(THIS_ DATE FAR* retval) PURE;
    STDMETHOD(get_Deleted)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(get_DownloadStatus)(THIS_ DIGWDownloadStatus FAR* FAR* retval) PURE;
    STDMETHOD(get_EnclosingFolders)(THIS_ DIGWFolders FAR* FAR* retval) PURE;
    STDMETHOD(get_ExpandedRecipients)(THIS_ DIGWRecipients FAR* FAR* retval) PURE;
    STDMETHOD(get_Fields)(THIS_ DIGWFields FAR* FAR* retval) PURE;
    STDMETHOD(get_FromText)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(put_FromText)(THIS_ BSTR Text) PURE;
    STDMETHOD(get_Hidden)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Hidden)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_MessageID)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(get_NotifyWhenDeleted)(THIS_ NotifyMessageConstants FAR* retval) PURE;
    STDMETHOD(put_NotifyWhenDeleted)(THIS_ NotifyMessageConstants How) PURE;
    STDMETHOD(get_NotifyWhenOpened)(THIS_ NotifyMessageConstants FAR* retval) PURE;
    STDMETHOD(put_NotifyWhenOpened)(THIS_ NotifyMessageConstants How) PURE;
    STDMETHOD(get_Opened)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Opened)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_Parent)(THIS_ DIGWAccount FAR* FAR* retval) PURE;
    STDMETHOD(get_Priority)(THIS_ MessagePriorityConstants FAR* retval) PURE;
    STDMETHOD(put_Priority)(THIS_ MessagePriorityConstants Priority) PURE;
    STDMETHOD(get_Read)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Read)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_Recipients)(THIS_ DIGWRecipients FAR* FAR* retval) PURE;
    STDMETHOD(get_ReplyChildren)(THIS_ DIGWMessageList FAR* FAR* retval) PURE;
    STDMETHOD(get_ReplyDaysRequested)(THIS_ int FAR* retval) PURE;
    STDMETHOD(put_ReplyDaysRequested)(THIS_ int Days) PURE;
    STDMETHOD(get_ReplyParent)(THIS_ DIGWMessage FAR* FAR* retval) PURE;
    STDMETHOD(get_ReplyRequested)(THIS_ ReplyRequestedConstants FAR* retval) PURE;
    STDMETHOD(put_ReplyRequested)(THIS_ ReplyRequestedConstants When) PURE;
    STDMETHOD(get_ReplyRoot)(THIS_ DIGWMessage FAR* FAR* retval) PURE;
    STDMETHOD(get_Routed)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Routed)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_RoutingEndOfLine)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(get_Sender)(THIS_ DIGWAddress FAR* FAR* retval) PURE;
    STDMETHOD(get_Subject)(THIS_ DIGWFormattedText FAR* FAR* retval) PURE;
    STDMETHOD(get_ViewName)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(put_ViewName)(THIS_ BSTR pClass) PURE;
    STDMETHOD(Annotate)(THIS_ DIGWNote2 FAR* Note) PURE;
    STDMETHOD(Clone)(THIS_ DIGWMessage FAR* FAR* retval) PURE;
    STDMETHOD(Delete)(THIS) PURE;
    STDMETHOD(Forward)(THIS_ DIGWMail FAR* FAR* retval) PURE;
    STDMETHOD(Refresh)(THIS) PURE;
    STDMETHOD(Reply)(THIS_ VARIANT ClassName, VARIANT ReplyToAll, VARIANT IncludeSenderMessageText, VARIANT AttachOriginalMessage, DIGWMessage FAR* FAR* retval) PURE;
    STDMETHOD(Retract)(THIS) PURE;
    STDMETHOD(Send)(THIS_ DIGWMessage FAR* FAR* retval) PURE;

    /* IGWMessage2 methods */
    STDMETHOD(get_ModifiedDate)(THIS_ DATE FAR* retval) PURE;
    STDMETHOD(get_Private)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Private)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_RevisionNumber)(THIS_ long FAR* retval) PURE;
    STDMETHOD(get_MasterRevisionNumber)(THIS_ long FAR* retval) PURE;

    /* IGWTask_m2 methods */
    STDMETHOD(get_Accepted)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(get_AssignedDate)(THIS_ DATE FAR* retval) PURE;
    STDMETHOD(put_AssignedDate)(THIS_ DATE Date) PURE;
    STDMETHOD(get_Autodate)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(get_AutodateMessages)(THIS_ DIGWMessageList FAR* FAR* retval) PURE;
    STDMETHOD(get_Completed)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Completed)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_Delegated)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(get_DueDate)(THIS_ DATE FAR* retval) PURE;
    STDMETHOD(put_DueDate)(THIS_ DATE Date) PURE;
    STDMETHOD(get_NotifyWhenCompleted)(THIS_ NotifyMessageConstants FAR* retval) PURE;
    STDMETHOD(put_NotifyWhenCompleted)(THIS_ NotifyMessageConstants How) PURE;
    STDMETHOD(get_OnCalendar)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_OnCalendar)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_Personal)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(get_StartDate)(THIS_ DATE FAR* retval) PURE;
    STDMETHOD(put_StartDate)(THIS_ DATE Date) PURE;
    STDMETHOD(get_TaskCategory)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(put_TaskCategory)(THIS_ BSTR name) PURE;
    STDMETHOD(get_TaskPriority)(THIS_ int FAR* retval) PURE;
    STDMETHOD(put_TaskPriority)(THIS_ int Priority) PURE;
    STDMETHOD(Accept)(THIS_ VARIANT Comment, VARIANT AllInstances) PURE;
    STDMETHOD(Decline)(THIS_ VARIANT Comment, VARIANT AllInstances) PURE;
    STDMETHOD(Delegate)(THIS_ VARIANT AllInstances, DIGWTask2 FAR* FAR* retval) PURE;
    STDMETHOD(MoveToMasterTaskList)(THIS) PURE;
#endif

    /* IGWTask3 methods */
    STDMETHOD(get_NotifyWhenAccepted)(THIS_ NotifyMessageConstants FAR* retval) PURE;
    STDMETHOD(put_NotifyWhenAccepted)(THIS_ NotifyMessageConstants How) PURE;
    STDMETHOD(get_NotifyWhenDeclined)(THIS_ NotifyMessageConstants FAR* retval) PURE;
    STDMETHOD(put_NotifyWhenDeclined)(THIS_ NotifyMessageConstants How) PURE;
    STDMETHOD(get_Archived)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Archived)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_Sharer)(THIS_ DIGWAddress FAR* FAR* retval) PURE;
    STDMETHOD(LocalDelete)(THIS) PURE;
};

DEFINE_GUID(DIID_DIGWTask2,0x7E000021L,0xE158,0x11CE,0x87,0xEB,0x00,0x80,0x5F,0xB4,0xB2,0xBE);

/* Definition of dispatch interface: DIGWTask2 */
#undef INTERFACE
#define INTERFACE DIGWTask2

DECLARE_INTERFACE_(DIGWTask2, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;
#endif

/* Capable of dispatching all the methods of interface IGWTask2 */
};

DEFINE_GUID(DIID_DIGWTask3,0x7E000029L,0xE158,0x11CE,0x87,0xEB,0x00,0x80,0x5F,0xB4,0xB2,0xBE);

/* Definition of dispatch interface: DIGWTask3 */
#undef INTERFACE
#define INTERFACE DIGWTask3

DECLARE_INTERFACE_(DIGWTask3, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;
#endif

/* Capable of dispatching all the methods of interface IGWTask3 */
};

DEFINE_GUID(CLSID_Task,0xC89C2F70L,0x04AF,0x11CF,0xB0,0x49,0x00,0x80,0x5F,0x88,0xE6,0x02);

#ifdef __cplusplus
class Task;
#endif

DEFINE_GUID(CLSID_Task2,0xC89C2F79L,0x04AF,0x11CF,0xB0,0x49,0x00,0x80,0x5F,0x88,0xE6,0x02);

#ifdef __cplusplus
class Task2;
#endif

DEFINE_GUID(CLSID_Task3,0x1DF2AFFCL,0xF4CB,0x11D1,0x8D,0x8F,0x00,0x80,0x5F,0xC1,0x00,0xD4);

#ifdef __cplusplus
class Task3;
#endif

DEFINE_GUID(IID_IGWTimeBlock,0x95DF5426L,0x0AEA,0x11CF,0x97,0xF6,0x00,0x60,0x8C,0xE8,0x2F,0x4D);

/* Definition of interface: IGWTimeBlock */
#undef INTERFACE
#define INTERFACE IGWTimeBlock

DECLARE_INTERFACE_(IGWTimeBlock, IUnknown)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;
#endif

    /* IGWTimeBlock methods */
    STDMETHOD(get_StartDate)(THIS_ DATE FAR* retval) PURE;
    STDMETHOD(get_EndDate)(THIS_ DATE FAR* retval) PURE;
    STDMETHOD(get_Duration)(THIS_ double FAR* retval) PURE;
    STDMETHOD(get_ObjType)(THIS_ TimeBlockConstants FAR* pTType) PURE;
    STDMETHOD(get_From)(THIS_ DIGWAddress FAR* FAR* retval) PURE;
    STDMETHOD(get_Place)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(get_Subject)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(get_Application)(THIS_ DIGWSession FAR* FAR* retval) PURE;
    STDMETHOD(get_Parent)(THIS_ DIGWTimeBlocks FAR* FAR* retval) PURE;
};

DEFINE_GUID(DIID_DIGWTimeBlock,0x95DF5427L,0x0AEA,0x11CF,0x97,0xF6,0x00,0x60,0x8C,0xE8,0x2F,0x4D);

/* Definition of dispatch interface: DIGWTimeBlock */
#undef INTERFACE
#define INTERFACE DIGWTimeBlock

DECLARE_INTERFACE_(DIGWTimeBlock, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;
#endif

/* Capable of dispatching all the methods of interface IGWTimeBlock */
};

DEFINE_GUID(CLSID_TimeBlock,0xC89C2D71L,0x04AF,0x11CF,0xB0,0x49,0x00,0x80,0x5F,0x88,0xE6,0x02);

#ifdef __cplusplus
class TimeBlock;
#endif

DEFINE_GUID(IID_IGWTimeBlocks,0x95DF5428L,0x0AEA,0x11CF,0x97,0xF6,0x00,0x60,0x8C,0xE8,0x2F,0x4D);

/* Definition of interface: IGWTimeBlocks */
#undef INTERFACE
#define INTERFACE IGWTimeBlocks

DECLARE_INTERFACE_(IGWTimeBlocks, IUnknown)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;
#endif

    /* IGWTimeBlocks methods */
    STDMETHOD(Item)(THIS_ long Index, DIGWTimeBlock FAR* FAR* retval) PURE;
    STDMETHOD(get_Count)(THIS_ long FAR* retval) PURE;
    STDMETHOD(get__NewEnum)(THIS_ IUnknown * FAR* retval) PURE;
    STDMETHOD(get_Application)(THIS_ DIGWSession FAR* FAR* retval) PURE;
    STDMETHOD(get_Parent)(THIS_ DIGWBusySearchElement FAR* FAR* retval) PURE;
};

DEFINE_GUID(DIID_DIGWTimeBlocks,0x95DF5429L,0x0AEA,0x11CF,0x97,0xF6,0x00,0x60,0x8C,0xE8,0x2F,0x4D);

/* Definition of dispatch interface: DIGWTimeBlocks */
#undef INTERFACE
#define INTERFACE DIGWTimeBlocks

DECLARE_INTERFACE_(DIGWTimeBlocks, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;
#endif

/* Capable of dispatching all the methods of interface IGWTimeBlocks */
};

DEFINE_GUID(CLSID_TimeBlocks,0xC89C2D72L,0x04AF,0x11CF,0xB0,0x49,0x00,0x80,0x5F,0x88,0xE6,0x02);

#ifdef __cplusplus
class TimeBlocks;
#endif

DEFINE_GUID(IID_IGWTrash,0x7D2265FAL,0xE158,0x11CE,0x87,0xEB,0x00,0x80,0x5F,0xB4,0xB2,0xBE);

/* Definition of interface: IGWTrash */
#undef INTERFACE
#define INTERFACE IGWTrash

DECLARE_INTERFACE_(IGWTrash, IUnknown)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;
#endif

    /* IGWTrash methods */
    STDMETHOD(get_Application)(THIS_ DIGWSession FAR* FAR* retval) PURE;
    STDMETHOD(get_Name)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(get_Parent)(THIS_ DIGWAccount FAR* FAR* retval) PURE;
    STDMETHOD(get_TrashEntries)(THIS_ DIGWTrashEntries FAR* FAR* retval) PURE;
    STDMETHOD(Empty)(THIS) PURE;
    STDMETHOD(Refresh)(THIS) PURE;
};

DEFINE_GUID(DIID_DIGWTrash,0x7D2265FBL,0xE158,0x11CE,0x87,0xEB,0x00,0x80,0x5F,0xB4,0xB2,0xBE);

/* Definition of dispatch interface: DIGWTrash */
#undef INTERFACE
#define INTERFACE DIGWTrash

DECLARE_INTERFACE_(DIGWTrash, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;
#endif

/* Capable of dispatching all the methods of interface IGWTrash */
};

DEFINE_GUID(CLSID_Trash,0xC89C2E75L,0x04AF,0x11CF,0xB0,0x49,0x00,0x80,0x5F,0x88,0xE6,0x02);

#ifdef __cplusplus
class Trash;
#endif

DEFINE_GUID(IID_IGWTrashEntry,0x7D2265FCL,0xE158,0x11CE,0x87,0xEB,0x00,0x80,0x5F,0xB4,0xB2,0xBE);

/* Definition of interface: IGWTrashEntry */
#undef INTERFACE
#define INTERFACE IGWTrashEntry

DECLARE_INTERFACE_(IGWTrashEntry, IUnknown)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;
#endif

    /* IGWTrashEntry methods */
    STDMETHOD(get_Application)(THIS_ DIGWSession FAR* FAR* retval) PURE;
    STDMETHOD(get_Folder)(THIS_ DIGWFolder FAR* FAR* retval) PURE;
    STDMETHOD(get_Message)(THIS_ DIGWMessage FAR* FAR* retval) PURE;
    STDMETHOD(get_Parent)(THIS_ DIGWTrashEntries FAR* FAR* retval) PURE;
    STDMETHOD(Delete)(THIS) PURE;
    STDMETHOD(Undelete)(THIS) PURE;
};

DEFINE_GUID(DIID_DIGWTrashEntry,0x7D2265FDL,0xE158,0x11CE,0x87,0xEB,0x00,0x80,0x5F,0xB4,0xB2,0xBE);

/* Definition of dispatch interface: DIGWTrashEntry */
#undef INTERFACE
#define INTERFACE DIGWTrashEntry

DECLARE_INTERFACE_(DIGWTrashEntry, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;
#endif

/* Capable of dispatching all the methods of interface IGWTrashEntry */
};

DEFINE_GUID(CLSID_TrashEntry,0xC89C2E76L,0x04AF,0x11CF,0xB0,0x49,0x00,0x80,0x5F,0x88,0xE6,0x02);

#ifdef __cplusplus
class TrashEntry;
#endif

DEFINE_GUID(IID_IGWTrashEntries,0x7D2265FEL,0xE158,0x11CE,0x87,0xEB,0x00,0x80,0x5F,0xB4,0xB2,0xBE);

/* Definition of interface: IGWTrashEntries */
#undef INTERFACE
#define INTERFACE IGWTrashEntries

DECLARE_INTERFACE_(IGWTrashEntries, IUnknown)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;
#endif

    /* IGWTrashEntries methods */
    STDMETHOD(get_Application)(THIS_ DIGWSession FAR* FAR* retval) PURE;
    STDMETHOD(get_Count)(THIS_ long FAR* retval) PURE;
    STDMETHOD(get__NewEnum)(THIS_ IUnknown * FAR* retval) PURE;
    STDMETHOD(get_Parent)(THIS_ IDispatch * FAR* retval) PURE;
    STDMETHOD(Find)(THIS_ VARIANT Condition, DIGWTrashEntries FAR* FAR* retval) PURE;
    STDMETHOD(Item)(THIS_ long Index, DIGWTrashEntry FAR* FAR* retval) PURE;
};

DEFINE_GUID(IID_IGWTrashEntries2,0xB6540B00L,0xF4DD,0x11D1,0xB4,0x9F,0x00,0x80,0x5F,0x36,0xA3,0x75);

/* Definition of interface: IGWTrashEntries2 */
#undef INTERFACE
#define INTERFACE IGWTrashEntries2

DECLARE_INTERFACE_(IGWTrashEntries2, IGWTrashEntries)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IGWTrashEntries methods */
    STDMETHOD(get_Application)(THIS_ DIGWSession FAR* FAR* retval) PURE;
    STDMETHOD(get_Count)(THIS_ long FAR* retval) PURE;
    STDMETHOD(get__NewEnum)(THIS_ IUnknown * FAR* retval) PURE;
    STDMETHOD(get_Parent)(THIS_ IDispatch * FAR* retval) PURE;
    STDMETHOD(Find)(THIS_ VARIANT Condition, DIGWTrashEntries FAR* FAR* retval) PURE;
    STDMETHOD(Item)(THIS_ long Index, DIGWTrashEntry FAR* FAR* retval) PURE;
#endif

    /* IGWTrashEntries2 methods */
    STDMETHOD(ItemEx)(THIS_ VARIANT Index, DIGWTrashEntry FAR* FAR* retval) PURE;
};

DEFINE_GUID(DIID_DIGWTrashEntries,0x7D2265FFL,0xE158,0x11CE,0x87,0xEB,0x00,0x80,0x5F,0xB4,0xB2,0xBE);

/* Definition of dispatch interface: DIGWTrashEntries */
#undef INTERFACE
#define INTERFACE DIGWTrashEntries

DECLARE_INTERFACE_(DIGWTrashEntries, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;
#endif

/* Capable of dispatching all the methods of interface IGWTrashEntries */
};

DEFINE_GUID(DIID_DIGWTrashEntries2,0xB6540B01L,0xF4DD,0x11D1,0xB4,0x9F,0x00,0x80,0x5F,0x36,0xA3,0x75);

/* Definition of dispatch interface: DIGWTrashEntries2 */
#undef INTERFACE
#define INTERFACE DIGWTrashEntries2

DECLARE_INTERFACE_(DIGWTrashEntries2, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;
#endif

/* Capable of dispatching all the methods of interface IGWTrashEntries2 */
};

DEFINE_GUID(CLSID_TrashEntries,0xC89C2E77L,0x04AF,0x11CF,0xB0,0x49,0x00,0x80,0x5F,0x88,0xE6,0x02);

#ifdef __cplusplus
class TrashEntries;
#endif

DEFINE_GUID(CLSID_TrashEntries2,0xB6540B02L,0xF4DD,0x11D1,0xB4,0x9F,0x00,0x80,0x5F,0x36,0xA3,0x75);

#ifdef __cplusplus
class TrashEntries2;
#endif

DEFINE_GUID(IID_IGWLookupTableEntry,0xF61EC4C0L,0xBD82,0x11D0,0xB3,0x34,0x00,0x80,0x5F,0x36,0xA3,0x75);

/* Definition of interface: IGWLookupTableEntry */
#undef INTERFACE
#define INTERFACE IGWLookupTableEntry

DECLARE_INTERFACE_(IGWLookupTableEntry, IUnknown)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;
#endif

    /* IGWLookupTableEntry methods */
    STDMETHOD(get_Application)(THIS_ DIGWSession FAR* FAR* retval) PURE;
    STDMETHOD(get_Parent)(THIS_ DIGWLookupTableEntries FAR* FAR* retval) PURE;
    STDMETHOD(get_Value)(THIS_ VARIANT FAR* retval) PURE;
};

DEFINE_GUID(DIID_DIGWLookupTableEntry,0xF61EC4C1L,0xBD82,0x11D0,0xB3,0x34,0x00,0x80,0x5F,0x36,0xA3,0x75);

/* Definition of dispatch interface: DIGWLookupTableEntry */
#undef INTERFACE
#define INTERFACE DIGWLookupTableEntry

DECLARE_INTERFACE_(DIGWLookupTableEntry, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;
#endif

/* Capable of dispatching all the methods of interface IGWLookupTableEntry */
};

DEFINE_GUID(CLSID_LookupTableEntry,0xF61EC4C2L,0xBD82,0x11D0,0xB3,0x34,0x00,0x80,0x5F,0x36,0xA3,0x75);

#ifdef __cplusplus
class LookupTableEntry;
#endif

DEFINE_GUID(IID_IGWLookupTableEntries,0xF61EC4C3L,0xBD82,0x11D0,0xB3,0x34,0x00,0x80,0x5F,0x36,0xA3,0x75);

/* Definition of interface: IGWLookupTableEntries */
#undef INTERFACE
#define INTERFACE IGWLookupTableEntries

DECLARE_INTERFACE_(IGWLookupTableEntries, IUnknown)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;
#endif

    /* IGWLookupTableEntries methods */
    STDMETHOD(Item)(THIS_ long lIndex, DIGWLookupTableEntry FAR* FAR* retval) PURE;
    STDMETHOD(get_Application)(THIS_ DIGWSession FAR* FAR* retval) PURE;
    STDMETHOD(get_Count)(THIS_ long FAR* retval) PURE;
    STDMETHOD(get__NewEnum)(THIS_ IUnknown * FAR* retval) PURE;
    STDMETHOD(get_Parent)(THIS_ DIGWFieldDefinition FAR* FAR* retval) PURE;
};

DEFINE_GUID(DIID_DIGWLookupTableEntries,0xF61EC4C4L,0xBD82,0x11D0,0xB3,0x34,0x00,0x80,0x5F,0x36,0xA3,0x75);

/* Definition of dispatch interface: DIGWLookupTableEntries */
#undef INTERFACE
#define INTERFACE DIGWLookupTableEntries

DECLARE_INTERFACE_(DIGWLookupTableEntries, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;
#endif

/* Capable of dispatching all the methods of interface IGWLookupTableEntries */
};

DEFINE_GUID(CLSID_LookupTableEntries,0xF61EC4C5L,0xBD82,0x11D0,0xB3,0x34,0x00,0x80,0x5F,0x36,0xA3,0x75);

#ifdef __cplusplus
class LookupTableEntries;
#endif

DEFINE_GUID(IID_IGWSharedNotification,0xD6647B00L,0x65CF,0x11D1,0x8D,0x82,0x00,0x80,0x5F,0xC1,0x28,0xBA);

/* Definition of interface: IGWSharedNotification */
#undef INTERFACE
#define INTERFACE IGWSharedNotification

DECLARE_INTERFACE_(IGWSharedNotification, IGWMessage3)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IGWMessage methods */
    STDMETHOD(get_Application)(THIS_ DIGWSession FAR* FAR* retval) PURE;
    STDMETHOD(get_Attachments)(THIS_ DIGWAttachments FAR* FAR* retval) PURE;
    STDMETHOD(get_BodyText)(THIS_ DIGWFormattedText FAR* FAR* retval) PURE;
    STDMETHOD(get_BoxType)(THIS_ MessageBoxTypeConstants FAR* retval) PURE;
    STDMETHOD(get_ClassName)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(put_ClassName)(THIS_ BSTR pClass) PURE;
    STDMETHOD(get_ConvertAttachments)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_ConvertAttachments)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_CreationDate)(THIS_ DATE FAR* retval) PURE;
    STDMETHOD(get_Deleted)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(get_DownloadStatus)(THIS_ DIGWDownloadStatus FAR* FAR* retval) PURE;
    STDMETHOD(get_EnclosingFolders)(THIS_ DIGWFolders FAR* FAR* retval) PURE;
    STDMETHOD(get_ExpandedRecipients)(THIS_ DIGWRecipients FAR* FAR* retval) PURE;
    STDMETHOD(get_Fields)(THIS_ DIGWFields FAR* FAR* retval) PURE;
    STDMETHOD(get_FromText)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(put_FromText)(THIS_ BSTR Text) PURE;
    STDMETHOD(get_Hidden)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Hidden)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_MessageID)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(get_NotifyWhenDeleted)(THIS_ NotifyMessageConstants FAR* retval) PURE;
    STDMETHOD(put_NotifyWhenDeleted)(THIS_ NotifyMessageConstants How) PURE;
    STDMETHOD(get_NotifyWhenOpened)(THIS_ NotifyMessageConstants FAR* retval) PURE;
    STDMETHOD(put_NotifyWhenOpened)(THIS_ NotifyMessageConstants How) PURE;
    STDMETHOD(get_Opened)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Opened)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_Parent)(THIS_ DIGWAccount FAR* FAR* retval) PURE;
    STDMETHOD(get_Priority)(THIS_ MessagePriorityConstants FAR* retval) PURE;
    STDMETHOD(put_Priority)(THIS_ MessagePriorityConstants Priority) PURE;
    STDMETHOD(get_Read)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Read)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_Recipients)(THIS_ DIGWRecipients FAR* FAR* retval) PURE;
    STDMETHOD(get_ReplyChildren)(THIS_ DIGWMessageList FAR* FAR* retval) PURE;
    STDMETHOD(get_ReplyDaysRequested)(THIS_ int FAR* retval) PURE;
    STDMETHOD(put_ReplyDaysRequested)(THIS_ int Days) PURE;
    STDMETHOD(get_ReplyParent)(THIS_ DIGWMessage FAR* FAR* retval) PURE;
    STDMETHOD(get_ReplyRequested)(THIS_ ReplyRequestedConstants FAR* retval) PURE;
    STDMETHOD(put_ReplyRequested)(THIS_ ReplyRequestedConstants When) PURE;
    STDMETHOD(get_ReplyRoot)(THIS_ DIGWMessage FAR* FAR* retval) PURE;
    STDMETHOD(get_Routed)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Routed)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_RoutingEndOfLine)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(get_Sender)(THIS_ DIGWAddress FAR* FAR* retval) PURE;
    STDMETHOD(get_Subject)(THIS_ DIGWFormattedText FAR* FAR* retval) PURE;
    STDMETHOD(get_ViewName)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(put_ViewName)(THIS_ BSTR pClass) PURE;
    STDMETHOD(Annotate)(THIS_ DIGWNote2 FAR* Note) PURE;
    STDMETHOD(Clone)(THIS_ DIGWMessage FAR* FAR* retval) PURE;
    STDMETHOD(Delete)(THIS) PURE;
    STDMETHOD(Forward)(THIS_ DIGWMail FAR* FAR* retval) PURE;
    STDMETHOD(Refresh)(THIS) PURE;
    STDMETHOD(Reply)(THIS_ VARIANT ClassName, VARIANT ReplyToAll, VARIANT IncludeSenderMessageText, VARIANT AttachOriginalMessage, DIGWMessage FAR* FAR* retval) PURE;
    STDMETHOD(Retract)(THIS) PURE;
    STDMETHOD(Send)(THIS_ DIGWMessage FAR* FAR* retval) PURE;

    /* IGWMessage2 methods */
    STDMETHOD(get_ModifiedDate)(THIS_ DATE FAR* retval) PURE;
    STDMETHOD(get_Private)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Private)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_RevisionNumber)(THIS_ long FAR* retval) PURE;
    STDMETHOD(get_MasterRevisionNumber)(THIS_ long FAR* retval) PURE;

    /* IGWMessage3 methods */
    STDMETHOD(get_Archived)(THIS_ VARIANT_BOOL FAR* retval) PURE;
    STDMETHOD(put_Archived)(THIS_ VARIANT_BOOL Flag) PURE;
    STDMETHOD(get_Sharer)(THIS_ DIGWAddress FAR* FAR* retval) PURE;
    STDMETHOD(LocalDelete)(THIS) PURE;
#endif

    /* IGWSharedNotification methods */
    STDMETHOD(Accept)(THIS_ VARIANT vr1, VARIANT vr2, VARIANT vr3) PURE;
    STDMETHOD(get_Description)(THIS_ BSTR FAR* retval) PURE;
    STDMETHOD(get_NotificationType)(THIS_ SharedNotificationTypeConstants FAR* retval) PURE;
    STDMETHOD(get_Name)(THIS_ BSTR FAR* retval) PURE;
};

DEFINE_GUID(DIID_DIGWSharedNotification,0xD6647B01L,0x65CF,0x11D1,0x8D,0x82,0x00,0x80,0x5F,0xC1,0x28,0xBA);

/* Definition of dispatch interface: DIGWSharedNotification */
#undef INTERFACE
#define INTERFACE DIGWSharedNotification

DECLARE_INTERFACE_(DIGWSharedNotification, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;
#endif

/* Capable of dispatching all the methods of interface IGWSharedNotification */
};

DEFINE_GUID(CLSID_SharedNotification,0xD6647B02L,0x65CF,0x11D1,0x8D,0x82,0x00,0x80,0x5F,0xC1,0x28,0xBA);

#ifdef __cplusplus
class SharedNotification;
#endif

#endif
